/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","vs/base/common/htmlContent","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(me){for(var e=[],D=0,N=me.length;D<N;D++)e[D]=Ce[me[D]];return e};define(Ce[158],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const f=new Map,P=new Map,A=new Map,v=new Map;function $(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function k(E,S){const u=E.get(S.detail);u&&(u>=0||E.set(S.detail,u+S.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of R)switch(E.type){case 10:$(f,E);break;case 11:case 12:k(f,E);break;case 21:$(P,E);break;case 22:k(P,E);break;case 33:$(A,E);break;case 34:k(A,E);break;case 31:$(v,E);break;case 32:k(v,E);break}let C=0;A.forEach(E=>C+=E);function b(E){const S=[];return E.forEach((u,m)=>S.push([m,u])),S}return{amdLoad:b(f),amdInvoke:b(P),nodeRequire:b(A),nodeEval:b(v),nodeRequireTotal:C}}static toMarkdownTable(f,P){let A="";const v=[];return f.forEach(($,k)=>{v[k]=$.length}),P.forEach($=>{$.forEach((k,R)=>{typeof k>"u"&&(k=$[R]="-");const C=k.toString().length;v[R]=Math.max(C,v[R])})}),f.forEach(($,k)=>{A+=`| ${$+" ".repeat(v[k]-$.toString().length)} `}),A+=`|
`,f.forEach(($,k)=>{A+=`| ${"-".repeat(v[k])} `}),A+=`|
`,P.forEach($=>{$.forEach((k,R)=>{typeof k<"u"&&(A+=`| ${k+" ".repeat(v[R]-k.toString().length)} `)}),A+=`|
`}),A}}e.$U=D}),define(Ce[159],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(u,m,a){const i=N(u,m);if(i!==-1)return u[i]}e.$fb=D;function N(u,m,a=u.length-1){for(let i=a;i>=0;i--){const r=u[i];if(m(r))return i}return-1}e.$gb=N;function f(u,m){const a=P(u,m);return a===-1?void 0:u[a]}e.$hb=f;function P(u,m,a=0,i=u.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);m(u[o])?r=o+1:n=o}return r-1}e.$ib=P;function A(u,m){const a=v(u,m);return a===u.length?void 0:u[a]}e.$jb=A;function v(u,m,a=0,i=u.length){let r=a,n=i;for(;r<n;){const o=Math.floor((r+n)/2);m(u[o])?n=o:r=o+1}return r}e.$kb=v;function $(u,m,a=0,i=u.length){const r=v(u,m,a,i);return r===u.length?-1:r}e.$lb=$;class k{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const a=P(this.e,m,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=k;function R(u,m){if(u.length===0)return;let a=u[0];for(let i=1;i<u.length;i++){const r=u[i];m(r,a)>0&&(a=r)}return a}e.$nb=R;function C(u,m){if(u.length===0)return;let a=u[0];for(let i=1;i<u.length;i++){const r=u[i];m(r,a)>=0&&(a=r)}return a}e.$ob=C;function b(u,m){return R(u,(a,i)=>-m(a,i))}e.$pb=b;function E(u,m){if(u.length===0)return-1;let a=0;for(let i=1;i<u.length;i++){const r=u[i];m(r,u[a])>0&&(a=i)}return a}e.$qb=E;function S(u,m){for(const a of u){const i=m(a);if(i!==void 0)return i}}e.$rb=S}),define(Ce[74],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(A,v){const $=Object.create(null);for(const k of A){const R=v(k);let C=$[R];C||(C=$[R]=[]),C.push(k)}return $}e.$K=D;function N(A,v){const $=[],k=[];for(const R of A)v.has(R)||$.push(R);for(const R of v)A.has(R)||k.push(R);return{removed:$,added:k}}e.$L=N;function f(A,v){const $=[],k=[];for(const[R,C]of A)v.has(R)||$.push(C);for(const[R,C]of v)A.has(R)||k.push(C);return{removed:$,added:k}}e.$M=f;function P(A,v){const $=new Set;for(const k of v)A.has(k)&&$.add(k);return $}e.$N=P}),define(Ce[52],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function D(A){return(v,$,k)=>{let R=null,C=null;if(typeof k.value=="function"?(R="value",C=k.value):typeof k.get=="function"&&(R="get",C=k.get),!C)throw new Error("not supported");k[R]=A(C,$)}}function N(A,v,$){let k=null,R=null;if(typeof $.value=="function"?(k="value",R=$.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",R=$.get),!R)throw new Error("not supported");const C=`$memoize$${v}`;$[k]=function(...b){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,b)}),this[C]}}e.$Ah=N;function f(A,v,$){return D((k,R)=>{const C=`$debounce$${R}`,b=`$debounce$result$${R}`;return function(...E){this[b]||(this[b]=$?$():void 0),clearTimeout(this[C]),v&&(this[b]=v(this[b],...E),E=[this[b]]),this[C]=setTimeout(()=>{k.apply(this,E),this[b]=$?$():void 0},A)}})}e.$Bh=f;function P(A,v,$){return D((k,R)=>{const C=`$throttle$timer$${R}`,b=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...u){if(this[b]||(this[b]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[b]=v(this[b],...u)),this[S])return;const m=this[E]+A;m<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[b]]),this[b]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),k.apply(this,[this[b]]),this[b]=$?$():void 0},m-Date.now()))}})}e.$Ch=P}),define(Ce[14],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N(o){e.$X.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=N;function f(o){if(!o||typeof o!="object")return!1;const t=o;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function P(o){k(o)||e.$X.onUnexpectedError(o)}e.$1=P;function A(o){k(o)||e.$X.onUnexpectedExternalError(o)}e.$2=A;function v(o){if(o instanceof Error){const{name:t,message:h}=o,s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:h,stack:s,noTelemetry:r.isErrorNoTelemetry(o)}}return o}e.$3=v;const $="Canceled";function k(o){return o instanceof R?!0:o instanceof Error&&o.name===$&&o.message===$}e.$4=k;class R extends Error{constructor(){super($),this.name=this.message}}e.$5=R;function C(){const o=new Error($);return o.name=o.message,o}e.$6=C;function b(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.$7=b;function E(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.$8=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function u(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.$0=u;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const h=new r;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(Ce[19],Ie([1,0,14,159]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(le,de=0){return le[le.length-(1+de)]}e.$sb=f;function P(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=P;function A(le,de,ue=(ge,V)=>ge===V){if(le===de)return!0;if(!le||!de||le.length!==de.length)return!1;for(let ge=0,V=le.length;ge<V;ge++)if(!ue(le[ge],de[ge]))return!1;return!0}e.$ub=A;function v(le,de){const ue=le.length-1;de<ue&&(le[de]=le[ue]),le.pop()}e.$vb=v;function $(le,de,ue){return k(le.length,ge=>ue(le[ge],de))}e.$wb=$;function k(le,de){let ue=0,ge=le-1;for(;ue<=ge;){const V=(ue+ge)/2|0,Z=de(V);if(Z<0)ue=V+1;else if(Z>0)ge=V-1;else return V}return-(ue+1)}e.$xb=k;function R(le,de,ue){if(le=le|0,le>=de.length)throw new TypeError("invalid index");const ge=de[Math.floor(de.length*Math.random())],V=[],Z=[],he=[];for(const be of de){const Pe=ue(be,ge);Pe<0?V.push(be):Pe>0?Z.push(be):he.push(be)}return le<V.length?R(le,V,ue):le<V.length+he.length?he[0]:R(le-(V.length+he.length),Z,ue)}e.$yb=R;function C(le,de){const ue=[];let ge;for(const V of le.slice(0).sort(de))!ge||de(ge[0],V)!==0?(ge=[V],ue.push(ge)):ge.push(V);return ue}e.$zb=C;function*b(le,de){let ue,ge;for(const V of le)ge!==void 0&&de(ge,V)?ue.push(V):(ue&&(yield ue),ue=[V]),ge=V;ue&&(yield ue)}e.$Ab=b;function E(le,de){for(let ue=0;ue<=le.length;ue++)de(ue===0?void 0:le[ue-1],ue===le.length?void 0:le[ue])}e.$Bb=E;function S(le,de){for(let ue=0;ue<le.length;ue++)de(ue===0?void 0:le[ue-1],le[ue],ue+1===le.length?void 0:le[ue+1])}e.$Cb=S;function u(le,de,ue){const ge=[];function V(be,Pe,pe){if(Pe===0&&pe.length===0)return;const Le=ge[ge.length-1];Le&&Le.start+Le.deleteCount===be?(Le.deleteCount+=Pe,Le.toInsert.push(...pe)):ge.push({start:be,deleteCount:Pe,toInsert:pe})}let Z=0,he=0;for(;;){if(Z===le.length){V(Z,0,de.slice(he));break}if(he===de.length){V(Z,le.length-Z,[]);break}const be=le[Z],Pe=de[he],pe=ue(be,Pe);pe===0?(Z+=1,he+=1):pe<0?(V(Z,1,[]),Z+=1):pe>0&&(V(Z,0,[Pe]),he+=1)}return ge}e.$Db=u;function m(le,de,ue){const ge=u(le,de,ue),V=[],Z=[];for(const he of ge)V.push(...le.slice(he.start,he.start+he.deleteCount)),Z.push(...he.toInsert);return{removed:V,added:Z}}e.$Eb=m;function a(le,de,ue){if(ue===0)return[];const ge=le.slice(0,ue).sort(de);return r(le,de,ge,ue,le.length),ge}e.top=a;function i(le,de,ue,ge,V){return ue===0?Promise.resolve([]):new Promise((Z,he)=>{(async()=>{const be=le.length,Pe=le.slice(0,ue).sort(de);for(let pe=ue,Le=Math.min(ue+ge,be);pe<be;pe=Le,Le=Math.min(Le+ge,be)){if(pe>ue&&await new Promise(Ne=>setTimeout(Ne)),V&&V.isCancellationRequested)throw new D.$5;r(le,de,Pe,pe,Le)}return Pe})().then(Z,he)})}e.$Gb=i;function r(le,de,ue,ge,V){for(const Z=ue.length;ge<V;ge++){const he=le[ge];if(de(he,ue[Z-1])<0){ue.pop();const be=(0,N.$kb)(ue,Pe=>de(he,Pe)<0);ue.splice(be,0,he)}}}function n(le){return le.filter(de=>!!de)}e.$Hb=n;function o(le){let de=0;for(let ue=0;ue<le.length;ue++)le[ue]&&(le[de]=le[ue],de+=1);le.length=de}e.$Ib=o;function t(le,de,ue){le.splice(ue,0,le.splice(de,1)[0])}e.$Jb=t;function h(le){return!Array.isArray(le)||le.length===0}e.$Kb=h;function s(le){return Array.isArray(le)&&le.length>0}e.$Lb=s;function d(le,de=ue=>ue){const ue=new Set;return le.filter(ge=>{const V=de(ge);return ue.has(V)?!1:(ue.add(V),!0)})}e.$Mb=d;function l(le){const de=new Set;return ue=>{const ge=le(ue);return de.has(ge)?!1:(de.add(ge),!0)}}e.$Nb=l;function c(le,de){return le.length>0?le[0]:de}e.$Ob=c;function p(le,de){return le.length>0?le[le.length-1]:de}e.$Pb=p;function I(le,de,ue=(ge,V)=>ge===V){let ge=0;for(let V=0,Z=Math.min(le.length,de.length);V<Z&&ue(le[V],de[V]);V++)ge++;return ge}e.$Qb=I;function w(le){return[].concat(...le)}e.$Rb=w;function g(le,de){let ue=typeof de=="number"?le:0;typeof de=="number"?ue=le:(ue=0,de=le);const ge=[];if(ue<=de)for(let V=ue;V<de;V++)ge.push(V);else for(let V=ue;V>de;V--)ge.push(V);return ge}e.$Sb=g;function y(le,de,ue){return le.reduce((ge,V)=>(ge[de(V)]=ue?ue(V):V,ge),Object.create(null))}e.$Tb=y;function L(le,de){return le.push(de),()=>F(le,de)}e.$Ub=L;function F(le,de){const ue=le.indexOf(de);if(ue>-1)return le.splice(ue,1),de}e.$Vb=F;function z(le,de,ue){const ge=le.slice(0,de),V=le.slice(de);return ge.concat(ue,V)}e.$Wb=z;function j(le,de){let ue;if(typeof de=="number"){let ge=de;ue=()=>{const V=Math.sin(ge++)*179426549;return V-Math.floor(V)}}else ue=Math.random;for(let ge=le.length-1;ge>0;ge-=1){const V=Math.floor(ue()*(ge+1)),Z=le[ge];le[ge]=le[V],le[V]=Z}}e.$Xb=j;function O(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.unshift(de))}e.$Yb=O;function M(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.push(de))}e.$Zb=M;function T(le,de){for(const ue of de)le.push(ue)}e.$1b=T;function U(le,de){return Array.isArray(le)?le.map(de):de(le)}e.$2b=U;function J(le){return Array.isArray(le)?le:[le]}e.$3b=J;function ne(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=ne;function ee(le,de,ue){const ge=Y(le,de),V=le.length,Z=ue.length;le.length=V+Z;for(let he=V-1;he>=ge;he--)le[he+Z]=le[he];for(let he=0;he<Z;he++)le[he+ge]=ue[he]}e.$5b=ee;function Q(le,de,ue,ge){const V=Y(le,de);let Z=le.splice(V,ue);return Z===void 0&&(Z=[]),ee(le,V,ge),Z}e.$6b=Q;function Y(le,de){return de<0?Math.max(de+le.length,0):Math.min(de,le.length)}var ce;(function(le){function de(Z){return Z<0}le.isLessThan=de;function ue(Z){return Z<=0}le.isLessThanOrEqual=ue;function ge(Z){return Z>0}le.isGreaterThan=ge;function V(Z){return Z===0}le.isNeitherLessOrGreaterThan=V,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function te(le,de){return(ue,ge)=>de(le(ue),le(ge))}e.$7b=te;function fe(...le){return(de,ue)=>{for(const ge of le){const V=ge(de,ue);if(!ce.isNeitherLessOrGreaterThan(V))return V}return ce.neitherLessOrGreaterThan}}e.$8b=fe;const re=(le,de)=>le-de;e.$9b=re;const K=(le,de)=>(0,e.$9b)(le?1:0,de?1:0);e.$0b=K;function B(le){return(de,ue)=>-le(de,ue)}e.$$b=B;class ae{constructor(de){this.g=de,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(de){let ue=this.c;for(;ue<this.g.length&&de(this.g[ue]);)ue++;const ge=ue===this.c?null:this.g.slice(this.c,ue);return this.c=ue,ge}takeFromEndWhile(de){let ue=this.d;for(;ue>=0&&de(this.g[ue]);)ue--;const ge=ue===this.d?null:this.g.slice(ue+1,this.d+1);return this.d=ue,ge}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const de=this.g[this.c];return this.c++,de}removeLast(){const de=this.g[this.d];return this.d--,de}takeCount(de){const ue=this.g.slice(this.c,this.c+de);return this.c+=de,ue}}e.$_b=ae;class Ee{static{this.empty=new Ee(de=>{})}constructor(de){this.iterate=de}forEach(de){this.iterate(ue=>(de(ue),!0))}toArray(){const de=[];return this.iterate(ue=>(de.push(ue),!0)),de}filter(de){return new Ee(ue=>this.iterate(ge=>de(ge)?ue(ge):!0))}map(de){return new Ee(ue=>this.iterate(ge=>ue(de(ge))))}some(de){let ue=!1;return this.iterate(ge=>(ue=de(ge),!ue)),ue}findFirst(de){let ue;return this.iterate(ge=>de(ge)?(ue=ge,!1):!0),ue}findLast(de){let ue;return this.iterate(ge=>(de(ge)&&(ue=ge),!0)),ue}findLastMaxBy(de){let ue,ge=!0;return this.iterate(V=>((ge||ce.isGreaterThan(de(V,ue)))&&(ge=!1,ue=V),!0)),ue}}e.$ac=Ee}),define(Ce[61],Ie([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function N(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=N;function f(k,R="Unreachable"){throw new Error(R)}e.$6c=f;function P(k){if(!k)throw new D.$cb("Assertion Failed")}e.$7c=P;function A(k){k||(0,D.$1)(new D.$cb("Assertion Failed"))}e.$8c=A;function v(k){if(!k()){debugger;k(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$9c=v;function $(k,R){let C=0;for(;C<k.length-1;){const b=k[C],E=k[C+1];if(!R(b,E))return!1;C++}return!0}e.$0c=$}),define(Ce[75],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,f){const P=this;let A=!1,v;return function(){if(A)return v;if(A=!0,f)try{v=N.apply(P,arguments)}finally{f()}else v=N.apply(P,arguments);return v}}e.$db=D}),define(Ce[121],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=e.$IN=void 0;class D{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$IN=D,e.$JN=new D("id#")}),define(Ce[53],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function f(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=f;const P=Object.freeze([]);function A(){return P}N.empty=A;function*v(t){yield t}N.single=v;function $(t){return f(t)?t:v(t)}N.wrap=$;function k(t){return t||P}N.from=k;function*R(t){for(let h=t.length-1;h>=0;h--)yield t[h]}N.reverse=R;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function b(t){return t[Symbol.iterator]().next().value}N.first=b;function E(t,h){for(const s of t)if(h(s))return!0;return!1}N.some=E;function S(t,h){for(const s of t)if(h(s))return s}N.find=S;function*u(t,h){for(const s of t)h(s)&&(yield s)}N.filter=u;function*m(t,h){let s=0;for(const d of t)yield h(d,s++)}N.map=m;function*a(...t){for(const h of t)yield*h}N.concat=a;function i(t,h,s){let d=s;for(const l of t)d=h(d,l);return d}N.reduce=i;function*r(t,h,s=t.length){for(h<0&&(h+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);h<s;h++)yield t[h]}N.slice=r;function n(t,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,t];const d=t[Symbol.iterator]();for(let l=0;l<h;l++){const c=d.next();if(c.done)return[s,N.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return d}}]}N.consume=n;async function o(t){const h=[];for await(const s of t)h.push(s);return Promise.resolve(h)}N.asyncToArray=o})(D||(e.Iterable=D={}))}),define(Ce[160],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,h=!1){let s=0;const d=t.length;let l="",c=0,p=16,I=0;function w(O){let M=0,T=0;for(;M<O;){const U=t.charCodeAt(s);if(U>=48&&U<=57)T=T*16+U-48;else if(U>=65&&U<=70)T=T*16+U-65+10;else if(U>=97&&U<=102)T=T*16+U-97+10;else break;s++,M++}return M<O&&(T=-1),T}function g(O){s=O,l="",c=0,p=16,I=0}function y(){const O=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return I=3,t.substring(O,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;M=s}else I=3;return t.substring(O,M)}function L(){let O="",M=s;for(;;){if(s>=d){O+=t.substring(M,s),I=2;break}const T=t.charCodeAt(s);if(T===34){O+=t.substring(M,s),s++;break}if(T===92){if(O+=t.substring(M,s),s++,s>=d){I=2;break}switch(t.charCodeAt(s++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const J=w(4);J>=0?O+=String.fromCharCode(J):I=4;break}default:I=5}M=s;continue}if(T>=0&&T<=31)if($(T)){O+=t.substring(M,s),I=2;break}else I=6;s++}return O}function F(){if(l="",I=0,c=s,s>=d)return c=d,p=17;let O=t.charCodeAt(s);if(v(O)){do s++,l+=String.fromCharCode(O),O=t.charCodeAt(s);while(v(O));return p=15}if($(O))return s++,l+=String.fromCharCode(O),O===13&&t.charCodeAt(s)===10&&(s++,l+=`
`),p=14;switch(O){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,l=L(),p=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<d&&!$(t.charCodeAt(s));)s++;return l=t.substring(M,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const T=d-1;let U=!1;for(;s<T;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,I=1),l=t.substring(M,s),p=13}return l+=String.fromCharCode(O),s++,p=16}case 45:if(l+=String.fromCharCode(O),s++,s===d||!k(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=y(),p=11;default:for(;s<d&&z(O);)s++,O=t.charCodeAt(s);if(c!==s){switch(l=t.substring(c,s),l){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return l+=String.fromCharCode(O),s++,p=16}}function z(O){if(v(O)||$(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let O;do O=F();while(O>=12&&O<=15);return O}return{setPosition:g,getPosition:()=>s,scan:h?j:F,getToken:()=>p,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>s-c,getTokenError:()=>I}}e.$en=A;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,h){const s=[],d=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(w,g,y,L){c.value=w,c.offset=g,c.length=y,c.type=L,c.colonOffset=void 0,l=c}try{r(t,{onObjectBegin:(w,g)=>{if(h<=w)throw d;l=void 0,p=h>w,s.push("")},onObjectProperty:(w,g,y)=>{if(h<g||(I(w,g,y,"property"),s[s.length-1]=w,h<=g+y))throw d},onObjectEnd:(w,g)=>{if(h<=w)throw d;l=void 0,s.pop()},onArrayBegin:(w,g)=>{if(h<=w)throw d;l=void 0,s.push(0)},onArrayEnd:(w,g)=>{if(h<=w)throw d;l=void 0,s.pop()},onLiteralValue:(w,g,y)=>{if(h<g||(I(w,g,y,o(w)),h<=g+y))throw d},onSeparator:(w,g,y)=>{if(h<=g)throw d;if(w===":"&&l&&l.type==="property")l.colonOffset=g,p=!1,l=void 0;else if(w===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(p=!0,s[s.length-1]=""),l=void 0}}})}catch(w){if(w!==d)throw w}return{path:s,previousNode:l,isAtPropertyKey:p,matches:w=>{let g=0;for(let y=0;g<w.length&&y<s.length;y++)if(w[g]===s[y]||w[g]==="*")g++;else if(w[g]!=="**")return!1;return g===w.length}}}e.$fn=C;function b(t,h=[],s=P.DEFAULT){let d=null,l=[];const c=[];function p(w){Array.isArray(l)?l.push(w):d!==null&&(l[d]=w)}return r(t,{onObjectBegin:()=>{const w={};p(w),c.push(l),l=w,d=null},onObjectProperty:w=>{d=w},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const w=[];p(w),c.push(l),l=w,d=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:p,onError:(w,g,y)=>{h.push({error:w,offset:g,length:y})}},s),l[0]}e.$gn=b;function E(t,h=[],s=P.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(w){d.type==="property"&&(d.length=w-d.offset,d=d.parent)}function c(w){return d.children.push(w),w}r(t,{onObjectBegin:w=>{d=c({type:"object",offset:w,length:-1,parent:d,children:[]})},onObjectProperty:(w,g,y)=>{d=c({type:"property",offset:g,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:w,offset:g,length:y,parent:d})},onObjectEnd:(w,g)=>{d.length=w+g-d.offset,d=d.parent,l(w+g)},onArrayBegin:(w,g)=>{d=c({type:"array",offset:w,length:-1,parent:d,children:[]})},onArrayEnd:(w,g)=>{d.length=w+g-d.offset,d=d.parent,l(w+g)},onLiteralValue:(w,g,y)=>{c({type:o(w),offset:g,length:y,parent:d,value:w}),l(g+y)},onSeparator:(w,g,y)=>{d.type==="property"&&(w===":"?d.colonOffset=g:w===","&&l(g))},onError:(w,g,y)=>{h.push({error:w,offset:g,length:y})}},s);const I=d.children[0];return I&&delete I.parent,I}e.$hn=E;function S(t,h){if(!t)return;let s=t;for(const d of h)if(typeof d=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let l=!1;for(const c of s.children)if(Array.isArray(c.children)&&c.children[0].value===d){s=c.children[1],l=!0;break}if(!l)return}else{const l=d;if(s.type!=="array"||l<0||!Array.isArray(s.children)||l>=s.children.length)return;s=s.children[l]}return s}e.$in=S;function u(t){if(!t.parent||!t.parent.children)return[];const h=u(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.$jn=u;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const h=Object.create(null);for(const s of t.children){const d=s.children[1];d&&(h[s.children[0].value]=m(d))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$kn=m;function a(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.$ln=a;function i(t,h,s=!1){if(a(t,h,s)){const d=t.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=h;l++){const c=i(d[l],h,s);if(c)return c}return t}}e.$mn=i;function r(t,h,s=P.DEFAULT){const d=A(t,!1);function l(te){return te?()=>te(d.getTokenOffset(),d.getTokenLength()):()=>!0}function c(te){return te?fe=>te(fe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const p=l(h.onObjectBegin),I=c(h.onObjectProperty),w=l(h.onObjectEnd),g=l(h.onArrayBegin),y=l(h.onArrayEnd),L=c(h.onLiteralValue),F=c(h.onSeparator),z=l(h.onComment),j=c(h.onError),O=s&&s.disallowComments,M=s&&s.allowTrailingComma;function T(){for(;;){const te=d.scan();switch(d.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:O||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:O?U(10):z();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,fe=[],re=[]){if(j(te),fe.length+re.length>0){let K=d.getToken();for(;K!==17;){if(fe.indexOf(K)!==-1){T();break}else if(re.indexOf(K)!==-1)break;K=T()}}}function J(te){const fe=d.getTokenValue();return te?L(fe):I(fe),T(),!0}function ne(){switch(d.getToken()){case 11:{let te=0;try{te=JSON.parse(d.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}L(te);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return T(),!0}function ee(){return d.getToken()!==10?(U(3,[],[2,5]),!1):(J(!1),d.getToken()===6?(F(":"),T(),ce()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){p(),T();let te=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(te||U(4,[],[]),F(","),T(),d.getToken()===2&&M)break}else te&&U(6,[],[]);ee()||U(4,[],[2,5]),te=!0}return w(),d.getToken()!==2?U(7,[2],[]):T(),!0}function Y(){g(),T();let te=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(te||U(4,[],[]),F(","),T(),d.getToken()===4&&M)break}else te&&U(6,[],[]);ce()||U(4,[],[4,5]),te=!0}return y(),d.getToken()!==4?U(8,[4],[]):T(),!0}function ce(){switch(d.getToken()){case 3:return Y();case 1:return Q();case 10:return J(!0);default:return ne()}}return T(),d.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ce()?(d.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.$nn=r;function n(t,h){const s=A(t),d=[];let l,c=0,p;do switch(p=s.getPosition(),l=s.scan(),l){case 12:case 13:case 17:c!==p&&d.push(t.substring(c,p)),h!==void 0&&d.push(s.getTokenValue().replace(/[^\r\n]/g,h)),c=s.getPosition();break}while(l!==17);return d.join("")}e.$on=n;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$pn=o}),define(Ce[43],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(Ce[76],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const A=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const v=new D(P);if(this.a===D.Undefined)this.a=v,this.b=v;else if(A){const k=this.b;this.b=v,v.prev=k,k.next=v}else{const k=this.a;this.a=v,v.next=k,k.prev=v}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(v))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$4c=N}),define(Ce[28],Ie([1,0]),function(me,e){"use strict";var D,N,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(r,n,o){let t=r.get(n);return t===void 0&&(t=o,r.set(n,t)),t}e.$xc=P;function A(r){const n=[];return r.forEach((o,t)=>{n.push(`${t} => ${o}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=A;function v(r){const n=[];return r.forEach(o=>{n.push(o)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=v;class ${constructor(n,o){this.uri=n,this.value=o}}function k(r){return Array.isArray(r)}class R{static{this.c=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof R)this.d=new Map(n.d),this.e=o??R.c;else if(k(n)){this.d=new Map,this.e=o??R.c;for(const[t,h]of n)this.set(t,h)}else this.d=new Map,this.e=n??R.c}set(n,o){return this.d.set(this.e(n),new $(n,o)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[t,h]of this.d)n(h.value,h.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=R;class C{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this.c=new R(n):(this.c=new R(o),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,o){this.c.forEach((t,h)=>n.call(o,h,h,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var b;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class E{constructor(){this[f]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,o=0){const t=this.c.get(n);if(t)return o!==0&&this.l(t,o),t.value}set(n,o,t=0){let h=this.c.get(n);if(h)h.value=o,t!==0&&this.l(h,t);else{switch(h={key:n,value:o,next:void 0,previous:void 0},t){case 0:this.j(h);break;case 1:this.i(h);break;case 2:this.j(h);break;default:this.j(h);break}this.c.set(n,h),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.c.get(n);if(o)return this.c.delete(n),this.k(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,o){const t=this.g;let h=this.d;for(;h;){if(o?n.bind(o)(h.value,h.key,this):n(h.value,h.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}values(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}entries(){const n=this,o=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==o)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.d,t=this.size;for(;o&&t>n;)this.c.delete(o.key),o=o.next,t--;this.d=o,this.f=t,o&&(o.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const o=n.next,t=n.previous;if(!o||!t)throw new Error("Invalid list");o.previous=t,t.next=o}n.next=void 0,n.previous=void 0,this.g++}l(n,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.d)return;const t=n.next,h=n.previous;n===this.e?(h.next=void 0,this.e=h):(t.previous=h,h.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(o===2){if(n===this.e)return;const t=n.next,h=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=h,h.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((o,t)=>{n.push([t,o])}),n}fromJSON(n){this.clear();for(const[o,t]of n)this.set(o,t)}}e.$Cc=E;class S extends E{constructor(n,o=1){super(),this.m=n,this.n=Math.min(Math.max(0,o),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class u{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let o=this.c.get(n)||0;return o===0?!1:(o--,o===0?this.c.delete(n):this.c.set(n,o),!0)}has(n){return this.c.has(n)}}e.$Ec=u;class m{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[o,t]of n)this.set(o,t)}clear(){this.c.clear(),this.d.clear()}set(n,o){this.c.set(n,o),this.d.set(o,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const o=this.c.get(n);return o===void 0?!1:(this.c.delete(n),this.d.delete(o),!0)}forEach(n,o){this.c.forEach((t,h)=>{n.call(o,t,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class a{constructor(){this.c=new Map}add(n,o){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(o)}delete(n,o){const t=this.c.get(n);t&&(t.delete(o),t.size===0&&this.c.delete(n))}forEach(n,o){const t=this.c.get(n);t&&t.forEach(o)}get(n){const o=this.c.get(n);return o||new Set}}e.$Gc=a;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[o,t]of r)if(!n.has(o)||n.get(o)!==t)return!1;for(const[o]of n)if(!r.has(o))return!1;return!0}e.$Hc=i}),define(Ce[3],Ie([1,0,19,74,28,75,53]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const v=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(L){let F=this.b.get(L);return F||(F={parent:null,source:null,isSingleton:!1,value:L,idx:k.a++},this.b.set(L,F)),F}trackDisposable(L){const F=this.c(L);F.source||(F.source=new Error().stack)}setParent(L,F){const z=this.c(L);z.parent=F}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,F){const z=F.get(L);if(z)return z;const j=L.parent?this.f(this.c(L.parent),F):L;return F.set(L,j),j}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,L).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(L=10,F){let z;if(F)z=F;else{const U=new Map,J=[...this.b.values()].filter(ee=>ee.source!==null&&!this.f(ee,U).isSingleton);if(J.length===0)return;const ne=new Set(J.map(ee=>ee.value));if(z=J.filter(ee=>!(ee.parent&&ne.has(ee.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function j(U){function J(ee,Q){for(;ee.length>0&&Q.some(Y=>typeof Y=="string"?Y===ee[0]:ee[0].match(Y));)ee.shift()}const ne=U.source.split(`
`).map(ee=>ee.trim().replace("at ","")).filter(ee=>ee!=="");return J(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const O=new f.$Gc;for(const U of z){const J=j(U);for(let ne=0;ne<=J.length;ne++)O.add(J.slice(0,ne).join(`
`),U)}z.sort((0,D.$7b)(U=>U.idx,D.$9b));let M="",T=0;for(const U of z.slice(0,L)){T++;const J=j(U),ne=[];for(let ee=0;ee<J.length;ee++){let Q=J[ee];Q=`(shared with ${O.get(J.slice(0,ee+1).join(`
`)).size}/${z.length} leaks) at ${Q}`;const ce=O.get(J.slice(0,ee).join(`
`)),te=(0,N.$K)([...ce].map(fe=>j(fe)[ee]),fe=>fe);delete te[J[ee]];for(const[fe,re]of Object.entries(te))ne.unshift(`    - stacktraces of ${re.length} other leaks continue with ${fe}`);ne.unshift(Q)}M+=`


==================== Leaking disposable ${T}/${z.length}: ${U.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return z.length>L&&(M+=`


... and ${z.length-L} more leaking disposables

`),{leaks:z,details:M}}}e.$Ic=k;function R(y){$=y}if(e.$Jc=R,v){const y="__is_disposable_tracked__";R(new class{trackDisposable(L){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[y]||console.log(F)},3e3)}setParent(L,F){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsSingleton(L){}})}function C(y){return $?.trackDisposable(y),y}e.$Kc=C;function b(y){$?.markAsDisposed(y)}e.$Lc=b;function E(y,L){$?.setParent(y,L)}function S(y,L){if($)for(const F of y)$.setParent(F,L)}function u(y){return $?.markAsSingleton(y),y}e.$Mc=u;function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=m;function a(y){if(A.Iterable.is(y)){const L=[];for(const F of y)if(F)try{F.dispose()}catch(z){L.push(z)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=a;function i(y){for(const L of y)m(L)&&L.dispose();return[]}e.$Pc=i;function r(...y){const L=n(()=>a(y));return S(y,L),L}e.$Qc=r;function n(y){const L=C({dispose:(0,P.$db)(()=>{b(L),y()})});return L}e.$Rc=n;class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return E(L,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),E(L,null))}}e.$Sc=o;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,C(this),E(this.q,this)}dispose(){b(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=t;class h{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&E(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&E(L,null),L}}e.$Uc=h;class s{constructor(L){this.a=new h,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class d{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=d;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(L){let F=L;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,b(this))},this}}e.$Xc=l;class c{constructor(){this.a=new Map}acquire(L,...F){let z=this.a.get(L);z||(z={counter:0,object:this.b(L,...F)},this.a.set(L,z));const{object:j}=z,O=(0,P.$db)(()=>{--z.counter===0&&(this.c(L,z.object),this.a.delete(L))});return z.counter++,{object:j,dispose:O}}}e.$Yc=c;class p{constructor(L){this.a=L}async acquire(L,...F){const z=this.a.acquire(L,...F);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(j){throw z.dispose(),j}}}e.$Zc=p;class I{constructor(L){this.object=L}dispose(){}}e.$1c=I;function w(y){const L=new o;try{y(L)}finally{L.dispose()}}e.$2c=w;class g{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,F,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(L)?.dispose(),this.a.set(L,F)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=g}),function(me,e){typeof define=="function"&&define.amd?define(Ce[161],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(de,ue){for(var ge=0;ge<ue.length;ge++){var V=ue[ge];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(de,V.key,V)}}function D(de,ue,ge){return ue&&e(de.prototype,ue),ge&&e(de,ge),Object.defineProperty(de,"prototype",{writable:!1}),de}function N(de,ue){if(de){if(typeof de=="string")return f(de,ue);var ge=Object.prototype.toString.call(de).slice(8,-1);if(ge==="Object"&&de.constructor&&(ge=de.constructor.name),ge==="Map"||ge==="Set")return Array.from(de);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return f(de,ue)}}function f(de,ue){(ue==null||ue>de.length)&&(ue=de.length);for(var ge=0,V=new Array(ue);ge<ue;ge++)V[ge]=de[ge];return V}function P(de,ue){var ge=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(ge)return(ge=ge.call(de)).next.bind(ge);if(Array.isArray(de)||(ge=N(de))||ue&&de&&typeof de.length=="number"){ge&&(de=ge);var V=0;return function(){return V>=de.length?{done:!0}:{done:!1,value:de[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function v(de){me.defaults=de}var $=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ue){return b[ue]};function S(de,ue){if(ue){if($.test(de))return de.replace(k,E)}else if(R.test(de))return de.replace(C,E);return de}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(de){return de.replace(u,function(ue,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var a=/(^|[^\[])\^/g;function i(de,ue){de=typeof de=="string"?de:de.source,ue=ue||"";var ge={replace:function(Z,he){return he=he.source||he,he=he.replace(a,"$1"),de=de.replace(Z,he),ge},getRegex:function(){return new RegExp(de,ue)}};return ge}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(de,ue,ge){if(de){var V;try{V=decodeURIComponent(m(ge)).replace(r,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ue&&!n.test(ge)&&(ge=l(ue,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(de,ue){t[" "+de]||(h.test(de)?t[" "+de]=de+"/":t[" "+de]=w(de,"/",!0)),de=t[" "+de];var ge=de.indexOf(":")===-1;return ue.substring(0,2)==="//"?ge?ue:de.replace(s,"$1")+ue:ue.charAt(0)==="/"?ge?ue:de.replace(d,"$1")+ue:de+ue}var c={exec:function(){}};function p(de){for(var ue=1,ge,V;ue<arguments.length;ue++){ge=arguments[ue];for(V in ge)Object.prototype.hasOwnProperty.call(ge,V)&&(de[V]=ge[V])}return de}function I(de,ue){var ge=de.replace(/\|/g,function(he,be,Pe){for(var pe=!1,Le=be;--Le>=0&&Pe[Le]==="\\";)pe=!pe;return pe?"|":" |"}),V=ge.split(/ \|/),Z=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ue)V.splice(ue);else for(;V.length<ue;)V.push("");for(;Z<V.length;Z++)V[Z]=V[Z].trim().replace(/\\\|/g,"|");return V}function w(de,ue,ge){var V=de.length;if(V===0)return"";for(var Z=0;Z<V;){var he=de.charAt(V-Z-1);if(he===ue&&!ge)Z++;else if(he!==ue&&ge)Z++;else break}return de.slice(0,V-Z)}function g(de,ue){if(de.indexOf(ue[1])===-1)return-1;for(var ge=de.length,V=0,Z=0;Z<ge;Z++)if(de[Z]==="\\")Z++;else if(de[Z]===ue[0])V++;else if(de[Z]===ue[1]&&(V--,V<0))return Z;return-1}function y(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(de,ue){if(ue<1)return"";for(var ge="";ue>1;)ue&1&&(ge+=de),ue>>=1,de+=de;return ge+de}function F(de,ue,ge,V){var Z=ue.href,he=ue.title?S(ue.title):null,be=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){V.state.inLink=!0;var Pe={type:"link",raw:ge,href:Z,title:he,text:be,tokens:V.inlineTokens(be)};return V.state.inLink=!1,Pe}return{type:"image",raw:ge,href:Z,title:he,text:S(be)}}function z(de,ue){var ge=de.match(/^(\s+)(?:```)/);if(ge===null)return ue;var V=ge[1];return ue.split(`
`).map(function(Z){var he=Z.match(/^\s+/);if(he===null)return Z;var be=he[0];return be.length>=V.length?Z.slice(V.length):Z}).join(`
`)}var j=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.space=function(V){var Z=this.rules.block.newline.exec(V);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ue.code=function(V){var Z=this.rules.block.code.exec(V);if(Z){var he=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?he:w(he,`
`)}}},ue.fences=function(V){var Z=this.rules.block.fences.exec(V);if(Z){var he=Z[0],be=z(he,Z[3]||"");return{type:"code",raw:he,lang:Z[2]?Z[2].trim():Z[2],text:be}}},ue.heading=function(V){var Z=this.rules.block.heading.exec(V);if(Z){var he=Z[2].trim();if(/#$/.test(he)){var be=w(he,"#");(this.options.pedantic||!be||/ $/.test(be))&&(he=be.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:he,tokens:this.lexer.inline(he)}}},ue.hr=function(V){var Z=this.rules.block.hr.exec(V);if(Z)return{type:"hr",raw:Z[0]}},ue.blockquote=function(V){var Z=this.rules.block.blockquote.exec(V);if(Z){var he=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ue.list=function(V){var Z=this.rules.block.list.exec(V);if(Z){var he,be,Pe,pe,Le,Ne,W,x,H,X,oe,ve,Me=Z[1].trim(),qe=Me.length>1,Ge={type:"list",raw:"",ordered:qe,start:qe?+Me.slice(0,-1):"",loose:!1,items:[]};Me=qe?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=qe?Me:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(ve=!1,!(!(Z=Ye.exec(V))||this.rules.block.hr.test(V)));){if(he=Z[0],V=V.substring(he.length),x=Z[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(pe=2,oe=x.trimLeft()):(pe=Z[2].search(/[^ ]/),pe=pe>4?1:pe,oe=x.slice(pe),pe+=Z[1].length),Ne=!1,!x&&/^ *$/.test(H)&&(he+=H+`
`,V=V.substring(H.length+1),ve=!0),!ve)for(var it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ut=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");V&&(X=V.split(`
`,1)[0],x=X,this.options.pedantic&&(x=x.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(x)||et.test(x)||it.test(x)||ut.test(V)));){if(x.search(/[^ ]/)>=pe||!x.trim())oe+=`
`+x.slice(pe);else if(!Ne)oe+=`
`+x;else break;!Ne&&!x.trim()&&(Ne=!0),he+=X+`
`,V=V.substring(X.length+1)}Ge.loose||(W?Ge.loose=!0:/\n *\n *$/.test(he)&&(W=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(oe),be&&(Pe=be[0]!=="[ ] ",oe=oe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:he,task:!!be,checked:Pe,loose:!1,text:oe}),Ge.raw+=he}Ge.items[Ge.items.length-1].raw=he.trimRight(),Ge.items[Ge.items.length-1].text=oe.trimRight(),Ge.raw=Ge.raw.trimRight();var Ae=Ge.items.length;for(Le=0;Le<Ae;Le++){this.lexer.state.top=!1,Ge.items[Le].tokens=this.lexer.blockTokens(Ge.items[Le].text,[]);var ke=Ge.items[Le].tokens.filter(function(_){return _.type==="space"}),He=ke.every(function(_){for(var se=_.raw.split(""),De=0,Ve=P(se),Xe;!(Xe=Ve()).done;){var nt=Xe.value;if(nt===`
`&&(De+=1),De>1)return!0}return!1});!Ge.loose&&ke.length&&He&&(Ge.loose=!0,Ge.items[Le].loose=!0)}return Ge}},ue.html=function(V){var Z=this.rules.block.html.exec(V);if(Z){var he={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(Z[0]):S(Z[0]);he.type="paragraph",he.text=be,he.tokens=this.lexer.inline(be)}return he}},ue.def=function(V){var Z=this.rules.block.def.exec(V);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var he=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Z[0],href:Z[2],title:Z[3]}}},ue.table=function(V){var Z=this.rules.block.table.exec(V);if(Z){var he={type:"table",header:I(Z[1]).map(function(W){return{text:W}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Z[0];var be=he.align.length,Pe,pe,Le,Ne;for(Pe=0;Pe<be;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(be=he.rows.length,Pe=0;Pe<be;Pe++)he.rows[Pe]=I(he.rows[Pe],he.header.length).map(function(W){return{text:W}});for(be=he.header.length,pe=0;pe<be;pe++)he.header[pe].tokens=this.lexer.inline(he.header[pe].text);for(be=he.rows.length,pe=0;pe<be;pe++)for(Ne=he.rows[pe],Le=0;Le<Ne.length;Le++)Ne[Le].tokens=this.lexer.inline(Ne[Le].text);return he}}},ue.lheading=function(V){var Z=this.rules.block.lheading.exec(V);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ue.paragraph=function(V){var Z=this.rules.block.paragraph.exec(V);if(Z){var he=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:he,tokens:this.lexer.inline(he)}}},ue.text=function(V){var Z=this.rules.block.text.exec(V);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ue.escape=function(V){var Z=this.rules.inline.escape.exec(V);if(Z)return{type:"escape",raw:Z[0],text:S(Z[1])}},ue.tag=function(V){var Z=this.rules.inline.tag.exec(V);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):S(Z[0]):Z[0]}},ue.link=function(V){var Z=this.rules.inline.link.exec(V);if(Z){var he=Z[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var be=w(he.slice(0,-1),"\\");if((he.length-be.length)%2===0)return}else{var Pe=g(Z[2],"()");if(Pe>-1){var pe=Z[0].indexOf("!")===0?5:4,Le=pe+Z[1].length+Pe;Z[2]=Z[2].substring(0,Pe),Z[0]=Z[0].substring(0,Le).trim(),Z[3]=""}}var Ne=Z[2],W="";if(this.options.pedantic){var x=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);x&&(Ne=x[1],W=x[3])}else W=Z[3]?Z[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(he)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),F(Z,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:W&&W.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ue.reflink=function(V,Z){var he;if((he=this.rules.inline.reflink.exec(V))||(he=this.rules.inline.nolink.exec(V))){var be=(he[2]||he[1]).replace(/\s+/g," ");if(be=Z[be.toLowerCase()],!be||!be.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return F(he,be,he[0],this.lexer)}},ue.emStrong=function(V,Z,he){he===void 0&&(he="");var be=this.rules.inline.emStrong.lDelim.exec(V);if(be&&!(be[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=be[1]||be[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var pe=be[0].length-1,Le,Ne,W=pe,x=0,H=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,Z=Z.slice(-1*V.length+pe);(be=H.exec(Z))!=null;)if(Le=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Le){if(Ne=Le.length,be[3]||be[4]){W+=Ne;continue}else if((be[5]||be[6])&&pe%3&&!((pe+Ne)%3)){x+=Ne;continue}if(W-=Ne,!(W>0)){if(Ne=Math.min(Ne,Ne+W+x),Math.min(pe,Ne)%2){var X=V.slice(1,pe+be.index+Ne);return{type:"em",raw:V.slice(0,pe+be.index+Ne+1),text:X,tokens:this.lexer.inlineTokens(X)}}var oe=V.slice(2,pe+be.index+Ne-1);return{type:"strong",raw:V.slice(0,pe+be.index+Ne+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}}}}},ue.codespan=function(V){var Z=this.rules.inline.code.exec(V);if(Z){var he=Z[2].replace(/\n/g," "),be=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return be&&Pe&&(he=he.substring(1,he.length-1)),he=S(he,!0),{type:"codespan",raw:Z[0],text:he}}},ue.br=function(V){var Z=this.rules.inline.br.exec(V);if(Z)return{type:"br",raw:Z[0]}},ue.del=function(V){var Z=this.rules.inline.del.exec(V);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ue.autolink=function(V,Z){var he=this.rules.inline.autolink.exec(V);if(he){var be,Pe;return he[2]==="@"?(be=S(this.options.mangle?Z(he[1]):he[1]),Pe="mailto:"+be):(be=S(he[1]),Pe=be),{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.url=function(V,Z){var he;if(he=this.rules.inline.url.exec(V)){var be,Pe;if(he[2]==="@")be=S(this.options.mangle?Z(he[0]):he[0]),Pe="mailto:"+be;else{var pe;do pe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(pe!==he[0]);be=S(he[0]),he[1]==="www."?Pe="http://"+be:Pe=be}return{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.inlineText=function(V,Z){var he=this.rules.inline.text.exec(V);if(he){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]):he[0]:be=S(this.options.smartypants?Z(he[0]):he[0]),{type:"text",raw:he[0],text:be}}},de}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=p({},O),O.gfm=p({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=p({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",O._label).getRegex(),M.nolink=i(M.nolink).replace("ref",O._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=p({},M),M.pedantic=p({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=p({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=p({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(de){var ue="",ge,V,Z=de.length;for(ge=0;ge<Z;ge++)V=de.charCodeAt(ge),Math.random()>.5&&(V="x"+V.toString(16)),ue+="&#"+V+";";return ue}var J=function(){function de(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:O.normal,inline:M.normal};this.options.pedantic?(V.block=O.pedantic,V.inline=M.pedantic):this.options.gfm&&(V.block=O.gfm,this.options.breaks?V.inline=M.breaks:V.inline=M.gfm),this.tokenizer.rules=V}de.lex=function(V,Z){var he=new de(Z);return he.lex(V)},de.lexInline=function(V,Z){var he=new de(Z);return he.inlineTokens(V)};var ue=de.prototype;return ue.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ue.blockTokens=function(V,Z){var he=this;Z===void 0&&(Z=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(W,x,H){return x+"    ".repeat(H.length)});for(var be,Pe,pe,Le;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(W){return(be=W.call({lexer:he},V,Z))?(V=V.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.space(V)){V=V.substring(be.raw.length),be.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(be);continue}if(be=this.tokenizer.code(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(be=this.tokenizer.fences(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.heading(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.hr(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.blockquote(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.list(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.html(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.def(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.lheading(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var W=1/0,x=V.slice(1),H=void 0;he.options.extensions.startBlock.forEach(function(X){H=X.call({lexer:this},x),typeof H=="number"&&H>=0&&(W=Math.min(W,H))}),W<1/0&&W>=0&&(pe=V.substring(0,W+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Pe=Z[Z.length-1],Le&&Pe.type==="paragraph"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be),Le=pe.length!==V.length,V=V.substring(be.raw.length);continue}if(be=this.tokenizer.text(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(V){var Ne="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return this.state.top=!0,Z},ue.inline=function(V,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:V,tokens:Z}),Z},ue.inlineTokens=function(V,Z){var he=this;Z===void 0&&(Z=[]);var be,Pe,pe,Le=V,Ne,W,x;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)H.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ne.index)+"["+L("a",Ne[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ne.index)+"["+L("a",Ne[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ne.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(W||(x=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(oe){return(be=oe.call({lexer:he},V,Z))?(V=V.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.escape(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.tag(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.link(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.emStrong(V,Le,x)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.codespan(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.br(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.del(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.autolink(V,U)){V=V.substring(be.raw.length),Z.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(V,U))){V=V.substring(be.raw.length),Z.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var oe=1/0,ve=V.slice(1),Me=void 0;he.options.extensions.startInline.forEach(function(qe){Me=qe.call({lexer:this},ve),typeof Me=="number"&&Me>=0&&(oe=Math.min(oe,Me))}),oe<1/0&&oe>=0&&(pe=V.substring(0,oe+1))}(),be=this.tokenizer.inlineText(pe,T)){V=V.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(x=be.raw.slice(-1)),W=!0,Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(V){var X="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return Z},D(de,null,[{key:"rules",get:function(){return{block:O,inline:M}}}]),de}(),ne=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.code=function(V,Z,he){var be=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(V,be);Pe!=null&&Pe!==V&&(he=!0,V=Pe)}return V=V.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+S(be,!0)+'">'+(he?V:S(V,!0))+`</code></pre>
`:"<pre><code>"+(he?V:S(V,!0))+`</code></pre>
`},ue.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ue.html=function(V){return V},ue.heading=function(V,Z,he,be){if(this.options.headerIds){var Pe=this.options.headerPrefix+be.slug(he);return"<h"+Z+' id="'+Pe+'">'+V+"</h"+Z+`>
`}return"<h"+Z+">"+V+"</h"+Z+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(V,Z,he){var be=Z?"ol":"ul",Pe=Z&&he!==1?' start="'+he+'"':"";return"<"+be+Pe+`>
`+V+"</"+be+`>
`},ue.listitem=function(V){return"<li>"+V+`</li>
`},ue.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(V){return"<p>"+V+`</p>
`},ue.table=function(V,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Z+`</table>
`},ue.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ue.tablecell=function(V,Z){var he=Z.header?"th":"td",be=Z.align?"<"+he+' align="'+Z.align+'">':"<"+he+">";return be+V+("</"+he+`>
`)},ue.strong=function(V){return"<strong>"+V+"</strong>"},ue.em=function(V){return"<em>"+V+"</em>"},ue.codespan=function(V){return"<code>"+V+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(V){return"<del>"+V+"</del>"},ue.link=function(V,Z,he){if(V=o(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<a href="'+S(V)+'"';return Z&&(be+=' title="'+Z+'"'),be+=">"+he+"</a>",be},ue.image=function(V,Z,he){if(V=o(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<img src="'+V+'" alt="'+he+'"';return Z&&(be+=' title="'+Z+'"'),be+=this.options.xhtml?"/>":">",be},ue.text=function(V){return V},de}(),ee=function(){function de(){}var ue=de.prototype;return ue.strong=function(V){return V},ue.em=function(V){return V},ue.codespan=function(V){return V},ue.del=function(V){return V},ue.html=function(V){return V},ue.text=function(V){return V},ue.link=function(V,Z,he){return""+he},ue.image=function(V,Z,he){return""+he},ue.br=function(){return""},de}(),Q=function(){function de(){this.seen={}}var ue=de.prototype;return ue.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(V,Z){var he=V,be=0;if(this.seen.hasOwnProperty(he)){be=this.seen[V];do be++,he=V+"-"+be;while(this.seen.hasOwnProperty(he))}return Z||(this.seen[V]=be,this.seen[he]=0),he},ue.slug=function(V,Z){Z===void 0&&(Z={});var he=this.serialize(V);return this.getNextSafeSlug(he,Z.dryrun)},de}(),Y=function(){function de(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new Q}de.parse=function(V,Z){var he=new de(Z);return he.parse(V)},de.parseInline=function(V,Z){var he=new de(Z);return he.parseInline(V)};var ue=de.prototype;return ue.parse=function(V,Z){Z===void 0&&(Z=!0);var he="",be,Pe,pe,Le,Ne,W,x,H,X,oe,ve,Me,qe,Ge,Ye,it,ut,ot,et,Ae=V.length;for(be=0;be<Ae;be++){if(oe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(et=this.options.extensions.renderers[oe.type].call({parser:this},oe),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(oe.type))){he+=et||"";continue}switch(oe.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(oe.tokens),oe.depth,m(this.parseInline(oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(oe.text,oe.lang,oe.escaped);continue}case"table":{for(H="",x="",Le=oe.header.length,Pe=0;Pe<Le;Pe++)x+=this.renderer.tablecell(this.parseInline(oe.header[Pe].tokens),{header:!0,align:oe.align[Pe]});for(H+=this.renderer.tablerow(x),X="",Le=oe.rows.length,Pe=0;Pe<Le;Pe++){for(W=oe.rows[Pe],x="",Ne=W.length,pe=0;pe<Ne;pe++)x+=this.renderer.tablecell(this.parseInline(W[pe].tokens),{header:!1,align:oe.align[pe]});X+=this.renderer.tablerow(x)}he+=this.renderer.table(H,X);continue}case"blockquote":{X=this.parse(oe.tokens),he+=this.renderer.blockquote(X);continue}case"list":{for(ve=oe.ordered,Me=oe.start,qe=oe.loose,Le=oe.items.length,X="",Pe=0;Pe<Le;Pe++)Ye=oe.items[Pe],it=Ye.checked,ut=Ye.task,Ge="",Ye.task&&(ot=this.renderer.checkbox(it),qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=ot+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=ot+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ye.tokens,qe),X+=this.renderer.listitem(Ge,ut,it);he+=this.renderer.list(X,ve,Me);continue}case"html":{he+=this.renderer.html(oe.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(oe.tokens));continue}case"text":{for(X=oe.tokens?this.parseInline(oe.tokens):oe.text;be+1<Ae&&V[be+1].type==="text";)oe=V[++be],X+=`
`+(oe.tokens?this.parseInline(oe.tokens):oe.text);he+=Z?this.renderer.paragraph(X):X;continue}default:{var ke='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return he},ue.parseInline=function(V,Z){Z=Z||this.renderer;var he="",be,Pe,pe,Le=V.length;for(be=0;be<Le;be++){if(Pe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(pe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=pe||"";continue}switch(Pe.type){case"escape":{he+=Z.text(Pe.text);break}case"html":{he+=Z.html(Pe.text);break}case"link":{he+=Z.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Z));break}case"image":{he+=Z.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=Z.strong(this.parseInline(Pe.tokens,Z));break}case"em":{he+=Z.em(this.parseInline(Pe.tokens,Z));break}case"codespan":{he+=Z.codespan(Pe.text);break}case"br":{he+=Z.br();break}case"del":{he+=Z.del(this.parseInline(Pe.tokens,Z));break}case"text":{he+=Z.text(Pe.text);break}default:{var Ne='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return he},de}();function ce(de,ue,ge){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof ue=="function"&&(ge=ue,ue=null),ue=p({},ce.defaults,ue||{}),y(ue),ge){var V=ue.highlight,Z;try{Z=J.lex(de,ue)}catch(Le){return ge(Le)}var he=function(Ne){var W;if(!Ne)try{ue.walkTokens&&ce.walkTokens(Z,ue.walkTokens),W=Y.parse(Z,ue)}catch(x){Ne=x}return ue.highlight=V,Ne?ge(Ne):ge(null,W)};if(!V||V.length<3||(delete ue.highlight,!Z.length))return he();var be=0;ce.walkTokens(Z,function(Le){Le.type==="code"&&(be++,setTimeout(function(){V(Le.text,Le.lang,function(Ne,W){if(Ne)return he(Ne);W!=null&&W!==Le.text&&(Le.text=W,Le.escaped=!0),be--,be===0&&he()})},0))}),be===0&&he();return}function Pe(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Le.message+"",!0)+"</pre>";throw Le}try{var pe=J.lex(de,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(pe,ue.walkTokens)).then(function(){return Y.parse(pe,ue)}).catch(Pe);ce.walkTokens(pe,ue.walkTokens)}return Y.parse(pe,ue)}catch(Le){Pe(Le)}}ce.options=ce.setOptions=function(de){return p(ce.defaults,de),v(ce.defaults),ce},ce.getDefaults=A,ce.defaults=me.defaults,ce.use=function(){for(var de=arguments.length,ue=new Array(de),ge=0;ge<de;ge++)ue[ge]=arguments[ge];var V=p.apply(void 0,[{}].concat(ue)),Z=ce.defaults.extensions||{renderers:{},childTokens:{}},he;ue.forEach(function(be){if(be.extensions&&(he=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Le=Z.renderers?Z.renderers[pe.name]:null;Le?Z.renderers[pe.name]=function(){for(var Ne=arguments.length,W=new Array(Ne),x=0;x<Ne;x++)W[x]=arguments[x];var H=pe.renderer.apply(this,W);return H===!1&&(H=Le.apply(this,W)),H}:Z.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[pe.level]?Z[pe.level].unshift(pe.tokenizer):Z[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?Z.startBlock?Z.startBlock.push(pe.start):Z.startBlock=[pe.start]:pe.level==="inline"&&(Z.startInline?Z.startInline.push(pe.start):Z.startInline=[pe.start]))}pe.childTokens&&(Z.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=ce.defaults.renderer||new ne,Le=function(x){var H=pe[x];pe[x]=function(){for(var X=arguments.length,oe=new Array(X),ve=0;ve<X;ve++)oe[ve]=arguments[ve];var Me=be.renderer[x].apply(pe,oe);return Me===!1&&(Me=H.apply(pe,oe)),Me}};for(var Ne in be.renderer)Le(Ne);V.renderer=pe}(),be.tokenizer&&function(){var pe=ce.defaults.tokenizer||new j,Le=function(x){var H=pe[x];pe[x]=function(){for(var X=arguments.length,oe=new Array(X),ve=0;ve<X;ve++)oe[ve]=arguments[ve];var Me=be.tokenizer[x].apply(pe,oe);return Me===!1&&(Me=H.apply(pe,oe)),Me}};for(var Ne in be.tokenizer)Le(Ne);V.tokenizer=pe}(),be.walkTokens){var Pe=ce.defaults.walkTokens;V.walkTokens=function(pe){var Le=[];return Le.push(be.walkTokens.call(this,pe)),Pe&&(Le=Le.concat(Pe.call(this,pe))),Le}}he&&(V.extensions=Z),ce.setOptions(V)})},ce.walkTokens=function(de,ue){for(var ge=[],V=function(){var Pe=he.value;switch(ge=ge.concat(ue.call(ce,Pe)),Pe.type){case"table":{for(var pe=P(Pe.header),Le;!(Le=pe()).done;){var Ne=Le.value;ge=ge.concat(ce.walkTokens(Ne.tokens,ue))}for(var W=P(Pe.rows),x;!(x=W()).done;)for(var H=x.value,X=P(H),oe;!(oe=X()).done;){var ve=oe.value;ge=ge.concat(ce.walkTokens(ve.tokens,ue))}break}case"list":{ge=ge.concat(ce.walkTokens(Pe.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Pe.type]?ce.defaults.extensions.childTokens[Pe.type].forEach(function(Me){ge=ge.concat(ce.walkTokens(Pe[Me],ue))}):Pe.tokens&&(ge=ge.concat(ce.walkTokens(Pe.tokens,ue)))}},Z=P(de),he;!(he=Z()).done;)V();return ge},ce.parseInline=function(de,ue){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");ue=p({},ce.defaults,ue||{}),y(ue);try{var ge=J.lexInline(de,ue);return ue.walkTokens&&ce.walkTokens(ge,ue.walkTokens),Y.parseInline(ge,ue)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(V.message+"",!0)+"</pre>";throw V}},ce.Parser=Y,ce.parser=Y.parse,ce.Renderer=ne,ce.TextRenderer=ee,ce.Lexer=J,ce.lexer=J.lex,ce.Tokenizer=j,ce.Slugger=Q,ce.parse=ce;var te=ce.options,fe=ce.setOptions,re=ce.use,K=ce.walkTokens,B=ce.parseInline,ae=ce,Ee=Y.parse,le=J.lex;me.Lexer=J,me.Parser=Y,me.Renderer=ne,me.Slugger=Q,me.TextRenderer=ee,me.Tokenizer=j,me.getDefaults=A,me.lexer=le,me.marked=ce,me.options=te,me.parse=ae,me.parseInline=B,me.parser=Ee,me.setOptions=fe,me.use=re,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(Ce[162],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=void 0;function D(u){const m=P(u);if(m&&m.length>0)return new Uint32Array(m)}e.$Uj=D;let N=0;const f=new Uint32Array(10);function P(u){if(N=0,A(u,C,4352),N>0||(A(u,b,4449),N>0)||(A(u,E,4520),N>0)||(A(u,S,12593),N))return f.subarray(0,N);if(u>=44032&&u<=55203){const m=u-44032,a=m%588,i=Math.floor(m/588),r=Math.floor(a/28),n=a%28-1;if(i<C.length?A(i,C,0):4352+i-12593<S.length&&A(4352+i,S,12593),r<b.length?A(r,b,0):4449+r-12593<S.length&&A(4449+r-12593,S,12593),n>=0&&(n<E.length?A(n,E,0):4520+n-12593<S.length&&A(4520+n-12593,S,12593)),N>0)return f.subarray(0,N)}}function A(u,m,a){u>=a&&u<a+m.length&&v(m[u-a])}function v(u){u!==0&&(f[N++]=u&255,u>>8&&(f[N++]=u>>8&255),u>>16&&(f[N++]=u>>16&255))}var $;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(k||(k={}));var R;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[77],Ie([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=void 0;const N=new D.$Dc(1e4);function f(k){return $(k,"NFC",N)}e.$Jl=f;const P=new D.$Dc(1e4);function A(k){return $(k,"NFD",P)}e.$Kl=A;const v=/[^\u0000-\u0080]/;function $(k,R,C){if(!k)return k;const b=C.get(k);if(b)return b;let E;return v.test(k)?E=k.normalize(R):E=k,C.set(k,E),E}e.$Ll=function(){const k=/[\u0300-\u036f]/g;return function(R){return A(R).replace(k,"")}}()}),define(Ce[122],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.rot=e.$0l=void 0;function D(v,$,k){return Math.min(Math.max(v,$),k)}e.$0l=D;function N(v,$){return($+v%$)%$}e.rot=N;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$_l=f;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$am=P;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$bm=A}),function(){function me(f){const P=[];typeof f=="number"&&P.push("code/timeOrigin",f);function A($){P.push($,Date.now())}function v(){const $=[];for(let k=0;k<P.length;k+=2)$.push({name:P[k],startTime:P[k+1]});return $}return{mark:A,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(f+A.startTime)});return P}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:me)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(N){if(e[N])return e[N].exports;var f=e[N]={i:N,l:!1,exports:{}};return me[N].call(f.exports,f,f.exports,D),f.l=!0,f.exports}return D.m=me,D.c=e,D.d=function(N,f,P){D.o(N,f)||Object.defineProperty(N,f,{enumerable:!0,get:P})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,f){if(1&f&&(N=D(N)),8&f||4&f&&typeof N=="object"&&N&&N.__esModule)return N;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:N}),2&f&&typeof N!="string")for(var A in N)D.d(P,A,function(v){return N[v]}.bind(null,A));return P},D.n=function(N){var f=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(f,"a",f),f},D.o=function(N,f){return Object.prototype.hasOwnProperty.call(N,f)},D.p="",D(D.s=0)}([function(me,e,D){(function(N){var f;e=me.exports=re,f=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],$=e.src=[],k=0,R=k++;$[R]="0|[1-9]\\d*";var C=k++;$[C]="[0-9]+";var b=k++;$[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;$[E]="("+$[R]+")\\.("+$[R]+")\\.("+$[R]+")";var S=k++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var u=k++;$[u]="(?:"+$[R]+"|"+$[b]+")";var m=k++;$[m]="(?:"+$[C]+"|"+$[b]+")";var a=k++;$[a]="(?:-("+$[u]+"(?:\\."+$[u]+")*))";var i=k++;$[i]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var r=k++;$[r]="[0-9A-Za-z-]+";var n=k++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var o=k++,t="v?"+$[E]+$[a]+"?"+$[n]+"?";$[o]="^"+t+"$";var h="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=k++;$[s]="^"+h+"$";var d=k++;$[d]="((?:<|>)?=?)";var l=k++;$[l]=$[C]+"|x|X|\\*";var c=k++;$[c]=$[R]+"|x|X|\\*";var p=k++;$[p]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[a]+")?"+$[n]+"?)?)?";var I=k++;$[I]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var w=k++;$[w]="^"+$[d]+"\\s*"+$[p]+"$";var g=k++;$[g]="^"+$[d]+"\\s*"+$[I]+"$";var y=k++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=k++;$[L]="(?:~>?)";var F=k++;$[F]="(\\s*)"+$[L]+"\\s+",v[F]=new RegExp($[F],"g");var z=k++;$[z]="^"+$[L]+$[p]+"$";var j=k++;$[j]="^"+$[L]+$[I]+"$";var O=k++;$[O]="(?:\\^)";var M=k++;$[M]="(\\s*)"+$[O]+"\\s+",v[M]=new RegExp($[M],"g");var T=k++;$[T]="^"+$[O]+$[p]+"$";var U=k++;$[U]="^"+$[O]+$[I]+"$";var J=k++;$[J]="^"+$[d]+"\\s*("+h+")$|^$";var ne=k++;$[ne]="^"+$[d]+"\\s*("+t+")$|^$";var ee=k++;$[ee]="(\\s*)"+$[d]+"\\s*("+h+"|"+$[p]+")",v[ee]=new RegExp($[ee],"g");var Q=k++;$[Q]="^\\s*("+$[p]+")\\s+-\\s+("+$[p]+")\\s*$";var Y=k++;$[Y]="^\\s*("+$[I]+")\\s+-\\s+("+$[I]+")\\s*$";var ce=k++;$[ce]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)f(te,$[te]),v[te]||(v[te]=new RegExp($[te]));function fe(H,X){if(H instanceof re)return H;if(typeof H!="string"||H.length>P||!(X?v[s]:v[o]).test(H))return null;try{return new re(H,X)}catch{return null}}function re(H,X){if(H instanceof re){if(H.loose===X)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof re))return new re(H,X);f("SemVer",H,X),this.loose=X;var oe=H.trim().match(X?v[s]:v[o]);if(!oe)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Me=+ve;if(Me>=0&&Me<A)return Me}return ve}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=fe,e.valid=function(H,X){var oe=fe(H,X);return oe?oe.version:null},e.clean=function(H,X){var oe=fe(H.trim().replace(/^[=v]+/,""),X);return oe?oe.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(H){return f("SemVer.compare",this.version,this.loose,H),H instanceof re||(H=new re(H,this.loose)),this.compareMain(H)||this.comparePre(H)},re.prototype.compareMain=function(H){return H instanceof re||(H=new re(H,this.loose)),B(this.major,H.major)||B(this.minor,H.minor)||B(this.patch,H.patch)},re.prototype.comparePre=function(H){if(H instanceof re||(H=new re(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var X=0;do{var oe=this.prerelease[X],ve=H.prerelease[X];if(f("prerelease compare",X,oe,ve),oe===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(oe===void 0)return-1;if(oe!==ve)return B(oe,ve)}while(++X)},re.prototype.inc=function(H,X){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,X,oe,ve){typeof oe=="string"&&(ve=oe,oe=void 0);try{return new re(H,oe).inc(X,ve).version}catch{return null}},e.diff=function(H,X){if(de(H,X))return null;var oe=fe(H),ve=fe(X);if(oe.prerelease.length||ve.prerelease.length){for(var Me in oe)if((Me==="major"||Me==="minor"||Me==="patch")&&oe[Me]!==ve[Me])return"pre"+Me;return"prerelease"}for(var Me in oe)if((Me==="major"||Me==="minor"||Me==="patch")&&oe[Me]!==ve[Me])return Me},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(H,X){var oe=K.test(H),ve=K.test(X);return oe&&ve&&(H=+H,X=+X),oe&&!ve?-1:ve&&!oe?1:H<X?-1:H>X?1:0}function ae(H,X,oe){return new re(H,oe).compare(new re(X,oe))}function Ee(H,X,oe){return ae(H,X,oe)>0}function le(H,X,oe){return ae(H,X,oe)<0}function de(H,X,oe){return ae(H,X,oe)===0}function ue(H,X,oe){return ae(H,X,oe)!==0}function ge(H,X,oe){return ae(H,X,oe)>=0}function V(H,X,oe){return ae(H,X,oe)<=0}function Z(H,X,oe,ve){var Me;switch(X){case"===":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Me=H===oe;break;case"!==":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Me=H!==oe;break;case"":case"=":case"==":Me=de(H,oe,ve);break;case"!=":Me=ue(H,oe,ve);break;case">":Me=Ee(H,oe,ve);break;case">=":Me=ge(H,oe,ve);break;case"<":Me=le(H,oe,ve);break;case"<=":Me=V(H,oe,ve);break;default:throw new TypeError("Invalid operator: "+X)}return Me}function he(H,X){if(H instanceof he){if(H.loose===X)return H;H=H.value}if(!(this instanceof he))return new he(H,X);f("comparator",H,X),this.loose=X,this.parse(H),this.semver===be?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(H,X){return B(X,H)},e.major=function(H,X){return new re(H,X).major},e.minor=function(H,X){return new re(H,X).minor},e.patch=function(H,X){return new re(H,X).patch},e.compare=ae,e.compareLoose=function(H,X){return ae(H,X,!0)},e.rcompare=function(H,X,oe){return ae(X,H,oe)},e.sort=function(H,X){return H.sort(function(oe,ve){return e.compare(oe,ve,X)})},e.rsort=function(H,X){return H.sort(function(oe,ve){return e.rcompare(oe,ve,X)})},e.gt=Ee,e.lt=le,e.eq=de,e.neq=ue,e.gte=ge,e.lte=V,e.cmp=Z,e.Comparator=he;var be={};function Pe(H,X){if(H instanceof Pe)return H.loose===X?H:new Pe(H.raw,X);if(H instanceof he)return new Pe(H.value,X);if(!(this instanceof Pe))return new Pe(H,X);if(this.loose=X,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function pe(H){return!H||H.toLowerCase()==="x"||H==="*"}function Le(H,X,oe,ve,Me,qe,Ge,Ye,it,ut,ot,et,Ae){return((X=pe(oe)?"":pe(ve)?">="+oe+".0.0":pe(Me)?">="+oe+"."+ve+".0":">="+X)+" "+(Ye=pe(it)?"":pe(ut)?"<"+(+it+1)+".0.0":pe(ot)?"<"+it+"."+(+ut+1)+".0":et?"<="+it+"."+ut+"."+ot+"-"+et:"<="+Ye)).trim()}function Ne(H,X){for(var oe=0;oe<H.length;oe++)if(!H[oe].test(X))return!1;if(X.prerelease.length){for(oe=0;oe<H.length;oe++)if(f(H[oe].semver),H[oe].semver!==be&&H[oe].semver.prerelease.length>0){var ve=H[oe].semver;if(ve.major===X.major&&ve.minor===X.minor&&ve.patch===X.patch)return!0}return!1}return!0}function W(H,X,oe){try{X=new Pe(X,oe)}catch{return!1}return X.test(H)}function x(H,X,oe,ve){var Me,qe,Ge,Ye,it;switch(H=new re(H,ve),X=new Pe(X,ve),oe){case">":Me=Ee,qe=V,Ge=le,Ye=">",it=">=";break;case"<":Me=le,qe=ge,Ge=Ee,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(W(H,X,ve))return!1;for(var ut=0;ut<X.set.length;++ut){var ot=X.set[ut],et=null,Ae=null;if(ot.forEach(function(ke){ke.semver===be&&(ke=new he(">=0.0.0")),et=et||ke,Ae=Ae||ke,Me(ke.semver,et.semver,ve)?et=ke:Ge(ke.semver,Ae.semver,ve)&&(Ae=ke)}),et.operator===Ye||et.operator===it||(!Ae.operator||Ae.operator===Ye)&&qe(H,Ae.semver)||Ae.operator===it&&Ge(H,Ae.semver))return!1}return!0}he.prototype.parse=function(H){var X=this.loose?v[J]:v[ne],oe=H.match(X);if(!oe)throw new TypeError("Invalid comparator: "+H);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new re(oe[2],this.loose):this.semver=be},he.prototype.toString=function(){return this.value},he.prototype.test=function(H){return f("Comparator.test",H,this.loose),this.semver===be||(typeof H=="string"&&(H=new re(H,this.loose)),Z(H,this.operator,this.semver,this.loose))},he.prototype.intersects=function(H,X){if(!(H instanceof he))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(H.value,X),W(this.value,oe,X);if(H.operator==="")return oe=new Pe(this.value,X),W(H.semver,oe,X);var ve=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ye=Z(this.semver,"<",H.semver,X)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),it=Z(this.semver,">",H.semver,X)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ve||Me||qe&&Ge||Ye||it},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(H){var X=this.loose;H=H.trim(),f("range",H,X);var oe=X?v[Y]:v[Q];H=H.replace(oe,Le),f("hyphen replace",H),H=H.replace(v[ee],"$1$2$3"),f("comparator trim",H,v[ee]),H=(H=(H=H.replace(v[F],"$1~")).replace(v[M],"$1^")).split(/\s+/).join(" ");var ve=X?v[J]:v[ne],Me=H.split(" ").map(function(qe){return function(Ge,Ye){return f("comp",Ge),Ge=function(it,ut){return it.trim().split(/\s+/).map(function(ot){return function(et,Ae){f("caret",et,Ae);var ke=Ae?v[U]:v[T];return et.replace(ke,function(He,_,se,De,Ve){var Xe;return f("caret",et,He,_,se,De,Ve),pe(_)?Xe="":pe(se)?Xe=">="+_+".0.0 <"+(+_+1)+".0.0":pe(De)?Xe=_==="0"?">="+_+"."+se+".0 <"+_+"."+(+se+1)+".0":">="+_+"."+se+".0 <"+(+_+1)+".0.0":Ve?(f("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=_==="0"?se==="0"?">="+_+"."+se+"."+De+Ve+" <"+_+"."+se+"."+(+De+1):">="+_+"."+se+"."+De+Ve+" <"+_+"."+(+se+1)+".0":">="+_+"."+se+"."+De+Ve+" <"+(+_+1)+".0.0"):(f("no pr"),Xe=_==="0"?se==="0"?">="+_+"."+se+"."+De+" <"+_+"."+se+"."+(+De+1):">="+_+"."+se+"."+De+" <"+_+"."+(+se+1)+".0":">="+_+"."+se+"."+De+" <"+(+_+1)+".0.0"),f("caret return",Xe),Xe})}(ot,ut)}).join(" ")}(Ge,Ye),f("caret",Ge),Ge=function(it,ut){return it.trim().split(/\s+/).map(function(ot){return function(et,Ae){var ke=Ae?v[j]:v[z];return et.replace(ke,function(He,_,se,De,Ve){var Xe;return f("tilde",et,He,_,se,De,Ve),pe(_)?Xe="":pe(se)?Xe=">="+_+".0.0 <"+(+_+1)+".0.0":pe(De)?Xe=">="+_+"."+se+".0 <"+_+"."+(+se+1)+".0":Ve?(f("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Xe=">="+_+"."+se+"."+De+Ve+" <"+_+"."+(+se+1)+".0"):Xe=">="+_+"."+se+"."+De+" <"+_+"."+(+se+1)+".0",f("tilde return",Xe),Xe})}(ot,ut)}).join(" ")}(Ge,Ye),f("tildes",Ge),Ge=function(it,ut){return f("replaceXRanges",it,ut),it.split(/\s+/).map(function(ot){return function(et,Ae){et=et.trim();var ke=Ae?v[g]:v[w];return et.replace(ke,function(He,_,se,De,Ve,Xe){f("xRange",et,He,_,se,De,Ve,Xe);var nt=pe(se),rt=nt||pe(De),je=rt||pe(Ve);return _==="="&&je&&(_=""),nt?He=_===">"||_==="<"?"<0.0.0":"*":_&&je?(rt&&(De=0),je&&(Ve=0),_===">"?(_=">=",rt?(se=+se+1,De=0,Ve=0):je&&(De=+De+1,Ve=0)):_==="<="&&(_="<",rt?se=+se+1:De=+De+1),He=_+se+"."+De+"."+Ve):rt?He=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(He=">="+se+"."+De+".0 <"+se+"."+(+De+1)+".0"),f("xRange return",He),He})}(ot,ut)}).join(" ")}(Ge,Ye),f("xrange",Ge),Ge=function(it,ut){return f("replaceStars",it,ut),it.trim().replace(v[ce],"")}(Ge,Ye),f("stars",Ge),Ge}(qe,X)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(qe){return!!qe.match(ve)})),Me=Me.map(function(qe){return new he(qe,X)})},Pe.prototype.intersects=function(H,X){if(!(H instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(ve){return H.set.some(function(Me){return Me.every(function(qe){return ve.intersects(qe,X)})})})})},e.toComparators=function(H,X){return new Pe(H,X).set.map(function(oe){return oe.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new re(H,this.loose));for(var X=0;X<this.set.length;X++)if(Ne(this.set[X],H))return!0;return!1},e.satisfies=W,e.maxSatisfying=function(H,X,oe){var ve=null,Me=null;try{var qe=new Pe(X,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ve&&Me.compare(Ge)!==-1||(Me=new re(ve=Ge,oe)))}),ve},e.minSatisfying=function(H,X,oe){var ve=null,Me=null;try{var qe=new Pe(X,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ve&&Me.compare(Ge)!==1||(Me=new re(ve=Ge,oe)))}),ve},e.validRange=function(H,X){try{return new Pe(H,X).range||"*"}catch{return null}},e.ltr=function(H,X,oe){return x(H,X,"<",oe)},e.gtr=function(H,X,oe){return x(H,X,">",oe)},e.outside=x,e.prerelease=function(H,X){var oe=fe(H,X);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(H,X,oe){return H=new Pe(H,oe),X=new Pe(X,oe),H.intersects(X)},e.coerce=function(H){if(H instanceof re)return H;if(typeof H!="string")return null;var X=H.match(v[y]);return X==null?null:fe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,D(1))},function(me,e){var D,N,f=me.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(m){if(D===setTimeout)return setTimeout(m,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var $,k=[],R=!1,C=-1;function b(){R&&$&&(R=!1,$.length?k=$.concat(k):C=-1,k.length&&E())}function E(){if(!R){var m=v(b);R=!0;for(var a=k.length;a;){for($=k,k=[];++C<a;)$&&$[C].run();C=-1,a=k.length}$=null,R=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(m)}}function S(m,a){this.fun=m,this.array=a}function u(){}f.nextTick=function(m){var a=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)a[i-1]=arguments[i];k.push(new S(m,a)),k.length!==1||R||v(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=u,f.addListener=u,f.once=u,f.off=u,f.removeListener=u,f.removeAllListeners=u,f.emit=u,f.prependListener=u,f.prependOnceListener=u,f.listeners=function(m){return[]},f.binding=function(m){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(m){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(Ce[38],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(P){return new N(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Sd=N}),define(Ce[4],Ie([1,0,14,75,3,76,38]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.Event=void 0;const v=!1,$=!1;var k;(function(w){w.None=()=>f.$Tc.None;function g(V){if($){const{onDidAddListener:Z}=V,he=S.create();let be=0;V.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),Z?.()}}}function y(V,Z){return ne(V,()=>{},0,void 0,!0,void 0,Z)}w.defer=y;function L(V){return(Z,he=null,be)=>{let Pe=!1,pe;return pe=V(Le=>{if(!Pe)return pe?pe.dispose():Pe=!0,Z.call(he,Le)},null,be),Pe&&pe.dispose(),pe}}w.once=L;function F(V,Z,he){return U((be,Pe=null,pe)=>V(Le=>be.call(Pe,Z(Le)),null,pe),he)}w.map=F;function z(V,Z,he){return U((be,Pe=null,pe)=>V(Le=>{Z(Le),be.call(Pe,Le)},null,pe),he)}w.forEach=z;function j(V,Z,he){return U((be,Pe=null,pe)=>V(Le=>Z(Le)&&be.call(Pe,Le),null,pe),he)}w.filter=j;function O(V){return V}w.signal=O;function M(...V){return(Z,he=null,be)=>{const Pe=(0,f.$Qc)(...V.map(pe=>pe(Le=>Z.call(he,Le))));return J(Pe,be)}}w.any=M;function T(V,Z,he,be){let Pe=he;return F(V,pe=>(Pe=Z(Pe,pe),Pe),be)}w.reduce=T;function U(V,Z){let he;const be={onWillAddFirstListener(){he=V(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};Z||g(be);const Pe=new r(be);return Z?.add(Pe),Pe.event}function J(V,Z){return Z instanceof Array?Z.push(V):Z&&Z.add(V),V}function ne(V,Z,he=100,be=!1,Pe=!1,pe,Le){let Ne,W,x,H=0,X;const oe={leakWarningThreshold:pe,onWillAddFirstListener(){Ne=V(Me=>{H++,W=Z(W,Me),be&&!x&&(ve.fire(W),W=void 0),X=()=>{const qe=W;W=void 0,x=void 0,(!be||H>1)&&ve.fire(qe),H=0},typeof he=="number"?(clearTimeout(x),x=setTimeout(X,he)):x===void 0&&(x=0,queueMicrotask(X))})},onWillRemoveListener(){Pe&&H>0&&X?.()},onDidRemoveLastListener(){X=void 0,Ne.dispose()}};Le||g(oe);const ve=new r(oe);return Le?.add(ve),ve.event}w.debounce=ne;function ee(V,Z=0,he){return w.debounce(V,(be,Pe)=>be?(be.push(Pe),be):[Pe],Z,void 0,!0,void 0,he)}w.accumulate=ee;function Q(V,Z=(be,Pe)=>be===Pe,he){let be=!0,Pe;return j(V,pe=>{const Le=be||!Z(pe,Pe);return be=!1,Pe=pe,Le},he)}w.latch=Q;function Y(V,Z,he){return[w.filter(V,Z,he),w.filter(V,be=>!Z(be),he)]}w.split=Y;function ce(V,Z=!1,he=[],be){let Pe=he.slice(),pe=V(W=>{Pe?Pe.push(W):Ne.fire(W)});be&&be.add(pe);const Le=()=>{Pe?.forEach(W=>Ne.fire(W)),Pe=null},Ne=new r({onWillAddFirstListener(){pe||(pe=V(W=>Ne.fire(W)),be&&be.add(pe))},onDidAddFirstListener(){Pe&&(Z?setTimeout(Le):Le())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return be&&be.add(Ne),Ne.event}w.buffer=ce;function te(V,Z){return(be,Pe,pe)=>{const Le=Z(new re);return V(function(Ne){const W=Le.evaluate(Ne);W!==fe&&be.call(Pe,W)},void 0,pe)}}w.chain=te;const fe=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(he=>(Z(he),he)),this}filter(Z){return this.f.push(he=>Z(he)?he:fe),this}reduce(Z,he){let be=he;return this.f.push(Pe=>(be=Z(be,Pe),be)),this}latch(Z=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const pe=he||!Z(Pe,be);return he=!1,be=Pe,pe?Pe:fe}),this}evaluate(Z){for(const he of this.f)if(Z=he(Z),Z===fe)break;return Z}}function K(V,Z,he=be=>be){const be=(...Ne)=>Le.fire(he(...Ne)),Pe=()=>V.on(Z,be),pe=()=>V.removeListener(Z,be),Le=new r({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Le.event}w.fromNodeEventEmitter=K;function B(V,Z,he=be=>be){const be=(...Ne)=>Le.fire(he(...Ne)),Pe=()=>V.addEventListener(Z,be),pe=()=>V.removeEventListener(Z,be),Le=new r({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Le.event}w.fromDOMEventEmitter=B;function ae(V){return new Promise(Z=>L(V)(Z))}w.toPromise=ae;function Ee(V){const Z=new r;return V.then(he=>{Z.fire(he)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}w.fromPromise=Ee;function le(V,Z,he){return Z(he),V(be=>Z(be))}w.runAndSubscribe=le;class de{constructor(Z,he){this._observable=Z,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};he||g(be),this.emitter=new r(be),he&&he.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,he){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(V,Z){return new de(V,Z).emitter.event}w.fromObservable=ue;function ge(V){return(Z,he,be)=>{let Pe=0,pe=!1;const Le={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(V.reportChanges(),pe&&(pe=!1,Z.call(he)))},handlePossibleChange(){},handleChange(){pe=!0}};V.addObserver(Le),V.reportChanges();const Ne={dispose(){V.removeObserver(Le)}};return be instanceof f.$Sc?be.add(Ne):Array.isArray(be)&&be.push(Ne),Ne}}w.fromObservableLight=ge})(k||(e.Event=k={}));class R{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${R.f++}`,R.all.add(this)}start(g){this.g=new A.$Sd,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Ud=R;let C=-1;function b(w){const g=C;return C=w,{dispose(){C=g}}}e.$Vd=b;class E{constructor(g,y=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=y,this.g=0}dispose(){this.f?.clear()}check(g,y){const L=this.threshold;if(L<=0||y<L)return;this.f||(this.f=new Map);const F=this.f.get(g.value)||0;if(this.f.set(g.value,F+1),this.g-=1,this.g<=0){this.g=L*.5;let z,j=0;for(const[O,M]of this.f)(!z||j<M)&&(z=O,j=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${j}):`),console.warn(z)}return()=>{const z=this.f.get(g.value)||0;this.f.set(g.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class m{constructor(g){this.value=g,this.id=u++}}const a=2,i=(w,g)=>{if(w instanceof m)g(w);else for(let y=0;y<w.length;y++){const L=w[y];L&&g(L)}};class r{constructor(g){this.w=0,this.f=g,this.g=C>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const g=this.t;queueMicrotask(()=>{i(g,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,y,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Tc.None;if(this.m)return f.$Tc.None;y&&(g=g.bind(y));const F=new m(g);let z,j;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=S.create(),z=this.g.check(F.stack,this.w+1)),v&&(F.stack=j??S.create()),this.t?this.t instanceof m?(this.u??=new o,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,f.$Rc)(()=>{z?.(),this.x(F)});return L instanceof f.$Sc?L.add(O):Array.isArray(L)&&L.push(O),O},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,L=y.indexOf(g);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[L]=void 0;const F=this.u.current===this;if(this.w*a<=y.length){let z=0;for(let j=0;j<y.length;j++)y[j]?y[z++]=y[j]:F&&(this.u.end--,z<this.u.i&&this.u.i--);y.length=z}}y(g,y){if(!g)return;const L=this.f?.onListenerError||D.$1;if(!L){g.value(y);return}try{g.value(y)}catch(F){L(F)}}z(g){const y=g.current.t;for(;g.i<g.end;)this.y(y[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,g);else{const y=this.u;y.enqueue(this,g,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Wd=r;const n=()=>new o;e.$Xd=n;class o{constructor(){this.i=-1,this.end=0}enqueue(g,y,L){this.i=0,this.end=L,this.current=g,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(g,y,L){if(this.t)for(this.h||(this.h=new P.$4c),i(this.t,F=>this.h.push([F.value,g]));this.h.size>0&&!y.isCancellationRequested;){const[F,z]=this.h.shift(),j=[],O={...z,token:y,waitUntil:M=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");L&&(M=L(M,F)),j.push(M)}};try{F(O)}catch(M){(0,D.$1)(M);continue}Object.freeze(j),await Promise.allSettled(j).then(M=>{for(const T of M)T.status==="rejected"&&(0,D.$1)(T.reason)})}}}e.$Yd=t;class h extends r{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new P.$4c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Zd=h;class s extends h{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$1d=s;class d extends r{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$2d=d;class l{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const y={event:g,listener:null};this.h.push(y),this.g&&this.m(y);const L=()=>{this.g&&this.o(y);const F=this.h.indexOf(y);this.h.splice(F,1)};return(0,f.$Rc)((0,N.$db)(L))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(y=>this.f.fire(y))}o(g){g.listener?.dispose(),g.listener=null}dispose(){this.f.dispose();for(const g of this.h)g.listener?.dispose();this.h=[]}}e.$3d=l;class c{constructor(g,y,L,F){this.f=new f.$Sc;const z=this.f.add(new l),j=this.f.add(new f.$3c);function O(M){j.set(M,z.add(F(M)))}for(const M of g)O(M);this.f.add(y(M=>{O(M)})),this.f.add(L(M=>{j.deleteAndDispose(M)})),this.event=z.event}dispose(){this.f.dispose()}}e.$4d=c;class p{constructor(){this.f=[]}wrapEvent(g){return(y,L,F)=>g(z=>{const j=this.f[this.f.length-1];j?j.push(()=>y.call(L,z)):y.call(L,z)},void 0,F)}bufferEvents(g){const y=[];this.f.push(y);const L=g();return this.f.pop(),y.forEach(F=>F()),L}}e.$5d=p;class I{constructor(){this.f=!1,this.g=k.None,this.h=f.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$6d=I}),define(Ce[22],Ie([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.CancellationToken=void 0;const N=Object.freeze(function(v,$){const k=setTimeout(v.bind($),0);return{dispose(){clearTimeout(k)}}});var f;(function(v){function $(k){return k===v.None||k===v.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}v.isCancellationToken=$,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(f||(e.CancellationToken=f={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=f.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=f.None}}e.$7d=A}),define(Ce[163],Ie([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=e.$Ge=e.$Fe=void 0;class N{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new D.$7d,$=this.b(v.token);return this.a={promise:$,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$Fe=N;class f{constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const $=JSON.stringify(v);return this.b!==$&&(this.b=$,this.a=this.c(v)),this.a}}e.$Ge=f;class P{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const $=this.b(v);return this.a.set(v,$),$}}e.$He=P}),define(Ce[98],Ie([1,0,14,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function f(n){const o=n;return o?typeof o.read=="function":!1}e.$8d=f;function P(n){const o=n;return o?[o.on,o.pause,o.resume,o.destroy].every(t=>typeof t=="function"):!1}e.$9d=P;function A(n){const o=n;return o?P(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.$0d=A;function v(n,o){return new $(n,o)}e.$$d=v;class ${constructor(o,t){this.e=o,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(t=>t(o))}h(o){this.c.error.length===0?(0,D.$1)(o):this.c.error.slice(0).forEach(t=>t(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,t){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(o,t){if(this.a.destroyed)return;let h;switch(o){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const s=h.indexOf(t);s>=0&&h.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(n,o){const t=[];let h;for(;(h=n.read())!==null;)t.push(h);return o(t)}e.$_d=k;function R(n,o,t){const h=[];let s;for(;(s=n.read())!==null&&h.length<t;)h.push(s);return s===null&&h.length>0?o(h):{read:()=>{if(h.length>0)return h.shift();if(typeof s<"u"){const d=s;return s=void 0,d}return n.read()}}}e.$ae=R;function C(n,o){return new Promise((t,h)=>{const s=[];b(n,{onData:d=>{o&&s.push(d)},onError:d=>{o?h(d):t(void 0)},onEnd:()=>{t(o?o(s):void 0)}})})}e.$be=C;function b(n,o,t){n.on("error",h=>{t?.isCancellationRequested||o.onError(h)}),n.on("end",()=>{t?.isCancellationRequested||o.onEnd()}),n.on("data",h=>{t?.isCancellationRequested||o.onData(h)})}e.$ce=b;function E(n,o){return new Promise((t,h)=>{const s=new N.$Sc,d=[],l=I=>{if(d.push(I),d.length>o)return s.dispose(),n.pause(),t({stream:n,buffer:d,ended:!1})},c=I=>(s.dispose(),h(I)),p=()=>(s.dispose(),t({stream:n,buffer:d,ended:!0}));s.add((0,N.$Rc)(()=>n.removeListener("error",c))),n.on("error",c),s.add((0,N.$Rc)(()=>n.removeListener("end",p))),n.on("end",p),s.add((0,N.$Rc)(()=>n.removeListener("data",l))),n.on("data",l)})}e.$de=E;function S(n,o){const t=v(o);return t.end(n),t}e.$ee=S;function u(){const n=v(()=>{throw new Error("not supported")});return n.end(),n}e.$fe=u;function m(n){let o=!1;return{read:()=>o?null:(o=!0,n)}}e.$ge=m;function a(n,o,t){const h=v(t);return b(n,{onData:s=>h.write(o.data(s)),onError:s=>h.error(o.error?o.error(s):s),onEnd:()=>h.end()}),h}e.$he=a;function i(n,o,t){let h=!1;return{read:()=>{const s=o.read();return h?s:(h=!0,s!==null?t([n,s]):n)}}}e.$ie=i;function r(n,o,t){let h=!1;const s=v(t);return b(o,{onData:d=>h?s.write(d):(h=!0,s.write(t([n,d]))),onError:d=>s.error(d),onEnd:()=>{h||(h=!0,s.write(n)),s.end()}}),s}e.$je=r}),define(Ce[21],Ie([1,0,43,98]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const f=typeof Buffer<"u",P=new D.$V(()=>new Uint8Array(256));let A,v;class ${static alloc(y){return f?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return f&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,L){return!(L?.dontUseNodeBuffer||!1)&&f?new $(Buffer.from(y)):(A||(A=new TextEncoder),new $(A.encode(y)))}static fromByteArray(y){const L=$.alloc(y.length);for(let F=0,z=y.length;F<z;F++)L.buffer[F]=y[F];return L}static concat(y,L){if(typeof L>"u"){L=0;for(let j=0,O=y.length;j<O;j++)L+=y[j].byteLength}const F=$.alloc(L);let z=0;for(let j=0,O=y.length;j<O;j++){const M=y[j];F.set(M,z),z+=M.byteLength}return F}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return f?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(y,L){return new $(this.buffer.subarray(y,L))}set(y,L){if(y instanceof $)this.buffer.set(y.buffer,L);else if(y instanceof Uint8Array)this.buffer.set(y,L);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),L);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return b(this.buffer,y)}writeUInt32BE(y,L){E(this.buffer,y,L)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,L){u(this.buffer,y,L)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,L){a(this.buffer,y,L)}indexOf(y,L=0){return k(this.buffer,y instanceof $?y.buffer:y,L)}}e.$ke=$;function k(g,y,L=0){const F=y.byteLength,z=g.byteLength;if(F===0)return 0;if(F===1)return g.indexOf(y[0]);if(F>z-L)return-1;const j=P.value;j.fill(y.length);for(let U=0;U<y.length;U++)j[y[U]]=y.length-U-1;let O=L+y.length-1,M=O,T=-1;for(;O<z;)if(g[O]===y[M]){if(M===0){T=O;break}O--,M--}else O+=Math.max(y.length-M,j[g[O]]),M=y.length-1;return T}e.$le=k;function R(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0}e.$me=R;function C(g,y,L){g[L+0]=y&255,y=y>>>8,g[L+1]=y&255}e.$ne=C;function b(g,y){return g[y]*2**24+g[y+1]*2**16+g[y+2]*2**8+g[y+3]}e.$oe=b;function E(g,y,L){g[L+3]=y,y=y>>>8,g[L+2]=y,y=y>>>8,g[L+1]=y,y=y>>>8,g[L]=y}e.$pe=E;function S(g,y){return g[y+0]<<0>>>0|g[y+1]<<8>>>0|g[y+2]<<16>>>0|g[y+3]<<24>>>0}e.$qe=S;function u(g,y,L){g[L+0]=y&255,y=y>>>8,g[L+1]=y&255,y=y>>>8,g[L+2]=y&255,y=y>>>8,g[L+3]=y&255}e.$re=u;function m(g,y){return g[y]}e.$se=m;function a(g,y,L){g[L]=y}e.$te=a;function i(g){return N.$_d(g,y=>$.concat(y))}e.$ue=i;function r(g){return N.$ge(g)}e.$ve=r;function n(g){return N.$be(g,y=>$.concat(y))}e.$we=n;async function o(g){return g.ended?$.concat(g.buffer):$.concat([...g.buffer,await n(g.stream)])}e.$xe=o;function t(g){return N.$ee(g,y=>$.concat(y))}e.$ye=t;function h(g){return N.$he(g,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}e.$ze=h;function s(g){return N.$$d(y=>$.concat(y),g)}e.$Ae=s;function d(g,y){return N.$ie(g,y,L=>$.concat(L))}e.$Be=d;function l(g,y){return N.$je(g,y,L=>$.concat(L))}e.$Ce=l;function c(g){let y=0,L=0,F=0;const z=new Uint8Array(Math.floor(g.length/4*3)),j=M=>{switch(L){case 3:z[F++]=y|M,L=0;break;case 2:z[F++]=y|M>>>2,y=M<<6,L=3;break;case 1:z[F++]=y|M>>>4,y=M<<4,L=2;break;default:y=M<<2,L=1}};for(let M=0;M<g.length;M++){const T=g.charCodeAt(M);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${g[M]}`)}}const O=F;for(;L>0;)j(0);return $.wrap(z).slice(0,O)}e.$De=c;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:g},y=!0,L=!1){const F=L?I:p;let z="";const j=g.byteLength%3;let O=0;for(;O<g.byteLength-j;O+=3){const M=g[O+0],T=g[O+1],U=g[O+2];z+=F[M>>>2],z+=F[(M<<4|T>>>4)&63],z+=F[(T<<2|U>>>6)&63],z+=F[U&63]}if(j===1){const M=g[O+0];z+=F[M>>>2],z+=F[M<<4&63],y&&(z+="==")}else if(j===2){const M=g[O+0],T=g[O+1];z+=F[M>>>2],z+=F[(M<<4|T>>>4)&63],z+=F[T<<2&63],y&&(z+="=")}return z}e.$Ee=w}),define(Ce[12],Ie([1,0,163,43]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jf=e.$If=e.$Hf=e.$Gf=e.GraphemeBreakType=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ke=f;const P=/{(\d+)}/g;function A(Ae,...ke){return ke.length===0?Ae:Ae.replace(P,function(He,_){const se=parseInt(_,10);return isNaN(se)||se<0||se>=ke.length?He:ke[se]})}e.$Le=A;const v=/{([^}]+)}/g;function $(Ae,ke){return Object.keys(ke).length===0?Ae:Ae.replace(v,(He,_)=>ke[_]??He)}e.$Me=$;function k(Ae){return Ae.replace(/[<>"'&]/g,ke=>{switch(ke){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ke})}e.$Ne=k;function R(Ae){return Ae.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.$Oe=R;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Pe=C;function b(Ae,ke){let He=0;const _=ke.charCodeAt(0);for(let se=Ae.length-1;se>=0;se--)Ae.charCodeAt(se)===_&&He++;return He}e.$Qe=b;function E(Ae,ke,He="\u2026"){return Ae.length<=ke?Ae:`${Ae.substr(0,ke)}${He}`}e.$Re=E;function S(Ae,ke,He="\u2026"){if(Ae.length<=ke)return Ae;const _=Math.ceil(ke/2)-He.length/2,se=Math.floor(ke/2)-He.length/2;return`${Ae.substr(0,_)}${He}${Ae.substr(Ae.length-se)}`}e.$Se=S;function u(Ae,ke=" "){const He=m(Ae,ke);return a(He,ke)}e.$Te=u;function m(Ae,ke){if(!Ae||!ke)return Ae;const He=ke.length;if(He===0||Ae.length===0)return Ae;let _=0;for(;Ae.indexOf(ke,_)===_;)_=_+He;return Ae.substring(_)}e.$Ue=m;function a(Ae,ke){if(!Ae||!ke)return Ae;const He=ke.length,_=Ae.length;if(He===0||_===0)return Ae;let se=_,De=-1;for(;De=Ae.lastIndexOf(ke,se-1),!(De===-1||De+He!==se);){if(De===0)return"";se=De}return Ae.substring(0,se)}e.$Ve=a;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$We=i;function r(Ae){return Ae.replace(/\*/g,"")}e.$Xe=r;function n(Ae,ke,He={}){if(!Ae)throw new Error("Cannot create regex from empty string");ke||(Ae=C(Ae)),He.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let _="";return He.global&&(_+="g"),He.matchCase||(_+="i"),He.multiline&&(_+="m"),He.unicode&&(_+="u"),new RegExp(Ae,_)}e.$Ye=n;function o(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Ze=o;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$1e=t;function h(Ae){const ke=[],He=Ae.split(/(\r\n|\r|\n)/);for(let _=0;_<Math.ceil(He.length/2);_++)ke.push(He[2*_]+(He[2*_+1]??""));return ke}e.$2e=h;function s(Ae){for(let ke=0,He=Ae.length;ke<He;ke++){const _=Ae.charCodeAt(ke);if(_!==32&&_!==9)return ke}return-1}e.$3e=s;function d(Ae,ke=0,He=Ae.length){for(let _=ke;_<He;_++){const se=Ae.charCodeAt(_);if(se!==32&&se!==9)return Ae.substring(ke,_)}return Ae.substring(ke,He)}e.$4e=d;function l(Ae,ke=Ae.length-1){for(let He=ke;He>=0;He--){const _=Ae.charCodeAt(He);if(_!==32&&_!==9)return He}return-1}e.$5e=l;function c(Ae,ke,He){const _=[];let se=0;for(const De of Ae.matchAll(ke)){if(_.push(Ae.slice(se,De.index)),De.index===void 0)throw new Error("match.index should be defined");se=De.index+De[0].length,_.push(He(De[0],...De.slice(1),De.index,Ae,De.groups))}return _.push(Ae.slice(se)),Promise.all(_).then(De=>De.join(""))}e.$6e=c;function p(Ae,ke){return Ae<ke?-1:Ae>ke?1:0}e.$7e=p;function I(Ae,ke,He=0,_=Ae.length,se=0,De=ke.length){for(;He<_&&se<De;He++,se++){const nt=Ae.charCodeAt(He),rt=ke.charCodeAt(se);if(nt<rt)return-1;if(nt>rt)return 1}const Ve=_-He,Xe=De-se;return Ve<Xe?-1:Ve>Xe?1:0}e.$8e=I;function w(Ae,ke){return g(Ae,ke,0,Ae.length,0,ke.length)}e.$9e=w;function g(Ae,ke,He=0,_=Ae.length,se=0,De=ke.length){for(;He<_&&se<De;He++,se++){let nt=Ae.charCodeAt(He),rt=ke.charCodeAt(se);if(nt===rt)continue;if(nt>=128||rt>=128)return I(Ae.toLowerCase(),ke.toLowerCase(),He,_,se,De);L(nt)&&(nt-=32),L(rt)&&(rt-=32);const je=nt-rt;if(je!==0)return je}const Ve=_-He,Xe=De-se;return Ve<Xe?-1:Ve>Xe?1:0}e.$0e=g;function y(Ae){return Ae>=48&&Ae<=57}e.$$e=y;function L(Ae){return Ae>=97&&Ae<=122}e.$_e=L;function F(Ae){return Ae>=65&&Ae<=90}e.$af=F;function z(Ae,ke){return Ae.length===ke.length&&g(Ae,ke)===0}e.$bf=z;function j(Ae,ke){const He=ke.length;return ke.length>Ae.length?!1:g(Ae,ke,0,He)===0}e.$cf=j;function O(Ae,ke){const He=Math.min(Ae.length,ke.length);let _;for(_=0;_<He;_++)if(Ae.charCodeAt(_)!==ke.charCodeAt(_))return _;return He}e.$df=O;function M(Ae,ke){const He=Math.min(Ae.length,ke.length);let _;const se=Ae.length-1,De=ke.length-1;for(_=0;_<He;_++)if(Ae.charCodeAt(se-_)!==ke.charCodeAt(De-_))return _;return He}e.$ef=M;function T(Ae){return 55296<=Ae&&Ae<=56319}e.$ff=T;function U(Ae){return 56320<=Ae&&Ae<=57343}e.$gf=U;function J(Ae,ke){return(Ae-55296<<10)+(ke-56320)+65536}e.$hf=J;function ne(Ae,ke,He){const _=Ae.charCodeAt(He);if(T(_)&&He+1<ke){const se=Ae.charCodeAt(He+1);if(U(se))return J(_,se)}return _}e.$if=ne;function ee(Ae,ke){const He=Ae.charCodeAt(ke-1);if(U(He)&&ke>1){const _=Ae.charCodeAt(ke-2);if(T(_))return J(_,He)}return He}class Q{get offset(){return this.e}constructor(ke,He=0){this.c=ke,this.d=ke.length,this.e=He}setOffset(ke){this.e=ke}prevCodePoint(){const ke=ee(this.c,this.e);return this.e-=ke>=65536?2:1,ke}nextCodePoint(){const ke=ne(this.c,this.d,this.e);return this.e+=ke>=65536?2:1,ke}eol(){return this.e>=this.d}}e.$jf=Q;class Y{get offset(){return this.c.offset}constructor(ke,He=0){this.c=new Q(ke,He)}nextGraphemeLength(){const ke=Me.getInstance(),He=this.c,_=He.offset;let se=ke.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const De=He.offset,Ve=ke.getGraphemeBreakType(He.nextCodePoint());if(oe(se,Ve)){He.setOffset(De);break}se=Ve}return He.offset-_}prevGraphemeLength(){const ke=Me.getInstance(),He=this.c,_=He.offset;let se=ke.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const De=He.offset,Ve=ke.getGraphemeBreakType(He.prevCodePoint());if(oe(Ve,se)){He.setOffset(De);break}se=Ve}return _-He.offset}eol(){return this.c.eol()}}e.$kf=Y;function ce(Ae,ke){return new Y(Ae,ke).nextGraphemeLength()}e.$lf=ce;function te(Ae,ke){return new Y(Ae,ke).prevGraphemeLength()}e.$mf=te;function fe(Ae,ke){ke>0&&U(Ae.charCodeAt(ke))&&ke--;const He=ke+ce(Ae,ke);return[He-te(Ae,He),He]}e.$nf=fe;function re(Ae){const ke=new Y(Ae);let He=0;for(;!ke.eol();)He++,ke.nextGraphemeLength();return He}e.$of=re;let K;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Ae){return K||(K=B()),K.test(Ae)}e.$pf=ae;const Ee=/^[\t\n\r\x20-\x7E]*$/;function le(Ae){return Ee.test(Ae)}e.$qf=le,e.$rf=/[\u2028\u2029]/;function de(Ae){return e.$rf.test(Ae)}e.$sf=de;function ue(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$tf=ue;function ge(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$uf=ge;function V(Ae,ke,He=""){const _=Ae.trimStart();if(_.length<ke)return _;const se=/\b/g;let De=0;for(;se.test(_)&&!(_.length-se.lastIndex<ke);)De=se.lastIndex,se.lastIndex+=1;return De===0?_:He+_.substring(De).trimStart()}e.$vf=V;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function be(Ae){return Ae&&(Ae=Ae.replace(Z,"").replace(he,"")),Ae}e.$wf=be,e.$xf="\uFEFF";function Pe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$yf=Pe;function pe(Ae){return Pe(Ae)?Ae.substr(1):Ae}e.$zf=pe;function Le(Ae,ke){if(!Ae||!ke||Ae.length<ke.length)return!1;const He=ke.length,_=Ae.toLowerCase();let se=0,De=-1;for(;se<He;){const Ve=_.indexOf(ke[se],De+1);if(Ve<0)return!1;De=Ve,se++}return!0}e.$Af=Le;function Ne(Ae,ke=!1){return Ae?(ke&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$Bf=Ne;function W(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$Cf=W;function x(Ae,ke=1){if(ke===0)return"";let He=-1;do He=Ae.indexOf(`
`,He+1),ke--;while(ke>0&&He>=0);return He===-1?Ae:(Ae[He-1]==="\r"&&He--,Ae.substr(0,He))}e.$Df=x;function H(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$Ef=H;function X(Ae){return Me.getInstance().getGraphemeBreakType(Ae)}e.$Ff=X;function oe(Ae,ke){return Ae===0?ke!==5&&ke!==7:Ae===2&&ke===3?!1:Ae===4||Ae===2||Ae===3||ke===4||ke===2||ke===3?!0:!(Ae===8&&(ke===8||ke===9||ke===11||ke===12)||(Ae===11||Ae===9)&&(ke===9||ke===10)||(Ae===12||Ae===10)&&ke===10||ke===5||ke===13||ke===7||Ae===1||Ae===13&&ke===14||Ae===6&&ke===6)}var ve;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=qe()}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const He=this.d,_=He.length/3;let se=1;for(;se<=_;)if(ke<He[3*se])se=2*se;else if(ke>He[3*se+1])se=2*se+1;else return He[3*se+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(Ae,ke){if(Ae===0)return 0;const He=Ye(Ae,ke);if(He!==void 0)return He;const _=new Q(ke,Ae);return _.prevCodePoint(),_.offset}e.$Gf=Ge;function Ye(Ae,ke){const He=new Q(ke,Ae);let _=He.prevCodePoint();for(;it(_)||_===65039||_===8419;){if(He.offset===0)return;_=He.prevCodePoint()}if(!ge(_))return;let se=He.offset;return se>0&&He.prevCodePoint()===8205&&(se=He.offset),se}function it(Ae){return 127995<=Ae&&Ae<=127999}var ut;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(ut||(ut={})),e.$Hf="\xA0";class ot{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ge(ke=>{function He(je){const yt=new Map;for(let kt=0;kt<je.length;kt+=2)yt.set(je[kt],je[kt+1]);return yt}function _(je,yt){const kt=new Map(je);for(const[Tt,Mt]of yt)kt.set(Tt,Mt);return kt}function se(je,yt){if(!je)return yt;const kt=new Map;for(const[Tt,Mt]of je)yt.has(Tt)&&kt.set(Tt,Mt);return kt}const De=this.c.value;let Ve=ke.filter(je=>!je.startsWith("_")&&je in De);Ve.length===0&&(Ve=["_default"]);let Xe;for(const je of Ve){const yt=He(De[je]);Xe=se(Xe,yt)}const nt=He(De._common),rt=_(nt,Xe);return new ot(rt)})}static getInstance(ke){return ot.d.get(Array.from(ke))}static{this.e=new N.$V(()=>Object.keys(ot.c.value).filter(ke=>!ke.startsWith("_")))}static getLocales(){return ot.e.value}constructor(ke){this.f=ke}isAmbiguous(ke){return this.f.has(ke)}getPrimaryConfusable(ke){return this.f.get(ke)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$If=ot;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(ke){return et.e().has(ke)}static get codePoints(){return et.e()}}e.$Jf=et}),define(Ce[123],Ie([1,0,28,162,12]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=e.$9j=e.FuzzyScore=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.or=void 0;function P(...pe){return function(Le,Ne){for(let W=0,x=pe.length;W<x;W++){const H=pe[W](Le,Ne);if(H)return H}return null}}e.or=P,e.$Wj=A.bind(void 0,!1),e.$Xj=A.bind(void 0,!0);function A(pe,Le,Ne){if(!Ne||Ne.length<Le.length)return null;let W;return pe?W=f.$cf(Ne,Le):W=Ne.indexOf(Le)===0,W?Le.length>0?[{start:0,end:Le.length}]:[]:null}function v(pe,Le){const Ne=Le.toLowerCase().indexOf(pe.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+pe.length}]}e.$Yj=v;function $(pe,Le){return k(pe.toLowerCase(),Le.toLowerCase(),0,0)}e.$Zj=$;function k(pe,Le,Ne,W){if(Ne===pe.length)return[];if(W===Le.length)return null;if(pe[Ne]===Le[W]){let x=null;return(x=k(pe,Le,Ne+1,W+1))?n({start:W,end:W+1},x):null}return k(pe,Le,Ne,W+1)}function R(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$1j=C;function b(pe){return 48<=pe&&pe<=57}function E(pe){return pe===32||pe===9||pe===10||pe===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>S.add(pe.charCodeAt(0)));function u(pe){return E(pe)||S.has(pe)}function m(pe,Le){return pe===Le||u(pe)&&u(Le)}const a=new Map;function i(pe){if(a.has(pe))return a.get(pe);let Le;const Ne=(0,N.$Uj)(pe);return Ne&&(Le=Ne),a.set(pe,Le),Le}function r(pe){return R(pe)||C(pe)||b(pe)}function n(pe,Le){return Le.length===0?Le=[pe]:pe.end===Le[0].start?Le[0].start=pe.start:Le.unshift(pe),Le}function o(pe,Le){for(let Ne=Le;Ne<pe.length;Ne++){const W=pe.charCodeAt(Ne);if(C(W)||b(W)||Ne>0&&!r(pe.charCodeAt(Ne-1)))return Ne}return pe.length}function t(pe,Le,Ne,W){if(Ne===pe.length)return[];if(W===Le.length)return null;if(pe[Ne]!==Le[W].toLowerCase())return null;{let x=null,H=W+1;for(x=t(pe,Le,Ne+1,W+1);!x&&(H=o(Le,H))<Le.length;)x=t(pe,Le,Ne+1,H),H++;return x===null?null:n({start:W,end:W+1},x)}}function h(pe){let Le=0,Ne=0,W=0,x=0,H=0;for(let qe=0;qe<pe.length;qe++)H=pe.charCodeAt(qe),C(H)&&Le++,R(H)&&Ne++,r(H)&&W++,b(H)&&x++;const X=Le/pe.length,oe=Ne/pe.length,ve=W/pe.length,Me=x/pe.length;return{upperPercent:X,lowerPercent:oe,alphaPercent:ve,numericPercent:Me}}function s(pe){const{upperPercent:Le,lowerPercent:Ne}=pe;return Ne===0&&Le>.6}function d(pe){const{upperPercent:Le,lowerPercent:Ne,alphaPercent:W,numericPercent:x}=pe;return Ne>.2&&Le<.8&&W>.6&&x<.2}function l(pe){let Le=0,Ne=0,W=0,x=0;for(let H=0;H<pe.length;H++)W=pe.charCodeAt(H),C(W)&&Le++,R(W)&&Ne++,E(W)&&x++;return(Le===0||Ne===0)&&x===0?pe.length<=30:Le<=5}function c(pe,Le){if(!Le||(Le=Le.trim(),Le.length===0)||!l(pe))return null;Le.length>60&&(Le=Le.substring(0,60));const Ne=h(Le);if(!d(Ne)){if(!s(Ne))return null;Le=Le.toLowerCase()}let W=null,x=0;for(pe=pe.toLowerCase();x<Le.length&&(W=t(pe,Le,0,x))===null;)x=o(Le,x+1);return W}e.$2j=c;function p(pe,Le,Ne=!1){if(!Le||Le.length===0)return null;let W=null,x=0;for(pe=pe.toLowerCase(),Le=Le.toLowerCase();x<Le.length&&(W=I(pe,Le,0,x,Ne),W===null);)x=w(Le,x+1);return W}e.$3j=p;function I(pe,Le,Ne,W,x){let H=0;if(Ne===pe.length)return[];if(W===Le.length)return null;if(!m(pe.charCodeAt(Ne),Le.charCodeAt(W))){const ve=i(pe.charCodeAt(Ne));if(!ve)return null;for(let Me=0;Me<ve.length;Me++)if(!m(ve[Me],Le.charCodeAt(W+Me)))return null;H+=ve.length-1}let X=null,oe=W+H+1;if(X=I(pe,Le,Ne+1,oe,x),!x)for(;!X&&(oe=w(Le,oe))<Le.length;)X=I(pe,Le,Ne+1,oe,x),oe++;if(!X)return null;if(pe.charCodeAt(Ne)!==Le.charCodeAt(W)){const ve=i(pe.charCodeAt(Ne));if(!ve)return X;for(let Me=0;Me<ve.length;Me++)if(ve[Me]!==Le.charCodeAt(W+Me))return X}return n({start:W,end:W+H+1},X)}function w(pe,Le){for(let Ne=Le;Ne<pe.length;Ne++)if(u(pe.charCodeAt(Ne))||Ne>0&&u(pe.charCodeAt(Ne-1)))return Ne;return pe.length}const g=P(e.$Xj,c,v),y=P(e.$Xj,c,$),L=new D.$Dc(1e4);function F(pe,Le,Ne=!1){if(typeof pe!="string"||typeof Le!="string")return null;let W=L.get(pe);W||(W=new RegExp(f.$We(pe),"i"),L.set(pe,W));const x=W.exec(Le);return x?[{start:x.index,end:x.index+x[0].length}]:Ne?y(pe,Le):g(pe,Le)}e.$4j=F;function z(pe,Le){const Ne=ue(pe,pe.toLowerCase(),0,Le,Le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?O(Ne):null}e.$5j=z;function j(pe,Le,Ne,W,x,H){const X=Math.min(13,pe.length);for(;Ne<X;Ne++){const oe=ue(pe,Le,Ne,W,x,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,H]}e.$6j=j;function O(pe){if(typeof pe>"u")return[];const Le=[],Ne=pe[1];for(let W=pe.length-1;W>1;W--){const x=pe[W]+Ne,H=Le[Le.length-1];H&&H.end===x?H.end=x+1:Le.push({start:x,end:x+1})}return Le}e.$7j=O;const M=128;function T(){const pe=[],Le=[];for(let Ne=0;Ne<=M;Ne++)Le[Ne]=0;for(let Ne=0;Ne<=M;Ne++)pe.push(Le.slice(0));return pe}function U(pe){const Le=[];for(let Ne=0;Ne<=pe;Ne++)Le[Ne]=0;return Le}const J=U(2*M),ne=U(2*M),ee=T(),Q=T(),Y=T(),ce=!1;function te(pe,Le,Ne,W,x){function H(oe,ve,Me=" "){for(;oe.length<ve;)oe=Me+oe;return oe}let X=` |   |${W.split("").map(oe=>H(oe,3)).join("|")}
`;for(let oe=0;oe<=Ne;oe++)oe===0?X+=" |":X+=`${Le[oe-1]}|`,X+=pe[oe].slice(0,x+1).map(ve=>H(ve.toString(),3)).join("|")+`
`;return X}function fe(pe,Le,Ne,W){pe=pe.substr(Le),Ne=Ne.substr(W),console.log(te(Q,pe,pe.length,Ne,Ne.length)),console.log(te(Y,pe,pe.length,Ne,Ne.length)),console.log(te(ee,pe,pe.length,Ne,Ne.length))}function re(pe,Le){if(Le<0||Le>=pe.length)return!1;const Ne=pe.codePointAt(Le);switch(Ne){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.$uf(Ne)}}function K(pe,Le){if(Le<0||Le>=pe.length)return!1;switch(pe.charCodeAt(Le)){case 32:case 9:return!0;default:return!1}}function B(pe,Le,Ne){return Le[pe]!==Ne[pe]}function ae(pe,Le,Ne,W,x,H,X=!1){for(;Le<Ne&&x<H;)pe[Le]===W[x]&&(X&&(J[Le]=x),Le+=1),x+=1;return Le===Ne}e.$8j=ae;var Ee;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var le;(function(pe){pe.Default=[-100,0];function Le(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}pe.isDefault=Le})(le||(e.FuzzyScore=le={}));class de{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Le,Ne){this.firstMatchCanBeWeak=Le,this.boostFullMatch=Ne}}e.$9j=de;function ue(pe,Le,Ne,W,x,H,X=de.default){const oe=pe.length>M?M:pe.length,ve=W.length>M?M:W.length;if(Ne>=oe||H>=ve||oe-Ne>ve-H||!ae(Le,Ne,oe,x,H,ve,!0))return;ge(oe,ve,Ne,H,Le,x);let Me=1,qe=1,Ge=Ne,Ye=H;const it=[!1];for(Me=1,Ge=Ne;Ge<oe;Me++,Ge++){const ke=J[Ge],He=ne[Ge],_=Ge+1<oe?ne[Ge+1]:ve;for(qe=ke-H+1,Ye=ke;Ye<_;qe++,Ye++){let se=Number.MIN_SAFE_INTEGER,De=!1;Ye<=He&&(se=V(pe,Le,Ge,Ne,W,x,Ye,ve,H,ee[Me-1][qe-1]===0,it));let Ve=0;se!==Number.MAX_SAFE_INTEGER&&(De=!0,Ve=se+Q[Me-1][qe-1]);const Xe=Ye>ke,nt=Xe?Q[Me][qe-1]+(ee[Me][qe-1]>0?-5:0):0,rt=Ye>ke+1&&ee[Me][qe-1]>0,je=rt?Q[Me][qe-2]+(ee[Me][qe-2]>0?-5:0):0;if(rt&&(!Xe||je>=nt)&&(!De||je>=Ve))Q[Me][qe]=je,Y[Me][qe]=3,ee[Me][qe]=0;else if(Xe&&(!De||nt>=Ve))Q[Me][qe]=nt,Y[Me][qe]=2,ee[Me][qe]=0;else if(De)Q[Me][qe]=Ve,Y[Me][qe]=1,ee[Me][qe]=ee[Me-1][qe-1]+1;else throw new Error("not possible")}}if(ce&&fe(pe,Ne,W,H),!it[0]&&!X.firstMatchCanBeWeak)return;Me--,qe--;const ut=[Q[Me][qe],H];let ot=0,et=0;for(;Me>=1;){let ke=qe;do{const He=Y[Me][ke];if(He===3)ke=ke-2;else if(He===2)ke=ke-1;else break}while(ke>=1);ot>1&&Le[Ne+Me-1]===x[H+qe-1]&&!B(ke+H-1,W,x)&&ot+1>ee[Me][ke]&&(ke=qe),ke===qe?ot++:ot=1,et||(et=ke),Me--,qe=ke-1,ut.push(qe)}ve===oe&&X.boostFullMatch&&(ut[0]+=2);const Ae=et-oe;return ut[0]-=Ae,ut}e.$0j=ue;function ge(pe,Le,Ne,W,x,H){let X=pe-1,oe=Le-1;for(;X>=Ne&&oe>=W;)x[X]===H[oe]&&(ne[X]=oe,X--),oe--}function V(pe,Le,Ne,W,x,H,X,oe,ve,Me,qe){if(Le[Ne]!==H[X])return Number.MIN_SAFE_INTEGER;let Ge=1,Ye=!1;return X===Ne-W?Ge=pe[Ne]===x[X]?7:5:B(X,x,H)&&(X===0||!B(X-1,x,H))?(Ge=pe[Ne]===x[X]?7:5,Ye=!0):re(H,X)&&(X===0||!re(H,X-1))?Ge=5:(re(H,X-1)||K(H,X-1))&&(Ge=5,Ye=!0),Ge>1&&Ne===W&&(qe[0]=!0),Ye||(Ye=B(X,x,H)||re(H,X-1)||K(H,X-1)),Ne===W?X>ve&&(Ge-=Ye?3:5):Me?Ge+=Ye?2:0:Ge+=Ye?0:1,X+1===oe&&(Ge-=Ye?3:5),Ge}function Z(pe,Le,Ne,W,x,H,X){return be(pe,Le,Ne,W,x,H,!0,X)}e.$$j=Z;function he(pe,Le,Ne,W,x,H,X){return be(pe,Le,Ne,W,x,H,!1,X)}e.$_j=he;function be(pe,Le,Ne,W,x,H,X,oe){let ve=ue(pe,Le,Ne,W,x,H,oe);if(ve&&!X)return ve;if(pe.length>=3){const Me=Math.min(7,pe.length-1);for(let qe=Ne+1;qe<Me;qe++){const Ge=Pe(pe,qe);if(Ge){const Ye=ue(Ge,Ge.toLowerCase(),Ne,W,x,H,oe);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function Pe(pe,Le){if(Le+1>=pe.length)return;const Ne=pe[Le],W=pe[Le+1];if(Ne!==W)return pe.slice(0,Le)+W+Ne+pe.slice(Le+2)}}),define(Ce[54],Ie([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=void 0;function N(a){return f(a,0)}e.$Wi=N;function f(a,i){switch(typeof a){case"object":return a===null?P(349,i):Array.isArray(a)?$(a,i):k(a,i);case"string":return v(a,i);case"boolean":return A(a,i);case"number":return P(a,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Xi=f;function P(a,i){return(i<<5)-i+a|0}e.$Yi=P;function A(a,i){return P(a?433:863,i)}function v(a,i){i=P(149417,i);for(let r=0,n=a.length;r<n;r++)i=P(a.charCodeAt(r),i);return i}e.$Zi=v;function $(a,i){return i=P(104579,i),a.reduce((r,n)=>f(n,r),i)}function k(a,i){return i=P(181387,i),Object.keys(a).sort().reduce((r,n)=>(r=v(n,r),f(a[n],r)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$1i=R;var C;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function b(a,i,r=32){const n=r-i,o=~((1<<n)-1);return(a<<i|(o&a)>>>n)>>>0}function E(a,i=0,r=a.byteLength,n=0){for(let o=0;o<r;o++)a[i+o]=n}function S(a,i,r="0"){for(;a.length<i;)a=r+a;return a}function u(a,i=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((a>>>0).toString(16),i/4)}e.$2i=u;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let o=this.r,t=this.u,h,s;for(t!==0?(h=t,s=-1,t=0):(h=i.charCodeAt(0),s=0);;){let d=h;if(D.$ff(h))if(s+1<r){const l=i.charCodeAt(s+1);D.$gf(l)?(s++,d=D.$hf(h,l)):d=65533}else{t=h;break}else D.$gf(h)&&(d=65533);if(o=this.w(n,o,d),s++,s<r)h=i.charCodeAt(s);else break}this.r=o,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,r=this.q;for(let p=0;p<64;p+=4)i.setUint32(p,r.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)i.setUint32(p,b(i.getUint32(p-12,!1)^i.getUint32(p-32,!1)^i.getUint32(p-56,!1)^i.getUint32(p-64,!1),1),!1);let n=this.h,o=this.l,t=this.m,h=this.n,s=this.o,d,l,c;for(let p=0;p<80;p++)p<20?(d=o&t|~o&h,l=1518500249):p<40?(d=o^t^h,l=1859775393):p<60?(d=o&t|o&h|t&h,l=2400959708):(d=o^t^h,l=3395469782),c=b(n,5)+d+s+l+i.getUint32(p*4,!1)&4294967295,s=h,h=t,t=b(o,30),o=n,n=c;this.h=this.h+n&4294967295,this.l=this.l+o&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}e.$3i=m}),define(Ce[39],Ie([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(N||(N={})),function(f){const P="error",A="warning",v="warn",$="info",k="ignore";function R(b){return b?D.$bf(P,b)?f.Error:D.$bf(A,b)||D.$bf(v,b)?f.Warning:D.$bf($,b)?f.Info:f.Ignore:f.Ignore}f.fromValue=R;function C(b){switch(b){case f.Error:return P;case f.Warning:return A;case f.Info:return $;default:return k}}f.toString=C}(N||(N={})),e.default=N}),define(Ce[164],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Ce[78],Ie([1,0,19,12]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0;class f{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),u=this.b.charCodeAt(this.c);return S-u}value(){return this.b[this.c]}}e.$$h=f;class P{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$8e)(E,this.b,0,E.length,this.c,this.d):(0,N.$0e)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$_h=P;class A{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const u=this.b.charCodeAt(S);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$8e)(E,this.b,0,E.length,this.d,this.e):(0,N.$0e)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ai=A;var v;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(v||(v={}));class ${constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$9e)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$9e)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$7e)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$7e)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$bi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(R||(R={}));class C{static forUris(E=()=>!1,S=()=>!1){return new C(new $(E,S))}static forPaths(E=!1){return new C(new A(void 0,!E))}static forStrings(){return new C(new f)}static forConfigKeys(){return new C(new P)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const u=S.slice(0);(0,D.$Xb)(u);for(const m of u)this.set(m,E)}else{const u=E.slice(0);(0,D.$Xb)(u);for(const m of u)this.set(m[0],m[1])}}set(E,S){const u=this.b.reset(E);let m;this.c||(this.c=new k,this.c.segment=u.value());const a=[];for(m=this.c;;){const r=u.cmp(m.segment);if(r>0)m.left||(m.left=new k,m.left.segment=u.value()),a.push([-1,m]),m=m.left;else if(r<0)m.right||(m.right=new k,m.right.segment=u.value()),a.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new k,m.mid.segment=u.value()),a.push([0,m]),m=m.mid;else break}const i=m.value;m.value=S,m.key=E;for(let r=a.length-1;r>=0;r--){const n=a[r][1];n.updateHeight();const o=n.balanceFactor();if(o<-1||o>1){const t=a[r][0],h=a[r+1][0];if(t===1&&h===1)a[r][1]=n.rotateLeft();else if(t===-1&&h===-1)a[r][1]=n.rotateRight();else if(t===1&&h===-1)n.right=a[r+1][1]=a[r+1][1].rotateRight(),a[r][1]=n.rotateLeft();else if(t===-1&&h===1)n.left=a[r+1][1]=a[r+1][1].rotateLeft(),a[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(a[r-1][0]){case-1:a[r-1][1].left=a[r][1];break;case 1:a[r-1][1].right=a[r][1];break;case 0:a[r-1][1].mid=a[r][1];break}else this.c=a[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let u=this.c;for(;u;){const m=S.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(S.hasNext())S.next(),u=u.mid;else break}return u}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const u=this.b.reset(E),m=[];let a=this.c;for(;a;){const i=u.cmp(a.segment);if(i>0)m.push([-1,a]),a=a.left;else if(i<0)m.push([1,a]),a=a.right;else if(u.hasNext())u.next(),m.push([0,a]),a=a.mid;else break}if(a){if(S?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const i=this.f(a.right);if(i.key){const{key:r,value:n,segment:o}=i;this.e(i.key,!1),a.key=r,a.value=n,a.segment=o}}else{const i=a.left??a.right;if(m.length>0){const[r,n]=m[m.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const r=m[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),m[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),m[i][1]=r.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let u=this.c,m;for(;u;){const a=S.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(S.hasNext())S.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(E){return this.g(E,!1)}g(E,S){const u=this.b.reset(E);let m=this.c;for(;m;){const a=u.cmp(m.segment);if(a>0)m=m.left;else if(a<0)m=m.right;else if(u.hasNext())u.next(),m=m.mid;else return m.mid?this.h(m.mid):S?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,u]of this)E(u,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const u=S.balanceFactor();return u<-1||u>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$ci=C}),define(Ce[18],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=void 0;function D(o){return typeof o=="string"}e.$Kf=D;function N(o){return Array.isArray(o)&&o.every(t=>D(t))}e.$Lf=N;function f(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$Mf=f;function P(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.$Nf=P;function A(o){return typeof o=="number"&&!isNaN(o)}e.$Of=A;function v(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$Pf=v;function $(o){return o===!0||o===!1}e.$Qf=$;function k(o){return typeof o>"u"}e.$Rf=k;function R(o){return!C(o)}e.$Sf=R;function C(o){return k(o)||o===null}e.$Tf=C;function b(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Uf=b;function E(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$Vf=E;function S(...o){const t=[];for(let h=0;h<o.length;h++){const s=o[h];if(C(s))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(s)}return t}e.$Wf=S;const u=Object.prototype.hasOwnProperty;function m(o){if(!f(o))return!1;for(const t in o)if(u.call(o,t))return!1;return!0}e.$Xf=m;function a(o){return typeof o=="function"}e.$Yf=a;function i(...o){return o.length>0&&o.every(a)}e.$Zf=i;function r(o,t){const h=Math.min(o.length,t.length);for(let s=0;s<h;s++)n(o[s],t[s])}e.$1f=r;function n(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$2f=n}),define(Ce[79],Ie([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=void 0;const N=Object.create(null);function f(v,$){if((0,D.$Kf)($)){const k=N[$];if(k===void 0)throw new Error(`${v} references an unknown codicon: ${$}`);$=k}return N[v]=$,{id:v}}function P(){return N}e.$ak=P;function A(){return Object.values(e.$ck)}e.$bk=A,e.$ck={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugBreakpointPending:f("debug-breakpoint-pending",60377),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),surroundWith:f("surround-with",60452),gitStash:f("git-stash",60454),gitStashApply:f("git-stash-apply",60455),gitStashPop:f("git-stash-pop",60456),coverage:f("coverage",60462),runAllCoverage:f("run-all-coverage",60461),runCoverage:f("run-all-coverage",60460),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(Ce[24],Ie([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=void 0;function N(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const i=Array.isArray(a)?[]:{};return Object.entries(a).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?N(n):n}),i}e.$zn=N;function f(a){if(!a||typeof a!="object")return a;const i=[a];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(P.call(r,n)){const o=r[n];typeof o=="object"&&!Object.isFrozen(o)&&!(0,D.$Nf)(o)&&i.push(o)}}return a}e.$An=f;const P=Object.prototype.hasOwnProperty;function A(a,i){return v(a,i,new Set)}e.$Bn=A;function v(a,i,r){if((0,D.$Tf)(a))return a;const n=i(a);if(typeof n<"u")return n;if(Array.isArray(a)){const o=[];for(const t of a)o.push(v(t,i,r));return o}if((0,D.$Mf)(a)){if(r.has(a))throw new Error("Cannot clone recursive data-structure");r.add(a);const o={};for(const t in a)P.call(a,t)&&(o[t]=v(a[t],i,r));return r.delete(a),o}return a}function $(a,i,r=!0){return(0,D.$Mf)(a)?((0,D.$Mf)(i)&&Object.keys(i).forEach(n=>{n in a?r&&((0,D.$Mf)(a[n])&&(0,D.$Mf)(i[n])?$(a[n],i[n],r):a[n]=i[n]):a[n]=i[n]}),a):i}e.$Cn=$;function k(a,i){if(a===i)return!0;if(a==null||i===null||i===void 0||typeof a!=typeof i||typeof a!="object"||Array.isArray(a)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(a)){if(a.length!==i.length)return!1;for(r=0;r<a.length;r++)if(!k(a[r],i[r]))return!1}else{const o=[];for(n in a)o.push(n);o.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!k(o,t))return!1;for(r=0;r<o.length;r++)if(!k(a[o[r]],i[o[r]]))return!1}return!0}e.$Dn=k;function R(a){const i=new Set;return JSON.stringify(a,(r,n)=>{if((0,D.$Mf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$En=R;function C(a,i){const r=Object.create(null);return!a||!i||Object.keys(i).forEach(o=>{const t=a[o],h=i[o];k(t,h)||(r[o]=h)}),r}e.$Fn=C;function b(a,i){const r=i.toLowerCase(),n=Object.keys(a).find(o=>o.toLowerCase()===r);return n?a[n]:a[i]}e.$Gn=b;function E(a,i){const r=Object.create(null);for(const[n,o]of Object.entries(a))i(n,o)&&(r[n]=o);return r}e.$Hn=E;function S(a){let i=[];for(;Object.prototype!==a;)i=i.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return i}e.$In=S;function u(a){const i=[];for(const r of S(a))typeof a[r]=="function"&&i.push(r);return i}e.$Jn=u;function m(a,i){const r=o=>function(){const t=Array.prototype.slice.call(arguments,0);return i(o,t)},n={};for(const o of a)n[o]=r(o);return n}e.$Kn=m}),define(Ce[55],Ie([1,0,79]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$dk=e.ThemeColor=void 0;var N;(function(A){function v($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=v})(N||(e.ThemeColor=N={}));function f(A){return{id:A}}e.$dk=f;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(i){const r=v.exec(i.id);if(!r)return $(D.$ck.error);const[,n,o]=r,t=["codicon","codicon-"+n];return o&&t.push("codicon-modifier-"+o.substring(1)),t}A.asClassNameArray=$;function k(i){return $(i).join(" ")}A.asClassName=k;function R(i){return"."+$(i).join(".")}A.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}A.isThemeIcon=C;const b=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(i){const r=b.exec(i);if(!r)return;const[,n]=r;return{id:n}}A.fromString=E;function S(i){return{id:i}}A.fromId=S;function u(i,r){let n=i.id;const o=n.lastIndexOf("~");return o!==-1&&(n=n.substring(0,o)),r&&(n=`${n}~${r}`),{id:n}}A.modify=u;function m(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}A.getModifier=m;function a(i,r){return i.id===r.id&&i.color?.id===r.color?.id}A.isEqual=a})(P||(e.ThemeIcon=P={}))}),define(Ce[165],Ie([1,0,123,12,55]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=void 0;const P="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${A.source}`,"g");function $(a){return a.replace(v,(i,r)=>r?i:`\\${i}`)}e.$ek=$;const k=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(k,i=>`\\${i}`)}e.$fk=R;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(a){return a.indexOf(P)===-1?a:a.replace(C,(i,r,n,o)=>n?i:r||o||"")}e.$gk=b;function E(a){return a?a.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$hk=E;const S=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(a){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const o=S.lastIndex,t=S.exec(a),h=a.substring(o,t?.index);if(h.length>0){i+=h;for(let s=0;s<h.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$ik=u;function m(a,i,r=!1){const{text:n,iconOffsets:o}=i;if(!o||o.length===0)return(0,D.$4j)(a,n,r);const t=(0,N.$Ue)(n," "),h=n.length-t.length,s=(0,D.$4j)(a,t,r);if(s)for(const d of s){const l=o[d.start+h]+h;d.start+=l,d.end+=l}return s}e.$jk=m}),define(Ce[124],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.Constants=void 0;var D;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(P){return P<0?0:P>255?255:P|0}e.$Ie=N;function f(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Je=f}),define(Ce[30],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.$rg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(f){return D.test(f)}e.$rg=N,e.$sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(v){for(let $=0;$<v.length;$++)v[$]=Math.floor(Math.random()*256);return v};const P=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){f(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,k="";return k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+="-",k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k+=A[P[$++]],k}}()}),define(Ce[166],Ie([1,0,19,53,30]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.$tt=e.$st=e.$rt=e.$qt=void 0;function P(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$qt=P;function A(C,b,E){const S={id:(0,f.$sg)(),name:C,uri:b,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$rt=A;class v{constructor(){this.a=new Map}get size(){let b=0;for(const E of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const E=[...this.a.keys()];return N.Iterable.some(this,([S,u])=>u.asFile())&&E.push("files"),R($(b),E)}get(b){return this.a.get(this.b(b))?.[0]}append(b,E){const S=this.a.get(b);S?S.push(E):this.a.set(this.b(b),[E])}replace(b,E){this.a.set(this.b(b),[E])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,E]of this.a)for(const S of E)yield[b,S]}b(b){return $(b)}}e.$st=v;function $(C){return C.toLowerCase()}function k(C,b){return R($(C),b.map($))}e.$tt=k;function R(C,b){if(C==="*/*")return b.length>0;if(b.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,u,m]=E;return m==="*"?b.some(a=>a.startsWith(u+"/")):!1}e.$ut=Object.freeze({create:C=>(0,D.$Mb)(C.map(b=>b.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$ut.split(C).filter(b=>!b.startsWith("#"))})}),define(Ce[167],Ie([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=e.$vg=e.$ug=void 0;function N(v,$,k,R=1){let C=!1;return new Promise(b=>{const E=setTimeout(()=>{if(!C)return C=!0,b(0)},k);f(v,$,R,S=>{if(!C)return C=!0,clearTimeout(E),b(S)})})}e.$ug=N;function f(v,$,k,R){if($===0)return R(0);const C=new D.Socket;C.once("connect",()=>(A(C),f(v+k,$-1,k,R))),C.once("data",()=>{}),C.once("error",b=>(A(C),b.code!=="ECONNREFUSED"?f(v+k,$-1,k,R):R(v))),C.connect(v,"127.0.0.1")}e.$vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(v,$,k,R="127.0.0.1"){let C=!1,b,E=1;const S=D.createServer({pauseOnConnect:!0});function u(m,a){C||(C=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),a(m))}return new Promise(m=>{b=setTimeout(()=>{u(0,m)},k),S.on("listening",()=>{u(v,m)}),S.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&E<$?(v++,E++,S.listen(v,R)):u(0,m)}),S.on("close",()=>{u(0,m)}),S.listen(v,R)})}e.$wg=P;function A(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch($){console.error($)}}}),define(Ce[125],Ie([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=void 0;class N{constructor(v){const $=(0,D.$Ie)(v);this.c=$,this.a=N.d($),this.b=new Map}static d(v){const $=new Uint8Array(256);return $.fill(v),$}set(v,$){const k=(0,D.$Ie)($);v>=0&&v<256?this.a[v]=k:this.b.set(v,k)}get(v){return v>=0&&v<256?this.a[v]:this.b.get(v)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$it=N;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class P{constructor(){this.a=new N(0)}add(v){this.a.set(v,1)}has(v){return this.a.get(v)===1}clear(){return this.a.clear()}}e.$jt=P}),define(Ce[168],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.StringEOL=void 0;var D;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(f){let P=0,A=0,v=0,$=0;for(let k=0,R=f.length;k<R;k++){const C=f.charCodeAt(k);C===13?(P===0&&(A=k),P++,k+1<R&&f.charCodeAt(k+1)===10?($|=2,k++):$|=3,v=k+1):C===10&&($|=1,P===0&&(A=k),P++,v=k+1)}return P===0&&(A=f.length),[P,A,f.length-v,$]}e.$xt=N}),define(Ce[48],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class D{constructor(f,P){this.lineNumber=f,this.column=P}with(f=this.lineNumber,P=this.column){return f===this.lineNumber&&P===this.column?this:new D(f,P)}delta(f=0,P=0){return this.with(this.lineNumber+f,this.column+P)}equals(f){return D.equals(this,f)}static equals(f,P){return!f&&!P?!0:!!f&&!!P&&f.lineNumber===P.lineNumber&&f.column===P.column}isBefore(f){return D.isBefore(this,f)}static isBefore(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<P.column}isBeforeOrEqual(f){return D.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<=P.column}static compare(f,P){const A=f.lineNumber|0,v=P.lineNumber|0;if(A===v){const $=f.column|0,k=P.column|0;return $-k}return A-v}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new D(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ws=D}),define(Ce[29],Ie([1,0,48]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=void 0;class N{constructor(P,A,v,$){P>v||P===v&&A>$?(this.startLineNumber=v,this.startColumn=$,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=v,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return N.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return N.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return N.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return N.plusRange(this,P)}static plusRange(P,A){let v,$,k,R;return A.startLineNumber<P.startLineNumber?(v=A.startLineNumber,$=A.startColumn):A.startLineNumber===P.startLineNumber?(v=A.startLineNumber,$=Math.min(A.startColumn,P.startColumn)):(v=P.startLineNumber,$=P.startColumn),A.endLineNumber>P.endLineNumber?(k=A.endLineNumber,R=A.endColumn):A.endLineNumber===P.endLineNumber?(k=A.endLineNumber,R=Math.max(A.endColumn,P.endColumn)):(k=P.endLineNumber,R=P.endColumn),new N(v,$,k,R)}intersectRanges(P){return N.intersectRanges(this,P)}static intersectRanges(P,A){let v=P.startLineNumber,$=P.startColumn,k=P.endLineNumber,R=P.endColumn;const C=A.startLineNumber,b=A.startColumn,E=A.endLineNumber,S=A.endColumn;return v<C?(v=C,$=b):v===C&&($=Math.max($,b)),k>E?(k=E,R=S):k===E&&(R=Math.min(R,S)),v>k||v===k&&$>R?null:new N(v,$,k,R)}equalsRange(P){return N.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(P){return new D.$Ws(P.endLineNumber,P.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(P){return new D.$Ws(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new N(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new N(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(P){return new N(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(P){return new N(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new N(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new N(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new N(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const k=P.startLineNumber|0,R=A.startLineNumber|0;if(k===R){const C=P.startColumn|0,b=A.startColumn|0;if(C===b){const E=P.endLineNumber|0,S=A.endLineNumber|0;if(E===S){const u=P.endColumn|0,m=A.endColumn|0;return u-m}return E-S}return C-b}return k-R}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Xs=N}),define(Ce[169],Ie([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class N{static insert(P,A){return{range:new D.$Xs(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$Ys=N}),define(Ce[170],Ie([1,0,48,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class P extends N.$Xs{constructor(v,$,k,R){super(v,$,k,R),this.selectionStartLineNumber=v,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return P.selectionsEqual(this,v)}static selectionsEqual(v,$){return v.selectionStartLineNumber===$.selectionStartLineNumber&&v.selectionStartColumn===$.selectionStartColumn&&v.positionLineNumber===$.positionLineNumber&&v.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,v,$):new P(v,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Ws(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Ws(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,$){return this.getDirection()===0?new P(v,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,v,$)}static fromPositions(v,$=v){return new P(v.lineNumber,v.column,$.lineNumber,$.column)}static fromRange(v,$){return $===0?new P(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new P(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new P(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,$){if(v&&!$||!v&&$)return!1;if(!v&&!$)return!0;if(v.length!==$.length)return!1;for(let k=0,R=v.length;k<R;k++)if(!this.selectionsEqual(v[k],$[k]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,$,k,R,C){return C===0?new P(v,$,k,R):new P(k,R,v,$)}}e.$Zs=P}),define(Ce[171],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0,e.$vs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[172],Ie([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.WordCharacterClass=void 0;var N;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class f extends D.$it{constructor(v){super(0);for(let $=0,k=v.length;$<k;$++)this.set(v.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$kt=f;function P(A){const v={};return $=>(v.hasOwnProperty($)||(v[$]=A($)),v[$])}e.$lt=P(A=>new f(A))}),define(Ce[126],Ie([1,0,53,3,76]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.$ys=e.$xs=e.$ws=void 0,e.$ws="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(C=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$ws)C.indexOf(E)>=0||(b+="\\"+E);return b+="\\s]+)",new RegExp(b,"g")}e.$xs=P();function A(C){let b=e.$xs;if(C&&C instanceof RegExp)if(C.global)b=C;else{let E="g";C.ignoreCase&&(E+="i"),C.multiline&&(E+="m"),C.unicode&&(E+="u"),b=new RegExp(C.source,E)}return b.lastIndex=0,b}e.$ys=A;const v=new f.$4c;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const b=v.unshift(C);return(0,N.$Rc)(b)}e.$zs=$;function k(C,b,E,S,u){if(b=A(b),u||(u=D.Iterable.first(v)),E.length>u.maxLen){let n=C-u.maxLen/2;return n<0?n=0:S+=n,E=E.substring(n,C+u.maxLen/2),k(C,b,E,S,u)}const m=Date.now(),a=C-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-m>=u.timeBudget);n++){const o=a-u.windowSize*n;b.lastIndex=Math.max(0,o);const t=R(b,E,a,i);if(!t&&r||(r=t,o<=0))break;i=o}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return b.lastIndex=0,n}return null}e.$As=k;function R(C,b,E,S){let u;for(;u=C.exec(b);){const m=u.index||0;if(m<=E&&C.lastIndex>=E)return u;if(S>0&&m>S)return null}return null}}),define(Ce[173],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=e.$Ut=e.IndentAction=void 0;var D;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(v){if(this.e=null,this.f=!1,this.open=v.open,this.close=v.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(v.notIn))for(let $=0,k=v.notIn.length;$<k;$++)switch(v.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(v,$){if(v.getTokenCount()===0)return!0;const k=v.findTokenIndexAtOffset($-2),R=v.getStandardTokenType(k);return this.isOK(R)}g(v,$){for(let k=v;k<=$;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Ut=N;class f{constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of v)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Vt=f;function P(A,v,$){A.has(v)?A.get(v).push($):A.set(v,[$])}}),define(Ce[174],Ie([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Z=e.$4Z=e.$3Z=e.State=void 0;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class f{constructor(S,u,m){const a=new Uint8Array(S*u);for(let i=0,r=S*u;i<r;i++)a[i]=m;this.a=a,this.rows=S,this.cols=u}get(S,u){return this.a[S*this.cols+u]}set(S,u,m){this.a[S*this.cols+u]=m}}class P{constructor(S){let u=0,m=0;for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];o>u&&(u=o),n>m&&(m=n),t>m&&(m=t)}u++,m++;const a=new f(m,u,0);for(let i=0,r=S.length;i<r;i++){const[n,o,t]=S[i];a.set(n,o,t)}this.a=a,this.b=u}nextState(S,u){return u<0||u>=this.b?0:this.a.get(S,u)}}e.$3Z=P;let A=null;function v(){return A===null&&(A=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function R(){if(k===null){k=new D.$it(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<E.length;u++)k.set(E.charCodeAt(u),1);const S=".,;:";for(let u=0;u<S.length;u++)k.set(S.charCodeAt(u),2)}return k}class C{static a(S,u,m,a,i){let r=i-1;do{const n=u.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>a);if(a>0){const n=u.charCodeAt(a-1),o=u.charCodeAt(r);(n===40&&o===41||n===91&&o===93||n===123&&o===125)&&r--}return{range:{startLineNumber:m,startColumn:a+1,endLineNumber:m,endColumn:r+2},url:u.substring(a,r+1)}}static computeLinks(S,u=v()){const m=R(),a=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),o=n.length;let t=0,h=0,s=0,d=1,l=!1,c=!1,p=!1,I=!1;for(;t<o;){let w=!1;const g=n.charCodeAt(t);if(d===13){let y;switch(g){case 40:l=!0,y=0;break;case 41:y=l?0:1;break;case 91:p=!0,c=!0,y=0;break;case 93:p=!1,y=c?0:1;break;case 123:I=!0,y=0;break;case 125:y=I?0:1;break;case 39:case 34:case 96:s===g?y=1:s===39||s===34||s===96?y=0:y=1;break;case 42:y=s===42?1:0;break;case 124:y=s===124?1:0;break;case 32:y=p?0:1;break;default:y=m.get(g)}y===1&&(a.push(C.a(m,n,i,h,t)),w=!0)}else if(d===12){let y;g===91?(c=!0,y=0):y=m.get(g),y===1?w=!0:d=13}else d=u.nextState(d,g),d===0&&(w=!0);w&&(d=1,l=!1,c=!1,I=!1,h=t+1,s=g),t++}d===13&&a.push(C.a(m,n,i,h,o))}return a}}e.$4Z=C;function b(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}e.$5Z=b}),define(Ce[80],Ie([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iv=e.$hv=e.$gv=e.$fv=e.ModelConstants=e.PositionAffinity=e.$ev=e.TrackedRangeStickiness=e.$dv=e.$cv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var f;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(f||(e.GlyphMarginLane=f={}));var P;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var A;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var v;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var k;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),o.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,o.indentSize|0),this.a=!1),this.insertSpaces=!!o.insertSpaces,this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=!!o.trimAutoWhitespace,this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.a===o.a&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,D.$Dn)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.$cv=R;class C{constructor(o,t){this._findMatchBrand=void 0,this.range=o,this.matches=t}}e.$dv=C;var b;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(e.TrackedRangeStickiness=b={}));function E(n){return n&&typeof n.read=="function"}e.$ev=E;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var u;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class m{constructor(o,t,h,s,d,l){this.identifier=o,this.range=t,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=l}}e.$fv=m;class a{constructor(o,t,h){this.regex=o,this.wordSeparators=t,this.simpleSearch=h}}e.$gv=a;class i{constructor(o,t,h){this.reverseEdits=o,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.$hv=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$iv=r}),define(Ce[175],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5B=e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.NodeColor=e.$VB=void 0;class D{constructor(m,a){this.piece=m,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$WB)return f(this.right);let m=this;for(;m.parent!==e.$WB&&m.parent.left!==m;)m=m.parent;return m.parent===e.$WB?e.$WB:m.parent}prev(){if(this.left!==e.$WB)return P(this.left);let m=this;for(;m.parent!==e.$WB&&m.parent.right!==m;)m=m.parent;return m.parent===e.$WB?e.$WB:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$VB=D;var N;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$WB=new D(null,0),e.$WB.parent=e.$WB,e.$WB.left=e.$WB,e.$WB.right=e.$WB,e.$WB.color=0;function f(u){for(;u.left!==e.$WB;)u=u.left;return u}e.$XB=f;function P(u){for(;u.right!==e.$WB;)u=u.right;return u}e.$YB=P;function A(u){return u===e.$WB?0:u.size_left+u.piece.length+A(u.right)}function v(u){return u===e.$WB?0:u.lf_left+u.piece.lineFeedCnt+v(u.right)}function $(){e.$WB.parent=e.$WB}function k(u,m){const a=m.right;a.size_left+=m.size_left+(m.piece?m.piece.length:0),a.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=a.left,a.left!==e.$WB&&(a.left.parent=m),a.parent=m.parent,m.parent===e.$WB?u.root=a:m.parent.left===m?m.parent.left=a:m.parent.right=a,a.left=m,m.parent=a}e.$ZB=k;function R(u,m){const a=m.left;m.left=a.right,a.right!==e.$WB&&(a.right.parent=m),a.parent=m.parent,m.size_left-=a.size_left+(a.piece?a.piece.length:0),m.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),m.parent===e.$WB?u.root=a:m===m.parent.right?m.parent.right=a:m.parent.left=a,a.right=m,m.parent=a}e.$1B=R;function C(u,m){let a,i;if(m.left===e.$WB?(i=m,a=i.right):m.right===e.$WB?(i=m,a=i.left):(i=f(m.right),a=i.right),i===u.root){u.root=a,a.color=0,m.detach(),$(),u.root.parent=e.$WB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=a:i.parent.right=a,i===m?(a.parent=i.parent,S(u,a)):(i.parent===m?a.parent=i:a.parent=i.parent,S(u,a),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===u.root?u.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$WB&&(i.left.parent=i),i.right!==e.$WB&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,S(u,i)),m.detach(),a.parent.left===a){const o=A(a),t=v(a);if(o!==a.parent.size_left||t!==a.parent.lf_left){const h=o-a.parent.size_left,s=t-a.parent.lf_left;a.parent.size_left=o,a.parent.lf_left=t,E(u,a.parent,h,s)}}if(S(u,a.parent),r){$();return}let n;for(;a!==u.root&&a.color===0;)a===a.parent.left?(n=a.parent.right,n.color===1&&(n.color=0,a.parent.color=1,k(u,a.parent),n=a.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.right.color===0&&(n.left.color=0,n.color=1,R(u,n),n=a.parent.right),n.color=a.parent.color,a.parent.color=0,n.right.color=0,k(u,a.parent),a=u.root)):(n=a.parent.left,n.color===1&&(n.color=0,a.parent.color=1,R(u,a.parent),n=a.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,a=a.parent):(n.left.color===0&&(n.right.color=0,n.color=1,k(u,n),n=a.parent.left),n.color=a.parent.color,a.parent.color=0,n.left.color=0,R(u,a.parent),a=u.root));a.color=0,$()}e.$2B=C;function b(u,m){for(S(u,m);m!==u.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const a=m.parent.parent.right;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,k(u,m)),m.parent.color=0,m.parent.parent.color=1,R(u,m.parent.parent))}else{const a=m.parent.parent.left;a.color===1?(m.parent.color=0,a.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,R(u,m)),m.parent.color=0,m.parent.parent.color=1,k(u,m.parent.parent))}u.root.color=0}e.$3B=b;function E(u,m,a,i){for(;m!==u.root&&m!==e.$WB;)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}e.$4B=E;function S(u,m){let a=0,i=0;if(m!==u.root){for(;m!==u.root&&m===m.parent.right;)m=m.parent;if(m!==u.root)for(m=m.parent,a=A(m.left)-m.size_left,i=v(m.left)-m.lf_left,m.size_left+=a,m.lf_left+=i;m!==u.root&&(a!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=a,m.parent.lf_left+=i),m=m.parent}}e.$5B=S}),define(Ce[176],Ie([1,0,19,124]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=void 0;class f{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,N.$Je)($);const R=this.a,C=this.b,b=k.length;return b===0?!1:(this.a=new Uint32Array(R.length+b),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($),$+b),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,N.$Je)($),k=(0,N.$Je)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,N.$Je)($),k=(0,N.$Je)(k);const R=this.a,C=this.b;if($>=R.length)return!1;const b=R.length-$;return k>=b&&(k=b),k===0?!1:(this.a=new Uint32Array(R.length-k),this.a.set(R.subarray(0,$),0),this.a.set(R.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Je)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let R=k;R<=$;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,R=this.a.length-1,C=0,b=0,E=0;for(;k<=R;)if(C=k+(R-k)/2|0,b=this.b[C],E=b-this.a[C],$<E)R=C-1;else if($>=b)k=C+1;else break;return new A(C,$-E)}}e.$lv=f;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],R=k>0?this.d[k-1]:0;return new A(k,$-R)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,D.$Wb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const R=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+R;for(let b=0;b<R;b++)this.e[C+b]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$mv=P;class A{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$nv=A}),define(Ce[177],Ie([1,0,12,48,176]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ov=void 0;class P{constructor(v,$,k,R){this.d=v,this.f=$,this.g=k,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(v){v.eol&&v.eol!==this.g&&(this.g=v.eol,this.j=null);const $=v.changes;for(const k of $)this.o(k.range),this.p(new N.$Ws(k.range.startLineNumber,k.range.startColumn),k.text);this.h=v.versionId,this.k=null}l(){if(!this.j){const v=this.g.length,$=this.f.length,k=new Uint32Array($);for(let R=0;R<$;R++)k[R]=this.f[R].length+v;this.j=new f.$lv(k)}}n(v,$){this.f[v]=$,this.j&&this.j.setValue(v,this.f[v].length+this.g.length)}o(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.startLineNumber-1].substring(v.endColumn-1));return}this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.endLineNumber-1].substring(v.endColumn-1)),this.f.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.j&&this.j.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}p(v,$){if($.length===0)return;const k=(0,D.$1e)($);if(k.length===1){this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]+this.f[v.lineNumber-1].substring(v.column-1));return}k[k.length-1]+=this.f[v.lineNumber-1].substring(v.column-1),this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]);const R=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this.f.splice(v.lineNumber+C-1,0,k[C]),R[C-1]=k[C].length+this.g.length;this.j&&this.j.insertValues(v.lineNumber,R)}}e.$ov=P}),define(Ce[99],Ie([1,0,12,172,48,29,80]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=void 0;const v=999;class ${constructor(i,r,n,o){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=o}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=D.$Ye(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new A.$gv(r,this.wordSeparators?(0,N.$lt)(this.wordSeparators):null,n?this.searchString:null)}}e.$6B=$;function k(a){if(!a||a.length===0)return!1;for(let i=0,r=a.length;i<r;i++){const n=a.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const o=a.charCodeAt(i);if(o===110||o===114||o===87)return!0}}return!1}e.$7B=k;function R(a,i,r){if(!r)return new A.$dv(a,null);const n=[];for(let o=0,t=i.length;o<t;o++)n[o]=i[o];return new A.$dv(a,n)}e.$8B=R;class C{constructor(i){const r=[];let n=0;for(let o=0,t=i.length;o<t;o++)i.charCodeAt(o)===10&&(r[n++]=o);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,o=r.length-1;if(o===-1||i<=r[0])return 0;for(;n<o;){const t=n+((o-n)/2>>0);r[t]>=i?o=t-1:r[t+1]>=i?(n=t,o=t):n=t+1}return n+1}}class b{static findMatches(i,r,n,o,t){const h=r.parseSearchRequest();return h?h.regex.multiline?this.b(i,n,new m(h.wordSeparators,h.regex),o,t):this.c(i,n,h,o,t):[]}static a(i,r,n,o,t,h){let s,d=0;o?(d=o.findLineFeedCountBeforeOffset(t),s=r+t+d):s=r+t;let l;if(o){const w=o.findLineFeedCountBeforeOffset(t+h.length)-d;l=s+h.length+w}else l=s+h.length;const c=i.getPositionAt(s),p=i.getPositionAt(l);return new P.$Xs(c.lineNumber,c.column,p.lineNumber,p.column)}static b(i,r,n,o,t){const h=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),d=i.getEOL()===`\r
`?new C(s):null,l=[];let c=0,p;for(n.reset(0);p=n.next(s);)if(l[c++]=R(this.a(i,h,s,d,p.index,p[0]),p,o),c>=t)return l;return l}static c(i,r,n,o,t){const h=[];let s=0;if(r.startLineNumber===r.endLineNumber){const l=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,l,r.startLineNumber,r.startColumn-1,s,h,o,t),h}const d=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,d,r.startLineNumber,r.startColumn-1,s,h,o,t);for(let l=r.startLineNumber+1;l<r.endLineNumber&&s<t;l++)s=this.d(n,i.getLineContent(l),l,0,s,h,o,t);if(s<t){const l=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,l,r.endLineNumber,0,s,h,o,t)}return h}static d(i,r,n,o,t,h,s,d){const l=i.wordSeparators;if(!s&&i.simpleSearch){const I=i.simpleSearch,w=I.length,g=r.length;let y=-w;for(;(y=r.indexOf(I,y+w))!==-1;)if((!l||u(l,r,g,y,w))&&(h[t++]=new A.$dv(new P.$Xs(n,y+1+o,n,y+1+w+o),null),t>=d))return t;return t}const c=new m(i.wordSeparators,i.regex);let p;c.reset(0);do if(p=c.next(r),p&&(h[t++]=R(new P.$Xs(n,p.index+1+o,n,p.index+1+p[0].length+o),p,s),t>=d))return t;while(p);return t}static findNextMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const h=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,h,o):this.f(i,n,h,o)}static e(i,r,n,o){const t=new f.$Ws(r.lineNumber,1),h=i.getOffsetAt(t),s=i.getLineCount(),d=i.getValueInRange(new P.$Xs(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),l=i.getEOL()===`\r
`?new C(d):null;n.reset(r.column-1);const c=n.next(d);return c?R(this.a(i,h,d,l,c.index,c[0]),c,o):r.lineNumber!==1||r.column!==1?this.e(i,new f.$Ws(1,1),n,o):null}static f(i,r,n,o){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h),d=this.g(n,s,h,r.column,o);if(d)return d;for(let l=1;l<=t;l++){const c=(h+l-1)%t,p=i.getLineContent(c+1),I=this.g(n,p,c+1,1,o);if(I)return I}return null}static g(i,r,n,o,t){i.reset(o-1);const h=i.next(r);return h?R(new P.$Xs(n,h.index+1,n,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,r,n,o){const t=r.parseSearchRequest();if(!t)return null;const h=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,h,o):this.j(i,n,h,o)}static h(i,r,n,o){const t=this.b(i,new P.$Xs(1,1,r.lineNumber,r.column),n,o,10*v);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return r.lineNumber!==h||r.column!==i.getLineMaxColumn(h)?this.h(i,new f.$Ws(h,i.getLineMaxColumn(h)),n,o):null}static j(i,r,n,o){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h).substring(0,r.column-1),d=this.k(n,s,h,o);if(d)return d;for(let l=1;l<=t;l++){const c=(t+h-l-1)%t,p=i.getLineContent(c+1),I=this.k(n,p,c+1,o);if(I)return I}return null}static k(i,r,n,o){let t=null,h;for(i.reset(0);h=i.next(r);)t=R(new P.$Xs(n,h.index+1,n,h.index+1+h[0].length),h,o);return t}}e.$9B=b;function E(a,i,r,n,o){if(n===0)return!0;const t=i.charCodeAt(n-1);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(n);if(a.get(h)!==0)return!0}return!1}function S(a,i,r,n,o){if(n+o===r)return!0;const t=i.charCodeAt(n+o);if(a.get(t)!==0||t===13||t===10)return!0;if(o>0){const h=i.charCodeAt(n+o-1);if(a.get(h)!==0)return!0}return!1}function u(a,i,r,n,o){return E(a,i,r,n,o)&&S(a,i,r,n,o)}e.$0B=u;class m{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const o=n.index,t=n[0].length;if(o===this.b&&t===this.c){if(t===0){D.$if(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=o,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,r,o,t))return n}while(n);return null}}e.$$B=m}),define(Ce[127],Ie([1,0,48,29,80,175,99]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=void 0;const v=65535;function $(a){let i;return a[a.length-1]<65536?i=new Uint16Array(a.length):i=new Uint32Array(a.length),i.set(a,0),i}class k{constructor(i,r,n,o,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=o,this.isBasicASCII=t}}function R(a,i=!0){const r=[0];let n=1;for(let o=0,t=a.length;o<t;o++){const h=a.charCodeAt(o);h===13?o+1<t&&a.charCodeAt(o+1)===10?(r[n++]=o+2,o++):r[n++]=o+1:h===10&&(r[n++]=o+1)}return i?$(r):r}e.$_B=R;function C(a,i){a.length=0,a[0]=0;let r=1,n=0,o=0,t=0,h=!0;for(let d=0,l=i.length;d<l;d++){const c=i.charCodeAt(d);c===13?d+1<l&&i.charCodeAt(d+1)===10?(t++,a[r++]=d+2,d++):(n++,a[r++]=d+1):c===10?(o++,a[r++]=d+1):h&&c!==9&&(c<32||c>126)&&(h=!1)}const s=new k($(a),n,o,t,h);return a.length=0,s}e.$aC=C;class b{constructor(i,r,n,o,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=o,this.length=t}}e.$bC=b;class E{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$cC=E;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==P.$WB&&i.iterate(i.root,n=>(n!==P.$WB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let o=0;o<n.length;o++){const t=n[o];if(t.node.parent===null||t.nodeStartOffset>=i){n[o]=null,r=!0;continue}}if(r){const o=[];for(const t of n)t!==null&&o.push(t);this.b=o}}}class m{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=P.$WB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let o=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const s=new b(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),o=this.S(o,s)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=v,n=r-Math.floor(r/3),o=n*2;let t="",h=0;const s=[];if(this.iterate(this.root,d=>{const l=this.R(d),c=l.length;if(h<=n||h+c<o)return t+=l,h+=c,!0;const p=t.replace(/\r\n|\r|\n/g,i);return s.push(new E(p,R(p))),t=l,h=c,!0}),h>0){const d=t.replace(/\r\n|\r|\n/g,i);s.push(new E(d,R(d)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,o=>{if(o===P.$WB)return!0;const t=this.R(o),h=t.length,s=i.G(r),d=i.G(r+h),l=i.getValueInRange2(s,d);return r+=h,t===l})}getOffsetAt(i,r){let n=0,o=this.root;for(;o!==P.$WB;)if(o.left!==P.$WB&&o.lf_left+1>=i)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt+1>=i){n+=o.size_left;const t=this.B(o,i-o.lf_left-2);return n+=t+r-1}else i-=o.lf_left+o.piece.lineFeedCnt,n+=o.size_left+o.piece.length,o=o.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const o=i;for(;r!==P.$WB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const h=this.getOffsetAt(n+1,1),s=o-h;return new D.$Ws(n+1,s+1)}return new D.$Ws(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===P.$WB){const t=this.getOffsetAt(n+1,1),h=o-i-t;return new D.$Ws(n+1,h+1)}else r=r.right;return new D.$Ws(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),o=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,o);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,d=this.a[s.piece.bufferIndex].buffer,l=this.u(s.piece.bufferIndex,s.piece.start);return d.substring(l+i.remainder,l+r.remainder)}let n=i.node;const o=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let h=o.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==P.$WB;){const s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){h+=s.substring(d,d+r.remainder);break}else h+=s.substr(d,n.piece.length);n=n.next()}return h}getLinesContent(){const i=[];let r=0,n="",o=!1;return this.iterate(this.root,t=>{if(t===P.$WB)return!0;const h=t.piece;let s=h.length;if(s===0)return!0;const d=this.a[h.bufferIndex].buffer,l=this.a[h.bufferIndex].lineStarts,c=h.start.line,p=h.end.line;let I=l[c]+h.start.column;if(o&&(d.charCodeAt(I)===10&&(I++,s--),i[r++]=n,n="",o=!1,s===0))return!0;if(c===p)return!this.f&&d.charCodeAt(I+s-1)===13?(o=!0,n+=d.substr(I,s-1)):n+=d.substr(I,s),!0;n+=this.f?d.substring(I,Math.max(I,l[c+1]-this.e)):d.substring(I,l[c+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let w=c+1;w<p;w++)n=this.f?d.substring(l[w],l[w+1]-this.e):d.substring(l[w],l[w+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&d.charCodeAt(l[p]+h.end.column-1)===13?(o=!0,h.end.column===0?r--:n=d.substr(l[p],h.end.column-1)):n=d.substr(l[p],h.end.column),!0}),o&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],o=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(o)}else{const r=this.a[i.node.piece.bufferIndex],o=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(o)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,o,t,h,s,d,l,c,p){const I=this.a[i.piece.bufferIndex],w=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,h);let L;const F={line:0,column:0};let z,j;r._wordSeparators?(z=I.buffer.substring(g,y),j=O=>O+g,r.reset(0)):(z=I.buffer,j=O=>O,r.reset(g));do if(L=r.next(z),L){if(j(L.index)>=y)return c;this.s(i,j(L.index)-w,F);const O=this.t(i.piece.bufferIndex,t,F),M=F.line===t.line?F.column-t.column+o:F.column+1,T=M+L[0].length;if(p[c++]=(0,A.$8B)(new N.$Xs(n+O,M,n+O,T),L,d),j(L.index)+L[0].length>=y||c>=l)return c}while(L);return c}findMatchesLineByLine(i,r,n,o){const t=[];let h=0;const s=new A.$$B(r.wordSeparators,r.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let c=this.s(d.node,d.remainder);const p=this.s(l.node,l.remainder);if(d.node===l.node)return this.findMatchesInNode(d.node,s,i.startLineNumber,i.startColumn,c,p,r,n,o,h,t),t;let I=i.startLineNumber,w=d.node;for(;w!==l.node;){const y=this.t(w.piece.bufferIndex,c,w.piece.end);if(y>=1){const F=this.a[w.piece.bufferIndex].lineStarts,z=this.u(w.piece.bufferIndex,w.piece.start),j=F[c.line+y],O=I===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(w,s,I,O,c,this.s(w,j-z),r,n,o,h,t),h>=o)return t;I+=y}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const F=this.getLineContent(I).substring(L,i.endColumn-1);return h=this.n(r,s,F,i.endLineNumber,L,h,t,n,o),t}if(h=this.n(r,s,this.getLineContent(I).substr(L),I,L,h,t,n,o),h>=o)return t;I++,d=this.H(I,1),w=d.node,c=this.s(d.node,d.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(y,i.endColumn-1);return h=this.n(r,s,L,i.endLineNumber,y,h,t,n,o),t}const g=I===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(l.node,s,I,g,c,p,r,n,o,h,t),t}n(i,r,n,o,t,h,s,d,l){const c=i.wordSeparators;if(!d&&i.simpleSearch){const I=i.simpleSearch,w=I.length,g=n.length;let y=-w;for(;(y=n.indexOf(I,y+w))!==-1;)if((!c||(0,A.$0B)(c,n,g,y,w))&&(s[h++]=new f.$dv(new N.$Xs(o,y+1+t,o,y+1+w+t),null),h>=l))return h;return h}let p;r.reset(0);do if(p=r.next(n),p&&(s[h++]=(0,A.$8B)(new N.$Xs(o,p.index+1+t,o,p.index+1+p[0].length+t),p,d),h>=l))return h;while(p);return h}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==P.$WB){const{node:o,remainder:t,nodeStartOffset:h}=this.G(i),s=o.piece,d=s.bufferIndex,l=this.s(o,t);if(o.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&r.length<v){this.F(o,r),this.y();return}if(h===i)this.o(r,o),this.h.validate(i);else if(h+o.piece.length>i){const c=[];let p=new b(s.bufferIndex,l,s.end,this.t(s.bufferIndex,l,s.end),this.u(d,s.end)-this.u(d,l));if(this.K()&&this.M(r)&&this.I(o,t)===10){const y={line:p.start.line+1,column:0};p=new b(p.bufferIndex,y,p.end,this.t(p.bufferIndex,y,p.end),p.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(o,t-1)===13){const y=this.s(o,t-1);this.C(o,y),r="\r"+r,o.piece.length===0&&c.push(o)}else this.C(o,l);else this.C(o,l);const I=this.w(r);p.length>0&&this.S(o,p);let w=o;for(let g=0;g<I.length;g++)w=this.S(w,I[g]);this.v(c)}else this.q(r,o)}else{const o=this.w(r);let t=this.T(null,o[0]);for(let h=1;h<o.length;h++)t=this.S(t,o[h])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===P.$WB)return;const n=this.G(i),o=this.G(i+r),t=n.node,h=o.node;if(t===h){const I=this.s(t,n.remainder),w=this.s(t,o.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const g=t.next();(0,P.$2B)(this,t),this.N(g),this.y();return}this.D(t,w),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,I),this.O(t),this.y();return}this.E(t,I,w),this.y();return}const s=[],d=this.s(t,n.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&s.push(t);const l=this.s(h,o.remainder);this.D(h,l),h.piece.length===0&&s.push(h);const c=t.next();for(let I=c;I!==P.$WB&&I!==h;I=I.next())s.push(I);const p=t.piece.length===0?t.prev():t;this.v(s),this.O(p),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const h=r.piece,s={line:h.start.line+1,column:0},d=new b(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);r.piece=d,i+=`
`,(0,P.$4B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const o=this.w(i);let t=this.T(r,o[o.length-1]);for(let h=o.length-2;h>=0;h--)t=this.T(t,o[h]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),o=this.S(r,n[0]);let t=o;for(let h=1;h<n.length;h++)t=this.S(t,n[h]);this.N(o)}s(i,r,n){const o=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,d=h[o.start.line]+o.start.column+r;let l=o.start.line,c=o.end.line,p=0,I=0,w=0;for(;l<=c&&(p=l+(c-l)/2|0,w=h[p],p!==c);)if(I=h[p+1],d<w)c=p-1;else if(d>=I)l=p+1;else break;return n?(n.line=p,n.column=d-w,null):{line:p,column:d-w}}t(i,r,n){if(n.column===0)return n.line-r.line;const o=this.a[i].lineStarts;if(n.line===o.length-1)return n.line-r.line;const t=o[n.line+1],h=o[n.line]+n.column;if(t>h+1)return n.line-r.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,P.$2B)(this,i[r])}w(i){if(i.length>v){const c=[];for(;i.length>v;){const I=i.charCodeAt(v-1);let w;I===13||I>=55296&&I<=56319?(w=i.substring(0,v-1),i=i.substring(v-1)):(w=i.substring(0,v),i=i.substring(v));const g=R(w);c.push(new b(this.a.length,{line:0,column:0},{line:g.length-1,column:w.length-g[g.length-1]},g.length-1,w.length)),this.a.push(new E(w,g))}const p=R(i);return c.push(new b(this.a.length,{line:0,column:0},{line:p.length-1,column:i.length-p[p.length-1]},p.length-1,i.length)),this.a.push(new E(i,p)),c}let r=this.a[0].buffer.length;const n=R(i,!1);let o=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},o=this.g;for(let c=0;c<n.length;c++)n[c]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let c=0;c<n.length;c++)n[c]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[h],d={line:h,column:s},l=new b(0,o,d,this.t(0,o,d),t-r);return this.g=d,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,o="";const t=this.h.get2(i);if(t){n=t.node;const h=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)o=s.substring(d+h,d+n.piece.length);else{const l=this.B(n,i-t.nodeStartLineNumber);return s.substring(d+h,d+l-r)}}else{let h=0;const s=i;for(;n!==P.$WB;)if(n.left!==P.$WB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const d=this.B(n,i-n.lf_left-2),l=this.B(n,i-n.lf_left-1),c=this.a[n.piece.bufferIndex].buffer,p=this.u(n.piece.bufferIndex,n.piece.start);return h+=n.size_left,this.h.set({node:n,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-n.lf_left)}),c.substring(p+d,p+l-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const d=this.B(n,i-n.lf_left-2),l=this.a[n.piece.bufferIndex].buffer,c=this.u(n.piece.bufferIndex,n.piece.start);o=l.substring(c+d,c+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,h+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==P.$WB;){const h=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),d=this.u(n.piece.bufferIndex,n.piece.start);return o+=h.substring(d,d+s-r),o}else{const s=this.u(n.piece.bufferIndex,n.piece.start);o+=h.substr(s,n.piece.length)}n=n.next()}return o}y(){let i=this.root,r=1,n=0;for(;i!==P.$WB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,o=this.s(i,r),t=o.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const h=this.t(i.piece.bufferIndex,n.start,o);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:o.column}}B(i,r){if(r<0)return 0;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?o[n.end.line]+n.end.column-o[n.start.line]-n.start.column:o[t]-o[n.start.line]-n.start.column}C(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),h=r,s=this.u(n.bufferIndex,h),d=this.t(n.bufferIndex,n.start,h),l=d-o,c=s-t,p=n.length+c;i.piece=new b(n.bufferIndex,n.start,h,d,p),(0,P.$4B)(this,i,c,l)}D(i,r){const n=i.piece,o=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),h=r,s=this.t(n.bufferIndex,h,n.end),d=this.u(n.bufferIndex,h),l=s-o,c=t-d,p=n.length+c;i.piece=new b(n.bufferIndex,h,n.end,s,p),(0,P.$4B)(this,i,c,l)}E(i,r,n){const o=i.piece,t=o.start,h=o.end,s=o.length,d=o.lineFeedCnt,l=r,c=this.t(o.bufferIndex,o.start,l),p=this.u(o.bufferIndex,r)-this.u(o.bufferIndex,t);i.piece=new b(o.bufferIndex,o.start,l,c,p),(0,P.$4B)(this,i,p-s,c-d);const I=new b(o.bufferIndex,n,h,this.t(o.bufferIndex,n,h),this.u(o.bufferIndex,h)-this.u(o.bufferIndex,n)),w=this.S(i,I);this.N(w)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),o=this.a[0].buffer.length;this.a[0].buffer+=r;const t=R(r,!1);for(let w=0;w<t.length;w++)t[w]+=o;if(n){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:o-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],d={line:h,column:s},l=i.piece.length+r.length,c=i.piece.lineFeedCnt,p=this.t(0,i.piece.start,d),I=p-c;i.piece=new b(i.piece.bufferIndex,i.piece.start,d,p,l),this.g=d,(0,P.$4B)(this,i,r.length,I)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let o=0;for(;r!==P.$WB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){o+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:o};return this.h.set(t),t}else i-=r.size_left+r.piece.length,o+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,o=0;for(;n!==P.$WB;)if(n.left!==P.$WB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),h=this.B(n,i-n.lf_left-1);return o+=n.size_left,{node:n,remainder:Math.min(t+r-1,h),nodeStartOffset:o}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:o};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,o+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==P.$WB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),h=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:h}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],o=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(o)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$WB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,o=r.start.line,t=n[o]+r.start.column;return o===n.length-1||n[o+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$WB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],o=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:o[i.piece.end.line]-o[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new b(i.piece.bufferIndex,i.piece.start,t,s,h),(0,P.$4B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const d={line:r.piece.start.line+1,column:0},l=r.piece.length-1,c=this.t(r.piece.bufferIndex,d,r.piece.end);r.piece=new b(r.piece.bufferIndex,d,r.piece.end,c,l),(0,P.$4B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const p=this.w(`\r
`);this.S(i,p[0]);for(let I=0;I<n.length;I++)(0,P.$2B)(this,n[I])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,P.$2B)(this,n);else{const o=n.piece,t={line:o.start.line+1,column:0},h=o.length-1,s=this.t(o.bufferIndex,t,o.end);n.piece=new b(o.bufferIndex,t,o.end,s,h),(0,P.$4B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===P.$WB)return r(P.$WB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===P.$WB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,o=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(o,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),o=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,o)}S(i,r){const n=new P.$VB(r,1);if(n.left=P.$WB,n.right=P.$WB,n.parent=P.$WB,n.size_left=0,n.lf_left=0,this.root===P.$WB)this.root=n,n.color=0;else if(i.right===P.$WB)i.right=n,n.parent=i;else{const t=(0,P.$XB)(i.right);t.left=n,n.parent=t}return(0,P.$3B)(this,n),n}T(i,r){const n=new P.$VB(r,1);if(n.left=P.$WB,n.right=P.$WB,n.parent=P.$WB,n.size_left=0,n.lf_left=0,this.root===P.$WB)this.root=n,n.color=0;else if(i.left===P.$WB)i.left=n,n.parent=i;else{const o=(0,P.$YB)(i.left);o.right=n,n.parent=o}return(0,P.$3B)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$dC=m}),define(Ce[178],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8=e.$X8=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const A=this.a.get(P);return this.a.delete(P),A}}addDragOperationTransfer(P,A){this.a.set(P,A)}}e.$X8=D;class N{constructor(P){this.identifier=P}}e.$Y8=N}),define(Ce[179],Ie([1,0,4,3]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Wd,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,$){return this.a.set(v,$),this.handleChange([v]),(0,N.$Rc)(()=>{this.a.get(v)===$&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,$){this.b.get(v)?.dispose();const k=new P(this,v,$);return this.b.set(v,k),(0,N.$Rc)(()=>{const R=this.b.get(v);!R||R!==k||(this.b.delete(v),R.dispose())})}async getOrCreate(v){const $=this.get(v);if($)return $;const k=this.b.get(v);return!k||k.isResolved?null:(await k.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const k=this.b.get(v);return!!(!k||k.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$wt=f;class P extends N.$Tc{get isResolved(){return this.c}constructor(v,$,k){super(),this.f=v,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Ce[180],Ie([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Ce[181],Ie([1,0,4,3,180]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=void 0;class P extends N.$Tc{constructor(b,E="",S="",u=!0,m){super(),this.h=this.B(new D.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=E,this.u=S,this.w=u,this.C=m}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,E){this.C&&await this.C(b)}}e.$Ni=P;class A extends N.$Tc{constructor(){super(...arguments),this.f=this.B(new D.$Wd),this.onWillRun=this.f.event,this.m=this.B(new D.$Wd),this.onDidRun=this.m.event}async run(b,E){if(!b.enabled)return;this.f.fire({action:b});let S;try{await this.u(b,E)}catch(u){S=u}this.m.fire({action:b,error:S})}async u(b,E){await b.run(E)}}e.$Oi=A;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let E=[];for(const S of b)S.length&&(E.length?E=[...E,new v,...S]:E=S);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Pi=v;class ${get actions(){return this.a}constructor(b,E,S,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=E,this.class=u,this.a=S}async run(){}}e.$Qi=$;class k extends P{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,f.localize(0,null),void 0,!1)}}e.$Ri=k;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...b)=>C.run(...b),tooltip:C.label}}e.$Si=R}),define(Ce[182],Ie([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Ce[183],Ie([1,0,182]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=void 0;const N=60,f=N*60,P=f*24,A=P*7,v=P*30,$=P*365;function k(b,E,S,u){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,D.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(!u&&m<30)return(0,D.localize)(1,null);let a;return m<N?(a=m,E?a===1?S?(0,D.localize)(2,null,a):(0,D.localize)(3,null,a):S?(0,D.localize)(4,null,a):(0,D.localize)(5,null,a):a===1?S?(0,D.localize)(6,null,a):(0,D.localize)(7,null,a):S?(0,D.localize)(8,null,a):(0,D.localize)(9,null,a)):m<f?(a=Math.floor(m/N),E?a===1?S?(0,D.localize)(10,null,a):(0,D.localize)(11,null,a):S?(0,D.localize)(12,null,a):(0,D.localize)(13,null,a):a===1?S?(0,D.localize)(14,null,a):(0,D.localize)(15,null,a):S?(0,D.localize)(16,null,a):(0,D.localize)(17,null,a)):m<P?(a=Math.floor(m/f),E?a===1?S?(0,D.localize)(18,null,a):(0,D.localize)(19,null,a):S?(0,D.localize)(20,null,a):(0,D.localize)(21,null,a):a===1?S?(0,D.localize)(22,null,a):(0,D.localize)(23,null,a):S?(0,D.localize)(24,null,a):(0,D.localize)(25,null,a)):m<A?(a=Math.floor(m/P),E?a===1?(0,D.localize)(26,null,a):(0,D.localize)(27,null,a):a===1?(0,D.localize)(28,null,a):(0,D.localize)(29,null,a)):m<v?(a=Math.floor(m/A),E?a===1?S?(0,D.localize)(30,null,a):(0,D.localize)(31,null,a):S?(0,D.localize)(32,null,a):(0,D.localize)(33,null,a):a===1?S?(0,D.localize)(34,null,a):(0,D.localize)(35,null,a):S?(0,D.localize)(36,null,a):(0,D.localize)(37,null,a)):m<$?(a=Math.floor(m/v),E?a===1?S?(0,D.localize)(38,null,a):(0,D.localize)(39,null,a):S?(0,D.localize)(40,null,a):(0,D.localize)(41,null,a):a===1?S?(0,D.localize)(42,null,a):(0,D.localize)(43,null,a):S?(0,D.localize)(44,null,a):(0,D.localize)(45,null,a)):(a=Math.floor(m/$),E?a===1?S?(0,D.localize)(46,null,a):(0,D.localize)(47,null,a):S?(0,D.localize)(48,null,a):(0,D.localize)(49,null,a):a===1?S?(0,D.localize)(50,null,a):(0,D.localize)(51,null,a):S?(0,D.localize)(52,null,a):(0,D.localize)(53,null,a))}e.$ym=k;function R(b,E){const S=Math.abs(b/1e3);return S<1?E?(0,D.localize)(54,null,b):(0,D.localize)(55,null,b):S<N?E?(0,D.localize)(56,null,Math.round(b)/1e3):(0,D.localize)(57,null,Math.round(b)/1e3):S<f?E?(0,D.localize)(58,null,Math.round(b/(1e3*N))):(0,D.localize)(59,null,Math.round(b/(1e3*N))):S<P?E?(0,D.localize)(60,null,Math.round(b/(1e3*f))):(0,D.localize)(61,null,Math.round(b/(1e3*f))):(0,D.localize)(62,null,Math.round(b/(1e3*P)))}e.$zm=R;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Am=C}),define(Ce[184],Ie([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,19,18,184]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=void 0;function P(C,b){return b&&(C.stack||C.stacktrace)?f.localize(0,null,v(C),A(C.stack)||A(C.stacktrace)):v(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function v(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?f.localize(1,null,C.message):C.message||f.localize(2,null)}function $(C=null,b=!1){if(!C)return f.localize(3,null);if(Array.isArray(C)){const E=D.$Hb(C),S=$(E[0],b);return E.length>1?f.localize(4,null,S,E.length):S}if(N.$Kf(C))return C;if(C.detail){const E=C.detail;if(E.error)return P(E.error,b);if(E.exception)return P(E.exception,b)}return C.stack?P(C,b):C.message?C.message:f.localize(5,null)}e.$Ti=$;function k(C){const b=C;return b instanceof Error&&Array.isArray(b.actions)}e.$Ui=k;function R(C,b){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=b,E}e.$Vi=R}),define(Ce[185],Ie([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Ce[11],Ie([1,0,185]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,f=!1,P=!1,A=!1,v=!1,$=!1,k=!1,R=!1,C=!1,b=!1,E,S=e.$g,u=e.$g,m,a;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",o=n&&r?.type==="renderer";if(typeof r=="object"){N=r.platform==="win32",f=r.platform==="darwin",P=r.platform==="linux",A=P&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,k=n,C=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,S=e.$g;const g=r.env.VSCODE_NLS_CONFIG;if(g)try{const y=JSON.parse(g),L=y.availableLanguages["*"];E=y.locale,u=y.osLocale,S=L||e.$g,m=y._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!o?(a=navigator.userAgent,N=a.indexOf("Windows")>=0,f=a.indexOf("Macintosh")>=0,R=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=a.indexOf("Linux")>=0,b=a?.indexOf("Mobi")>=0,$=!0,E=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=E,u=navigator.language):console.error("Unable to resolve platform.");var t;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=h;let s=0;f?s=1:N?s=3:P&&(s=2),e.$i=N,e.$j=f,e.$k=P,e.$l=A,e.$m=v,e.$n=k,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=b,e.$t=C,e.$u=s,e.$v=a,e.$w=S;var d;(function(g){function y(){return e.$w}g.value=y;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}g.isDefaultVariant=L;function F(){return e.$w==="en"}g.isDefault=F})(d||(e.Language=d={})),e.$x=E,e.$y=u,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const g=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let F=0,z=g.length;F<z;F++){const j=g[F];if(j.id===L.data.vscodeScheduleAsyncWork){g.splice(F,1),j.callback();return}}});let y=0;return L=>{const F=++y;g.push({id:F,callback:L}),i.postMessage({vscodeScheduleAsyncWork:F},"*")}}return g=>setTimeout(g)})();var l;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||R?2:N?1:3;let c=!0,p=!1;function I(){if(!p){p=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,c=new Uint16Array(g.buffer)[0]===513}return c}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(g){return parseFloat(g)>=20}e.$J=w}),define(Ce[49],Ie([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const P=f.process;N={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(Ce[17],Ie([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,f=97,P=90,A=122,v=46,$=47,k=92,R=58,C=63;class b extends Error{constructor(h,s,d){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const c=h.indexOf(".")!==-1?"property":"argument";let p=`The "${h}" ${c} ${l} of type ${s}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,h){if(t===null||typeof t!="object")throw new b(h,"Object",t)}function S(t,h){if(typeof t!="string")throw new b(h,"string",t)}const u=D.$dc==="win32";function m(t){return t===$||t===k}function a(t){return t===$}function i(t){return t>=N&&t<=P||t>=f&&t<=A}function r(t,h,s,d){let l="",c=0,p=-1,I=0,w=0;for(let g=0;g<=t.length;++g){if(g<t.length)w=t.charCodeAt(g);else{if(d(w))break;w=$}if(d(w)){if(!(p===g-1||I===1))if(I===2){if(l.length<2||c!==2||l.charCodeAt(l.length-1)!==v||l.charCodeAt(l.length-2)!==v){if(l.length>2){const y=l.lastIndexOf(s);y===-1?(l="",c=0):(l=l.slice(0,y),c=l.length-1-l.lastIndexOf(s)),p=g,I=0;continue}else if(l.length!==0){l="",c=0,p=g,I=0;continue}}h&&(l+=l.length>0?`${s}..`:"..",c=2)}else l.length>0?l+=`${s}${t.slice(p+1,g)}`:l=t.slice(p+1,g),c=g-p-1;p=g,I=0}else w===v&&I!==-1?++I:I=-1}return l}function n(t,h){E(h,"pathObject");const s=h.dir||h.root,d=h.base||`${h.name||""}${h.ext||""}`;return s?s===h.root?`${s}${d}`:`${s}${t}${d}`:d}e.$fc={resolve(...t){let h="",s="",d=!1;for(let l=t.length-1;l>=-1;l--){let c;if(l>=0){if(c=t[l],S(c,"path"),c.length===0)continue}else h.length===0?c=D.cwd():(c=D.env[`=${h}`]||D.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==h.toLowerCase()&&c.charCodeAt(2)===k)&&(c=`${h}\\`));const p=c.length;let I=0,w="",g=!1;const y=c.charCodeAt(0);if(p===1)m(y)&&(I=1,g=!0);else if(m(y))if(g=!0,m(c.charCodeAt(1))){let L=2,F=L;for(;L<p&&!m(c.charCodeAt(L));)L++;if(L<p&&L!==F){const z=c.slice(F,L);for(F=L;L<p&&m(c.charCodeAt(L));)L++;if(L<p&&L!==F){for(F=L;L<p&&!m(c.charCodeAt(L));)L++;(L===p||L!==F)&&(w=`\\\\${z}\\${c.slice(F,L)}`,I=L)}}}else I=1;else i(y)&&c.charCodeAt(1)===R&&(w=c.slice(0,2),I=2,p>2&&m(c.charCodeAt(2))&&(g=!0,I=3));if(w.length>0)if(h.length>0){if(w.toLowerCase()!==h.toLowerCase())continue}else h=w;if(d){if(h.length>0)break}else if(s=`${c.slice(I)}\\${s}`,d=g,g&&h.length>0)break}return s=r(s,!d,"\\",m),d?`${h}\\${s}`:`${h}${s}`||"."},normalize(t){S(t,"path");const h=t.length;if(h===0)return".";let s=0,d,l=!1;const c=t.charCodeAt(0);if(h===1)return a(c)?"\\":t;if(m(c))if(l=!0,m(t.charCodeAt(1))){let I=2,w=I;for(;I<h&&!m(t.charCodeAt(I));)I++;if(I<h&&I!==w){const g=t.slice(w,I);for(w=I;I<h&&m(t.charCodeAt(I));)I++;if(I<h&&I!==w){for(w=I;I<h&&!m(t.charCodeAt(I));)I++;if(I===h)return`\\\\${g}\\${t.slice(w)}\\`;I!==w&&(d=`\\\\${g}\\${t.slice(w,I)}`,s=I)}}}else s=1;else i(c)&&t.charCodeAt(1)===R&&(d=t.slice(0,2),s=2,h>2&&m(t.charCodeAt(2))&&(l=!0,s=3));let p=s<h?r(t.slice(s),!l,"\\",m):"";return p.length===0&&!l&&(p="."),p.length>0&&m(t.charCodeAt(h-1))&&(p+="\\"),d===void 0?l?`\\${p}`:p:l?`${d}\\${p}`:`${d}${p}`},isAbsolute(t){S(t,"path");const h=t.length;if(h===0)return!1;const s=t.charCodeAt(0);return m(s)||h>2&&i(s)&&t.charCodeAt(1)===R&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,s;for(let c=0;c<t.length;++c){const p=t[c];S(p,"path"),p.length>0&&(h===void 0?h=s=p:h+=`\\${p}`)}if(h===void 0)return".";let d=!0,l=0;if(typeof s=="string"&&m(s.charCodeAt(0))){++l;const c=s.length;c>1&&m(s.charCodeAt(1))&&(++l,c>2&&(m(s.charCodeAt(2))?++l:d=!1))}if(d){for(;l<h.length&&m(h.charCodeAt(l));)l++;l>=2&&(h=`\\${h.slice(l)}`)}return e.$fc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h)return"";const s=e.$fc.resolve(t),d=e.$fc.resolve(h);if(s===d||(t=s.toLowerCase(),h=d.toLowerCase(),t===h))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===k;)l++;let c=t.length;for(;c-1>l&&t.charCodeAt(c-1)===k;)c--;const p=c-l;let I=0;for(;I<h.length&&h.charCodeAt(I)===k;)I++;let w=h.length;for(;w-1>I&&h.charCodeAt(w-1)===k;)w--;const g=w-I,y=p<g?p:g;let L=-1,F=0;for(;F<y;F++){const j=t.charCodeAt(l+F);if(j!==h.charCodeAt(I+F))break;j===k&&(L=F)}if(F!==y){if(L===-1)return d}else{if(g>y){if(h.charCodeAt(I+F)===k)return d.slice(I+F+1);if(F===2)return d.slice(I+F)}p>y&&(t.charCodeAt(l+F)===k?L=F:F===2&&(L=3)),L===-1&&(L=0)}let z="";for(F=l+L+1;F<=c;++F)(F===c||t.charCodeAt(F)===k)&&(z+=z.length===0?"..":"\\..");return I+=L,z.length>0?`${z}${d.slice(I,w)}`:(d.charCodeAt(I)===k&&++I,d.slice(I,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$fc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const s=h.charCodeAt(2);if(s!==C&&s!==v)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return t},dirname(t){S(t,"path");const h=t.length;if(h===0)return".";let s=-1,d=0;const l=t.charCodeAt(0);if(h===1)return m(l)?t:".";if(m(l)){if(s=d=1,m(t.charCodeAt(1))){let I=2,w=I;for(;I<h&&!m(t.charCodeAt(I));)I++;if(I<h&&I!==w){for(w=I;I<h&&m(t.charCodeAt(I));)I++;if(I<h&&I!==w){for(w=I;I<h&&!m(t.charCodeAt(I));)I++;if(I===h)return t;I!==w&&(s=d=I+1)}}}}else i(l)&&t.charCodeAt(1)===R&&(s=h>2&&m(t.charCodeAt(2))?3:2,d=s);let c=-1,p=!0;for(let I=h-1;I>=d;--I)if(m(t.charCodeAt(I))){if(!p){c=I;break}}else p=!1;if(c===-1){if(s===-1)return".";c=s}return t.slice(0,c)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,l=!0,c;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let p=h.length-1,I=-1;for(c=t.length-1;c>=s;--c){const w=t.charCodeAt(c);if(m(w)){if(!l){s=c+1;break}}else I===-1&&(l=!1,I=c+1),p>=0&&(w===h.charCodeAt(p)?--p===-1&&(d=c):(p=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(c=t.length-1;c>=s;--c)if(m(t.charCodeAt(c))){if(!l){s=c+1;break}}else d===-1&&(l=!1,d=c+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=0,s=-1,d=0,l=-1,c=!0,p=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(h=d=2);for(let I=t.length-1;I>=h;--I){const w=t.charCodeAt(I);if(m(w)){if(!c){d=I+1;break}continue}l===-1&&(c=!1,l=I+1),w===v?s===-1?s=I:p!==1&&(p=1):s!==-1&&(p=-1)}return s===-1||l===-1||p===0||p===1&&s===l-1&&s===d+1?"":t.slice(s,l)},format:n.bind(null,"\\"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.length;let d=0,l=t.charCodeAt(0);if(s===1)return m(l)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(m(l)){if(d=1,m(t.charCodeAt(1))){let L=2,F=L;for(;L<s&&!m(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&m(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&!m(t.charCodeAt(L));)L++;L===s?d=L:L!==F&&(d=L+1)}}}}else if(i(l)&&t.charCodeAt(1)===R){if(s<=2)return h.root=h.dir=t,h;if(d=2,m(t.charCodeAt(2))){if(s===3)return h.root=h.dir=t,h;d=3}}d>0&&(h.root=t.slice(0,d));let c=-1,p=d,I=-1,w=!0,g=t.length-1,y=0;for(;g>=d;--g){if(l=t.charCodeAt(g),m(l)){if(!w){p=g+1;break}continue}I===-1&&(w=!1,I=g+1),l===v?c===-1?c=g:y!==1&&(y=1):c!==-1&&(y=-1)}return I!==-1&&(c===-1||y===0||y===1&&c===I-1&&c===p+1?h.base=h.name=t.slice(p,I):(h.name=t.slice(p,c),h.base=t.slice(p,I),h.ext=t.slice(c,I))),p>0&&p!==d?h.dir=t.slice(0,p-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(u){const t=/\\/g;return()=>{const h=D.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let h="",s=!1;for(let d=t.length-1;d>=-1&&!s;d--){const l=d>=0?t[d]:o();S(l,"path"),l.length!==0&&(h=`${l}/${h}`,s=l.charCodeAt(0)===$)}return h=r(h,!s,"/",a),s?`/${h}`:h.length>0?h:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!h,"/",a),t.length===0?h?"/":s?"./":".":(s&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let h;for(let s=0;s<t.length;++s){const d=t[s];S(d,"path"),d.length>0&&(h===void 0?h=d:h+=`/${d}`)}return h===void 0?".":e.$gc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h||(t=e.$gc.resolve(t),h=e.$gc.resolve(h),t===h))return"";const s=1,d=t.length,l=d-s,c=1,p=h.length-c,I=l<p?l:p;let w=-1,g=0;for(;g<I;g++){const L=t.charCodeAt(s+g);if(L!==h.charCodeAt(c+g))break;L===$&&(w=g)}if(g===I)if(p>I){if(h.charCodeAt(c+g)===$)return h.slice(c+g+1);if(g===0)return h.slice(c+g)}else l>I&&(t.charCodeAt(s+g)===$?w=g:g===0&&(w=0));let y="";for(g=s+w+1;g<=d;++g)(g===d||t.charCodeAt(g)===$)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(c+w)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$;let s=-1,d=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===$){if(!d){s=l;break}}else d=!1;return s===-1?h?"/":".":h&&s===1?"//":t.slice(0,s)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,l=!0,c;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let p=h.length-1,I=-1;for(c=t.length-1;c>=0;--c){const w=t.charCodeAt(c);if(w===$){if(!l){s=c+1;break}}else I===-1&&(l=!1,I=c+1),p>=0&&(w===h.charCodeAt(p)?--p===-1&&(d=c):(p=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===$){if(!l){s=c+1;break}}else d===-1&&(l=!1,d=c+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=-1,s=0,d=-1,l=!0,c=0;for(let p=t.length-1;p>=0;--p){const I=t.charCodeAt(p);if(I===$){if(!l){s=p+1;break}continue}d===-1&&(l=!1,d=p+1),I===v?h===-1?h=p:c!==1&&(c=1):h!==-1&&(c=-1)}return h===-1||d===-1||c===0||c===1&&h===d-1&&h===s+1?"":t.slice(h,d)},format:n.bind(null,"/"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.charCodeAt(0)===$;let d;s?(h.root="/",d=1):d=0;let l=-1,c=0,p=-1,I=!0,w=t.length-1,g=0;for(;w>=d;--w){const y=t.charCodeAt(w);if(y===$){if(!I){c=w+1;break}continue}p===-1&&(I=!1,p=w+1),y===v?l===-1?l=w:g!==1&&(g=1):l!==-1&&(g=-1)}if(p!==-1){const y=c===0&&s?1:c;l===-1||g===0||g===1&&l===p-1&&l===c+1?h.base=h.name=t.slice(y,p):(h.name=t.slice(y,l),h.base=t.slice(y,p),h.ext=t.slice(l,p))}return c>0?h.dir=t.slice(0,c-1):s&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Ce[128],Ie([1,0,43,17]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=void 0;const f=new D.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),P=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(I,w,g=!1){const y=I||"",L=w||"",F=f.value.collator.compare(y,L);return f.value.collatorIsNumeric&&F===0&&y!==L?y<L?-1:1:F}e.$Lq=v;function $(I,w){const g=P.value.collator;return I=I||"",w=w||"",n(g,I,w)}e.$Mq=$;function k(I,w){const g=P.value.collator;return I=I||"",w=w||"",s(I,w)||n(g,I,w)}e.$Nq=k;function R(I,w){const g=P.value.collator;return I=I||"",w=w||"",h(I,w)||n(g,I,w)}e.$Oq=R;function C(I,w){return I=I||"",w=w||"",I===w?0:I<w?-1:1}e.$Pq=C;function b(I,w){const[g,y]=i(I),[L,F]=i(w);let z=f.value.collator.compare(y,F);if(z===0){if(f.value.collatorIsNumeric&&y!==F)return y<F?-1:1;if(z=f.value.collator.compare(g,L),f.value.collatorIsNumeric&&z===0&&g!==L)return g<L?-1:1}return z}e.$Qq=b;function E(I,w){I=I||"",w=w||"";const g=r(I),y=r(w),L=P.value.collator,F=A.value.collator;return n(F,g,y)||n(L,I,w)}e.$Rq=E;function S(I,w){I=I||"",w=w||"";const g=r(I),y=r(w),L=P.value.collator,F=A.value.collator;return n(F,g,y)||s(I,w)||n(L,I,w)}e.$Sq=S;function u(I,w){I=I||"",w=w||"";const g=r(I),y=r(w),L=P.value.collator,F=A.value.collator;return n(F,g,y)||h(I,w)||n(L,I,w)}e.$Tq=u;function m(I,w){I=I||"",w=w||"";const g=r(I).toLowerCase(),y=r(w).toLowerCase();return g!==y?g<y?-1:1:I!==w?I<w?-1:1:0}e.$Uq=m;const a=/^(.*?)(\.([^.]*))?$/;function i(I,w=!1){const g=I?a.exec(I):[];let y=[g&&g[1]||"",g&&g[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function r(I){const w=I?a.exec(I):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function n(I,w,g){const y=I.compare(w,g);return y!==0?y:w.length!==g.length?w.length<g.length?-1:1:0}function o(I){const w=I.charAt(0);return w.toLocaleUpperCase()!==w}function t(I){const w=I.charAt(0);return w.toLocaleLowerCase()!==w}function h(I,w){return o(I)&&t(w)?-1:t(I)&&o(w)?1:0}function s(I,w){return t(I)&&o(w)?-1:o(I)&&t(w)?1:0}function d(I,w,g=!1){return g||(I=I&&I.toLowerCase(),w=w&&w.toLowerCase()),I===w?0:I<w?-1:1}function l(I,w,g=!1){const y=I.split(N.sep),L=w.split(N.sep),F=y.length-1,z=L.length-1;let j,O;for(let M=0;;M++){if(j=F===M,O=z===M,j&&O)return v(y[M],L[M],g);if(j)return-1;if(O)return 1;const T=d(y[M],L[M],g);if(T!==0)return T}}e.$Vq=l;function c(I,w,g){const y=I.toLowerCase(),L=w.toLowerCase(),F=p(I,w,g);if(F)return F;const z=y.endsWith(g),j=L.endsWith(g);if(z!==j)return z?-1:1;const O=v(y,L);return O!==0?O:y.localeCompare(L)}e.$Wq=c;function p(I,w,g){const y=I.toLowerCase(),L=w.toLowerCase(),F=y.startsWith(g),z=L.startsWith(g);if(F!==z)return F?-1:1;if(F&&z){if(y.length<L.length)return-1;if(y.length>L.length)return 1}return 0}e.$Xq=p}),define(Ce[34],Ie([1,0,17,11,12,18]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=void 0;function A(c){return c===47||c===92}e.$3f=A;function v(c){return c.replace(/[\\/]/g,D.$gc.sep)}e.$4f=v;function $(c){return c.indexOf("/")===-1&&(c=v(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$5f=$;function k(c,p=D.$gc.sep){if(!c)return"";const I=c.length,w=c.charCodeAt(0);if(A(w)){if(A(c.charCodeAt(1))&&!A(c.charCodeAt(2))){let y=3;const L=y;for(;y<I&&!A(c.charCodeAt(y));y++);if(L!==y&&!A(c.charCodeAt(y+1))){for(y+=1;y<I;y++)if(A(c.charCodeAt(y)))return c.slice(0,y+1).replace(/[\\/]/g,p)}}return p}else if(a(w)&&c.charCodeAt(1)===58)return A(c.charCodeAt(2))?c.slice(0,2)+p:c.slice(0,2);let g=c.indexOf("://");if(g!==-1){for(g+=3;g<I;g++)if(A(c.charCodeAt(g)))return c.slice(0,g+1)}return""}e.$6f=k;function R(c){if(!N.$i||!c||c.length<5)return!1;let p=c.charCodeAt(0);if(p!==92||(p=c.charCodeAt(1),p!==92))return!1;let I=2;const w=I;for(;I<c.length&&(p=c.charCodeAt(I),p!==92);I++);return!(w===I||(p=c.charCodeAt(I+1),isNaN(p)||p===92))}e.$7f=R;const C=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(c,p=N.$i){const I=p?C:b;return!(!c||c.length===0||/^\s+$/.test(c)||(I.lastIndex=0,I.test(c))||p&&E.test(c)||c==="."||c===".."||p&&c[c.length-1]==="."||p&&c.length!==c.trim().length||c.length>255)}e.$8f=S;function u(c,p,I){const w=c===p;return!I||w?w:!c||!p?!1:(0,f.$bf)(c,p)}e.$9f=u;function m(c,p,I,w=D.sep){if(c===p)return!0;if(!c||!p||p.length>c.length)return!1;if(I){if(!(0,f.$cf)(c,p))return!1;if(p.length===c.length)return!0;let y=p.length;return p.charAt(p.length-1)===w&&y--,c.charAt(y)===w}return p.charAt(p.length-1)!==w&&(p+=w),c.indexOf(p)===0}e.$0f=m;function a(c){return c>=65&&c<=90||c>=97&&c<=122}e.$$f=a;function i(c,p){return N.$i&&c.endsWith(":")&&(c+=D.sep),(0,D.$ic)(c)||(c=(0,D.$jc)(p,c)),c=(0,D.$hc)(c),N.$i?(c=(0,f.$Ve)(c,D.sep),c.endsWith(":")&&(c+=D.sep)):(c=(0,f.$Ve)(c,D.sep),c||(c=D.sep)),c}e.$_f=i;function r(c){const p=(0,D.$hc)(c);return N.$i?c.length>3?!1:n(p)&&(c.length===2||p.charCodeAt(2)===92):p===D.$gc.sep}e.$ag=r;function n(c,p=N.$i){return p?a(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$bg=n;function o(c,p=N.$i){return n(c,p)?c[0]:void 0}e.$cg=o;function t(c,p,I){return p.length>c.length?-1:c===p?0:(I&&(c=c.toLowerCase(),p=p.toLowerCase()),c.indexOf(p))}e.$dg=t;function h(c){const p=c.split(":");let I,w,g;for(const y of p){const L=Number(y);(0,P.$Of)(L)?w===void 0?w=L:g===void 0&&(g=L):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:w!==void 0?w:void 0,column:g!==void 0?g:w!==void 0?1:void 0}}e.$eg=h;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(c,p,I=8){let w="";for(let y=0;y<I;y++){let L;y===0&&N.$i&&!p&&(I===3||I===4)?L=d:L=s,w+=L.charAt(Math.floor(Math.random()*L.length))}let g;return p?g=`${p}-${w}`:g=w,c?(0,D.$jc)(c,g):g}e.$fg=l}),define(Ce[129],Ie([1,0,128,123,54,17,11,12]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=void 0;const $=0,k=[$,[]];function R(U,J,ne,ee){if(!U||!J)return k;const Q=U.length,Y=J.length;if(Q<Y)return k;const ce=U.toLowerCase();return C(J,ne,Y,U,ce,Q,ee)}e.$Yq=R;function C(U,J,ne,ee,Q,Y,ce){const te=[],fe=[];for(let ae=0;ae<ne;ae++){const Ee=ae*Y,le=Ee-Y,de=ae>0,ue=U[ae],ge=J[ae];for(let V=0;V<Y;V++){const Z=V>0,he=Ee+V,be=he-1,Pe=le+V-1,pe=Z?te[be]:0,Le=de&&Z?te[Pe]:0,Ne=de&&Z?fe[Pe]:0;let W;!Le&&de?W=0:W=b(ue,ge,ee,Q,V,Ne),W&&Le+W>=pe&&(ce||de||Q.startsWith(J,V))?(fe[he]=Ne+1,te[he]=Le+W):(fe[he]=$,te[he]=pe)}}const re=[];let K=ne-1,B=Y-1;for(;K>=0&&B>=0;){const ae=K*Y+B;fe[ae]===$||(re.push(B),K--),B--}return[te[ne*Y-1],re.reverse()]}function b(U,J,ne,ee,Q,Y){let ce=0;if(!E(J,ee[Q]))return ce;if(ce+=1,Y>0&&(ce+=Y*5),U===ne[Q]&&(ce+=1),Q===0)ce+=8;else{const te=S(ne.charCodeAt(Q-1));te?ce+=te:(0,N.$1j)(ne.charCodeAt(Q))&&Y===0&&(ce+=2)}return ce}function E(U,J){return U===J?!0:U==="/"||U==="\\"?J==="/"||J==="\\":!1}function S(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function m(U,J,ne=0,ee=0){const Q=J;return Q.values&&Q.values.length>1?a(U,Q.values,ne,ee):i(U,J,ne,ee)}e.$Zq=m;function a(U,J,ne,ee){let Q=0;const Y=[];for(const ce of J){const[te,fe]=i(U,ce,ne,ee);if(typeof te!="number")return u;Q+=te,Y.push(...fe)}return[Q,I(Y)]}function i(U,J,ne,ee){const Q=(0,N.$0j)(J.original,J.originalLowercase,ne,U,U.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,N.$7j)(Q)]:u}const r=Object.freeze({score:0}),n=1<<18,o=1<<17,t=65536;function h(U,J,ne,ee){const Q=ee.values?ee.values:[ee];return(0,f.$Wi)({[ee.normalized]:{values:Q.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:U,description:J,allowNonContiguousMatches:ne}})}function s(U,J,ne,ee,Q){if(!U||!J.normalized)return r;const Y=ee.getItemLabel(U);if(!Y)return r;const ce=ee.getItemDescription(U),te=h(Y,ce,ne,J),fe=Q[te];if(fe)return fe;const re=d(Y,ce,ee.getItemPath(U),J,ne);return Q[te]=re,re}e.$1q=s;function d(U,J,ne,ee,Q){const Y=!ne||!ee.containsPathSeparator;return ne&&(A.$k?ee.pathNormalized===ne:(0,v.$bf)(ee.pathNormalized,ne))?{score:n,labelMatch:[{start:0,end:U.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:ee.values&&ee.values.length>1?l(U,J,ne,ee.values,Y,Q):c(U,J,ne,ee,Y,Q)}function l(U,J,ne,ee,Q,Y){let ce=0;const te=[],fe=[];for(const re of ee){const{score:K,labelMatch:B,descriptionMatch:ae}=c(U,J,ne,re,Q,Y);if(K===$)return r;ce+=K,B&&te.push(...B),ae&&fe.push(...ae)}return{score:ce,labelMatch:I(te),descriptionMatch:I(fe)}}function c(U,J,ne,ee,Q,Y){if(Q||!J){const[ce,te]=R(U,ee.normalized,ee.normalizedLowercase,Y&&!ee.expectContiguousMatch);if(ce){const fe=(0,N.$Xj)(ee.normalized,U);let re;if(fe){re=o;const K=Math.round(ee.normalized.length/U.length*100);re+=K}else re=t;return{score:re+ce,labelMatch:fe||p(te)}}}if(J){let ce=J;ne&&(ce=`${J}${P.sep}`);const te=ce.length,fe=`${ce}${U}`,[re,K]=R(fe,ee.normalized,ee.normalizedLowercase,Y&&!ee.expectContiguousMatch);if(re){const B=p(K),ae=[],Ee=[];return B.forEach(le=>{le.start<te&&le.end>te?(ae.push({start:0,end:le.end-te}),Ee.push({start:le.start,end:te})):le.start>=te?ae.push({start:le.start-te,end:le.end-te}):Ee.push(le)}),{score:re,labelMatch:ae,descriptionMatch:Ee}}}return r}function p(U){const J=[];if(!U)return J;let ne;for(const ee of U)ne&&ne.end===ee?ne.end+=1:(ne={start:ee,end:ee+1},J.push(ne));return J}function I(U){const J=U.sort((Q,Y)=>Q.start-Y.start),ne=[];let ee;for(const Q of J)!ee||!w(ee,Q)?(ee=Q,ne.push(Q)):(ee.start=Math.min(ee.start,Q.start),ee.end=Math.max(ee.end,Q.end));return ne}function w(U,J){return!(U.end<J.start||J.end<U.start)}function g(U,J,ne,ee,Q,Y){const ce=s(U,ne,ee,Q,Y),te=s(J,ne,ee,Q,Y),fe=ce.score,re=te.score;if((fe===n||re===n)&&fe!==re)return fe===n?-1:1;if(fe>t||re>t){if(fe!==re)return fe>re?-1:1;if(fe<o&&re<o){const ue=L(ce.labelMatch,te.labelMatch);if(ue!==0)return ue}const le=Q.getItemLabel(U)||"",de=Q.getItemLabel(J)||"";if(le.length!==de.length)return le.length-de.length}if(fe!==re)return fe>re?-1:1;const K=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,B=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(K&&!B)return-1;if(B&&!K)return 1;const ae=y(U,ce,Q),Ee=y(J,te,Q);return ae&&Ee&&ae!==Ee?Ee>ae?-1:1:F(U,J,ne,Q)}e.$2q=g;function y(U,J,ne){let ee=-1,Q=-1;if(J.descriptionMatch&&J.descriptionMatch.length?ee=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(ee=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(Q=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const Y=ne.getItemDescription(U);Y&&(Q+=Y.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(Q=J.descriptionMatch[J.descriptionMatch.length-1].end);return Q-ee}function L(U,J){if(!U&&!J||(!U||!U.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!U||!U.length)return 1;const ne=U[0].start,Q=U[U.length-1].end-ne,Y=J[0].start,te=J[J.length-1].end-Y;return Q===te?0:te<Q?1:-1}function F(U,J,ne,ee){const Q=ee.getItemLabel(U)||"",Y=ee.getItemLabel(J)||"",ce=ee.getItemDescription(U),te=ee.getItemDescription(J),fe=Q.length+(ce?ce.length:0),re=Y.length+(te?te.length:0);if(fe!==re)return fe-re;const K=ee.getItemPath(U),B=ee.getItemPath(J);return K&&B&&K.length!==B.length?K.length-B.length:Q!==Y?(0,D.$Wq)(Q,Y,ne.normalized):ce&&te&&ce!==te?(0,D.$Wq)(ce,te,ne.normalized):K&&B&&K!==B?(0,D.$Wq)(K,B,ne.normalized):0}function z(U){return U.startsWith('"')&&U.endsWith('"')}const j=" ";function O(U){typeof U!="string"&&(U="");const J=U.toLowerCase(),{pathNormalized:ne,normalized:ee,normalizedLowercase:Q}=M(U),Y=ne.indexOf(P.sep)>=0,ce=z(U);let te;const fe=U.split(j);if(fe.length>1)for(const re of fe){const K=z(re),{pathNormalized:B,normalized:ae,normalizedLowercase:Ee}=M(re);ae&&(te||(te=[]),te.push({original:re,originalLowercase:re.toLowerCase(),pathNormalized:B,normalized:ae,normalizedLowercase:Ee,expectContiguousMatch:K}))}return{original:U,originalLowercase:J,pathNormalized:ne,normalized:ee,normalizedLowercase:Q,values:te,containsPathSeparator:Y,expectContiguousMatch:ce}}e.$3q=O;function M(U){let J;A.$i?J=U.replace(/\//g,P.sep):J=U.replace(/\\/g,P.sep);const ne=(0,v.$Xe)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:ne,normalizedLowercase:ne.toLowerCase()}}function T(U){return Array.isArray(U)?O(U.map(J=>J.original).join(j)):O(U.original)}e.$4q=T}),define(Ce[100],Ie([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=e.$ks=e.$js=e.$is=void 0,e.$is=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const C=(0,D.$oc)(R),b=N[C.toLowerCase()];return b!==void 0?b:A(R)}e.$js=P;function A(R){const C=(0,D.$oc)(R);return f[C.toLowerCase()]}e.$ks=A;function v(R){for(const C in f)if(f[C]===R)return C}e.$ls=v;const $=/^(.+)\/(.+?)(;.+)?$/;function k(R,C){const b=$.exec(R);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:C?void 0:R}e.$ms=k}),define(Ce[101],Ie([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=e.$Ul=e.TerminateResponseCode=e.Source=void 0;var N;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(N||(e.Source=N={}));var f;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function P(v,...$){const k=$.reduce((b,E)=>(b[E]=!0,b),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(b=>!k[b]).forEach(b=>{for(let E=0;E<R.length;E++)if(b.search(R[E])!==-1){delete v[b];break}})}e.$Ul=P;function A(v){v&&(delete v.DEBUG,D.$j&&delete v.DYLD_LIBRARY_PATH,D.$k&&delete v.LD_PRELOAD)}e.$Vl=A}),define(Ce[2],Ie([1,0,17,11]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function v(d,l){if(!d.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!f.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!P.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(d,l){return!d&&!l?"file":d}function k(d,l){switch(d){case"https":case"http":case"file":l?l[0]!==C&&(l=C+l):l=C;break}return l}const R="",C="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(l){return l instanceof E?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,c,p,I,w,g=!1){typeof l=="object"?(this.scheme=l.scheme||R,this.authority=l.authority||R,this.path=l.path||R,this.query=l.query||R,this.fragment=l.fragment||R):(this.scheme=$(l,g),this.authority=c||R,this.path=k(this.scheme,p||R),this.query=I||R,this.fragment=w||R,v(this,g))}get fsPath(){return n(this,!1)}with(l){if(!l)return this;let{scheme:c,authority:p,path:I,query:w,fragment:g}=l;return c===void 0?c=this.scheme:c===null&&(c=R),p===void 0?p=this.authority:p===null&&(p=R),I===void 0?I=this.path:I===null&&(I=R),w===void 0?w=this.query:w===null&&(w=R),g===void 0?g=this.fragment:g===null&&(g=R),c===this.scheme&&p===this.authority&&I===this.path&&w===this.query&&g===this.fragment?this:new m(c,p,I,w,g)}static parse(l,c=!1){const p=b.exec(l);return p?new m(p[2]||R,s(p[4]||R),s(p[5]||R),s(p[7]||R),s(p[9]||R),c):new m(R,R,R,R,R)}static file(l){let c=R;if(N.$i&&(l=l.replace(/\\/g,C)),l[0]===C&&l[1]===C){const p=l.indexOf(C,2);p===-1?(c=l.substring(2),l=C):(c=l.substring(2,p),l=l.substring(p)||C)}return new m("file",c,l,R,R)}static from(l,c){return new m(l.scheme,l.authority,l.path,l.query,l.fragment,c)}static joinPath(l,...c){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return N.$i&&l.scheme==="file"?p=E.file(D.$fc.join(n(l,!0),...c)).path:p=D.$gc.join(l.path,...c),l.with({path:p})}toString(l=!1){return o(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof E)return l;{const c=new m(l);return c._formatted=l.external??null,c._fsPath=l._sep===u?l.fsPath??null:null,c}}else return l}}e.URI=E;function S(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}e.$vc=S;const u=N.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(l=!1){return l?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=u),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(d,l,c){let p,I=-1;for(let w=0;w<d.length;w++){const g=d.charCodeAt(w);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||l&&g===47||c&&g===91||c&&g===93||c&&g===58)I!==-1&&(p+=encodeURIComponent(d.substring(I,w)),I=-1),p!==void 0&&(p+=d.charAt(w));else{p===void 0&&(p=d.substr(0,w));const y=a[g];y!==void 0?(I!==-1&&(p+=encodeURIComponent(d.substring(I,w)),I=-1),p+=y):I===-1&&(I=w)}}return I!==-1&&(p+=encodeURIComponent(d.substring(I))),p!==void 0?p:d}function r(d){let l;for(let c=0;c<d.length;c++){const p=d.charCodeAt(c);p===35||p===63?(l===void 0&&(l=d.substr(0,c)),l+=a[p]):l!==void 0&&(l+=d[c])}return l!==void 0?l:d}function n(d,l){let c;return d.authority&&d.path.length>1&&d.scheme==="file"?c=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?l?c=d.path.substr(1):c=d.path[1].toLowerCase()+d.path.substr(2):c=d.path,N.$i&&(c=c.replace(/\//g,"\\")),c}e.$wc=n;function o(d,l){const c=l?r:i;let p="",{scheme:I,authority:w,path:g,query:y,fragment:L}=d;if(I&&(p+=I,p+=":"),(w||I==="file")&&(p+=C,p+=C),w){let F=w.indexOf("@");if(F!==-1){const z=w.substr(0,F);w=w.substr(F+1),F=z.lastIndexOf(":"),F===-1?p+=c(z,!1,!1):(p+=c(z.substr(0,F),!1,!1),p+=":",p+=c(z.substr(F+1),!1,!0)),p+="@"}w=w.toLowerCase(),F=w.lastIndexOf(":"),F===-1?p+=c(w,!1,!0):(p+=c(w.substr(0,F),!1,!0),p+=w.substr(F))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const F=g.charCodeAt(1);F>=65&&F<=90&&(g=`/${String.fromCharCode(F+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const F=g.charCodeAt(0);F>=65&&F<=90&&(g=`${String.fromCharCode(F+32)}:${g.substr(2)}`)}p+=c(g,!0,!1)}return y&&(p+="?",p+=c(y,!1,!1)),L&&(p+="#",p+=l?L:i(L,!1,!1)),p}function t(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+t(d.substr(3)):d}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(h)?d.replace(h,l=>t(l)):d}}),define(Ce[186],Ie([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$rq=e.$qq=e.$pq=void 0;function N(k){const R=k;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$pq=N;function f(k){const R=[];let C;try{const b=JSON.parse(k.arguments),E=b[b.length-1];E&&E.__$stack&&(b.pop(),C=E.__$stack),R.push(...b)}catch{R.push("Unable to log remote console arguments",k.arguments)}return{args:R,stack:C}}e.$qq=f;function P(k){if(typeof k!="string")return P(f(k).stack);const R=k;if(R){const C=A(R),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(b&&b.length===4)return{uri:D.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$rq=P;function A(k){if(!k)return k;const R=k.indexOf(`
`);return R===-1?k:k.substring(0,R)}function v(k,R){const{args:C,stack:b}=f(k),E=typeof C[0]=="string"&&C.length===1;let S=A(b);S&&(S=`(${S.trim()})`);let u=[];if(typeof C[0]=="string"?S&&E?u=[`%c[${R}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:u=[`%c[${R}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:u=[`%c[${R}]%`,$("blue"),...C],S&&!E&&u.push(S),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,u)}e.log=v;function $(k){return`color: ${k}`}}),define(Ce[56],Ie([1,0,21,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=void 0;function f($){return JSON.stringify($,A)}e.$Dh=f;function P($){let k=JSON.parse($);return k=v(k),k}e.$Eh=P;function A($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function v($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ke||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let R=0;R<$.length;++R)$[R]=v($[R],k+1);else for(const R in $)Object.hasOwnProperty.call($,R)&&($[R]=v($[R],k+1))}return $}e.$Fh=v}),define(Ce[15],Ie([1,0,14,11,12,2]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.Schemas=void 0;var A;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function v(b,E){return P.URI.isUri(b)?(0,f.$bf)(b.scheme,E):(0,f.$cf)(b,E+":")}e.$gg=v;function $(b,...E){return E.some(S=>v(b,S))}e.$hg=$,e.$ig="vscode-tkn",e.$jg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${A.vscodeRemoteResource}`}set(E,S,u){this.a[E]=S,this.b[E]=u}setConnectionToken(E,S){this.c[E]=S}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(r){return D.$1(r),E}const S=E.authority;let u=this.a[S];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const m=this.b[S],a=this.c[S];let i=`path=${encodeURIComponent(E.path)}`;return typeof a=="string"&&(i+=`&${e.$jg}=${encodeURIComponent(a)}`),P.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${u}:${m}`,path:this.f,query:i})}}e.$kg=new k,e.$lg="vs/../../extensions",e.$mg="vs/../../node_modules",e.$ng="vs/../../node_modules.asar",e.$og="vs/../../node_modules.asar.unpacked",e.$pg="vscode-app";class R{static{this.a=e.$pg}asBrowserUri(E){const S=this.b(E,me);return this.uriToBrowserUri(S)}uriToBrowserUri(E){return E.scheme===A.vscodeRemote?e.$kg.rewrite(E):E.scheme===A.file&&(N.$m||N.$q===`${A.vscodeFileResource}://${R.a}`)?E.with({scheme:A.vscodeFileResource,authority:E.authority||R.a,query:null,fragment:null}):E}asFileUri(E){const S=this.b(E,me);return this.uriToFileUri(S)}uriToFileUri(E){return E.scheme===A.vscodeFileResource?E.with({scheme:A.file,authority:E.authority!==R.a?E.authority:null,query:null,fragment:null}):E}b(E,S){return P.URI.isUri(E)?E:P.URI.parse(S.toUrl(E))}}e.$qg=new R;var C;(function(b){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(E.get("3"));const S="vscode-coi";function u(a){let i;typeof a=="string"?i=new URL(a).searchParams:a instanceof URL?i=a.searchParams:P.URI.isUri(a)&&(i=new URL(a.toString(!0)).searchParams);const r=i?.get(S);if(r)return E.get(r)}b.getHeadersFromQuery=u;function m(a,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";a instanceof URLSearchParams?a.set(S,n):a[S]=n}b.addSearchParam=m})(C||(e.COI=C={}))}),define(Ce[187],Ie([1,0,158,15,11,2]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=void 0;class A{constructor(b,E,S){this.id=b,this.dependencies=E,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,E,S)=>{typeof b!="string"&&(S=E,E=b,b=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new A(b,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const E=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!E)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(b){return new Promise((E,S)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const m=()=>{u.removeEventListener("load",a),u.removeEventListener("error",i)},a=r=>{m(),E(this.c.pop())},i=r=>{m(),S(r)};u.addEventListener("load",a),u.addEventListener("error",i),this.f&&(b=this.f.createScriptURL(b)),u.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(b){return new Promise((E,S)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),E(this.c.pop())}catch(u){S(u)}})}async j(b){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(b).fsPath,a=E.readFileSync(m).toString(),i=u.wrap(a.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function R(C,b,E){if(D.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[C]&&(C=k[C]);const S=`${C}/${b}`;if($.has(S))return $.get(S);let u;if(/^\w[\w\d+.-]*:\/\//.test(S))u=S;else{const r=`${E&&!f.$o?N.$ng:N.$mg}/${S}`;u=N.$qg.asBrowserUri(r).toString(!0)}const m=v.INSTANCE.load(u);return $.set(S,m),m}else return await new Promise((S,u)=>{me([C],S,u)})}e.$kD=R}),define(Ce[23],Ie([1,0,34,15,17,11,12,2]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.DataUri=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=void 0;function $(E){return(0,v.$wc)(E,!0)}e.$xg=$;class k{constructor(S){this.a=S}compare(S,u,m=!1){return S===u?0:(0,A.$7e)(this.getComparisonKey(S,m),this.getComparisonKey(u,m))}isEqual(S,u,m=!1){return S===u?!0:!S||!u?!1:this.getComparisonKey(S,m)===this.getComparisonKey(u,m)}getComparisonKey(S,u=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,u,m=!1){if(S.scheme===u.scheme){if(S.scheme===N.Schemas.file)return D.$0f($(S),$(u),this.a(S))&&S.query===u.query&&(m||S.fragment===u.fragment);if((0,e.$Og)(S.authority,u.authority))return D.$0f(S.path,u.path,this.a(S),"/")&&S.query===u.query&&(m||S.fragment===u.fragment)}return!1}joinPath(S,...u){return v.URI.joinPath(S,...u)}basenameOrAuthority(S){return(0,e.$Gg)(S)||S.authority}basename(S){return f.$gc.basename(S.path)}extname(S){return f.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let u;return S.scheme===N.Schemas.file?u=v.URI.file(f.$mc($(S))).path:(u=f.$gc.dirname(S.path),S.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),u="/")),S.with({path:u})}normalizePath(S){if(!S.path.length)return S;let u;return S.scheme===N.Schemas.file?u=v.URI.file(f.$hc($(S))).path:u=f.$gc.normalize(S.path),S.with({path:u})}relativePath(S,u){if(S.scheme!==u.scheme||!(0,e.$Og)(S.authority,u.authority))return;if(S.scheme===N.Schemas.file){const i=f.$lc($(S),$(u));return P.$i?D.$4f(i):i}let m=S.path||"/";const a=u.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(m.length,a.length);i<r&&!(m.charCodeAt(i)!==a.charCodeAt(i)&&m.charAt(i).toLowerCase()!==a.charAt(i).toLowerCase());i++);m=a.substr(0,i)+m.substr(i)}return f.$gc.relative(m,a)}resolvePath(S,u){if(S.scheme===N.Schemas.file){const m=v.URI.file(f.$kc($(S),u));return S.with({authority:m.authority,path:m.path})}return u=D.$5f(u),S.with({path:f.$gc.resolve(S.path,u)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,u){return S===u||S!==void 0&&u!==void 0&&(0,A.$bf)(S,u)}hasTrailingPathSeparator(S,u=f.sep){if(S.scheme===N.Schemas.file){const m=$(S);return m.length>D.$6f(m).length&&m[m.length-1]===u}else{const m=S.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,u=f.sep){return(0,e.$Pg)(S,u)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,u=f.sep){let m=!1;if(S.scheme===N.Schemas.file){const a=$(S);m=a!==void 0&&a.length===D.$6f(a).length&&a[a.length-1]===u}else{u="/";const a=S.path;m=a.length===1&&a.charCodeAt(a.length-1)===47}return!m&&!(0,e.$Pg)(S,u)?S.with({path:S.path+"/"}):S}}e.$yg=k,e.$zg=new k(()=>!1),e.$Ag=new k(E=>E.scheme===N.Schemas.file?!P.$k:!0),e.$Bg=new k(E=>!0),e.$Cg=e.$zg.isEqual.bind(e.$zg),e.$Dg=e.$zg.isEqualOrParent.bind(e.$zg),e.$Eg=e.$zg.getComparisonKey.bind(e.$zg),e.$Fg=e.$zg.basenameOrAuthority.bind(e.$zg),e.$Gg=e.$zg.basename.bind(e.$zg),e.$Hg=e.$zg.extname.bind(e.$zg),e.$Ig=e.$zg.dirname.bind(e.$zg),e.$Jg=e.$zg.joinPath.bind(e.$zg),e.$Kg=e.$zg.normalizePath.bind(e.$zg),e.$Lg=e.$zg.relativePath.bind(e.$zg),e.$Mg=e.$zg.resolvePath.bind(e.$zg),e.$Ng=e.$zg.isAbsolutePath.bind(e.$zg),e.$Og=e.$zg.isEqualAuthority.bind(e.$zg),e.$Pg=e.$zg.hasTrailingPathSeparator.bind(e.$zg),e.$Qg=e.$zg.removeTrailingPathSeparator.bind(e.$zg),e.$Rg=e.$zg.addTrailingPathSeparator.bind(e.$zg);function R(E,S){const u=[];for(let m=0;m<E.length;m++){const a=S(E[m]);E.some((i,r)=>r===m?!1:(0,e.$Dg)(a,S(i)))||u.push(E[m])}return u}e.$Sg=R;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(u){const m=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,o]=r.split(":");n&&o&&m.set(n,o)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&m.set(E.META_DATA_MIME,i),m}E.parseMetaData=S})(C||(e.DataUri=C={}));function b(E,S,u){if(S){let m=E.path;return m&&m[0]!==f.$gc.sep&&(m=f.$gc.sep+m),E.with({scheme:u,authority:S,path:m})}return E.with({scheme:u})}e.$Tg=b}),define(Ce[8],Ie([1,0,22,14,4,3,23,11,164,43]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.Promises=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=void 0;function R(ge){return!!ge&&typeof ge.then=="function"}e.$Ug=R;function C(ge){const V=new D.$7d,Z=ge(V.token),he=new Promise((be,Pe)=>{const pe=V.token.onCancellationRequested(()=>{pe.dispose(),Pe(new N.$5)});Promise.resolve(Z).then(Le=>{pe.dispose(),V.dispose(),be(Le)},Le=>{pe.dispose(),V.dispose(),Pe(Le)})});return new class{cancel(){V.cancel(),V.dispose()}then(be,Pe){return he.then(be,Pe)}catch(be){return this.then(void 0,be)}finally(be){return he.finally(be)}}}e.$Vg=C;function b(ge,V,Z){return new Promise((he,be)=>{const Pe=V.onCancellationRequested(()=>{Pe.dispose(),he(Z)});ge.then(he,be).finally(()=>Pe.dispose())})}e.$Wg=b;function E(ge,V){return new Promise((Z,he)=>{const be=V.onCancellationRequested(()=>{be.dispose(),he(new N.$5)});ge.then(Z,he).finally(()=>be.dispose())})}e.$Xg=E;async function S(ge){let V=-1;const Z=ge.map((he,be)=>he.then(Pe=>(V=be,Pe)));try{return await Promise.race(Z)}finally{ge.forEach((he,be)=>{be!==V&&he.cancel()})}}e.$Yg=S;function u(ge,V,Z){let he;const be=setTimeout(()=>{he?.(void 0),Z?.()},V);return Promise.race([ge.finally(()=>clearTimeout(be)),new Promise(Pe=>he=Pe)])}e.$Zg=u;function m(ge){return new Promise((V,Z)=>{const he=ge();R(he)?he.then(V,Z):V(he)})}e.$1g=m;function a(){let ge,V;return{promise:new Promise((he,be)=>{ge=he,V=be}),resolve:ge,reject:V}}e.$2g=a;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const Z=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Z,Z).then(he)})}return new Promise((Z,he)=>{this.b.then(Z,he)})}return this.a=V(),new Promise((Z,he)=>{this.a.then(be=>{this.a=null,Z(be)},be=>{this.a=null,he(be)})})}dispose(){this.f=!0}}e.$3g=i;class r{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$4g=r;class n{constructor(){this.a=new Map}queue(V,Z){const be=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(V)===be&&this.a.delete(V)});return this.a.set(V,be),be}}e.$5g=n;const o=(ge,V)=>{let Z=!0;const he=setTimeout(()=>{Z=!1,V()},ge);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(he),Z=!1}}},t=ge=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,ge())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class h{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,Z=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((be,Pe)=>{this.d=be,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Z===$.$Td?t(he):o(Z,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$6g=h;class s{constructor(V){this.a=new h(V),this.b=new i}trigger(V,Z){return this.a.trigger(()=>this.b.queue(V),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$7g=s;class d{constructor(){this.a=!1,this.b=new Promise((V,Z)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$8g=d;class l extends d{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$9g=l;function c(ge,V){return V?new Promise((Z,he)=>{const be=setTimeout(()=>{Pe.dispose(),Z()},ge),Pe=V.onCancellationRequested(()=>{clearTimeout(be),Pe.dispose(),he(new N.$5)})}):C(Z=>c(ge,Z))}e.$0g=c;function p(ge,V=0,Z){const he=setTimeout(()=>{ge(),Z&&be.dispose()},V),be=(0,P.$Rc)(()=>{clearTimeout(he),Z?.deleteAndLeak(be)});return Z?.add(be),be}e.$$g=p;function I(ge){const V=[];let Z=0;const he=ge.length;function be(){return Z<he?ge[Z++]():null}function Pe(pe){pe!=null&&V.push(pe);const Le=be();return Le?Le.then(Pe):Promise.resolve(V)}return Promise.resolve(null).then(Pe)}e.$_g=I;function w(ge,V=he=>!!he,Z=null){let he=0;const be=ge.length,Pe=()=>{if(he>=be)return Promise.resolve(Z);const pe=ge[he++];return Promise.resolve(pe()).then(Ne=>V(Ne)?Promise.resolve(Ne):Pe())};return Pe()}e.$ah=w;function g(ge,V=he=>!!he,Z=null){if(ge.length===0)return Promise.resolve(Z);let he=ge.length;const be=()=>{he=-1;for(const Pe of ge)Pe.cancel?.()};return new Promise((Pe,pe)=>{for(const Le of ge)Le.then(Ne=>{--he>=0&&V(Ne)?(be(),Pe(Ne)):he===0&&Pe(Z)}).catch(Ne=>{--he>=0&&(be(),pe(Ne))})})}e.$bh=g;class y{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new f.$Wd}whenIdle(){return this.size>0?f.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,he)=>{this.g.push({factory:V,c:Z,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const Z=V.factory();Z.then(V.c,V.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ch=y;class L extends y{constructor(){super(1)}}e.$dh=L;class F{constructor(){this.a=new Y,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$eh=F;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new fe;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,Z=A.$zg){const he=Z.getComparisonKey(V);return this.a.get(he)?.size??0}queueFor(V,Z,he=A.$zg){const be=he.getComparisonKey(V);let Pe=this.a.get(be);if(!Pe){Pe=new L;const pe=this.f++,Le=f.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(pe,Le),this.a.set(be,Pe)}return Pe.queue(Z)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$fh=z;class j{constructor(V,Z){this.a=-1,typeof V=="function"&&typeof Z=="number"&&this.setIfNotSet(V,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},Z)}setIfNotSet(V,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},Z))}}e.$gh=j;class O{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,Z,he=globalThis){this.cancel();const be=he.setInterval(()=>{V()},Z);this.d=(0,P.$Rc)(()=>{he.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$hh=O;class M{constructor(V,Z){this.b=-1,this.a=V,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ih=M;class T{constructor(V,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=V,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$jh=T;class U extends M{constructor(V,Z){super(V,Z),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$kh=U;class J extends P.$Tc{constructor(V,Z){super(),this.g=V,this.h=Z,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of V)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$lh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$nh=(ge,V)=>{(0,v.$B)(()=>{if(Z)return;const he=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$nh=(ge,V,Z)=>{const he=ge.requestIdleCallback(V,typeof Z=="number"?{timeout:Z}:void 0);let be=!1;return{dispose(){be||(be=!0,ge.cancelIdleCallback(he))}}},e.$mh=ge=>(0,e.$nh)(globalThis,ge)}();class ne{constructor(V,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$nh)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$oh=ne;class ee extends ne{constructor(V){super(globalThis,V)}}e.$ph=ee;async function Q(ge,V,Z){let he;for(let be=0;be<Z;be++)try{return await ge()}catch(Pe){he=Pe,await c(V)}throw he}e.$qh=Q;class Y{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,Z,he){return this.a={taskId:V,cancel:()=>he?.(),promise:Z},Z.then(()=>this.d(V),()=>this.d(V)),Z}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:Z,resolve:he,reject:be}=a();this.b={run:V,promise:Z,promiseResolve:he,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$rh=Y;class ce{constructor(V,Z=()=>Date.now()){this.d=V,this.f=Z,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$sh=ce;var te;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(te||(te={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,Z)=>{this.a=V,this.b=Z})}complete(V){return new Promise(Z=>{this.a(V),this.d={outcome:0,value:V},Z()})}error(V){return new Promise(Z=>{this.b(V),this.d={outcome:1,value:V},Z()})}cancel(){return this.error(new N.$5)}}e.$th=fe;var re;(function(ge){async function V(he){let be;const Pe=await Promise.all(he.map(pe=>pe.then(Le=>Le,Le=>{be||(be=Le)})));if(typeof be<"u")throw be;return Pe}ge.settled=V;function Z(he){return new Promise(async(be,Pe)=>{try{await he(be,Pe)}catch(pe){Pe(pe)}})}ge.withAsyncBody=Z})(re||(e.Promises=re={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$uh=K;class B{constructor(V){this.b=V,this.a=new k.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$vh=B;var ae;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ae||(ae={}));class Ee{static fromArray(V){return new Ee(Z=>{Z.emitMany(V)})}static fromPromise(V){return new Ee(async Z=>{Z.emitMany(await V)})}static fromPromises(V){return new Ee(async Z=>{await Promise.all(V.map(async he=>Z.emitOne(await he)))})}static merge(V){return new Ee(async Z=>{await Promise.all(V.map(async he=>{for await(const be of he)Z.emitOne(be)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new f.$Wd,queueMicrotask(async()=>{const Z={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(V(Z)),this.j()}catch(he){this.k(he)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(V,Z){return new Ee(async he=>{for await(const be of V)he.emitOne(Z(be))})}map(V){return Ee.map(this,V)}static filter(V,Z){return new Ee(async he=>{for await(const be of V)Z(be)&&he.emitOne(be)})}filter(V){return Ee.filter(this,V)}static coalesce(V){return Ee.filter(V,Z=>!!Z)}coalesce(){return Ee.coalesce(this)}static async toPromise(V){const Z=[];for await(const he of V)Z.push(he);return Z}toPromise(){return Ee.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$wh=Ee;class le extends Ee{constructor(V,Z){super(Z),this.l=V}cancel(){this.l.cancel()}}e.$xh=le;function de(ge){const V=new D.$7d,Z=ge(V.token);return new le(V,async he=>{const be=V.token.onCancellationRequested(()=>{be.dispose(),V.dispose(),he.reject(new N.$5)});try{for await(const Pe of Z){if(V.token.isCancellationRequested)return;he.emitOne(Pe)}be.dispose(),V.dispose()}catch(Pe){be.dispose(),V.dispose(),he.reject(Pe)}})}e.$yh=de;class ue{constructor(){this.a=new fe,this.b=new Ee(he=>{if(V){he.reject(V);return}return Z&&he.emitMany(Z),this.d=be=>he.reject(be),this.f=be=>he.emitOne(be),this.a.p});let V,Z;this.f=he=>{Z||(Z=[]),Z.push(he)},this.d=he=>{V||(V=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$zh=ue}),define(Ce[35],Ie([1,0,19,8,34,28,17,11,12]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=void 0;function k(){return Object.create(null)}e.$Kj=k,e.$Lj="**",e.$Mj="/";const R="[/\\\\]",C="[^/\\\\]",b=/\//g;function E(ne,ee){switch(ne){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${ee?`|${R}${C}+`:""})*?`}}function S(ne,ee){if(!ne)return[];const Q=[];let Y=!1,ce=!1,te="";for(const fe of ne){switch(fe){case ee:if(!Y&&!ce){Q.push(te),te="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=fe}return te&&Q.push(te),Q}e.$Nj=S;function u(ne){if(!ne)return"";let ee="";const Q=S(ne,e.$Mj);if(Q.every(Y=>Y===e.$Lj))ee=".*";else{let Y=!1;Q.forEach((ce,te)=>{if(ce===e.$Lj){if(Y)return;ee+=E(2,te===Q.length-1)}else{let fe=!1,re="",K=!1,B="";for(const ae of ce){if(ae!=="}"&&fe){re+=ae;continue}if(K&&(ae!=="]"||!B)){let Ee;ae==="-"?Ee=ae:(ae==="^"||ae==="!")&&!B?Ee="^":ae===e.$Mj?Ee="":Ee=(0,$.$Pe)(ae),B+=Ee;continue}switch(ae){case"{":fe=!0;continue;case"[":K=!0;continue;case"}":{const le=`(?:${S(re,",").map(de=>u(de)).join("|")})`;ee+=le,fe=!1,re="";break}case"]":{ee+="["+B+"]",K=!1,B="";break}case"?":ee+=C;continue;case"*":ee+=E(1);continue;default:ee+=(0,$.$Pe)(ae)}}te<Q.length-1&&(Q[te+1]!==e.$Lj||te+2<Q.length)&&(ee+=R)}Y=ce===e.$Lj})}return ee}const m=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),h=function(){return!1},s=function(){return null};function d(ne,ee){if(!ne)return s;let Q;typeof ne!="string"?Q=ne.pattern:Q=ne,Q=Q.trim();const Y=`${Q}_${!!ee.trimForExclusions}`;let ce=t.get(Y);if(ce)return l(ce,ne);let te;return m.test(Q)?ce=p(Q.substr(4),Q):(te=a.exec(c(Q,ee)))?ce=I(te[1],Q):(ee.trimForExclusions?r:i).test(Q)?ce=w(Q,ee):(te=n.exec(c(Q,ee)))?ce=g(te[1].substr(1),Q,!0):(te=o.exec(c(Q,ee)))?ce=g(te[1],Q,!1):ce=y(Q),t.set(Y,ce),l(ce,ne)}function l(ne,ee){if(typeof ee=="string")return ne;const Q=function(Y,ce){return(0,f.$0f)(Y,ee.base,!v.$k)?ne((0,$.$Ue)(Y.substr(ee.base.length),A.sep),ce):null};return Q.allBasenames=ne.allBasenames,Q.allPaths=ne.allPaths,Q.basenames=ne.basenames,Q.patterns=ne.patterns,Q}function c(ne,ee){return ee.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function p(ne,ee){return function(Q,Y){return typeof Q=="string"&&Q.endsWith(ne)?ee:null}}function I(ne,ee){const Q=`/${ne}`,Y=`\\${ne}`,ce=function(fe,re){return typeof fe!="string"?null:re?re===ne?ee:null:fe===ne||fe.endsWith(Q)||fe.endsWith(Y)?ee:null},te=[ne];return ce.basenames=te,ce.patterns=[ee],ce.allBasenames=te,ce}function w(ne,ee){const Q=U(ne.slice(1,-1).split(",").map(re=>d(re,ee)).filter(re=>re!==s),ne),Y=Q.length;if(!Y)return s;if(Y===1)return Q[0];const ce=function(re,K){for(let B=0,ae=Q.length;B<ae;B++)if(Q[B](re,K))return ne;return null},te=Q.find(re=>!!re.allBasenames);te&&(ce.allBasenames=te.allBasenames);const fe=Q.reduce((re,K)=>K.allPaths?re.concat(K.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function g(ne,ee,Q){const Y=A.sep===A.$gc.sep,ce=Y?ne:ne.replace(b,A.sep),te=A.sep+ce,fe=A.$gc.sep+ne;let re;return Q?re=function(K,B){return typeof K=="string"&&(K===ce||K.endsWith(te)||!Y&&(K===ne||K.endsWith(fe)))?ee:null}:re=function(K,B){return typeof K=="string"&&(K===ce||!Y&&K===ne)?ee:null},re.allPaths=[(Q?"*/":"./")+ne],re}function y(ne){try{const ee=new RegExp(`^${u(ne)}$`);return function(Q){return ee.lastIndex=0,typeof Q=="string"&&ee.test(Q)?ne:null}}catch{return s}}function L(ne,ee,Q){return!ne||typeof ee!="string"?!1:F(ne)(ee,void 0,Q)}e.$Oj=L;function F(ne,ee={}){if(!ne)return h;if(typeof ne=="string"||z(ne)){const Q=d(ne,ee);if(Q===s)return h;const Y=function(ce,te){return!!Q(ce,te)};return Q.allBasenames&&(Y.allBasenames=Q.allBasenames),Q.allPaths&&(Y.allPaths=Q.allPaths),Y}return M(ne,ee)}e.$Pj=F;function z(ne){const ee=ne;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$Qj=z;function j(ne){return ne.allBasenames||[]}e.$Rj=j;function O(ne){return ne.allPaths||[]}e.$Sj=O;function M(ne,ee){const Q=U(Object.getOwnPropertyNames(ne).map(re=>T(re,ne[re],ee)).filter(re=>re!==s)),Y=Q.length;if(!Y)return s;if(!Q.some(re=>!!re.requiresSiblings)){if(Y===1)return Q[0];const re=function(ae,Ee){let le;for(let de=0,ue=Q.length;de<ue;de++){const ge=Q[de](ae,Ee);if(typeof ge=="string")return ge;(0,N.$Ug)(ge)&&(le||(le=[]),le.push(ge))}return le?(async()=>{for(const de of le){const ue=await de;if(typeof ue=="string")return ue}return null})():null},K=Q.find(ae=>!!ae.allBasenames);K&&(re.allBasenames=K.allBasenames);const B=Q.reduce((ae,Ee)=>Ee.allPaths?ae.concat(Ee.allPaths):ae,[]);return B.length&&(re.allPaths=B),re}const ce=function(re,K,B){let ae,Ee;for(let le=0,de=Q.length;le<de;le++){const ue=Q[le];ue.requiresSiblings&&B&&(K||(K=(0,A.$nc)(re)),ae||(ae=K.substr(0,K.length-(0,A.$oc)(re).length)));const ge=ue(re,K,ae,B);if(typeof ge=="string")return ge;(0,N.$Ug)(ge)&&(Ee||(Ee=[]),Ee.push(ge))}return Ee?(async()=>{for(const le of Ee){const de=await le;if(typeof de=="string")return de}return null})():null},te=Q.find(re=>!!re.allBasenames);te&&(ce.allBasenames=te.allBasenames);const fe=Q.reduce((re,K)=>K.allPaths?re.concat(K.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function T(ne,ee,Q){if(ee===!1)return s;const Y=d(ne,Q);if(Y===s)return s;if(typeof ee=="boolean")return Y;if(ee){const ce=ee.when;if(typeof ce=="string"){const te=(fe,re,K,B)=>{if(!B||!Y(fe,re))return null;const ae=ce.replace("$(basename)",()=>K),Ee=B(ae);return(0,N.$Ug)(Ee)?Ee.then(le=>le?ne:null):Ee?ne:null};return te.requiresSiblings=!0,te}}return Y}function U(ne,ee){const Q=ne.filter(re=>!!re.basenames);if(Q.length<2)return ne;const Y=Q.reduce((re,K)=>{const B=K.basenames;return B?re.concat(B):re},[]);let ce;if(ee){ce=[];for(let re=0,K=Y.length;re<K;re++)ce.push(ee)}else ce=Q.reduce((re,K)=>{const B=K.patterns;return B?re.concat(B):re},[]);const te=function(re,K){if(typeof re!="string")return null;if(!K){let ae;for(ae=re.length;ae>0;ae--){const Ee=re.charCodeAt(ae-1);if(Ee===47||Ee===92)break}K=re.substr(ae)}const B=Y.indexOf(K);return B!==-1?ce[B]:null};te.basenames=Y,te.patterns=ce,te.allBasenames=Y;const fe=ne.filter(re=>!re.basenames);return fe.push(te),fe}function J(ne,ee){return(0,D.$ub)(ne,ee,(Q,Y)=>typeof Q=="string"&&typeof Y=="string"?Q===Y:typeof Q!="string"&&typeof Y!="string"?Q.base===Y.base&&Q.pattern===Y.pattern:!1)}e.$Tj=J}),define(Ce[63],Ie([1,0,14,165,23,12,2]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,D.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=b(this.supportThemeIcons?(0,N.$ek)(i):i).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${E(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,P.$Pe)(r),"g");return i.replace(n,(o,t)=>i.charAt(t-1)!=="\\"?`\\${o}`:o)}}e.$kk=$;function k(a){return R(a)?!a.value:Array.isArray(a)?a.every(k):!0}e.$lk=k;function R(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.$mk=R;function C(a,i){return a===i?!0:!a||!i?!1:a.value===i.value&&a.isTrusted===i.isTrusted&&a.supportThemeIcons===i.supportThemeIcons&&a.supportHtml===i.supportHtml&&(a.baseUri===i.baseUri||!!a.baseUri&&!!i.baseUri&&(0,f.$Cg)(A.URI.from(a.baseUri),A.URI.from(i.baseUri)))}e.$nk=C;function b(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ok=b;function E(a,i){const r=a.match(/^`+/gm)?.reduce((o,t)=>o.length>t.length?o:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,a,`${"`".repeat(n)}`].join(`
`)}e.$pk=E;function S(a){return a.replace(/"/g,"&quot;")}e.$qk=S;function u(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$rk=u;function m(a){const i=[],r=a.split("|").map(o=>o.trim());a=r[0];const n=r[1];if(n){const o=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),h=o?o[1]:"",s=t?t[1]:"",d=isFinite(parseInt(s)),l=isFinite(parseInt(h));d&&i.push(`width="${s}"`),l&&i.push(`height="${h}"`)}return{href:a,dimensions:i}}e.$sk=m}),define(Ce[102],Ie([1,0,19,34,17,11,23,12]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=void 0;function $(d,l){const{os:c,tildify:p,relative:I}=l;if(I){const y=k(d,I,c);if(typeof y=="string")return y}let w=d.fsPath;if(c===1&&!P.$i?w=w.replace(/\//g,"\\"):c!==1&&P.$i&&(w=w.replace(/\\/g,"/")),c!==1&&p?.userHome){const y=p.userHome.fsPath;let L;d.scheme!==p.userHome.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep?L=p.userHome.with({path:d.path}).fsPath:L=w,w=b(L,y,c)}return(c===1?f.$fc:f.$gc).normalize(R(w,c===1))}e.$Yv=$;function k(d,l,c){const p=c===1?f.$fc:f.$gc,I=c===3?A.$zg:A.$Bg,w=l.getWorkspace(),g=(0,D.$Ob)(w.folders);if(!g)return;d.scheme!==g.uri.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep&&(d=g.uri.with({path:d.path}));const y=l.getWorkspaceFolder(d);if(!y)return;let L;if(I.isEqual(y.uri,d)?L="":L=I.relativePath(y.uri,d)??"",L&&(L=p.normalize(L)),w.folders.length>1&&!l.noPrefix){const F=y.name?y.name:I.basenameOrAuthority(y.uri);L=L?`${F} \u2022 ${L}`:F}return L}function R(d,l=P.$i){return(0,N.$bg)(d,l)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Zv=R;let C=Object.create(null);function b(d,l,c=P.OS){if(c===1||!d||!l)return d;let p=C.original===l?C.normalized:void 0;p||(p=l,P.$i&&(p=(0,N.$4f)(p)),p=`${(0,v.$Ve)(p,f.$gc.sep)}${f.$gc.sep}`,C={original:l,normalized:p});let I=d;return P.$i&&(I=(0,N.$4f)(I)),(c===3?I.startsWith(p):(0,v.$cf)(I,p))?`~/${I.substr(p.length)}`:d}e.$1v=b;function E(d,l){return d.replace(/^~($|\/|\\)/,`${l}$1`)}e.$2v=E;const S="\u2026",u="\\\\",m="~";function a(d,l=f.sep){const c=new Array(d.length);let p=!1;for(let I=0;I<d.length;I++){const w=d[I];if(w===""){c[I]=`.${l}`;continue}if(!w){c[I]=w;continue}p=!0;let g="",y=w;y.indexOf(u)===0?(g=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(l)===0?(g=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(m)===0&&(g=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const L=y.split(l);for(let F=1;p&&F<=L.length;F++)for(let z=L.length-F;p&&z>=0;z--){p=!1;let j=L.slice(z,z+F).join(l);for(let O=0;!p&&O<d.length;O++)if(O!==I&&d[O]&&d[O].indexOf(j)>-1){const M=z+F===L.length,T=z>0&&d[O].indexOf(l)>-1?l+j:j,U=d[O].endsWith(T);p=!M||U}if(!p){let O="";(L[0].endsWith(":")||g!=="")&&(z===1&&(z=0,F++,j=L[0]+l+j),z>0&&(O=L[0]+l),O=g+O),z>0&&(O=O+S+l),O=O+j,z+F<L.length&&(O=O+l+S),c[I]=O}}p&&(c[I]=w)}return c}e.$3v=a;var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(d,l=Object.create(null)){const c=[];let p=!1,I="";for(const w of d)if(w==="$"||p&&w==="{")I&&c.push({value:I,type:i.TEXT}),I="",p=!0;else if(w==="}"&&p){const g=l[I];if(typeof g=="string")g.length&&c.push({value:g,type:i.VARIABLE});else if(g){const y=c[c.length-1];(!y||y.type!==i.SEPARATOR)&&c.push({value:g.label,type:i.SEPARATOR})}I="",p=!1}else I+=w;return I&&!p&&c.push({value:I,type:i.TEXT}),c.filter((w,g)=>{if(w.type===i.SEPARATOR){const y=c[g-1],L=c[g+1];return[y,L].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(w=>w.value).join("")}e.$4v=r;function n(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):d.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$5v=n;function o(d,l){return P.$j||l?d.replace(/\(&&\w\)|&&/g,""):P.$i?d.replace(/&&|&/g,c=>c==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$6v=o;function t(d){return d.replace(/&/g,"&&")}e.$7v=t;function h(d){if(d.endsWith("]")){const l=d.lastIndexOf(" [",d.length-2);if(l!==-1){const c=s(d.substring(0,l)),p=d.substring(l);return{name:c.name+p,parentPath:c.parentPath}}}return s(d)}e.$8v=h;function s(d){const l=d.indexOf("/")!==-1?f.$gc:f.$fc,c=l.basename(d),p=l.dirname(d);return c.length?{name:c,parentPath:p}:{name:p,parentPath:""}}}),define(Ce[130],Ie([1,0,21,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=void 0;function f(C){return C.toJSON()}class P{constructor(b){this.a=b}transformIncoming(b){const E=this.a.transformIncoming(b);return E===b?b:f(N.URI.from(E))}transformOutgoing(b){const E=this.a.transformOutgoing(b);return E===b?b:f(N.URI.from(E))}transformOutgoingURI(b){const E=this.a.transformOutgoing(b);return E===b?b:N.URI.from(E)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$8m=P,e.$9m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,b,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return b.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const u=A(C[S],b,E+1);u!==null&&(C[S]=u)}}return null}function v(C,b){const E=A(C,b,0);return E===null?C:E}e.$0m=v;function $(C,b,E,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?N.URI.revive(b.transformIncoming(C)):b.transformIncoming(C);if(C instanceof D.$ke)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const m=$(C[u],b,E,S+1);m!==null&&(C[u]=m)}}return null}function k(C,b){const E=$(C,b,!1,0);return E===null?C:E}e.$$m=k;function R(C,b){const E=$(C,b,!0,0);return E===null?C:E}e.$_m=R}),define(Ce[31],Ie([1,0,57,64,388,8,34,77,17,11,23,2]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function E(T,U=b.UNLINK,J){if((0,A.$ag)(T))throw new Error("rimraf - will refuse to recursively delete root");return U===b.UNLINK?u(T):S(T,J)}async function S(T,U=(0,A.$fg)((0,N.tmpdir)())){try{try{await D.promises.rename(T,U)}catch(J){return J.code==="ENOENT"?void 0:u(T)}u(U).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function u(T){return(0,f.promisify)(D.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,A.$ag)(T))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function a(T,U){return n(await(U?i(T):(0,f.promisify)(D.readdir)(T)))}async function i(T){try{return await(0,f.promisify)(D.readdir)(T,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const U=[],J=await a(T);for(const ne of J){let ee=!1,Q=!1,Y=!1;try{const ce=await e.Promises.lstat((0,$.$jc)(T,ne));ee=ce.isFile(),Q=ce.isDirectory(),Y=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}U.push({name:ne,isFile:()=>ee,isDirectory:()=>Q,isSymbolicLink:()=>Y})}return U}function r(T){return n(D.readdirSync(T))}e.readdirSync=r;function n(T){return T.map(U=>typeof U=="string"?k.$j?(0,v.$Jl)(U):U:(U.name=k.$j?(0,v.$Jl)(U.name):U.name,U))}async function o(T){const U=await a(T),J=[];for(const ne of U)await h.existsDirectory((0,$.$jc)(T,ne))&&J.push(ne);return J}function t(T,U=1e3){return new Promise(J=>{let ne=!1;const ee=setInterval(()=>{ne||(ne=!0,D.access(T,Q=>{ne=!1,Q&&(clearInterval(ee),J(void 0))}))},U)})}e.whenDeleted=t;var h;(function(T){async function U(ee){let Q;try{if(Q=await e.Promises.lstat(ee),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(k.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ce}throw Y}}T.stat=U;async function J(ee){try{const{stat:Q,symbolicLink:Y}=await T.stat(ee);return Q.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=J;async function ne(ee){try{const{stat:Q,symbolicLink:Y}=await T.stat(ee);return Q.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=ne})(h||(e.SymlinkSupport=h={}));const s=new P.$fh;function d(T,U,J){return s.queueFor(C.URI.file(T),()=>{const ne=w(J);return new Promise((ee,Q)=>p(T,U,ne,Y=>Y?Q(Y):ee()))},R.$Ag)}let l=!0;function c(T){l=T}e.configureFlushOnWrite=c;function p(T,U,J,ne){if(!l)return D.writeFile(T,U,{mode:J.mode,flag:J.flag},ne);D.open(T,J.flag,J.mode,(ee,Q)=>{if(ee)return ne(ee);D.writeFile(Q,U,Y=>{if(Y)return D.close(Q,()=>ne(Y));D.fdatasync(Q,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),c(!1)),D.close(Q,te=>ne(te))))})})}function I(T,U,J){const ne=w(J);if(!l)return D.writeFileSync(T,U,{mode:ne.mode,flag:ne.flag});const ee=D.openSync(T,ne.flag,ne.mode);try{D.writeFileSync(ee,U);try{D.fdatasyncSync(ee)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),c(!1)}}finally{D.closeSync(ee)}}e.writeFileSync=I;function w(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function g(T,U,J=6e4){if(T!==U)try{k.$i&&typeof J=="number"?await y(T,U,Date.now(),J):await(0,f.promisify)(D.rename)(T,U)}catch(ne){if(T.toLowerCase()!==U.toLowerCase()&&ne.code==="EXDEV"||T.endsWith("."))await L(T,U,{preserveSymlinks:!1}),await E(T,b.MOVE);else throw ne}}async function y(T,U,J,ne,ee=0){try{return await(0,f.promisify)(D.rename)(T,U)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-J>=ne)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${Q}`),Q;if(ee===0){let Y=!1;try{const{stat:ce}=await h.stat(U);ce.isFile()||(Y=!0)}catch{}if(Y)throw Q}return await(0,P.$0g)(Math.min(100,ee*10)),y(T,U,J,ne,ee+1)}}async function L(T,U,J){return z(T,U,{root:{source:T,target:U},options:J,handledSourcePaths:new Set})}const F=511;async function z(T,U,J){if(J.handledSourcePaths.has(T))return;J.handledSourcePaths.add(T);const{stat:ne,symbolicLink:ee}=await h.stat(T);if(ee){if(J.options.preserveSymlinks)try{return await M(T,U,J)}catch{}if(ee.dangling)return}return ne.isDirectory()?j(T,U,ne.mode&F,J):O(T,U,ne.mode&F)}async function j(T,U,J,ne){await e.Promises.mkdir(U,{recursive:!0,mode:J});const ee=await a(T);for(const Q of ee)await z((0,$.$jc)(T,Q),(0,$.$jc)(U,Q),ne)}async function O(T,U,J){await e.Promises.copyFile(T,U),await e.Promises.chmod(U,J)}async function M(T,U,J){let ne=await e.Promises.readlink(T);(0,A.$0f)(ne,J.root.source,!k.$k)&&(ne=(0,$.$jc)(J.root.target,ne.substr(J.root.source.length+1))),await e.Promises.symlink(ne,U)}e.Promises=new class{get access(){return(0,f.promisify)(D.access)}get stat(){return(0,f.promisify)(D.stat)}get lstat(){return(0,f.promisify)(D.lstat)}get utimes(){return(0,f.promisify)(D.utimes)}get read(){return(T,U,J,ne,ee)=>new Promise((Q,Y)=>{D.read(T,U,J,ne,ee,(ce,te,fe)=>ce?Y(ce):Q({bytesRead:te,buffer:fe}))})}get readFile(){return(0,f.promisify)(D.readFile)}get write(){return(T,U,J,ne,ee)=>new Promise((Q,Y)=>{D.write(T,U,J,ne,ee,(ce,te,fe)=>ce?Y(ce):Q({bytesWritten:te,buffer:fe}))})}get appendFile(){return(0,f.promisify)(D.appendFile)}get fdatasync(){return(0,f.promisify)(D.fdatasync)}get truncate(){return(0,f.promisify)(D.truncate)}get copyFile(){return(0,f.promisify)(D.copyFile)}get open(){return(0,f.promisify)(D.open)}get close(){return(0,f.promisify)(D.close)}get symlink(){return(0,f.promisify)(D.symlink)}get readlink(){return(0,f.promisify)(D.readlink)}get chmod(){return(0,f.promisify)(D.chmod)}get mkdir(){return(0,f.promisify)(D.mkdir)}get unlink(){return(0,f.promisify)(D.unlink)}get rmdir(){return(0,f.promisify)(D.rmdir)}get realpath(){return(0,f.promisify)(D.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return o}get writeFile(){return d}get rm(){return E}get rename(){return g}get copy(){return L}}}),define(Ce[103],Ie([1,0,57,17,11,12,31]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=void 0;function v(b){if(f.$k)return b;const E=(0,N.$mc)(b);if(b===E)return b;const S=((0,N.$nc)(b)||b).toLowerCase();try{const m=(0,A.readdirSync)(E).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=v(E);if(a)return(0,N.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=v(E);if(i)return(0,N.$jc)(i,m[a])}}}catch{}return null}e.$wq=v;async function $(b){if(f.$k)return b;const E=(0,N.$mc)(b);if(b===E)return b;const S=((0,N.$nc)(b)||b).toLowerCase();try{const m=(await A.Promises.readdir(E)).filter(a=>a.toLowerCase()===S);if(m.length===1){const a=await $(E);if(a)return(0,N.$jc)(a,m[0])}else if(m.length>1){const a=m.indexOf(S);if(a>=0){const i=await $(E);if(i)return(0,N.$jc)(i,m[a])}}}catch{}return null}e.$xq=$;async function k(b){try{return await A.Promises.realpath(b)}catch{const S=C(b);return await A.Promises.access(S,D.constants.R_OK),S}}e.$yq=k;function R(b){try{return D.realpathSync(b)}catch{const S=C(b);return D.accessSync(S,D.constants.R_OK),S}}e.$zq=R;function C(b){return(0,P.$Ve)((0,N.$hc)(b),N.sep)}}),define(Ce[104],Ie([1,0,17,11,49,101,18,31]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Xl=e.$Wl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(C=f.env){return C.comspec||"cmd.exe"}e.$Wl=$;function k(C){let b=[],E=!1;const S=function(u){if(E){b.push(u);return}(!C.send(u,a=>{if(a&&console.error(a),E=!1,b.length>0){const i=b.slice(0);b=[],i.forEach(r=>S(r))}})||N.$i)&&(E=!0)};return{send:S}}e.$Xl=k;var R;(function(C){async function b(E,S,u){if(D.$ic(E))return E;if(S===void 0&&(S=f.cwd()),D.$mc(E)!=="."||(u===void 0&&A.$Kf(f.env.PATH)&&(u=f.env.PATH.split(D.$tc)),u===void 0||u.length===0))return D.$jc(S,E);async function a(i){if(await v.Promises.exists(i)){let r;try{r=await v.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await v.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of u){let r;if(D.$ic(i)?r=D.$jc(i,E):r=D.$jc(S,i,E),await a(r))return r;let n=r+".com";if(await a(n)||(n=r+".exe",await a(n)))return n}return D.$jc(S,E)}C.findExecutable=b})(R||(e.win32=R={}))});var Ke=this&&this.__decorate||function(me,e,D,N){var f=arguments.length,P=f<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(me,e,D,N);else for(var v=me.length-1;v>=0;v--)(A=me[v])&&(P=(f<3?A(P):f>3?A(e,D,P):A(e,D))||P);return f>3&&P&&Object.defineProperty(e,D,P),P};define(Ce[81],Ie([1,0,19,8,21,22,52,14,4,3,56,12,18]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.ProxyChannel=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.RequestInitiator=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=void 0;var E;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(E||(E={}));function S(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(u||(u={}));function m(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(a||(a={}));function i(ee){let Q=0;for(let Y=0;;Y+=7){const ce=ee.read(1);if(Q|=(ce.buffer[0]&127)<<Y,!(ce.buffer[0]&128))return Q}}const r=s(0);function n(ee,Q){if(Q===0){ee.write(r);return}let Y=0;for(let te=Q;te!==0;te=te>>>7)Y++;const ce=f.$ke.alloc(Y);for(let te=0;Q!==0;te++)ce.buffer[te]=Q&127,Q=Q>>>7,Q>0&&(ce.buffer[te]|=128);ee.write(ce)}class o{constructor(Q){this.b=Q,this.a=0}read(Q){const Y=this.b.slice(this.a,this.a+Q);return this.a+=Y.byteLength,Y}}e.$Gh=o;class t{constructor(){this.a=[]}get buffer(){return f.$ke.concat(this.a)}write(Q){this.a.push(Q)}}e.$Hh=t;var h;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(h||(h={}));function s(ee){const Q=f.$ke.alloc(1);return Q.writeUInt8(ee,0),Q}const d={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object),Uint:s(h.Int)},l=typeof Buffer<"u";function c(ee,Q){if(typeof Q>"u")ee.write(d.Undefined);else if(typeof Q=="string"){const Y=f.$ke.fromString(Q);ee.write(d.String),n(ee,Y.byteLength),ee.write(Y)}else if(l&&Buffer.isBuffer(Q)){const Y=f.$ke.wrap(Q);ee.write(d.Buffer),n(ee,Y.byteLength),ee.write(Y)}else if(Q instanceof f.$ke)ee.write(d.VSBuffer),n(ee,Q.byteLength),ee.write(Q);else if(Array.isArray(Q)){ee.write(d.Array),n(ee,Q.length);for(const Y of Q)c(ee,Y)}else if(typeof Q=="number"&&(Q|0)===Q)ee.write(d.Uint),n(ee,Q);else{const Y=f.$ke.fromString(JSON.stringify(Q));ee.write(d.Object),n(ee,Y.byteLength),ee.write(Y)}}e.$Ih=c;function p(ee){switch(ee.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return ee.read(i(ee)).toString();case h.Buffer:return ee.read(i(ee)).buffer;case h.VSBuffer:return ee.read(i(ee));case h.Array:{const Y=i(ee),ce=[];for(let te=0;te<Y;te++)ce.push(p(ee));return ce}case h.Object:return JSON.parse(ee.read(i(ee)).toString());case h.Int:return i(ee)}}e.$Jh=p;class I{constructor(Q,Y,ce=null,te=1e3){this.h=Q,this.j=Y,this.k=ce,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(fe=>this.q(fe)),this.m({type:200})}registerChannel(Q,Y){this.b.set(Q,Y),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Y=this.o([Q.type]);this.k?.logOutgoing(Y,0,1,m(Q.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Y,Q.id,1,m(Q.type),Q.data);return}}}o(Q,Y=void 0){const ce=new t;return c(ce,Q),c(ce,Y),this.p(ce.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Y=new o(Q),ce=p(Y),te=p(Y),fe=ce[0];switch(fe){case 100:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}: ${ce[2]}.${ce[3]}`,te),this.s({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 102:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}: ${ce[2]}.${ce[3]}`,te),this.t({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:te});case 101:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}`),this.u({type:fe,id:ce[1]});case 103:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}`),this.u({type:fe,id:ce[1]})}}s(Q){const Y=this.b.get(Q.channelName);if(!Y){this.v(Q);return}const ce=new P.$7d;let te;try{te=Y.call(this.j,Q.name,Q.arg,ce.token)}catch(K){te=Promise.reject(K)}const fe=Q.id;te.then(K=>{this.m({id:fe,data:K,type:201})},K=>{K instanceof Error?this.m({id:fe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:fe,data:K,type:203})}).finally(()=>{re.dispose(),this.d.delete(Q.id)});const re=(0,k.$Rc)(()=>ce.cancel());this.d.set(Q.id,re)}t(Q){const Y=this.b.get(Q.channelName);if(!Y){this.v(Q);return}const ce=Q.id,fe=Y.listen(this.j,Q.name,Q.arg)(re=>this.m({id:ce,data:re,type:204}));this.d.set(Q.id,fe)}u(Q){const Y=this.d.get(Q.id);Y&&(Y.dispose(),this.d.delete(Q.id))}v(Q){let Y=this.g.get(Q.channelName);Y||(Y=[],this.g.set(Q.channelName,Y));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:Q,timeoutTimer:ce})}w(Q){const Y=this.g.get(Q);if(Y){for(const ce of Y)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=I;var w;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class g{constructor(Q,Y=null){this.l=Q,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Y}getChannel(Q){const Y=this;return{call(ce,te,fe){return Y.a?Promise.reject(new v.$5):Y.m(Q,ce,te,fe)},listen(ce,te){return Y.a?$.Event.None:Y.o(Q,ce,te)}}}m(Q,Y,ce,te=P.CancellationToken.None){const fe=this.g++,K={id:fe,type:100,channelName:Q,name:Y,arg:ce};if(te.isCancellationRequested)return Promise.reject(new v.$5);let B;return new Promise((Ee,le)=>{if(te.isCancellationRequested)return le(new v.$5);const de=()=>{const Z=he=>{switch(he.type){case 201:this.f.delete(fe),Ee(he.data);break;case 202:{this.f.delete(fe);const be=new Error(he.data.message);be.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,be.name=he.data.name,le(be);break}case 203:this.f.delete(fe),le(he.data);break}};this.f.set(fe,Z),this.p(K)};let ue=null;this.b===a.Idle?de():(ue=(0,N.$Vg)(Z=>this.u()),ue.then(()=>{ue=null,de()}));const ge=()=>{ue?(ue.cancel(),ue=null):this.p({id:fe,type:101}),le(new v.$5)},V=te.onCancellationRequested(ge);B=(0,k.$Qc)((0,k.$Rc)(ge),V),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Q,Y,ce){const te=this.g++,re={id:te,type:102,channelName:Q,name:Y,arg:ce};let K=null;const B=new $.$Wd({onWillAddFirstListener:()=>{K=(0,N.$Vg)(Ee=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(re)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:te,type:103}))}}),ae=Ee=>B.fire(Ee.data);return this.f.set(te,ae),B.event}p(Q){switch(Q.type){case 100:case 102:{const Y=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Y,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Y=this.q([Q.type,Q.id]);this.j?.logOutgoing(Y,Q.id,0,S(Q.type));return}}}q(Q,Y=void 0){const ce=new t;return c(ce,Q),c(ce,Y),this.r(ce.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Y=new o(Q),ce=p(Y),te=p(Y),fe=ce[0];switch(fe){case 200:return this.j?.logIncoming(Q.byteLength,0,0,m(fe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ce[1],0,m(fe),te),this.t({type:ce[0],id:ce[1],data:te})}}t(Q){if(Q.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Lh=g,Ke([A.$Ah],g.prototype,"onDidInitializePromise",null);class y{get connections(){const Q=[];return this.f.forEach(Y=>Q.push(Y)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$Wd,this.onDidAddConnection=this.g.event,this.h=new $.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new k.$Sc,this.j.add(Q(({protocol:Y,onDidClientDisconnect:ce})=>{const te=$.Event.once(Y.onMessage);this.j.add(te(fe=>{const re=new o(fe),K=p(re),B=new I(Y,K),ae=new g(Y);this.a.forEach((le,de)=>B.registerChannel(de,le));const Ee={channelServer:B,channelClient:ae,ctx:K};this.f.add(Ee),this.g.fire(Ee),this.j.add(ce(()=>{B.dispose(),ae.dispose(),this.f.delete(Ee),this.h.fire(Ee)}))}))}))}getChannel(Q,Y){const ce=this;return{call(te,fe,re){let K;if((0,b.$Yf)(Y)){const ae=(0,D.$4b)(ce.connections.filter(Y));K=ae?Promise.resolve(ae):$.Event.toPromise($.Event.filter(ce.onDidAddConnection,Y))}else K=Y.routeCall(ce,te,fe);const B=K.then(ae=>ae.channelClient.getChannel(Q));return F(B).call(te,fe,re)},listen(te,fe){if((0,b.$Yf)(Y))return ce.k(Q,Y,te,fe);const re=Y.routeEvent(ce,te,fe).then(K=>K.channelClient.getChannel(Q));return F(re).listen(te,fe)}}}k(Q,Y,ce,te){const fe=this;let re;const K=new $.$Wd({onWillAddFirstListener:()=>{re=new k.$Sc;const B=new $.$3d,ae=new Map,Ee=de=>{const ge=de.channelClient.getChannel(Q).listen(ce,te),V=B.add(ge);ae.set(de,V)},le=de=>{const ue=ae.get(de);ue&&(ue.dispose(),ae.delete(de))};fe.connections.filter(Y).forEach(Ee),$.Event.filter(fe.onDidAddConnection,Y)(Ee,void 0,re),fe.onDidRemoveConnection(le,void 0,re),B.event(K.fire,K,re),re.add(B)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return K.event}registerChannel(Q,Y){this.a.set(Q,Y);for(const ce of this.f)ce.channelServer.registerChannel(Q,Y)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Mh=y;class L{constructor(Q,Y,ce=null){const te=new t;c(te,Y),Q.send(te.buffer),this.a=new g(Q,ce),this.d=new I(Q,Y,ce)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Y){this.d.registerChannel(Q,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Nh=L;function F(ee){return{call(Q,Y,ce){return ee.then(te=>te.call(Q,Y,ce))},listen(Q,Y){const ce=new $.$6d;return ee.then(te=>ce.input=te.listen(Q,Y)),ce.event}}}e.$Oh=F;function z(ee){let Q=!1;return{call(Y,ce,te){return Q?ee.call(Y,ce,te):(0,N.$0g)(0).then(()=>Q=!0).then(()=>ee.call(Y,ce,te))},listen(Y,ce){if(Q)return ee.listen(Y,ce);const te=new $.$6d;return(0,N.$0g)(0).then(()=>Q=!0).then(()=>te.input=ee.listen(Y,ce)),te.event}}}e.$Ph=z;class j{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Y of Q.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Qh=j;var O;(function(ee){function Q(fe,re,K){const B=fe,ae=K&&K.disableMarshalling,Ee=new Map;for(const le in B)ce(le)&&Ee.set(le,$.Event.buffer(B[le],!0,void 0,re));return new class{listen(le,de,ue){const ge=Ee.get(de);if(ge)return ge;if(te(de)){const V=B[de];if(typeof V=="function")return V.call(B,ue)}throw new v.$bb(`Event not found: ${de}`)}call(le,de,ue){const ge=B[de];if(typeof ge=="function"){if(!ae&&Array.isArray(ue))for(let Z=0;Z<ue.length;Z++)ue[Z]=(0,R.$Fh)(ue[Z]);let V=ge.apply(B,ue);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new v.$bb(`Method not found: ${de}`)}}}ee.fromService=Q;function Y(fe,re){const K=re&&re.disableMarshalling;return new Proxy({},{get(B,ae){if(typeof ae=="string")return re?.properties?.has(ae)?re.properties.get(ae):te(ae)?function(Ee){return fe.listen(ae,Ee)}:ce(ae)?fe.listen(ae):async function(...Ee){let le;re&&!(0,b.$Tf)(re.context)?le=[re.context,...Ee]:le=Ee;const de=await fe.call(ae,le);return K?de:(0,R.$Fh)(de)};throw new v.$bb(`Property not found: ${String(ae)}`)}})}ee.toService=Y;function ce(fe){return fe[0]==="o"&&fe[1]==="n"&&C.$af(fe.charCodeAt(2))}function te(fe){return/^onDynamic/.test(fe)&&C.$af(fe.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const Q=ee.toString();if(Q!=="[object Object]")return Q}return ee}function U(ee){return Array.isArray(ee)?ee.map(T):T(ee)}function J(ee,Q,Y,ce,te,fe,re){re=U(re);const K=M[te],B=K[ce%K.length];let ae=[`%c[${ee}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(fe)?(ae=ae.concat(re),ae.push(")")):ae.push(re),console.log.apply(console,ae)}class ne{constructor(Q,Y){this.d=Q,this.f=Y,this.a=0,this.b=0}logOutgoing(Q,Y,ce,te,fe){this.b+=Q,J(this.d,this.b,Q,Y,ce,te,fe)}logIncoming(Q,Y,ce,te,fe){this.a+=Q,J(this.f,this.a,Q,Y,ce,te,fe)}}e.$Rh=ne}),define(Ce[82],Ie([1,0,21,4,3,81]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.ProtocolConstants=e.$Sh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(d){d.Created="created",d.Read="read",d.Write="write",d.Open="open",d.Error="error",d.Close="close",d.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",d.NodeEndReceived="nodeEndReceived",d.NodeEndSent="nodeEndSent",d.NodeDrainBegin="nodeDrainBegin",d.NodeDrainEnd="nodeDrainEnd",d.zlibInflateError="zlibInflateError",d.zlibInflateData="zlibInflateData",d.zlibInflateInitialWrite="zlibInflateInitialWrite",d.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",d.zlibInflateWrite="zlibInflateWrite",d.zlibInflateFlushFired="zlibInflateFlushFired",d.zlibDeflateError="zlibDeflateError",d.zlibDeflateData="zlibDeflateData",d.zlibDeflateWrite="zlibDeflateWrite",d.zlibDeflateFlushFired="zlibDeflateFlushFired",d.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",d.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",d.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",d.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",d.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",d.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",d.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",d.ProtocolHeaderRead="protocolHeaderRead",d.ProtocolMessageRead="protocolMessageRead",d.ProtocolHeaderWrite="protocolHeaderWrite",d.ProtocolMessageWrite="protocolMessageWrite",d.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(d){d.enableDiagnostics=!1,d.records=[];const l=new WeakMap;let c=0;function p(w,g){if(!l.has(w)){const y=String(++c);l.set(w,y)}return l.get(w)}function I(w,g,y,L){if(!d.enableDiagnostics)return;const F=p(w,g);if(L instanceof D.$ke||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=D.$ke.alloc(L.byteLength);z.set(L),d.records.push({timestamp:Date.now(),id:F,label:g,type:y,buff:z})}else d.records.push({timestamp:Date.now(),id:F,label:g,type:y,data:L})}d.traceSocketEvent=I})(v||(e.SocketDiagnostics=v={}));var $;(function(d){d[d.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",d[d.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function R(){return k||(k=D.$ke.alloc(0)),k}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,c){if(l===0)return R();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const g=this.a[0];return c&&(this.a.shift(),this.b-=l),g}if(this.a[0].byteLength>l){const g=this.a[0].slice(0,l);return c&&(this.a[0]=this.a[0].slice(l),this.b-=l),g}const p=D.$ke.alloc(l);let I=0,w=0;for(;l>0;){const g=this.a[w];if(g.byteLength>l){const y=g.slice(0,l);p.set(y,I),I+=l,c&&(this.a[w]=g.slice(l),this.b-=l),l-=l}else p.set(g,I),I+=g.byteLength,c?(this.a.shift(),this.b-=g.byteLength):w++,l-=g.byteLength}return p}}e.$Sh=C;var b;(function(d){d[d.None=0]="None",d[d.Regular=1]="Regular",d[d.Control=2]="Control",d[d.Ack=3]="Ack",d[d.Disconnect=5]="Disconnect",d[d.ReplayRequest=6]="ReplayRequest",d[d.Pause=7]="Pause",d[d.Resume=8]="Resume",d[d.KeepAlive=9]="KeepAlive"})(b||(b={}));function E(d){switch(d){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(d){d[d.HeaderLength=13]="HeaderLength",d[d.AcknowledgeTime=2e3]="AcknowledgeTime",d[d.TimeoutTime=2e4]="TimeoutTime",d[d.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",d[d.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",d[d.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class u{constructor(l,c,p,I){this.type=l,this.id=c,this.ack=p,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends f.$Tc{constructor(l){super(),this.f=this.B(new N.$Wd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new C,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,I=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new u(p,I,w,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.$ke.alloc(13);c.writeUInt8(l.type,0),c.writeUInt32BE(l.id,1),c.writeUInt32BE(l.ack,5),c.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(c,l.data)}g(l,c){const p=this.f===0;return this.d.push(l,c),this.f+=l.byteLength+c.byteLength,p}h(){const l=D.$ke.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,c){this.g(l,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends f.$Tc{constructor(l){super(),this.f=new N.$Wd,this.onMessage=this.f.event,this.g=new N.$Wd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new a(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new u(1,0,0,l))}}e.$Th=i;class r extends P.$Nh{static fromSocket(l,c){return new r(new i(l),c)}get onDidDispose(){return this.b.onDidDispose}constructor(l,c,p=null){super(l,c,p),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Uh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Wd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Vh=n;class o{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,c=this.a;for(;c;)c=c.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let c=0,p=this.a;for(;p;)l[c++]=p.data,p=p.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const c=new o(l);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const l=Date.now();for(let c=0;c<h.a;c++)this.c[c]=l-1e3*c;setInterval(()=>{for(let c=h.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),c=(1+h.a)*1e3;let p=0;for(let I=0;I<h.a;I++)l-this.c[I]<=c&&p++;return 1-p/h.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??h.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Sc,this.o=l.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new u(5,0,0,R());this.p.write(l),this.p.flush()}sendPause(){const l=new u(7,0,0,R());this.p.write(l)}sendResume(){const l=new u(8,0,0,R());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,c){this.a=!0,this.r.dispose(),this.r=new f.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new u(3,0,this.h,R());this.p.write(l);const c=this.b.toArray();for(let p=0,I=c.length;p<I;p++)this.p.write(c[p]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const c=this.b.peek();if(c&&c.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new u(6,0,0,R())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let p=0,I=c.length;p<I;p++)this.p.write(c[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const c=++this.c;this.h=this.g;const p=new u(1,c,this.h,l);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(l){const c=new u(2,0,0,l);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),c=Date.now()-l.writtenTime,p=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(c>=2e4&&p>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:p});return}const w=Math.max(2e4-c,2e4-p,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new u(3,0,this.h,R());this.p.write(l)}D(){this.h=this.g;const l=new u(9,0,this.h,R());this.p.write(l)}}e.$Wh=s}),define(Ce[188],Ie([1,0,50,8,21,22,186,14,4,3,24,104,101,81]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0;class S extends E.$Kh{constructor(a){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>f.$ke.wrap(Buffer.from(i,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$tq=S;class u{constructor(a,i){this.i=a,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Wd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new N.$6g(r),this.d=null,this.f=null}getChannel(a){const i=this;return{call(r,n,o){return i.k(a,r,n,o)},listen(r,n){return i.l(a,r,n)}}}k(a,i,r,n=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(v.$6());this.b.cancel();const o=this.n(a),t=(0,N.$Vg)(d=>o.call(i,r,d)),h=n.onCancellationRequested(()=>t.cancel()),s=(0,k.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{h.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const o=new $.$Wd({onWillAddFirstListener:()=>{n=this.n(a).listen(i,r)(o.fire,o),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$zn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,b.$Vl)(i.env),this.d=(0,D.fork)(this.i,a,i);const r=new $.$Wd;$.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,A.$pq)(l)){(0,A.log)(l,`IPC Library: ${this.j.serverName}`);return}r.fire(f.$ke.wrap(Buffer.from(l,"base64")))});const o=this.j.useQueue?(0,C.$Xl)(this.d):this.d,t=l=>this.d&&this.d.connected&&o.send(l.buffer.toString("base64")),h=r.event,s={send:t,onMessage:h};this.f=new E.$Lh(s);const d=()=>this.o();process.once("exit",d),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,c)=>{process.removeListener("exit",d),this.c.forEach(p=>(0,k.$Oc)(p)),this.c.clear(),l!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:c})})}return this.f}n(a){let i=this.g.get(a);return i||(i=this.m.getChannel(a),this.g.set(a,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$uq=u}),define(Ce[189],Ie([1,0,8,4,3,56,18]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.StorageState=e.$sp=e.StorageHint=void 0;var v;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function $(b){const E=b;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$sp=$;var k;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(k||(e.StorageState=k={}));class R extends f.$Tc{static{this.a=100}constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new N.$Zd),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new D.$7g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,u)=>this.w(u,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===k.Closed)return;let u=!1;(0,A.$Tf)(S)?u=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),u=!0),u&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const u=this.f.get(E);return(0,A.$Tf)(u)?S:u}getBoolean(E,S){const u=this.get(E);return(0,A.$Tf)(u)?S:u==="true"}getNumber(E,S){const u=this.get(E);return(0,A.$Tf)(u)?S:parseInt(u,10)}getObject(E,S){const u=this.get(E);return(0,A.$Tf)(u)?S:(0,P.$Eh)(u)}async set(E,S,u=!1){if(this.c===k.Closed)return;if((0,A.$Tf)(S))return this.delete(E,u);const m=(0,A.$Mf)(S)||Array.isArray(S)?(0,P.$Dh)(S):String(S);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:u}),this.D()}async delete(E,S=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$tp=R;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,u)=>this.a.set(u,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$up=C}),define(Ce[190],Ie([1,0,12,11,21]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=void 0;let P;function A(){return P||(P=new TextDecoder("UTF-16LE")),P}let v;function $(){return v||(v=new TextDecoder("UTF-16BE")),v}let k;function R(){return k||(k=N.$D()?A():$()),k}e.$dt=R;function C(S,u,m){const a=new Uint16Array(S.buffer,u,m);return m>0&&(a[0]===65279||a[0]===65534)?b(S,u,m):A().decode(a)}e.$et=C;function b(S,u,m){const a=[];let i=0;for(let r=0;r<m;r++){const n=f.$me(S,u);u+=2,a[i++]=String.fromCharCode(n)}return a.join("")}class E{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return R().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const m=this.a-this.d;m<=1&&(m===0||D.$ff(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const m=u.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=u;return}for(let a=0;a<m;a++)this.b[this.d++]=u.charCodeAt(a)}}e.$ft=E}),define(Ce[191],Ie([1,0,21,190]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=void 0;function f($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,R,C,b){this.oldPosition=k,this.oldText=R,this.newPosition=C,this.newText=b}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,R,C){const b=R.length;D.$pe(k,b,C),C+=4;for(let E=0;E<b;E++)D.$ne(k,R.charCodeAt(E),C),C+=2;return C}static d(k,R){const C=D.$oe(k,R);return R+=4,(0,N.$et)(k,R,C)}writeSize(){return 8+P.a(this.oldText)+P.a(this.newText)}write(k,R){return D.$pe(k,this.oldPosition,R),R+=4,D.$pe(k,this.newPosition,R),R+=4,R=P.c(k,this.oldText,R),R=P.c(k,this.newText,R),R}static read(k,R,C){const b=D.$oe(k,R);R+=4;const E=D.$oe(k,R);R+=4;const S=P.d(k,R);R+=P.a(S);const u=P.d(k,R);return R+=P.a(u),C.push(new P(b,S,E,u)),R}}e.$gt=P;function A($,k){return $===null||$.length===0?k:new v($,k).compress()}e.$ht=A;class v{constructor(k,R){this.a=k,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,R=0,C=this.n(k),b=this.l(R);for(;k<this.f||R<this.h;){if(C===null){this.k(b),b=this.l(++R);continue}if(b===null){this.m(C),C=this.n(++k);continue}if(b.oldEnd<=C.newPosition){this.k(b),b=this.l(++R);continue}if(C.newEnd<=b.oldPosition){this.m(C),C=this.n(++k);continue}if(b.oldPosition<C.newPosition){const[a,i]=v.r(b,C.newPosition-b.oldPosition);this.k(a),b=i;continue}if(C.newPosition<b.oldPosition){const[a,i]=v.q(C,b.oldPosition-C.newPosition);this.m(a),C=i;continue}let u,m;if(b.oldEnd===C.newEnd)u=C,m=b,C=this.n(++k),b=this.l(++R);else if(b.oldEnd<C.newEnd){const[a,i]=v.q(C,b.oldLength);u=a,m=b,C=i,b=this.l(++R)}else{const[a,i]=v.r(b,C.newLength);u=C,m=a,C=this.n(++k),b=i}this.d[this.e++]=new P(u.oldPosition,u.oldText,m.newPosition,m.newText),this.g+=u.newLength-u.oldLength,this.j+=m.newLength-m.oldLength}const E=v.s(this.d);return v.t(E)}k(k){this.d[this.e++]=v.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=v.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,R){return new P(R.oldPosition-k,R.oldText,R.newPosition,R.newText)}static p(k,R){return new P(R.oldPosition,R.oldText,R.newPosition+k,R.newText)}static q(k,R){const C=k.newText.substr(0,R),b=k.newText.substr(R);return[new P(k.oldPosition,k.oldText,k.newPosition,C),new P(k.oldEnd,"",k.newPosition+R,b)]}static r(k,R){const C=k.oldText.substr(0,R),b=k.oldText.substr(R);return[new P(k.oldPosition,C,k.newPosition,k.newText),new P(k.oldPosition+R,b,k.newEnd,"")]}static s(k){if(k.length===0)return k;const R=[];let C=0,b=k[0];for(let E=1;E<k.length;E++){const S=k[E];b.oldEnd===S.oldPosition?b=new P(b.oldPosition,b.oldText+S.oldText,b.newPosition,b.newText+S.newText):(R[C++]=b,b=S)}return R[C++]=b,R}static t(k){if(k.length===0)return k;const R=[];let C=0;for(let b=0;b<k.length;b++){const E=k[b];E.oldText!==E.newText&&(R[C++]=E)}return R}}}),define(Ce[192],Ie([1,0,35,17]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0;function f(P,A,v,$,k,R){if(Array.isArray(P)){let C=0;for(const b of P){const E=f(b,A,v,$,k,R);if(E===10)return E;E>C&&(C=E)}return C}else{if(typeof P=="string")return $?P==="*"?5:P===v?10:0:0;if(P){const{language:C,pattern:b,scheme:E,hasAccessToAllModels:S,notebookType:u}=P;if(!$&&!S)return 0;u&&k&&(A=k);let m=0;if(E)if(E===A.scheme)m=10;else if(E==="*")m=5;else return 0;if(C)if(C===v)m=10;else if(C==="*")m=Math.max(m,5);else return 0;if(u)if(u===R)m=10;else if(u==="*"&&R!==void 0)m=Math.max(m,5);else return 0;if(b){let a;if(typeof b=="string"?a=b:a={...b,base:(0,N.$hc)(b.base)},a===A.fsPath||(0,D.$Oj)(a,A.fsPath))m=10;else return 0}return m}else return 0}}e.$Et=f}),define(Ce[193],Ie([1,0,4,12,29,80,127,168,191,3]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class R extends k.$Tc{constructor(b,E,S,u,m,a,i){super(),this.m=this.B(new D.$Wd),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=u,this.h=m,this.c=new A.$dC(b,S,i)}equals(b){return!(b instanceof R)||this.f!==b.f||this.getEOL()!==b.getEOL()?!1:this.c.equal(b.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(b){return this.c.createSnapshot(b?this.f:"")}getOffsetAt(b,E){return this.c.getOffsetAt(b,E)}getPositionAt(b){return this.c.getPositionAt(b)}getRangeAt(b,E){const S=b+E,u=this.getPositionAt(b),m=this.getPositionAt(S);return new f.$Xs(u.lineNumber,u.column,m.lineNumber,m.column)}getValueInRange(b,E=0){if(b.isEmpty())return"";const S=this.n(E);return this.c.getValueInRange(b,S)}getValueLengthInRange(b,E=0){if(b.isEmpty())return 0;if(b.startLineNumber===b.endLineNumber)return b.endColumn-b.startColumn;const S=this.getOffsetAt(b.startLineNumber,b.startColumn),u=this.getOffsetAt(b.endLineNumber,b.endColumn);let m=0;const a=this.n(E),i=this.getEOL();if(a.length!==i.length){const r=a.length-i.length,n=b.endLineNumber-b.startLineNumber;m=r*n}return u-S+m}getCharacterCountInRange(b,E=0){if(this.j){let S=0;const u=b.startLineNumber,m=b.endLineNumber;for(let a=u;a<=m;a++){const i=this.getLineContent(a),r=a===u?b.startColumn-1:0,n=a===m?b.endColumn-1:i.length;for(let o=r;o<n;o++)N.$ff(i.charCodeAt(o))?(S=S+1,o=o+1):S=S+1}return S+=this.n(E).length*(m-u),S}return this.getValueLengthInRange(b,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(b){return this.c.getLineContent(b)}getLineCharCode(b,E){return this.c.getLineCharCode(b,E)}getCharCode(b){return this.c.getCharCode(b)}getLineLength(b){return this.c.getLineLength(b)}getLineMinColumn(b){return 1}getLineMaxColumn(b){return this.getLineLength(b)+1}getLineFirstNonWhitespaceColumn(b){const E=N.$3e(this.getLineContent(b));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(b){const E=N.$5e(this.getLineContent(b));return E===-1?0:E+2}n(b){switch(b){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(b){this.c.setEOL(b)}applyEdits(b,E,S){let u=this.g,m=this.h,a=this.j,i=!0,r=[];for(let l=0;l<b.length;l++){const c=b[l];i&&c._isTracked&&(i=!1);const p=c.range;if(c.text){let L=!0;a||(L=!N.$qf(c.text),a=L),!u&&L&&(u=N.$pf(c.text)),!m&&L&&(m=N.$sf(c.text))}let I="",w=0,g=0,y=0;if(c.text){let L;[w,g,y,L]=(0,v.$xt)(c.text);const F=this.getEOL();L===0||L===(F===`\r
`?2:1)?I=c.text:I=c.text.replace(/\r\n|\r|\n/g,F)}r[l]={sortIndex:l,identifier:c.identifier||null,range:p,rangeOffset:this.getOffsetAt(p.startLineNumber,p.startColumn),rangeLength:this.getValueLengthInRange(p),text:I,eolCount:w,firstLineLength:g,lastLineLength:y,forceMoveMarkers:!!c.forceMoveMarkers,isAutoWhitespaceEdit:c.isAutoWhitespaceEdit||!1}}r.sort(R.u);let n=!1;for(let l=0,c=r.length-1;l<c;l++){const p=r[l].range.getEndPosition(),I=r[l+1].range.getStartPosition();if(I.isBeforeOrEqual(p)){if(I.isBefore(p))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const o=S||E?R._getInverseEditRanges(r):[],t=[];if(E)for(let l=0;l<r.length;l++){const c=r[l],p=o[l];if(c.isAutoWhitespaceEdit&&c.range.isEmpty())for(let I=p.startLineNumber;I<=p.endLineNumber;I++){let w="";I===p.startLineNumber&&(w=this.getLineContent(c.range.startLineNumber),N.$3e(w)!==-1)||t.push({lineNumber:I,oldContent:w})}}let h=null;if(S){let l=0;h=[];for(let c=0;c<r.length;c++){const p=r[c],I=o[c],w=this.getValueInRange(p.range),g=p.rangeOffset+l;l+=p.text.length-w.length,h[c]={sortIndex:p.sortIndex,identifier:p.identifier,range:I,text:w,textChange:new $.$gt(p.rangeOffset,w,g,p.text)}}n||h.sort((c,p)=>c.sortIndex-p.sortIndex)}this.g=u,this.h=m,this.j=a;const s=this.t(r);let d=null;if(E&&t.length>0){t.sort((l,c)=>c.lineNumber-l.lineNumber),d=[];for(let l=0,c=t.length;l<c;l++){const p=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===p)continue;const I=t[l].oldContent,w=this.getLineContent(p);w.length===0||w===I||N.$3e(w)!==-1||d.push(p)}}return this.m.fire(),new P.$hv(h,s,d)}s(b){return b.length<1e3?b:[this._toSingleEditOperation(b)]}_toSingleEditOperation(b){let E=!1;const S=b[0].range,u=b[b.length-1].range,m=new f.$Xs(S.startLineNumber,S.startColumn,u.endLineNumber,u.endColumn);let a=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,d=b.length;s<d;s++){const l=b[s],c=l.range;E=E||l.forceMoveMarkers,r.push(this.getValueInRange(new f.$Xs(a,i,c.startLineNumber,c.startColumn))),l.text.length>0&&r.push(l.text),a=c.endLineNumber,i=c.endColumn}const n=r.join(""),[o,t,h]=(0,v.$xt)(n);return{sortIndex:0,identifier:b[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:n,eolCount:o,firstLineLength:t,lastLineLength:h,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(b){b.sort(R.w);const E=[];for(let S=0;S<b.length;S++){const u=b[S],m=u.range.startLineNumber,a=u.range.startColumn,i=u.range.endLineNumber,r=u.range.endColumn;if(m===i&&a===r&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const n=new f.$Xs(m,a,i,r);E.push({range:n,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return E}findMatchesLineByLine(b,E,S,u){return this.c.findMatchesLineByLine(b,E,S,u)}getPieceTree(){return this.c}static _getInverseEditRange(b,E){const S=b.startLineNumber,u=b.startColumn,[m,a,i]=(0,v.$xt)(E);let r;if(E.length>0){const n=m+1;n===1?r=new f.$Xs(S,u,S,u+a):r=new f.$Xs(S,u,S+n-1,i+1)}else r=new f.$Xs(S,u,S,u);return r}static _getInverseEditRanges(b){const E=[];let S=0,u=0,m=null;for(let a=0,i=b.length;a<i;a++){const r=b[a];let n,o;m?m.range.endLineNumber===r.range.startLineNumber?(n=S,o=u+(r.range.startColumn-m.range.endColumn)):(n=S+(r.range.startLineNumber-m.range.endLineNumber),o=r.range.startColumn):(n=r.range.startLineNumber,o=r.range.startColumn);let t;if(r.text.length>0){const h=r.eolCount+1;h===1?t=new f.$Xs(n,o,n,o+r.firstLineLength):t=new f.$Xs(n,o,n+h-1,r.lastLineLength+1)}else t=new f.$Xs(n,o,n,o);S=t.endLineNumber,u=t.endColumn,E.push(t),m=r}return E}static u(b,E){const S=f.$Xs.compareRangesUsingEnds(b.range,E.range);return S===0?b.sortIndex-E.sortIndex:S}static w(b,E){const S=f.$Xs.compareRangesUsingEnds(b.range,E.range);return S===0?E.sortIndex-b.sortIndex:-S}}e.$eC=R}),define(Ce[194],Ie([1,0,12,127,193]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class P{constructor($,k,R,C,b,E,S,u,m){this.a=$,this.b=k,this.c=R,this.d=C,this.e=b,this.f=E,this.g=S,this.h=u,this.j=m}k($){const k=this.c+this.d+this.e,R=this.c+this.e;return k===0?$===1?`
`:`\r
`:R>k/2?`\r
`:`
`}create($){const k=this.k($),R=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let b=0,E=R.length;b<E;b++){const S=R[b].buffer.replace(/\r\n|\r|\n/g,k),u=(0,N.$_B)(S);R[b]=new N.$cC(S,u)}const C=new f.$eC(R,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$yf($)&&(this.b=D.$xf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,N.$aC)(this.e,$);this.a.push(new N.$cC($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=D.$pf($)),this.k||(this.k=D.$sf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,N.$_B)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$fC=A}),define(Ce[131],Ie([1,0,21,11]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$=e.$8$=void 0;var f;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(f||(f={}));function P(C){for(let b=0,E=C.length;b<E;b+=4){const S=C[b+0],u=C[b+1],m=C[b+2],a=C[b+3];C[b+0]=a,C[b+1]=m,C[b+2]=u,C[b+3]=S}}function A(C){const b=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||P(b),D.$ke.wrap(b)}function v(C){const b=C.buffer;if(N.$D()||P(b),b.byteOffset%4===0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const E=new Uint8Array(b.byteLength);return E.set(b),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(C){const b=new Uint32Array(k(C));let E=0;if(b[E++]=C.id,C.type==="full")b[E++]=1,b[E++]=C.data.length,b.set(C.data,E),E+=C.data.length;else{b[E++]=2,b[E++]=C.deltas.length;for(const S of C.deltas)b[E++]=S.start,b[E++]=S.deleteCount,S.data?(b[E++]=S.data.length,b.set(S.data,E),E+=S.data.length):b[E++]=0}return A(b)}e.$8$=$;function k(C){let b=0;if(b+=2,C.type==="full")b+=1+C.data.length;else{b+=1,b+=3*C.deltas.length;for(const E of C.deltas)E.data&&(b+=E.data.length)}return b}function R(C){const b=v(C);let E=0;const S=b[E++];if(b[E++]===1){const i=b[E++],r=b.subarray(E,E+i);return E+=i,{id:S,type:"full",data:r}}const m=b[E++],a=[];for(let i=0;i<m;i++){const r=b[E++],n=b[E++],o=b[E++];let t;o>0&&(t=b.subarray(E,E+o),E+=o),a[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:a}}e.$9$=R}),define(Ce[195],Ie([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Ce[132],Ie([1,0,19,24,11,171,126,195]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(se,De,Ve,Xe){this.id=se,this.name=De,this.defaultValue=Ve,this.schema=Xe}applyUpdate(se,De){return E(se,De)}compute(se,De,Ve){return Ve}}class b{constructor(se,De){this.newValue=se,this.didChange=De}}e.ApplyUpdateResult=b;function E(_,se){if(typeof _!="object"||typeof se!="object"||!_||!se)return new b(se,_!==se);if(Array.isArray(_)||Array.isArray(se)){const Ve=Array.isArray(_)&&Array.isArray(se)&&D.$ub(_,se);return new b(se,!Ve)}let De=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const Xe=E(_[Ve],se[Ve]);Xe.didChange&&(_[Ve]=Xe.newValue,De=!0)}return new b(_,De)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,De){return E(se,De)}validate(se){return this.defaultValue}}class u{constructor(se,De,Ve,Xe){this.id=se,this.name=De,this.defaultValue=Ve,this.schema=Xe}applyUpdate(se,De){return E(se,De)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,De,Ve){return Ve}}function m(_,se){return typeof _>"u"?se:_==="false"?!1:!!_}e.boolean=m;class a extends u{constructor(se,De,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="boolean",Xe.default=Ve),super(se,De,Ve,Xe)}validate(se){return m(se,this.defaultValue)}}function i(_,se,De,Ve){if(typeof _>"u")return se;let Xe=parseInt(_,10);return isNaN(Xe)?se:(Xe=Math.max(De,Xe),Xe=Math.min(Ve,Xe),Xe|0)}e.clampedInt=i;class r extends u{static clampedInt(se,De,Ve,Xe){return i(se,De,Ve,Xe)}constructor(se,De,Ve,Xe,nt,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=Xe,rt.maximum=nt),super(se,De,Ve,rt),this.minimum=Xe,this.maximum=nt}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(_,se,De,Ve){if(typeof _>"u")return se;const Xe=o.float(_,se);return o.clamp(Xe,De,Ve)}e.clampedFloat=n;class o extends u{static clamp(se,De,Ve){return se<De?De:se>Ve?Ve:se}static float(se,De){if(typeof se=="number")return se;if(typeof se>"u")return De;const Ve=parseFloat(se);return isNaN(Ve)?De:Ve}constructor(se,De,Ve,Xe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(se,De,Ve,nt),this.validationFn=Xe}validate(se){return this.validationFn(o.float(se,this.defaultValue))}}class t extends u{static string(se,De){return typeof se!="string"?De:se}constructor(se,De,Ve,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.default=Ve),super(se,De,Ve,Xe)}validate(se){return t.string(se,this.defaultValue)}}function h(_,se,De,Ve){return typeof _!="string"?se:Ve&&_ in Ve?Ve[_]:De.indexOf(_)===-1?se:_}e.stringSet=h;class s extends u{constructor(se,De,Ve,Xe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Xe,nt.default=Ve),super(se,De,Ve,nt),this.c=Xe}validate(se){return h(se,this.defaultValue,this.c)}}class d extends C{constructor(se,De,Ve,Xe,nt,rt,je=void 0){typeof je<"u"&&(je.type="string",je.enum=nt,je.default=Xe),super(se,De,Ve,je),this.c=nt,this.d=rt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function l(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,De,Ve){return Ve===0?se.accessibilitySupport:Ve}}class p extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:v.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertSpace:m(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function w(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function y(_){switch(_){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(_){switch(_){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class F extends S{constructor(){super(140)}compute(se,De,Ve){const Xe=["monaco-editor"];return De.get(39)&&Xe.push(De.get(39)),se.extraEditorClassName&&Xe.push(se.extraEditorClassName),De.get(73)==="default"?Xe.push("mouse-default"):De.get(73)==="copy"&&Xe.push("mouse-copy"),De.get(110)&&Xe.push("showUnused"),De.get(138)&&Xe.push("showDeprecated"),Xe.join(" ")}}class z extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(se,De,Ve){return Ve&&se.emptySelectionClipboard}}class j extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:v.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:v.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{cursorMoveOnType:m(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":h(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":h(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(De.loop,this.defaultValue.loop)}}}class O extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?O.OFF:se==="true"?O.ON:se:se?O.ON:O.OFF}}e.EditorFontLigatures=O;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,De,Ve){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class T extends S{constructor(){super(50)}compute(se,De,Ve){return se.fontInfo}}class U extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(se){const De=o.float(se,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(De,6,100)}compute(se,De,Ve){return se.fontInfo.fontSize}}class J extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class ne extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:v.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{multiple:h(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??h(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??h(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??h(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??h(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??h(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:v.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),delay:r.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:m(De.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(De.above,this.defaultValue.above)}}}var Q;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Y extends S{constructor(){super(143)}compute(se,De,Ve){return Y.computeLayout(De,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const De=se.height/se.lineHeight,Ve=Math.floor(se.paddingTop/se.lineHeight);let Xe=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Xe=Math.max(Xe,De-1));const nt=(Ve+se.viewLineCount+Xe)/(se.pixelRatio*se.height),rt=Math.floor(se.viewLineCount/nt);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Xe,desiredRatio:nt,minimapLineCount:rt}}static c(se,De){const Ve=se.outerWidth,Xe=se.outerHeight,nt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Xe};const rt=De.stableMinimapLayoutInput,je=rt&&se.outerHeight===rt.outerHeight&&se.lineHeight===rt.lineHeight&&se.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&se.pixelRatio===rt.pixelRatio&&se.scrollBeyondLastLine===rt.scrollBeyondLastLine&&se.paddingTop===rt.paddingTop&&se.paddingBottom===rt.paddingBottom&&se.minimap.enabled===rt.minimap.enabled&&se.minimap.side===rt.minimap.side&&se.minimap.size===rt.minimap.size&&se.minimap.showSlider===rt.minimap.showSlider&&se.minimap.renderCharacters===rt.minimap.renderCharacters&&se.minimap.maxColumn===rt.minimap.maxColumn&&se.minimap.scale===rt.minimap.scale&&se.verticalScrollbarWidth===rt.verticalScrollbarWidth&&se.isViewportWrapping===rt.isViewportWrapping,yt=se.lineHeight,kt=se.typicalHalfwidthCharacterWidth,Tt=se.scrollBeyondLastLine,Mt=se.minimap.renderCharacters;let St=nt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ei=se.minimap.maxColumn,Vt=se.minimap.size,ni=se.minimap.side,Zt=se.verticalScrollbarWidth,Yt=se.viewLineCount,_e=se.remainingWidth,Ht=se.isViewportWrapping,ti=Mt?2:3;let dt=Math.floor(nt*Xe);const $t=dt/nt;let Jt=!1,ii=!1,At=ti*St,ft=St/nt,Nt=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:zt,extraLinesBeyondLastLine:Lt,desiredRatio:Bt,minimapLineCount:Gt}=Y.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:Tt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Xe,lineHeight:yt,pixelRatio:nt});if(Yt/Gt>1)Jt=!0,ii=!0,St=1,At=1,ft=St/nt;else{let It=!1,qt=St+1;if(Vt==="fit"){const Dt=Math.ceil((zt+Yt+Lt)*At);Ht&&je&&_e<=De.stableFitRemainingWidth?(It=!0,qt=De.stableFitMaxMinimapScale):It=Dt>dt}if(Vt==="fill"||It){Jt=!0;const Dt=St;At=Math.min(yt*nt,Math.max(1,Math.floor(1/Bt))),Ht&&je&&_e<=De.stableFitRemainingWidth&&(qt=De.stableFitMaxMinimapScale),St=Math.min(qt,Math.max(1,Math.floor(At/ti))),St>Dt&&(Nt=Math.min(2,St/Dt)),ft=St/nt/Nt,dt=Math.ceil(Math.max(gt,zt+Yt+Lt)*At),Ht?(De.stableMinimapLayoutInput=se,De.stableFitRemainingWidth=_e,De.stableFitMaxMinimapScale=St):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const oi=Math.floor(ei*ft),Ft=Math.min(oi,Math.max(0,Math.floor((_e-Zt-2)*ft/(kt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(nt*Ft);const jt=Je/nt;Je=Math.floor(Je*Nt);const Ut=Mt?1:2,xt=ni==="left"?0:Ve-Ft-Zt;return{renderMinimap:Ut,minimapLeft:xt,minimapWidth:Ft,minimapHeightIsEditorHeight:Jt,minimapIsSampling:ii,minimapScale:St,minimapLineHeight:At,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:jt,minimapCanvasOuterHeight:$t}}static computeLayout(se,De){const Ve=De.outerWidth|0,Xe=De.outerHeight|0,nt=De.lineHeight|0,rt=De.lineNumbersDigitCount|0,je=De.typicalHalfwidthCharacterWidth,yt=De.maxDigitWidth,kt=De.pixelRatio,Tt=De.viewLineCount,Mt=se.get(135),St=Mt==="inherit"?se.get(134):Mt,ei=St==="inherit"?se.get(130):St,Vt=se.get(133),ni=De.isDominatedByLongLines,Zt=se.get(57),Yt=se.get(67).renderType!==0,_e=se.get(68),Ht=se.get(104),ti=se.get(83),dt=se.get(72),$t=se.get(102),Jt=$t.verticalScrollbarSize,ii=$t.verticalHasArrows,At=$t.arrowSize,ft=$t.horizontalScrollbarSize,Nt=se.get(43),oi=se.get(109)!=="never";let Ft=se.get(65);Nt&&oi&&(Ft+=16);let Je=0;if(Yt){const Pt=Math.max(rt,_e);Je=Math.round(Pt*yt)}let jt=0;Zt&&(jt=nt*De.glyphMarginDecorationLaneCount);let Ut=0,xt=Ut+jt,gt=xt+Je,zt=gt+Ft;const Lt=Ve-jt-Je-Ft;let Bt=!1,Gt=!1,Wt=-1;St==="inherit"&&ni?(Bt=!0,Gt=!0):ei==="on"||ei==="bounded"?Gt=!0:ei==="wordWrapColumn"&&(Wt=Vt);const It=Y.c({outerWidth:Ve,outerHeight:Xe,lineHeight:nt,typicalHalfwidthCharacterWidth:je,pixelRatio:kt,scrollBeyondLastLine:Ht,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:dt,verticalScrollbarWidth:Jt,viewLineCount:Tt,remainingWidth:Lt,isViewportWrapping:Gt},De.memory||new R);It.renderMinimap!==0&&It.minimapLeft===0&&(Ut+=It.minimapWidth,xt+=It.minimapWidth,gt+=It.minimapWidth,zt+=It.minimapWidth);const qt=Lt-It.minimapWidth,Dt=Math.max(1,Math.floor((qt-Jt-2)/je)),pt=ii?At:0;return Gt&&(Wt=Math.max(1,Dt),ei==="bounded"&&(Wt=Math.min(Wt,Vt))),{width:Ve,height:Xe,glyphMarginLeft:Ut,glyphMarginWidth:jt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:xt,lineNumbersWidth:Je,decorationsLeft:gt,decorationsWidth:Ft,contentLeft:zt,contentWidth:qt,minimap:It,viewportColumn:Dt,isWordWrapMinified:Bt,isViewportWrapping:Gt,wrappingColumn:Wt,verticalScrollbarWidth:Jt,horizontalScrollbarHeight:ft,overviewRuler:{top:pt,width:Jt,height:Xe-2*pt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ce extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(se){return h(se,"simple",["simple","advanced"])}compute(se,De,Ve){return De.get(2)===2?"advanced":Ve}}var te;(function(_){_.Off="off",_.OnCode="onCode",_.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class fe extends C{constructor(){const se={enabled:te.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:se.enabled,enumDescriptions:[v.localize(50,null),v.localize(51,null),v.localize(52,null)],description:v.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:h(se.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class re extends C{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:v.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:v.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:v.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:v.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:v.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(59,null),v.localize(60,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(61,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:v.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:v.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:v.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:h(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:m(De.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,De,Ve){return Ve<0?r.clampedInt(-Ve*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ae extends o{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>o.clamp(se,0,150),{markdownDescription:v.localize(66,null)})}compute(se,De,Ve){return se.fontInfo.lineHeight}}class Ee extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:v.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:v.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)],default:se.size,description:v.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:v.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:v.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:v.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:v.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),autohide:m(De.autohide,this.defaultValue.autohide),size:h(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(De.side,this.defaultValue.side,["right","left"]),showSlider:h(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(De.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(De.scale,1,1,3),maxColumn:r.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class de extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{top:r.clampedInt(De.top,0,0,1e3),bottom:r.clampedInt(De.bottom,0,0,1e3)}}}class ue extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:v.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:v.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),cycle:m(De.cycle,this.defaultValue.cycle)}}}class ge extends S{constructor(){super(141)}compute(se,De,Ve){return se.pixelRatio}}class V extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(82,null),v.localize(83,null),v.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:se.strings,description:v.localize(85,null)},comments:{anyOf:De,default:se.comments,description:v.localize(86,null)},other:{anyOf:De,default:se.other,description:v.localize(87,null)}},default:se,markdownDescription:v.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const kt=se?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!se||typeof se!="object")return this.defaultValue;const{other:De,comments:Ve,strings:Xe}=se,nt=["on","inline","off"];let rt,je,yt;return typeof De=="boolean"?rt=De?"on":"off":rt=h(De,this.defaultValue.other,nt),typeof Ve=="boolean"?je=Ve?"on":"off":je=h(Ve,this.defaultValue.comments,nt),typeof Xe=="boolean"?yt=Xe?"on":"off":yt=h(Xe,this.defaultValue.strings,nt),{other:rt,comments:je,strings:yt}}}var Z;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class he extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(89,null),v.localize(90,null),v.localize(91,null),v.localize(92,null)],default:"on",description:v.localize(93,null)})}validate(se){let De=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(De=4,Ve=se):se==="interval"?De=3:se==="relative"?De=2:se==="on"?De=1:De=0),{renderType:De,renderFn:Ve}}}function be(_){const se=_.get(97);return se==="editable"?_.get(90):se!=="on"}e.filterValidationDecorations=be;class Pe extends C{constructor(){const se=[],De={type:"number",description:v.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:v.localize(95,null),format:"color-hex"}}}]},default:se,description:v.localize(96,null)})}validate(se){if(Array.isArray(se)){const De=[];for(const Ve of se)if(typeof Ve=="number")De.push({column:r.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Xe=Ve;De.push({column:r.clampedInt(Xe.column,0,0,1e4),color:Xe.color})}return De.sort((Ve,Xe)=>Ve.column-Xe.column),De}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Le(_,se){if(typeof _!="string")return se;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ne extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(97,null),v.localize(98,null),v.localize(99,null)],default:"auto",description:v.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(101,null),v.localize(102,null),v.localize(103,null)],default:"auto",description:v.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:v.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:v.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:v.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se,Ve=r.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Xe=r.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Le(De.vertical,this.defaultValue.vertical),horizontal:Le(De.horizontal,this.defaultValue.horizontal),useShadows:m(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:r.clampedInt(De.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Xe,verticalSliderSize:r.clampedInt(De.verticalSliderSize,Xe,0,1e3),scrollByPage:m(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:v.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:v.localize(115,null)}})}applyUpdate(se,De){let Ve=!1;De.allowedCharacters&&se&&(N.$Dn(se.allowedCharacters,De.allowedCharacters)||(se={...se,allowedCharacters:De.allowedCharacters},Ve=!0)),De.allowedLocales&&se&&(N.$Dn(se.allowedLocales,De.allowedLocales)||(se={...se,allowedLocales:De.allowedLocales},Ve=!0));const Xe=super.applyUpdate(se,De);return Ve?new b(Xe.newValue,!0):Xe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{nonBasicASCII:oe(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:oe(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:oe(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,De){if(typeof se!="object"||!se)return De;const Ve={};for(const[Xe,nt]of Object.entries(se))nt===!0&&(Ve[Xe]=!0);return Ve}}class x extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:v.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(117,null),v.localize(118,null),v.localize(119,null)],description:v.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:v.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:v.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),mode:h(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class H extends C{constructor(){const se={enabled:P.$vs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$vs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class X extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:se.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:se.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:se.highlightActiveIndentation,description:v.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{bracketPairs:oe(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:oe(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function oe(_,se,De){const Ve=De.indexOf(_);return Ve===-1?se:De[Ve]}class ve extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:se.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:se.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertMode:h(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(De.showIcons,this.defaultValue.showIcons),showStatusBar:m(De.showStatusBar,this.defaultValue.showStatusBar),preview:m(De.preview,this.defaultValue.preview),previewMode:h(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(De.showMethods,this.defaultValue.showMethods),showFunctions:m(De.showFunctions,this.defaultValue.showFunctions),showConstructors:m(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(De.showFields,this.defaultValue.showFields),showVariables:m(De.showVariables,this.defaultValue.showVariables),showClasses:m(De.showClasses,this.defaultValue.showClasses),showStructs:m(De.showStructs,this.defaultValue.showStructs),showInterfaces:m(De.showInterfaces,this.defaultValue.showInterfaces),showModules:m(De.showModules,this.defaultValue.showModules),showProperties:m(De.showProperties,this.defaultValue.showProperties),showEvents:m(De.showEvents,this.defaultValue.showEvents),showOperators:m(De.showOperators,this.defaultValue.showOperators),showUnits:m(De.showUnits,this.defaultValue.showUnits),showValues:m(De.showValues,this.defaultValue.showValues),showConstants:m(De.showConstants,this.defaultValue.showConstants),showEnums:m(De.showEnums,this.defaultValue.showEnums),showEnumMembers:m(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(De.showKeywords,this.defaultValue.showKeywords),showWords:m(De.showWords,this.defaultValue.showWords),showColors:m(De.showColors,this.defaultValue.showColors),showFiles:m(De.showFiles,this.defaultValue.showFiles),showReferences:m(De.showReferences,this.defaultValue.showReferences),showFolders:m(De.showFolders,this.defaultValue.showFolders),showTypeParameters:m(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(De.showSnippets,this.defaultValue.showSnippets),showUsers:m(De.showUsers,this.defaultValue.showUsers),showIssues:m(De.showIssues,this.defaultValue.showIssues)}}}class Me extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class Ge extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,De,Ve){return De.get(2)===2?0:Ve}}class Ye extends S{constructor(){super(144)}compute(se,De,Ve){const Xe=De.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Xe.isWordWrapMinified,isViewportWrapping:Xe.isViewportWrapping,wrappingColumn:Xe.wrappingColumn}}}class it extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),showDropSelector:h(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:m(De.enabled,this.defaultValue.enabled),showPasteSelector:h(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ot="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",Ae="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?et:f.$k?Ae:ot,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(_){return e.editorOptionsRegistry[_.id]=_,_}var He;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(He||(e.EditorOption=He={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:ke(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:ke(new c),accessibilityPageSize:ke(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:ke(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:ke(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:ke(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:ke(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:ke(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:ke(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:ke(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:ke(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:ke(new a(13,"automaticLayout",!1)),autoSurround:ke(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:ke(new H),bracketPairGuides:ke(new X),stickyTabStops:ke(new a(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:ke(new a(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:ke(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:ke(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:ke(new a(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:ke(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:ke(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:ke(new a(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:ke(new p),contextmenu:ke(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new a(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:ke(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:ke(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:ke(new d(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:v.localize(248,null)})),cursorSurroundingLines:ke(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:ke(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:ke(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:ke(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new a(34,"domReadOnly",!1)),dragAndDrop:ke(new a(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:ke(new z),dropIntoEditor:ke(new it),stickyScroll:ke(new re),experimentalWhitespaceRendering:ke(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:ke(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ke(new o(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:v.localize(259,null)})),find:ke(new j),fixedOverflowWidgets:ke(new a(42,"fixedOverflowWidgets",!1)),folding:ke(new a(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:ke(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:ke(new a(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:ke(new a(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:ke(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:ke(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:ke(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:ke(new T),fontLigatures2:ke(new O),fontSize:ke(new U),fontWeight:ke(new J),fontVariations:ke(new M),formatOnPaste:ke(new a(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:ke(new a(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:ke(new a(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:ke(new ne),hideCursorInOverviewRuler:ke(new a(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:ke(new ee),inDiffEditor:ke(new a(61,"inDiffEditor",!1)),letterSpacing:ke(new o(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>o.clamp(_,-5,20),{description:v.localize(273,null)})),lightbulb:ke(new fe),lineDecorationsWidth:ke(new B),lineHeight:ke(new ae),lineNumbers:ke(new he),lineNumbersMinChars:ke(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new a(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:ke(new a(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:ke(new s(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:ke(new Ee),mouseStyle:ke(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new o(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:ke(new a(75,"mouseWheelZoom",!1,{markdownDescription:f.$j?v.localize(278,null):v.localize(279,null)})),multiCursorMergeOverlapping:ke(new a(76,"multiCursorMergeOverlapping",!0,{description:v.localize(280,null)})),multiCursorModifier:ke(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[v.localize(281,null),v.localize(282,null)],markdownDescription:v.localize(283,null)})),multiCursorPaste:ke(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(284,null),v.localize(285,null)],markdownDescription:v.localize(286,null)})),multiCursorLimit:ke(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(287,null)})),occurrencesHighlight:ke(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(288,null),v.localize(289,null),v.localize(290,null)],markdownDescription:v.localize(291,null)})),overviewRulerBorder:ke(new a(81,"overviewRulerBorder",!0,{description:v.localize(292,null)})),overviewRulerLanes:ke(new r(82,"overviewRulerLanes",3,0,3)),padding:ke(new de),pasteAs:ke(new ut),parameterHints:ke(new ue),peekWidgetDefaultFocus:ke(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(293,null),v.localize(294,null)],description:v.localize(295,null)})),definitionLinkOpensInPeek:ke(new a(87,"definitionLinkOpensInPeek",!1,{description:v.localize(296,null)})),quickSuggestions:ke(new V),quickSuggestionsDelay:ke(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(297,null)})),readOnly:ke(new a(90,"readOnly",!1)),readOnlyMessage:ke(new pe),renameOnType:ke(new a(92,"renameOnType",!1,{description:v.localize(298,null),markdownDeprecationMessage:v.localize(299,null)})),renderControlCharacters:ke(new a(93,"renderControlCharacters",!0,{description:v.localize(300,null),restricted:!0})),renderFinalNewline:ke(new s(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:v.localize(301,null)})),renderLineHighlight:ke(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(302,null)],description:v.localize(303,null)})),renderLineHighlightOnlyWhenFocus:ke(new a(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(304,null)})),renderValidationDecorations:ke(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(305,null),v.localize(306,null),v.localize(307,null),""],description:v.localize(308,null)})),revealHorizontalRightPadding:ke(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new a(100,"roundedSelection",!0,{description:v.localize(309,null)})),rulers:ke(new Pe),scrollbar:ke(new Ne),scrollBeyondLastColumn:ke(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(310,null)})),scrollBeyondLastLine:ke(new a(104,"scrollBeyondLastLine",!0,{description:v.localize(311,null)})),scrollPredominantAxis:ke(new a(105,"scrollPredominantAxis",!0,{description:v.localize(312,null)})),selectionClipboard:ke(new a(106,"selectionClipboard",!0,{description:v.localize(313,null),included:f.$k})),selectionHighlight:ke(new a(107,"selectionHighlight",!0,{description:v.localize(314,null)})),selectOnLineNumbers:ke(new a(108,"selectOnLineNumbers",!0)),showFoldingControls:ke(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(315,null),v.localize(316,null),v.localize(317,null)],description:v.localize(318,null)})),showUnused:ke(new a(110,"showUnused",!0,{description:v.localize(319,null)})),showDeprecated:ke(new a(138,"showDeprecated",!0,{description:v.localize(320,null)})),inlayHints:ke(new K),snippetSuggestions:ke(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null),v.localize(324,null)],description:v.localize(325,null)})),smartSelect:ke(new Me),smoothScrolling:ke(new a(113,"smoothScrolling",!1,{description:v.localize(326,null)})),stopRenderingLineAfter:ke(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new ve),inlineSuggest:ke(new x),inlineCompletionsAccessibilityVerbose:ke(new a(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(327,null)})),suggestFontSize:ke(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new a(120,"suggestOnTriggerCharacters",!0,{description:v.localize(330,null)})),suggestSelection:ke(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(331,null),v.localize(332,null),v.localize(333,null)],description:v.localize(334,null)})),tabCompletion:ke(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(335,null),v.localize(336,null),v.localize(337,null)],description:v.localize(338,null)})),tabIndex:ke(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new W),unusualLineTerminators:ke(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),useShadowDOM:ke(new a(126,"useShadowDOM",!0)),useTabStops:ke(new a(127,"useTabStops",!0,{description:v.localize(343,null)})),wordBreak:ke(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(344,null),v.localize(345,null)],description:v.localize(346,null)})),wordSeparators:ke(new t(129,"wordSeparators",A.$ws,{description:v.localize(347,null)})),wordWrap:ke(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(348,null),v.localize(349,null),v.localize(350,null),v.localize(351,null)],description:v.localize(352,null)})),wordWrapBreakAfterCharacters:ke(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(353,null)})),wordWrapOverride1:ke(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new F),defaultColorDecorators:ke(new a(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(354,null)})),pixelRatio:ke(new ge),tabFocusMode:ke(new a(142,"tabFocusMode",!1,{markdownDescription:v.localize(355,null)})),layoutInfo:ke(new Y),wrappingInfo:ke(new Ye),wrappingIndent:ke(new Ge),wrappingStrategy:ke(new ce)}}),define(Ce[196],Ie([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Ce[83],Ie([1,0,79,2,169,29,179,196]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Pt=e.$Ot=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Nt=e.$Mt=e.SymbolKinds=e.SymbolTag=e.$Lt=e.$Kt=e.SymbolKind=e.$Jt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$It=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Ht=e.$Gt=e.$Ft=void 0;class ${constructor(O,M,T){this.offset=O,this.type=M,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ft=$;class k{constructor(O,M){this.tokens=O,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Gt=k;class R{constructor(O,M){this.tokens=O,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Ht=R;var C;(function(j){j[j.Method=0]="Method",j[j.Function=1]="Function",j[j.Constructor=2]="Constructor",j[j.Field=3]="Field",j[j.Variable=4]="Variable",j[j.Class=5]="Class",j[j.Struct=6]="Struct",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Event=10]="Event",j[j.Operator=11]="Operator",j[j.Unit=12]="Unit",j[j.Value=13]="Value",j[j.Constant=14]="Constant",j[j.Enum=15]="Enum",j[j.EnumMember=16]="EnumMember",j[j.Keyword=17]="Keyword",j[j.Text=18]="Text",j[j.Color=19]="Color",j[j.File=20]="File",j[j.Reference=21]="Reference",j[j.Customcolor=22]="Customcolor",j[j.Folder=23]="Folder",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue",j[j.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var b;(function(j){const O=new Map;O.set(0,D.$ck.symbolMethod),O.set(1,D.$ck.symbolFunction),O.set(2,D.$ck.symbolConstructor),O.set(3,D.$ck.symbolField),O.set(4,D.$ck.symbolVariable),O.set(5,D.$ck.symbolClass),O.set(6,D.$ck.symbolStruct),O.set(7,D.$ck.symbolInterface),O.set(8,D.$ck.symbolModule),O.set(9,D.$ck.symbolProperty),O.set(10,D.$ck.symbolEvent),O.set(11,D.$ck.symbolOperator),O.set(12,D.$ck.symbolUnit),O.set(13,D.$ck.symbolValue),O.set(15,D.$ck.symbolEnum),O.set(14,D.$ck.symbolConstant),O.set(15,D.$ck.symbolEnum),O.set(16,D.$ck.symbolEnumMember),O.set(17,D.$ck.symbolKeyword),O.set(27,D.$ck.symbolSnippet),O.set(18,D.$ck.symbolText),O.set(19,D.$ck.symbolColor),O.set(20,D.$ck.symbolFile),O.set(21,D.$ck.symbolReference),O.set(22,D.$ck.symbolCustomColor),O.set(23,D.$ck.symbolFolder),O.set(24,D.$ck.symbolTypeParameter),O.set(25,D.$ck.account),O.set(26,D.$ck.issues);function M(J){let ne=O.get(J);return ne||(console.info("No codicon found for CompletionItemKind "+J),ne=D.$ck.symbolProperty),ne}j.toIcon=M;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function U(J,ne){let ee=T.get(J);return typeof ee>"u"&&!ne&&(ee=9),ee}j.fromString=U})(b||(e.CompletionItemKinds=b={}));var E;(function(j){j[j.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(j){j[j.None=0]="None",j[j.KeepWhitespace=1]="KeepWhitespace",j[j.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var u;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var m;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class a{constructor(O,M,T,U){this.range=O,this.text=M,this.completionKind=T,this.isSnippetText=U}equals(O){return P.$Xs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$It=a;var i;(function(j){j[j.Invoke=1]="Invoke",j[j.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function o(j){return j&&N.URI.isUri(j.uri)&&P.$Xs.isIRange(j.range)&&(P.$Xs.isIRange(j.originSelectionRange)||P.$Xs.isIRange(j.targetSelectionRange))}e.$Jt=o;var t;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Kt={17:(0,v.localize)(0,null),16:(0,v.localize)(1,null),4:(0,v.localize)(2,null),13:(0,v.localize)(3,null),8:(0,v.localize)(4,null),9:(0,v.localize)(5,null),21:(0,v.localize)(6,null),23:(0,v.localize)(7,null),7:(0,v.localize)(8,null),0:(0,v.localize)(9,null),11:(0,v.localize)(10,null),10:(0,v.localize)(11,null),19:(0,v.localize)(12,null),5:(0,v.localize)(13,null),1:(0,v.localize)(14,null),2:(0,v.localize)(15,null),20:(0,v.localize)(16,null),15:(0,v.localize)(17,null),18:(0,v.localize)(18,null),24:(0,v.localize)(19,null),3:(0,v.localize)(20,null),6:(0,v.localize)(21,null),14:(0,v.localize)(22,null),22:(0,v.localize)(23,null),25:(0,v.localize)(24,null),12:(0,v.localize)(25,null)};function h(j,O){return(0,v.localize)(26,null,j,e.$Kt[O])}e.$Lt=h;var s;(function(j){j[j.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var d;(function(j){const O=new Map;O.set(0,D.$ck.symbolFile),O.set(1,D.$ck.symbolModule),O.set(2,D.$ck.symbolNamespace),O.set(3,D.$ck.symbolPackage),O.set(4,D.$ck.symbolClass),O.set(5,D.$ck.symbolMethod),O.set(6,D.$ck.symbolProperty),O.set(7,D.$ck.symbolField),O.set(8,D.$ck.symbolConstructor),O.set(9,D.$ck.symbolEnum),O.set(10,D.$ck.symbolInterface),O.set(11,D.$ck.symbolFunction),O.set(12,D.$ck.symbolVariable),O.set(13,D.$ck.symbolConstant),O.set(14,D.$ck.symbolString),O.set(15,D.$ck.symbolNumber),O.set(16,D.$ck.symbolBoolean),O.set(17,D.$ck.symbolArray),O.set(18,D.$ck.symbolObject),O.set(19,D.$ck.symbolKey),O.set(20,D.$ck.symbolNull),O.set(21,D.$ck.symbolEnumMember),O.set(22,D.$ck.symbolStruct),O.set(23,D.$ck.symbolEvent),O.set(24,D.$ck.symbolOperator),O.set(25,D.$ck.symbolTypeParameter);function M(T){let U=O.get(T);return U||(console.info("No codicon found for SymbolKind "+T),U=D.$ck.symbolProperty),U}j.toIcon=M})(d||(e.SymbolKinds=d={}));class l{static asEditOperation(O){return f.$Ys.replace(P.$Xs.lift(O.range),O.text)}}e.$Mt=l;class c{static{this.Comment=new c("comment")}static{this.Imports=new c("imports")}static{this.Region=new c("region")}static fromValue(O){switch(O){case"comment":return c.Comment;case"imports":return c.Imports;case"region":return c.Region}return new c(O)}constructor(O){this.value=O}}e.$Nt=c;var p;(function(j){function O(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}j.is=O})(p||(e.Command=p={}));var I;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var w;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var g;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var y;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(y||(e.CommentState=y={}));var L;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class F{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ot=F,e.$Pt=new A.$wt;var z;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(Ce[197],Ie([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[198],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[199],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[200],Ie([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Ce[201],Ie([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[202],Ie([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[203],Ie([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[204],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Ce[205],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Ce[206],Ie([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[207],Ie([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Ce[208],Ie([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[209],Ie([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[210],Ie([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Ce[211],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[212],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ce[213],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[214],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[215],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[216],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[217],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[218],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[219],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[220],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[221],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[222],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[223],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[224],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[225],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Ce[226],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Ce[227],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Ce[228],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[229],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[230],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[231],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[232],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[233],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[234],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[235],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[236],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ce[237],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[238],Ie([1,0,14,199]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.TokenType=void 0;var f;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(f||(e.TokenType=f={}));function P(...k){switch(k.length){case 1:return(0,N.localize)(0,null,k[0]);case 2:return(0,N.localize)(1,null,k[0],k[1]);case 3:return(0,N.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,N.localize)(3,null),v=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,b=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:b};this.g.push({offset:C,lexeme:b,additionalInfo:R}),this.f.push(E)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),b=$.b.get(C);b?this.k(b):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,b=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(v);return}const S=this.c.charCodeAt(R);if(C)C=!1;else if(S===47&&!b){R++;break}else S===91?b=!0:S===92?C=!0:S===93&&(b=!1);R++}for(;R<this.c.length&&$.a.has(this.c.charCodeAt(R));)R++;this.e=R;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$4i=$}),define(Ce[239],Ie([1,0,23,39,202,389]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||A.test(a)}e.$dp=$;function k(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=a.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$ep=k;function R(a){if(!a)return null;const i=a.majorBase,r=a.majorMustEqual,n=a.minorBase;let o=a.minorMustEqual;const t=a.patchBase;let h=a.patchMustEqual;a.hasCaret&&(i===0||(o=!1),h=!1);let s=0;if(a.preRelease){const d=v.exec(a.preRelease);if(d){const[,l,c,p]=d;s=Date.UTC(Number(l),Number(c)-1,Number(p))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:o,patchBase:t,patchMustEqual:h,isMinimum:a.hasGreaterEquals,notBefore:s}}e.$fp=R;function C(a,i,r){let n;typeof a=="string"?n=R(k(a)):n=a;let o;i instanceof Date?o=i.getTime():typeof i=="string"&&(o=new Date(i).getTime());let t;if(typeof r=="string"?t=R(k(r)):t=r,!n||!t)return!1;const h=n.majorBase,s=n.minorBase,d=n.patchBase;let l=t.majorBase,c=t.minorBase,p=t.patchBase;const I=t.notBefore;let w=t.majorMustEqual,g=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?h>l?!0:h<l?!1:s>c?!0:s<c||o&&o<I?!1:d>=p:(h===1&&l===0&&(!w||!g||!y)&&(l=1,c=0,p=0,w=!0,g=!1,y=!1),h<l?!1:h>l?!w:s<c?!1:s>c?!g:d<p?!1:d>p?!y:!(o&&o<I))}e.$gp=C;function b(a,i,r,n,o){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([N.default.Error,f.localize(0,null)]),t;if(typeof n.name!="string")return t.push([N.default.Error,f.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([N.default.Error,f.localize(2,null,"version")]),t;if(!n.engines)return t.push([N.default.Error,f.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([N.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!m(n.extensionDependencies))return t.push([N.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!m(n.activationEvents))return t.push([N.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([N.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([N.default.Warning,f.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([N.default.Error,f.localize(9,null,"main")]),t;{const d=(0,D.$Jg)(r,n.main);(0,D.$Dg)(d,r)||t.push([N.default.Warning,f.localize(10,null,d.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([N.default.Error,f.localize(11,null,"browser")]),t;{const d=(0,D.$Jg)(r,n.browser);(0,D.$Dg)(d,r)||t.push([N.default.Warning,f.localize(12,null,d.path,r.path)])}}if(!P.valid(n.version))return t.push([N.default.Error,f.localize(13,null)]),t;const h=[];if(!E(a,i,n,o,h))for(const d of h)t.push([N.default.Error,d]);return t}e.$hp=b;function E(a,i,r,n,o){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:u(a,i,r.engines.vscode,o)}e.$ip=E;function S(a,i,r){return a==="*"||u(i,r,a)}e.$jp=S;function u(a,i,r,n=[]){const o=R(k(r));if(!o)return n.push(f.localize(14,null,r)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return n.push(f.localize(15,null,r)),!1}else if(!o.majorMustEqual)return n.push(f.localize(16,null,r)),!1;return C(a,i,o)?!0:(n.push(f.localize(17,null,a,r)),!1)}function m(a){if(!Array.isArray(a))return!1;for(let i=0,r=a.length;i<r;i++)if(typeof a[i]!="string")return!1;return!0}}),define(Ce[105],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class D{constructor(f,P=[],A=!1){this.ctor=f,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$6h=D}),define(Ce[84],Ie([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=e.$2r=e.InstantiationType=void 0;const N=[];var f;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function P(v,$,k){$ instanceof D.$6h||($=new D.$6h($,[],!!k)),N.push([v,$])}e.$2r=P;function A(){return N}e.$3r=A}),define(Ce[240],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;class D{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Fq=D;class N{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const v=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(A);v.outgoing.set($.key,$),$.incoming.set(v.key,v)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const v of this.a.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let v=this.a.get(A);return v||(v=new D(A,P),this.a.set(A,v)),v}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,v]of this.a)P.push(`${A}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const v=new Set([P]),$=this.c(A,v);if($)return $}}c(P,A){for(const[v,$]of P.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const k=this.c($,A);if(k)return k;A.delete(v)}}}e.$Gq=N}),define(Ce[5],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=e.$8h=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function v($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=v})(D||(e._util=D={})),e.$8h=f("instantiationService");function N(A,v,$){v[D.DI_TARGET]===v?v[D.DI_DEPENDENCIES].push({id:A,index:$}):(v[D.DI_DEPENDENCIES]=[{id:A,index:$}],v[D.DI_TARGET]=v)}function f(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const v=function($,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(v,$,R)};return v.toString=()=>A,D.serviceIds.set(A,v),v}e.$9h=f;function P(A){return A}e.$0h=P}),define(Ce[51],Ie([1,0,18,2,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ConfigurationTarget=e.$Ei=e.$Di=e.$Ci=void 0,e.$Ci=(0,f.$9h)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}e.$Di=P;function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}e.$Ei=A;var v;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Fi=$;function k(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}e.$Gi=k;function R(a,i){const r=Object.create(null);for(const n in a)C(r,n,a[n],i);return r}e.$Hi=R;function C(a,i,r,n){const o=i.split("."),t=o.pop();let h=a;for(let s=0;s<o.length;s++){const d=o[s];let l=h[d];switch(typeof l){case"undefined":l=h[d]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}h=l}if(typeof h=="object"&&h!==null)try{h[t]=r}catch{n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}else n(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(h)}`)}e.$Ii=C;function b(a,i){const r=i.split(".");E(a,r)}e.$Ji=b;function E(a,i){const r=i.shift();if(i.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const n=a[r];typeof n=="object"&&!Array.isArray(n)&&(E(n,i),Object.keys(n).length===0&&delete a[r])}}function S(a,i,r){function n(h,s){let d=h;for(const l of s){if(typeof d!="object"||d===null)return;d=d[l]}return d}const o=i.split("."),t=n(a,o);return typeof t>"u"?r:t}e.$Ki=S;function u(a,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in a?D.$Mf(a[n])&&D.$Mf(i[n])?u(a[n],i[n],r):r&&(a[n]=i[n]):a[n]=i[n])})}e.$Li=u;function m(a){return a.replace(/[\[\]]/g,"")}e.$Mi=m}),define(Ce[45],Ie([1,0,11,12,238,5,198,14]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.ContextKeyExprType=e.$5i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function k(K,B){if($.get(K)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,B)}e.$5i=k;const R=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const b={regexParsingWithErrorRecovery:!0},E=(0,A.localize)(0,null),S=(0,A.localize)(1,null),u=(0,A.localize)(2,null),m=(0,A.localize)(3,null),a=(0,A.localize)(4,null),i=(0,A.localize)(5,null),r=(0,A.localize)(6,null),n=(0,A.localize)(7,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=b){this.k=B,this.d=new f.$4i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const Ee=this.D(),le=Ee.type===17?i:void 0;throw this.h.push({message:a,offset:Ee.offset,lexeme:f.$4i.getLexeme(Ee),additionalInfo:le}),o.c}return ae}catch(ae){if(ae!==o.c)throw ae;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ae=this.o();B.push(ae)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ae=this.s();B.push(ae)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const ae=this.l();return this.A(1,m),ae?.negate()}case 17:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ae=this.l();return this.A(1,m),ae}case 17:{const ae=B.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const de=le.lexeme,ue=de.lastIndexOf("/"),ge=ue===de.length-1?void 0:this.w(de.substring(ue+1));let V;try{V=new RegExp(de.substring(1,ue),ge)}catch{throw this.B("REGEX",le)}return T.create(ae,V)}switch(le.type){case 10:case 19:{const de=[le.lexeme];this.z();let ue=this.D(),ge=0;for(let Pe=0;Pe<le.lexeme.length;Pe++)le.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Pe=0;Pe<ue.lexeme.length;Pe++)ue.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--}if(ge<0)break;de.push(f.$4i.getLexeme(ue)),this.z(),ue=this.D()}const V=de.join(""),Z=V.lastIndexOf("/"),he=Z===V.length-1?void 0:this.w(V.substring(Z+1));let be;try{be=new RegExp(V.substring(1,Z),he)}catch{throw this.B("REGEX",le)}return t.regex(ae,be)}case 18:{const de=le.lexeme;this.z();let ue=null;if(!(0,N.$Ke)(de)){const ge=de.indexOf("/"),V=de.lastIndexOf("/");if(ge!==V&&ge>=0){const Z=de.slice(ge+1,V),he=de[V+1]==="i"?"i":"";try{ue=new RegExp(Z,he)}catch{throw this.B("REGEX",le)}}}if(ue===null)throw this.B("REGEX",le);return T.create(ae,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const le=this.u();return t.notIn(ae,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ae,le);switch(le){case"true":return t.has(ae);case"false":return t.not(ae);default:return t.equals(ae,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ae,le);switch(le){case"true":return t.not(ae);case"false":return t.has(ae);default:return t.notEquals(ae,le)}}case 5:return this.z(),O.create(ae,this.u());case 6:return this.z(),M.create(ae,this.u());case 7:return this.z(),z.create(ae,this.u());case 8:return this.z(),j.create(ae,this.u());case 13:return this.z(),t.in(ae,this.u());default:return t.has(ae)}}case 20:throw this.h.push({message:r,offset:B.offset,lexeme:"",additionalInfo:n}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ae){if(this.C(B))return this.z();throw this.B(ae,this.D())}B(B,ae,Ee){const le=(0,A.localize)(8,null,B,f.$4i.getLexeme(ae)),de=ae.offset,ue=f.$4i.getLexeme(ae);return this.h.push({message:le,offset:de,lexeme:ue,additionalInfo:Ee}),o.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$6i=o;class t{static false(){return l.INSTANCE}static true(){return c.INSTANCE}static has(B){return p.create(B)}static equals(B,ae){return I.create(B,ae)}static notEquals(B,ae){return y.create(B,ae)}static regex(B,ae){return T.create(B,ae)}static in(B,ae){return w.create(B,ae)}static notIn(B,ae){return g.create(B,ae)}static not(B){return L.create(B)}static and(...B){return ne.create(B,null,!0)}static or(...B){return ee.create(B,null,!0)}static greater(B,ae){return z.create(B,ae)}static greaterEquals(B,ae){return j.create(B,ae)}static smaller(B,ae){return O.create(B,ae)}static smallerEquals(B,ae){return M.create(B,ae)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$7i=t;function h(K){const B=new o({regexParsingWithErrorRecovery:!1});return K.map(ae=>(B.parse(ae),B.lexingErrors.length>0?B.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,A.localize)(9,null,Ee.additionalInfo):(0,A.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$8i=h;function s(K,B){const ae=K?K.substituteConstants():void 0,Ee=B?B.substituteConstants():void 0;return!ae&&!Ee?!0:!ae||!Ee?!1:ae.equals(Ee)}e.$9i=s;function d(K,B){return K.cmp(B)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return c.INSTANCE}}e.$0i=l;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.$$i=c;class p{static create(B,ae=null){const Ee=$.get(B);return typeof Ee=="boolean"?Ee?c.INSTANCE:l.INSTANCE:new p(B,ae)}constructor(B,ae){this.key=B,this.c=ae,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?c.INSTANCE:l.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$_i=p;class I{static create(B,ae,Ee=null){if(typeof ae=="boolean")return ae?p.create(B,Ee):L.create(B,Ee);const le=$.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?c.INSTANCE:l.INSTANCE:new I(B,ae,Ee)}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?c.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$aj=I;class w{static create(B,ae){return new w(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.f),Ee=B.getValue(this.d);return Array.isArray(ae)?ae.includes(Ee):typeof Ee=="string"&&typeof ae=="object"&&ae!==null?R.call(ae,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$bj=w;class g{static create(B,ae){return new g(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=11,this.c=w.create(B,ae)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$cj=g;class y{static create(B,ae,Ee=null){if(typeof ae=="boolean")return ae?L.create(B,Ee):p.create(B,Ee);const le=$.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?l.INSTANCE:c.INSTANCE:new y(B,ae,Ee)}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?l.INSTANCE:c.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$dj=y;class L{static create(B,ae=null){const Ee=$.get(B);return typeof Ee=="boolean"?Ee?l.INSTANCE:c.INSTANCE:new L(B,ae)}constructor(B,ae){this.c=B,this.d=ae,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?l.INSTANCE:c.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$ej=L;function F(K,B){if(typeof K=="string"){const ae=parseFloat(K);isNaN(ae)||(K=ae)}return typeof K=="string"||typeof K=="number"?B(K):l.INSTANCE}class z{static create(B,ae,Ee=null){return F(ae,le=>new z(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$fj=z;class j{static create(B,ae,Ee=null){return F(ae,le=>new j(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$gj=j;class O{static create(B,ae,Ee=null){return F(ae,le=>new O(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$hj=O;class M{static create(B,ae,Ee=null){return F(ae,le=>new M(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$ij=M;class T{static create(B,ae){return new T(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ae=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return ae<Ee?-1:ae>Ee?1:0}equals(B){if(B.type===this.type){const ae=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return this.d===B.d&&ae===Ee}return!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$jj=T;class U{static create(B){return new U(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new U(this.c.map(B))}negate(){return this.c}}e.$kj=U;function J(K){let B=null;for(let ae=0,Ee=K.length;ae<Ee;ae++){const le=K[ae].substituteConstants();if(K[ae]!==le&&B===null){B=[];for(let de=0;de<ae;de++)B[de]=K[de]}B!==null&&(B[ae]=le)}return B===null?K:B}class ne{static create(B,ae,Ee){return ne.d(B,ae,Ee)}constructor(B,ae){this.expr=B,this.c=ae,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++){const le=d(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=J(this.expr);return B===this.expr?this:ne.create(B,this.c,!1)}evaluate(B){for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].evaluate(B))return!1;return!0}static d(B,ae,Ee){const le=[];let de=!1;for(const ue of B)if(ue){if(ue.type===1){de=!0;continue}if(ue.type===0)return l.INSTANCE;if(ue.type===6){le.push(...ue.expr);continue}le.push(ue)}if(le.length===0&&de)return c.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(d);for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];for(;le.length>1;){const ue=le[le.length-1];if(ue.type!==9)break;le.pop();const ge=le.pop(),V=le.length===0,Z=ee.create(ue.expr.map(he=>ne.create([he,ge],null,Ee)),null,V);Z&&(le.push(Z),le.sort(d))}if(le.length===1)return le[0];if(Ee){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return l.INSTANCE;if(le.length===1)return le[0]}return new ne(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new ne(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());this.c=ee.create(B,this,!0)}return this.c}}e.$lj=ne;class ee{static create(B,ae,Ee){return ee.d(B,ae,Ee)}constructor(B,ae){this.expr=B,this.c=ae,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++){const le=d(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=J(this.expr);return B===this.expr?this:ee.create(B,this.c,!1)}evaluate(B){for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(this.expr[ae].evaluate(B))return!0;return!1}static d(B,ae,Ee){let le=[],de=!1;if(B){for(let ue=0,ge=B.length;ue<ge;ue++){const V=B[ue];if(V){if(V.type===0){de=!0;continue}if(V.type===1)return c.INSTANCE;if(V.type===9){le=le.concat(V.expr);continue}le.push(V)}}if(le.length===0&&de)return l.INSTANCE;le.sort(d)}if(le.length!==0){if(le.length===1)return le[0];for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];if(Ee){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return c.INSTANCE;if(le.length===1)return le[0]}return new ee(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new ee(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());for(;B.length>1;){const ae=B.shift(),Ee=B.shift(),le=[];for(const de of re(ae))for(const ue of re(Ee))le.push(ne.create([de,ue],null,!1));B.unshift(ee.create(le,null,!1))}this.c=ee.create(B,this,!0)}return this.c}}e.$mj=ee;class Q extends p{static{this.d=[]}static all(){return Q.d.values()}constructor(B,ae,Ee){super(B,null),this.f=ae,typeof Ee=="object"?Q.d.push({...Ee,key:B}):Ee!==!0&&Q.d.push({key:B,description:Ee,type:ae!=null?typeof ae:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return I.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$nj=Q,e.$oj=(0,P.$9h)("contextKeyService");function Y(K,B){return K<B?-1:K>B?1:0}function ce(K,B,ae,Ee){return K<ae?-1:K>ae?1:B<Ee?-1:B>Ee?1:0}function te(K,B){if(K.type===0||B.type===1)return!0;if(K.type===9)return B.type===9?fe(K.expr,B.expr):!1;if(B.type===9){for(const ae of B.expr)if(te(K,ae))return!0;return!1}if(K.type===6){if(B.type===6)return fe(B.expr,K.expr);for(const ae of K.expr)if(te(ae,B))return!0;return!1}return K.equals(B)}e.$pj=te;function fe(K,B){let ae=0,Ee=0;for(;ae<K.length&&Ee<B.length;){const le=K[ae].cmp(B[Ee]);if(le<0)return!1;le===0&&ae++,Ee++}return ae===K.length}function re(K){return K.type===9?K.expr:[K]}}),define(Ce[241],Ie([1,0,23,39,200,5,102,11,24]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.ConfirmResult=e.$$v=e.$0v=e.$9v=void 0,e.$9v=(0,P.$9h)("dialogService");var k;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(k||(k={}));class R{a(m){return this.d(m,k.Confirmation)}b(m){return this.d(m,k.Prompt)}c(m){return this.d(m,k.Input)}d(m,a){const i=[];switch(a){case k.Confirmation:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(1,null));break}case k.Prompt:{const r=m;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case k.Input:{const r=m;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,a,i){const r=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&r.push(m.cancelButton);let n=r[a]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$0v=R,e.$$v=(0,P.$9h)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const b=10;function E(u){const m=[];return m.push(...u.slice(0,b).map(a=>typeof a=="string"?a:(0,D.$Gg)(a))),u.length>b&&(u.length-b===1?m.push((0,f.localize)(7,null)):m.push((0,f.localize)(8,null,u.length-b))),m.push(""),m.join(`
`)}e.$_v=E;function S(u,m){const a=(0,$.$zn)(u);let i=(a.buttons??[]).map(t=>(0,A.$6v)(t)),r=(u.buttons||[]).map((t,h)=>h),n=0,o=a.cancelId??i.length-1;if(i.length>1){const t=typeof o=="number"?i[o]:void 0;if(v.$k||v.$j){if(typeof t=="string"&&i.length>1&&o!==1){i.splice(o,1),i.splice(1,0,t);const h=r[o];r.splice(o,1),r.splice(1,0,h),o=1}v.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(o=n-1))}else if(v.$i&&typeof t=="string"&&i.length>1&&o!==i.length-1){i.splice(o,1),i.push(t);const h=r[o];r.splice(o,1),r.push(h),o=i.length-1}}return a.buttons=i,a.defaultId=n,a.cancelId=o,a.noLink=!0,a.title=a.title||m.nameLong,{options:a,buttonIndeces:r}}e.$aw=S}),define(Ce[133],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=void 0,e.$di=(0,D.$9h)("environmentService"),e.$ei=(0,D.$0h)(e.$di)}),define(Ce[134],Ie([1,0,201,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.ExtensionGalleryErrorCode=e.$Do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=void 0,e.$qo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ro=new RegExp(e.$qo),e.$so="__web_extension",e.$to="skipWalkthrough",e.$uo="extensionsSync",e.$vo="dependecyOrPackExtensionInstall";function f(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$wo=f;function P(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$xo=P;function A(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$yo=A;function v(r,n){return n==="web"&&!r.includes("web")}e.$zo=v;function $(r,n,o){return v(n,o)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===o}e.$Ao=$;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Bo=k;var R;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var b;(function(r){r.Install="install",r.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Co=(0,N.$9h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var u;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class m extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Do=m;var a;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(a||(e.ExtensionGalleryErrorCode=a={}));class i extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$Eo=i,e.$Fo=(0,N.$9h)("extensionManagementService"),e.$Go="extensionsIdentifiers/disabled",e.$Ho="extensionsIdentifiers/enabled",e.$Io=(0,N.$9h)("IGlobalExtensionEnablementService"),e.$Jo=(0,N.$9h)("IExtensionTipsService"),e.$Ko=(0,D.localize2)(0,"Extensions"),e.$Lo=(0,D.localize2)(1,"Preferences")}),define(Ce[242],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h3b=e.$g3b=void 0,e.$g3b=(0,D.$9h)("externalTerminal"),e.$h3b="Terminal.app"}),define(Ce[243],Ie([1,0,50,52,15,17,11,101,31,104,203,242]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=e.$g$b=e.$f$b=void 0;const b=R.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{static{this.b="cmd.exe"}openTerminal(o,t){return this.spawnTerminal(D,o,k.$Wl(),t)}spawnTerminal(o,t,h,s){const d=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=P.$nc(d,".exe").toLowerCase();if(l==="cmder")return o.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return d.indexOf(" ")>=0&&c.push('""'),c.push(d),l==="wt"&&c.push("-d ."),new Promise((p,I)=>{const w=a(process),g=o.spawn(h,c,{cwd:s,env:w,detached:!0});g.on("error",I),g.on("exit",()=>p())})}async runInTerminal(o,t,h,s,d){const l="windowsExec"in d&&d.windowsExec?d.windowsExec:S.getDefaultTerminalWindows(),c=await S.f();return new Promise((p,I)=>{const w=`"${t} - ${b}"`,g=`""${h.join('" "')}" & pause"`,y=Object.assign({},a(process),s);Object.keys(y).filter(O=>y[O]===null).forEach(O=>delete y[O]);const L={cwd:t,env:y,windowsVerbatimArguments:!0};let F,z;P.$nc(l,".exe")==="wt"?(F=l,z=["-d",".",S.b,"/c",g]):c?(F=c,z=["-d",t,l,"/c",g]):(F=S.b,z=["/c","start",w,"/wait",l,"/c",g]),D.spawn(F,z,L).on("error",O=>{I(i(O))}),p(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const o=await k.win32.findExecutable("wt");return await $.Promises.exists(o)?o:void 0}catch{return}}}e.$f$b=S,Ke([N.$Ah],S,"f",null);class u extends E{static{this.b="/usr/bin/osascript"}openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,h,s,d){const l=d.osxExec||C.$h3b;return new Promise((c,p)=>{if(l===C.$h3b||l==="iTerm.app"){const I=l===C.$h3b?"TerminalHelper":"iTermHelper",g=[f.$qg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",o||b,"-w",t];for(const F of h)g.push("-a"),g.push(F);if(s){const F=Object.assign({},a(process),s);for(const z in F){const j=F[z];j===null?(g.push("-u"),g.push(z)):(g.push("-e"),g.push(`${z}=${j}`))}}let y="";const L=D.spawn(u.b,g);L.on("error",F=>{p(i(F))}),L.stderr.on("data",F=>{y+=F.toString()}),L.on("exit",F=>{if(F===0)c(void 0);else if(y){const z=y.split(`
`,1);p(new Error(z[0]))}else p(new Error(R.localize(1,null,I,F)))})}else p(new Error(R.localize(2,null,l)))})}spawnTerminal(o,t,h){const s=t.osxExec||C.$h3b;return new Promise((d,l)=>{const c=["-a",s];h&&c.push(h);const p=a(process),I=o.spawn("/usr/bin/open",c,{cwd:h,env:p});I.on("error",l),I.on("exit",()=>d())})}}e.$g$b=u;class m extends E{static{this.b=R.localize(3,null)}openTerminal(o,t){return this.spawnTerminal(D,o,t)}runInTerminal(o,t,h,s,d){const l=d.linuxExec?Promise.resolve(d.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((c,p)=>{const I=[];l.then(w=>{w.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const g=`${r(h)}; echo; read -p "${m.b}" -n1;`;I.push(`''${g}''`);const y=Object.assign({},a(process),s);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const L={cwd:t,env:y};let F="";const z=D.spawn(w,I,L);z.on("error",j=>{p(i(j))}),z.stderr.on("data",j=>{F+=j.toString()}),z.on("exit",j=>{if(j===0)c(void 0);else if(F){const O=F.split(`
`,1);p(new Error(O[0]))}else p(new Error(R.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!A.$k)m.d=Promise.resolve("xterm");else{const o=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{o?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(o,t,h){const s=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,l)=>{s.then(c=>{const p=a(process),I=o.spawn(c,[],{cwd:h,env:p});I.on("error",l),I.on("exit",()=>d())})})}}e.$h$b=m;function a(n){const o={...n.env};return(0,v.$Ul)(o),o}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(R.localize(5,null,n.path)):n}function r(n){let o="";for(const t of n)t.indexOf(" ")>=0?o+='"'+t+'"':o+=t,o+=" ";return o}}),define(Ce[32],Ie([1,0,78,17,12,18,2,204,5,11,15,43]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.FileKind=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileOperationResult=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.FileChangeType=e.$Lk=e.FileOperation=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.FileSystemProviderErrorCode=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileSystemProviderCapabilities=e.$vk=e.FilePermission=e.FileType=e.$uk=e.$tk=void 0,e.$tk=(0,$.$9h)("fileService");function b(te){return te.create===!0}e.$uk=b;var E;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var S;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function u(te){const fe=te;return!!fe&&typeof fe.onDidChange=="function"}e.$vk=u;var m;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function a(te){return!!(te.capabilities&2)}e.$wk=a;function i(te){return!!(te.capabilities&8)}e.$xk=i;function r(te){return!!(te.capabilities&131072)}e.$yk=r;function n(te){return!!(te.capabilities&4)}e.$zk=n;function o(te){return!!(te.capabilities&16)}e.$Ak=o;function t(te){return a(te)?!!(te.capabilities&16384):!1}e.$Bk=t;function h(te){return a(te)?!!(te.capabilities&32768):!1}e.$Ck=h;function s(te){return!!(te.capabilities&65536)}e.$Dk=s;function d(te){return!!(te.capabilities&2048)}e.$Ek=d;var l;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class c extends Error{static create(fe,re){const K=new c(fe.toString(),re);return w(K,re),K}constructor(fe,re){super(fe),this.code=re}}e.$Fk=c;function p(te,fe){return c.create(te,fe)}e.$Gk=p;function I(te){return te||p((0,v.localize)(0,null),l.Unknown)}e.$Hk=I;function w(te,fe){return te.name=fe?`${fe} (FileSystemError)`:"FileSystemError",te}e.$Ik=w;function g(te){if(!te)return l.Unknown;if(te instanceof c)return te.code;const fe=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!fe)return l.Unknown;switch(fe[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$Jk=g;function y(te){if(te instanceof M)return te.fileOperationResult;switch(g(te)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$Kk=y;var L;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class F{constructor(fe,re,K){this.resource=fe,this.operation=re,this.target=K}isOperation(fe){return this.operation===fe}}e.$Lk=F;var z;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class j{static{this.a=null}constructor(fe,re){this.c=re,this.b=void 0,this.d=new C.$V(()=>{const K=D.$ci.forUris(()=>this.c);return K.fill(this.rawAdded.map(B=>[B,!0])),K}),this.f=new C.$V(()=>{const K=D.$ci.forUris(()=>this.c);return K.fill(this.rawUpdated.map(B=>[B,!0])),K}),this.g=new C.$V(()=>{const K=D.$ci.forUris(()=>this.c);return K.fill(this.rawDeleted.map(B=>[B,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of fe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==j.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(fe,...re){return this.h(fe,{includeChildren:!1},...re)}affects(fe,...re){return this.h(fe,{includeChildren:!0},...re)}h(fe,re,...K){if(!fe)return!1;const B=K.length>0;return!!((!B||K.includes(1))&&(this.d.value.get(fe)||re.includeChildren&&this.d.value.findSuperstr(fe))||(!B||K.includes(0))&&(this.f.value.get(fe)||re.includeChildren&&this.f.value.findSuperstr(fe))||(!B||K.includes(2))&&(this.g.value.findSubstr(fe)||re.includeChildren&&this.g.value.findSuperstr(fe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(fe){return this.b===fe}hasCorrelation(){return typeof this.b=="number"}}e.$Mk=j;function O(te,fe,re){return!te||!fe||te===fe||fe.length>te.length?!1:(fe.charAt(fe.length-1)!==N.sep&&(fe+=N.sep),re?(0,f.$cf)(te,fe):te.indexOf(fe)===0)}e.$Nk=O;class M extends Error{constructor(fe,re,K){super(fe),this.fileOperationResult=re,this.options=K}}e.$Ok=M;class T extends M{constructor(fe,re,K,B){super(fe,re,B),this.fileOperationResult=re,this.size=K}}e.$Pk=T;class U extends M{constructor(fe,re,K){super(fe,2,K),this.stat=re}}e.$Qk=U;var J;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Tk="files.associations",e.$Uk="files.exclude",e.$Vk="files.readonlyInclude",e.$Wk="files.readonlyExclude",e.$Xk="files.readonlyFromPermissions";var ne;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$Yk="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Zk=ee;async function Q(te,fe){if(!fe.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(re=>{const K=fe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===te.scheme&&B.added&&(K.dispose(),re())})})}e.$1k=Q;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(fe){return(0,P.$Of)(fe)||(fe=0),fe<Y.KB?(0,v.localize)(1,null,fe.toFixed(0)):fe<Y.MB?(0,v.localize)(2,null,(fe/Y.KB).toFixed(2)):fe<Y.GB?(0,v.localize)(3,null,(fe/Y.MB).toFixed(2)):fe<Y.TB?(0,v.localize)(4,null,(fe/Y.GB).toFixed(2)):(0,v.localize)(5,null,(fe/Y.TB).toFixed(2))}}e.$2k=Y;function ce(te){const fe=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*Y.MB:fe?10*Y.MB:k.$o?50*Y.MB:1024*Y.MB}e.$3k=ce}),define(Ce[244],Ie([1,0,21,14,205,32]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;async function A(R,C,b,E,S,u){let m;try{await v(R,C,b,E,S,u)}catch(a){m=a}finally{m&&S.errorTransformer&&(m=S.errorTransformer(m)),typeof m<"u"&&b.error(m),b.end()}}e.$eq=A;async function v(R,C,b,E,S,u){$(u);const m=await R.open(C,{create:!1});try{$(u);let a=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),o=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(m,o,n.buffer,t,n.byteLength-t),o+=i,t+=i,a+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await b.write(E(n)),n=D.$ke.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(u)&&k(a,S));if(t>0){let h=t;typeof r=="number"&&(h=Math.min(t,r)),b.write(E(n.slice(0,h)))}}catch(a){throw(0,P.$Hk)(a)}finally{await R.close(m)}}function $(R){if(R.isCancellationRequested)throw(0,N.$6)();return!0}function k(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,P.$Gk)((0,f.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[85],Ie([1,0,35,3,17,11,2,32]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=void 0;function $(a){return a.recursive===!0}e.$gq=$;class k extends N.$Tc{static{this.a=5}constructor(i,r,n,o){super(),this.h=i,this.j=r,this.m=n,this.n=o,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const i=new N.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$hq=k;class R extends k{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$iq=R;class C extends k{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$jq=C;function b(a){return a.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$kq=b;function E(a){const i=new m;for(const r of a)i.processEvent(r);return i.coalesce()}e.$lq=E;function S(a,i){return typeof i=="string"&&!i.startsWith(D.$Lj)&&!(0,f.$ic)(i)?{base:a,pattern:i}:i}e.$mq=S;function u(a,i){const r=[];for(const n of i)r.push((0,D.$Pj)(S(a,n)));return r}e.$nq=u;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const o=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:o===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):o===2&&t===1?r.type=0:o===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,o)=>n.resource.fsPath.length-o.resource.fsPath.length).filter(n=>r.some(o=>(0,v.$Nk)(n.resource.fsPath,o,!P.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(Ce[245],Ie([1,0,57,8,22,34,3,77,17,11,23,2,103,31,85]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=void 0;class u extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,o){super(),this.m=i,this.n=r,this.r=n,this.s=o,this.c=this.B(new N.$lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$kh(t=>this.z(t),u.b)),this.g=(0,S.$nq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$nq)(this.m.path,this.m.includes):void 0,this.j=new f.$7d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await E.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await E.Promises.realpath(i.path),i.path===r&&(r=await(0,b.$xq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(k.$j&&(0,P.$0f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const n=new f.$7d(this.j.token),o=new A.$Sc;try{const t=C.URI.file(this.m.path),h=(0,$.$nc)(i),s=(0,D.watch)(i);o.add((0,A.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const d=new Set;if(r)try{for(const c of await E.Promises.readdir(i))d.add(c)}catch(c){this.D(c)}const l=new Map;o.add((0,A.$Rc)(()=>{for(const[,c]of l)c.dispose();l.clear()})),s.on("error",(c,p)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${c}, ${p})`),this.dispose()}),s.on("change",(c,p)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${p}`);let I="";if(p&&(I=p.toString(),k.$j&&(I=(0,v.$Jl)(I))),!(!I||c!=="change"&&c!=="rename"))if(r)if(c==="rename"){l.get(I)?.dispose();const w=setTimeout(async()=>{if(l.delete(I),I===h&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,$.$jc)(i,I));if(n.token.isCancellationRequested)return;let y;g?d.has(I)?y=0:(y=1,d.add(I)):(d.delete(I),y=2),this.y({resource:(0,R.$Jg)(t,I),type:y,cId:this.m.correlationId})},u.a);l.set(I,(0,A.$Rc)(()=>clearTimeout(w)))}else{let w;d.has(I)?w=0:(w=1,d.add(I)),this.y({resource:(0,R.$Jg)(t,I),type:w,cId:this.m.correlationId})}else if(c==="rename"||I!==h){const w=setTimeout(async()=>{const g=await E.Promises.exists(i);n.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),o.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);o.clear(),o.add((0,A.$Rc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{n.dispose(!0),o.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$lq)(i);if(r.length>0){if(this.s)for(const o of r)this.G(` >> normalized ${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(k.$k)return E.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await E.Promises.readdir((0,$.$mc)(i))).some(o=>o===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Aq=u;async function m(a,i,r,n,o=512){const t=await E.Promises.open(a,"r"),h=Buffer.allocUnsafe(o),s=new f.$7d(n);let d,l=!1;const c={path:a,excludes:[],recursive:!1},p=new u(c,I=>{(async()=>{for(const{type:w}of I)if(w===0){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:g}=await E.Promises.read(t,h,0,o,null);if(!g||s.token.isCancellationRequested)break;i(h.slice(0,g))}}catch(g){d=new Error(g),s.dispose(!0)}finally{l=!1}}})()});return await p.ready,r(),new Promise((I,w)=>{s.token.onCancellationRequested(async()=>{p.dispose();try{await E.Promises.close(t)}catch(g){d=new Error(g)}d?w(d):I()})})}e.$Bq=m}),define(Ce[246],Ie([1,0,4,35,3,11,245]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class v extends f.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(k){const R=this.j(k),C=R.filter(E=>{const S=this.c.get(E.path);return S?!(0,N.$Tj)(S.request.excludes,E.excludes)||!(0,N.$Tj)(S.request.includes,E.includes):!0}),b=Array.from(this.c.values()).filter(({request:E})=>!R.find(S=>S.path===E.path&&(0,N.$Tj)(S.excludes,E.excludes)&&(0,N.$Tj)(S.includes,E.includes))).map(({request:E})=>E.path);C.length&&this.m(`Request to start watching: ${C.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const E of b)this.h(E);for(const E of C)this.g(E)}g(k){const R=new A.$Aq(k,b=>this.a.fire(b),b=>this.b.fire(b),this.f),C={request:k,instance:R};this.c.set(k.path,C)}async stop(){for(const[k]of this.c)this.h(k);this.c.clear()}h(k){const R=this.c.get(k);R&&(this.c.delete(k),R.instance.dispose())}j(k){const R=new Map;for(const C of k){const b=P.$k?C.path:C.path.toLowerCase();let E=R.get(C.correlationId);E||(E=new Map,R.set(C.correlationId,E)),E.set(b,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(k){this.f=k;for(const[,R]of this.c)R.instance.setVerboseLogging(k)}m(k){this.f&&this.b.fire({type:"trace",message:this.n(k)})}n(k,R){return R?`[File Watcher (node.js)] ${k} (path: ${R.request.path})`:`[File Watcher (node.js)] ${k}`}}e.$Cq=v}),define(Ce[247],Ie([1,0,85,246]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;class f extends D.$iq{constructor(A,v,$){super(A,v,$),this.s()}r(A){return A.add(new N.$Cq)}}e.$Dq=f}),define(Ce[248],Ie([1,0,15,81,188,85]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;class A extends P.$jq{constructor($,k,R){super($,k,R),this.s()}r($){const k=$.add(new f.$uq(D.$qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Ph)(k.getChannel("watcher")))}}e.$vq=A}),define(Ce[106],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=void 0;class D{constructor(...f){this.a=new Map;for(const[P,A]of f)this.set(P,A)}set(f,P){const A=this.a.get(f);return this.a.set(f,P),A}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$7h=D}),define(Ce[249],Ie([1,0,8,14,3,105,240,5,106,76]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;const R=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class b{constructor(m=new $.$7h,a=!1,i,r=R){this.f=m,this.g=a,this.h=i,this.i=r,this.o=new Set,this.f.set(v.$8h,this),this._globalGraph=r?i?._globalGraph??new A.$Gq(n=>n):void 0}createChild(m){return new b(m,this.g,this,this.i)}invokeFunction(m,...a){const i=S.traceInvocation(this.i,m);let r=!1;try{return m({get:o=>{if(r)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(o,i);if(!t)throw new Error(`[invokeFunction] unknown service '${o}'`);return t}},...a)}finally{r=!0,i.stop()}}createInstance(m,...a){let i,r;return m instanceof P.$6h?(i=S.traceCreation(this.i,m.ctor),r=this.j(m.ctor,m.staticArguments.concat(a),i)):(i=S.traceCreation(this.i,m),r=this.j(m,a,i)),i.stop(),r}j(m,a=[],i){const r=v._util.getServiceDependencies(m).sort((t,h)=>t.index-h.index),n=[];for(const t of r){const h=this.m(t.id,i);h||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(h)}const o=r.length>0?r[0].index:a.length;if(a.length!==o){console.trace(`[createInstance] First service dependency of ${m.name} at position ${o+1} conflicts with ${a.length} static arguments`);const t=o-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,o)}return Reflect.construct(m,a.concat(n))}k(m,a){if(this.f.get(m)instanceof P.$6h)this.f.set(m,a);else if(this.h)this.h.k(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const a=this.f.get(m);return!a&&this.h?this.h.l(m):a}m(m,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof P.$6h?this.q(m,i,a.branch(m,!0)):(a.branch(m,!1),i)}q(m,a,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,a,i)}finally{this.o.delete(m)}}r(m,a,i){const r=new A.$Gq(t=>t.id.toString());let n=0;const o=[{id:m,desc:a,_trace:i}];for(;o.length;){const t=o.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new C(r);for(const h of v._util.getServiceDependencies(t.desc.ctor)){const s=this.l(h.id);if(s||this.u(`[createInstance] ${m} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),s instanceof P.$6h){const d={id:h.id,desc:s,_trace:t._trace.branch(h.id,!0)};r.insertEdge(t,d),o.push(d)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new C(r);break}for(const{data:h}of t){if(this.l(h.id)instanceof P.$6h){const d=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,d)}r.removeNode(h)}}return this.l(m)}s(m,a,i=[],r,n){if(this.f.get(m)instanceof P.$6h)return this.t(m,a,i,r,n);if(this.h)return this.h.s(m,a,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(m,a,i=[],r,n){if(r){const o=new b(void 0,this.g,this,this.i);o.c=String(m);const t=new Map,h=new D.$ph(()=>{const s=o.j(a,i,n);for(const[d,l]of t){const c=s[d];if(typeof c=="function")for(const p of l)p.disposable=c.apply(s,p.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,d){if(!h.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let p=t.get(d);return p||(p=new k.$4c,t.set(d,p)),(w,g,y)=>{if(h.isInitialized)return h.value[d](w,g,y);{const L={listener:[w,g,y],disposable:void 0},F=p.push(L);return(0,f.$Rc)(()=>{F(),L.disposable?.dispose()})}}}if(d in s)return s[d];const l=h.value;let c=l[d];return typeof c!="function"||(c=c.bind(l),s[d]=c),c},set(s,d,l){return h.value[d]=l,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,i,n)}u(m,a){if(a&&console.warn(m),this.g)throw new Error(m)}}e.$Hq=b;var E;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(E||(E={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,a){return m?new S(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(m,a){return m?new S(1,a.name):S.c}static{this.f=0}constructor(m,a){this.type=m,this.name=a,this.g=Date.now(),this.h=[]}branch(m,a){const i=new S(3,m.toString());return this.h.push([m,a,i]),i}stop(){const m=Date.now()-this.g;S.f+=m;let a=!1;function i(n,o){const t=[],h=new Array(n+1).join("	");for(const[s,d,l]of o.h)if(d&&l){a=!0,t.push(`${h}CREATES -> ${s}`);const c=i(n+1,l);c&&t.push(c)}else t.push(`${h}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(m>2||a)&&S.all.add(r.join(`
`))}}e.$Iq=S}),define(Ce[13],Ie([1,0,44,4,54,3,28,11,23,18,2,45,5]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.log=e.$tj=e.LogLevel=e.$sj=e.$rj=e.$qj=void 0,e.$qj=(0,b.$9h)("logService"),e.$rj=(0,b.$9h)("loggerService");function E(){return new Date().toISOString()}function S(w){return(0,k.$Of)(w)}e.$sj=S;var u;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$tj=u.Info;function m(w,g,y){switch(g){case u.Trace:w.trace(y);break;case u.Debug:w.debug(y);break;case u.Info:w.info(y);break;case u.Warning:w.warn(y);break;case u.Error:w.error(y);break;case u.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=m;function a(w,g=!1){let y="";for(let L=0;L<w.length;L++){let F=w[L];if(F instanceof Error&&(F=(0,D.$Ti)(F,g)),typeof F=="object")try{F=JSON.stringify(F)}catch{}y+=(L>0?" ":"")+F}return y}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$tj,this.c=this.B(new N.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==u.Off&&this.b<=g}}e.$vj=i;class r extends i{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...y){this.f(u.Trace)&&this.g(u.Trace,a([g,...y],!0))}debug(g,...y){this.f(u.Debug)&&this.g(u.Debug,a([g,...y]))}info(g,...y){this.f(u.Info)&&this.g(u.Info,a([g,...y]))}warn(g,...y){this.f(u.Warning)&&this.g(u.Warning,a([g,...y]))}error(g,...y){if(this.f(u.Error))if(g instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=g.stack,this.g(u.Error,a(L))}else this.g(u.Error,a([g,...y]))}flush(){}}e.$wj=r;class n extends i{constructor(g=e.$tj){super(),this.setLevel(g),this.g=!v.$i}trace(g,...y){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,g,...y):console.log(`[main ${E()}]`,g,...y))}debug(g,...y){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,g,...y):console.log(`[main ${E()}]`,g,...y))}info(g,...y){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,g,...y):console.log(`[main ${E()}]`,g,...y))}warn(g,...y){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,g,...y):console.warn(`[main ${E()}]`,g,...y))}error(g,...y){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,g,...y):console.error(`[main ${E()}]`,g,...y))}flush(){}}e.$xj=n;class o extends i{constructor(g=e.$tj,y=!0){super(),this.g=y,this.setLevel(g)}trace(g,...y){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...y):console.log(g,...y))}debug(g,...y){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...y):console.log(g,...y))}info(g,...y){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...y):console.log(g,...y))}warn(g,...y){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...y):console.log(g,...y))}error(g,...y){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...y):console.error(g,...y))}flush(){}}e.$yj=o;class t extends i{constructor(g,y=e.$tj){super(),this.g=g,this.setLevel(y)}trace(g,...y){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(g),...y])}debug(g,...y){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(g),...y])}info(g,...y){this.f(u.Info)&&this.g.log(u.Info,[this.h(g),...y])}warn(g,...y){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(g),...y])}error(g,...y){this.f(u.Error)&&this.g.log(u.Error,[this.h(g),...y])}h(g){return typeof g=="string"?g:(0,D.$Ti)(g,this.f(u.Trace))}flush(){}}e.$zj=t;class h extends i{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const y of this.g)y.setLevel(g);super.setLevel(g)}trace(g,...y){for(const L of this.g)L.trace(g,...y)}debug(g,...y){for(const L of this.g)L.debug(g,...y)}info(g,...y){for(const L of this.g)L.info(g,...y)}warn(g,...y){for(const L of this.g)L.warn(g,...y)}error(g,...y){for(const L of this.g)L.error(g,...y)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$Aj=h;class s extends P.$Tc{constructor(g,y,L){if(super(),this.h=g,this.j=y,this.b=new A.$Ac,this.c=this.B(new N.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Wd),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(g){return(0,k.$Kf)(g)?[...this.b.values()].find(y=>y.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,y){const L=this.n(g),F=(0,k.$Kf)(g)?g:y?.id??(0,f.$Wi)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const j=y?.logLevel==="always"?u.Trace:y?.logLevel;z||(z=this.s(L,j??this.getLogLevel(L)??this.h,{...y,id:F}));const O={logger:z,info:{resource:L,id:F,logLevel:j,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(O.info),this.b.set(L,O),z}n(g){return(0,k.$Kf)(g)?(0,$.$Jg)(this.j,`${g}.log`):g}setLogLevel(g,y){if(R.URI.isUri(g)){const L=g,F=y,z=this.b.get(L);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([L,F]))}else{this.h=g;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,y){const L=this.m(g);L&&y!==!L.info.hidden&&(L.info.hidden=!y,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,y]))}getLogLevel(g){let y;return g&&(y=this.b.get(g)?.info.logLevel),y??this.h}registerLogger(g){const y=this.b.get(g.resource);y?y.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const y=this.b.get(g);y&&(y.logger&&y.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Bj=s;class d{constructor(){this.onDidChangeLogLevel=new N.$Wd().event}setLevel(g){}getLevel(){return u.Info}trace(g,...y){}debug(g,...y){}info(g,...y){}warn(g,...y){}error(g,...y){}critical(g,...y){}dispose(){}flush(){}}e.$Cj=d;class l extends d{}e.$Dj=l;function c(w){if(w.verbose)return u.Trace;if(typeof w.logLevel=="string"){const g=I(w.logLevel.toLowerCase());if(g!==void 0)return g}return e.$tj}e.$Ej=c;function p(w){switch(w){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$Fj=p;function I(w){switch(w){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$Gj=I,e.$Hj=new C.$nj("logLevel",p(u.Info))}),define(Ce[250],Ie([1,0,19,8,14,4,3,17,85,13]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class R extends A.$Tc{constructor(b,E){super(),this.a=b,this.b=E,this.c=this.B(new P.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$7g(0)),this.w=[],this.y=this.B(new N.$7g(0))}watch(b,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(b,E):this.z(b,E)}n(b,E){const S={path:this.H(b),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},u=(0,D.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,f.$1)(b))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,$.$kq)(E)),E=>this.G(E),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const E of this.j)(0,$.$gq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const E of this.j)(0,$.$gq)(E)&&b.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,E){const S={path:this.H(b),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},u=(0,D.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,f.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,$.$kq)(b)),b=>this.G(b),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,v.$hc)(b.fsPath)}}e.$oq=R}),define(Ce[251],Ie([1,0,57,390,8,28,21,4,34,3,17,11,23,98,31,206,32,244,250,44,248,247]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(h){console.error(`Error enabling graceful-fs: ${(0,r.$Ti)(h)}`)}})();class t extends i.$oq{static{this.I=!1}constructor(s,d){super(s,d),this.onDidChangeCapabilities=v.Event.None,this.N=new P.$Ac(l=>b.$Ag.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:d,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(d,l),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size,permissions:d.mode&128?void 0:m.FilePermission.Locked}}catch(d){throw this.fb(d)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const d=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),l=[];return await Promise.all(d.map(async c=>{try{let p;c.isSymbolicLink()?p=(await this.stat((0,b.$Jg)(s,c.name))).type:p=this.M(c),l.push([c.name,p])}catch(p){this.a.trace(p)}})),l}catch(d){throw this.fb(d)}}M(s,d){let l;return d?.dangling?l=m.FileType.Unknown:s.isFile()?l=m.FileType.File:s.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,d&&(l|=m.FileType.SymbolicLink),l}async O(s){const d=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${d})`);let l;for(;l=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${d})`),await l.wait();const c=new f.$8g;return this.N.set(s,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${d})`),(0,k.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${d})`),this.N.get(s)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${d})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${d})`),c.open()})}async readFile(s,d){let l;try{d?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),l=await this.O(s));const c=this.H(s);return await S.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{l?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,d,l){const c=(0,E.$$d)(p=>A.$ke.concat(p.map(I=>A.$ke.wrap(I))).buffer);return(0,a.$eq)(this,s,c,p=>p.buffer,{...d,bufferSize:256*1024},l),c}async writeFile(s,d,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,b.$Jg)((0,b.$Ig)(s),`${(0,b.$Gg)(s)}${l.atomic.postfix}`),d,l):this.S(s,d,l)}async Q(s){try{const d=this.H(s),{symbolicLink:l}=await S.SymlinkSupport.stat(d);if(l)return!1}catch{}return!0}async R(s,d,l,c){const p=new k.$Sc;try{p.add(await this.O(s)),p.add(await this.O(d)),await this.S(d,l,c,!0);try{await this.rename(d,s,{overwrite:!0})}catch(I){try{await this.delete(d,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{p.dispose()}}async S(s,d,l,c){let p;try{const I=this.H(s);if(!l.create||!l.overwrite){if(await S.Promises.exists(I)){if(!l.overwrite)throw(0,m.$Gk)((0,u.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.$Gk)((0,u.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(s,{create:!0,unlock:l.unlock},c),await this.write(p,0,d,0,d.byteLength)}catch(I){throw await this.gb(s,I)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,d,l){const c=this.H(s);let p;(0,m.$uk)(d)&&!l&&(p=await this.O(s));let I;try{if((0,m.$uk)(d)&&d.unlock)try{const{stat:g}=await S.SymlinkSupport.stat(c);g.mode&128||await S.Promises.chmod(c,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let w;if((0,m.$uk)(d)){if(C.$i)try{await S.Promises.truncate(c,0),w="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}w||(w="w")}else w="r";I=await S.Promises.open(c,w)}catch(w){throw p?.dispose(),(0,m.$uk)(d)?await this.gb(s,w):this.fb(w)}if(this.U.set(I,0),(0,m.$uk)(d)&&this.X.set(I,s),p){const w=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${c})`),this.W.set(I,p),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${c})`),w.dispose())}return I}async close(s){const d=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(s)}catch(l){throw this.fb(l)}finally{d&&(this.W.get(s)===d&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),d.dispose())}}async read(s,d,l,c,p){const I=this.Z(s,d);let w=null;try{w=(await S.Promises.read(s,l,c,p,I)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(s,I,w)}return w}Z(s,d){return d===this.U.get(s)?null:d}$(s,d,l){const c=this.U.get(s);typeof c=="number"&&(typeof d=="number"||(typeof l=="number"?this.U.set(s,c+l):this.U.delete(s)))}async write(s,d,l,c,p){return(0,f.$qh)(()=>this.ab(s,d,l,c,p),100,3)}async ab(s,d,l,c,p){const I=this.Z(s,d);let w=null;try{w=(await S.Promises.write(s,l,c,p,I)).bytesWritten}catch(g){throw await this.gb(this.X.get(s),g)}finally{this.$(s,I,w)}return w}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(d){throw this.fb(d)}}async delete(s,d){try{const l=this.H(s);if(d.recursive){let c;d?.atomic!==!1&&d.atomic.postfix&&(c=(0,R.$jc)((0,R.$mc)(l),`${(0,R.$nc)(l)}${d.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,c)}else try{await S.Promises.unlink(l)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let p=!1;try{const{stat:I,symbolicLink:w}=await S.SymlinkSupport.stat(l);p=I.isDirectory()&&!w}catch{}if(p)await S.Promises.rmdir(l);else throw c}else throw c}}catch(l){throw this.fb(l)}}async rename(s,d,l){const c=this.H(s),p=this.H(d);if(c!==p)try{await this.bb(s,d,"move",l.overwrite),await S.Promises.rename(c,p)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,u.localize)(2,null,(0,R.$nc)(c),(0,R.$nc)((0,R.$mc)(p)),I.toString()))),this.fb(I)}}async copy(s,d,l){const c=this.H(s),p=this.H(d);if(c!==p)try{await this.bb(s,d,"copy",l.overwrite),await S.Promises.copy(c,p,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,u.localize)(3,null,(0,R.$nc)(c),(0,R.$nc)((0,R.$mc)(p)),I.toString()))),this.fb(I)}}async bb(s,d,l,c){const p=this.H(s),I=this.H(d);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$9f)(p,I,!0)),w){if(l==="copy")throw(0,m.$Gk)((0,u.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const y=await this.L(s);if(!y)throw(0,m.$Gk)((0,u.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(d);if(L){if(!c)throw(0,m.$Gk)((0,u.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&L.type&m.FileType.File||await this.delete(d,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,d){return this.cb(s,d,!1)}async cb(s,d,l){const c=this.H(s),p=this.H(d),I=!!(this.capabilities&1024);if((0,$.$9f)(c,p,!I))return;const w=new k.$Sc;try{w.add(await this.O(s)),w.add(await this.O(d)),l&&await S.Promises.mkdir((0,R.$mc)(p),{recursive:!0}),await S.Promises.copyFile(c,p)}catch(g){if(g.code==="ENOENT"&&!l)return this.cb(s,d,!0);throw this.fb(g)}finally{w.dispose()}}t(s,d,l){return new n.$vq(c=>s(c),c=>d(c),l)}F(s,d,l){return new o.$Dq(c=>s(c),c=>d(c),l)}fb(s){if(s instanceof m.$Fk)return s;let d=s,l;switch(s.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":d=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Gk)(d,l)}async gb(s,d){let l=this.fb(d);if(s&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await S.SymlinkSupport.stat(this.H(s));c.mode&128||(l=(0,m.$Gk)(d,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return l}}e.$Eq=t}),define(Ce[252],Ie([1,0,3,13]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=void 0;class f extends D.$Tc{constructor(A,v=[]){super(),this.a=new N.$Aj([A,...v]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...v){this.a.trace(A,...v)}debug(A,...v){this.a.debug(A,...v)}info(A,...v){this.a.info(A,...v)}warn(A,...v){this.a.warn(A,...v)}error(A,...v){this.a.error(A,...v)}flush(){this.a.flush()}}e.$1O=f}),define(Ce[253],Ie([1,0,32,13]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=void 0;var f;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(f||(f={}));async function P(k,R,C,b,E){try{const S=await new Promise((m,a)=>{me(["@vscode/spdlog"],m,a)});S.setFlushOn(f.Trace);const u=await S.createAsyncRotatingLogger(k,R,C,b);return E?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(S){console.error(S)}return null}function A(k,R,C){switch(R){case N.LogLevel.Trace:k.trace(C);break;case N.LogLevel.Debug:k.debug(C);break;case N.LogLevel.Info:k.info(C);break;case N.LogLevel.Warning:k.warn(C);break;case N.LogLevel.Error:k.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function v(k,R){switch(R){case N.LogLevel.Trace:k.setLevel(f.Trace);break;case N.LogLevel.Debug:k.setLevel(f.Debug);break;case N.LogLevel.Info:k.setLevel(f.Info);break;case N.LogLevel.Warning:k.setLevel(f.Warning);break;case N.LogLevel.Error:k.setLevel(f.Error);break;case N.LogLevel.Off:k.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class $ extends N.$wj{constructor(R,C,b,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,C,b,E),this.B(this.onDidChangeLogLevel(u=>{this.r&&v(this.r,u)}))}async s(R,C,b,E){const S=b?6:1,u=30/S*D.$2k.MB,m=await P(R,C,u,S,E);if(m){this.r=m,v(this.r,this.getLevel());for(const{level:a,message:i}of this.m)A(this.r,a,i);this.m=[]}}g(R,C){this.r?A(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$PO=$}),define(Ce[135],Ie([1,0,39,207,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function k(S,u){return u-S}$.compare=k;const R=Object.create(null);R[$.Error]=(0,N.localize)(0,null),R[$.Warning]=(0,N.localize)(1,null),R[$.Info]=(0,N.localize)(2,null);function C(S){return R[S]||""}$.toString=C;function b(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=b;function E(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=E}(A||(e.MarkerSeverity=A={}));var v;(function($){const k="";function R(b){return C(b,!0)}$.makeKey=R;function C(b,E){const S=[k];return b.source?S.push(b.source.replace("\xA6","\\\xA6")):S.push(k),b.code?typeof b.code=="string"?S.push(b.code.replace("\xA6","\\\xA6")):S.push(b.code.value.replace("\xA6","\\\xA6")):S.push(k),b.severity!==void 0&&b.severity!==null?S.push(A.toString(b.severity)):S.push(k),b.message&&E?S.push(b.message.replace("\xA6","\\\xA6")):S.push(k),b.startLineNumber!==void 0&&b.startLineNumber!==null?S.push(b.startLineNumber.toString()):S.push(k),b.startColumn!==void 0&&b.startColumn!==null?S.push(b.startColumn.toString()):S.push(k),b.endLineNumber!==void 0&&b.endLineNumber!==null?S.push(b.endLineNumber.toString()):S.push(k),b.endColumn!==void 0&&b.endColumn!==null?S.push(b.endColumn.toString()):S.push(k),S.push(k),S.join("\xA6")}$.makeKeyOptionalMessage=C})(v||(e.IMarkerData=v={})),e.$Dt=(0,f.$9h)("markerService")}),define(Ce[254],Ie([1,0,4,39,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.NotificationsFilter=e.$tv=e.NeverShowAgainScope=e.NotificationPriority=e.$sv=e.Severity=void 0,e.Severity=N.default,e.$sv=(0,f.$9h)("notificationService");var P;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function v(C){if(C){const b=C;return typeof b.id=="string"&&typeof b.label=="string"}return!1}e.$tv=v;var $;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new R,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(b){}updateMessage(b){}updateActions(b){}close(){}}e.$uv=k;class R{infinite(){}done(){}total(b){}worked(b){}}e.$vv=R}),define(Ce[255],Ie([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const P=f.context.configuration();if(P)N=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:P.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Ce[136],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=void 0,e.$Ij=(0,D.$9h)("productService"),e.$Jj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,N){e(D,N,me)}};define(Ce[107],Ie([1,0,8,22,3,5]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.ProgressLocation=e.$wv=void 0,e.$wv=(0,P.$9h)("progressService");var A;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$xv=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(b){this.b=b}report(b){this.a=b,this.b(this.a)}}e.$yv=v;class ${get value(){return this.a}constructor(b){this.e=b}report(b){this.b?this.b.push(b):this.b=[b],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const b=this.b.shift();this.a=b,await this.e(this.a)}}finally{this.c=!1;const b=this.d;this.d=void 0,b?.()}}drain(){return this.c?new Promise(b=>{const E=this.d;this.d=()=>{E?.(),b()}}):Promise.resolve()}}e.$zv=$;let k=class extends f.$Tc{constructor(b,E){super(),this.a=new D.$th,E.withProgress(b,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,f.$Rc)(()=>this.a.complete()))}report(b){this.b?this.b.report(b):this.c=b}};e.$Av=k,e.$Av=k=Ke([We(1,e.$wv)],k);class R extends f.$Tc{constructor(b){super(),this.g=b,this.a=0,this.b=this.B(new f.$Sc)}start(b){this.stop();const E=++this.a,S=new N.$7d;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},b),this.b.add((0,f.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Rc)(()=>S.cancel())),this.b.add((0,f.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:S.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(b){this.a===b&&this.b.clear()}}e.$Bv=R,e.$Cv=(0,P.$9h)("editorProgressService")}),define(Ce[37],Ie([1,0,61,18]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0;class f{constructor(){this.a=new Map}add(A,v){D.ok(N.$Kf(A)),D.ok(N.$Mf(v)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,v)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Ln=new f}),define(Ce[108],Ie([1,0,4,37]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=void 0,e.$Mn={JSONContribution:"base.contributions.json"};function f(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class P{constructor(){this.b=new D.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[f($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;N.$Ln.add(e.$Mn.JSONContribution,A)}),define(Ce[86],Ie([1,0,19,4,18,197,51,108,37]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.ConfigurationScope=e.$Qn=e.EditPresentationTypes=void 0;var k;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Qn={Configuration:"base.contributions.configuration"};var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn={properties:{},patternProperties:{}},e.$Xn="vscode://schemas/settings/resourceLanguage",e.$Yn="vscode://schemas/settings/configurationDefaults";const C=$.$Ln.as(v.$Mn.JSONContribution);class b{constructor(){this.h=new Set,this.i=new N.$Wd,this.onDidSchemaChange=this.i.event,this.j=new N.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Xn,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const s=new Set;this.n(t,h,s),C.registerSchema(e.$Xn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const h=new Set;this.o(t,h),C.registerSchema(e.$Xn,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const s=new Set;this.o(h,s),this.n(t,!1,s),C.registerSchema(e.$Xn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const s=[];for(const{overrides:d,source:l}of t)for(const c in d)if(h.add(c),e.$1n.test(c)){const p=this.a.get(c),I=p?.valuesSources??new Map;if(l)for(const L of Object.keys(d[c]))I.set(L,l);const w={...p?.value||{},...d[c]};this.a.set(c,{source:l,value:w,valuesSources:I});const g=(0,A.$Mi)(c),y={type:"object",default:w,description:P.localize(1,null,g),$ref:e.$Xn,defaultDefaultValue:w,source:f.$Kf(l)?void 0:l,defaultValueSource:l};s.push(...u(c)),this.d[c]=y,this.b.properties[c]=y}else{this.a.set(c,{value:d[c],source:l});const p=this.d[c];p&&(this.w(c,p),this.r(c,p))}this.m(s)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:s,source:d}of t)for(const l in s){const c=this.a.get(l),p=f.$Kf(d)?d:d?.id,I=f.$Kf(c?.source)?c?.source:c?.source?.id;if(p===I)if(h.add(l),this.a.delete(l),e.$1n.test(l))delete this.d[l],delete this.b.properties[l];else{const w=this.d[l];w&&(this.w(l,w),this.r(l,w))}}this.u()}deltaConfiguration(t){let h=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,s){t.forEach(d=>{this.p(d,h,d.extensionInfo,d.restrictedProperties,void 0,s),this.c.push(d),this.q(d)})}o(t,h){const s=d=>{if(d.properties)for(const l in d.properties){h.add(l);const c=this.d[l];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[l],this.s(l,d.properties[l])}d.allOf?.forEach(l=>s(l))};for(const d of t){s(d);const l=this.c.indexOf(d);l!==-1&&this.c.splice(l,1)}}p(t,h=!0,s,d,l=3,c){l=f.$Tf(t.scope)?l:t.scope;const p=t.properties;if(p)for(const w in p){const g=p[w];if(h&&r(w,g)){delete p[w];continue}if(g.source=s,g.defaultDefaultValue=p[w].default,this.w(w,g),e.$1n.test(w)?g.scope=void 0:(g.scope=f.$Tf(g.scope)?l:g.scope,g.restricted=f.$Tf(g.restricted)?!!d?.includes(w):g.restricted),p[w].hasOwnProperty("included")&&!p[w].included){this.f[w]=p[w],delete p[w];continue}else this.d[w]=p[w],p[w].policy?.name&&this.e.set(p[w].policy.name,w);!p[w].deprecationMessage&&p[w].markdownDeprecationMessage&&(p[w].deprecationMessage=p[w].markdownDeprecationMessage),c.add(w)}const I=t.allOf;if(I)for(const w of I)this.p(w,h,s,d,l,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=s=>{const d=s.properties;if(d)for(const c in d)this.r(c,d[c]);s.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$Rn.properties[t]=h,h.scope){case 1:e.$Sn.properties[t]=h;break;case 2:e.$Tn.properties[t]=h;break;case 6:e.$Un.properties[t]=h;break;case 3:e.$Vn.properties[t]=h;break;case 4:e.$Wn.properties[t]=h;break;case 5:e.$Wn.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$Rn.properties[t],h.scope){case 1:delete e.$Sn.properties[t];break;case 2:delete e.$Tn.properties[t];break;case 6:delete e.$Un.properties[t];break;case 3:delete e.$Vn.properties[t];break;case 4:case 5:delete e.$Wn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Xn};this.w(h,s),e.$Rn.properties[h]=s,e.$Sn.properties[h]=s,e.$Tn.properties[h]=s,e.$Un.properties[h]=s,e.$Vn.properties[h]=s,e.$Wn.properties[h]=s}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Xn};e.$Rn.patternProperties[e.$Zn]=t,e.$Sn.patternProperties[e.$Zn]=t,e.$Tn.patternProperties[e.$Zn]=t,e.$Un.patternProperties[e.$Zn]=t,e.$Vn.patternProperties[e.$Zn]=t,e.$Wn.patternProperties[e.$Zn]=t,this.i.fire()}w(t,h){const s=this.a.get(t);let d=s?.value,l=s?.source;f.$Rf(d)&&(d=h.defaultDefaultValue,l=void 0),f.$Rf(d)&&(d=a(h.type)),h.default=d,h.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$Zn=`^(${E})+$`,e.$1n=new RegExp(e.$Zn);function u(o){const t=[];if(e.$1n.test(o)){let h=S.exec(o);for(;h?.length;){const s=h[1].trim();s&&t.push(s),h=S.exec(o)}}return(0,D.$Mb)(t)}e.$2n=u;function m(o){return o.reduce((t,h)=>`${t}[${h}]`,"")}e.$3n=m;function a(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$4n=a;const i=new b;$.$Ln.add(e.$Qn.Configuration,i);function r(o,t){return o.trim()?e.$1n.test(o)?P.localize(7,null,o):i.getConfigurationProperties()[o]!==void 0?P.localize(8,null,o):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,o,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$5n=r;function n(){const o=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))o.push([h,t[h].scope]);return o.push(["launch",4]),o.push(["task",4]),o}e.$6n=n}),define(Ce[256],Ie([1,0,19,4,160,3,28,24,18,2,51,86,37]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=void 0;function E(h){return Object.isFrozen(h)?h:v.$An(h)}class S{constructor(s={},d=[],l=[],c){this.b=s,this.c=d,this.d=l,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(d=>{if(d instanceof S)return d;const l=new u("");return l.parseRaw(d),l.configurationModel});this.f=s.reduce((d,l)=>l===d?l:d.merge(l),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$Ki)(this.contents,s):this.contents}inspect(s,d){const l=this;return{get value(){return E(l.rawConfiguration.getValue(s))},get override(){return d?E(l.rawConfiguration.getOverrideValue(s,d)):void 0},get merged(){return E(d?l.rawConfiguration.override(d).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const c=[];for(const{contents:p,identifiers:I,keys:w}of l.rawConfiguration.overrides){const g=new S(p,w).getValue(s);g!==void 0&&c.push({identifiers:I,value:g})}return c.length?E(c):void 0}}}getOverrideValue(s,d){const l=this.i(d);return l?s?(0,R.$Ki)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const d=[];for(const l of this.overrides)l.identifiers.includes(s)&&d.push(...l.keys);return D.$Mb(d)}getAllOverrideIdentifiers(){const s=[];for(const d of this.overrides)s.push(...d.identifiers);return D.$Mb(s)}override(s){let d=this.a.get(s);return d||(d=this.g(s),this.a.set(s,d)),d}merge(...s){const d=v.$zn(this.contents),l=v.$zn(this.overrides),c=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const I of s)if(p.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(d,I.contents);for(const w of I.overrides){const[g]=l.filter(y=>D.$ub(y.identifiers,w.identifiers));g?(this.h(g.contents,w.contents),g.keys.push(...w.keys),g.keys=D.$Mb(g.keys)):l.push(v.$zn(w))}for(const w of I.keys)c.indexOf(w)===-1&&c.push(w)}return new S(d,c,l,p.every(I=>I instanceof S)?void 0:p)}g(s){const d=this.i(s);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const l={};for(const c of D.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let p=this.contents[c];const I=d[c];I&&(typeof p=="object"&&typeof I=="object"?(p=v.$zn(p),this.h(p,I)):p=I),l[c]=p}return new S(l,this.keys,this.overrides)}h(s,d){for(const l of Object.keys(d)){if(l in s&&$.$Mf(s[l])&&$.$Mf(d[l])){this.h(s[l],d[l]);continue}s[l]=v.$zn(d[l])}}i(s){let d=null,l=null;const c=p=>{p&&(l?this.h(l,p):l=v.$zn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===s?d=p.contents:p.identifiers.includes(s)&&c(p.contents);return c(d),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,d){this.j(s,d,!0)}setValue(s,d){this.j(s,d,!1)}removeValue(s){const d=this.keys.indexOf(s);d!==-1&&(this.keys.splice(d,1),(0,R.$Ji)(this.contents,s),C.$1n.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>D.$ub(l.identifiers,(0,C.$2n)(s))),1))}j(s,d,l){(0,R.$Ii)(this.contents,s,d,c=>console.error(c)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),C.$1n.test(s)&&this.overrides.push({identifiers:(0,C.$2n)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$Hi)(this.contents[s],c=>console.error(c))})}}e.$7n=S;class u{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,d){if(!$.$Tf(s)){const l=this.g(s);this.parseRaw(l,d)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,d){this.a=s;const{contents:l,keys:c,overrides:p,restricted:I,hasExcludedProperties:w}=this.h(s,d);this.b=new S(l,c,p,w?[s]:void 0),this.c=I||[]}g(s){let d={},l=null,c=[];const p=[],I=[];function w(y){Array.isArray(c)?c.push(y):l!==null&&(c[l]=y)}const g={onObjectBegin:()=>{const y={};w(y),p.push(c),c=y,l=null},onObjectProperty:y=>{l=y},onObjectEnd:()=>{c=p.pop()},onArrayBegin:()=>{const y=[];w(y),p.push(c),c=y,l=null},onArrayEnd:()=>{c=p.pop()},onLiteralValue:w,onError:(y,L,F)=>{I.push({error:y,offset:L,length:F})}};if(s)try{f.$nn(s,g),d=c[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return d}h(s,d){const l=b.$Ln.as(C.$Qn.Configuration).getConfigurationProperties(),c=this.i(s,l,!0,d);s=c.raw;const p=(0,R.$Hi)(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),I=Object.keys(s),w=this.j(s,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:p,keys:I,overrides:w,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(s,d,l,c){let p=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:p};const I={},w=[];for(const g in s)if(C.$1n.test(g)&&l){const y=this.i(s[g],d,!1,c);I[g]=y.raw,p=p||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=d[g],L=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(g),!c.exclude?.includes(g)&&(c.include?.includes(g)||(L===void 0||c.scopes===void 0||c.scopes.includes(L))&&!(c.skipRestricted&&y?.restricted))?I[g]=s[g]:p=!0}return{raw:I,restricted:w,hasExcludedProperties:p}}j(s,d){const l=[];for(const c of Object.keys(s))if(C.$1n.test(c)){const p={};for(const I in s[c])p[I]=s[c][I];l.push({identifiers:(0,C.$2n)(c),keys:Object.keys(p),contents:(0,R.$Hi)(p,d)})}return l}}e.$8n=u;class m extends P.$Tc{constructor(s,d,l,c){super(),this.c=s,this.f=d,this.g=c,this.b=this.B(new N.$Wd),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&l.isEqual(p.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$9n=m;class a{constructor(s,d,l,c,p,I,w,g,y,L,F,z,j){this.a=s,this.b=d,this.c=l,this.overrideIdentifiers=c,this.d=p,this.f=I,this.g=w,this.h=g,this.i=y,this.j=L,this.k=F,this.l=z,this.m=j}get value(){return E(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(s,d,l,c,p=new S,I=new S,w=new A.$Ac,g=new S,y=new A.$Ac){this.c=s,this.d=d,this.f=l,this.g=c,this.h=p,this.i=I,this.j=w,this.l=g,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,d,l){return this.p(s,d,l).getValue(s)}updateValue(s,d,l={}){let c;l.resource?(c=this.m.get(l.resource),c||(c=new S,this.m.set(l.resource,c))):c=this.l,d===void 0?c.removeValue(s):c.setValue(s,d),l.resource||(this.a=null)}inspect(s,d,l){const c=this.p(s,d,l),p=this.t(d.resource,l),I=d.resource?this.m.get(d.resource)||this.l:this.l,w=new Set;for(const g of c.overrides)for(const y of g.identifiers)c.getOverrideValue(s,y)!==void 0&&w.add(y);return new a(s,d,c.getValue(s),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,p||void 0,I)}keys(s){const d=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,d){this.j.set(s,d),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,d){const l=[];if(!d){const{added:c,updated:p,removed:I}=o(this.c,s);d=[...c,...p,...I]}for(const c of d)for(const p of(0,C.$2n)(c)){const I=this.c.getKeysForOverrideIdentifier(p),w=s.getKeysForOverrideIdentifier(p),g=[...w.filter(y=>I.indexOf(y)===-1),...I.filter(y=>w.indexOf(y)===-1),...I.filter(y=>!v.$Dn(this.c.override(p).getValue(y),s.override(p).getValue(y)))];l.push([p,g])}return this.updateDefaultConfiguration(s),{keys:d,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:d,updated:l,removed:c}=o(this.d,s),p=[...d,...l,...c];return p.length&&this.updatePolicyConfiguration(s),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:d,updated:l,removed:c,overrides:p}=o(this.applicationConfiguration,s),I=[...d,...l,...c];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:p}}compareAndUpdateLocalUserConfiguration(s){const{added:d,updated:l,removed:c,overrides:p}=o(this.localUserConfiguration,s),I=[...d,...l,...c];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:p}}compareAndUpdateRemoteUserConfiguration(s){const{added:d,updated:l,removed:c,overrides:p}=o(this.remoteUserConfiguration,s),I=[...d,...l,...c];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:p}}compareAndUpdateWorkspaceConfiguration(s){const{added:d,updated:l,removed:c,overrides:p}=o(this.workspaceConfiguration,s),I=[...d,...l,...c];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:p}}compareAndUpdateFolderConfiguration(s,d){const l=this.folderConfigurations.get(s),{added:c,updated:p,removed:I,overrides:w}=o(l,d),g=[...c,...p,...I];return(g.length||!l)&&this.updateFolderConfiguration(s,d),{keys:g,overrides:w}}compareAndDeleteFolderConfiguration(s){const d=this.folderConfigurations.get(s);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:c,removed:p,overrides:I}=o(d,void 0);return{keys:[...l,...c,...p],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,d,l){let c=this.q(d,l);return d.overrideIdentifier&&(c=c.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(c=c.merge(this.d)),c}q({resource:s},d){let l=this.r();if(d&&s){const c=d.getFolder(s);c&&(l=this.s(c.uri)||l);const p=this.m.get(s);p&&(l=l.merge(p))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let d=this.b.get(s);if(!d){const l=this.r(),c=this.j.get(s);c?(d=l.merge(c),this.b.set(s,d)):d=l}return d}t(s,d){if(d&&s){const l=d.getFolder(s);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,d)=>{const{contents:l,overrides:c,keys:p}=this.j.get(d);return s.push([d,{contents:l,overrides:c,keys:p}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(d=>s.add(d)),this.userConfiguration.keys.forEach(d=>s.add(d)),this.i.keys.forEach(d=>s.add(d)),this.j.forEach(d=>d.keys.forEach(l=>s.add(l))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}v(s){const d=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.i.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(c=>d.add(c))),[...d.values()]}static parse(s){const d=this.w(s.defaults),l=this.w(s.policy),c=this.w(s.application),p=this.w(s.user),I=this.w(s.workspace),w=s.folders.reduce((g,y)=>(g.set(k.URI.revive(y[0]),this.w(y[1])),g),new A.$Ac);return new i(d,l,c,p,new S,I,w,new S,new A.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$0n=i;function r(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,d=new Map;for(const c of h)c.keys.forEach(p=>s.add(p)),c.overrides.forEach(([p,I])=>{const w=(0,A.$xc)(d,p,new Set);I.forEach(g=>w.add(g))});const l=[];return d.forEach((c,p)=>l.push([p,[...c.values()]])),{keys:[...s.values()],overrides:l}}e.$$n=r;class n{constructor(s,d,l,c){this.change=s,this.f=d,this.g=l,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const p of s.keys)this.affectedKeys.add(p);for(const[,p]of s.overrides)for(const I of p)this.affectedKeys.add(I);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,d){const l=this.a+s,c=this.d.indexOf(l);if(c<0)return!1;const p=c+l.length;if(p>=this.d.length)return!1;const I=this.d.charCodeAt(p);if(I!==this.b&&I!==this.c)return!1;if(d){const w=this.previousConfiguration?this.previousConfiguration.getValue(s,d,this.f?.workspace):void 0,g=this.g.getValue(s,d,this.h);return!v.$Dn(w,g)}return!0}}e.$_n=n;function o(h,s){const{added:d,removed:l,updated:c}=t(s?.rawConfiguration,h?.rawConfiguration),p=[],I=h?.getAllOverrideIdentifiers()||[],w=s?.getAllOverrideIdentifiers()||[];if(s){const g=w.filter(y=>!I.includes(y));for(const y of g)p.push([y,s.getKeysForOverrideIdentifier(y)])}if(h){const g=I.filter(y=>!w.includes(y));for(const y of g)p.push([y,h.getKeysForOverrideIdentifier(y)])}if(s&&h){for(const g of I)if(w.includes(g)){const y=t({contents:h.getOverrideValue(void 0,g)||{},keys:h.getKeysForOverrideIdentifier(g)},{contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)});p.push([g,[...y.added,...y.removed,...y.updated]])}}return{added:d,removed:l,updated:c,overrides:p}}function t(h,s){const d=h?s?h.keys.filter(p=>s.keys.indexOf(p)===-1):[...h.keys]:[],l=s?h?s.keys.filter(p=>h.keys.indexOf(p)===-1):[...s.keys]:[],c=[];if(h&&s){for(const p of s.keys)if(h.keys.indexOf(p)!==-1){const I=(0,R.$Ki)(s.contents,p),w=(0,R.$Ki)(h.contents,p);v.$Dn(I,w)||c.push(p)}}return{added:d,removed:l,updated:c}}}),define(Ce[257],Ie([1,0,21,4,3,82]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Esb=e.$Dsb=e.$Csb=e.$Bsb=void 0;const A=(k,R,C)=>{const b=new Uint8Array(16);for(let u=0;u<16;u++)b[u]=Math.round(Math.random()*256);const E=(0,D.$Ee)(D.$ke.wrap(b));return[`GET ws://localhost${k}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$Bsb=A,e.$Csb=D.$ke.fromString(`\r
\r
`);async function v(k,R,C,b,E){k.write(D.$ke.fromString((0,e.$Bsb)(R,C,b)));const S=new f.$Sc;try{return await new Promise((u,m)=>{let a;S.add(k.onData(i=>{a?a=D.$ke.concat([a,i],a.byteLength+i.byteLength):a=i;const r=a.indexOf(e.$Csb);if(r===-1)return;u(k),k.pauseData();const n=a.slice(r+e.$Csb.byteLength);n.byteLength&&E.onData.fire(n)})),S.add(k.onClose(i=>m(i??new Error("socket closed")))),S.add(k.onEnd(()=>m(new Error("socket ended"))))})}catch(u){throw k.dispose(),u}finally{S.dispose()}}e.$Dsb=v;class $ extends f.$Tc{constructor(R,C){super(),this.g=R,this.a=this.B(new N.$Zd),this.onData=(...b)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...b)),this.b=this.B(new N.$Wd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(b=>this.a.fire(b))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){P.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Esb=$}),define(Ce[65],Ie([1,0,14,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.RemoteAuthorityResolverErrorCode=e.$al=e.$_k=e.RemoteConnectionType=e.$$k=void 0,e.$$k=(0,N.$9h)("remoteAuthorityResolverService");var f;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class P{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$_k=P;class A{constructor(C,b){this.host=C,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$al=A;var v;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===v.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===v.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===v.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===v.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,b=v.Unknown,E){super(C),this._message=C,this._code=b,this._detail=E,this.isHandled=b===v.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$bl=$;function k(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$cl=k}),define(Ce[66],Ie([1,0,15]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0;function N(k){return k.scheme===D.Schemas.vscodeRemote?k.authority:void 0}e.$dl=N;function f(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.$el=f;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$fl=P;function A(k){const{host:R,port:C}=$(k);if(typeof C>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$gl=A;function v(k,R){let{host:C,port:b}=$(k);return typeof b>"u"&&(b=R),{host:C,port:b}}e.$hl=v;function $(k){const R=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=k.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const b=k.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:k,port:void 0}}}),define(Ce[25],Ie([1,0,12,5,66]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.TargetPlatform=e.ExtensionType=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=void 0,e.$im="extensions.user.cache",e.$jm="extensions.builtin.cache",e.$km="undefined_publisher",e.$lm=["ui","workspace","web"];function P(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$mm=P,e.$nm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(A||(e.ExtensionType=A={}));var v;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const i=typeof m=="string"?m:m.value,r=typeof a=="string"?a:a.value;return D.$bf(i,r)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$om=$;class k{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const a of m)this.add(a)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$pm=k;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,a){this.c.set($.toKey(m),a)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qm=R;function C(u){return b(u)}e.$rm=C;function b(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$sm=b;function E(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$tm=E;function S(u,m){if(m){const a=`onResolveRemoteAuthority:${(0,f.$el)(m)}`;return!!u.activationEvents?.includes(a)}return!1}e.$um=S,e.$vm=(0,N.$9h)("IBuiltinExtensionsScannerService")}),define(Ce[137],Ie([1,0,14,25]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(A,v){this.a.set(A,v)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const v=Object.create(null);for(const $ of A){const k=this.readActivationEvents($);k.length>0&&(v[N.$om.toKey($.identifier)]=k)}return v}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const v=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<v.length;$++)v[$]==="onUri"&&(v[$]=`onUri:${N.$om.toKey(A.identifier)}`);if(!A.contributes)return v;for(const $ in A.contributes){const k=this.a.get($);if(!k)continue;const R=A.contributes[$],C=Array.isArray(R)?R:[R];try{k(C,v)}catch(b){(0,D.$1)(b)}}return v}}e.$qF=f,e.$rF=new f}),define(Ce[258],Ie([1,0,8,21,22,14,4,3,58,38,30,82,65,66]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.PersistentConnectionEventType=e.$ol=e.$nl=e.$ml=e.ConnectionType=void 0;const S=30*1e3;var u;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function m(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(K){const B=new f.$7d;return setTimeout(()=>B.cancel(),K),B.token}function i(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return f.CancellationToken.Cancelled;const ae=new f.$7d;return K.onCancellationRequested(()=>ae.cancel()),B.onCancellationRequested(()=>ae.cancel()),ae.token}class r{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new v.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$2g)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function n(K,B){const ae=new r(B);return ae.registerDisposable(K.onControlMessage(Ee=>{const le=JSON.parse(Ee.toString()),de=Q(le);de?ae.reject(de):ae.resolve(le)})),ae.promise}function o(K,B,ae,Ee,le,de,ue,ge){const V=new r(ge),Z=k.$Sd.create(!1);return K.info(`Creating a socket (${ue})...`),$.mark(`code/willCreateSocket/${de}`),B.connect(ae,Ee,le,ue).then(he=>{V.didTimeout?($.mark(`code/didCreateSocketError/${de}`),K.info(`Creating a socket (${ue}) finished after ${Z.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):($.mark(`code/didCreateSocketOK/${de}`),K.info(`Creating a socket (${ue}) was successful after ${Z.elapsed()} ms.`),V.resolve(he))},he=>{$.mark(`code/didCreateSocketError/${de}`),K.info(`Creating a socket (${ue}) returned an error after ${Z.elapsed()} ms.`),K.error(he),V.reject(he)}),V.promise}function t(K,B){const ae=new r(B);return K.then(Ee=>{ae.didTimeout||ae.resolve(Ee)},Ee=>{ae.didTimeout||ae.reject(Ee)}),ae.promise}async function h(K,B,ae,Ee){const le=fe(K,B);K.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let de;try{de=await o(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,E.$fl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,m(B),`renderer-${m(B)}-${K.reconnectionToken}`,Ee)}catch(he){throw K.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),K.logService.error(he),he}K.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ue,ge;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(de,null),ue=K.reconnectionProtocol,ge=!1):(ue=new C.$Wh({socket:de}),ge=!0),K.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const V=await t(K.signService.createNewMessage((0,R.$sg)()),Ee),Z={type:"auth",auth:K.connectionToken||"00000000000000000000",data:V.data};ue.sendControl(N.$ke.fromString(JSON.stringify(Z)));try{const he=await n(ue,i(Ee,a(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(K.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(K.signService.validate(V,he.signedData),Ee)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const Pe=await t(K.signService.sign(he.data),Ee),pe={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:B};return ae&&(pe.args=ae),K.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(N.$ke.fromString(JSON.stringify(pe))),{protocol:ue,ownsProtocol:ge}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(K.logService.error(`${le} the handshake timed out. Error:`),K.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${le} received error control message when negotiating connection. Error:`),K.logService.error(he)),ge&&ee(ue),he}}async function s(K,B,ae,Ee){const le=Date.now(),de=fe(K,B),{protocol:ue,ownsProtocol:ge}=await h(K,B,ae,Ee),V=new r(Ee);return V.registerDisposable(ue.onControlMessage(Z=>{const he=JSON.parse(Z.toString()),be=Q(he);be?(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(be),ge&&ee(ue),V.reject(be)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${re(le)}!`),V.resolve({protocol:ue,firstMessage:he}))})),V.promise}async function d(K,B){const{protocol:ae}=await s(K,1,void 0,B);return{protocol:ae}}async function l(K,B,ae){const{protocol:Ee,firstMessage:le}=await s(K,2,B,ae),de=le&&le.debugPort;return{protocol:Ee,debugPort:de}}async function c(K,B,ae){const Ee=Date.now(),le=fe(K,3),{protocol:de}=await h(K,3,B,ae);return K.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${re(Ee)}!`),de}async function p(K,B,ae){const{connectTo:Ee,connectionToken:le}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:Ee,connectionToken:le,reconnectionToken:B,reconnectionProtocol:ae,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function I(K,B,ae){return g(K,async Ee=>{const{protocol:le}=await d(Ee,f.CancellationToken.None);return new J(K,B,ae,Ee.reconnectionToken,le)})}e.$ml=I;async function w(K,B){return g(K,async ae=>{const{protocol:Ee,debugPort:le}=await l(ae,B,f.CancellationToken.None);return new ne(K,B,ae.reconnectionToken,Ee,le)})}e.$nl=w;async function g(K,B){for(let Ee=1;;Ee++)try{const le=(0,R.$sg)(),de=await p(K,le,null);return await B(de)}catch(le){if(Ee<5)K.logService.error(`[remote-connection][attempt ${Ee}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(le);else throw K.logService.error(`[remote-connection][attempt ${Ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(le),U.triggerPermanentFailure(0,0,b.$bl.isHandled(le)),le}}async function y(K,B,ae){const Ee=await p(K,(0,R.$sg)(),null);return await c(Ee,{host:B,port:ae},f.CancellationToken.None)}e.$ol=y;function L(K){return(0,D.$Vg)(B=>new Promise((ae,Ee)=>{const le=setTimeout(ae,K*1e3);B.onCancellationRequested(()=>{clearTimeout(le),ae()})}))}var F;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(B,ae){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.type=0}}e.$pl=z;class j{constructor(B,ae,Ee,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.durationSeconds=Ee,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$ql=j;class O{constructor(B,ae,Ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.type=2}}e.$rl=O;class M{constructor(B,ae,Ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.type=4}}e.$sl=M;class T{constructor(B,ae,Ee,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.handled=le,this.type=3}}e.$tl=T;class U extends v.$Tc{static triggerPermanentFailure(B,ae,Ee){this._permanentFailure=!0,this.f=B,this.g=ae,this.h=Ee,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(B,ae,Ee,le,de){super(),this.t=B,this.u=ae,this.reconnectionToken=Ee,this.protocol=le,this.w=de,this.m=this.B(new A.$Wd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ue=>{const ge=te(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${ge} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${ge} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${ge} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ue=>{const ge=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ge} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,v.$Rc)(()=>{const ue=U.j.indexOf(this);ue>=0&&U.j.splice(ue,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=te(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ae=[0,5,5,10,10,10,10,10,30];let Ee=-1;do{Ee++;const le=Ee<ae.length?ae[Ee]:ae[ae.length-1];try{if(le>0){const ue=L(le);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ue)),this.u.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1)),this.u.logService.info(`${B} resolving connection...`);const de=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${de.connectTo}...`),await this.G(de,a(S)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1));break}catch(de){if(de.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(Ee>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(b.$bl.isTemporarilyNotAvailable(de)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((de.code==="ETIMEDOUT"||de.code==="ENETUNREACH"||de.code==="ECONNREFUSED"||de.code==="ECONNRESET")&&de.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((0,P.$4)(de)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if(de instanceof b.$bl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,b.$bl.isHandled(de));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}}while(!this.n&&!this.s)}C(B,ae,Ee){this.w?U.triggerPermanentFailure(B,ae,Ee):this.D(B,ae,Ee)}D(B,ae,Ee){this.m.fire(new T(this.reconnectionToken,B,ae,Ee)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ul=U;class J extends U{constructor(B,ae,Ee,le,de){super(1,B,le,de,!0),this.client=this.B(new C.$Uh(de,{remoteAuthority:ae,clientId:Ee},B.ipcLogger))}async G(B,ae){await d(B,ae)}}e.$vl=J;class ne extends U{constructor(B,ae,Ee,le,de){super(2,B,Ee,le,!1),this.H=ae,this.debugPort=de}async G(B,ae){await l(B,this.H,ae)}}e.$wl=ne;function ee(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,P.$1)(B)}}function Q(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Y(K,B){for(;K.length<B;)K+=" ";return K}function ce(K,B){return`[remote-connection][${Y(m(K),13)}][${B.substr(0,5)}\u2026]`}function te(K,B,ae){return`${ce(K,B)}[${ae?"reconnect":"initial"}]`}function fe(K,B){return`${te(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function re(K){return`${Date.now()-K} ms`}}),define(Ce[259],Ie([1,0,3,5]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=void 0,e.$il=(0,N.$9h)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(A,v){return this.a[A]??=[],this.a[A].push(v),(0,D.$Rc)(()=>{const $=this.a[A]?.indexOf(v);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find($=>$.supports(A))}connect(A,v,$,k){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,v,$,k)}}e.$jl=f}),define(Ce[260],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const P=await this.c();if(P){const A=String(D.a++);return this.b.set(A,P),{id:A,data:P.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,P){if(!f.id)return!0;const A=this.b.get(f.id);if(!A)return!1;this.b.delete(f.id);try{return A.validate(P)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$B7b=D}),define(Ce[109],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=void 0,e.$kl="signService",e.$ll=(0,D.$9h)(e.$kl)}),define(Ce[138],Ie([1,0,260]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=void 0;class N extends D.$B7b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(A=>new A.signer().sign(P))}h(){return new Promise((P,A)=>me(["vsda"],P,A))}}e.$v_b=N}),define(Ce[261],Ie([1,0,11,49,30]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=void 0;function P($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,k,R,C,b,E,S,u,m){const a=Object.create(null);a["common.machineId"]=E,a["common.sqmId"]=S,a.sessionID=(0,f.$sg)()+Date.now(),a.commitHash=C,a.version=b,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.$h)(D.$u),a["common.nodePlatform"]=N.$dc,a["common.nodeArch"]=R,a["common.product"]=m||"desktop",u&&(a["common.msftInternal"]=u);let i=0;const r=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(a["common.snap"]="true");const n=P(k);return n&&(a["common.platformDetail"]=n),a}e.$Mo=A;function v($){const k=N.env.USERDNSDOMAIN;if(!k)return!1;const R=k.toLowerCase();return $.some(C=>R===C)}e.$No=v}),define(Ce[262],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0,e.$xl=(0,D.$9h)("telemetryService"),e.$yl=(0,D.$9h)("customEndpointTelemetryService"),e.$zl="telemetry.currentSessionDate",e.$Al="telemetry.firstSessionDate",e.$Bl="telemetry.lastSessionDate",e.$Cl="telemetry.machineId",e.$Dl="telemetry.sqmId",e.$El="telemetry",e.$Fl="telemetry.telemetryLevel",e.$Gl="telemetry.enableCrashReporter",e.$Hl="telemetry.enableTelemetry";var N;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var f;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(Ce[87],Ie([1,0,24,18,66,261,262]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=void 0;class v{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$Oo=v;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Po=$,e.$Qo=new $;class k{async publicLog(h,s,d){}async publicLogError(h,s,d){}}e.$Ro=k,e.$So="telemetry",e.$To="extensionTelemetryLog",e.$Uo={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$Vo=R;function C(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Wo=C;function b(t){const h=t.getValue(A.$Fl),s=t.getValue(A.$Gl);if(t.getValue(A.$Hl)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Xo=b;function E(t){const h={},s={},d={};m(t,d);for(let l in d){l=l.length>150?l.substr(l.length-149):l;const c=d[l];typeof c=="number"?s[l]=c:typeof c=="boolean"?s[l]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${c.length}`),h[l]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(h[l]=c)}return{properties:h,measurements:s}}e.$Yo=E;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const h=(0,f.$el)(t);return S.has(h)?h:"other"}e.$Zo=u;function m(t,h,s=0,d){if(t)for(const l of Object.getOwnPropertyNames(t)){const c=t[l],p=d?d+l:l;Array.isArray(c)?h[p]=(0,D.$En)(c):c instanceof Date?h[p]=c.toISOString():(0,N.$Mf)(c)?s<2?m(c,h,s+1,p+"."):h[p]=(0,D.$En)(c):h[p]=c}}function a(t,h){const s=t.msftInternalDomains||[],d=h.getValue("telemetry.internalTesting");return(0,P.$No)(s)||d}e.$1o=a;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$2o=i;function r(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const d=[];for(const I of h)for(;;){const w=I.exec(t);if(!w)break;d.push([w.index,I.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(s="";;){const I=c.exec(t);if(!I)break;const w=d.some(([g,y])=>I.index<y&&g<c.lastIndex);!l.test(I[0])&&!w&&(s+=t.substring(p,I.index)+"<REDACTED: user-file-path>",p=c.lastIndex)}return p<t.length&&(s+=t.substr(p)),s}function n(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of h)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function o(t,h){return(0,D.$Bn)(t,s=>{if(s instanceof v||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let d=s.replaceAll("%20"," ");d=r(d,h);for(const l of h)d=d.replace(l,"");return d=n(d),d}})}e.$3o=o}),define(Ce[263],Ie([1,0,12,134,25,11,2,14,49,87]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0;function R(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,D.$9e)(s.id,d.id)===0}e.$4o=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(d){const l=d.manifest?d.manifest.version:d.version,c=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new b(d.identifier,l,c)}static parse(d){const l=C.exec(d);return l&&l[1]&&l[2]?new b({id:l[1]},l[2],l[4]||void 0):null}constructor(d,l,c="undefined"){this.version=l,this.targetPlatform=c,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof b?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$5o=b;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const d=E.exec(s);return d&&d[1]?[m(d[1]),d[2]]:[m(s),void 0]}e.$6o=S;function u(s,d){return`${s}.${d}`}e.$7o=u;function m(s){return s.toLowerCase()}e.$8o=m;function a(s,d){return m(u(s??f.$km,d))}e.$9o=a;function i(s,d){const l=[],c=p=>{for(const I of l)if(I.some(w=>R(d(w),d(p))))return I;return null};for(const p of s){const I=c(p);I?I.push(p):l.push([p])}return l}e.$0o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$$o=r;function n(s){return{id:new k.$Oo(s.identifier.id),name:new k.$Oo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$_o=n,e.$ap=new f.$om("pprice.better-merge");function o(s,d){const l=[],c=d.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const p=c.shift();if(p&&l.every(I=>!R(I.identifier,{id:p}))){const I=s.filter(w=>R(w.identifier,{id:p}));I.length===1&&(l.push(I[0]),c.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$bp=o;async function t(s,d){if(!P.$k)return!1;let l;try{l=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){d.debug("Error while getting the os-release file.",(0,v.$0)(p))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(s,d){const l=await t(s,d),c=(0,N.$yo)(l?"alpine":P.$u,$.$ec);return d.debug("ComputeTargetPlatform:",c),c}e.$cp=h}),define(Ce[264],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0;function D($){return[...$.entries()]}e.$Pr=D;function N($){return $?[...$.entries()]:[]}e.$Qr=N;function f($){return new Map($)}e.$Rr=f;function P($){return new Map($??[])}e.$Sr=P;function A($){return Array.from($.entries()).map(k=>[k[0],D(k[1].map),N(k[1].descriptionMap)])}e.$Tr=A;function v($){return new Map($.map(k=>[k[0],{map:f(k[1]),descriptionMap:P(k[2])}]))}e.$Ur=v}),define(Ce[265],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vsb=void 0;class D{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,P,A=5){const v=P($=>{const k=typeof $=="string"?$:$.data;let R=this.a.get(f);if(R){R.data.push(k);return}const C=setTimeout(()=>this.flushBuffer(f),A);R={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(f),v.dispose()}},this.a.set(f,R)});return v}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const P=this.a.get(f);P&&(this.a.delete(f),this.b(f,P.data.join("")))}}e.$Vsb=D}),define(Ce[266],Ie([1,0,8,79,55,4,18,2,208,108,37]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.IconFontDefinition=e.IconContribution=e.$zw=void 0,e.$zw={IconContribution:"base.contributions.icons"};var C;(function(n){function o(t,h){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const d=S.getIcon(s.id);if(!d)return;s=d.defaults}return s}n.getDefinition=o})(C||(e.IconContribution=C={}));var b;(function(n){function o(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=o;function t(h){const s=d=>(0,A.$Kf)(d)?d:void 0;if(h&&Array.isArray(h.src)&&h.src.every(d=>(0,A.$Kf)(d.format)&&(0,A.$Kf)(d.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(d=>({format:d.format,location:v.URI.parse(d.location)}))}}n.fromJSONObject=t})(b||(e.IconFontDefinition=b={}));class E{constructor(){this.a=new P.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(o,t,h,s){const d=this.b[o];if(d){if(h&&!d.description){d.description=h,this.d.properties[o].markdownDescription=`${h} $(${o})`;const p=this.e.enum.indexOf(o);p!==-1&&(this.e.enumDescriptions[p]=h),this.a.fire()}return d}const l={id:o,description:h,defaults:t,deprecationMessage:s};this.b[o]=l;const c={$ref:"#/definitions/icons"};return s&&(c.deprecationMessage=s),h&&(c.markdownDescription=`${h}: $(${o})`),this.d.properties[o]=c,this.e.enum.push(o),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:o}}deregisterIcon(o){delete this.b[o],delete this.d.properties[o];const t=this.e.enum.indexOf(o);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(o=>this.b[o])}getIcon(o){return this.b[o]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(o,t){const h=this.f[o];return h||(this.f[o]=t,this.a.fire(),t)}deregisterIconFont(o){delete this.f[o]}getIconFont(o){return this.f[o]}toString(){const o=(d,l)=>d.id.localeCompare(l.id),t=d=>{for(;f.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(d=>this.b[d]);for(const d of s.filter(l=>!!l.description).sort(o))h.push(`|<i class="${t(d)}"></i>|${d.id}|${f.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const d of s.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(o))h.push(`|<i class="${t(d)}"></i>|${d.id}|`);return h.join(`
`)}}const S=new E;R.$Ln.add(e.$zw.IconContribution,S);function u(n,o,t,h){return S.registerIcon(n,o,t,h)}e.$Aw=u;function m(){return S}e.$Bw=m;function a(){const n=(0,N.$ak)();for(const o in n){const t="\\"+n[o].toString(16);S.registerIcon(o,{fontCharacter:t})}}a(),e.$Cw="vscode://schemas/icons";const i=R.$Ln.as(k.$Mn.JSONContribution);i.registerSchema(e.$Cw,S.getIconSchema());const r=new D.$ih(()=>i.notifySchemaChanged(e.$Cw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Dw=u("widget-close",N.$ck.close,(0,$.localize)(2,null)),e.$Ew=u("goto-previous-location",N.$ck.arrowUp,(0,$.localize)(3,null)),e.$Fw=u("goto-next-location",N.$ck.arrowDown,(0,$.localize)(4,null)),e.$Gw=f.ThemeIcon.modify(N.$ck.sync,"spin"),e.$Hw=f.ThemeIcon.modify(N.$ck.loading,"spin")}),define(Ce[88],Ie([1,0,4,2,51,5,13]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.ProvidedOnAutoForward=e.$Fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ev=e.$Dv=void 0,e.$Dv=(0,P.$9h)("tunnelService"),e.$Ev=(0,P.$9h)("sharedTunnelsService");var v;(function(a){a.Http="http",a.Https="https"})(v||(e.TunnelProtocol=v={}));var $;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(a){return!!a.forwardPort}e.$Fv=k;var R;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(R||(e.ProvidedOnAutoForward=R={}));function C(a,{checkQuery:i=!0}={}){if(a.scheme!=="http"&&a.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(r)return{address:r[1],port:+r[2]};if(!a.query||!i)return;const n=a.query.split("&");for(const o of n){const t=o.split("=")[1];if(/^https?:/.exec(t)){const h=C(N.URI.parse(t));if(h)return h}}}e.$Gv=C,e.$Hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(a){return e.$Hv.indexOf(a)>=0}e.$Iv=b,e.$Jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(a){return e.$Jv.indexOf(a)>=0}e.$Kv=E;function S(a,i,r,n){if(r===1)return!1;if(r===2&&E(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return a<1024}e.$Lv=S;class u{constructor(i,r,n){this.remoteAddress=i,this.localAddress=r,this.b=n,this.a=new D.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mv=u;let m=class{constructor(i,r){this.k=i,this.l=r,this.a=new D.$Wd,this.onTunnelOpened=this.a.event,this.b=new D.$Wd,this.onTunnelClosed=this.b.event,this.c=new D.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const n of r){const o=Array.from(n.values());for(const t of o){const h=await t.value;h&&typeof h!="string"&&i.push(h)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(n=>typeof n!="string"?n?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,n,o,t){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:n,privacy:o,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(E(i)||b(i))&&(i=e.$Hv[0]);const n=this.s(i,r);if(n)return++n.refcount,n.value}openTunnel(i,r,n,o,t,h=!1,s,d){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${n} on local port ${t}.`);const l=this.f??i;if(!l)return;if(r||(r="localhost"),o||(o=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.t(l,r,n,o,t,h,s,d);return c?c.then(p=>{if(p){if(typeof p=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,n),p}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o(p);return(p.tunnelRemoteHost!==r||p.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&p.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const n=r.get(i.tunnelRemotePort);n&&(n.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,n))}}}}async p(i,r,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=n.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const n=this.e.get(i);if(n&&n.has(r)){const o=n.get(r);o.refcount=0,await this.p(i,r,o)}}q(i,r,n){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:n})}async r(i,r){const n=this.e.get(i);if(n){const o=n.get(r),t=o?await o.value:void 0;(!t||typeof t=="string")&&n.delete(r),n.size===0&&this.e.delete(i)}}s(i,r){const n=[i];b(i)?(n.push(...e.$Hv),n.push(...e.$Jv)):E(i)&&n.push(...e.$Jv);const o=n.map(t=>this.e.get(t));for(const t of o){const h=t?.get(r);if(h)return h}}canTunnel(i){return!!C(i)}u(i,r,n,o,t,h,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${n} on local port ${o}.`);const d=n;this.j.add(d);const l=o===void 0?n:o,c={elevationRequired:t?this.isPortPrivileged(l):!1},p={remoteAddress:{host:r,port:n},localAddressPort:o,privacy:h,public:h?h!==$.Private:void 0,protocol:s},I=i.forwardPort(p,c);return I?(this.q(r,n,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(d)})):this.j.delete(d),I}};e.$Nv=m,e.$Nv=m=Ke([We(0,A.$qj),We(1,f.$Ci)],m)}),define(Ce[267],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=void 0,e.$4k=(0,D.$9h)("IUriIdentityService")}),define(Ce[268],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ov=void 0,e.$Ov=(0,D.$9h)("editSessionIdentityService");var N;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ce[269],Ie([1,0,15]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=void 0;function N($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$YK=N;function f($){if($.folders.length)return $.folders.every(k=>N(k.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}e.$ZK=f;function P($){return f($)?.scheme}e.$1K=P;function A($){return f($)?.authority}e.$2K=A;function v($){return f($)!==void 0}e.$3K=v}),define(Ce[40],Ie([1,0,210,17,78,23,2,5,15]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.WorkbenchState=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,v.$9h)("contextService");function k(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.uri)}e.$gi=k;function R(d){return typeof d?.id=="string"&&!k(d)&&!b(d)}e.$hi=R,e.$ii={id:"ext-dev"},e.$ji={id:"empty-window"};function C(d,l){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,N.$nc)(d)}:l?e.$ii:e.$ji;const c=d;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$ki=C;function b(d){const l=d;return typeof l?.id=="string"&&A.URI.isUri(l.configPath)}e.$li=b;function E(d){const l=d;if(l?.uri)return{id:l.id,uri:A.URI.revive(l.uri)};const c=d;if(c?.configPath)return{id:c.id,configPath:A.URI.revive(c.configPath)};if(d?.id)return{id:d.id}}e.$mi=E;var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function u(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$ni=u;function m(d){const l=d;return!!(l&&typeof l=="object"&&A.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$oi=m;class a{constructor(l,c,p,I,w){this.h=l,this.j=p,this.k=I,this.l=w,this.c=f.$ci.forUris(this.l,()=>!0),this.folders=c}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=f.$ci.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$pi=a;class i{constructor(l,c){this.raw=c,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,P.$Jg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$qi=i;function r(d){return new i({uri:d,index:0,name:(0,P.$Fg)(d)},{uri:d.toString()})}e.$ri=r,e.$si="code-workspace",e.$ti=`.${e.$si}`,e.$ui=[{name:(0,D.localize)(0,null),extensions:[e.$si]}],e.$vi="workspace.json";function n(d,l){return P.$Ag.isEqualOrParent(d,l.untitledWorkspacesHome)}e.$wi=n;function o(d){let l;return A.URI.isUri(d)?l=d:l=d.configuration,l?.scheme===$.Schemas.tmp}e.$xi=o,e.$yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$yi}e.$zi=t;function h(d,l){return!n(d,l)&&!o(d)}e.$Ai=h;function s(d){return(typeof d=="string"?(0,N.$oc)(d):(0,P.$Hg)(d))===e.$ti}e.$Bi=s}),define(Ce[270],Ie([1,0,54,4,3,23,2,209,133,32,5,13,40,28,267,8,30,12,18]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.ProfileResourceType=void 0;var r;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(d){const l=d;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&A.URI.isUri(l.location)&&A.URI.isUri(l.globalStorageHome)&&A.URI.isUri(l.settingsResource)&&A.URI.isUri(l.keybindingsResource)&&A.URI.isUri(l.tasksResource)&&A.URI.isUri(l.snippetsHome)&&A.URI.isUri(l.extensionsResource))}e.$5k=n,e.$6k=(0,R.$9h)("IUserDataProfilesService");function o(d,l){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:A.URI.revive(d.location).with({scheme:l}),globalStorageHome:A.URI.revive(d.globalStorageHome).with({scheme:l}),settingsResource:A.URI.revive(d.settingsResource).with({scheme:l}),keybindingsResource:A.URI.revive(d.keybindingsResource).with({scheme:l}),tasksResource:A.URI.revive(d.tasksResource).with({scheme:l}),snippetsHome:A.URI.revive(d.snippetsHome).with({scheme:l}),extensionsResource:A.URI.revive(d.extensionsResource).with({scheme:l}),cacheHome:A.URI.revive(d.cacheHome).with({scheme:l}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}e.$7k=o;function t(d,l,c,p,I,w){return{id:d,name:l,location:c,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:w&&I?.useDefaultFlags?.globalState?w.globalStorageHome:(0,P.$Jg)(c,"globalStorage"),settingsResource:w&&I?.useDefaultFlags?.settings?w.settingsResource:(0,P.$Jg)(c,"settings.json"),keybindingsResource:w&&I?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,P.$Jg)(c,"keybindings.json"),tasksResource:w&&I?.useDefaultFlags?.tasks?w.tasksResource:(0,P.$Jg)(c,"tasks.json"),snippetsHome:w&&I?.useDefaultFlags?.snippets?w.snippetsHome:(0,P.$Jg)(c,"snippets"),extensionsResource:w&&I?.useDefaultFlags?.extensions?w.extensionsResource:(0,P.$Jg)(c,"extensions.json"),cacheHome:(0,P.$Jg)(p,d),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$8k=t;let h=class extends f.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,c,p,I){super(),this.t=l,this.u=c,this.w=p,this.y=I,this.f=!0,this.h=this.B(new N.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Jg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Jg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),c=[l];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,i.$Kf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}c.push(t((0,P.$Gg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},l))}}catch(w){this.y.error(w)}const p=new E.$Ac,I=new Map;if(c.length)try{const w=this.Q();if(w.workspaces)for(const[g,y]of Object.entries(w.workspaces)){const L=A.URI.parse(g),F=c.find(z=>z.id===y);F&&p.set(L,F)}if(w.emptyWindows)for(const[g,y]of Object.entries(w.emptyWindows)){const L=c.find(F=>F.id===y);L&&I.set(g,L)}}catch(w){this.y.error(w)}this.z={profiles:c,workspaces:p,emptyWindows:I}}return this.z}D(){const l=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const c="Temp",p=new RegExp(`${(0,a.$Pe)(c)}\\s(\\d+)`);let I=0;for(const g of this.profiles){const y=p.exec(g.name),L=y?parseInt(y[1]):0;I=L>I?L:I}const w=`${c} ${I+1}`;return this.createProfile((0,D.$Wi)((0,m.$sg)()).toString(16),w,{transient:!0},l)}async createNamedProfile(l,c,p){return this.createProfile((0,D.$Wi)((0,m.$sg)()).toString(16),l,c,p)}async createProfile(l,c,p,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(l,c,p);return I&&await this.setProfileForWorkspace(I,w),w}async F(l,c,p){if(!(0,i.$Kf)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(c);return I||(I=(async()=>{try{const w=this.profiles.find(L=>L.name===c||L.id===l);if(w)return w;const g=t(l,c,(0,P.$Jg)(this.profilesHome,l),this.g,p,this.defaultProfile);await this.u.createFolder(g.location);const y=[];return this.j.fire({profile:g,join(L){y.push(L)}}),await u.Promises.settled(y),this.I([g],[],[]),g}finally{this.r.delete(c)}})(),this.r.set(c,I)),I}async updateProfile(l,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(I=>I.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);return p=t(p.id,c.name??p.name,p.location,this.g,{shortName:c.shortName??p.shortName,icon:c.icon===null?void 0:c.icon??p.icon,transient:c.transient??p.isTransient,useDefaultFlags:c.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(I=>I.id===l.id);if(!c)throw new Error(`Profile '${l.name}' does not exist`);const p=[];this.m.fire({profile:c,join(I){p.push(I)}});try{await Promise.allSettled(p)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(I){(0,k.$Kk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(l,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(I=>I.id===c.id);if(!p)throw new Error(`Profile '${c.name}' does not exist`);this.L(l,p)}unsetWorkspace(l,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(c=>c.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(l.map(c=>this.removeProfile(c)))}getProfileForWorkspace(l){const c=this.G(l);return A.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(l){return(0,b.$gi)(l)?l.uri:(0,b.$li)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,l.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,l.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,l.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,l.location)))}I(l,c,p){const I=[...this.profiles,...l],w=[];this.s.profiles=[];for(let g of I)g.isDefault||c.some(y=>g.id===y.id)||(g=p.find(y=>g.id===y.id)??g,g.isTransient?this.s.profiles.push(g):w.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P(w),this.z=void 0,this.J(l,c,p)}J(l,c,p){this.h.fire({added:l,removed:c,updated:p,all:this.profiles})}L(l,c,p){p=c?.isTransient?!0:p,p||this.L(l,void 0,!0);const I=this.G(l),w=p?this.s:this.C;A.URI.isUri(I)?(w.workspaces.delete(I),c&&w.workspaces.set(I,c)):(w.emptyWindows.delete(I),c&&w.emptyWindows.set(I,c)),p||this.M()}M(){const l={};for(const[p,I]of this.C.workspaces.entries())l[p.toString()]=I.id;const c={};for(const[p,I]of this.C.emptyWindows.entries())c[p.toString()]=I.id;this.R({workspaces:l,emptyWindows:c}),this.z=void 0}N(l){const c={},p=this.D();if(l.workspaces)for(const[w,g]of Object.entries(l.workspaces)){const y=A.URI.parse(g);c[w]=this.w.extUri.isEqual(y,p.location)?p.id:this.w.extUri.basename(y)}const I={};if(l.emptyWindows)for(const[w,g]of Object.entries(l.emptyWindows)){const y=A.URI.parse(g);I[w]=this.w.extUri.isEqual(y,p.location)?p.id:this.w.extUri.basename(y)}return{workspaces:c,emptyWindows:I}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$9k=h,e.$9k=h=Ke([We(0,$.$di),We(1,k.$tk),We(2,S.$4k),We(3,C.$qj)],h);class s extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$0k=s}),define(Ce[271],Ie([1,0,8,4,3,58,18,189,5,270]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$xp=e.$wp=e.$vp=void 0,e.$vp="__$__isNewStorageMarker",e.$wp="__$__targetStorageMarker",e.$xp=(0,$.$9h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var b;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function E(i){const r=i.get(e.$wp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$yp=E;class S extends f.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new N.$Zd),this.c=this.B(new N.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,o){return N.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),o)}n(){this.j.value=(0,D.$mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:o,external:t}=n;if(o===e.$wp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:o,target:this.J(r)[o],external:t})}w(r){this.f.fire({reason:r})}get(r,n,o){return this.P(n)?.get(r,o)}getBoolean(r,n,o){return this.P(n)?.getBoolean(r,o)}getNumber(r,n,o){return this.P(n)?.getNumber(r,o)}getObject(r,n,o){return this.P(n)?.getObject(r,o)}storeAll(r,n){this.y(()=>{for(const o of r)this.store(o.key,o.value,o.scope,o.target,n)})}store(r,n,o,t,h=!1){if((0,A.$Tf)(n)){this.remove(r,o,h);return}this.y(()=>{this.z(r,o,t),this.P(o)?.set(r,n,h)})}remove(r,n,o=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,o)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const o=[],t=this.J(r);for(const h of Object.keys(t))t[h]===n&&o.push(h);return o}z(r,n,o,t=!1){const h=this.J(n);typeof o=="number"?h[r]!==o&&(h[r]=o,this.P(n)?.set(e.$wp,JSON.stringify(h),t)):typeof h[r]=="number"&&(delete h[r],this.P(n)?.set(e.$wp,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?E(n):Object.create(null)}isNew(r){return this.getBoolean(e.$vp,r)===!0}async flush(r=R.NONE){this.f.fire({reason:r});const n=this.P(-1),o=this.P(0),t=this.P(1);switch(r){case R.NONE:await D.Promises.settled([n?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await D.Promises.settled([n?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,o=this.P(1)?.items??new Map;return a(r,n,o,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(R.NONE),(0,k.$5k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||u(n)&&u(r))}N(r,n,o){this.y(()=>{const t=new Set;for(const[h,s]of r)t.add(h),n.get(h)!==s&&this.u(o,{key:h,external:!0});for(const[h]of n.items)t.has(h)||this.u(o,{key:h,external:!0})})}}e.$zp=S;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Ap=u;class m extends S{constructor(){super(),this.U=this.B(new v.$tp(new v.$up,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$tp(new v.$up,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$tp(new v.$up,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$Bp=m;async function a(i,r,n,o,t,h){const s=L=>{try{return JSON.parse(L)}catch{return L}},d=new Map,l=new Map;i.forEach((L,F)=>{d.set(F,L),l.set(F,s(L))});const c=new Map,p=new Map;r.forEach((L,F)=>{c.set(F,L),p.set(F,s(L))});const I=new Map,w=new Map;n.forEach((L,F)=>{I.set(F,L),w.set(F,s(L))}),console.group(o!==t?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const g=[];if(d.forEach((L,F)=>{g.push({key:F,value:L})}),console.table(g),console.groupEnd(),console.log(l),o!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];c.forEach((F,z)=>{L.push({key:z,value:F})}),console.table(L),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${h})`);const y=[];I.forEach((L,F)=>{y.push({key:F,value:L})}),console.table(y),console.groupEnd(),console.log(w)}e.$Cp=a}),define(Ce[110],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class D{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const P=this.c++;return this.b.set(P,f),this.e(),P}get(f,P){return this.b.has(f)?this.b.get(f)[P]:void 0}delete(f){this.b.delete(f),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$xgc=D}),define(Ce[59],Ie([1,0,15,23,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=void 0;class P{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new N.$yg(v=>{const $=this.b.get(v.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(v,$){$===null?this.b.delete(v.scheme):this.b.set(v.scheme,$)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$Agc=P,e.$Bgc=(0,f.$9h)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0,e.$TN=(0,D.$9h)("IExtHostInitDataService")}),define(Ce[272],Ie([1,0,216,13,252,27]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;let A=class extends f.$1O{constructor($,k,R){const C=R.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",b=R.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(k.createLogger(C,{name:b}))}};e.$Hic=A,e.$Hic=A=Ke([We(1,N.$rj),We(2,P.$TN)],A)}),define(Ce[273],Ie([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;class N{constructor(A,v,$){this.h=new Map,this.a=A,this.b=v,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new D.$ih(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of k.values())R.complete()}catch(R){for(const C of k.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,v){let $=this.f[A];return typeof $>"u"&&($=v),$}update(A,v){this.f[A]=v;const $=this.h.get(A);if($!==void 0)return $.p;const k=new D.$th;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$jhc=N;class f extends N{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,v){super(A.identifier.value,!0,v),this.j=A}}e.$khc=f}),define(Ce[274],Ie([1,0,4,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class f{constructor(A){this.c=A,this.a=new D.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,v,$,k){const C=this.c.getNotebookDocument(N.URI.revive(A)).acceptModelChanged(v.value,$,k);this.b.fire(C)}$acceptDirtyStateChanged(A,v){this.c.getNotebookDocument(N.URI.revive(A)).acceptDirty(v)}$acceptModelSaved(A){const v=this.c.getNotebookDocument(N.URI.revive(A));this.a.fire(v.apiNotebook)}}e.$0hc=f}),define(Ce[20],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=void 0,e.$DN=(0,D.$9h)("IExtHostRpcService");class N{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$EN=N}),define(Ce[275],Ie([1,0,25,4]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class f{#e;constructor(A,v){this.b=new N.$Wd,this.onDidChange=this.b.event,this.a=D.$om.toKey(A.identifier),this.#e=v,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(A){return this.#e.get(this.a,A)}store(A,v){return this.#e.store(this.a,A,v)}delete(A){return this.#e.delete(this.a,A)}}e.$rhc=f}),define(Ce[67],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=void 0,e.$Tgc=(0,D.$9h)("IURITransformerService");class N{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Ugc=N}),define(Ce[276],Ie([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lb=e.$3lb=void 0;class N{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function f(v,$){if($.serializeBuffersForPostMessage){const k=new N,C=JSON.stringify(v,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S)};if(ArrayBuffer.isView(S)){const u=P(S);if(u)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S.buffer),view:{type:u,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),b=k.buffers.map(E=>{const S=new Uint8Array(E);return D.$ke.wrap(S)});return{message:C,buffers:b}}else return{message:JSON.stringify(v),buffers:[]}}e.$3lb=f;function P(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(v,$){const k=$.map(b=>{const E=new ArrayBuffer(b.byteLength);return new Uint8Array(E).set(b.buffer),E}),R=$.length?(b,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:u}=S,m=k[u];if(S.view)switch(S.view.type){case 1:return new Int8Array(m,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(v,R),arrayBuffers:k}}e.$4lb=A}),define(Ce[277],Ie([1,0,278,391,392,62,2,13,393]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;const k=!1;function R(r,n,o,t,h,s){const d=s.environment.useHostProxy,l=typeof d=="boolean"?d:!s.remote.isRemote,c={resolveProxy:w=>r.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,h,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>b(n),addCertificatesV2:()=>E(n),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case v.LogLevel.Trace:return $.LogLevel.Trace;case v.LogLevel.Debug:return $.LogLevel.Debug;case v.LogLevel.Info:return $.LogLevel.Info;case v.LogLevel.Warning:return $.LogLevel.Warning;case v.LogLevel.Error:return $.LogLevel.Error;case v.LogLevel.Off:return $.LogLevel.Off;default:return g(w)}function g(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const w=[];if(s.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const g=r.loadCertificates();g.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(g)}return(await Promise.all(w)).flat()},env:process.env},p=(0,$.createProxyResolver)(c),I=C(c,p);return u(o,I)}e.$djc=R;function C(r,n){return{http:Object.assign(D,(0,$.createHttpPatch)(r,D,n)),https:Object.assign(N,(0,$.createHttpPatch)(r,N,n)),net:Object.assign(P,(0,$.createNetPatch)(r,P)),tls:Object.assign(f,(0,$.createTlsPatch)(r,f))}}function b(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",k)&&!!n.get("systemCertificates")}function E(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",k)&&!!n.get("systemCertificates")}const S=new Map;function u(r,n){return r.getExtensionPathIndex().then(o=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(d,l,c){if(d==="net")return n.net;if(d==="tls")return n.tls;if(d!=="http"&&d!=="https")return h.apply(this,arguments);const p=o.findSubstr(A.URI.file(l.filename));let I=S.get(p);if(I||S.set(p,I={}),!I[d]){const w=n[d];I[d]={...w}}return I[d]}})}async function m(r,n,o,t,h,s,d,l){const c=t[s];d&&(t[s]=d),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${d}`,`proxyAuthenticateCache:${c}`);const p=d||c,I=Array.isArray(p)?p:typeof p=="string"?[p]:[];if(i(n,I,h),I.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const w=await new Promise((z,j)=>{me(["kerberos"],z,j)}),g=new URL(s),y=o.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let a=!1;function i(r,n,o){a||!n.length||(a=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:o?"remote":"local"}))}}),define(Ce[279],Ie([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;function N(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(P){return new D.$8m(N(P))}e.$6r=f}),define(Ce[139],Ie([1,0,226,18,2,3,5,37,32,15,44,181,39]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.$8E=e.EditorsOrder=e.$7E=e.CloseDirection=e.$6E=e.$5E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.EditorInputCapabilities=e.$VE=e.SaveReason=e.Verbosity=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=void 0,e.$IE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$JE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$KE="workbench.editor.sidebysideEditor",e.$LE="workbench.editors.textDiffEditor",e.$ME="workbench.editors.binaryResourceDiffEditor";var E;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function u(re){const K=re;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$NE=u;function m(re,K,B){for(const ae of B.visibleEditorPanes)if(ae.group.id===K&&re.matches(ae.input))return ae.getViewState()}e.$OE=m;function a(re){if(p(re))return!1;const K=re;return f.URI.isUri(K?.resource)}e.$PE=a;function i(re){if(p(re))return!1;const K=re;return K?.original!==void 0&&K.modified!==void 0}e.$QE=i;function r(re){if(p(re))return!1;const K=re;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$RE=r;function n(re){if(p(re)||i(re))return!1;const K=re;return K?.primary!==void 0&&K.secondary!==void 0}e.$SE=n;function o(re){if(p(re))return!1;const K=re;return K?K.resource===void 0||K.resource.scheme===k.Schemas.untitled||K.forceUntitled===!0:!1}e.$TE=o;function t(re){if(p(re))return!1;const K=re;return f.URI.isUri(K?.base?.resource)&&f.URI.isUri(K?.input1?.resource)&&f.URI.isUri(K?.input2?.resource)&&f.URI.isUri(K?.result?.resource)}e.$UE=t;var h;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class d{constructor(){this.a=new Map}registerSource(K,B){let ae=this.a.get(K);return ae||(ae={source:K,label:B},this.a.set(K,ae)),ae.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$VE=new d;var l;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class c extends P.$Tc{}e.$WE=c;function p(re){return re instanceof c}e.$XE=p;function I(re){const K=re;return f.URI.isUri(K?.preferredResource)}function w(re){const K=re;return p(K?.primary)&&p(K?.secondary)}e.$YE=w;function g(re){const K=re;return p(K?.modified)&&p(K?.original)}e.$ZE=g;function y(re,K,B,ae,Ee){return fe(ae,[(0,C.$Si)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};re.openEditor(K,le)}}),(0,C.$Si)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.$1E=y;function L(re){return p(re?.editor)}e.$2E=L;function F(re){const K=re;return L(re)&&K?.group!==void 0}e.$3E=F;function z(re){const K=re;return typeof K?.groupId=="number"&&p(K.editor)}e.$4E=z;var j;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(j||(e.EditorCloseContext=j={}));var O;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var M;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class T{getOriginalUri(K,B){if(!K)return;if(t(K))return e.$6E.getOriginalUri(K.result,B);if(B?.supportSideBySide){const{primary:Ee,secondary:le}=this.a(K);if(Ee&&le){if(B?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===M.ANY)return this.getOriginalUri(Ee,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===M.PRIMARY?Ee:le}}if(i(K)||r(K)||n(K)||t(K))return;const ae=I(K)?K.preferredResource:K.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}a(K){return w(K)||n(K)?{primary:K.primary,secondary:K.secondary}:g(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,B){if(!K)return;if(t(K))return e.$6E.getCanonicalUri(K.result,B);if(B?.supportSideBySide){const{primary:Ee,secondary:le}=this.a(K);if(Ee&&le){if(B?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===M.ANY)return this.getCanonicalUri(Ee,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===M.PRIMARY?Ee:le}}if(i(K)||r(K)||n(K)||t(K))return;const ae=K.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}b(K,B){if(Array.isArray(B)){if(B.some(ae=>K.scheme===ae))return K}else if(B===K.scheme)return K}}var U;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function J(re,K,B,ae){if(!re.isSticky(K))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return B===U.MOUSE||B===U.KEYBOARD;case"mouse":return B===U.MOUSE;case"keyboard":return B===U.KEYBOARD}return!1}e.$5E=J,e.$6E=new T;var ne;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(ne||(e.CloseDirection=ne={}));class ee{constructor(){this.c=new Map,this.d=new Map}start(K){const B=this.a=K.get(A.$8h);for(const[ae,Ee]of this.c)this.e(ae,Ee,B);this.c.clear()}e(K,B,ae){const Ee=ae.createInstance(B);this.d.set(K,Ee)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,N.$Vf)(this.b)}registerEditorSerializer(K,B){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,B,this.a):this.c.set(K,B),(0,P.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}v.$Ln.add(e.$IE.EditorFactory,new ee);async function Q(re,K,B){return!re||!re.length?[]:await Promise.all(re.map(async ae=>{const Ee=f.URI.revive(ae.fileUri);if(!Ee){B.info("Cannot resolve the path because it is not valid.",ae);return}if(!await K.canHandleResource(Ee)){B.info("Cannot resolve the path because it cannot be handled",ae);return}let de=ae.exists,ue=ae.type;if(typeof de!="boolean"||typeof ue!="number")try{ue=(await K.stat(Ee)).isDirectory?$.FileType.Directory:$.FileType.Unknown,de=!0}catch(V){B.error(V),de=!1}if(!de&&ae.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ae);return}if(ue===$.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ae);return}const ge={...ae.options,pinned:!0};return de?{resource:Ee,options:ge}:{resource:Ee,options:ge,forceUntitled:!0}}))}e.$7E=Q;var Y;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function ce(re){const K=re;if(!K)return!1;const B=K;if(B.modified)return ce(B.modified);const ae=K;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.$8E=ce;function te(re){return(0,R.$Ui)(re)}e.$9E=te;function fe(re,K,B){const ae=(0,R.$Vi)(re,K);return ae.forceMessage=B?.forceMessage,ae.forceSeverity=B?.forceSeverity,ae.allowDialog=B?.allowDialog,ae}e.$0E=fe}),define(Ce[280],Ie([1,0,4,227,5,3,28,37,19,24,79,266]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$dF=e.ViewContentGroups=e.$cF=e.$bF=e.ViewContainerLocation=e.Extensions=e.$aF=e.$_E=e.$$E=void 0,e.$$E="views",e.$_E=(0,N.localize)(0,null),e.$aF=(0,C.$Aw)("default-view-icon",R.$ck.window,(0,N.localize)(1,null));var b;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var E;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$bF=[0,1,2];function S(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$cF=S;class u extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,d,l){const c=this.get(s.id);if(c)return c;const p=s;return p.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,A.$xc)(this.g,d,[]).push(p),l?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:d}),p}deregisterViewContainer(s){for(const d of this.g.keys()){const l=this.g.get(d),c=l?.indexOf(s);if(c!==-1){l?.splice(c,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}v.$Ln.add(b.ViewContainersRegistry,new u);var m;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(m||(e.ViewContentGroups=m={}));function a(h,s){const d=h.group??m.More,l=s.group??m.More;return d!==l?d.localeCompare(l):(h.order??5)-(s.order??5)}class i extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new D.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(s)}deregisterViews(s,d){const l=this.s(s,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(s,d){for(const l of this.m.keys())if(l!==d){const c=this.s(s,l);c.length&&(this.r(c,d),this.g.fire({views:c,from:l,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const l=(this.m.get(d)||[]).filter(c=>c.id===s)[0];if(l)return l}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(c=>c.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,P.$Rc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const l=new Map;for(const[c,p]of d)this.n.add(s,p),l.set(c,(0,P.$Rc)(()=>{this.n.delete(s,p),this.h.fire(s)}));return this.h.fire(s),l}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,l=>d.push(l)),d.sort(a)}r(s,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const c of s){if(this.getView(c.id)!==null)throw new Error((0,N.localize)(2,null,c.id));l.push(c)}}s(s,d){const l=this.m.get(d);if(!l)return[];const c=[],p=[];for(const I of l)s.includes(I)?c.push(I):p.push(I);return c.length&&(p.length?this.m.set(d,p):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),c}}v.$Ln.add(b.ViewsRegistry,new i),e.$dF=(0,f.$9h)("viewDescriptorService");var r;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,d){this.c=!1,this.d=!1,(0,k.$Cn)(this,s),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const c=await d(l);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$eF=o;class t extends Error{constructor(s){super((0,N.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$fF=t}),define(Ce[281],Ie([1,0,2,29,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$nF=e.$mF=void 0;function P(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof D.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(N.$Xs.isIRange)}e.$mF=P;function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(P)}e.$nF=A;var v;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$oF=(0,f.$9h)("IChatService"),e.$pF="accessibility.voice.keywordActivation"}),define(Ce[140],Ie([1,0,4,8,228]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new D.$Wd,this.n=new D.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(v){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=v}onEvent(v){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=v}onRequest(v){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=v}sendResponse(v){v.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.s("response",v)}sendRequest(v,$,k,R){const C={command:v};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof R=="number"){const b=setTimeout(()=>{clearTimeout(b);const E=this.f.get(C.seq);if(E){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:v,message:(0,f.localize)(0,null,R,v)};E(S)}},R)}return k&&this.f.set(C.seq,k),C.seq}acceptMessage(v){this.j?this.j(v):(this.k.push(v),this.k.length===1&&this.q())}o(v,$){return v.type!=="event"||$.type!=="event"}async q(){let v;for(;this.k.length;){if((!v||this.o(this.k[0],v))&&await(0,N.$0g)(0),v=this.k.shift(),!v)return;switch(v.type){case"event":this.i?.(v);break;case"request":this.g?.(v);break;case"response":{const $=v,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}s(v,$){$.type=v,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const v=new Map;this.f.forEach(($,k)=>v.set(k,$)),await(0,N.$0g)(500),v.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$wmb=P}),define(Ce[282],Ie([1,0,2,229,45,5]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$ZH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$YH=e.MemoryRangeType=e.$XH=e.State=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=void 0,e.$PG="workbench.view.debug",e.$QG="workbench.debug.variablesView",e.$RG="workbench.debug.watchExpressionsView",e.$SG="workbench.debug.callStackView",e.$TG="workbench.debug.loadedScriptsView",e.$UG="workbench.debug.breakPointsView",e.$VG="workbench.debug.disassemblyView",e.$WG="workbench.panel.repl",e.$XG="workbench.panel.repl.view",e.$YG=new f.$nj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$ZG=new f.$nj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$1G=new f.$nj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$2G="debugUx",e.$3G=new f.$nj(e.$2G,"default",{type:"string",description:N.localize(3,null)}),e.$4G=new f.$nj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$5G=new f.$nj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$6G=new f.$nj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$7G=new f.$nj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$8G=new f.$nj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$9G=new f.$nj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$0G=new f.$nj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$$G=new f.$nj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$_G=new f.$nj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$aH=new f.$nj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$bH=new f.$nj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$cH=new f.$nj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$dH=new f.$nj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$eH=new f.$nj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$fH=new f.$nj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$gH=new f.$nj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$hH=new f.$nj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$iH=new f.$nj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$jH=new f.$nj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(22,null)}),e.$kH=new f.$nj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(23,null)}),e.$lH=new f.$nj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(24,null)}),e.$mH=new f.$nj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(25,null)}),e.$nH=new f.$nj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(26,null)}),e.$oH=new f.$nj("stepBackSupported",!1,{type:"boolean",description:N.localize(27,null)}),e.$pH=new f.$nj("restartFrameSupported",!1,{type:"boolean",description:N.localize(28,null)}),e.$qH=new f.$nj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(29,null)}),e.$rH=new f.$nj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$sH=new f.$nj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(31,null)}),e.$tH=new f.$nj("breakpointsExist",!1,{type:"boolean",description:N.localize(32,null)}),e.$uH=new f.$nj("debuggersAvailable",!1,{type:"boolean",description:N.localize(33,null)}),e.$vH=new f.$nj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(34,null)}),e.$wH=new f.$nj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(35,null)}),e.$xH=new f.$nj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(36,null)}),e.$yH=new f.$nj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(37,null)}),e.$zH=new f.$nj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$AH=new f.$nj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$BH=new f.$nj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$CH=new f.$nj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$DH=new f.$nj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$EH=new f.$nj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(43,null)}),e.$FH=new f.$nj("variableIsReadonly",!1,{type:"boolean",description:N.localize(44,null)}),e.$GH=new f.$nj("variableValue",!1,{type:"string",description:N.localize(45,null)}),e.$HH=new f.$nj("variableType",!1,{type:"string",description:N.localize(46,null)}),e.$IH=new f.$nj("variableName",!1,{type:"string",description:N.localize(47,null)}),e.$JH=new f.$nj("variableLanguage",!1,{type:"string",description:N.localize(48,null)}),e.$KH=new f.$nj("variableExtensionId",!1,{type:"string",description:N.localize(49,null)}),e.$LH=new f.$nj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(50,null)}),e.$MH=new f.$nj("multiSessionRepl",!1,{type:"boolean",description:N.localize(51,null)}),e.$NH=new f.$nj("multiSessionDebug",!1,{type:"boolean",description:N.localize(52,null)}),e.$OH=new f.$nj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(53,null)}),e.$PH=new f.$nj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(54,null)}),e.$QH=new f.$nj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(55,null)}),e.$RH=new f.$nj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(56,null)});const A=u=>N.localize(57,null,u);e.$SH=A,e.$TH="editor.contrib.debug",e.$UH="editor.contrib.breakpoint",e.$VH="debug",e.$WH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(58,null)};var v;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(v||(e.State=v={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$XH=$;var k;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$YH="vscode-debug-memory";var R;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var C;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$ZH=(0,P.$9h)("debugService");var b;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE",u[u.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var E;(function(u){u[u.Command=0]="Command",u[u.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var S;(function(u){u.deserialize=m=>({id:m.id,name:m.name,iconPath:m.iconPath&&{light:D.URI.revive(m.iconPath.light),dark:D.URI.revive(m.iconPath.dark)},iconClass:m.iconClass,visualization:m.visualization}),u.serialize=m=>m})(S||(e.IDebugVisualization=S={}))}),define(Ce[283],Ie([1,0,12,2,17,24,15,29,22,19]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=void 0;const R=/{([^}]+)}/g;function C(I,w,g){return I.replace(R,function(y,L){return w&&L.length>0&&L[0]!=="_"?y:g&&g.hasOwnProperty(L)?g[L]:y})}e.$eG=C;function b(I){const w={};for(const g of Object.keys(I))g.startsWith("!")||(w[g]=I[g]);return w}e.$fG=b;function E(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||E(I.parentSession))}e.$gG=E;function S(I){let w=I.configuration.type;if(w)return w==="vslsShare"&&(w=I.configuration.adapterProxy.configuration.type),(0,D.$bf)(w,"extensionhost")||(0,D.$bf)(w,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$hG=S;function u(I){return I.type&&(I.label||I.program||I.runtime)}e.$iG=u;function m(I,w,g){let y,L=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=F.exec(I);){const j=z.index+1,O=j+z[0].length;if(j<=w&&O>=g){y=z[0],L=j;break}}if(y){const j=/\w+/g;let O=null;for(;(O=j.exec(y))&&!(O.index+1+L+O[0].length>=g););O&&(y=y.substring(0,j.lastIndex))}return y?{start:L,end:L+y.length-1}:{start:0,end:0}}e.$jG=m;async function a(I,w,g,y){if(I.evaluatableExpressionProvider.has(w)){const L=I.evaluatableExpressionProvider.ordered(w),F=(0,k.$Hb)(await Promise.all(L.map(async z=>{try{return await z.provideEvaluatableExpression(w,g,y??$.CancellationToken.None)}catch{return}})));if(F.length>0){let z=F[0].expression;const j=F[0].range;return z||(z=w.getLineContent(g.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:z}}}else{const L=w.getLineContent(g.lineNumber),{start:F,end:z}=m(L,g.column,g.column),j=L.substring(F-1,z);return{matchingExpression:j,range:new v.$Xs(g.lineNumber,F,g.lineNumber,F+j.length)}}return null}e.$kG=a;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(i))}e.$lG=r;function n(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return N.URI.parse(I.path);if((0,f.$ic)(I.path))return N.URI.file(I.path)}return I.path}function o(I){if(typeof I.path=="object"){const w=N.URI.revive(I.path);if(w)return w.scheme===A.Schemas.file?w.fsPath:w.toString()}return I.path}function t(I,w){const g=w?n:o,y=(0,P.$zn)(I);return s(y,(L,F)=>{L&&F&&(F.path=g(F))}),y}e.$mG=t;function h(I,w){const g=w?n:o,y=(0,P.$zn)(I);return s(y,(L,F)=>{!L&&F&&(F.path=g(F))}),y}e.$nG=h;function s(I,w){switch(I.type){case"event":{const g=I;switch(g.event){case"output":w(!1,g.body.source);break;case"loadedSource":w(!1,g.body.source);break;case"breakpoint":w(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=I;switch(g.command){case"setBreakpoints":w(!0,g.arguments.source);break;case"breakpointLocations":w(!0,g.arguments.source);break;case"source":w(!0,g.arguments.source);break;case"gotoTargets":w(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const g=I;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":g.body.sources.forEach(y=>w(!1,y));break;case"scopes":g.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":g.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":g.body?.instructions.forEach(L=>w(!1,L.location));break;default:break}break}}}function d(I){return I.filter(w=>!w.presentation?.hidden).sort((w,g)=>w.presentation?g.presentation?w.presentation.group?g.presentation.group?w.presentation.group!==g.presentation.group?w.presentation.group.localeCompare(g.presentation.group):l(w.presentation.order,g.presentation.order):-1:g.presentation.group?1:l(w.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$oG=d;function l(I,w){return typeof I!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:I-w}async function c(I,w){const g=I.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(g!=="none"&&(await w.saveAll(),g==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}e.$pG=c;const p=(I,w)=>!I||!w?I===w:I.name===w.name&&I.path===w.path&&I.sourceReference===w.sourceReference;e.$qG=p}),define(Ce[284],Ie([1,0,50,62,24,17,11,12,31,230,140]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=e.$Pic=e.$Oic=e.$Nic=void 0;class C extends R.$wmb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(a,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,a.on("data",r=>this.w(r))}sendMessage(a){if(this.p){const i=JSON.stringify(a);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(a){for(this.r=Buffer.concat([this.r,a]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(C.b);for(const o of n){const t=o.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$Nic=C;class b extends C{startSession(){return new Promise((a,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),a(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Oic=b;class E extends b{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$Pic=E;class S extends b{constructor(a){super(),this.z=a}y(a){return N.createConnection(this.z.path,a)}}e.$Qic=S;class u extends C{constructor(a,i){super(),this.y=a,this.z=i}async startSession(){const a=this.y.command,i=this.y.args,r=this.y.options||{};try{if(a)if(P.$ic(a)){if(!await $.Promises.exists(a))throw new Error(k.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=f.$Cn(f.$zn(process.env),r.env)),a==="node")if(Array.isArray(i)&&i.length>0){const o=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:o?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const h=D.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(k.localize(2,null,i[0]));this.x=h}else throw new Error(k.localize(3,null));else{const o={env:n};r.cwd&&(o.cwd=r.cwd),this.x=D.spawn(a,i,o)}this.x.on("error",o=>{this.m.fire(o)}),this.x.on("exit",(o,t)=>{this.n.fire(o)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",o=>{this.m.fire(o)}),this.x.stdin.on("error",o=>{this.m.fire(o)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((a,i)=>{const r=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,o,t){if(n)return i(n)});r.on("exit",a),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,i){if(!a)return;const r=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?r.runtime=P.$jc(i,a.runtime):r.runtime=a.runtime),a.runtimeArgs&&(r.runtimeArgs=a.runtimeArgs),a.program&&(P.$ic(a.program)?r.program=a.program:r.program=P.$jc(i,a.program)),a.args&&(r.args=a.args);const n=a;return n.win&&(r.win=u.A(n.win,i)),n.winx86&&(r.winx86=u.A(n.winx86,i)),n.windows&&(r.windows=u.A(n.windows,i)),n.osx&&(r.osx=u.A(n.osx,i)),n.linux&&(r.linux=u.A(n.linux,i)),r}static platformAdapterExecutable(a,i){let r=Object.create(null);i=i.toLowerCase();for(const d of a)if(d.contributes){const l=d.contributes.debuggers;l&&l.length>0&&l.filter(c=>typeof c.type=="string"&&v.$bf(c.type,i)).forEach(c=>{const p=u.A(c,d.extensionLocation.fsPath);r=f.$Cn(r,p,d.isBuiltin)})}let n;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:A.$i?n=r.win||r.windows:A.$j?n=r.osx:A.$k&&(n=r.linux),n=n||r;const o=n.program||r.program,t=n.args||r.args,h=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(h)return{type:"executable",command:h,args:(s||[]).concat(typeof o=="string"?[o]:[]).concat(t||[])};if(o)return{type:"executable",command:o,args:t||[]}}}e.$Ric=u}),define(Ce[285],Ie([1,0,50,34,11]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=void 0;function P(k,R){return new Promise((C,b)=>{let E="";const S=D.spawn(k,R);S.pid&&S.stdout.on("data",u=>{E+=u.toString()}),S.on("error",u=>{b(u)}),S.on("close",u=>{C(E)})})}async function A(k){if(k)if(f.$i){const R=await new Promise((C,b)=>{me(["@vscode/windows-process-tree"],C,b)});return new Promise(C=>{R.getProcessTree(k,b=>{C(!!b&&b.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$Sic=A;var v;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(v||(v={}));function $(k,R,C,b,E){k=k.trim().toLowerCase();let S;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?S=1:k.indexOf("cmd.exe")>=0?S=0:k.indexOf("bash")>=0?S=2:f.$i?S=0:S=2;let u,m=" ";switch(S){case 1:if(u=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),b){const a=(0,N.$cg)(b);a&&(m+=`${a}:; `),m+=`cd ${u(b)}; `}if(E)for(const a in E){const i=E[a];i===null?m+=`Remove-Item env:${a}; `:m+=`\${env:${a}}='${i}'; `}if(R.length>0){const a=R.shift(),i=C?a:u(a);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of R)m+=r==="<"||r===">"||C?r:u(r),m+=" "}break;case 0:if(u=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>a.includes(i))||a.length===0?`"${a}"`:a),b){const a=(0,N.$cg)(b);a&&(m+=`${a}: && `),m+=`cd ${u(b)} && `}if(E){m+='cmd /C "';for(const a in E){let i=E[a];i===null?m+=`set "${a}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),m+=`set "${a}=${i}" && `)}}for(const a of R)m+=a==="<"||a===">"||C?a:u(a),m+=" ";E&&(m+='"');break;case 2:{u=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const a=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(b&&(m+=`cd ${u(b)} ; `),E){m+="/usr/bin/env";for(const i in E){const r=E[i];r===null?m+=` -u ${a(i)}`:m+=` ${a(`${i}=${r}`)}`}m+=" "}for(const i of R)m+=i==="<"||i===">"||C?i:u(i),m+=" ";break}}return m}e.$Tic=$}),define(Ce[286],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.CellExecutionUpdateType=void 0;var N;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vJ=(0,D.$9h)("INotebookExecutionService")}),define(Ce[287],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfb=e.$Xfb=e.ProxyKernelState=e.$Wfb=void 0,e.$Wfb=100;var N;(function(f){f[f.Disconnected=1]="Disconnected",f[f.Connected=2]="Connected",f[f.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$Xfb=(0,D.$9h)("INotebookKernelService"),e.$Yfb=(0,D.$9h)("INotebookKernelHistoryService")}),define(Ce[288],Ie([1,0,3,29,194,99]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Rb=void 0;class A extends D.$Tc{constructor($,k,R){super(),this._source=$,this.b=k,this.c=R,this.a=void 0}f($){const k=$.getLineCount();return new N.$Xs(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new f.$fC;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:R,disposable:C}=k.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new f.$fC;k.acceptChunk($);const R=k.finish(!0),{textBuffer:C,disposable:b}=R.create(1);return this.B(b),C})),this.a}findInInputs($){const R=new P.$6B($,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs($){const R=new P.$6B($,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const b=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(b.length!==0)return{textBuffer:C,matches:b}}).filter(C=>!!C):[]}}e.$8Rb=A}),define(Ce[68],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gK=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class f{static fromExtHostTestItem(A,v,$=A.parent){if(A._isRoot)return new f([v]);const k=[A.id];for(let R=$;R&&R.id!==v;R=R.parent)k.push(R.id);return k.push(v),new f(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const v=A.indexOf("\0");return v===-1?A:A.slice(0,v)}static fromString(A){return new f(A.split("\0"))}static join(A,v){return new f([...A.path,v])}static joinToString(A,v){return A.toString()+"\0"+v}static parentId(A){const v=A.lastIndexOf("\0");return v===-1?void 0:A.slice(0,v)}static localId(A){const v=A.lastIndexOf("\0");return v===-1?A:A.slice(v+1)}static isChild(A,v){return v.startsWith(A)&&v[A.length]==="\0"}static compare(A,v){return A===v?0:f.isChild(A,v)?2:f.isChild(v,A)?3:1}constructor(A,v=A.length){if(this.path=A,this.d=v,A.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let v=0;v<A.d&&v<this.d;v++)if(A.path[v]!==this.path[v])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$gK=f}),define(Ce[89],Ie([1,0,2,48,29,68]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$nK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$mK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$lK=e.$kK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$jK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$iK=e.$hK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var v;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$hK=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$iK=k;var R;(function(M){M.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),M.deserialize=(T,U)=>({range:f.$Xs.lift(U.range),uri:T.asCanonicalUri(D.URI.revive(U.uri))})})(R||(e.IRichLocation=R={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var b;(function(M){M.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&R.serialize(T.location)}),M.deserialize=(T,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&R.deserialize(T,U.location)})})(b||(e.ITestErrorMessage=b={}));const E=(M,T)=>`${T?"s":"e"}${M}`;e.$jK=E;var S;(function(M){M.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&R.serialize(T.location)}),M.deserialize=(T,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&R.deserialize(T,U.location)})})(S||(e.ITestOutputMessage=S={}));var u;(function(M){M.serialize=T=>T.type===0?b.serialize(T):S.serialize(T),M.deserialize=(T,U)=>U.type===0?b.deserialize(T,U):S.deserialize(T,U)})(u||(e.ITestMessage=u={}));var m;(function(M){M.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),M.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(u.serialize)}),M.deserialize=(T,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(J=>u.deserialize(T,J))})})(m||(e.ITestTaskState=m={}));const a="\0",i=(M,T)=>M+a+T;e.$kK=i;const r=M=>{const T=M.indexOf(a);return{ctrlId:M.slice(0,T),tagId:M.slice(T+1)}};e.$lK=r;var n;(function(M){M.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),M.deserialize=(T,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?T.asCanonicalUri(D.URI.revive(U.uri)):void 0,range:U.range?f.$Xs.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(n||(e.ITestItem=n={}));var o;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var t;(function(M){M.serialize=T=>({expand:T.expand,item:n.serialize(T.item)}),M.deserialize=(T,U)=>({controllerId:P.$gK.root(U.item.extId),expand:U.expand,item:n.deserialize(T,U.item)})})(t||(e.InternalTestItem=t={}));var h;(function(M){M.serialize=T=>{let U;return T.item&&(U={},T.item.label!==void 0&&(U.label=T.item.label),T.item.tags!==void 0&&(U.tags=T.item.tags),T.item.busy!==void 0&&(U.busy=T.item.busy),T.item.uri!==void 0&&(U.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(U.range=T.item.range?.toJSON()),T.item.description!==void 0&&(U.description=T.item.description),T.item.error!==void 0&&(U.error=T.item.error),T.item.sortText!==void 0&&(U.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:U}},M.deserialize=T=>{let U;return T.item&&(U={},T.item.label!==void 0&&(U.label=T.item.label),T.item.tags!==void 0&&(U.tags=T.item.tags),T.item.busy!==void 0&&(U.busy=T.item.busy),T.item.range!==void 0&&(U.range=T.item.range?f.$Xs.lift(T.item.range):null),T.item.description!==void 0&&(U.description=T.item.description),T.item.error!==void 0&&(U.error=T.item.error),T.item.sortText!==void 0&&(U.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:U}}})(h||(e.ITestItemUpdate=h={}));const s=(M,T)=>{T.expand!==void 0&&(M.expand=T.expand),T.item!==void 0&&(M.item=M.item?Object.assign(M.item,T.item):T.item)};e.$mK=s;var d;(function(M){M.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),M.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),M.deserialize=(T,U)=>({...t.deserialize(T,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(J=>m.deserialize(T,J)),retired:!0})})(d||(e.TestResultItem=d={}));var l;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(T,U)=>{T.covered+=U.covered,T.total+=U.total}})(l||(e.ICoveredCount=l={}));var c;(function(M){M.serialize=T=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(g.serialize),uri:T.uri.toJSON()}),M.deserialize=(T,U)=>({statement:U.statement,branch:U.branch,declaration:U.declaration,details:U.details?.map(g.deserialize),uri:T.asCanonicalUri(D.URI.revive(U.uri))})})(c||(e.IFileCoverage=c={}));function p(M){return{...M,location:M.location?.toJSON()}}function I(M){return M.location=M.location?N.$Ws.isIPosition(M.location)?N.$Ws.lift(M.location):f.$Xs.lift(M.location):void 0,M}e.$nK=3;var w;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(w||(e.DetailType=w={}));var g;(function(M){M.serialize=T=>T.type===0?L.serialize(T):F.serialize(T),M.deserialize=T=>T.type===0?L.deserialize(T):F.deserialize(T)})(g||(e.CoverageDetails=g={}));var y;(function(M){M.serialize=p,M.deserialize=I})(y||(e.IBranchCoverage=y={}));var L;(function(M){M.serialize=p,M.deserialize=I})(L||(e.IDeclarationCoverage=L={}));var F;(function(M){M.serialize=T=>({...p(T),branches:T.branches?.map(y.serialize)}),M.deserialize=T=>({...I(T),branches:T.branches?.map(y.deserialize)})})(F||(e.IStatementCoverage=F={}));var z;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var j;(function(M){M.deserialize=(T,U)=>U.op===0?{op:U.op,item:t.deserialize(T,U.item)}:U.op===1?{op:U.op,item:h.deserialize(U.item)}:U.op===2?{op:U.op,uri:T.asCanonicalUri(D.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:h.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class O{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const U=this.v();for(const J of T)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),U);break;case 1:this.o(h.deserialize(J.item),U);break;case 3:this.p(J.itemId,U);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}U.complete?.()}l(T,U){const J=P.$gK.parentId(T.item.extId)?.toString();let ne;if(!J)ne=this.w(T),this.g.add(ne),this.f.set(T.item.extId,ne);else if(this.f.has(J)){const ee=this.f.get(J);ee.children.add(T.item.extId),ne=this.w(T,ee),this.f.set(T.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return U.add?.(ne),T.expand===2&&this.h++,ne}o(T,U){const J=this.f.get(T.extId);if(J)return T.expand!==void 0&&(J.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$mK)(J,T),U.update?.(J),J}p(T,U){const J=this.f.get(T);if(!J)return;const ne=P.$gK.parentId(J.item.extId)?.toString();ne?this.f.get(ne).children.delete(J.item.extId):this.g.delete(J);const ee=[[T]];for(;ee.length;)for(const Q of ee.pop()){const Y=this.f.get(Q);Y&&(ee.push(Y.children),this.f.delete(Q),U.remove?.(Y,Y!==J),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$oK=O}),define(Ce[111],Ie([1,0,8,4,3,61,89,68]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(i,r)=>i===r,C=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),b=(i,r)=>{let n;for(const[o,t]of C)t(i[o],r[o])||(n?n[o]=r[o]:n={[o]:r[o]});return n};class E extends f.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new D.$ih(()=>this.flushDiff(),200)),this.g=this.B(new N.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,A.$mK)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,A.$mK)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const o=this.tree.get(r);if(o){if((o.expandLevels===void 0||n>o.expandLevels)&&(o.expandLevels=n),o.expand===1){const t=this.M(o);return t.isOpen()?this.L(o,n-1):t.wait().then(()=>this.L(o,n-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.L(o,n-1)):this.L(o,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(v.$gK.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const o of n.ops)this.w(r,o);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,P.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const o=v.$gK.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let h=this.tree.get(o.toString());if(!h){h={fullId:o,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(r)}}),this.I(r,h,n);return}if(h.actual===r){this.H(r,h,n);return}if(h.actual.uri?.toString()!==r.uri?.toString())return this.O(o.toString()),this.z(r,n);const s=this.s.getChildren(h.actual),d=h.actual,l=b(this.s.toITestItem(d),this.s.toITestItem(r));this.s.getApiFor(d).listener=void 0,h.actual=r,h.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(r.tags,d.tags,o.toString()),delete l.tags),this.w(h,{op:4,update:l})),this.I(r,h,n);for(const[c,p]of s)this.s.getChildren(r).get(p.id)||this.O(v.$gK.joinToString(o,p.id));this.y(h.actual.uri)}C(r,n,o){const t=new Set(n.map(h=>h.id));for(const h of r)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:o,item:{tags:r.map(h=>(0,A.$kK)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$kK)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,A.$kK)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,o){this.G(r,o);const t=this.s.getApiFor(r);t.parent=o?.actual,t.listener=h=>this.w(n,h),this.J(n)}I(r,n,o){this.H(r,n,o);for(const[t,h]of this.s.getChildren(r))this.z(h,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const o=[];for(const[t,h]of this.s.getChildren(r.actual)){const s=this.expand(v.$gK.joinToString(r.fullId,h.id),n);(0,D.$Ug)(s)&&o.push(s)}if(o.length)return Promise.all(o).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const h=new D.$8g;return h.open(),h}r.expand=2,this.N(r);const n=r.resolveBarrier=new D.$8g,o=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(h){o(h)}return(0,D.$Ug)(t)?t.catch(o).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const o=[n];for(;o.length;){const t=o.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,s]of this.s.getChildren(t.actual))o.push(this.tree.get(v.$gK.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$tN=E;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$uN=S;class u extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$vN=u;class m extends Error{constructor(r,n,o){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${o}".`)}}e.$wN=m;const a=(i,r,n)=>{let o=new Map;return{get size(){return o.size},forEach(t,h){for(const s of o.values())t.call(h,s,this)},[Symbol.iterator](){return o.entries()},replace(t){const h=new Map,s=new Set(o.keys()),d={op:5,ops:[]};for(const l of t){if(!(l instanceof n))throw new u(l.id);const c=r(l).controllerId;if(c!==i.controllerId)throw new m(l.id,c,i.controllerId);if(h.has(l.id))throw new S(l.id);h.set(l.id,l),s.delete(l.id),d.ops.push({op:0,item:l})}for(const l of s.keys())d.ops.push({op:3,id:l});i.listener?.(d),o=h},add(t){if(!(t instanceof n))throw new u(t.id);o.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){o.delete(t)&&i.listener?.({op:3,id:t})},get(t){return o.get(t)},toJSON(){return Array.from(o.values())}}};e.$xN=a}),define(Ce[141],Ie([1,0,111]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=void 0;const N=new WeakMap,f=(A,v)=>{const $={controllerId:v};return N.set(A,$),$};e.$yN=f;const P=A=>{const v=N.get(A);if(!v)throw new D.$vN(A?.id||"<unknown>");return v};e.$zN=P}),define(Ce[112],Ie([1,0,15,2]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mwb=e.$Lwb=e.$Kwb=e.$Jwb=e.$Iwb=void 0,e.$Iwb="vscode-cdn.net",e.$Jwb=`vscode-resource.${e.$Iwb}`,e.$Kwb=`'self' https://*.${e.$Iwb}`;function f(v,$){return v.scheme===D.Schemas.http||v.scheme===D.Schemas.https?v:($&&$.authority&&$.isRemote&&v.scheme===D.Schemas.file&&(v=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:v.path})),N.URI.from({scheme:D.Schemas.https,authority:`${v.scheme}+${P(v.authority)}.${e.$Jwb}`,path:v.path,fragment:v.fragment,query:v.query}))}e.$Lwb=f;function P(v){return v.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function A(v){return v.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}e.$Mwb=A}),define(Ce[289],Ie([1,0,4,3,112]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class P{constructor(v,$,k){this.d=v,this.e=$,this.f=k,this.a=0,this.b=new N.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const R=$.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(v=>v.inset.dispose()),this.b.dispose()}createWebviewEditorInset(v,$,k,R,C){let b;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===v){b=r;break}if(!b)throw new Error("not a visible editor");const E=this,S=this.a++,u=new D.$Wd,m=new D.$Wd,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,f.$Lwb)(r,E.f)}get cspSource(){return f.$Kwb}set options(r){this.b=r,E.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,E.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(r){return E.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=v,this.line=$,this.height=k,this.webview=a,this.onDidDispose=m.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),m.fire(),m.dispose(),u.dispose())}};return this.d.$createEditorInset(S,b.id,b.value.document.uri,$+1,k,R||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:v,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(v){const $=this.c.get(v);$&&$.inset.dispose()}$onDidReceiveMessage(v,$){this.c.get(v)?.onDidReceiveMessage.fire($)}}e.$Rgc=P}),define(Ce[142],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$vK=void 0,e.$vK="__",e.$wK=(0,D.$9h)("IAuthenticationService")}),define(Ce[290],Ie([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.VariableKind=e.$pO=void 0,e.$pO=(0,D.$9h)("configurationResolverService");var N;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class f extends Error{constructor(A,v){super(v),this.variable=A}}e.$qO=f}),define(Ce[291],Ie([1,0,17,49,18,24,11,102,233,290,12]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,S,u,m){this.h=new Map,this.a=E,this.b=S,this.g=u,m&&(this.c=m.then(a=>this.i(a)))}i(E){if(A.$i){const S=Object.create(null);return Object.keys(E).forEach(u=>{S[u.toLowerCase()]=E[u]}),S}return E}resolveWithEnvironment(E,S,u){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,u)}async resolveAsync(E,S){const u={env:await this.c,userHome:await this.g};return this.l(u,E?E.uri:void 0,S)}async j(E,S,u,m){const a=P.$zn(S);A.$i&&a.windows?Object.keys(a.windows).forEach(r=>a[r]=a.windows[r]):A.$j&&a.osx?Object.keys(a.osx).forEach(r=>a[r]=a.osx[r]):A.$k&&a.linux&&Object.keys(a.linux).forEach(r=>a[r]=a.linux[r]),delete a.windows,delete a.osx,delete a.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,a,u,m)}async resolveAnyAsync(E,S,u){return this.j(E,S,u)}async resolveAnyMap(E,S,u){const m=new Map;return{newConfig:await this.j(E,S,u,m),resolvedVariables:m}}resolveWithInteractionReplace(E,S,u,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,u,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,u,m,a){if(f.$Kf(u))return this.m(E,S,u,m,a);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(E,S,i,m,a)));if(f.$Mf(u)){const i=Object.create(null),r=await Promise.all(Object.keys(u).map(async n=>[await this.m(E,S,n,m,a),await this.l(E,S,u[n],m,a)]));for(const[n,o]of r)i[n]=o;return i}return u}m(E,S,u,m,a){return(0,R.$6e)(u,C.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(C.VARIABLE_LHS))return i;let n=await this.o(E,i,r,S,m);return a?.set(r,n),n!==i&&f.$Kf(n)&&n.match(C.VARIABLE_REGEXP)&&(n=await this.m(E,S,n,m,a)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,u,m,a){let i;const r=u.split(":");r.length>1&&(u=r[0],i=r[1]);const n=h=>{const s=this.a.getFilePath();if(s)return(0,v.$Zv)(s);throw new k.$qO(h,(0,$.localize)(0,null,S))},o=h=>{const s=n(h);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,v.$Zv)(d)}throw new k.$qO(h,(0,$.localize)(1,null,S,D.$nc(s)))},t=h=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new k.$qO(h,(0,$.localize)(2,null,S,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new k.$qO(h,(0,$.localize)(3,null,S)):new k.$qO(h,(0,$.localize)(4,null,S))};switch(u){case"env":if(i){if(E.env){const h=E.env[A.$i?i.toLowerCase():i];if(f.$Kf(h))return h}return""}throw new k.$qO(k.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const h=this.a.getConfigurationValue(m,i);if(f.$Tf(h))throw new k.$qO(k.VariableKind.Config,(0,$.localize)(6,null,S,i));if(f.$Mf(h))throw new k.$qO(k.VariableKind.Config,(0,$.localize)(7,null,S,i));return h}throw new k.$qO(k.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(k.VariableKind.Command,S,i,a,"command");case"input":return this.p(k.VariableKind.Input,S,i,a,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new k.$qO(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(h.extensionLocation)}throw new k.$qO(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,v.$Zv)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,v.$Zv)(this.n(t(k.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.$Zv)(D.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$qO(k.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new k.$qO(k.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new k.$qO(k.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(k.VariableKind.File);case"fileWorkspaceFolder":return o(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(o(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?D.$lc(this.n(t(k.VariableKind.RelativeFile)),n(k.VariableKind.RelativeFile)):n(k.VariableKind.RelativeFile);case"relativeFileDirname":{const h=D.$mc(n(k.VariableKind.RelativeFileDirname));if(m||i){const s=D.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),h);return s.length===0?".":s}return h}case"fileDirname":return D.$mc(n(k.VariableKind.FileDirname));case"fileExtname":return D.$oc(n(k.VariableKind.FileExtname));case"fileBasename":return D.$nc(n(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=D.$nc(n(k.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-D.$oc(h).length)}case"fileDirnameBasename":return D.$nc(D.$mc(n(k.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||S}case"execInstallFolder":{const h=this.a.getAppRoot();return h||S}case"pathSeparator":case"/":return D.sep;default:try{const h=i?`${u}:${i}`:u;return this.p(k.VariableKind.Unknown,S,h,a,void 0)}catch{return S}}}}p(E,S,u,m,a){if(u&&m){const i=a===void 0?m[u]:m[a+":"+u];if(typeof i=="string")return i;throw new k.$qO(E,(0,$.localize)(14,null,S))}return S}}e.$EO=C}),define(Ce[143],Ie([1,0,5,139]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.OpenEditorContext=e.GroupsOrder=e.$cD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$bD=void 0,e.$bD=(0,D.$9h)("editorGroupsService");var f;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var v;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(S){const u=S;return(0,N.$XE)(u?.editor)&&(0,N.$XE)(u?.replacement)}e.$cD=k;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function b(S){const u=S;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$dD=b;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$eD=E}),define(Ce[292],Ie([1,0,5,143]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=void 0,e.$fD=(0,D.$9h)("editorService"),e.$gD=-1,e.$hD=-2,e.$iD=-3;function f(P){const A=P;return typeof P=="number"||(0,N.$dD)(A)}e.$jD=f}),define(Ce[144],Ie([1,0,5,133]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=void 0,e.$MK=(0,D.$0h)(N.$di)}),define(Ce[145],Ie([1,0,25,4,17,3,8]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E8b=e.$D8b=e.$C8b=e.$B8b=e.$A8b=void 0;class v{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$A8b=v;class ${static isHostExtension(i,r,n){if(r.getExtensionDescription(i))return!1;const o=n.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new N.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(u),this.f=new D.$qm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const n of r)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=m(this.e,r),this.e=this.e.concat(i);const n=$.l(this.e);return this.e=m(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new v(this.d,n)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,d){this.addNode(s),this.addNode(d),this.c.has(s)?this.c.get(s).push(d):this.c.set(s,[d])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,d){const l=r.getArcs(s);for(let c=0;c<l.length;c++)if(!d.has(l[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$qm;for(const s of i)if(n.set(s.identifier,s),s.extensionDependencies)for(const d of s.extensionDependencies)r.addArc(D.$om.toKey(s.identifier),D.$om.toKey(d));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const t=r.getNodes().filter(s=>!o.has(s));let h;do{h=!1;for(let s=0;s<t.length;s++){const d=t[s];r.hasOnlyGoodArcs(d,o)&&(t.splice(s,1),s--,o.add(d),h=!0)}}while(h);return t.map(s=>n.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$B8b=$;class k{constructor(i,r){this.versionId=i,this.extensions=r}}e.$C8b=k;class R{constructor(i){this.d=new E,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new C(this,r)}deltaExtensions(i,r,n){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,n)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$D8b=R;class C extends P.$Tc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$E8b=C;class b{constructor(i){this.name=i;const r=(0,A.$2g)();this.promise=r.promise,this.c=r.resolve}resolve(i){this.c(i)}}class E{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new b(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const n=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(n),r=!1,this.d=!1,this.e())};i.resolve((0,P.$Rc)(o))}}var S;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(S||(S={}));function u(a,i){const r=a.isBuiltin?0:a.isUnderDevelopment?2:1,n=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==n)return r-n;const o=f.$gc.basename(a.extensionLocation.path),t=f.$gc.basename(i.extensionLocation.path);return o<t?-1:o>t?1:0}function m(a,i){const r=new D.$pm(i);return a.filter(n=>!r.has(n.identifier))}}),define(Ce[293],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.ExtHostConnectionType=void 0;var D;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$Tm=N;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[f.ENV_KEY]="1"}}e.$Um=f;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[P.ENV_KEY]="1"}}e.$Vm=P;function A(R){delete R[N.ENV_KEY],delete R[f.ENV_KEY],delete R[P.ENV_KEY]}function v(R,C){A(C),R.serialize(C)}e.$Wm=v;function $(R){if(R[N.ENV_KEY])return k(R,new N(R[N.ENV_KEY]));if(R[f.ENV_KEY])return k(R,new f);if(R[P.ENV_KEY])return k(R,new P);throw new Error("No connection information defined in environment!")}e.$Xm=$;function k(R,C){return A(R),C}}),define(Ce[113],Ie([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$xm=e.$wm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(N||(e.UIKind=N={}));var f;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A(k){const R=D.$ke.alloc(1);switch(k){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$wm=A;function v(k,R){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$xm=v;var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ce[90],Ie([1,0,5,4,13,27,113,66,87,24,2,3,219]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=e.$WN=e.$VN=e.$UN=void 0;let E=class extends C.$Tc{constructor(a,i){super(),this.s=a,this.t=i,this.a=this.B(new N.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$To,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,f.$sj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,i,r){const n=this.getTelemetryDetails(),o=new S(i,r,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,o]),o.apiTelemetryLogger}$initializeTelemetryLevel(a,i,r){this.f=a,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const i=Object.create(null);switch(i["common.extname"]=`${a.publisher}.${a.name}`,i["common.extversion"]=a.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$el)((0,$.$Zo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const o=r.filter(t=>!t.isDisposed);o.length===0?this.r.delete(n):this.r.set(n,o)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,i){const n=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(a.value),!1;let o=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),o=!0);return o}};e.$UN=E,e.$UN=E=Ke([We(0,P.$TN),We(1,f.$rj)],E);class S{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,i,r,n,o,t,h){this.g=r,this.h=n,this.i=o,this.j=t,this.a=new N.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(a,i){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let i="properties"in a?a.properties??{}:a;return i=(0,$.$3o)(i,[]),this.c&&(i=(0,k.$Cn)(i,this.c)),this.b||(i=(0,k.$Cn)(i,this.j)),"properties"in a?a.properties=i:a=i,a}k(a,i){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(a,i),this.h.trace(a,i))}logUsage(a,i){this.d.isUsageEnabled&&this.k(a,i)}logError(a,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,i);else{const r={name:a.name,message:a.message,stack:a.stack,cause:a.cause},n=(0,$.$3o)(r,[]),o=new Error(n.message,{cause:n.cause});o.stack=n.stack,o.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(o,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const a=this,i={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$VN=S;function u(m){const a=Date.now()-new Date(m).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$WN=u,e.$XN=(0,D.$9h)("IExtHostTelemetry")}),define(Ce[26],Ie([1,0,4,2,263,137,25,5]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$om("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,v.$9h)("extensionService");class ${constructor(o){this.dependency=o}}e.$JF=$;var k;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(o,t,h){this.c=o,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$rF.createActivationEventsMap(this.d)}}set(o,t,h){if(this.c>o)throw new Error(`ExtensionHostExtensions: invalid versionId ${o} (current: ${this.c})`);const s=[],d=[],l=[],c=[],p=C(this.d),I=C(t),w=(z,j)=>z.extensionLocation.toString()===j.extensionLocation.toString()||z.isBuiltin===j.isBuiltin||z.isUserBuiltin===j.isUserBuiltin||z.isUnderDevelopment===j.isUnderDevelopment;for(const z of this.d){const j=I.get(z.identifier);if(!j){s.push(z.identifier),p.delete(z.identifier);continue}if(!w(z,j)){s.push(z.identifier),p.delete(z.identifier);continue}}for(const z of t){const j=p.get(z.identifier);if(!j){d.push(z);continue}if(!w(j,z)){s.push(j.identifier),p.delete(j.identifier);continue}}const g=new A.$pm(this.e),y=new A.$pm(h);for(const z of this.e)y.has(z)||l.push(z);for(const z of h)g.has(z)||c.push(z);const L=P.$rF.createActivationEventsMap(d),F={versionId:o,toRemove:s,toAdd:d,addActivationEvents:L,myToRemove:l,myToAdd:c};return this.delta(F),F}delta(o){if(this.c>=o.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:s,myToAdd:d}=o,l=new A.$pm(t),c=new A.$pm(s);for(let p=0;p<this.d.length;p++)l.has(this.d[p].identifier)&&(this.d.splice(p,1),p--);for(let p=0;p<this.e.length;p++)c.has(this.e[p])&&(this.e.splice(p,1),p--);for(const p of h)this.d.push(p);for(const p of d)this.e.push(p);return this.f=null,o}containsExtension(o){for(const t of this.e)if(A.$om.equals(t,o))return!0;return!1}containsActivationEvent(o){return this.f||(this.f=this.g()),this.f.has(o)}g(){const o=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=P.$rF.readActivationEvents(t);for(const s of h)o.add(s)}return o}}e.$KF=R;function C(n){const o=new A.$qm;for(const t of n)o.set(t.identifier,t);return o}function b(n,o){return n.enabledApiProposals?n.enabledApiProposals.includes(o):!1}e.$LF=b;function E(n,o){if(!b(n,o))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${o}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${o}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$MF=E;class S{constructor(o,t,h,s){this.codeLoadingTime=o,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.$NF=S;class u{constructor(o,t){this.description=o,this.value=t}}e.$OF=u;var m;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function a(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,f.$9o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$PF=a;function i(n,o){return{identifier:new A.$om((0,f.$7o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!o,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$QF=i;class r{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(o){return Promise.resolve(void 0)}activateById(o,t){return Promise.resolve(void 0)}activationEventIsDone(o){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(o,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=r}),define(Ce[294],Ie([1,0,14,145,25,26,13,8]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=e.$fhc=e.$ehc=e.$dhc=e.$chc=e.$bhc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,i,r,n){this.startup=a,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$bhc=$;class k{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,i){return a===-1||i===-1?-1:i-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$chc=k;class R{constructor(a,i,r,n,o,t){this.activationFailed=a,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=o,this.subscriptions=t}}e.$dhc=R;class C extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ehc=C;class b extends R{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$fhc=b;class E extends R{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(a,i,r,n){this.g=n,this.a=a,this.b=i,this.c=r,this.d=new f.$qm,this.f=Object.create(null)}dispose(){for(const[a,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const a=[];for(const[i,r]of this.d)a.push(r.wait());await Promise.all(a)}isActivated(a){const i=this.d.get(a);return!!(i&&i.value)}getActivatedExtension(a){const i=this.d.get(a);if(!i||!i.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return i.value}async activateByEvent(a,i){if(this.f[a])return;const r=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,i){const r=this.a.getExtensionDescription(a);if(!r)throw new Error(`Extension '${a}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(a){const i=a.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const i=this.a.getExtensionDescription(a.id);if(!i){const o=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(o));return this.c.onExtensionActivationError(a.id,o,new P.$JF(a.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const o of n){if(this.m(o))continue;const t=this.d.get(o);if(t){r.push(t);continue}if(this.l(o)){r.push(this.j({id:this.b.getExtensionDescription(o).identifier,reason:a.reason}));continue}const h=this.a.getExtensionDescription(o);if(h){if(!h.main&&!h.browser)continue;r.push(this.j({id:h.identifier,reason:a.reason}));continue}const s=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${o}'`),l=this.k(a,i.displayName,[],new E(d));return this.c.onExtensionActivationError(i.identifier,d,new P.$JF(o)),l}return this.k(a,i.displayName,r,null)}k(a,i,r,n){const o=new u(a.id,i,a.reason,r,n,this.c,this.g);return this.d.set(a.id,o),o}l(a){return N.$B8b.isHostExtension(a,this.a,this.b)}m(a){const i=this.b.getExtensionDescription(a);return i?!i.main&&!i.browser:!1}};e.$ghc=S,e.$ghc=S=Ke([We(3,A.$qj)],S);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,i,r,n,o,t,h){this.c=a,this.d=i,this.f=r,this.g=n,this.h=o,this.j=t,this.k=h,this.a=new v.$8g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const i=this.g[a];if(i.value&&!i.value.activationFailed){this.g.splice(a,1),a--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new E(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const i=new Error;if(a&&a.name&&(i.name=a.name),a&&a.message?i.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(i.stack=a.stack),this.h=new E(i),this.b&&D.$4(a))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};u=Ke([We(6,A.$qj)],u)}),define(Ce[295],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[296],Ie([1,0,235,14,39,134,108,37,25,295,136,137]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=void 0;const b=v.$Ln.as(A.$Mn.JSONContribution);class E{constructor(o,t,h){this.a=o,this.b=t,this.c=h}d(o,t){this.a({type:o,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(o){this.d(f.default.Error,o)}warn(o){this.d(f.default.Warning,o)}info(o){this.d(f.default.Info,o)}}e.$AF=E;class S{static a(o){const t=new $.$pm;for(let h=0,s=o.length;h<s;h++)t.add(o[h].description.identifier);return t}static compute(o,t){if(!o||!o.length)return new S(t,[]);if(!t||!t.length)return new S([],o);const h=this.a(o),s=this.a(t),d=t.filter(c=>!h.has(c.description.identifier)),l=o.filter(c=>!s.has(c.description.identifier));return new S(d,l)}constructor(o,t){this.added=o,this.removed=t}}e.$BF=S;class u{constructor(o,t){this.name=o,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(o){if(this.a!==null)throw new Error("Handler already set!");this.a=o,this.d()}acceptUsers(o){this.c=S.compute(this.b,o),this.b=o,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(o){(0,N.$1)(o)}}}e.$CF=u;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$DF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$nm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$qo}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$qo}},extensionKind:{description:D.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(o){if(this.a.has(o.extensionPoint))throw new Error("Duplicate extension point: "+o.extensionPoint);const t=new u(o.extensionPoint,o.defaultExtensionKind);return this.a.set(o.extensionPoint,t),o.activationEventsGenerator&&C.$rF.register(o.extensionPoint,o.activationEventsGenerator),e.$DF.properties.contributes.properties[o.extensionPoint]=o.jsonSchema,b.registerSchema(a,e.$DF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$EF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};v.$Ln.add(r.ExtensionsRegistry,new i),e.$FF=v.$Ln.as(r.ExtensionsRegistry),b.registerSchema(a,e.$DF),b.registerSchema(R.$Jj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[297],Ie([1,0,231,18,24,296,45,4]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var k;(function(b){function E(S,u,m){if(!S)return;const a=N.$Kf(S.type)?S.type:void 0;if(!a||a.length===0){m.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)N.$Kf(r)&&i.push(r);return{extensionId:u.value,taskType:a,required:i,properties:S.properties?f.$zn(S.properties):{},when:S.when?A.$7i.deserialize(S.when):void 0}}b.from=E})(k||(k={}));const R=P.$FF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(b,E)=>{for(const S of b)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new v.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{R.setHandler((u,m)=>{this.c=void 0;try{for(const a of m.removed){const i=a.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const a of m.added){const i=a.value;for(const r of i){const n=k.from(r,a.description.identifier,a.collector);n&&(this.a[n.taskType]=n)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const u={type:"object",additionalProperties:!1};S.required.length>0&&(u.required=S.required.slice(0)),S.properties!==void 0?u.properties=f.$zn(S.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[S.taskType]},E.push(u)}this.c={oneOf:E}}return this.c}}e.$EG=new C}),define(Ce[298],Ie([1,0,232,18,23,24,45,297]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$OG=e.JsonSchemaVersion=e.ExecutionEngine=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$IG=e.ShellQuoting=e.$HG=e.$GG=e.$FG=void 0,e.$FG="settings",e.$GG=new A.$nj("taskRunning",!1,D.localize(0,null)),e.$HG=D.localize2(2,"Tasks");var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$IG="$customized",function(M){function T(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=T}($||(e.ShellQuoting=$={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var R;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(R||(e.RevealKind=R={})),function(M){function T(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=T}(R||(e.RevealKind=R={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function T(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=T}(C||(e.RevealProblemKind=C={}));var b;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(b||(e.PanelKind=b={})),function(M){function T(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=T}(b||(e.PanelKind=b={}));var E;(function(M){M.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:b.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function T(J){switch(J.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=T;function U(J){switch(J){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(S||(e.RuntimeType=S={}));var u;(function(M){function T(U){return N.$Kf(U)?U:U.value}M.value=T})(u||(e.CommandString=u={}));var m;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function T(J){return J===M.Clean._id||J===M.Build._id||J===M.Rebuild._id||J===M.Test._id}M.is=T;function U(J){if(J!==void 0)return N.$Kf(J)?T(J)?{_id:J,isDefault:!1}:void 0:J}M.from=U})(m||(e.TaskGroup=m={}));var a;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function T(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var o;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(o||(e.RunOptions=o={}));class t{constructor(T,U,J,ne,ee,Q){this._label="",this._id=T,U&&(this._label=U),J&&(this.type=J),this.runOptions=ne,this.configurationProperties=ee,this._source=Q}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,U=!1){if(T===void 0)return!1;if(N.$Kf(T))return T===this._label||T===this.configurationProperties.identifier||U&&T===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$JG=t;class h extends t{constructor(T,U,J,ne,ee,Q,Y,ce){super(T,J,void 0,Y,ce,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,ee&&(this.command=ee)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case S.Shell:U="shell";break;case S.Process:U="process";break;case S.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(T){return T instanceof h}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$FG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const J={type:e.$IG,folder:T,id:U};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Gg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new h(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$KG=h;class s extends t{constructor(T,U,J,ne,ee,Q,Y){super(T,J,ne,Q,Y,U),this._source=U,this.configures=ee}static is(T){return T instanceof s}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Gg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$FG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const J={type:e.$IG,folder:T,id:U};return JSON.stringify(J)}}e.$LG=s;class d extends t{constructor(T,U,J,ne,ee,Q,Y,ce,te){super(T,J,ne,ce,te,U),this.defines=ee,this.hasDefinedMatchers=Y,this.command=Q,this.icon=te.icon,this.hide=te.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof d}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new d(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$MG=d;class l extends t{constructor(T,U,J,ne,ee,Q){super(T,J,ne,ee,Q,U),this._source=U}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new l(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$NG=l;var c;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(c||(e.ExecutionEngine=c={})),function(M){M._default=M.Terminal}(c||(e.ExecutionEngine=c={}));var p;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(p||(e.JsonSchemaVersion=p={}));class I{constructor(T){this.c=new Map;for(let U=0;U<T.length;U++)this.c.set(T[U].uri.toString(),U)}compare(T,U){const J=T.getWorkspaceFolder(),ne=U.getWorkspaceFolder();if(J&&ne){let ee=this.c.get(J.uri.toString());ee=ee===void 0?0:ee+1;let Q=this.c.get(ne.uri.toString());return Q=Q===void 0?0:Q+1,ee===Q?T._label.localeCompare(U._label):ee-Q}else return!J&&ne?-1:J&&!ne?1:0}}e.$OG=I;var w;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(w||(e.TaskEventKind=w={}));var g;(function(M){M.SingleRun="singleRun",M.Background="background"})(g||(e.TaskRunType=g={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var L;(function(M){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function U(ce,te,fe){return{...T(ce),kind:"start",terminalId:te,resolvedVariables:fe}}M.start=U;function J(ce,te,fe){return{...T(ce),kind:"processStarted",terminalId:te,processId:fe}}M.processStarted=J;function ne(ce,te,fe){return{...T(ce),kind:"processEnded",terminalId:te,exitCode:fe}}M.processEnded=ne;function ee(ce,te,fe){return{...T(ce),kind:"terminated",exitReason:fe,terminalId:te}}M.terminated=ee;function Q(ce,te,fe){return{...T(te),kind:ce,terminalId:fe}}M.general=Q;function Y(){return{kind:"changed"}}M.changed=Y})(L||(e.TaskEvent=L={}));var F;(function(M){function T(J){const ne=Object.keys(J).sort();let ee="";for(const Q of ne){let Y=J[Q];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),ee+=Q+","+Y+","}return ee}function U(J){const ee={_key:T(J),type:J.taskType};return Object.assign(ee,J),ee}M.create=U})(F||(e.KeyedTaskIdentifier=F={}));var z;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var j;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var O;(function(M){function T(U,J){const ne=v.$EG.get(U.type);if(ne===void 0){const ce=P.$zn(U);return delete ce._key,F.create(ce)}const ee=Object.create(null);ee.type=ne.taskType;const Q=new Set;ne.required.forEach(ce=>Q.add(ce));const Y=ne.properties;for(const ce of Object.keys(Y)){const te=U[ce];if(te!=null)ee[ce]=te;else if(Q.has(ce)){const fe=Y[ce];if(fe.default!==void 0)ee[ce]=P.$zn(fe.default);else switch(fe.type){case"boolean":ee[ce]=!1;break;case"number":case"integer":ee[ce]=0;break;case"string":ee[ce]="";break;default:J.error(D.localize(1,null,JSON.stringify(U,void 0,0),ce));return}}}return F.create(ee)}M.createTaskIdentifier=T})(O||(e.TaskDefinition=O={}))}),define(Ce[299],Ie([1,0,14]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G8b=e.$F8b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,v)=>{this.b=A,this.d=v,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,D.$1)(A))}then(A,v){return this.j().then(A,v)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$F8b=N;class f extends N{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$G8b=f}),define(Ce[69],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.$Uv=e.$Tv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Tv=D;const N=[];function f(v){const $=new D(v);return N[$.nid]=$,$}e.$Uv=f;function P(v){return N[v].sid}e.$Vv=P;class A{constructor($){this.value=$}}e.$Wv=A}),define(Ce[6],Ie([1,0,69]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.$pL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$oL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var f;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var P;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var v;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var $;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var R;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$oL=C;var b;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var E;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$pL={MainThreadAuthentication:(0,D.$Uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Uv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Uv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Uv)("MainThreadCommands"),MainThreadComments:(0,D.$Uv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Uv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Uv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Uv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Uv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Uv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Uv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Uv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Uv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Uv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Uv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Uv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Uv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Uv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Uv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Uv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Uv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Uv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Uv)("MainThreadSCM"),MainThreadSearch:(0,D.$Uv)("MainThreadSearch"),MainThreadShare:(0,D.$Uv)("MainThreadShare"),MainThreadTask:(0,D.$Uv)("MainThreadTask"),MainThreadWindow:(0,D.$Uv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Uv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Uv)("MainThreadInteractive"),MainThreadChat:(0,D.$Uv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Uv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Uv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Uv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Uv)("MainThreadIssueReporter")},e.$qL={ExtHostCommands:(0,D.$Uv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Uv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Uv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Uv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Uv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Uv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Uv)("ExtHostSCM"),ExtHostSearch:(0,D.$Uv)("ExtHostSearch"),ExtHostTask:(0,D.$Uv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Uv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Uv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Uv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Uv)("ExtHostProgress"),ExtHostComments:(0,D.$Uv)("ExtHostComments"),ExtHostSecretState:(0,D.$Uv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Uv)("ExtHostStorage"),ExtHostUrls:(0,D.$Uv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Uv)("ExtHostOutputService"),ExtHostLabelService:(0,D.$Uv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Uv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Uv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Uv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Uv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Uv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Uv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Uv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Uv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Uv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Uv)("ExtHostIssueReporter")}}),define(Ce[91],Ie([1,0,5,13,6,20]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=e.$Egc=void 0,e.$Egc=(0,D.$9h)("IExtHostApiDeprecationService");let A=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(f.$pL.MainThreadTelemetry)}report($,k,R){const C=this.d($,k);this.a.has(C)||(this.a.add(C),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$Fgc=A,e.$Fgc=A=Ke([We(0,P.$DN),We(1,N.$qj)],A),e.$Ggc=Object.freeze(new class{report(v,$,k){}})}),define(Ce[300],Ie([1,0,53,3,6]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class P{static{this.a=0}constructor($,k){this.extension=$,this.provider=k,this.handle=P.a++}}class A{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(f.$pL.MainThreadChat)}registerChatProvider($,k,R){const C=new P($,R);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,k),(0,N.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession($,k){const R=D.Iterable.find(this.c.keys(),C=>this.c.get(C)===$)??0;typeof R=="number"&&this.d.$transferChatSession(R,k)}sendInteractiveRequestToProvider($,k){this.d.$sendRequestToProvider($,k)}async $prepareChat($,k){const R=this.b.get($);if(!R)return;const C=await R.provider.prepareSession(k);if(!C)return;const b=A.a++;return this.c.set(b,C),{id:b,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession($){this.c.delete($)}}e.$Lgc=A}),define(Ce[301],Ie([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class N{constructor(P){const A=P.getProxy(D.$pL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(v){return A.$writeText(v)}})}}e.$Pgc=N}),define(Ce[302],Ie([1,0,24,6,27,20]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;let A=class{constructor(R,C){this.a=R.getProxy(N.$pL.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const b=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){b.e(R,C,E,arguments)}})}e(R,C,b,E){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(E,this.b)}),this.c&&this.f(R,b,E)}};e.$Gic=A,e.$Gic=A=Ke([We(0,P.$DN),We(1,f.$TN)],A);const v=1e5;function $(k,R){const C=[];if(k.length)for(let b=0;b<k.length;b++){let E=k[b];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}C.push(E)}if(R){const b=new Error().stack;b&&C.push({__$stack:b.split(`
`).slice(3).join(`
`)})}try{const b=(0,D.$En)(C);return b.length>v?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}),define(Ce[303],Ie([1,0,2,6,26]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;class P{constructor(v){this.a=v.getProxy(N.$pL.MainThreadDialogs)}showOpenDialog(v,$){return $?.allowUIResources&&(0,f.$MF)(v,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(R=>D.URI.revive(R)):void 0)}showSaveDialog(v){return this.a.$showSaveDialog(v).then($=>$?D.URI.revive($):void 0)}}e.$Khc=P}),define(Ce[304],Ie([1,0,3,6]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class f{constructor(A){this.b=0,this.a=A.getProxy(N.$pL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const v=this.b++;return this.a.$registerResourceLabelFormatter(v,A),(0,D.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(v)})}}e.$6hc=f}),define(Ce[114],Ie([1,0,11,12,2,5,13,6,27,20]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=void 0;let R=class{constructor(b,E,S){this.f=S,this.d=new Map,this.a=E.getProxy(v.$pL.MainThreadLocalization),this.b=b.environment.appLanguage,this.c=this.b===D.$g}getMessage(b,E){const{message:S,args:u,comment:m}=E;if(this.c)return(0,N.$Me)(S,u??{});let a=S;m&&m.length>0&&(a+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(b)?.contents[a];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,N.$Me)(i??S,u??{})}getBundle(b){return this.d.get(b)?.contents}getBundleUri(b){return this.d.get(b)?.uri}async initializeLocalizedMessages(b){if(this.c||!b.l10n&&!b.isBuiltin||this.d.has(b.identifier.value))return;let E;const S=await this.g(b);if(!S){this.f.error(`No bundle location found for extension ${b.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(S),m=JSON.parse(u);E=b.isBuiltin?m.contents?.bundle:m}catch(u){this.f.error(`Failed to load translations for ${b.identifier.value} from ${S}: ${u.message}`);return}E&&this.d.set(b.identifier.value,{contents:E,uri:S})}async g(b){if(b.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(b.identifier.value,this.b);return f.URI.revive(E)}return b.l10n?f.URI.joinPath(b.extensionLocation,b.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$shc=R,e.$shc=R=Ke([We(0,$.$TN),We(1,k.$DN),We(2,A.$qj)],R),e.$thc=(0,P.$9h)("IExtHostLocalizationService")}),define(Ce[146],Ie([1,0,13,6,27,20,2,56]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;let $=class extends D.$Bj{constructor(C,b){super(b.logLevel,b.logsLocation,b.loggers.map(E=>(0,v.$Fh)(E))),this.r=C.getProxy(N.$pL.MainThreadLogger)}$setLogLevel(C,b){b?this.setLogLevel(A.URI.revive(b),C):this.setLogLevel(C)}setVisibility(C,b){super.setVisibility(C,b),this.r.$setVisibility(C,b)}s(C,b,E){return new k(this.r,C,b,E)}};e.$Fic=$,e.$Fic=$=Ke([We(0,P.$DN),We(1,f.$TN)],$);class k extends D.$wj{constructor(C,b,E,S){super(S?.logLevel==="always"),this.r=C,this.s=b,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(b,S).then(()=>{this.u(this.n),this.m=!0})}g(C,b){const E=[[C,b]];this.m?this.u(E):this.n.push(...E)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Ce[115],Ie([1,0,6,5,3,20,21]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0,e.$uhc=(0,N.$9h)("IExtHostManagedSockets");let v=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$pL.MainThreadManagedSockets)}setFactory(C,b){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,b),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const b=++this.b,E=await this.c.makeConnection(),S=new f.$Sc;return this.d.set(b,new k(b,E,S)),S.add((0,f.$Rc)(()=>this.d.delete(b))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(b),S.dispose()})),S.add(E.onDidClose(u=>{this.a.$onDidManagedSocketClose(b,u?.stack??u?.message),S.dispose()})),S.add(E.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(b,A.$ke.wrap(u)))),b}$remoteSocketWrite(C,b){this.d.get(C)?.actual.send(b.buffer)}$remoteSocketEnd(C){const b=this.d.get(C);b&&(b.actual.end(),b.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$vhc=v,e.$vhc=v=Ke([We(0,P.$DN)],v);class ${constructor(C,b){this.socketFactoryId=C,this.makeConnection=b}}class k extends f.$Tc{constructor(C,b,E){super(),this.socketId=C,this.actual=b,this.B(E)}}}),define(Ce[305],Ie([1,0,6,13,26]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;function P(v){return v&&v.title}let A=class{constructor($,k){this.b=k,this.a=$.getProxy(D.$pL.MainThreadMessageService)}showMessage($,k,R,C,b){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||P(C)?S=[C,...b]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,S=b),E.useCustom&&(0,f.$MF)($,"resolvers");const u=[];let m=!1;for(let a=0;a<S.length;a++){const i=S[a];if(typeof i=="string")u.push({title:i,handle:a,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;u.push({title:r,isCloseAffordance:!!n,handle:a}),n&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,R,E,u).then(a=>{if(typeof a=="number")return S[a]})}};e.$8hc=A,e.$8hc=A=Ke([We(1,N.$qj)],A)}),define(Ce[306],Ie([1,0,3,18,2,26,6]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class v{constructor(k){this.b=new Map,this.a=k.getProxy(A.$pL.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,R,C){if((0,P.$MF)(k,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,k.identifier.value),(0,D.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(k,R,C,b){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(R,C,b)}async $readProfile(k,R,C){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.readProfile((0,N.$Kf)(R)?R:f.URI.revive(R),C)}}e.$eic=v}),define(Ce[116],Ie([1,0,6,4,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;class P{constructor(v){this.b=new N.$Wd,this.onDidChangePassword=this.b.event,this.a=v.getProxy(D.$pL.MainThreadSecretState)}async $onDidChangePassword(v){this.b.fire(v)}get(v,$){return this.a.$getPassword(v,$)}store(v,$,k){return this.a.$setPassword(v,$,k)}delete(v,$){return this.a.$deletePassword(v,$)}}e.$phc=P,e.$qhc=(0,f.$9h)("IExtHostSecretState")}),define(Ce[307],Ie([1,0,22,3,6]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class P{static{this.a=1}constructor(v){this.c=new Map,this.d=new Map,this.b=v.getProxy(f.$pL.MainThreadSpeech)}async $createSpeechToTextSession(v,$){const k=this.c.get(v);if(!k)return;const R=new N.$Sc,C=new D.$7d;this.d.set($,C);const b=R.add(k.provideSpeechToTextSession(C.token));R.add(b.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}async $createKeywordRecognitionSession(v,$){const k=this.c.get(v);if(!k)return;const R=new N.$Sc,C=new D.$7d;this.d.set($,C);const b=R.add(k.provideKeywordRecognitionSession(C.token));R.add(b.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}registerProvider(v,$,k){const R=P.a++;return this.c.set(R,k),this.b.$registerProvider(R,$,{extension:v,displayName:v.value}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$lic=P}),define(Ce[117],Ie([1,0,6,4,5]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=void 0;class P{constructor(v,$){this.c=$,this.b=new N.$Wd,this.onDidChangeStorage=this.b.event,this.a=v.getProxy(D.$pL.MainThreadStorage)}registerExtensionStorageKeysToSync(v,$){this.a.$registerExtensionStorageKeysToSync(v,$)}async initializeExtensionStorage(v,$,k){const R=await this.a.$initializeExtensionStorage(v,$);let C;return R&&(C=this.d(v,$,R)),C||k}setValue(v,$,k){return this.a.$setValue(v,$,k)}$acceptValue(v,$,k){const R=this.d(v,$,k);R&&this.b.fire({shared:v,key:$,value:R})}d(v,$,k){try{return JSON.parse(k)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${v}): ${R}`)}}}e.$hhc=P,e.$ihc=(0,f.$9h)("IExtHostStorage")}),define(Ce[308],Ie([1,0,3,15,2,6]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class A{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$pL.MainThreadUriOpeners)}registerExternalUriOpener($,k,R,C){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const b=C.schemes.find(E=>!A.a.has(E));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this.c.set(k,R),this.b.$registerUriOpener(k,C.schemes,$,C.label),(0,D.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const b=f.URI.revive(k);return C.canOpenExternalUri(b,R)}async $openUri($,k,R){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(f.URI.revive(k.resolvedUri),{sourceUri:f.URI.revive(k.sourceUri)},R)}}e.$zic=A}),define(Ce[309],Ie([1,0,6,2,3,14,25]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class v{static{this.a=0}constructor(k){this.c=new A.$pm,this.d=new Map,this.b=k.getProxy(D.$pL.MainThreadUrls)}registerUriHandler(k,R){const C=k.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const b=v.a++;return this.c.add(C),this.d.set(b,R),this.b.$registerUriHandler(b,C,k.displayName||k.name),(0,f.$Rc)(()=>{this.c.delete(C),this.d.delete(b),this.b.$unregisterUriHandler(b)})}$handleExternalUri(k,R){const C=this.d.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(R))}catch(b){(0,P.$1)(b)}return Promise.resolve(void 0)}async createAppUri(k){return N.URI.revive(await this.b.$createAppUri(k))}}e.$Aic=v}),define(Ce[92],Ie([1,0,4,3,15,24,2,239,276,112,6]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=e.$7gc=e.$6gc=e.$5gc=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(n,o,t,h,s,d,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Wd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=o,this.#o=t,this.#n=h,this.#s=s,this.#r=d,this.#l=b(d),this.#d=E(d),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,k.$Lwb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===f.Schemas.https||n.scheme===f.Schemas.http){let o=n.toString();return o.endsWith("/")||(o+="/"),o+" "+k.$Kwb}return k.$Kwb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),P.$Dn(this.#o,n)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const o=(0,$.$3lb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,o.message,...o.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const o=this.#r.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,l,c,p)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(c)}),w=(0,k.$Lwb)(I,{isRemote:o,authority:t}).toString();return`${s}${w}${p}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,l,c,p)=>{const I=A.URI.from({scheme:l||"file",path:decodeURIComponent(c)}),w=(0,k.$Lwb)(I,{isRemote:o,authority:t}).toString();return`${s}${w}${p}`})}}e.$5gc=C;function b(r){try{const n=(0,v.$fp)((0,v.$ep)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$6gc=b;function E(r){try{const n=(0,v.$fp)((0,v.$ep)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends N.$Tc{constructor(n,o,t,h,s){super(),this.c=o,this.f=t,this.g=h,this.h=s,this.b=new Map,this.a=n.getProxy(R.$pL.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,o,t){const h=this.j(n);if(h){const{message:s}=(0,$.$4lb)(o,t.value);h._onMessageEmitter.fire(s)}}$onMissingCsp(n,o){this.g.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,o,t){const h=new C(n,this.a,a(o),this.c,this.f,t,this.h);this.b.set(n,h);const s=h._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return h}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$7gc=S;function u(r){return{id:r.identifier,location:r.extensionLocation}}e.$8gc=u;function m(r,n,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||i(r,n)}}e.$9gc=m;function a(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>A.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(o=>o.uri),r.extensionLocation]}}),define(Ce[147],Ie([1,0,4,6,2,15,12,5,20,26]),function(me,e,D,N,f,P,A,v,$,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=e.$Cic=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,k.$MF)(E,"windowActivity"),S.active}}}constructor(E){this.c=new D.$Wd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=E.getProxy(N.$pL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:u})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let u;if(typeof E=="string"){u=E;try{E=f.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,A.$Ke)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,u,S)}async asExternalUri(E,S){if((0,A.$Ke)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(E,S);return f.URI.from(u)}};e.$Cic=C,e.$Cic=C=R=Ke([We(0,$.$DN)],C),e.$Dic=(0,v.$9h)("IExtHostWindow")}),define(Ce[310],Ie([1,0,302,27,20]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;const P=1024*1024;let A=class extends D.$Gic{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,R){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const R=process[$],C=R.write;let b="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(E,S,u)=>{if(!this.g){b+=E.toString(S);const m=b.length>P?b.length:b.lastIndexOf(`
`);m!==-1&&(console[k](b.slice(0,m)),b=b.slice(m+1))}C.call(R,E,S,u)}})}};e.$fjc=A,e.$fjc=A=Ke([We(0,f.$DN),We(1,N.$TN)],A)}),define(Ce[311],Ie([1,0,146,15,253,30]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class A extends D.$Fic{s($,k,R){return $.scheme===N.Schemas.file?new f.$PO(R?.name||(0,P.$sg)(),$.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,k):super.s($,k,R)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$rjc=A}),define(Ce[312],Ie([1,0,8,21,22,14,4,3,130,299,69]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=e.ResponsiveState=e.RequestInitiator=e.$I8b=e.$H8b=void 0;function b(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class u{constructor(L,F){this.jsonString=L,this.referencedBuffers=F}}function m(y,L=null,F=!1){const z=[];return{jsonString:(F?b:JSON.stringify)(y,(O,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof N.$ke){const T=z.push(M)-1;return{[E]:T}}if(L)return L(O,M)}return M}),referencedBuffers:z}}e.$H8b=m;function a(y,L,F){return JSON.parse(y,(z,j)=>{if(j){const O=j[E];if(typeof O=="number")return L[O];if(F&&j.$mid===1)return F.transformIncoming(j)}return j})}e.$I8b=a;function i(y,L){return JSON.stringify(y,L)}function r(y){return y?(L,F)=>F&&F.$mid===1?y.transformOutgoing(F):F:null}var n;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var o;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(o||(e.ResponsiveState=o={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class d extends v.$Tc{static{C=h}static{this.a=3*1e3}constructor(L,F=null,z=null){super(),this[C]=!0,this.b=this.B(new A.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=F,this.g=z,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,O=R.$Tv.count;j<O;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$ih(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const F=this.w[L];delete this.w[L],F.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,$.$$m)(L,this.g):L}getProxy(L){const{nid:F,sid:z}=L;return this.s[F]||(this.s[F]=this.J(F,z)),this.s[F]}J(L,F){const z={get:(j,O)=>(typeof O=="string"&&!j[O]&&O.charCodeAt(0)===36&&(j[O]=(...M)=>this.U(L,O,M)),O===s?F:j[O])};return new Proxy(Object.create(null),z)}set(L,F){return this.m[L.nid]=F,F}assertRegistered(L){for(let F=0,z=L.length;F<z;F++){const j=L[F];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(L){if(this.j)return;const F=L.byteLength,z=c.read(L,0),j=z.readUInt8(),O=z.readUInt32();switch(j){case 1:case 2:{let{rpcId:M,method:T,args:U}=I.deserializeRequestJSONArgs(z);this.g&&(U=(0,$.$$m)(U,this.g)),this.M(F,O,M,T,U,j===2);break}case 3:case 4:{let{rpcId:M,method:T,args:U}=I.deserializeRequestMixedArgs(z);this.g&&(U=(0,$.$$m)(U,this.g)),this.M(F,O,M,T,U,j===4);break}case 5:{this.f?.logIncoming(F,O,0,"ack"),this.G(O);break}case 6:{this.N(F,O);break}case 7:{this.O(F,O,void 0);break}case 9:{let M=I.deserializeReplyOKJSON(z);this.g&&(M=(0,$.$$m)(M,this.g)),this.O(F,O,M);break}case 10:{const M=I.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(F,O,M);break}case 8:{const M=I.deserializeReplyOKVSBuffer(z);this.O(F,O,M);break}case 11:{let M=I.deserializeReplyErrError(z);this.g&&(M=(0,$.$$m)(M,this.g)),this.P(F,O,M);break}case 12:{this.P(F,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,F,z,j,O,M){this.f?.logIncoming(L,F,1,`receiveRequest ${(0,R.$Vv)(z)}.${j}(`,O);const T=String(F);let U,J;if(M){const ee=new f.$7d;O.push(ee.token),U=this.Q(z,j,O),J=()=>ee.cancel()}else U=this.Q(z,j,O),J=t;this.u[T]=J;const ne=I.serializeAcknowledged(F);this.f?.logOutgoing(ne.byteLength,F,1,"ack"),this.c.send(ne),U.then(ee=>{delete this.u[T];const Q=I.serializeReplyOK(F,ee,this.h);this.f?.logOutgoing(Q.byteLength,F,1,"reply:",ee),this.c.send(Q)},ee=>{delete this.u[T];const Q=I.serializeReplyErr(F,ee);this.f?.logOutgoing(Q.byteLength,F,1,"replyErr:",ee),this.c.send(Q)})}N(L,F){this.f?.logIncoming(L,F,1,"receiveCancel");const z=String(F);this.u[z]?.()}O(L,F,z){this.f?.logIncoming(L,F,0,"receiveReply:",z);const j=String(F);if(!this.w.hasOwnProperty(j))return;const O=this.w[j];delete this.w[j],O.resolveOk(z)}P(L,F,z){this.f?.logIncoming(L,F,0,"receiveReplyErr:",z);const j=String(F);if(!this.w.hasOwnProperty(j))return;const O=this.w[j];delete this.w[j];let M;z&&(z.$isError?(M=new Error,M.name=z.name,M.message=z.message,M.stack=z.stack):M=z),O.resolveErr(M)}Q(L,F,z){try{return Promise.resolve(this.S(L,F,z))}catch(j){return Promise.reject(j)}}S(L,F,z){const j=this.m[L];if(!j)throw new Error("Unknown actor "+(0,R.$Vv)(L));const O=j[F];if(typeof O!="function")throw new Error("Unknown method "+F+" on actor "+(0,R.$Vv)(L));return O.apply(j,z)}U(L,F,z){if(this.j)return new k.$G8b;let j=null;if(z.length>0&&f.CancellationToken.isCancellationToken(z[z.length-1])&&(j=z.pop()),j&&j.isCancellationRequested)return Promise.reject(P.$6());const O=I.serializeRequestArguments(z,this.h),M=++this.t,T=String(M),U=new k.$F8b,J=new v.$Sc;j&&J.add(j.onCancellationRequested(()=>{const ee=I.serializeCancel(M);this.f?.logOutgoing(ee.byteLength,M,0,"cancel"),this.c.send(I.serializeCancel(M))})),this.w[T]=new l(U,J),this.F(M);const ne=I.serializeRequest(M,L,F,O,!!j);return this.f?.logOutgoing(ne.byteLength,M,0,`request: ${(0,R.$Vv)(L)}.${F}(`,z),this.c.send(ne),U}}e.$J8b=d;class l{constructor(L,F){this.a=L,this.b=F}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class c{static alloc(L,F,z){const j=new c(N.$ke.alloc(z+1+4),0);return j.writeUInt8(L),j.writeUInt32(F),j}static read(L,F){return new c(L,F)}get buffer(){return this.a}constructor(L,F){this.a=L,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+L);return this.b+=L,F}static sizeMixedArray(L){let F=0;F+=1;for(let z=0,j=L.length;z<j;z++){const O=L[z];switch(F+=1,O.type){case 1:F+=this.sizeLongString(O.value);break;case 2:F+=this.sizeVSBuffer(O.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(O.value);for(let M=0;M<O.buffers.length;++M)F+=this.sizeVSBuffer(O.buffers[M]);break;case 4:break}}return F}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let F=0,z=L.length;F<z;F++){const j=L[F];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let O=0;O<j.buffers.length;++O)this.writeBuffer(j.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const F=new Array(L);for(let z=0;z<L;z++)switch(this.readUInt8()){case 1:F[z]=this.readLongString();break;case 2:F[z]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),M=this.readLongString(),T=[];for(let U=0;U<O;++U)T.push(this.readVSBuffer());F[z]=new R.$Wv(a(M,T,null));break}case 4:F[z]=void 0;break}return F}}var p;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(p||(p={}));class I{static a(L){for(let F=0,z=L.length;F<z;F++)if(L[F]instanceof N.$ke||L[F]instanceof R.$Wv||typeof L[F]>"u")return!0;return!1}static serializeRequestArguments(L,F){if(this.a(L)){const z=[];for(let j=0,O=L.length;j<O;j++){const M=L[j];if(M instanceof N.$ke)z[j]={type:2,value:M};else if(typeof M>"u")z[j]={type:4};else if(M instanceof R.$Wv){const{jsonString:T,referencedBuffers:U}=m(M.value,F);z[j]={type:3,value:N.$ke.fromString(T),buffers:U}}else z[j]={type:1,value:N.$ke.fromString(i(M,F))}}return{type:1,args:z}}return{type:0,args:i(L,F)}}static serializeRequest(L,F,z,j,O){switch(j.type){case 0:return this.b(L,F,z,j.args,O);case 1:return this.c(L,F,z,j.args,O)}}static b(L,F,z,j,O){const M=N.$ke.fromString(z),T=N.$ke.fromString(j);let U=0;U+=c.sizeUInt8(),U+=c.sizeShortString(M),U+=c.sizeLongString(T);const J=c.alloc(O?2:1,L,U);return J.writeUInt8(F),J.writeShortString(M),J.writeLongString(T),J.buffer}static deserializeRequestJSONArgs(L){const F=L.readUInt8(),z=L.readShortString(),j=L.readLongString();return{rpcId:F,method:z,args:JSON.parse(j)}}static c(L,F,z,j,O){const M=N.$ke.fromString(z);let T=0;T+=c.sizeUInt8(),T+=c.sizeShortString(M),T+=c.sizeMixedArray(j);const U=c.alloc(O?4:3,L,T);return U.writeUInt8(F),U.writeShortString(M),U.writeMixedArray(j),U.buffer}static deserializeRequestMixedArgs(L){const F=L.readUInt8(),z=L.readShortString(),j=L.readMixedArray(),O=new Array(j.length);for(let M=0,T=j.length;M<T;M++){const U=j[M];typeof U=="string"?O[M]=JSON.parse(U):O[M]=U}return{rpcId:F,method:z,args:O}}static serializeAcknowledged(L){return c.alloc(5,L,0).buffer}static serializeCancel(L){return c.alloc(6,L,0).buffer}static serializeReplyOK(L,F,z){if(typeof F>"u")return this.d(L);if(F instanceof N.$ke)return this.e(L,F);if(F instanceof R.$Wv){const{jsonString:j,referencedBuffers:O}=m(F.value,z,!0);return this.g(L,j,O)}else return this.f(L,b(F,z))}static d(L){return c.alloc(7,L,0).buffer}static e(L,F){let z=0;z+=c.sizeVSBuffer(F);const j=c.alloc(8,L,z);return j.writeVSBuffer(F),j.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,F){const z=N.$ke.fromString(F);let j=0;j+=c.sizeLongString(z);const O=c.alloc(9,L,j);return O.writeLongString(z),O.buffer}static g(L,F,z){const j=N.$ke.fromString(F);let O=0;O+=c.sizeUInt32,O+=c.sizeLongString(j);for(const T of z)O+=c.sizeVSBuffer(T);const M=c.alloc(10,L,O);M.writeUInt32(z.length),M.writeLongString(j);for(const T of z)M.writeBuffer(T);return M.buffer}static deserializeReplyOKJSON(L){const F=L.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(L,F){const z=L.readUInt32(),j=L.readLongString(),O=[];for(let M=0;M<z;++M)O.push(L.readVSBuffer());return new R.$Wv(a(j,O,F))}static serializeReplyErr(L,F){const z=F?b(P.$3(F),null):void 0;if(typeof z!="string")return this.h(L);const j=N.$ke.fromString(z);let O=0;O+=c.sizeLongString(j);const M=c.alloc(11,L,O);return M.writeLongString(j),M.buffer}static deserializeReplyErrError(L){const F=L.readLongString();return JSON.parse(F)}static h(L){return c.alloc(12,L,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var g;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(g||(g={}))}),define(Ce[313],Ie([1,0,21,28,15,84,5]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bJ=e.$aJ=e.$_I=e.$$I=void 0,e.$$I=(0,A.$9h)("notebookDocumentService");const v=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${v.join("")}]+`),k=7;function R(E){if(E.scheme!==f.Schemas.vscodeNotebookCell)return;const S=E.fragment.indexOf("s");if(S<0)return;const u=parseInt(E.fragment.substring(0,S).replace($,""),k),m=(0,D.$De)(E.fragment.substring(S+1)).toString();if(!isNaN(u))return{handle:u,notebook:E.with({scheme:m,fragment:null})}}e.$_I=R;function C(E,S){const u=S.toString(k),a=`${u.length<v.length?v[u.length-1]:"z"}${u}s${(0,D.$Ee)(D.$ke.fromString(E.scheme),!0,!0)}`;return E.with({scheme:f.Schemas.vscodeNotebookCell,fragment:a})}e.$aJ=C;class b{constructor(){this.a=new N.$Ac}getNotebook(S){if(S.scheme===f.Schemas.vscodeNotebookCell){const u=R(S);if(u){const m=this.a.get(u.notebook);if(m)return m}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$bJ=b,(0,P.$2r)(e.$$I,b,1)}),define(Ce[118],Ie([1,0,21,35,53,100,15,17,11,45,313]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.CellStatusbarAlignment=e.$pJ=e.$oJ=e.$nJ=e.NotebookEditorPriority=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.CellKind=e.$eJ=e.$dJ=e.$cJ=void 0,e.$cJ="workbench.editor.notebook",e.$dJ="workbench.editor.notebookTextDiffEditor",e.$eJ="workbench.editor.interactive";var C;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(C||(e.CellKind=C={})),e.$fJ=["application/json","application/javascript","text/html","image/svg+xml",P.$is.latex,P.$is.markdown,"image/png","image/jpeg",P.$is.text],e.$gJ=[P.$is.latex,P.$is.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$is.text],e.$hJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$iJ="_notAvailable";var b;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(b||(e.NotebookRunState=b={}));var E;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var u;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var m;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var a;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(U){U.scheme=A.Schemas.vscodeNotebookCell;function J(te,fe){return(0,R.$aJ)(te,fe)}U.generate=J;function ne(te){return(0,R.$_I)(te)}U.parse=ne;function ee(te,fe){return te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${te.scheme!==A.Schemas.file?te.scheme:""}`})}U.generateCellOutputUri=ee;function Q(te){if(te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!fe)return;const re=fe[1]&&fe[1]!==""?fe[1]:void 0,K=fe[2];return{outputId:re,notebook:te.with({scheme:K||A.Schemas.file,fragment:null})}}U.parseCellOutputUri=Q;function Y(te,fe,re){return U.generate(te,fe).with({scheme:re})}U.generateCellPropertyUri=Y;function ce(te,fe){if(te.scheme===fe)return U.parse(te.with({scheme:U.scheme}))}U.parseCellPropertyUri=ce})(n||(e.CellUri=n={}));const o=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(J=[],ne=e.$fJ){this.e=ne,this.d=[...new Set(J)].map(ee=>({pattern:ee,matches:N.$Pj(o(ee))}))}sort(J){const ne=new Map(f.Iterable.map(J,Q=>[Q,o(Q)]));let ee=[];for(const{matches:Q}of this.d)for(const[Y,ce]of ne)if(Q(ce)){ee.push(Y),ne.delete(Y);break}return ne.size&&(ee=ee.concat([...ne.keys()].sort((Q,Y)=>this.e.indexOf(Q)-this.e.indexOf(Y)))),ee}prioritize(J,ne){const ee=this.f(J);if(ee===-1){this.d.unshift({pattern:J,matches:N.$Pj(o(J))});return}const Q=new Set(ne.map(ce=>this.f(ce,ee)));Q.delete(-1);const Y=Array.from(Q).sort();this.d.splice(ee+1,0,...Y.map(ce=>this.d[ce]));for(let ce=Y.length-1;ce>=0;ce--)this.d.splice(Y[ce],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ne=this.d.length){const ee=o(J);for(let Q=0;Q<ne;Q++)if(this.d[Q].matches(ee))return Q;return-1}}e.$jJ=t;function h(U,J,ne,ee=(Q,Y)=>Q===Y){const Q=[];function Y(fe,re,K){if(re===0&&K.length===0)return;const B=Q[Q.length-1];B&&B.start+B.deleteCount===fe?(B.deleteCount+=re,B.toInsert.push(...K)):Q.push({start:fe,deleteCount:re,toInsert:K})}let ce=0,te=0;for(;;){if(ce===U.length){Y(ce,0,J.slice(te));break}if(te===J.length){Y(ce,U.length-ce,[]);break}const fe=U[ce],re=J[te];if(ee(fe,re)){ce+=1,te+=1;continue}ne(re)?(Y(ce,1,[]),ce+=1):(Y(ce,0,[re]),te+=1)}return Q}e.$kJ=h,e.$lJ=new k.$nj("notebookEditorCursorAtBoundary","none"),e.$mJ=new k.$nj("notebookEditorCursorAtLineBoundary","none");var s;(function(U){U.default="default",U.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(U){const J=U;return!!((typeof J.include=="string"||N.$Qj(J.include))&&(typeof J.exclude=="string"||N.$Qj(J.exclude)))}e.$nJ=d;function l(U,J,ne){if(Array.isArray(U.viewType)&&U.viewType.indexOf(J)>=0||U.viewType===J)return!0;if(U.filenamePattern){const ee=d(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Q=d(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(N.$Oj(ee,(0,v.$nc)(ne.fsPath).toLowerCase()))return!(Q&&N.$Oj(Q,(0,v.$nc)(ne.fsPath).toLowerCase()))}return!1}e.$oJ=l,e.$pJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var c;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class p{static{this.d="notebook/"}static create(J){return`${p.d}${J}`}static parse(J){if(J.startsWith(p.d))return J.substring(p.d.length)}}e.$qJ=p;function I(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$rJ=I;const w=new TextDecoder;function g(U){const J=[];let ne=!1;for(const ce of U)(J.length===0||ne)&&(J.push(ce),ne=!0);let ee=F(J);const Q=D.$ke.concat(J.map(ce=>D.$ke.wrap(ce))),Y=T(Q);return ee=ee||Y.byteLength!==Q.byteLength,{data:Y,didCompression:ee}}e.$sJ=g,e.$tJ="\x1B[A";const y=e.$tJ.split("").map(U=>U.charCodeAt(0)),L=10;function F(U){let J=!1;return U.forEach((ne,ee)=>{if(ee===0||ne.length<e.$tJ.length)return;const Q=U[ee-1],Y=ne.subarray(0,e.$tJ.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const ce=Q.lastIndexOf(L);if(ce===-1)return;J=!0,U[ee-1]=Q.subarray(0,ce),U[ee]=ne.subarray(e.$tJ.length)}}),J}function z(U){let J=U;do U=J,J=U.replace(/[^\n]\x08/gm,"");while(J.length<U.length);return U}function j(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const J=U.match(/^(.*)\r+/m)[1];let ne=U.match(/\r+(.*)$/m)[1];ne=ne+J.slice(ne.length,J.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return U}const O=8,M=13;function T(U){return!U.buffer.includes(O)&&!U.buffer.includes(M)?U:D.$ke.fromString(j(z(w.decode(U.buffer))))}}),define(Ce[7],Ie([1,0,19,14,63,28,100,12,18,2,30,25,32,65,118]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";var u,m,a,i,r,n,o,t,h,s,d,l,c,p,I,w,g;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.ChatAgentResultFeedbackKind=e.$jN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$iN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.TestRunProfileKind=e.TestResultState=e.$1M=e.$ZM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$YM=e.NotebookVariablesRequestKind=e.$XM=e.$WM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$VM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.ColorThemeKind=e.$PM=e.$OM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$NM=e.$MM=e.DebugConsoleMode=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$GM=e.$FM=e.FileChangeType=e.$EM=e.$DM=e.$CM=e.$BM=e.InlineCompletionTriggerKind=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.ConfigurationTarget=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$eM=e.ViewBadge=e.ProgressLocation=e.$dM=e.$cM=e.TaskScope=e.ShellQuoting=e.$bM=e.$aM=e.$_L=e.TaskPanelKind=e.TaskRevealKind=e.$$L=e.TerminalLocation=e.$0L=e.$9L=e.$8L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$7L=e.$6L=e.$5L=e.$4L=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$3L=e.StatusBarAlignment=e.ViewColumn=e.$2L=e.$1L=e.$ZL=e.$YL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$XL=e.$WL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.LanguageStatusSeverity=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.CodeActionTriggerKind=e.$KL=e.$JL=e.SymbolTag=e.SymbolKind=e.$IL=e.$HL=e.DocumentHighlightKind=e.$GL=e.$FL=e.$EL=e.$DL=e.DiagnosticSeverity=e.DiagnosticTag=e.$CL=e.$BL=e.FileEditType=e.$AL=e.$zL=e.$yL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(G){return Object.assign(G,{apply:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const Fe=we.length===1?[]:we[1];return Reflect.construct(G,Fe,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const[Fe,...Ze]=we;return Reflect.construct(G,Ze,Fe.constructor)}}})}var L;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var F;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let z=u=class{static from(...q){let we=q;return new u(function(){if(we){for(const Fe of we)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$rL=z,e.$rL=z=u=Ke([y],z);let j=m=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Fe=1;Fe<q.length;Fe++){const Ze=q[Fe];Ze.isBefore(we)&&(we=Ze)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Fe=1;Fe<q.length;Fe++){const Ze=q[Fe];Ze.isAfter(we)&&(we=Ze)}return we}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:we,character:Fe}=q;return typeof we=="number"&&typeof Fe=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,N.$7)("line must be non-negative");if(we<0)throw(0,N.$7)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,N.$7)();let Fe;return typeof q>"u"?Fe=0:typeof q=="number"?Fe=q:(Fe=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Fe===0&&we===0?this:new m(this.line+Fe,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,N.$7)();let Fe;return typeof q>"u"?Fe=this.line:typeof q=="number"?Fe=q:(Fe=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Fe===this.line&&we===this.character?this:new m(Fe,we)}toJSON(){return{line:this.line,character:this.character}}};e.$sL=j,e.$sL=j=m=Ke([y],j);let O=a=class{static isRange(q){return q instanceof a?!0:q?j.isPosition(q.start)&&j.isPosition(q.end):!1}static of(q){if(q instanceof a)return q;if(this.isRange(q))return new a(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Fe,Ze){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(tt=new j(q,we),lt=new j(Fe,Ze)):j.isPosition(q)&&j.isPosition(we)&&(tt=j.of(q),lt=j.of(we)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return a.isRange(q)?this.contains(q.start)&&this.contains(q.end):j.isPosition(q)?!(j.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=j.Max(q.start,this.c),Fe=j.Min(q.end,this.e);if(!we.isAfter(Fe))return new a(we,Fe)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=j.Min(q.start,this.c),Fe=j.Max(q.end,this.end);return new a(we,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,N.$7)();let Fe;return q?j.isPosition(q)?Fe=q:(Fe=q.start||this.start,we=q.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&we.isEqual(this.end)?this:new a(Fe,we)}toJSON(){return[this.start,this.end]}};e.$tL=O,e.$tL=O=a=Ke([y],O);let M=i=class extends O{static isSelection(q){return q instanceof i?!0:q?O.isRange(q)&&j.isPosition(q.anchor)&&j.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Fe,Ze){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(tt=new j(q,we),lt=new j(Fe,Ze)):j.isPosition(q)&&j.isPosition(we)&&(tt=j.of(q),lt=j.of(we)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$uL=M,e.$uL=M=i=Ke([y],M);const T=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,N.$7)("connectionToken")};class U{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Fe){if(typeof q!="string"||q.length===0)throw(0,N.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,N.$7)("port");typeof Fe<"u"&&T(Fe),this.host=q,this.port=Math.round(we),this.connectionToken=Fe}}e.$vL=U;class J{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&T(we)}}e.$wL=J;class ne extends Error{static NotAvailable(q,we){return new ne(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new ne(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=E.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(q),this._message=q,this._code=we,this._detail=Fe,Object.setPrototypeOf(this,ne.prototype)}}e.$xL=ne;var ee;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ee||(e.EndOfLine=ee={}));var Q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let Y=r=class{static isTextEdit(q){return q instanceof r?!0:q?O.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new r(q,we)}static insert(q,we){return r.replace(new O(q,q),we)}static delete(q){return r.replace(q,"")}static setEndOfLine(q){const we=new r(new O(new j(0,0),new j(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!O.isRange(q))throw(0,N.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$7)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$yL=Y,e.$yL=Y=r=Ke([y],Y);let ce=n=class{static isNotebookCellEdit(q){return q instanceof n?!0:q?hi.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new n(q,we)}static insertCells(q,we){return new n(new hi(q,q),we)}static deleteCells(q){return new n(q,[])}static updateCellMetadata(q,we){const Fe=new n(new hi(q,q),[]);return Fe.newCellMetadata=we,Fe}static updateNotebookMetadata(q){const we=new n(new hi(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$zL=ce,e.$zL=ce=n=Ke([y],ce);class te{static isSnippetTextEdit(q){return q instanceof te?!0:q?O.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,we){return new te(q,we)}static insert(q,we){return te.replace(new O(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$AL=te;var fe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Fe,Ze){this.c.push({_type:1,from:q,to:we,options:Fe,metadata:Ze})}createFile(q,we,Fe){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Fe})}deleteFile(q,we,Fe){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Fe})}e(q,we,Fe){this.c.push({_type:3,metadata:Fe,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Fe,Ze){const tt=we.start,lt=we.end;(tt!==lt||Fe.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Fe,metadata:Ze})}g(q,we,Fe,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:we,metadata:Fe}})}replace(q,we,Fe,Ze){this.c.push({_type:2,uri:q,edit:new Y(we,Fe),metadata:Ze})}insert(q,we,Fe,Ze){this.replace(q,new O(we,we),Fe,Ze)}delete(q,we,Fe){this.replace(q,we,"",Fe)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Fe of we){if(!Fe)continue;let Ze,tt;Array.isArray(Fe)?(Ze=Fe[0],tt=Fe[1]):Ze=Fe,ce.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,tt):this.f(q,Ze.range,Ze.newCells,tt):te.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:tt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Ze=this.c[Fe];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Fe]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const we=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===q.toString()&&we.push(Fe.edit);return we}entries(){const q=new P.$Ac;for(const we of this.c)if(we._type===2){let Fe=q.get(we.uri);Fe||(Fe=[we.uri,[]],q.set(we.uri,Fe)),Fe[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$BL=re,e.$BL=re=Ke([y],re);let K=o=class{static isSnippetString(q){return q instanceof o?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=o.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Fe=new o;Fe.e=this.e,q(Fe),this.e=Fe.e,q=Fe.value}else q=o.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Fe=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Fe=new o;Fe.e=this.e,we(Fe),this.e=Fe.e,we=Fe.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$CL=K,e.$CL=K=o=Ke([y],K);var B;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae||(e.DiagnosticSeverity=ae={}));let Ee=t=class{static isLocation(q){return q instanceof t?!0:q?O.isRange(q.range)&&k.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(O.isRange(we))this.range=O.of(we);else if(j.isPosition(we))this.range=new O(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$DL=Ee,e.$DL=Ee=t=Ke([y],Ee);let le=class{static is(q){return q?typeof q.message=="string"&&q.location&&O.isRange(q.location.range)&&k.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$EL=le,e.$EL=le=Ke([y],le);let de=class{constructor(q,we,Fe=ae.Error){if(!O.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Fe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,D.$ub)(q.tags,we.tags)&&(0,D.$ub)(q.relatedInformation,we.relatedInformation,le.isEqual)}};e.$FL=de,e.$FL=de=Ke([y],de);let ue=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$GL=ue,e.$GL=ue=Ke([y],ue);var ge;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let V=class{constructor(q,we=ge.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$HL=V,e.$HL=V=Ke([y],V);let Z=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$IL=Z,e.$IL=Z=Ke([y],Z);var he;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var be;(function(G){G[G.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Pe=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Fe,Ze,tt){this.name=q,this.kind=we,this.containerName=tt,typeof Fe=="string"&&(this.containerName=Fe),Ze instanceof Ee?this.location=Ze:Fe instanceof O&&(this.location=new Ee(Ze,Fe)),h.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$JL=Pe,e.$JL=Pe=h=Ke([y],Pe);let pe=s=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(s.validate)}constructor(q,we,Fe,Ze,tt){this.name=q,this.detail=we,this.kind=Fe,this.range=Ze,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$KL=pe,e.$KL=pe=s=Ke([y],pe);var Le;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let Ne=class{constructor(q,we){this.title=q,this.kind=we}};e.$LL=Ne,e.$LL=Ne=Ke([y],Ne);let W=class{static{d=this}static{this.c="."}constructor(q){this.value=q}append(q){return new d(this.value?this.value+d.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+d.c)}};e.$ML=W,e.$ML=W=d=Ke([y],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let x=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$NL=x,e.$NL=x=Ke([y],x);class H{constructor(q,we,Fe,Ze,tt,lt){this.kind=q,this.name=we,this.detail=Fe,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$OL=H;class X{constructor(q,we){this.fromRanges=we,this.from=q}}e.$PL=X;class oe{constructor(q,we){this.fromRanges=we,this.to=q}}e.$QL=oe;var ve;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(ve||(e.LanguageStatusSeverity=ve={}));let Me=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$RL=Me,e.$RL=Me=Ke([y],Me);let qe=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new f.$kk(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$SL=qe,e.$SL=qe=l=Ke([y],qe);let Ge=class{constructor(q,we){this.label=q,this.documentation=we}};e.$TL=Ge,e.$TL=Ge=Ke([y],Ge);let Ye=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$UL=Ye,e.$UL=Ye=Ke([y],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$VL=it,e.$VL=it=Ke([y],it);var ut;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ut||(e.SignatureHelpTriggerKind=ut={}));var ot;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let et=class{constructor(q){this.value=q}};e.$WL=et,e.$WL=et=Ke([y],et);let Ae=class{constructor(q,we,Fe){this.position=q,this.label=we,this.kind=Fe}};e.$XL=Ae,e.$XL=Ae=Ke([y],Ae);var ke;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ke||(e.CompletionTriggerKind=ke={}));var He;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var _;(function(G){G[G.Deprecated=1]="Deprecated"})(_||(e.CompletionItemTag=_={}));let se=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$YL=se,e.$YL=se=Ke([y],se);let De=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$ZL=De,e.$ZL=De=Ke([y],De);let Ve=class{constructor(q,we,Fe){this.insertText=q,this.range=we,this.command=Fe}};e.$1L=Ve,e.$1L=Ve=Ke([y],Ve);let Xe=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$2L=Xe,e.$2L=Xe=Ke([y],Xe);var nt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function je(G,q){return`${C.$om.toKey(G)}.${q}`}e.$3L=je;var yt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var kt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var Tt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Tt||(e.TextEditorRevealType=Tt={}));var Mt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var St;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var ei;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ei||(e.DecorationRangeBehavior=ei={})),function(G){function q(we){switch(we){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var Vt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Vt||(e.SyntaxTokenType=Vt={})),function(G){function q(we){switch(we){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Vt||(e.SyntaxTokenType=Vt={}));let ni=class{constructor(q,we){if(we&&!k.URI.isUri(we))throw(0,N.$7)("target");if(!O.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.target=we}};e.$4L=ni,e.$4L=ni=Ke([y],ni);let Zt=class{constructor(q,we,Fe,Ze){this.red=q,this.green=we,this.blue=Fe,this.alpha=Ze}};e.$5L=Zt,e.$5L=Zt=Ke([y],Zt);let Yt=class{constructor(q,we){if(we&&!(we instanceof Zt))throw(0,N.$7)("color");if(!O.isRange(q)||q.isEmpty)throw(0,N.$7)("range");this.range=q,this.color=we}};e.$6L=Yt,e.$6L=Yt=Ke([y],Yt);let _e=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$7)("label");this.label=q}};e.$7L=_e,e.$7L=_e=Ke([y],_e);var Ht;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var ti;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var dt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class $t{constructor(q,we,Fe){if(this.startIndex=q,this.length=we,this.tooltip=Fe,typeof q!="number"||q<0)throw(0,N.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,N.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,N.$7)("tooltip")}}e.$8L=$t;class Jt{constructor(q){this.uri=q}}e.$9L=Jt;class ii{constructor(q){this.terminalCommand=q}}e.$0L=ii;var At;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$7)("options")}}e.$$L=ft;var Nt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Nt||(e.TaskRevealKind=Nt={}));var oi;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Ft=class{static{c=this}static{this.Clean=new c("clean","Clean")}static{this.Build=new c("build","Build")}static{this.Rebuild=new c("rebuild","Rebuild")}static{this.Test=new c("test","Test")}static from(q){switch(q){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,N.$7)("name");this.c=q}get id(){return this.c}};e.$_L=Ft,e.$_L=Ft=c=Ke([y],Ft);function Je(G){let q="";for(let we=0;we<G.length;we++)q+=G[we].replace(/,/g,",,")+",";return q}let jt=class{constructor(q,we,Fe){if(typeof q!="string")throw(0,N.$7)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Fe):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Je(q)}};e.$aM=jt,e.$aM=jt=Ke([y],jt);let Ut=class{constructor(q,we,Fe){if(this.f=[],Array.isArray(we)){if(!q)throw(0,N.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q,this.f=we,this.g=Fe}else{if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Je(q)}};e.$bM=Ut,e.$bM=Ut=Ke([y],Ut);var xt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(xt||(e.ShellQuoting=xt={}));var gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class zt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$sg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$cM=zt;let Lt=class{static{p=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Fe,Ze,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof we=="string"?(this.o=this.name=we,this.w=this.source=Fe,this.execution=Ze,mt=tt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=tt,mt=lt):(this.target=we,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=tt,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:p.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:p.f,id:this.q.computeId()}:this.q instanceof zt?this.l={type:p.c,id:this.q.computeId()}:this.l={type:p.g,id:(0,R.$sg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,N.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const we=this.l.type;(p.g===we||p.e===we||p.f===we||p.c===we)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$dM=Lt,e.$dM=Lt=p=Ke([y],Lt);var Bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var Gt;(function(G){function q(we){const Fe=we;return(0,$.$Of)(Fe.value)?Fe.tooltip&&!(0,$.$Kf)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}G.isViewBadge=q})(Gt||(e.ViewBadge=Gt={}));let Wt=I=class{static isTreeItem(q,we){const Fe=q;if(Fe.checkboxState!==void 0){const Ze=(0,$.$Of)(Fe.checkboxState)?Fe.checkboxState:(0,$.$Mf)(Fe.checkboxState)&&(0,$.$Of)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,tt=!(0,$.$Of)(Fe.checkboxState)&&(0,$.$Mf)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==qt.Checked&&Ze!==qt.Unchecked||tt!==void 0&&!(0,$.$Kf)(tt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(q instanceof I)return!0;if(Fe.label!==void 0&&!(0,$.$Kf)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,$.$Kf)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,$.$Kf)(Fe.iconPath)&&!k.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,$.$Kf)(Fe.iconPath.id))){const Ze=Fe.iconPath;if(!Ze||!(0,$.$Kf)(Ze.light)&&!k.URI.isUri(Ze.light)&&!(0,$.$Kf)(Ze.dark)&&!k.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,$.$Kf)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!k.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,$.$Kf)(Fe.tooltip)&&!(Fe.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<It.None&&Fe.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,$.$Kf)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(q,we=It.None){this.collapsibleState=we,k.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$eM=Wt,e.$eM=Wt=I=Ke([y],Wt);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var qt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(qt||(e.TreeItemCheckboxState=qt={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$fM=Dt,e.$fM=Dt=Ke([y],Dt);class pt extends Dt{}e.$gM=pt;class Pt extends pt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$hM=Pt;class Ct{constructor(q,we,Fe,Ze){this.name=q,this.uri=we,this._itemId=Fe,this.c=Ze}data(){return this.c()}}e.$iM=Ct;let li=class{#e=new Map;constructor(q){for(const[we,Fe]of q??[]){const Ze=this.#e.get(this.#t(we));Ze?Ze.push(Fe):this.#e.set(this.#t(we),[Fe])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Fe,Ze]of this.#e)for(const tt of Ze)q.call(we,tt,Fe,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Fe of we)yield[q,Fe]}#t(q){return q.toLowerCase()}};e.$jM=li,e.$jM=li=Ke([y],li);let Xt=class{constructor(q){this.insertText=q}};e.$kM=Xt,e.$kM=Xt=Ke([y],Xt);let bi=class{constructor(q,we){this.label=we,this.insertText=q}};e.$lM=bi,e.$lM=bi=Ke([y],bi);let Re=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$mM=Re,e.$mM=Re=Ke([y],Re),Re.File=new Re("file"),Re.Folder=new Re("folder");let Oe=class{constructor(q){this.id=q}};e.$nM=Oe,e.$nM=Oe=Ke([y],Oe);var ye;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ye||(e.ConfigurationTarget=ye={}));let ie=class{get base(){return this.c}set base(q){this.c=q,this.e=k.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!k.URI.isUri(q)&&!k.URI.isUri(q.uri)))throw(0,N.$7)("base");if(typeof we!="string")throw(0,N.$7)("pattern");typeof q=="string"?this.baseUri=k.URI.file(q):k.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oM=ie,e.$oM=ie=Ke([y],ie);const Te=new WeakMap;function ze(G,q){Te.set(G,q)}e.$pM=ze;let xe=class{constructor(q,we,Fe,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Te.get(this)??(0,R.$sg)()),this.c}};e.$qM=xe,e.$qM=xe=Ke([y],xe);let Qe=class extends xe{constructor(q,we,Fe,Ze,tt){if(super(we,Fe,Ze,tt),q===null)throw(0,N.$7)("location");this.location=q}};e.$rM=Qe,e.$rM=Qe=Ke([y],Qe);let at=class extends xe{constructor(q,we,Fe,Ze,tt){super(we,Fe,Ze,tt),this.functionName=q}};e.$sM=at,e.$sM=at=Ke([y],at);let vt=class extends xe{constructor(q,we,Fe,Ze,tt,lt,mt){if(super(Ze,tt,lt,mt),!we)throw(0,N.$7)("dataId");this.label=q,this.dataId=we,this.canPersist=Fe}};e.$tM=vt,e.$tM=vt=Ke([y],vt);let Kt=class{constructor(q,we,Fe){this.command=q,this.args=we||[],this.options=Fe}};e.$uM=Kt,e.$uM=Kt=Ke([y],Kt);let Et=class{constructor(q,we){this.port=q,this.host=we}};e.$vM=Et,e.$vM=Et=Ke([y],Et);let Rt=class{constructor(q){this.path=q}};e.$wM=Rt,e.$wM=Rt=Ke([y],Rt);let Qt=class{constructor(q){this.implementation=q}};e.$xM=Qt,e.$xM=Qt=Ke([y],Qt);let wi=class{constructor(q,we,Fe){this.session=q,this.threadId=we,this.frameId=Fe}};e.$yM=wi,e.$yM=wi=Ke([y],wi);let pi=class{constructor(q,we){this.session=q,this.threadId=we}};e.$zM=pi,e.$zM=pi=Ke([y],pi);let ht=class{constructor(q,we){this.range=q,this.expression=we}};e.$AM=ht,e.$AM=ht=Ke([y],ht);var Xi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Xi||(e.InlineCompletionTriggerKind=Xi={}));let ai=class{constructor(q,we){this.range=q,this.text=we}};e.$BM=ai,e.$BM=ai=Ke([y],ai);let fi=class{constructor(q,we,Fe=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Fe}};e.$CM=fi,e.$CM=fi=Ke([y],fi);let ki=class{constructor(q,we){this.range=q,this.expression=we}};e.$DM=ki,e.$DM=ki=Ke([y],ki);let Ai=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$EM=Ai,e.$EM=Ai=Ke([y],Ai);var Qi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Ri=w=class extends Error{static FileExists(q){return new w(q,b.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,b.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,b.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,b.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,b.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,b.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,we=b.FileSystemProviderErrorCode.Unknown,Fe){super(k.URI.isUri(q)?q.toString(!0):q),this.code=Fe?.name??"Unknown",(0,b.$Ik)(this,we),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$FM=Ri,e.$FM=Ri=w=Ke([y],Ri);let Si=class{constructor(q,we,Fe){this.start=q,this.end=we,this.kind=Fe}};e.$GM=Si,e.$GM=Si=Ke([y],Si);var Zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Mi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Mi||(e.CommentThreadCollapsibleState=Mi={}));var gi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(gi||(e.CommentMode=gi={}));var Yi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Yi||(e.CommentState=Yi={}));var Di;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Di||(e.CommentThreadState=Di={}));class Ni{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$HM=Ni;function ln(G){return typeof G>"u"||(0,$.$Lf)(G)}class Fi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Fe=q.tokenTypes.length;we<Fe;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Fe=q.tokenModifiers.length;we<Fe;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Fe,Ze,tt){if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(q,we,Fe,Ze,tt);if(O.isRange(q)&&typeof we=="string"&&ln(Fe))return this.o(q,we,Fe);throw(0,N.$7)()}o(q,we,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(we);let _t=0;if(Fe)for(const si of Fe){if(!this.l.has(si))throw new Error("`tokenModifier` is not in the provided legend");const ui=this.l.get(si);_t|=1<<ui>>>0}this.q(Ze,tt,lt,mt,_t)}q(q,we,Fe,Ze,tt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const _t=this.g.length/5|0;let si=0,ui=0;for(let di=0;di<_t;di++){let $i=this.g[5*di],Ki=this.g[5*di+1];$i===0?($i=si,Ki+=ui):$i+=si,this.g[5*di]=$i,this.g[5*di+1]=Ki,si=$i,ui=Ki}}let lt=q,mt=we;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Fe,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=q,this.e=we}static r(q){const we=[],Fe=q.length/5|0;for(let mt=0;mt<Fe;mt++)we[mt]=mt;we.sort((mt,_t)=>{const si=q[5*mt],ui=q[5*_t];if(si===ui){const di=q[5*mt+1],$i=q[5*_t+1];return di-$i}return si-ui});const Ze=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Fe;mt++){const _t=5*we[mt],si=q[_t+0],ui=q[_t+1],di=q[_t+2],$i=q[_t+3],Ki=q[_t+4],In=si-tt,Xn=In===0?ui-lt:ui,Ji=5*mt;Ze[Ji+0]=In,Ze[Ji+1]=Xn,Ze[Ji+2]=di,Ze[Ji+3]=$i,Ze[Ji+4]=Ki,tt=si,lt=ui}return Ze}build(q){return this.f?new mi(new Uint32Array(this.g),q):new mi(Fi.r(this.g),q)}}e.$IM=Fi;class mi{constructor(q,we){this.resultId=we,this.data=q}}e.$JM=mi;class hn{constructor(q,we,Fe){this.start=q,this.deleteCount=we,this.data=Fe}}e.$KM=hn;class dn{constructor(q,we){this.resultId=we,this.edits=q}}e.$LM=dn;var xi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class Ei{constructor(q){this.name=q}}e.$MM=Ei;let Ti=class{static{this.Back={iconPath:new Re("arrow-left")}}constructor(){}};e.$NM=Ti,e.$NM=Ti=Ke([y],Ti);var _i;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var Ci;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var Oi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class fn{static validate(q){if(typeof q.badge=="string"){let we=(0,v.$lf)(q.badge,0);if(we<q.badge.length&&(we+=(0,v.$lf)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Re.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Fe){this.badge=q,this.tooltip=we,this.color=Fe}}e.$OM=fn;let Ii=class{constructor(q){this.kind=q}};e.$PM=Ii,e.$PM=Ii=Ke([y],Ii);var ji;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class hi{static isNotebookRange(q){return q instanceof hi?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,N.$7)("start must be positive");if(we<0)throw(0,N.$7)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Fe=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Fe=q.end),we===this.c&&Fe===this.e?this:new hi(we,Fe)}}e.$QM=hi;class Pi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>Pi.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Fe,Ze,tt,lt,mt){this.kind=q,this.value=we,this.languageId=Fe,this.mime=Ze,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,Pi.validate(this)}}e.$RM=Pi;class gn{constructor(q){this.cells=q}}e.$SM=gn;class ri{static isNotebookCellOutputItem(q){return q instanceof ri?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return ri.json(we,"application/vnd.code.notebook.error")}static stdout(q){return ri.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return ri.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new ri(q,we)}static#e=new TextEncoder;static text(q,we=A.$is.text){const Fe=ri.#e.encode(String(q));return new ri(Fe,we)}static json(q,we="text/x-json"){const Fe=JSON.stringify(q,void 0,"	");return ri.text(Fe,we)}constructor(q,we){this.data=q,this.mime=we;const Fe=(0,A.$ms)(we,!0);if(!Fe)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$TM=ri;class vi{static isNotebookCellOutput(q){return q instanceof vi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Fe=new Set,Ze=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,A.$ms)(lt.mime);if(!Fe.has(mt)||(0,S.$rJ)(mt)){Fe.add(mt);continue}Ze.add(tt),we&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ze.size===0?q:q.filter((tt,lt)=>!Ze.has(lt))}constructor(q,we,Fe){this.items=vi.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Fe):(this.id=(0,R.$sg)(),this.metadata=we??Fe)}}e.$UM=vi;var Ui;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var Be;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Be||(e.NotebookCellExecutionState=Be={}));var ci;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ci||(e.NotebookCellStatusBarAlignment=ci={}));var zi;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zi||(e.NotebookEditorRevealType=zi={}));class st{constructor(q,we){this.text=q,this.alignment=we}}e.$VM=st;var bt;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var en;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(q,we=[]){this.uri=q,this.provides=(0,D.$3b)(we)}}e.$WM=mn;class tn{constructor(q){this.label=q}}e.$XM=tn;var nn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let yi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$YM=yi,e.$YM=yi=Ke([y],yi);var rn;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$ZM=an;class $n{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$1M=$n;var cn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Bi=class{constructor(q=void 0,we=void 0,Fe=void 0,Ze=!1){this.include=q,this.exclude=we,this.profile=Fe,this.continuous=Ze}};e.$2M=Bi,e.$2M=Bi=Ke([y],Bi);let Wi=g=class{static diff(q,we,Fe){const Ze=new g(q);return Ze.expectedOutput=we,Ze.actualOutput=Fe,Ze}constructor(q){this.message=q}};e.$3M=Wi,e.$3M=Wi=g=Ke([y],Wi);let qi=class{constructor(q){this.id=q}};e.$4M=qi,e.$4M=qi=Ke([y],qi);class Li{constructor(q,we){this.covered=q,this.total=we}}e.$5M=Li;const Vi=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class Hi{static fromDetails(q,we){const Fe=new Li(0,0),Ze=new Li(0,0),tt=new Li(0,0);for(const mt of we)if("branches"in mt){Fe.total+=1,Fe.covered+=mt.executed?1:0;for(const _t of mt.branches)Ze.total+=1,Ze.covered+=_t.executed?1:0}else tt.total+=1,tt.covered+=mt.executed?1:0;const lt=new Hi(q,Fe,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=we,lt}constructor(q,we,Fe,Ze){this.uri=q,this.statementCoverage=we,this.branchCoverage=Fe,this.declarationCoverage=Ze,Vi(we),Vi(Fe),Vi(Ze)}}e.$6M=Hi;class bn{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe=[]){this.executed=q,this.location=we,this.branches=Fe}}e.$7M=bn;class $e{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe){this.executed=q,this.location=we,this.label=Fe}}e.$8M=$e;class Se{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe){this.name=q,this.executed=we,this.location=Fe}}e.$9M=Se;var Ue;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ue||(e.ExternalUriOpenerPriority=Ue={}));var ct;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ct||(e.WorkspaceTrustState=ct={}));var wt;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Ot{constructor(q,we,Fe,Ze,tt,lt){this.kind=q,this.name=we,this.detail=Fe,this.uri=Ze,this.range=tt,this.selectionRange=lt}}e.$0M=Ot;class Gi{constructor(q){this.uri=q}}e.$$M=Gi;class Pn{constructor(q,we){this.original=q,this.modified=we}}e.$_M=Pn;class Ln{constructor(q,we,Fe,Ze){this.base=q,this.input1=we,this.input2=Fe,this.result=Ze}}e.$aN=Ln;class An{constructor(q,we){this.uri=q,this.viewType=we}}e.$bN=An;class Rn{constructor(q){this.viewType=q}}e.$cN=Rn;class Mn{constructor(q,we){this.uri=q,this.notebookType=we}}e.$dN=Mn;class Nn{constructor(q,we,Fe){this.original=q,this.modified=we,this.notebookType=Fe}}e.$eN=Nn;class Fn{constructor(){}}e.$fN=Fn;class Tn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$gN=Tn;class On{constructor(q){this.providerId=q}}e.$hN=On;var wn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class jn{constructor(q,we){this.label=q,this.values=we}}e.$iN=jn;var yn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant"})(En||(e.ChatMessageRole=En={}));class Un{constructor(q,we){this.role=q,this.content=we}}e.$jN=Un;var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));class zn{constructor(q){this.value=q}}e.$kN=zn;class Bn{constructor(q){this.value=typeof q=="string"?new qe(q):q}}e.$lN=Bn;class Wn{constructor(q,we){this.value=q,this.baseUri=we}}e.$mN=Wn;class qn{constructor(q,we){this.value=q,this.title=we}}e.$nN=qn;class Vn{constructor(q){this.value=q}}e.$oN=Vn;class Hn{constructor(q){this.value=q}}e.$pN=Hn;class Gn{constructor(q){this.value=q}}e.$qN=Gn;class Kn{constructor(q,we,Fe,Ze){this.prompt=q,this.agentId=we,this.command=Fe,this.variables=Ze}}e.$rN=Kn;class Jn{constructor(q,we,Fe){this.response=q,this.result=we,this.agentId=Fe}}e.$sN=Jn;var Sn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(Ce[314],Ie([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$pL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,v,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(v,$)??[]}getRelatedInformation(A,v,$){return this.c.$getAiRelatedInformation(v,$)}registerRelatedInformationProvider(A,v,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,v),new N.$rL(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$ygc=f}),define(Ce[315],Ie([1,0,4,6,7,25,142]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class v{constructor(R){this.b=new Map,this.c=new D.$Wd,this.onDidChangeSessions=this.c.event,this.d=new $,this.f=new $,this.a=R.getProxy(N.$pL.MainThreadAuthentication)}async getSession(R,C,b,E={}){const S=P.$om.toKey(R.identifier),u=[...b].sort().join(" ");return await this.d.getOrCreate(`${S} ${C} ${u}`,async()=>{await this.a.$ensureProvider(C);const m=R.displayName||R.name;return this.a.$getSession(C,b,S,m,E)})}async getSessions(R,C,b){const E=P.$om.toKey(R.identifier),S=[...b].sort().join(" ");return await this.f.getOrCreate(`${E} ${S}`,async()=>{await this.a.$ensureProvider(C);const u=R.displayName||R.name;return this.a.$getSessions(C,b,E,u)})}async removeSession(R,C){const b=this.b.get(R);return b?b.provider.removeSession(C):this.a.$removeSession(R,C)}registerAuthenticationProvider(R,C,b,E){if(this.b.get(R))throw new Error(`An authentication provider with id '${R}' is already registered.`);this.b.set(R,{label:C,provider:b,options:E??{supportsMultipleAccounts:!1}});const S=b.onDidChangeSessions(u=>this.a.$sendDidChangeSessions(R,u));return this.a.$registerAuthenticationProvider(R,C,E?.supportsMultipleAccounts??!1),new f.$rL(()=>{S.dispose(),this.b.delete(R),this.a.$unregisterAuthenticationProvider(R)})}$createSession(R,C,b){const E=this.b.get(R);if(E)return Promise.resolve(E.provider.createSession(C,b));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$removeSession(R,C){const b=this.b.get(R);if(b)return Promise.resolve(b.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$getSessions(R,C){const b=this.b.get(R);if(b)return Promise.resolve(b.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$onDidChangeAuthenticationSessions(R,C){return R.startsWith(A.$vK)||this.c.fire({provider:{id:R,label:C}}),Promise.resolve()}}e.$Jgc=v;class ${constructor(){this.a=new Map}getOrCreate(R,C){const b=this.a.get(R);if(b)return b;const E=C().finally(()=>this.a.delete(R));return this.a.set(R,E),E}}}),define(Ce[148],Ie([1,0,2,6,7,5,20,13,19,12,17,26]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0;let E=class{static{b=this}static{this.c=0}static{this.d=250}constructor(u,m){this.h=m,this.f=new Map,this.g=u.getProxy(N.$pL.MainThreadDecorations)}registerFileDecorationProvider(u,m){const a=b.c++;this.f.set(a,{provider:u,extensionDescription:m}),this.g.$registerDecorationProvider(a,m.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(a,null);return}const n=(0,$.$3b)(r);if(n.length<=b.d){this.g.$onDidChange(a,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,n.length);const o=n.map(s=>({uri:s,rank:(0,k.$Qe)(s.path,"/")})),t=(0,$.$zb)(o,(s,d)=>s.rank-d.rank||(0,k.$7e)(s.uri.path,d.uri.path)),h=[];e:for(const s of t){let d;for(const l of s){const c=(0,R.$mc)(l.uri.path);if(d!==c&&(d=c,h.push(l.uri)>=b.d))break e}}this.g.$onDidChange(a,h)});return new f.$rL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(u,m,a){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(u);return await Promise.all(m.map(async o=>{try{const{uri:t,id:h}=o,s=await Promise.resolve(r.provideFileDecoration(D.URI.revive(t),a));if(!s)return;try{f.$OM.validate(s),s.badge&&typeof s.badge!="string"&&(0,C.$MF)(n,"codiconDecoration"),i[h]=[s.propagate,s.tooltip,s.badge,s.color]}catch(d){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$Ihc=E,e.$Ihc=E=b=Ke([We(0,A.$DN),We(1,v.$qj)],E),e.$Jhc=(0,P.$9h)("IExtHostDecorations")}),define(Ce[316],Ie([1,0,14,2,7,6,15,22,12]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class k{static{this.a=0}constructor(C,b,E){this.d=b,this.e=E,this.b=new Map,this.c=C.getProxy(P.$pL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,b){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=k.a++;this.b.set(E,b),this.c.$registerTextContentProvider(E,C);let S;if(typeof b.onDidChange=="function"){let u;S=b.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;u&&await u;const a=this.$provideTextDocumentContent(E,m).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(m);if(!r)return;const n=(0,$.$1e)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(m,i)}).catch(D.$1).finally(()=>{u===a&&(u=void 0)});u=a})}return new f.$rL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,b){const E=this.b.get(C);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive(b),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.$Lhc=k}),define(Ce[149],Ie([1,0,61,15,12,177,126,7,19]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=e.$FN=void 0;const k=new Map;function R(S,u){u?k.set(S,u):k.delete(S)}e.$FN=R;function C(S){return k.get(S)}class b extends P.$ov{constructor(u,m,a,i,r,n,o,t){super(m,a,i,r),this.c=u,this.m=n,this.q=o,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,$.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===N.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(m){return m?u.s(m):u.getText()},get eol(){return u.g===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(m){return u.t(m)},offsetAt(m){return u.u(m)},positionAt(m){return u.v(m)},validateRange(m){return u.w(m)},validatePosition(m){return u.x(m)},getWordRangeAtPosition(m,a){return u.y(m,a)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,D.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,D.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const m=this.w(u);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const a=this.g,i=m.start.line,r=m.end.line,n=[];n.push(this.f[i].substring(m.start.character));for(let o=i+1;o<r;o++)n.push(this.f[o]);return n.push(this.f[r].substring(0,m.end.character)),n.join(a)}t(u){let m;if(u instanceof v.$sL?m=u.line:typeof u=="number"&&(m=u),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const m=this.j.getIndexOf(u),a=this.f[m.index].length;return new v.$sL(m.index,Math.min(m.remainder,a))}w(u){if(!(u instanceof v.$tL))throw new Error("Invalid argument");const m=this.x(u.start),a=this.x(u.end);return m===u.start&&a===u.end?u:new v.$tL(m.line,m.character,a.line,a.character)}x(u){if(!(u instanceof v.$sL))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:m,character:a}=u,i=!1;if(m<0)m=0,a=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,a=this.f[m].length,i=!0;else{const r=this.f[m].length;a<0?(a=0,i=!0):a>r&&(a=r,i=!0)}return i?new v.$sL(m,a):u}y(u,m){const a=this.x(u);if(!m)m=C(this.m);else if((0,f.$Ze)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,A.$As)(a.character+1,(0,A.$ys)(m),this.f[a.line],0);if(i)return new v.$tL(a.line,i.startColumn-1,a.line,i.endColumn-1)}}e.$GN=b;class E{constructor(u,m,a){this.a=u,this.b=m,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new v.$tL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new v.$tL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$HN=E}),define(Ce[317],Ie([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(D.$pL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,v,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const R=await k.provideEmbeddingVector(v,$);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,v,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(v,k),new N.$rL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Nhc=f}),define(Ce[70],Ie([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0;let S=E=class{constructor(m,a){this.b=new Map,this.c=new R.$fh,this.a=m.getProxy(D.$pL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const o=i.b.get(r.scheme);return o?(await i.a.$ensureActivation(r.scheme),n=await o.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===N.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return E.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return E.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return E.e(n)}},async writeFile(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(o.impl,o.extUri,o.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(o.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,P.$ke.wrap(n))}catch(o){return E.e(o)}},async delete(r,n){try{const o=i.b.get(r.scheme);return o&&!o.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await o.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(o){return E.e(o)}},async rename(r,n,o){try{return await i.a.$rename(r,n,{overwrite:!1,...o})}catch(t){return E.e(t)}},async copy(r,n,o){try{return await i.a.$copy(r,n,{overwrite:!1,...o})}catch(t){return E.e(t)}},isWritableFileSystem(r){const n=a.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(m,a,i){const r=[];for(;!a.isEqual(i,a.dirname(i));)try{if(!((await m.stat(i)).type&N.FileType.Directory))throw f.$FM.FileExists(`Unable to create folder '${i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(N.$Jk(n)!==N.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(i)),i=a.dirname(i)}for(let n=r.length-1;n>=0;n--){i=a.joinPath(i,r[n]);try{await m.createDirectory(i)}catch(o){if(N.$Jk(o)!==N.FileSystemProviderErrorCode.FileExists)throw o}}}static e(m){if(m instanceof f.$FM)throw m;if(m instanceof N.$Fk)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw f.$FM.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw f.$FM.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw f.$FM.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw f.$FM.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw f.$FM.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw f.$FM.Unavailable(m.message);default:throw new f.$FM(m.message,m.name)}if(!(m instanceof Error))throw new f.$FM(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw f.$FM.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw f.$FM.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw f.$FM.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw f.$FM.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw f.$FM.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw f.$FM.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw f.$FM.Unavailable(m.message);default:throw new f.$FM(m.message,m.name)}}addFileSystemProvider(m,a,i){return this.b.set(m,{impl:a,extUri:i?.isCaseSensitive?C.$zg:C.$Bg,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$zg}};e.$1gc=S,e.$1gc=S=E=Ke([We(0,v.$DN),We(1,$.$Bgc)],S),e.$2gc=(0,A.$9h)("IExtHostConsumerFileSystem")}),define(Ce[318],Ie([1,0,6,7]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=void 0;class f{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(D.$pL.MainThreadIssueReporter)}async $getIssueReporterUri(A,v){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(A);if(!$)throw new Error("Issue request handler not found");const k=await $.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueData(v);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(A);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueTemplate(v);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,v){const $=A.identifier.value;return this.a.set($,v),this.c.$registerIssueUriRequestHandler($),new N.$rL(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(A,v){const $=A.identifier.value;return this.b.set($,v),this.c.$registerIssueDataProvider($),new N.$rL(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$5hc=f}),define(Ce[93],Ie([1,0,5,27,13,70,2]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=void 0,e.$3gc=(0,D.$9h)("IExtensionStoragePaths");let v=class{constructor(k,R,C){this.d=R,this.f=C,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(b=>this.c=b)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,R=await this.g(k);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4gc=v,e.$4gc=v=Ke([We(0,N.$TN),We(1,f.$qj),We(2,P.$2gc)],v)}),define(Ce[319],Ie([1,0,7,20,4]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let P=class{constructor(v){this.a=new D.$PM(D.ColorThemeKind.Dark),this.b=new f.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(v){let $;switch(v){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$PM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$vic=P,e.$vic=P=Ke([We(0,N.$DN)],P)}),define(Ce[71],Ie([1,0,22,4,3,222,5,13,88,6,27,20,7]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fzb=e.$Ezb=e.TunnelDtoConverter=void 0;class E extends $.$Mv{}var S;(function(m){function a(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}m.fromApiTunnel=a;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}m.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Ezb=(0,A.$9h)("IExtHostTunnelService");let u=class extends f.$Tc{constructor(a,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(k.$pL.MainThreadTunnelService)}async openTunnel(a,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,a.displayName);if(r){const n=new E(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,i){const r=this.u();return this.r.set(r,{selector:a,provider:i}),this.a.$registerPortsAttributesProvider(a,r),new b.$rL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(a,i,r,n,o){const t=[];for(const s of a){const d=this.r.get(s);if(!d)return[];t.push(...await Promise.all(i.map(async l=>{let c;try{c=await d.provider.providePortAttributes({port:l,pid:r,commandLine:n},o)}catch{c=await d.provider.providePortAttributes(l,r,n,o)}return{providedAttributes:c,port:l}})))}const h=t.filter(s=>!!s.providedAttributes);return h.length>0?h.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,o)=>await a.provideTunnel(n,o,new D.$7d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,f.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,i){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const r=a.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(o)}}else this.b=void 0;return(0,f.$Rc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,i){if(this.g.has(a.host)){const r=this.g.get(a.host);r.has(a.port)&&(i&&r.get(a.port).disposeListener.dispose(),await r.get(a.port).tunnel.dispose(),r.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(a,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const o=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:n,disposeListener:o}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(a){const i=await Promise.all(a.map(n=>this.f(n.host,n.port,n.detail??""))),r=a.filter((n,o)=>i[o]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$Fzb=u,e.$Fzb=u=Ke([We(0,C.$DN),We(1,R.$TN),We(2,v.$qj)],u)}),define(Ce[16],Ie([1,0,19,21,166,75,63,28,161,56,100,24,18,2,29,83,135,141,139,118,68,89,292,26,7,23]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$CN=e.$BN=e.MarkdownString=e.$AN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var l;(function(Re){function Oe(ie){const{selectionStartLineNumber:Te,selectionStartColumn:ze,positionLineNumber:xe,positionColumn:Qe}=ie,at=new s.$sL(Te-1,ze-1),vt=new s.$sL(xe-1,Qe-1);return new s.$uL(at,vt)}Re.to=Oe;function ye(ie){const{anchor:Te,active:ze}=ie;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Re.from=ye})(l||(e.Selection=l={}));var c;(function(Re){function Oe(ie){if(!ie)return;const{start:Te,end:ze}=ie;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Re.from=Oe;function ye(ie){if(!ie)return;const{startLineNumber:Te,startColumn:ze,endLineNumber:xe,endColumn:Qe}=ie;return new s.$tL(Te-1,ze-1,xe-1,Qe-1)}Re.to=ye})(c||(e.Range=c={}));var p;(function(Re){function Oe(ie){return{uri:ie.uri,range:c.from(ie.range)}}Re.from=Oe;function ye(ie){return new s.$DL(E.URI.revive(ie.uri),c.to(ie.range))}Re.to=ye})(p||(e.Location=p={}));var I;(function(Re){function Oe(ye){switch(ye){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Oe})(I||(e.TokenType=I={}));var w;(function(Re){function Oe(ie){return new s.$sL(ie.lineNumber-1,ie.column-1)}Re.to=Oe;function ye(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Re.from=ye})(w||(e.Position=w={}));var g;(function(Re){function Oe(Te,ze,xe){return(0,D.$Hb)((0,D.$3b)(Te).map(Qe=>ye(Qe,ze,xe)))}Re.from=Oe;function ye(Te,ze,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ie(Te.scheme,ze),pattern:De.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function ie(Te,ze){return ze&&typeof Te=="string"?ze.transformOutgoingScheme(Te):Te}})(g||(e.DocumentSelector=g={}));var y;(function(Re){function Oe(ie){switch(ie){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function ye(ie){switch(ie){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=ye})(y||(e.DiagnosticTag=y={}));var L;(function(Re){function Oe(ie){let Te;return ie.code&&((0,b.$Kf)(ie.code)||(0,b.$Of)(ie.code)?Te=String(ie.code):Te={value:String(ie.code.value),target:ie.code.target}),{...c.from(ie.range),message:ie.message,source:ie.source,code:Te,severity:z.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(F.from),tags:Array.isArray(ie.tags)?(0,D.$Hb)(ie.tags.map(y.from)):void 0}}Re.from=Oe;function ye(ie){const Te=new s.$FL(c.to(ie),ie.message,z.to(ie.severity));return Te.source=ie.source,Te.code=(0,b.$Kf)(ie.code)?ie.code:ie.code?.value,Te.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(F.to),Te.tags=ie.tags&&(0,D.$Hb)(ie.tags.map(y.to)),Te}Re.to=ye})(L||(e.Diagnostic=L={}));var F;(function(Re){function Oe(ie){return{...c.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Re.from=Oe;function ye(ie){return new s.$EL(new s.$DL(ie.resource,c.to(ie)),ie.message)}Re.to=ye})(F||(e.DiagnosticRelatedInformation=F={}));var z;(function(Re){function Oe(ie){switch(ie){case s.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}Re.from=Oe;function ye(ie){switch(ie){case m.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=ye})(z||(e.DiagnosticSeverity=z={}));var j;(function(Re){function Oe(ie){return typeof ie=="number"&&ie>=s.ViewColumn.One?ie-1:ie===s.ViewColumn.Beside?t.$hD:t.$gD}Re.from=Oe;function ye(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=ye})(j||(e.ViewColumn=j={}));function O(Re){return typeof Re.range<"u"}function M(Re){return Re.length===0?!0:!!O(Re[0])}e.$AN=M;var T;(function(Re){function Oe(Qe){return Qe.map(Re.from)}Re.fromMany=Oe;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let at;if(ye(Qe)){const{language:Rt,value:Qt}=Qe;at={value:"```"+Rt+`
`+Qt+"\n```\n"}}else s.$SL.isMarkdownString(Qe)?at={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?at={value:Qe}:at={value:""};const vt=Object.create(null);at.uris=vt;const Kt=Rt=>{try{let Qt=E.URI.parse(Rt,!0);Qt=Qt.with({query:Te(Qt.query,vt)}),vt[Rt]=Qt}catch{}return""},Et=new $.marked.Renderer;return Et.link=Kt,Et.image=Rt=>typeof Rt=="string"?Kt(A.$sk(Rt).href):"",(0,$.marked)(at.value,{renderer:Et}),at}Re.from=ie;function Te(Qe,at){if(!Qe)return Qe;let vt;try{vt=(0,k.$Eh)(Qe)}catch{}if(!vt)return Qe;let Kt=!1;return vt=(0,C.$Bn)(vt,Et=>{if(E.URI.isUri(Et)){const Rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[Rt]=Et,Kt=!0,Rt}else return}),Kt?JSON.stringify(vt):Qe}function ze(Qe){const at=new s.$SL(Qe.value,Qe.supportThemeIcons);return at.isTrusted=Qe.isTrusted,at.supportHtml=Qe.supportHtml,at.baseUri=Qe.baseUri?E.URI.from(Qe.baseUri):void 0,at}Re.to=ze;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Re.from(Qe)}Re.fromStrict=xe})(T||(e.MarkdownString=T={}));function U(Re){return M(Re)?Re.map(Oe=>({range:c.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?T.fromMany(Oe.hoverMessage):Oe.hoverMessage?T.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:c.from(Oe)}))}e.$BN=U;function J(Re){return typeof Re>"u"?Re:typeof Re=="string"?E.URI.file(Re):Re}e.$CN=J;var ne;(function(Re){function Oe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?J(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Re.from=Oe})(ne||(e.ThemableDecorationAttachmentRenderOptions=ne={}));var ee;(function(Re){function Oe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?J(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?ne.from(ye.before):void 0,after:ye.after?ne.from(ye.after):void 0}}Re.from=Oe})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Q;(function(Re){function Oe(ye){if(typeof ye>"u")return ye;switch(ye){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(Q||(e.DecorationRangeBehavior=Q={}));var Y;(function(Re){function Oe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?Q.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?ee.from(ye.light):void 0,dark:ye.dark?ee.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?J(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?ne.from(ye.before):void 0,after:ye.after?ne.from(ye.after):void 0}}Re.from=Oe})(Y||(e.DecorationRenderOptions=Y={}));var ce;(function(Re){function Oe(ie){return{text:ie.newText,eol:ie.newEol&&Ae.from(ie.newEol),range:c.from(ie.range)}}Re.from=Oe;function ye(ie){const Te=new s.$yL(c.to(ie.range),ie.text);return Te.newEol=typeof ie.eol>"u"?void 0:Ae.to(ie.eol),Te}Re.to=ye})(ce||(e.TextEdit=ce={}));var te;(function(Re){function Oe(ie,Te){const ze={edits:[]};if(ie instanceof s.$BL){const xe=new v.$Bc;for(const Qe of ie._allEntries())Qe._type===1&&E.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===1){let at;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?at={type:"base64",value:(0,N.$Ee)(N.$ke.wrap(Qe.options.contents))}:at={type:"dataTransferItem",id:Qe.options.contents._itemId}),ze.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:at},metadata:Qe.metadata})}else Qe._type===2?ze.edits.push({resource:Qe.uri,textEdit:ce.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?ze.edits.push({resource:Qe.uri,textEdit:{range:c.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?ze.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&ze.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Tt.from)}})}return ze}Re.from=Oe;function ye(ie){const Te=new s.$BL,ze=new v.$Ac;for(const xe of ie.edits)if(xe.textEdit){const Qe=xe,at=E.URI.revive(Qe.resource),vt=c.to(Qe.textEdit.range),Kt=Qe.textEdit.text,Et=Qe.textEdit.insertAsSnippet;let Rt;Et?Rt=s.$AL.replace(vt,new s.$CL(Kt)):Rt=s.$yL.replace(vt,Kt);const Qt=ze.get(at);Qt?Qt.push(Rt):ze.set(at,[Rt])}else Te.renameFile(E.URI.revive(xe.oldResource),E.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of ze)Te.set(xe,Qe);return Te}Re.to=ye})(te||(e.WorkspaceEdit=te={}));var fe;(function(Re){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function ye(Te){return typeof Oe[Te]=="number"?Oe[Te]:6}Re.from=ye;function ie(Te){for(const ze in Oe)if(Oe[ze]===Te)return Number(ze);return s.SymbolKind.Property}Re.to=ie})(fe||(e.SymbolKind=fe={}));var re;(function(Re){function Oe(ie){switch(ie){case s.SymbolTag.Deprecated:return 1}}Re.from=Oe;function ye(ie){switch(ie){case 1:return s.SymbolTag.Deprecated}}Re.to=ye})(re||(e.SymbolTag=re={}));var K;(function(Re){function Oe(ie){return{name:ie.name,kind:fe.from(ie.kind),tags:ie.tags&&ie.tags.map(re.from),containerName:ie.containerName,location:de.from(ie.location)}}Re.from=Oe;function ye(ie){const Te=new s.$JL(ie.name,fe.to(ie.kind),ie.containerName,de.to(ie.location));return Te.tags=ie.tags&&ie.tags.map(re.to),Te}Re.to=ye})(K||(e.WorkspaceSymbol=K={}));var B;(function(Re){function Oe(ie){const Te={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:c.from(ie.range),selectionRange:c.from(ie.selectionRange),kind:fe.from(ie.kind),tags:ie.tags?.map(re.from)??[]};return ie.children&&(Te.children=ie.children.map(Oe)),Te}Re.from=Oe;function ye(ie){const Te=new s.$KL(ie.name,ie.detail,fe.to(ie.kind),c.to(ie.range),c.to(ie.selectionRange));return(0,D.$Lb)(ie.tags)&&(Te.tags=ie.tags.map(re.to)),ie.children&&(Te.children=ie.children.map(ye)),Te}Re.to=ye})(B||(e.DocumentSymbol=B={}));var ae;(function(Re){function Oe(ie){const Te=new s.$OL(fe.to(ie.kind),ie.name,ie.detail||"",E.URI.revive(ie.uri),c.to(ie.range),c.to(ie.selectionRange));return Te._sessionId=ie._sessionId,Te._itemId=ie._itemId,Te}Re.to=Oe;function ye(ie,Te,ze){if(Te=Te??ie._sessionId,ze=ze??ie._itemId,Te===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:ze,name:ie.name,detail:ie.detail,kind:fe.from(ie.kind),uri:ie.uri,range:c.from(ie.range),selectionRange:c.from(ie.selectionRange),tags:ie.tags?.map(re.from)}}Re.from=ye})(ae||(e.CallHierarchyItem=ae={}));var Ee;(function(Re){function Oe(ye){return new s.$PL(ae.to(ye.from),ye.fromRanges.map(ie=>c.to(ie)))}Re.to=Oe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var le;(function(Re){function Oe(ye){return new s.$QL(ae.to(ye.to),ye.fromRanges.map(ie=>c.to(ie)))}Re.to=Oe})(le||(e.CallHierarchyOutgoingCall=le={}));var de;(function(Re){function Oe(ie){return{range:ie.range&&c.from(ie.range),uri:ie.uri}}Re.from=Oe;function ye(ie){return new s.$DL(E.URI.revive(ie.uri),c.to(ie.range))}Re.to=ye})(de||(e.location=de={}));var ue;(function(Re){function Oe(ie){const Te=ie,ze=ie;return{originSelectionRange:Te.originSelectionRange?c.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:ze.uri,range:c.from(Te.targetRange?Te.targetRange:ze.range),targetSelectionRange:Te.targetSelectionRange?c.from(Te.targetSelectionRange):void 0}}Re.from=Oe;function ye(ie){return{targetUri:E.URI.revive(ie.uri),targetRange:c.to(ie.range),targetSelectionRange:ie.targetSelectionRange?c.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?c.to(ie.originSelectionRange):void 0}}Re.to=ye})(ue||(e.DefinitionLink=ue={}));var ge;(function(Re){function Oe(ie){return{range:c.from(ie.range),contents:T.fromMany(ie.contents)}}Re.from=Oe;function ye(ie){return new s.$GL(ie.contents.map(T.to),c.to(ie.range))}Re.to=ye})(ge||(e.Hover=ge={}));var V;(function(Re){function Oe(ie){return{range:c.from(ie.range),expression:ie.expression}}Re.from=Oe;function ye(ie){return new s.$AM(c.to(ie.range),ie.expression)}Re.to=ye})(V||(e.EvaluatableExpression=V={}));var Z;(function(Re){function Oe(ie){if(ie instanceof s.$BM)return{type:"text",range:c.from(ie.range),text:ie.text};if(ie instanceof s.$CM)return{type:"variable",range:c.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof s.$DM)return{type:"expression",range:c.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function ye(ie){switch(ie.type){case"text":return{range:c.to(ie.range),text:ie.text};case"variable":return{range:c.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:c.to(ie.range),expression:ie.expression}}}Re.to=ye})(Z||(e.InlineValue=Z={}));var he;(function(Re){function Oe(ie){return{frameId:ie.frameId,stoppedLocation:c.from(ie.stoppedLocation)}}Re.from=Oe;function ye(ie){return new s.$EM(ie.frameId,c.to(ie.stoppedLocation))}Re.to=ye})(he||(e.InlineValueContext=he={}));var be;(function(Re){function Oe(ie){return{range:c.from(ie.range),kind:ie.kind}}Re.from=Oe;function ye(ie){return new s.$HL(c.to(ie.range),ie.kind)}Re.to=ye})(be||(e.DocumentHighlight=be={}));var Pe;(function(Re){function Oe(ie){return{uri:ie.uri,highlights:ie.highlights.map(be.from)}}Re.from=Oe;function ye(ie){return new s.$IL(E.URI.revive(ie.uri),ie.highlights.map(be.to))}Re.to=ye})(Pe||(e.MultiDocumentHighlight=Pe={}));var pe;(function(Re){function Oe(ye){switch(ye){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Oe})(pe||(e.CompletionTriggerKind=pe={}));var Le;(function(Re){function Oe(ye){return{triggerKind:pe.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Re.to=Oe})(Le||(e.CompletionContext=Le={}));var Ne;(function(Re){function Oe(ie){switch(ie){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function ye(ie){switch(ie){case 1:return s.CompletionItemTag.Deprecated}}Re.to=ye})(Ne||(e.CompletionItemTag=Ne={}));var W;(function(Re){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ye(ze){return Oe.get(ze)??9}Re.from=ye;const ie=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(ze){return ie.get(ze)??s.CompletionItemKind.Property}Re.to=Te})(W||(e.CompletionItemKind=W={}));var x;(function(Re){function Oe(ye,ie){const Te=new s.$YL(ye.label);return Te.insertText=ye.insertText,Te.kind=W.to(ye.kind),Te.tags=ye.tags?.map(Ne.to),Te.detail=ye.detail,Te.documentation=A.$mk(ye.documentation)?T.to(ye.documentation):ye.documentation,Te.sortText=ye.sortText,Te.filterText=ye.filterText,Te.preselect=ye.preselect,Te.commitCharacters=ye.commitCharacters,S.$Xs.isIRange(ye.range)?Te.range=c.to(ye.range):typeof ye.range=="object"&&(Te.range={inserting:c.to(ye.range.insert),replacing:c.to(ye.range.replace)}),Te.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Te.insertText=new s.$CL(ye.insertText):(Te.insertText=ye.insertText,Te.textEdit=Te.range instanceof s.$tL?new s.$yL(Te.range,Te.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Te.additionalTextEdits=ye.additionalTextEdits.map(ze=>ce.to(ze))),Te.command=ie&&ye.command?ie.fromInternal(ye.command):void 0,Te}Re.to=Oe})(x||(e.CompletionItem=x={}));var H;(function(Re){function Oe(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:T.fromStrict(ie.documentation)}}Re.from=Oe;function ye(ie){return{label:ie.label,documentation:A.$mk(ie.documentation)?T.to(ie.documentation):ie.documentation}}Re.to=ye})(H||(e.ParameterInformation=H={}));var X;(function(Re){function Oe(ie){return{label:ie.label,documentation:T.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(H.from):[],activeParameter:ie.activeParameter}}Re.from=Oe;function ye(ie){return{label:ie.label,documentation:A.$mk(ie.documentation)?T.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(H.to):[],activeParameter:ie.activeParameter}}Re.to=ye})(X||(e.SignatureInformation=X={}));var oe;(function(Re){function Oe(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(X.from):[]}}Re.from=Oe;function ye(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(X.to):[]}}Re.to=ye})(oe||(e.SignatureHelp=oe={}));var ve;(function(Re){function Oe(ye,ie){const Te=new s.$XL(w.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Me.to.bind(void 0,ye)),ie.kind&&qe.to(ie.kind));return Te.textEdits=ie.textEdits&&ie.textEdits.map(ce.to),Te.tooltip=A.$mk(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,Te.paddingLeft=ie.paddingLeft,Te.paddingRight=ie.paddingRight,Te}Re.to=Oe})(ve||(e.InlayHint=ve={}));var Me;(function(Re){function Oe(ye,ie){const Te=new s.$WL(ie.label);return Te.tooltip=A.$mk(ie.tooltip)?T.to(ie.tooltip):ie.tooltip,u.Command.is(ie.command)&&(Te.command=ye.fromInternal(ie.command)),ie.location&&(Te.location=de.to(ie.location)),Te}Re.to=Oe})(Me||(e.InlayHintLabelPart=Me={}));var qe;(function(Re){function Oe(ie){return ie}Re.from=Oe;function ye(ie){return ie}Re.to=ye})(qe||(e.InlayHintKind=qe={}));var Ge;(function(Re){function Oe(ie){return{range:c.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Re.from=Oe;function ye(ie){let Te;if(ie.url)try{Te=typeof ie.url=="string"?E.URI.parse(ie.url,!0):E.URI.revive(ie.url)}catch{}return new s.$4L(c.to(ie.range),Te)}Re.to=ye})(Ge||(e.DocumentLink=Ge={}));var Ye;(function(Re){function Oe(ie){const Te=new s.$7L(ie.label);return ie.textEdit&&(Te.textEdit=ce.to(ie.textEdit)),ie.additionalTextEdits&&(Te.additionalTextEdits=ie.additionalTextEdits.map(ze=>ce.to(ze))),Te}Re.to=Oe;function ye(ie){return{label:ie.label,textEdit:ie.textEdit?ce.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Te=>ce.from(Te)):void 0}}Re.from=ye})(Ye||(e.ColorPresentation=Ye={}));var it;(function(Re){function Oe(ie){return new s.$5L(ie[0],ie[1],ie[2],ie[3])}Re.to=Oe;function ye(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Re.from=ye})(it||(e.Color=it={}));var ut;(function(Re){function Oe(ie){return{range:c.from(ie.range)}}Re.from=Oe;function ye(ie){return new s.$NL(c.to(ie.range))}Re.to=ye})(ut||(e.SelectionRange=ut={}));var ot;(function(Re){function Oe(ye){switch(ye){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(ot||(e.TextDocumentSaveReason=ot={}));var et;(function(Re){function Oe(ie){switch(ie){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function ye(ie){switch(ie){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=ye})(et||(e.TextEditorLineNumbersStyle=et={}));var Ae;(function(Re){function Oe(ie){if(ie===s.EndOfLine.CRLF)return 1;if(ie===s.EndOfLine.LF)return 0}Re.from=Oe;function ye(ie){if(ie===1)return s.EndOfLine.CRLF;if(ie===0)return s.EndOfLine.LF}Re.to=ye})(Ae||(e.EndOfLine=Ae={}));var ke;(function(Re){function Oe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ke||(e.ProgressLocation=ke={}));var He;(function(Re){function Oe(ie){const Te={start:ie.start+1,end:ie.end+1};return ie.kind&&(Te.kind=_.from(ie.kind)),Te}Re.from=Oe;function ye(ie){const Te={start:ie.start-1,end:ie.end-1};return ie.kind&&(Te.kind=_.to(ie.kind)),Te}Re.to=ye})(He||(e.FoldingRange=He={}));var _;(function(Re){function Oe(ie){if(ie)switch(ie){case s.FoldingRangeKind.Comment:return u.$Nt.Comment;case s.FoldingRangeKind.Imports:return u.$Nt.Imports;case s.FoldingRangeKind.Region:return u.$Nt.Region}}Re.from=Oe;function ye(ie){if(ie)switch(ie.value){case u.$Nt.Comment.value:return s.FoldingRangeKind.Comment;case u.$Nt.Imports.value:return s.FoldingRangeKind.Imports;case u.$Nt.Region.value:return s.FoldingRangeKind.Region}}Re.to=ye})(_||(e.FoldingRangeKind=_={}));var se;(function(Re){function Oe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?c.from(ye.selection):void 0,override:typeof ye.override=="boolean"?i.$JE.id:void 0}}Re.from=Oe})(se||(e.TextEditorOpenOptions=se={}));var De;(function(Re){function Oe(ze){return ze instanceof s.$oM?ze.toJSON():typeof ze=="string"?ze:ye(ze)||ie(ze)?new s.$oM(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Re.from=Oe;function ye(ze){const xe=ze;return xe?E.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ie(ze){const xe=ze;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(ze){return typeof ze=="string"?ze:new s.$oM(E.URI.revive(ze.baseUri),ze.pattern)}Re.to=Te})(De||(e.GlobPattern=De={}));var Ve;(function(Re){function Oe(ye){if(ye){if(Array.isArray(ye))return ye.map(Oe);if(typeof ye=="string")return ye;{const ie=ye;return{language:ie.language,scheme:ie.scheme,pattern:De.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Re.from=Oe})(Ve||(e.LanguageSelector=Ve={}));var Xe;(function(Re){function Oe(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Te=>Array.isArray(Te)&&Te.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&E.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(xe=>xe instanceof s.$tL)))}Re.is=Oe;function ye(ie){return{documents:ie.documents.map(Te=>Te.map(ze=>({uri:E.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(xe=>c.from(xe))})))}}Re.from=ye})(Xe||(e.MappedEditsContext=Xe={}));var nt;(function(Re){function Oe(ie){return{start:ie.start,end:ie.end}}Re.from=Oe;function ye(ie){return new s.$QM(ie.start,ie.end)}Re.to=ye})(nt||(e.NotebookRange=nt={}));var rt;(function(Re){function Oe(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Re.to=Oe;function ye(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Re.from=ye})(rt||(e.NotebookCellExecutionSummary=rt={}));var je;(function(Re){function Oe(ye){if(ye===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ye===r.NotebookCellExecutionState.Pending)return;if(ye===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Re.to=Oe})(je||(e.NotebookCellExecutionState=je={}));var yt;(function(Re){function Oe(ie){switch(ie){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Re.from=Oe;function ye(ie){switch(ie){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=ye})(yt||(e.NotebookCellKind=yt={}));var kt;(function(Re){function Oe(ie){const Te={metadata:ie.metadata??Object.create(null),cells:[]};for(const ze of ie.cells)s.$RM.validate(ze),Te.cells.push(Tt.from(ze));return Te}Re.from=Oe;function ye(ie){const Te=new s.$SM(ie.cells.map(Tt.to));return(0,b.$Xf)(ie.metadata)||(Te.metadata=ie.metadata),Te}Re.to=ye})(kt||(e.NotebookData=kt={}));var Tt;(function(Re){function Oe(ie){return{cellKind:yt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:rt.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(St.from):[]}}Re.from=Oe;function ye(ie){return new s.$RM(yt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(St.to):void 0,ie.metadata,ie.internalMetadata?rt.to(ie.internalMetadata):void 0)}Re.to=ye})(Tt||(e.NotebookCellData=Tt={}));var Mt;(function(Re){function Oe(ie){return{mime:ie.mime,valueBytes:N.$ke.wrap(ie.data)}}Re.from=Oe;function ye(ie){return new s.$TM(ie.valueBytes.buffer,ie.mime)}Re.to=ye})(Mt||(e.NotebookCellOutputItem=Mt={}));var St;(function(Re){function Oe(ie){return{outputId:ie.id,items:ie.items.map(Mt.from),metadata:ie.metadata}}Re.from=Oe;function ye(ie){const Te=ie.items.map(Mt.to);return new s.$UM(Te,ie.outputId,ie.metadata)}Re.to=ye})(St||(e.NotebookCellOutput=St={}));var ei;(function(Re){function Oe(Te){return ie(Te)?{include:De.from(Te.include)??void 0,exclude:De.from(Te.exclude)??void 0}:De.from(Te)??void 0}Re.from=Oe;function ye(Te){return ie(Te)?{include:De.to(Te.include),exclude:De.to(Te.exclude)}:De.to(Te)}Re.to=ye;function ie(Te){const ze=Te;return ze?!(0,b.$Tf)(ze.include)&&!(0,b.$Tf)(ze.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var Vt;(function(Re){function Oe(ye,ie,Te){const ze=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(ze,Te),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Re.from=Oe})(Vt||(e.NotebookStatusBarItem=Vt={}));var ni;(function(Re){function Oe(ye,ie,Te){const ze=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ie.toInternal(ze,Te),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Re.from=Oe})(ni||(e.NotebookKernelSourceAction=ni={}));var Zt;(function(Re){function Oe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Re.from=Oe})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Yt;(function(Re){function Oe(ie){return{uri:ie.uri,provides:ie.provides}}Re.from=Oe;function ye(ie){return new s.$WM(E.URI.revive(ie.uri),ie.provides)}Re.to=ye})(Yt||(e.NotebookRendererScript=Yt={}));var _e;(function(Re){function Oe(ie){return{message:T.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:c.from(ie.location.range),uri:ie.location.uri}}}Re.from=Oe;function ye(ie){const Te=new s.$3M(typeof ie.message=="string"?ie.message:T.to(ie.message));return Te.actualOutput=ie.actual,Te.expectedOutput=ie.expected,Te.contextValue=ie.contextValue,Te.location=ie.location?de.to(ie.location):void 0,Te}Re.to=ye})(_e||(e.TestMessage=_e={}));var Ht;(function(Re){Re.namespace=o.$kK,Re.denamespace=o.$lK})(Ht||(e.TestTag=Ht={}));var ti;(function(Re){function Oe(ie){const Te=(0,a.$zN)(ie).controllerId;return{extId:n.$gK.fromExtHostTestItem(ie,Te).toString(),label:ie.label,uri:E.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(ze=>Ht.namespace(Te,ze.id)),range:S.$Xs.lift(c.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&T.fromStrict(ie.error)||null}}Re.from=Oe;function ye(ie){return{parent:void 0,error:void 0,id:n.$gK.fromString(ie.extId).localId,label:ie.label,uri:E.URI.revive(ie.uri),tags:(ie.tags||[]).map(Te=>{const{tagId:ze}=Ht.denamespace(Te);return new s.$4M(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Re.toPlain=ye})(ti||(e.TestItem=ti={})),function(Re){function Oe(ie){return{id:ie.id}}Re.from=Oe;function ye(ie){return new s.$4M(ie.id)}Re.to=ye}(Ht||(e.TestTag=Ht={}));var dt;(function(Re){const Oe=(ie,Te)=>{const ze=[];for(const[Qe,at]of Te)n.$gK.compare(at.item.extId,Qe)===2&&(Te.delete(Qe),ze.push(at));const xe={...ti.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(at=>at.type===0).map(_e.to)})),children:ze.map(Qe=>Oe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function ye(ie){const Te=[],ze=new Map;for(const xe of ie.items){ze.set(xe.item.extId,xe);const Qe=n.$gK.root(xe.item.extId);ie.request.targets.some(at=>at.controllerId===Qe&&at.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:ie.completedAt,results:Te.map(xe=>Oe(xe,ze))}}Re.to=ye})(dt||(e.TestResults=dt={}));var $t;(function(Re){function Oe(ze){return{covered:ze.covered,total:ze.total}}function ye(ze){return"line"in ze?w.from(ze):c.from(ze)}function ie(ze){return"branches"in ze?{count:ze.executed,location:ye(ze.location),type:1,branches:ze.branches.length?ze.branches.map(xe=>({count:xe.executed,location:xe.location&&ye(xe.location),label:xe.label})):void 0}:{type:0,name:ze.name,count:ze.executed,location:ye(ze.location)}}Re.fromDetailed=ie;function Te(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),declaration:ze.declarationCoverage&&Oe(ze.declarationCoverage),details:ze.detailedCoverage?.map(ie)}}Re.fromFile=Te})($t||(e.TestCoverage=$t={}));var Jt;(function(Re){function Oe(ye){switch(ye){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Jt||(e.CodeActionTriggerKind=Jt={}));var ii;(function(Re){function Oe(ie){const Te=new s.$0M(fe.to(ie.kind),ie.name,ie.detail||"",E.URI.revive(ie.uri),c.to(ie.range),c.to(ie.selectionRange));return Te._sessionId=ie._sessionId,Te._itemId=ie._itemId,Te}Re.to=Oe;function ye(ie,Te,ze){if(Te=Te??ie._sessionId,ze=ze??ie._itemId,Te===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:ze,kind:fe.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:c.from(ie.range),selectionRange:c.from(ie.selectionRange),tags:ie.tags?.map(re.from)}}Re.from=ye})(ii||(e.TypeHierarchyItem=ii={}));var At;(function(Re){function Oe(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Re.from=Oe})(At||(e.ViewBadge=At={}));var ft;(function(Re){function Oe(ze,xe,Qe){const at=xe.fileData;return at?new s.$hM(new s.$iM(at.name,E.URI.revive(at.uri),at.id,(0,P.$db)(()=>Qe(at.id)))):ze===R.$is.uriList&&xe.uriListData?new s.$gM(Te(xe.uriListData)):new s.$gM(xe.asString)}Re.to=Oe;async function ye(ze,xe){const Qe=await xe.asString();if(ze===R.$is.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const at=xe.asFile();return{asString:Qe,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}Re.from=ye;function ie(ze){return f.$ut.split(ze).map(xe=>{if(xe.startsWith("#"))return xe;try{return E.URI.parse(xe)}catch{}return xe})}function Te(ze){return f.$ut.create(ze.map(xe=>typeof xe=="string"?xe:E.URI.revive(xe)))}})(ft||(e.DataTransferItem=ft={}));var Nt;(function(Re){function Oe(ie,Te){const ze=ie.items.map(([xe,Qe])=>[xe,ft.to(xe,Qe,Te)]);return new s.$jM(ze)}Re.toDataTransfer=Oe;async function ye(ie){const Te={items:[]},ze=[];for(const[xe,Qe]of ie)ze.push((async()=>{Te.items.push([xe,await ft.from(xe,Qe)])})());return await Promise.all(ze),Te}Re.from=ye})(Nt||(e.DataTransfer=Nt={}));var oi;(function(Re){function Oe(ye){return{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Re.from=Oe})(oi||(e.ChatFollowup=oi={}));var Ft;(function(Re){function Oe(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Re.from=Oe})(Ft||(e.ChatInlineFollowup=Ft={}));var Je;(function(Re){function Oe(ie){return new s.$jN(jt.to(ie.role),ie.content)}Re.to=Oe;function ye(ie){return{role:jt.from(ie.role),content:ie.content}}Re.from=ye})(Je||(e.ChatMessage=Je={}));var jt;(function(Re){function Oe(ie){switch(ie){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant}}Re.to=Oe;function ye(ie){switch(ie){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.User:default:return 1}}Re.from=ye})(jt||(e.ChatMessageRole=jt={}));var Ut;(function(Re){function Oe(Te){const ze={};for(const xe of Object.keys(Te))ze[xe]=Te[xe].map(Re.to);return ze}Re.objectTo=Oe;function ye(Te){return{level:xt.to(Te.level),kind:Te.kind,value:(0,E.$vc)(Te.value)?E.URI.revive(Te.value):Te.value,description:Te.description}}Re.to=ye;function ie(Te){return{level:xt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Re.from=ie})(Ut||(e.ChatVariable=Ut={}));var xt;(function(Re){function Oe(ie){switch(ie){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Re.to=Oe;function ye(ie){switch(ie){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Re.from=ye})(xt||(e.ChatVariableLevel=xt={}));var gt;(function(Re){function Oe(ye){switch(ye){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=Oe})(gt||(e.InteractiveEditorResponseFeedbackKind=gt={}));var zt;(function(Re){function Oe(ie){return{kind:"markdownContent",content:T.from(new s.$SL().appendText(ie.value))}}Re.to=Oe;function ye(ie){return new s.$kN(ie.content.value)}Re.from=ye})(zt||(e.ChatResponseTextPart=zt={}));var Lt;(function(Re){function Oe(ie){return{kind:"markdownContent",content:T.from(ie.value)}}Re.to=Oe;function ye(ie){return new s.$lN(T.to(ie.content))}Re.from=ye})(Lt||(e.ChatResponseMarkdownPart=Lt={}));var Bt;(function(Re){function Oe(ie){const{value:Te,baseUri:ze}=ie;function xe(Qe,at){return Qe.map(vt=>{const Kt=E.URI.joinPath(at,vt.name);return{label:vt.name,uri:Kt,children:vt.children&&xe(vt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,d.$Gg)(ze),uri:ze,children:xe(Te,ze)}}}Re.to=Oe;function ye(ie){const Te=(0,k.$Fh)(ie.treeData);function ze(at){return at.map(vt=>({name:vt.label,children:vt.children&&ze(vt.children)}))}const xe=Te.uri,Qe=Te.children?ze(Te.children):[];return new s.$mN(Qe,xe)}Re.from=ye})(Bt||(e.ChatResponseFilesPart=Bt={}));var Gt;(function(Re){function Oe(ie){return{kind:"inlineReference",name:ie.title,inlineReference:E.URI.isUri(ie.value)?ie.value:p.from(ie.value)}}Re.to=Oe;function ye(ie){const Te=(0,k.$Fh)(ie);return new s.$nN(E.URI.isUri(Te.inlineReference)?Te.inlineReference:p.to(Te.inlineReference),ie.name)}Re.from=ye})(Gt||(e.ChatResponseAnchorPart=Gt={}));var Wt;(function(Re){function Oe(ie){return{kind:"progressMessage",content:T.from(ie.value)}}Re.to=Oe;function ye(ie){return new s.$oN(ie.content.value)}Re.from=ye})(Wt||(e.ChatResponseProgressPart=Wt={}));var It;(function(Re){function Oe(ie,Te,ze){return{kind:"command",command:Te.toInternal(ie.value,ze)??{command:ie.value.command,title:ie.value.title}}}Re.to=Oe;function ye(ie,Te){return new s.$pN(Te.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Re.from=ye})(It||(e.ChatResponseCommandButtonPart=It={}));var qt;(function(Re){function Oe(ie){return{kind:"reference",reference:E.URI.isUri(ie.value)?ie.value:p.from(ie.value)}}Re.to=Oe;function ye(ie){const Te=(0,k.$Fh)(ie);return new s.$qN(E.URI.isUri(Te.reference)?Te.reference:p.to(Te.reference))}Re.from=ye})(qt||(e.ChatResponseReferencePart=qt={}));var Dt;(function(Re){function Oe(ie){return ie instanceof s.$lN?Lt.to(ie):ie instanceof s.$nN?Gt.to(ie):ie instanceof s.$qN?qt.to(ie):ie instanceof s.$oN?Wt.to(ie):ie instanceof s.$mN?Bt.to(ie):{kind:"content",content:""}}Re.to=Oe;function ye(ie,Te){switch(ie.kind){case"markdownContent":return Lt.from(ie);case"inlineReference":return Gt.from(ie);case"reference":return qt.from(ie);case"progressMessage":return Wt.from(ie);case"treeData":return Bt.from(ie);case"command":return It.from(ie,Te)}}Re.from=ye})(Dt||(e.ChatResponsePart=Dt={}));var pt;(function(Re){function Oe(Te,ze){return"markdownContent"in ze?((0,h.$MF)(Te,"chatAgents2Additions"),{content:T.from(ze.markdownContent),kind:"markdownContent"}):"content"in ze?"vulnerabilities"in ze&&ze.vulnerabilities?((0,h.$MF)(Te,"chatAgents2Additions"),{content:ze.content,vulnerabilities:ze.vulnerabilities,kind:"vulnerability"}):typeof ze.content=="string"?{content:ze.content,kind:"content"}:((0,h.$MF)(Te,"chatAgents2Additions"),{content:T.from(ze.content),kind:"markdownContent"}):"documents"in ze?{documents:ze.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Qe=>c.from(Qe))})),kind:"usedContext"}:"reference"in ze?{reference:"uri"in ze.reference?{uri:ze.reference.uri,range:c.from(ze.reference.range)}:ze.reference,kind:"reference"}:"inlineReference"in ze?{inlineReference:"uri"in ze.inlineReference?{uri:ze.inlineReference.uri,range:c.from(ze.inlineReference.range)}:ze.inlineReference,name:ze.title,kind:"inlineReference"}:"agentName"in ze?((0,h.$MF)(Te,"chatAgents2Additions"),{agentName:ze.agentName,command:ze.command,kind:"agentDetection"}):"message"in ze?{content:T.from(ze.message),kind:"progressMessage"}:void 0}Re.from=Oe;function ye(Te){switch(Te.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(Te);case"content":return{content:Te.content};case"usedContext":return{documents:Te.documents.map(ze=>({uri:E.URI.revive(ze.uri),version:ze.version,ranges:ze.ranges.map(xe=>c.to(xe))}))};case"reference":return{reference:(0,E.$vc)(Te.reference)?E.URI.revive(Te.reference):p.to(Te.reference)};case"agentDetection":return;case"progressMessage":return{message:Te.content.value};case"vulnerability":return{content:Te.content,vulnerabilities:Te.vulnerabilities};default:return}}Re.to=ye;function ie(Te,ze){switch(Te.kind){case"markdownContent":return{content:Te.content.value};case"inlineReference":return{inlineReference:(0,E.$vc)(Te.inlineReference)?E.URI.revive(Te.inlineReference):p.to(Te.inlineReference),title:Te.name};case"command":return{command:ze.fromInternal(Te.command)??{command:Te.command.id,title:Te.command.title}};default:return}}Re.toProgressContent=ie})(pt||(e.ChatResponseProgress=pt={}));var Pt;(function(Re){function Oe(ye){return{prompt:ye.message,prompt2:ye.variables2.message,variables:Ut.objectTo(ye.variables),command:ye.command,agentId:ye.agentId,variables2:ye.variables2.variables.map(Ct.to)}}Re.to=Oe})(Pt||(e.ChatAgentRequest=Pt={}));var Ct;(function(Re){function Oe(ye){return{name:ye.name,range:[ye.range.start,ye.range.endExclusive],values:ye.values.map(Ut.to)}}Re.to=Oe})(Ct||(e.ChatAgentResolvedVariable=Ct={}));var li;(function(Re){function Oe(ye){return{label:ye.label,values:ye.values.map(Ut.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Re.from=Oe})(li||(e.ChatAgentCompletionItem=li={}));var Xt;(function(Re){function Oe(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Re.to=Oe})(Xt||(e.ChatAgentResult=Xt={}));var bi;(function(Re){function Oe(ye,ie,Te){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:ie.toInternal(ye,Te)}Re.from=Oe})(bi||(e.TerminalQuickFix=bi={}))}),define(Ce[320],Ie([1,0,6,20,16]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;let P=class{constructor(v,$){this.a=v.getProxy(D.$pL.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>$.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,$,k){const R=f.WorkspaceEdit.from(v,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,k?.isRefactoring??!1)}};e.$Kgc=P,e.$Kgc=P=Ke([We(0,N.$DN)],P)}),define(Ce[321],Ie([1,0,19,8,44,4,63,3,38,2,211,6,16,7,281,26]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class m{constructor(n,o,t,h,s,d){this.i=n,this.j=o,this.k=t,this.l=h,this.m=s,this.n=d,this.a=$.$Sd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let o=function(h){if(n.b){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,h),s}};const n=this;this.a.reset();const t=h=>{typeof this.d>"u"&&"content"in h&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,h)};this.g={text(h){return o(this.text),this.markdown(new A.$kk().appendText(h)),this},markdown(h){o(this.markdown);const s=new E.$lN(h),d=b.ChatResponseMarkdownPart.to(s);return t(d),this},filetree(h,s){o(this.filetree);const d=new E.$mN(h,s),l=b.ChatResponseFilesPart.to(d);return t(l),this},anchor(h,s){o(this.anchor);const d=new E.$nN(h,s),l=b.ChatResponseAnchorPart.to(d);return t(l),this},button(h){o(this.anchor);const s=new E.$pN(h),d=b.ChatResponseCommandButtonPart.to(s,n.m,n.n);return t(d),this},progress(h){o(this.progress);const s=new E.$oN(h),d=b.ChatResponseProgressPart.to(s);return t(d),this},reference(h){o(this.reference);const s=new E.$qN(h),d=b.ChatResponseReferencePart.to(s);return t(d),this},push(h){o(this.push);const s=b.ChatResponsePart.to(h);return t(s),this},report(h){if(o(this.report),"placeholder"in h&&"resolvedContent"in h)return;const s=b.ChatResponseProgress.from(n.i,h);if(!s){n.l.error("Unknown progress type: "+JSON.stringify(h));return}return t(s),this}}}return this.g}}class a{static{this.a=0}constructor(n,o,t,h){this.i=o,this.j=t,this.k=h,this.b=new Map,this.g=new v.$3c,this.d=n.getProxy(C.$pL.MainThreadChatAgents2)}createChatAgent(n,o,t){const h=a.a++,s=new i(n,o,this.d,h,t);return this.b.set(h,s),this.d.$registerAgent(h,o,{}),s.apiAgent}async $invokeAgent(n,o,t,h){const s=this.b.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);this.i.$updateAccesslist([{extension:s.extension.identifier,enabled:!0}]);let d=this.g.get(o.sessionId);d||(d=new v.$Sc,this.g.set(o.sessionId,d));const l=new m(s.extension,o,this.d,this.j,this.k.converter,d);try{const c=await this.l(o,t),p=await this.m(o,t),I=s.invoke(b.ChatAgentRequest.to(o),{history:c,history2:p},l.apiObject,h);return await(0,N.$Wg)(Promise.resolve(I).then(w=>{if(w?.metadata)try{JSON.stringify(w.metadata)}catch(g){const y=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.j.error(`[${s.extension.identifier.value}] [@${s.id}] ${y}`,s.extension),{errorDetails:{message:y},timings:l.timings}}return{errorDetails:w?.errorDetails,timings:l.timings,metadata:w?.metadata}}),h)}catch(c){return this.j.error(c,s.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,f.$Ti)(c)),responseIsIncomplete:!0}}}finally{l.close(),this.i.$updateAccesslist([{extension:s.extension.identifier,enabled:!1}])}}async l(n,o){return(0,D.$Hb)(await Promise.all(o.history.map(async t=>{const h=b.ChatAgentResult.to(t.result),s=n.agentId===t.request.agentId?h:{...h,metadata:void 0};return{request:b.ChatAgentRequest.to(t.request),response:(0,D.$Hb)(t.response.map(d=>b.ChatResponsePart.from(d,this.k.converter))),result:s}})))}async m(n,o){const t=[];for(const h of o.history){const s=b.ChatAgentResult.to(h.result),d=n.agentId===h.request.agentId?s:{...s,metadata:void 0};t.push(new E.$rN(h.request.message,h.request.agentId,h.request.command,h.request.variables2.variables.map(b.ChatAgentResolvedVariable.to)));const l=(0,D.$Hb)(h.response.map(c=>b.ChatResponsePart.from(c,this.k.converter)));t.push(new E.$sN(l,d,h.request.agentId))}return t}$releaseSession(n){this.g.deleteAndDispose(n)}async $provideSlashCommands(n,o){const t=this.b.get(n);return t?t.provideSlashCommands(o):[]}$provideFollowups(n,o,t){const h=this.b.get(n);if(!h)return Promise.resolve([]);const s=b.ChatAgentResult.to(o);return h.provideFollowups(s,t)}$acceptFeedback(n,o,t,h){const s=this.b.get(n);if(!s)return;const d=b.ChatAgentResult.to(o);let l;switch(t){case S.InteractiveSessionVoteDirection.Down:l=E.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:l=E.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(h?{result:d,kind:l,reportIssue:h}:{result:d,kind:l}))}$acceptAction(n,o,t){const h=this.b.get(n);if(!h||t.action.kind==="vote")return;const s=b.ChatAgentResult.to(o);if(t.action.kind==="command"){const d={kind:"command",commandButton:b.ChatResponseProgress.toProgressContent(t.action.commandButton,this.k.converter)};h.acceptAction(Object.freeze({action:d,result:s}));return}else h.acceptAction(Object.freeze({action:t.action,result:s}))}async $invokeCompletionProvider(n,o,t){const h=this.b.get(n);return h?(await h.invokeCompletionProvider(o,t)).map(b.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(n,o){const t=this.b.get(n);if(t)return await t.provideWelcomeMessage(o)}async $provideSampleQuestions(n,o){const t=this.b.get(n);if(t)return await t.provideSampleQuestions(o)}}e.$Ngc=a;class i{constructor(n,o,t,h,s){this.extension=n,this.id=o,this.u=t,this.w=h,this.x=s,this.o=new P.$Wd,this.p=new P.$Wd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.p.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async provideSlashCommands(n){if(!this.a)return[];const o=await this.a.provideCommands(n);return o?o.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest})):[]}async provideFollowups(n,o){if(!this.b)return[];const t=await this.b.provideFollowups(n,o);return t?t.filter(h=>!(h&&"commandId"in h)).map(h=>b.ChatFollowup.from(h)):[]}async provideWelcomeMessage(n){if(!this.t)return[];const o=await this.t.provideWelcomeMessage(n);return o?o.map(t=>typeof t=="string"?t:b.MarkdownString.from(t)):[]}async provideSampleQuestions(n){if(!this.t||!this.t.provideSampleQuestions)return[];const o=await this.t.provideSampleQuestions(n);return o?o?.map(t=>b.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const t=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof k.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof E.$mM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:b.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:b.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),o=!1}))},h=this;return{get name(){return h.id},get description(){return h.d??""},set description(s){h.d=s,t()},get fullName(){return h.g??h.extension.displayName??h.extension.name},set fullName(s){h.g=s,t()},get iconPath(){return h.i},set iconPath(s){h.i=s,t()},get commandProvider(){return h.a},set commandProvider(s){h.a=s,t()},get followupProvider(){return h.b},set followupProvider(s){h.b=s,t()},get isDefault(){return(0,u.$MF)(h.extension,"defaultChatAgent"),h.j},set isDefault(s){(0,u.$MF)(h.extension,"defaultChatAgent"),h.j=s,t()},get helpTextPrefix(){return(0,u.$MF)(h.extension,"defaultChatAgent"),h.k},set helpTextPrefix(s){if((0,u.$MF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPrefix is only available on the default chat agent");h.k=s,t()},get helpTextPostfix(){return(0,u.$MF)(h.extension,"defaultChatAgent"),h.l},set helpTextPostfix(s){if((0,u.$MF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPostfix is only available on the default chat agent");h.l=s,t()},get isSecondary(){return(0,u.$MF)(h.extension,"defaultChatAgent"),h.n},set isSecondary(s){(0,u.$MF)(h.extension,"defaultChatAgent"),h.n=s,t()},get sampleRequest(){return h.m},set sampleRequest(s){h.m=s,t()},get supportIssueReporting(){return(0,u.$MF)(h.extension,"chatAgents2Additions"),h.q},set supportIssueReporting(s){(0,u.$MF)(h.extension,"chatAgents2Additions"),h.q=s,t()},get onDidReceiveFeedback(){return h.o.event},set agentVariableProvider(s){if(h.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");h.u.$registerAgentCompletionsProvider(h.w,s.triggerCharacters)}else h.u.$unregisterAgentCompletionsProvider(h.w)},get agentVariableProvider(){return h.s},set welcomeMessageProvider(s){h.t=s,t()},get welcomeMessageProvider(){return h.t},onDidPerformAction:(0,u.$LF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){n=!0,h.a=void 0,h.b=void 0,h.o.dispose(),h.u.$unregisterAgent(h.w)}}}invoke(n,o,t,h){return this.x(n,o,t,h)}}}),define(Ce[322],Ie([1,0,22,3,6,16,107,25,8,4,212,142]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class b{constructor(m,a){this.option=m,this.stream=new $.$zh,this.stream=a??new $.$zh}}class E{constructor(m,a){this.cts=a,this.a=new Map,this.b=new $.$zh,this.c=!1;const i=this;this.apiObject={result:m,stream:i.b.asyncIterable},m.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,r]of this.a)r.stream.resolve();else this.b.resolve()})}handleFragment(m){if(this.c)return;let a=this.a.get(m.index);a||(this.a.size===0?a=new b(m.index,this.b):a=new b(m.index),this.a.set(m.index,a)),a.stream.emitOne(m.part)}}class S{static{this.a=1}constructor(m,a,i){this.j=a,this.k=i,this.c=new k.$Wd,this.d=new k.$Wd,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new v.$qm,this.i=new Map,this.b=m.getProxy(f.$pL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(m,a,i,r){const n=S.a++;return this.f.set(n,{extension:m,provider:i}),this.b.$registerProvider(n,a,{extension:m,model:r.name??""}),(0,N.$Rc)(()=>{this.f.delete(n),this.b.$unregisterProvider(n)})}async $provideLanguageModelResponse(m,a,i,r,n,o){const t=this.f.get(m);if(!t)return;const h=new A.$yv(async s=>{if(o.isCancellationRequested){this.j.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:s.index,part:s.part})});return t.provider.provideLanguageModelResponse(r.map(P.ChatMessage.to),n,v.$om.toKey(i),h,o)}$updateLanguageModels(m){const a=[],i=[];if(m.added)for(const r of m.added)this.g.add(r),a.push(r);if(m.removed)for(const r of m.removed){this.g.delete(r),i.push(r);for(const[n,o]of this.i)o.languageModelId===r&&(o.res.cts.cancel(),this.i.delete(n))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.g)}$updateAccesslist(m){const a=new v.$pm;for(const{extension:i,enabled:r}of m)this.h.get(i)!==r&&(this.h.set(i,r),a.add(i));this.c.fire(a)}async requestLanguageModelAccess(m,a,i){const r=m.identifier;if(this.h.get(r)===!1)throw new Error("Extension is NOT allowed to make chat requests");const n=i?.justification,o=await this.b.$prepareChatAccess(r,a,n);if(!o)throw this.h.get(r)?new Error(`Language model '${a}' NOT found`):new Error("Extension is NOT allowed to make chat requests");await this.l(m,a,n);const t=this;return{get model(){return o.model},get isRevoked(){return!t.h.get(r)||!t.g.has(a)},get onDidChangeAccess(){const h=k.Event.filter(t.c.event,d=>d.has(r)),s=k.Event.filter(t.d.event,d=>d.removed.includes(a));return k.Event.signal(k.Event.any(h,s))},makeChatRequest(h,s,d){if(!t.h.get(r))throw new Error("Access to chat has been revoked");if(!t.g.has(a))throw new Error("Language Model has been removed");const l=new D.$7d(d),c=Math.random()*1e6|0,p=t.b.$fetchResponse(r,a,c,h.map(P.ChatMessage.from),s??{},l.token),I=new E(p,l);return t.i.set(c,{languageModelId:a,res:I}),p.finally(()=>{t.i.delete(c),l.dispose()}),I.apiObject}}}async $handleResponseFragment(m,a){const i=this.i.get(m);i&&i.res.handleFragment(a)}async l(m,a,i){const r=C.$vK+a;if(!await this.k.getSession(m,r,[],{silent:!0}))try{await this.k.getSession(m,r,[],{forceNewSession:{detail:i??(0,R.localize)(0,null,a)}})}catch{throw new Error("Access to language model has not been granted")}}}e.$Mgc=S}),define(Ce[323],Ie([1,0,3,6,14,16]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class A{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(N.$pL.MainThreadChatVariables)}async $resolveVariable($,k,R){const C=this.b.get($);if(C)try{const b=await C.resolver.resolve(C.data.name,{prompt:k},R);if(b)return b.map(P.ChatVariable.from)}catch(b){(0,f.$2)(b)}}registerVariableResolver($,k,R,C){const b=A.a++;return this.b.set(b,{extension:$.identifier,data:{name:k,description:R},resolver:C}),this.c.$registerVariable(b,{name:k,description:R}),(0,D.$Rc)(()=>{this.b.delete(b),this.c.$unregisterVariable(b)})}}e.$Ogc=A}),define(Ce[324],Ie([1,0,8,52,4,3,2,83,25,16,7,6,26]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;function E(S,u,m){const a=S.getProxy(C.$pL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$qm,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const p=this.b.get(c.handle);return p?p.value:c}else if(c&&c.$mid===7){const p=this.b.get(c.commentControlHandle);if(!p)return c;const I=p.getCommentThread(c.commentThreadHandle);return I?I.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const p=this.b.get(c.thread.commentControlHandle);if(!p)return c;const I=p.getCommentThread(c.thread.commentThreadHandle);return I?c.$mid===8?I.value:{thread:I.value,text:c.text}:c}else if(c&&c.$mid===10){const p=this.b.get(c.thread.commentControlHandle);if(!p)return c;const I=p.getCommentThread(c.thread.commentThreadHandle);if(!I)return c;const w=c.commentUniqueId,g=I.getCommentByUniqueId(w);return g||c}else if(c&&c.$mid===11){const p=this.b.get(c.thread.commentControlHandle);if(!p)return c;const I=p.getCommentThread(c.thread.commentThreadHandle);if(!I)return c;const w=c.text,g=c.commentUniqueId,y=I.getCommentByUniqueId(g);return y?(typeof y.body=="string"?y.body=w:y.body=new R.$SL(w),y):c}return c}})}createCommentController(c,p,I){const w=i.a++,g=new n(c,w,p,I);this.b.set(g.handle,g);const y=this.c.get(c.identifier)||[];return y.push(g),this.c.set(c.identifier,y),g.value}async $createCommentThreadTemplate(c,p,I){const w=this.b.get(c);w&&w.$createCommentThreadTemplate(p,I)}async $setActiveComment(c,p){const I=this.b.get(c);I&&I.$setActiveComment(p??void 0)}async $updateCommentThreadTemplate(c,p,I){const w=this.b.get(c);w&&w.$updateCommentThreadTemplate(p,I)}$deleteCommentThread(c,p){this.b.get(c)?.$deleteCommentThread(p)}$provideCommentingRanges(c,p,I){const w=this.b.get(c);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const g=m.getDocument(A.URI.revive(p));return(0,D.$1g)(async()=>{const y=await w.commentingRangeProvider.provideCommentingRanges(g,I);let L;return Array.isArray(y)?L={ranges:y,fileComments:!1}:y?L={ranges:y.ranges||[],fileComments:y.fileComments||!1}:L=y??void 0,L}).then(y=>{let L;return y&&(L={ranges:y.ranges.map(F=>k.Range.from(F)),fileComments:y.fileComments}),L})}$toggleReaction(c,p,I,w,g){const y=this.b.get(c);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,D.$1g)(()=>{const L=y.getCommentThread(p);if(L){const F=L.getCommentByUniqueId(w.uniqueIdInThread);if(y!==void 0&&F&&y.reactionHandler)return y.reactionHandler(F,h(g))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){(c===void 0!=(this.p===void 0)||!c||!this.p||!c.isEqual(this.p))&&(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,p,I,w,g,y,L,F){this.m=p,this.n=I,this.o=w,this.p=g,this.q=y,this.extensionDescription=L,this.r=F,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Uc,this.l.value=new P.$Sc,this.n===void 0&&(this.n=`${c}.${this.handle}`),a.$createCommentThread(p,this.handle,this.n,this.o,k.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{a.$deleteCommentThread(p,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(j){z.range=j},get comments(){return z.comments},set comments(j){z.comments=j},get collapsibleState(){return z.collapsibleState},set collapsibleState(j){z.collapsibleState=j},get canReply(){return z.canReply},set canReply(j){z.canReply=j},get contextValue(){return z.contextValue},set contextValue(j){z.contextValue=j},get label(){return z.label},set label(j){z.label=j},get state(){return z.state},set state(j){z.state=j},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Sc);const c=I=>Object.prototype.hasOwnProperty.call(this.b,I),p={};c("range")&&(p.range=k.Range.from(this.p)),c("label")&&(p.label=this.label),c("contextValue")&&(p.contextValue=this.contextValue??null),c("comments")&&(p.comments=this.q.map(I=>o(this,I,this.k,this.extensionDescription))),c("collapsibleState")&&(p.collapseState=s(this.g)),c("canReply")&&(p.canReply=this.canReply),c("state")&&(p.state=d(this.h)),c("isTemplate")&&(p.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(c){for(const p of this.k){const I=p[0],w=p[1];if(c===w)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}Ke([(0,N.$Bh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,b.$MF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,b.$MF)(this.h,"activeComment"),this.f}constructor(c,p,I,w){this.h=c,this.i=p,this.j=I,this.k=w,this.a=new Map,a.$registerCommentController(this.handle,I,w,this.h.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(y){g.options=y},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(y){g.commentingRangeProvider=y},get reactionHandler(){return g.reactionHandler},set reactionHandler(y){g.reactionHandler=y},get activeCommentThread(){return g.activeCommentThread},createCommentThread(y,L,F){return g.createCommentThread(y,L,F).value},dispose:()=>{g.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(c,p,I){p===void 0&&(0,b.$MF)(this.h,"fileComments");const w=new r(this.id,this.handle,void 0,c,p,I,this.h,!1);return this.a.set(w.handle,w),w}$setActiveComment(c){if(!c){this.e=void 0,this.f=void 0;return}const p=this.a.get(c.commentThreadHandle);p&&(this.e=c.uniqueIdInThread?p.getCommentByUniqueId(c.uniqueIdInThread):void 0,this.f=p)}$createCommentThreadTemplate(c,p){const I=new r(this.id,this.handle,void 0,A.URI.revive(c),k.Range.to(p),[],this.h,!0);return I.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(c,p){const I=this.a.get(c);I&&(I.range=k.Range.to(p))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.g.forEach(c=>c.dispose())}}function o(l,c,p,I){let w=p.get(c);return w||(w=++l.commentHandle,p.set(c,w)),c.state!==void 0&&(0,b.$MF)(I,"commentsDraftState"),c.reactions?.some(g=>g.reactors!==void 0)&&(0,b.$MF)(I,"commentReactor"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:w,body:typeof c.body=="string"?c.body:k.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(g=>t(g)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?k.$CN(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(c=>c.name):l.reactors}}function h(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?A.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(c=>({name:c}))}}function s(l){if(l!==void 0)switch(l){case R.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function d(l){if(l!==void 0)switch(l){case R.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.$Sgc=E}),define(Ce[325],Ie([1,0,22,54,3,15,23,2,16,92,110,6,7]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class E{constructor(h,s){this.document=h,this.b=s,this.a=1,this.c=new R.$xgc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,s){await this.f(h).undo(),s||this.disposeBackup()}async redo(h,s){await this.f(h).redo(),s||this.disposeBackup()}disposeEdits(h){for(const s of h)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=o(this.document.uri)+this.a++;return(0,A.$Jg)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const s=this.c.get(h,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(h,s){return this.a.get(this.b(h,s))}add(h,s,d){const l=this.b(h,s.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${h} resource:${s.uri}`);const c=new E(s,d);return this.a.set(l,c),c}delete(h,s){const d=this.b(h,s.uri);this.a.delete(d)}b(h,s){return`${h}@@@${s}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class m{constructor(){this.a=new Map}addTextProvider(h,s,d){return this.b(0,h,s,d)}addCustomProvider(h,s,d){return this.b(1,h,s,d)}get(h){return this.a.get(h)}b(h,s,d,l){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:h,extension:d,provider:l}),new b.$rL(()=>this.a.delete(s))}}class a{constructor(h,s,d,l,c){this.d=s,this.f=d,this.g=l,this.h=c,this.b=new m,this.c=new S,this.a=h.getProxy(C.$pL.MainThreadCustomEditors)}registerCustomEditorProvider(h,s,d,l){const c=new f.$Sc;return r(d)?(c.add(this.b.addTextProvider(s,h,d)),this.a.$registerTextEditorProvider((0,k.$8gc)(h),s,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.$6gc)(h))):(c.add(this.b.addCustomProvider(s,h,d)),i(d)&&c.add(d.onDidChangeCustomDocument(p=>{const I=this.i(s,p.document.uri);if(n(p)){const w=I.addEdit(p);this.a.$onDidEdit(p.document.uri,s,w,p.label)}else this.a.$onContentChange(p.document.uri,s)})),this.a.$registerCustomEditorProvider((0,k.$8gc)(h),s,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,k.$6gc)(h))),b.$rL.from(c,new b.$rL(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(h,s,d,l,c){const p=this.b.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=v.URI.revive(h),w=await p.provider.openCustomDocument(I,{backupId:d,untitledDocumentData:l?.buffer},c);let g;return i(p.provider)&&this.f&&(g=this.f.workspaceValue(p.extension)??this.f.globalValue(p.extension)),this.c.add(s,w,g),{editable:i(p.provider)}}async $disposeCustomDocument(h,s){const d=this.b.get(s);if(!d)throw new Error(`No provider found for '${s}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${s}'`);const l=v.URI.revive(h),{document:c}=this.i(s,l);this.c.delete(s,c),c.dispose()}async $resolveCustomEditor(h,s,d,l,c,p){const I=this.b.get(d);if(!I)throw new Error(`No provider found for '${d}'`);const w=$.ViewColumn.to(c),g=this.g.createNewWebview(s,l.contentOptions,I.extension),y=this.h.createNewWebviewPanel(s,d,l.title,w,l.options,g,l.active),L=v.URI.revive(h);switch(I.type){case 1:{const{document:F}=this.i(d,L);return I.provider.resolveCustomEditor(F,y,p)}case 0:{const F=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(F,y,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,s,d){this.i(s,h).disposeEdits(d)}async $onMoveCustomEditor(h,s,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const c=this.h.getWebviewPanel(h);if(!c)throw new Error("No webview found");const p=v.URI.revive(s),I=this.d.getDocument(p);await l.provider.moveCustomTextEditor(I,c,D.CancellationToken.None)}async $undo(h,s,d,l){return this.i(s,h).undo(d,l)}async $redo(h,s,d,l){return this.i(s,h).redo(d,l)}async $revert(h,s,d){const l=this.i(s,h);await this.j(s).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(h,s,d){const l=this.i(s,h);await this.j(s).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(h,s,d,l){const c=this.i(s,h);return this.j(s).saveCustomDocumentAs(c.document,v.URI.revive(d),l)}async $backup(h,s,d){const l=this.i(s,h),p=await this.j(s).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(p),p.id}i(h,s){const d=this.c.get(h,v.URI.revive(s));if(!d)throw new Error("No custom document found");return d}j(h){const d=this.b.get(h)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$$gc=a;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function o(t){const h=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Wi)(h)+""}}),define(Ce[326],Ie([1,0,213,135,2,6,7,16,4,13,28,59]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=void 0;class E{#e;#t;#i;constructor(m,a,i,r,n,o,t,h){this.d=m,this.e=a,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new R.$Ac(s=>o.getComparisonKey(s)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,a){if(!m){this.clear();return}this.j();let i=[];if(f.URI.isUri(m)){if(!a){this.delete(m);return}this.#i.set(m,a.slice()),i=[m]}else if(Array.isArray(m)){i=[];let o;m=[...m].sort(E.k);for(const t of m){const[h,s]=t;if((!o||h.toString()!==o.toString())&&(o&&this.#i.get(o).length===0&&this.#i.delete(o),o=h,i.push(h),this.#i.set(h,[])),s)this.#i.get(h)?.push(...s);else{const d=this.#i.get(h);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const o of i){let t=[];const h=this.#i.get(o);if(h)if(h.length>this.g){t=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const l of h)if(l.severity===s[d]&&t.push({...v.Diagnostic.from(l),modelVersionId:this.h(o)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(s=>({...v.Diagnostic.from(s),modelVersionId:this.h(o)}));if(r.push([o,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,a){this.j();for(const[i,r]of this)m.call(a,i,r,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const a=this.#i.get(m);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,a){return m[0].toString()<a[0].toString()?-1:m[0].toString()>a[0].toString()?1:0}}e.$Cgc=E;let S=class{static{b=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*b.d}static _mapper(m){const a=new R.$Ac;for(const i of m)a.set(i,i);return{uris:Object.freeze(Array.from(a.values()))}}constructor(m,a,i,r){this.j=a,this.k=i,this.l=r,this.g=new Map,this.h=new $.$1d({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,b._mapper),this.f=m.getProxy(P.$pL.MainThreadDiagnostics)}createDiagnosticCollection(m,a){const{g:i,f:r,h:n,j:o,k:t,l:h}=this,s=new class{$changeMany(c,p){r.$changeMany(c,p),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,c,p.length===0?"CLEARING":p)}$clear(c){r.$clear(c),o.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,c)}dispose(){r.dispose()}};let d;if(!a)a="_generated_diagnostic_collection_name_#"+b.c++,d=a;else if(!i.has(a))d=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do d=a+b.c++;while(i.has(d))}return new class extends E{constructor(){super(a,d,b.e,b.d,c=>h.getDocument(c)?.version,t.extUri,s,n),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(m){if(m)return this.m(m);{const a=new Map,i=[];for(const r of this.g.values())r.forEach((n,o)=>{let t=a.get(n.toString());typeof t>"u"&&(t=i.length,a.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...o)});return i}}m(m){let a=[];for(const i of this.g.values())i.has(m)&&(a=a.concat(i.get(m)));return a}$acceptMarkersChange(m){if(!this.n){const a="_generated_mirror",i=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(a,i),this.n=i}for(const[a,i]of m)this.n.set(f.URI.revive(a),i.map(v.Diagnostic.to))}};e.$Dgc=S,e.$Dgc=S=b=Ke([We(1,k.$qj),We(2,C.$Bgc)],S)}),define(Ce[327],Ie([1,0,2,14,7,16,76]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class v{constructor(k,R,C,b={timeout:1500,errors:3}){this.c=k,this.d=R,this.f=C,this.g=b,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(R,C,b)=>{const S={dispose:this.a.push([R,C,k])};return Array.isArray(b)&&b.push(S),S}}async $participateInSave(k,R){const C=D.URI.revive(k);let b=!1;const E=setTimeout(()=>b=!0,this.g.timeout),S=[];try{for(const u of[...this.a]){if(b)break;const m=this.d.getDocument(C),a=await this.h(u,{document:m,reason:P.TextDocumentSaveReason.to(R)});S.push(a)}}finally{clearTimeout(E)}return S}h([k,R,C],b){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(C,k,R,b).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const u=this.b.get(k);this.b.set(k,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,R,C,b){const E=[],S=Date.now(),{document:u,reason:m}=b,{version:a}=u,i=Object.freeze({document:u,reason:m,waitUntil(r){if(Object.isFrozen(E))throw(0,N.$8)("waitUntil can not be called async");E.push(Promise.resolve(r))}});try{R.apply(C,[i])}catch(r){return Promise.reject(r)}return Object.freeze(E),new Promise((r,n)=>{const o=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(o),r(t)}).catch(t=>{clearTimeout(o),n(t)})}).then(r=>{const n={edits:[]};for(const o of r)if(Array.isArray(o)&&o.every(t=>t instanceof f.$yL))for(const{newText:t,newEol:h,range:s}of o)n.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:t,eol:h&&P.EndOfLine.from(h)}});if(n.edits.length!==0)return a===u.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$Mhc=v}),define(Ce[328],Ie([1,0,4,3,2,6,149,16,18,24,7]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class C{constructor(E,S){this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Sc,this.h=new Map,this.f=E.getProxy(P.$pL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(u=>{for(const m of u)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const m of u)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const S=this.g.getDocument(E);if(S)return S}getDocument(E){const S=this.getDocumentData(E);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return S.document}ensureDocumentData(E){const S=this.g.getDocument(E);if(S)return Promise.resolve(S);let u=this.h.get(E.toString());return u||(u=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const a=f.URI.revive(m);return(0,$.$Vf)(this.g.getDocument(a))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),u)),u}createDocumentData(E){return this.f.$tryCreateDocument(E).then(S=>f.URI.revive(S))}$acceptModelLanguageChanged(E,S){const u=f.URI.revive(E),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(S),this.a.fire(m.document)}$acceptModelSaved(E){const S=f.URI.revive(E),u=this.g.getDocument(S);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(E,S){const u=f.URI.revive(E),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");m._acceptIsDirty(S),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,S,u){const m=f.URI.revive(E),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");a._acceptIsDirty(u),a.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,k.$An)({document:a.document,contentChanges:S.changes.map(r=>({range:v.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(E,S){(0,A.$FN)(E,S)}}e.$zgc=C}),define(Ce[72],Ie([1,0,74,4,18,2,5,6,20,16,7]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=e.$_gc=void 0,e.$_gc=(0,A.$9h)("IExtHostEditorTabs");class C{constructor(m,a,i){this.e=i,this.d=a,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$$M(P.URI.revive(this.b.input.uri));case 2:return new R.$_M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new R.$aN(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new R.$bN(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$cN(this.b.input.viewType);case 4:return new R.$dN(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$eN(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$fN;case 9:return new R.$gN(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$hN(this.b.input.providerId);default:return}}}class b{constructor(m,a){this.c=[],this.d="",this.b=m,this.e=a;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,a={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return k.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const a=this.c.find(i=>i.tabId===m.tabDto.id);if(!a)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(m.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new N.$Wd,this.c=new N.$Wd,this.e=[],this.a=m.getProxy(v.$pL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,a={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,f.$Vf)(m.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(m){const a=new Set(this.e.map(s=>s.groupId)),i=new Set(m.map(s=>s.groupId)),r=(0,D.$L)(a,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),o=[],t=[];this.e=m.map(s=>{const d=new b(s,()=>this.d);return r.added.includes(d.groupId)?o.push(d.apiObject):t.push(d.apiObject),d});const h=(0,f.$Vf)(m.find(s=>s.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:o,closed:n,changed:t}))}$acceptTabGroupUpdate(m){const a=this.e.find(i=>i.groupId===m.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const a=this.e.find(r=>r.groupId===m.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const i=a.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const a of this.e)for(const i of a.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(a=>a.apiObject===m)}async i(m,a){const i=[];for(const r of m){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,a)}async j(m,a){const i=[];for(const r of m){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,a)}};e.$ahc=E,e.$ahc=E=Ke([We(0,$.$DN)],E);function S(u){return u.tabs!==void 0}}),define(Ce[329],Ie([1,0,2,6,3,7,16,174,12,21,26,63]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class b{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const m=this.a.indexOf(u);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),m=[];let a,i,r=14,n=14;for(const o of u){let t=a?(0,$.$df)(a,o):0;for(t===0?i=1:i=n;t<o.length;t++)t+1===o.length?(r=n,n=9):n+=1,m.push([i,o.toUpperCase().charCodeAt(t),n]),m.push([i,o.toLowerCase().charCodeAt(t),n]),i=n;a=o,n=r}m.push([9,58,10]),m.push([10,47,12]),this.b=new v.$3Z(m)}}provideDocumentLinks(u){this.c();const m=[],a=v.$4Z.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of a){const r=A.DocumentLink.to(i);r.target&&m.push(r)}return m}}class E{constructor(u,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(N.$pL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,m,a,i={}){if(E.j(a),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const r=this.h++;this.b.add(m),this.d.add(m),this.c.set(r,a);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof a.copy=="function"&&(n+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,R.$MF)(u,"fsChunks"),n+=4);let o;i.isReadonly&&(0,C.$mk)(i.isReadonly)&&i.isReadonly.value!==""&&(o={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,m,n,o).catch(h=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${m}`),console.error(h)});const t=a.onDidChangeFile(h=>{const s=[];for(const d of h){const{uri:l,type:c}=d;if(l.scheme!==m)continue;let p;switch(c){case P.FileChangeType.Changed:p=0;break;case P.FileChangeType.Created:p=1;break;case P.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:p})}this.a.$onFileSystemChange(r,s)});return(0,f.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:m,ctime:a,mtime:i,size:r,permissions:n}=u;return{type:m,ctime:a,mtime:i,size:r,permissions:n}}$stat(u,m){return Promise.resolve(this.l(u).stat(D.URI.revive(m))).then(a=>E.k(a))}$readdir(u,m){return Promise.resolve(this.l(u).readDirectory(D.URI.revive(m)))}$readFile(u,m){return Promise.resolve(this.l(u).readFile(D.URI.revive(m))).then(a=>k.$ke.wrap(a))}$writeFile(u,m,a,i){return Promise.resolve(this.l(u).writeFile(D.URI.revive(m),a.buffer,i))}$delete(u,m,a){return Promise.resolve(this.l(u).delete(D.URI.revive(m),a))}$rename(u,m,a,i){return Promise.resolve(this.l(u).rename(D.URI.revive(m),D.URI.revive(a),i))}$copy(u,m,a,i){const r=this.l(u);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(D.URI.revive(m),D.URI.revive(a),i))}$mkdir(u,m){return Promise.resolve(this.l(u).createDirectory(D.URI.revive(m)))}$watch(u,m,a,i){const r=this.l(u).watch(D.URI.revive(a),i);this.f.set(m,r)}$unwatch(u,m){const a=this.f.get(m);a&&(a.dispose(),this.f.delete(m))}$open(u,m,a){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(m),a))}$close(u,m){const a=this.l(u);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(m))}$read(u,m,a,i){const r=this.l(u);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=k.$ke.alloc(i);return Promise.resolve(r.read(m,a,n.buffer,0,i)).then(o=>n.slice(0,o))}$write(u,m,a,i){const r=this.l(u);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(m,a,i.buffer,0,i.byteLength))}l(u){const m=this.c.get(u);if(!m){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return m}}e.$Ohc=E}),define(Ce[330],Ie([1,0,4,35,2,6,16,7,43]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,S,u,m,a,i){this.a=Math.random(),this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,N.$Pj)(a),n=typeof a=="string",o=i?.correlate,t=m(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(o&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=v.$rL.from(this.i(E,u,a,i,i?.correlate),this.b,this.c,this.d,t)}i(E,S,u,m,a){const i=v.$rL.from();if(typeof u=="string")return i;const r=E.getProxy(P.$pL.MainThreadFileSystemEventService);let n=!1;return(u.pattern.includes(N.$Lj)||u.pattern.includes(N.$Mj))&&(n=!0),r.$watch(S.identifier.value,this.a,u.baseUri,{recursive:n,excludes:m?.excludes??[]},!!a),v.$rL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(f.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(E,S,u){this.j=E,this.k=S,this.l=u,this.a=new D.$Wd,this.b=new D.$Wd,this.c=new D.$Wd,this.d=new D.$Wd,this.g=new D.$Yd,this.h=new D.$Yd,this.i=new D.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,S,u,m){return new k(this.j,E,S,this.a.event,A.GlobPattern.from(u),m)}$onFileEvent(E){this.a.fire(new R(E))}$onDidRunFileOperation(E,S){switch(E){case 2:this.b.fire(Object.freeze({files:S.map(u=>({oldUri:f.URI.revive(u.source),newUri:f.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(u=>f.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(u=>f.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,S){return(u,m,a)=>{const i=function(n){u.call(m,n)};return i.extension=E,S.event(i,void 0,a)}}async $onWillRunFileOperation(E,S,u,m){switch(E){case 2:return await this.n(this.g,{files:S.map(a=>({oldUri:f.URI.revive(a.source),newUri:f.URI.revive(a.target)}))},u,m);case 1:return await this.n(this.i,{files:S.map(a=>f.URI.revive(a.target))},u,m);case 0:case 3:return await this.n(this.h,{files:S.map(a=>f.URI.revive(a.target))},u,m)}}async n(E,S,u,m){const a=new Set,i=[];if(await E.fireAsync(S,m,async(n,o)=>{const t=Date.now(),h=await Promise.resolve(n);h instanceof v.$BL&&(i.push([o.extension,h]),a.add(o.extension.displayName??o.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",o.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:o}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(o)}return{edit:r,extensionNames:Array.from(a)}}}e.$Phc=C}),define(Ce[331],Ie([1,0,2,24,16,7,83,6,12,29,19,18,170,22,25,3,131,121,110,38,14,8,26,215]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class s{constructor(W,x){this.d=W,this.e=x}async provideDocumentSymbols(W,x){const H=this.d.getDocument(W),X=await this.e.provideDocumentSymbols(H,x);if(!(0,R.$Kb)(X))return X[0]instanceof P.$KL?X.map(f.DocumentSymbol.from):s.f(X)}static f(W){W=W.slice(0).sort((X,oe)=>{let ve=X.location.range.start.compareTo(oe.location.range.start);return ve===0&&(ve=oe.location.range.end.compareTo(X.location.range.end)),ve});const x=[],H=[];for(const X of W){const oe={name:X.name||"!!MISSING: name!!",kind:f.SymbolKind.from(X.kind),tags:X.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:f.Range.from(X.location.range),selectionRange:f.Range.from(X.location.range),children:[]};for(;;){if(H.length===0){H.push(oe),x.push(oe);break}const ve=H[H.length-1];if(k.$Xs.containsRange(ve.range,oe.range)&&!k.$Xs.equalsRange(ve.range,oe.range)){ve.children?.push(oe),H.push(oe);break}H.pop()}}return x}}class d{constructor(W,x,H,X,oe,ve){this.f=W,this.g=x,this.h=H,this.j=X,this.k=oe,this.l=ve,this.d=new i.$xgc("CodeLens"),this.e=new Map}async provideCodeLenses(W,x){const H=this.f.getDocument(W),X=await this.h.provideCodeLenses(H,x);if(!X||x.isCancellationRequested)return;const oe=this.d.add(X),ve=new u.$Sc;this.e.set(oe,ve);const Me={cacheId:oe,lenses:[]};for(let qe=0;qe<X.length;qe++)Me.lenses.push({cacheId:[oe,qe],range:f.Range.from(X[qe].range),command:this.g.toInternal(X[qe].command,ve)});return Me}async resolveCodeLens(W,x){const H=W.cacheId&&this.d.get(...W.cacheId);if(!H)return;let X;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?X=H:X=await this.h.resolveCodeLens(H,x),X||(X=H),x.isCancellationRequested)return;const oe=W.cacheId&&this.e.get(W.cacheId[0]);if(oe){if(!X.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return W.command=this.g.toInternal(X.command,oe),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function l(Ne){return Array.isArray(Ne)?Ne.map(f.DefinitionLink.from):Ne?[f.DefinitionLink.from(Ne)]:[]}class c{constructor(W,x){this.d=W,this.e=x}async provideDefinition(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideDefinition(X,oe,H);return l(ve)}}class p{constructor(W,x){this.d=W,this.e=x}async provideDeclaration(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideDeclaration(X,oe,H);return l(ve)}}class I{constructor(W,x){this.d=W,this.e=x}async provideImplementation(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideImplementation(X,oe,H);return l(ve)}}class w{constructor(W,x){this.d=W,this.e=x}async provideTypeDefinition(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideTypeDefinition(X,oe,H);return l(ve)}}class g{constructor(W,x){this.d=W,this.e=x}async provideHover(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideHover(X,oe,H);if(!(!ve||(0,R.$Kb)(ve.contents)))return ve.range||(ve.range=X.getWordRangeAtPosition(oe)),ve.range||(ve.range=new P.$tL(oe,oe)),f.Hover.from(ve)}}class y{constructor(W,x){this.d=W,this.e=x}async provideEvaluatableExpression(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideEvaluatableExpression(X,oe,H);if(ve)return f.EvaluatableExpression.from(ve)}}class L{constructor(W,x){this.d=W,this.e=x}async provideInlineValues(W,x,H,X){const oe=this.d.getDocument(W),ve=await this.e.provideInlineValues(oe,f.Range.to(x),f.InlineValueContext.to(H),X);if(Array.isArray(ve))return ve.map(Me=>f.InlineValue.from(Me))}}class F{constructor(W,x){this.d=W,this.e=x}async provideDocumentHighlights(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideDocumentHighlights(X,oe,H);if(Array.isArray(ve))return ve.map(f.DocumentHighlight.from)}}class z{constructor(W,x){this.d=W,this.e=x}async provideMultiDocumentHighlights(W,x,H,X){const oe=this.d.getDocument(W),ve=H.map(Ge=>this.d.getDocument(Ge)),Me=f.Position.to(x),qe=await this.e.provideMultiDocumentHighlights(oe,Me,ve,X);if(Array.isArray(qe))return qe.map(f.MultiDocumentHighlight.from)}}class j{constructor(W,x){this.d=W,this.e=x}async provideLinkedEditingRanges(W,x,H){const X=this.d.getDocument(W),oe=f.Position.to(x),ve=await this.e.provideLinkedEditingRanges(X,oe,H);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,R.$Hb)(ve.ranges.map(f.Range.from)),wordPattern:ve.wordPattern}}}class O{constructor(W,x){this.d=W,this.e=x}async provideReferences(W,x,H,X){const oe=this.d.getDocument(W),ve=f.Position.to(x),Me=await this.e.provideReferences(oe,ve,H,X);if(Array.isArray(Me))return Me.map(f.location.from)}}class M{static{this.d=1e3}constructor(W,x,H,X,oe,ve,Me){this.g=W,this.h=x,this.j=H,this.k=X,this.l=oe,this.m=ve,this.n=Me,this.e=new i.$xgc("CodeAction"),this.f=new Map}async provideCodeActions(W,x,H,X){const oe=this.g.getDocument(W),ve=b.$Zs.isISelection(x)?f.Selection.to(x):f.Range.to(x),Me=[];for(const ot of this.j.getDiagnostics(W))if(ve.intersection(ot.range)&&Me.push(ot)>M.d)break;const qe={diagnostics:Me,only:H.only?new P.$ML(H.only):void 0,triggerKind:f.CodeActionTriggerKind.to(H.trigger)},Ge=await this.k.provideCodeActions(oe,ve,qe,X);if(!(0,R.$Lb)(Ge)||X.isCancellationRequested)return;const Ye=this.e.add(Ge),it=new u.$Sc;this.f.set(Ye,it);const ut=[];for(let ot=0;ot<Ge.length;ot++){const et=Ge[ot];if(et)if(M.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,it)});else{qe.only&&(et.kind?qe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Ae=et.ranges??[];ut.push({cacheId:[Ye,ot],title:et.title,command:et.command&&this.h.toInternal(et.command,it),diagnostics:et.diagnostics&&et.diagnostics.map(f.Diagnostic.from),edit:et.edit&&f.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,t.$LF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,t.$LF)(this.m,"codeActionRanges")?(0,R.$Hb)(Ae.map(f.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ye,actions:ut}}async resolveCodeAction(W,x){const[H,X]=W,oe=this.e.get(H,X);if(!oe||M.o(oe))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(oe,x)??oe;let Me;ve.edit&&(Me=f.WorkspaceEdit.from(ve.edit,void 0));let qe;if(ve.command){const Ge=this.f.get(H);Ge&&(qe=this.h.toInternal(ve.command,Ge))}return{edit:Me,command:qe}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class T{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,X,oe){this.d=W,this.e=x,this.f=H,this.g=X,this.h=oe}async prepareDocumentPaste(W,x,H,X){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(W),ve=x.map(Ge=>f.Range.to(Ge)),Me=f.DataTransfer.toDataTransfer(H,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(oe,ve,Me,X),X.isCancellationRequested)return;const qe=Array.from(Me).filter(([,Ge])=>!(Ge instanceof P.$gM));return f.DataTransfer.from(qe)}async providePasteEdits(W,x,H,X,oe){if(!this.f.provideDocumentPasteEdits)return;const ve=this.e.getDocument(x),Me=H.map(Ye=>f.Range.to(Ye)),qe=f.DataTransfer.toDataTransfer(X,async Ye=>(await this.d.$resolvePasteFileData(this.g,W,Ye)).buffer),Ge=await this.f.provideDocumentPasteEdits(ve,Me,qe,oe);if(Ge)return{label:Ge.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ge.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:T.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?f.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class U{constructor(W,x){this.d=W,this.e=x}async provideDocumentFormattingEdits(W,x,H){const X=this.d.getDocument(W),oe=await this.e.provideDocumentFormattingEdits(X,x,H);if(Array.isArray(oe))return oe.map(f.TextEdit.from)}}class J{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeFormattingEdits(W,x,H,X){const oe=this.d.getDocument(W),ve=f.Range.to(x),Me=await this.e.provideDocumentRangeFormattingEdits(oe,ve,H,X);if(Array.isArray(Me))return Me.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,x,H,X){(0,C.$Uf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(W),ve=x.map(f.Range.to),Me=await this.e.provideDocumentRangesFormattingEdits(oe,ve,H,X);if(Array.isArray(Me))return Me.map(f.TextEdit.from)}}class ne{constructor(W,x){this.d=W,this.e=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,x,H,X,oe){const ve=this.d.getDocument(W),Me=f.Position.to(x),qe=await this.e.provideOnTypeFormattingEdits(ve,Me,H,X,oe);if(Array.isArray(qe))return qe.map(f.TextEdit.from)}}class ee{constructor(W,x){this.e=W,this.f=x,this.d=new i.$xgc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,x){const H=await this.e.provideWorkspaceSymbols(W,x);if(!(0,R.$Lb)(H))return{symbols:[]};const X=this.d.add(H),oe={cacheId:X,symbols:[]};for(let ve=0;ve<H.length;ve++){const Me=H[ve];if(!Me||!Me.name){this.f.warn("INVALID SymbolInformation",Me);continue}oe.symbols.push({...f.WorkspaceSymbol.from(Me),cacheId:[X,ve]})}return oe}async resolveWorkspaceSymbol(W,x){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const H=this.d.get(...W.cacheId);if(H){const X=await this.e.resolveWorkspaceSymbol(H,x);return X&&(0,N.$Cn)(W,f.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class Q{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideRenameEdits(W,x,H,X){const oe=this.d.getDocument(W),ve=f.Position.to(x);try{const Me=await this.e.provideRenameEdits(oe,ve,H,X);return Me?f.WorkspaceEdit.from(Me):void 0}catch(Me){const qe=Q.g(Me);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Me)}}async resolveRenameLocation(W,x,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(W),oe=f.Position.to(x);try{const ve=await this.e.prepareRename(X,oe,H);let Me,qe;if(P.$tL.isRange(ve)?(Me=ve,qe=X.getText(ve)):(0,C.$Mf)(ve)&&(Me=ve.range,qe=ve.placeholder),!Me||!qe)return;if(Me.start.line>oe.line||Me.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Me),text:qe}}catch(ve){const Me=Q.g(ve);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(ve)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideNewSymbolNames(W,x,H){const X=this.d.getDocument(W),oe=f.Range.to(x);try{const ve=await this.e.provideNewSymbolNames(X,oe,H);return ve||void 0}catch(ve){this.f.error(Y.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ce{constructor(W,x){this.resultId=W,this.tokens=x}}class te{constructor(W,x){this.f=W,this.g=x,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,x,H){const X=this.f.getDocument(W),oe=x!==0?this.d.get(x):null;let ve=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,oe.resultId,H):await this.g.provideDocumentSemanticTokens(X,H);return oe&&this.d.delete(x),ve?(ve=te.h(ve),this.o(te.n(oe,ve),ve)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return te.j(W)?te.k(W)?W:new P.$JM(new Uint32Array(W.data),W.resultId):te.l(W)?te.m(W)?W:new P.$LM(W.edits.map(x=>new P.$KM(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const x of W.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static n(W,x){if(!te.j(x)||!W||!W.tokens)return x;const H=W.tokens,X=H.length,oe=x.data,ve=oe.length;let Me=0;const qe=Math.min(X,ve);for(;Me<qe&&H[Me]===oe[Me];)Me++;if(Me===X&&Me===ve)return new P.$LM([],x.resultId);let Ge=0;const Ye=qe-Me;for(;Ge<Ye&&H[X-Ge-1]===oe[ve-Ge-1];)Ge++;return new P.$LM([{start:Me,deleteCount:X-Me-Ge,data:oe.subarray(Me,ve-Ge)}],x.resultId)}o(W,x){if(te.j(W)){const H=this.e++;return this.d.set(H,new ce(W.resultId,W.data)),(0,m.$8$)({id:H,type:"full",data:W.data})}if(te.l(W)){const H=this.e++;return te.j(x)?this.d.set(H,new ce(x.resultId,x.data)):this.d.set(H,new ce(W.resultId)),(0,m.$8$)({id:H,type:"delta",deltas:(W.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class fe{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeSemanticTokens(W,x,H){const X=this.d.getDocument(W),oe=await this.e.provideDocumentRangeSemanticTokens(X,f.Range.to(x),H);return oe?this.f(oe):null}f(W){return(0,m.$8$)({id:0,type:"full",data:W.data})}}class re{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,x,H,X,oe){this.f=W,this.g=x,this.h=H,this.j=X,this.k=oe,this.d=new i.$xgc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,x,H,X){const oe=this.f.getDocument(W),ve=f.Position.to(x),Me=oe.getWordRangeAtPosition(ve)||new P.$tL(ve,ve),qe=Me.with({end:ve}),Ge=new r.$Sd,Ye=await this.h.provideCompletionItems(oe,ve,X,f.CompletionContext.to(H));if(!Ye||X.isCancellationRequested)return;const it=Array.isArray(Ye)?new P.$ZL(Ye):Ye,ut=re.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),ot=new u.$Sc;this.e.set(ut,ot);const et=[],Ae={x:ut,b:et,a:{replace:f.Range.from(Me),insert:f.Range.from(qe)},c:it.isIncomplete||void 0,d:Ge.elapsed()};for(let ke=0;ke<it.items.length;ke++){const He=it.items[ke],_=this.l(He,[ut,ke],qe,Me);et.push(_)}return Ae}async resolveCompletionItem(W,x){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...W);if(!H)return;const X=this.l(H,W),oe=await this.h.resolveCompletionItem(H,x);if(!oe)return;const ve=this.l(oe,W);return(X.h!==ve.h||X.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==ve.n||X.o!==ve.o||!(0,N.$Dn)(X.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x,H,X){const oe=this.e.get(x[0]);if(!oe)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(W.command,oe),Me={x,a:W.label,b:W.kind!==void 0?f.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(f.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:f.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(f.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=W.textEdit.newText):typeof W.insertText=="string"?Me.h=W.insertText:W.insertText instanceof P.$CL&&(Me.h=W.insertText.value,Me.i|=4);let qe;return W.textEdit?qe=W.textEdit.range:W.range&&(qe=W.range),P.$tL.isRange(qe)?Me.j=f.Range.from(qe):qe&&(!H?.isEqual(qe.inserting)||!X?.isEqual(qe.replacing))&&(Me.j={insert:f.Range.from(qe.inserting),replace:f.Range.from(qe.replacing)}),Me}}class K{async provideInlineCompletions(W,x,H,X){}disposeCompletions(W){}handleDidShowCompletionItem(W,x,H){}handlePartialAccept(W,x,H){}}class B extends K{constructor(W,x,H,X){super(),this.f=W,this.g=x,this.h=H,this.j=X,this.d=new ae,this.e=(0,t.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,x,H,X){const oe=this.g.getDocument(W),ve=f.Position.to(x),Me=await this.h.provideInlineCompletionItems(oe,ve,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:f.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},X);if(!Me||X.isCancellationRequested)return;const qe=Array.isArray(Me)?Me:Me.items,Ge=this.e?Array.isArray(Me)?[]:Me.commands||[]:[],Ye=this.e&&!Array.isArray(Me)?Me.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:qe}),items:qe.map((ot,et)=>{let Ae;ot.command&&(it||(it=new u.$Sc),Ae=this.j.toInternal(ot.command,it));const ke=ot.insertText;return{insertText:typeof ke=="string"?ke:{snippet:ke.value},filterText:ot.filterText,range:ot.range?f.Range.from(ot.range):void 0,command:Ae,idx:et,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Ge.map(ot=>(it||(it=new u.$Sc),this.j.toInternal(ot,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,x,H){const X=this.d.get(W)?.items[x];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,H)}handlePartialAccept(W,x,H){const X=this.d.get(W)?.items[x];X&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(X,H)}}class ae{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const x=this.e++;return this.d.set(x,W),x}disposeReferenceId(W){const x=this.d.get(W);return this.d.delete(W),x}get(W){return this.d.get(W)}}class Ee{constructor(W,x){this.e=W,this.f=x,this.d=new i.$xgc("SignatureHelp")}async provideSignatureHelp(W,x,H,X){const oe=this.e.getDocument(W),ve=f.Position.to(x),Me=this.g(H),qe=await this.f.provideSignatureHelp(oe,ve,X,Me);if(qe){const Ge=this.d.add([qe]);return{...f.SignatureHelp.from(qe),id:Ge}}}g(W){let x;if(W.activeSignatureHelp){const H=f.SignatureHelp.to(W.activeSignatureHelp),X=this.d.get(W.activeSignatureHelp.id,0);X?(x=X,x.activeSignature=H.activeSignature,x.activeParameter=H.activeParameter):x=H}return{...W,activeSignatureHelp:x}}releaseSignatureHelp(W){this.d.delete(W)}}class le{constructor(W,x,H,X,oe){this.f=W,this.g=x,this.h=H,this.j=X,this.k=oe,this.d=new i.$xgc("InlayHints"),this.e=new Map}async provideInlayHints(W,x,H){const X=this.f.getDocument(W),oe=f.Range.to(x),ve=await this.h.provideInlayHints(X,oe,H);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`);return}if(H.isCancellationRequested)return;const Me=this.d.add(ve);this.e.set(Me,new u.$Sc);const qe={hints:[],cacheId:Me};for(let Ge=0;Ge<ve.length;Ge++)this.l(ve[Ge],oe)&&qe.hints.push(this.m(ve[Ge],[Me,Ge]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`),qe}async resolveInlayHint(W,x){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...W);if(!H)return;const X=await this.h.resolveInlayHint(H,x);if(X&&this.l(X))return this.m(X,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x){return W.label.length===0||Array.isArray(W.label)&&W.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(x&&!x.contains(W.position))}m(W,x){const H=this.e.get(x[0]);if(!H)throw Error("DisposableStore is missing...");const X={label:"",cacheId:x,tooltip:f.MarkdownString.fromStrict(W.tooltip),position:f.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(f.TextEdit.from),kind:W.kind&&f.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")X.label=W.label;else{const oe=[];X.label=oe;for(const ve of W.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Me={label:ve.value,tooltip:f.MarkdownString.fromStrict(ve.tooltip)};P.$DL.isLocation(ve.location)&&(Me.location=f.location.from(ve.location)),ve.command&&(Me.command=this.g.toInternal(ve.command,H)),oe.push(Me)}}return X}}class de{constructor(W,x){this.e=W,this.f=x,this.d=new i.$xgc("DocumentLink")}async provideLinks(W,x){const H=this.e.getDocument(W),X=await this.f.provideDocumentLinks(H,x);if(!(!Array.isArray(X)||X.length===0)&&!x.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(de.g).map(f.DocumentLink.from)};{const oe=this.d.add(X),ve={links:[],cacheId:oe};for(let Me=0;Me<X.length;Me++){if(!de.g(X[Me]))continue;const qe=f.DocumentLink.from(X[Me]);qe.cacheId=[oe,Me],ve.links.push(qe)}return ve}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,x){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...W);if(!H)return;const X=await this.f.resolveDocumentLink(H,x);if(!(!X||!de.g(X)))return f.DocumentLink.from(X)}releaseLinks(W){this.d.delete(W)}}class ue{constructor(W,x){this.d=W,this.e=x}async provideColors(W,x){const H=this.d.getDocument(W),X=await this.e.provideDocumentColors(H,x);return Array.isArray(X)?X.map(ve=>({color:f.Color.from(ve.color),range:f.Range.from(ve.range)})):[]}async provideColorPresentations(W,x,H){const X=this.d.getDocument(W),oe=f.Range.to(x.range),ve=f.Color.to(x.color),Me=await this.e.provideColorPresentations(ve,{document:X,range:oe},H);if(Array.isArray(Me))return Me.map(f.ColorPresentation.from)}}class ge{constructor(W,x){this.d=W,this.e=x}async provideFoldingRanges(W,x,H){const X=this.d.getDocument(W),oe=await this.e.provideFoldingRanges(X,x,H);if(Array.isArray(oe))return oe.map(f.FoldingRange.from)}}class V{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideSelectionRanges(W,x,H){const X=this.d.getDocument(W),oe=x.map(f.Position.to),ve=await this.e.provideSelectionRanges(X,oe,H);if(!(0,R.$Lb)(ve))return[];if(ve.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let qe=0;qe<oe.length;qe++){const Ge=[];Me.push(Ge);let Ye=oe[qe],it=ve[qe];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(f.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Me}}class Z{constructor(W,x){this.f=W,this.g=x,this.d=new a.$IN(""),this.e=new Map}async prepareSession(W,x,H){const X=this.f.getDocument(W),oe=f.Position.to(x),ve=await this.g.prepareCallHierarchy(X,oe,H);if(!ve)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(ve)?ve.map(qe=>this.h(Me,qe)):[this.h(Me,ve)]}async provideCallsTo(W,x,H){const X=this.j(W,x);if(!X)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(X,H);if(oe)return oe.map(ve=>({from:this.h(W,ve.from),fromRanges:ve.fromRanges.map(Me=>f.Range.from(Me))}))}async provideCallsFrom(W,x,H){const X=this.j(W,x);if(!X)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(X,H);if(oe)return oe.map(ve=>({to:this.h(W,ve.to),fromRanges:ve.fromRanges.map(Me=>f.Range.from(Me))}))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),X=f.CallHierarchyItem.from(x,W,H.size.toString(36));return H.set(X._itemId,x),X}j(W,x){return this.e.get(W)?.get(x)}}class he{constructor(W,x){this.f=W,this.g=x,this.d=new a.$IN(""),this.e=new Map}async prepareSession(W,x,H){const X=this.f.getDocument(W),oe=f.Position.to(x),ve=await this.g.prepareTypeHierarchy(X,oe,H);if(!ve)return;const Me=this.d.nextId();return this.e.set(Me,new Map),Array.isArray(ve)?ve.map(qe=>this.h(Me,qe)):[this.h(Me,ve)]}async provideSupertypes(W,x,H){const X=this.j(W,x);if(!X)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(X,H);if(oe)return oe.map(ve=>this.h(W,ve))}async provideSubtypes(W,x,H){const X=this.j(W,x);if(!X)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(X,H);if(oe)return oe.map(ve=>this.h(W,ve))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),X=f.TypeHierarchyItem.from(x,W,H.size.toString(36));return H.set(X._itemId,x),X}j(W,x){return this.e.get(W)?.get(x)}}class be{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,X,oe){this.d=W,this.e=x,this.f=H,this.g=X,this.h=oe}async provideDocumentOnDropEdits(W,x,H,X,oe){const ve=this.e.getDocument(x),Me=f.Position.to(H),qe=f.DataTransfer.toDataTransfer(X,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,W,Ye)).buffer),Ge=await this.f.provideDocumentDropEdits(ve,Me,qe,oe);if(Ge)return{label:Ge.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ge.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:be.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?f.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class Pe{constructor(W,x){this.d=W,this.e=x}async provideMappedEdits(W,x,H,X){const oe=D.URI.revive(W),ve=this.d.getDocument(oe),Me=H.documents.map(Ye=>Ye.map(it=>({uri:D.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(ut=>f.Range.to(ut))}))),qe={documents:Me,selections:Me[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(ve,x,qe,X);return Ge?f.WorkspaceEdit.from(Ge):null}}class pe{constructor(W,x){this.adapter=W,this.extension=x}}class Le{static{this.d=0}constructor(W,x,H,X,oe,ve,Me,qe){this.g=x,this.h=H,this.j=X,this.k=oe,this.l=ve,this.m=Me,this.n=qe,this.f=new Map,this.e=W.getProxy(v.$pL.MainThreadLanguageFeatures)}o(W,x){return f.DocumentSelector.from(W,this.g,x)}p(W){return new P.$rL(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Le.d++}async s(W,x,H,X,oe,ve=!1){const Me=this.f.get(W);if(!Me||!(Me.adapter instanceof x))return X;const qe=Date.now();ve||this.l.trace(`[${Me.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ge=H(Me.adapter,Me.extension);return Promise.resolve(Ge).catch(Ye=>{(0,n.$4)(Ye)||(this.l.error(`[${Me.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Me.extension.identifier,Ye))}).finally(()=>{ve||this.l.trace(`[${Me.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),E.CancellationToken.isCancellationToken(oe)?(0,o.$Xg)(Ge,oe):Ge}t(W,x){const H=this.q();return this.f.set(H,new pe(W,x)),H}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,x,H,X){const oe=this.t(new s(this.h,H),W),ve=X&&X.label||Le.u(W);return this.e.$registerDocumentSymbolProvider(oe,this.o(x,W),ve),this.p(oe)}$provideDocumentSymbols(W,x,H){return this.s(W,s,X=>X.provideDocumentSymbols(D.URI.revive(x),H),void 0,H)}registerCodeLensProvider(W,x,H){const X=this.q(),oe=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new pe(new d(this.h,this.j.converter,H,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(X,this.o(x,W),oe);let ve=this.p(X);if(oe!==void 0){const Me=H.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(oe));ve=P.$rL.from(ve,Me)}return ve}$provideCodeLenses(W,x,H){return this.s(W,d,X=>X.provideCodeLenses(D.URI.revive(x),H),void 0,H)}$resolveCodeLens(W,x,H){return this.s(W,d,X=>X.resolveCodeLens(x,H),void 0,void 0)}$releaseCodeLenses(W,x){this.s(W,d,H=>Promise.resolve(H.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(W,x,H){const X=this.t(new c(this.h,H),W);return this.e.$registerDefinitionSupport(X,this.o(x,W)),this.p(X)}$provideDefinition(W,x,H,X){return this.s(W,c,oe=>oe.provideDefinition(D.URI.revive(x),H,X),[],X)}registerDeclarationProvider(W,x,H){const X=this.t(new p(this.h,H),W);return this.e.$registerDeclarationSupport(X,this.o(x,W)),this.p(X)}$provideDeclaration(W,x,H,X){return this.s(W,p,oe=>oe.provideDeclaration(D.URI.revive(x),H,X),[],X)}registerImplementationProvider(W,x,H){const X=this.t(new I(this.h,H),W);return this.e.$registerImplementationSupport(X,this.o(x,W)),this.p(X)}$provideImplementation(W,x,H,X){return this.s(W,I,oe=>oe.provideImplementation(D.URI.revive(x),H,X),[],X)}registerTypeDefinitionProvider(W,x,H){const X=this.t(new w(this.h,H),W);return this.e.$registerTypeDefinitionSupport(X,this.o(x,W)),this.p(X)}$provideTypeDefinition(W,x,H,X){return this.s(W,w,oe=>oe.provideTypeDefinition(D.URI.revive(x),H,X),[],X)}registerHoverProvider(W,x,H,X){const oe=this.t(new g(this.h,H),W);return this.e.$registerHoverProvider(oe,this.o(x,W)),this.p(oe)}$provideHover(W,x,H,X){return this.s(W,g,oe=>oe.provideHover(D.URI.revive(x),H,X),void 0,X)}registerEvaluatableExpressionProvider(W,x,H,X){const oe=this.t(new y(this.h,H),W);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(x,W)),this.p(oe)}$provideEvaluatableExpression(W,x,H,X){return this.s(W,y,oe=>oe.provideEvaluatableExpression(D.URI.revive(x),H,X),void 0,X)}registerInlineValuesProvider(W,x,H,X){const oe=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new L(this.h,H),W);this.e.$registerInlineValuesProvider(ve,this.o(x,W),oe);let Me=this.p(ve);if(oe!==void 0){const qe=H.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(oe));Me=P.$rL.from(Me,qe)}return Me}$provideInlineValues(W,x,H,X,oe){return this.s(W,L,ve=>ve.provideInlineValues(D.URI.revive(x),H,X,oe),void 0,oe)}registerDocumentHighlightProvider(W,x,H){const X=this.t(new F(this.h,H),W);return this.e.$registerDocumentHighlightProvider(X,this.o(x,W)),this.p(X)}registerMultiDocumentHighlightProvider(W,x,H){const X=this.t(new z(this.h,H),W);return this.e.$registerMultiDocumentHighlightProvider(X,this.o(x,W)),this.p(X)}$provideDocumentHighlights(W,x,H,X){return this.s(W,F,oe=>oe.provideDocumentHighlights(D.URI.revive(x),H,X),void 0,X)}$provideMultiDocumentHighlights(W,x,H,X,oe){return this.s(W,z,ve=>ve.provideMultiDocumentHighlights(D.URI.revive(x),H,X.map(Me=>D.URI.revive(Me)),oe),void 0,oe)}registerLinkedEditingRangeProvider(W,x,H){const X=this.t(new j(this.h,H),W);return this.e.$registerLinkedEditingRangeProvider(X,this.o(x,W)),this.p(X)}$provideLinkedEditingRanges(W,x,H,X){return this.s(W,j,async oe=>{const ve=await oe.provideLinkedEditingRanges(D.URI.revive(x),H,X);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Le.w(ve.wordPattern):void 0}},void 0,X)}registerReferenceProvider(W,x,H){const X=this.t(new O(this.h,H),W);return this.e.$registerReferenceSupport(X,this.o(x,W)),this.p(X)}$provideReferences(W,x,H,X,oe){return this.s(W,O,ve=>ve.provideReferences(D.URI.revive(x),H,X,oe),void 0,oe)}registerCodeActionProvider(W,x,H,X){const oe=new u.$Sc,ve=this.t(new M(this.h,this.j.converter,this.k,H,this.l,W,this.m),W);return this.e.$registerQuickFixSupport(ve,this.o(x,W),{providedKinds:X?.providedCodeActionKinds?.map(Me=>Me.value),documentation:X?.documentation?.map(Me=>({kind:Me.kind.value,command:this.j.converter.toInternal(Me.command,oe)}))},Le.u(W),!!H.resolveCodeAction),oe.add(this.p(ve)),oe}$provideCodeActions(W,x,H,X,oe){return this.s(W,M,ve=>ve.provideCodeActions(D.URI.revive(x),H,X,oe),void 0,oe)}$resolveCodeAction(W,x,H){return this.s(W,M,X=>X.resolveCodeAction(x,H),{},void 0)}$releaseCodeActions(W,x){this.s(W,M,H=>Promise.resolve(H.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(W,x,H){const X=this.t(new U(this.h,H),W);return this.e.$registerDocumentFormattingSupport(X,this.o(x,W),W.identifier,W.displayName||W.name),this.p(X)}$provideDocumentFormattingEdits(W,x,H,X){return this.s(W,U,oe=>oe.provideDocumentFormattingEdits(D.URI.revive(x),H,X),void 0,X)}registerDocumentRangeFormattingEditProvider(W,x,H){const X=typeof H.provideDocumentRangesFormattingEdits=="function",oe=this.t(new J(this.h,H),W);return this.e.$registerRangeFormattingSupport(oe,this.o(x,W),W.identifier,W.displayName||W.name,X),this.p(oe)}$provideDocumentRangeFormattingEdits(W,x,H,X,oe){return this.s(W,J,ve=>ve.provideDocumentRangeFormattingEdits(D.URI.revive(x),H,X,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(W,x,H,X,oe){return this.s(W,J,ve=>ve.provideDocumentRangesFormattingEdits(D.URI.revive(x),H,X,oe),void 0,oe)}registerOnTypeFormattingEditProvider(W,x,H,X){const oe=this.t(new ne(this.h,H),W);return this.e.$registerOnTypeFormattingSupport(oe,this.o(x,W),X,W.identifier),this.p(oe)}$provideOnTypeFormattingEdits(W,x,H,X,oe,ve){return this.s(W,ne,Me=>Me.provideOnTypeFormattingEdits(D.URI.revive(x),H,X,oe,ve),void 0,ve)}registerWorkspaceSymbolProvider(W,x){const H=this.t(new ee(x,this.l),W);return this.e.$registerNavigateTypeSupport(H,typeof x.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(W,x,H){return this.s(W,ee,X=>X.provideWorkspaceSymbols(x,H),{symbols:[]},H)}$resolveWorkspaceSymbol(W,x,H){return this.s(W,ee,X=>X.resolveWorkspaceSymbol(x,H),void 0,void 0)}$releaseWorkspaceSymbols(W,x){this.s(W,ee,H=>H.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(W,x,H){const X=this.t(new Q(this.h,H,this.l),W);return this.e.$registerRenameSupport(X,this.o(x,W),Q.supportsResolving(H)),this.p(X)}$provideRenameEdits(W,x,H,X,oe){return this.s(W,Q,ve=>ve.provideRenameEdits(D.URI.revive(x),H,X,oe),void 0,oe)}$resolveRenameLocation(W,x,H,X){return this.s(W,Q,oe=>oe.resolveRenameLocation(D.URI.revive(x),H,X),void 0,X)}registerNewSymbolNamesProvider(W,x,H){const X=this.t(new Y(this.h,H,this.l),W);return this.e.$registerNewSymbolNamesProvider(X,this.o(x,W)),this.p(X)}$provideNewSymbolNames(W,x,H,X){return this.s(W,Y,oe=>oe.provideNewSymbolNames(D.URI.revive(x),H,X),void 0,X)}registerDocumentSemanticTokensProvider(W,x,H,X){const oe=this.t(new te(this.h,H),W),ve=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(x,W),X,ve);let Me=this.p(oe);if(ve){const qe=H.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(ve));Me=P.$rL.from(Me,qe)}return Me}$provideDocumentSemanticTokens(W,x,H,X){return this.s(W,te,oe=>oe.provideDocumentSemanticTokens(D.URI.revive(x),H,X),null,X)}$releaseDocumentSemanticTokens(W,x){this.s(W,te,H=>H.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,x,H,X){const oe=this.t(new fe(this.h,H),W);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(x,W),X),this.p(oe)}$provideDocumentRangeSemanticTokens(W,x,H,X){return this.s(W,fe,oe=>oe.provideDocumentRangeSemanticTokens(D.URI.revive(x),H,X),null,X)}registerCompletionItemProvider(W,x,H,X){const oe=this.t(new re(this.h,this.j.converter,H,this.m,W),W);return this.e.$registerCompletionsProvider(oe,this.o(x,W),X,re.supportsResolving(H),W.identifier),this.p(oe)}$provideCompletionItems(W,x,H,X,oe){return this.s(W,re,ve=>ve.provideCompletionItems(D.URI.revive(x),H,X,oe),void 0,oe)}$resolveCompletionItem(W,x,H){return this.s(W,re,X=>X.resolveCompletionItem(x,H),void 0,H)}$releaseCompletionItems(W,x){this.s(W,re,H=>H.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(W,x,H,X){const oe=new B(W,this.h,H,this.j.converter),ve=this.t(oe,W);return this.e.$registerInlineCompletionsSupport(ve,this.o(x,W),oe.supportsHandleEvents,S.$om.toKey(W.identifier.value),X?.yieldTo?.map(Me=>S.$om.toKey(Me))||[]),this.p(ve)}$provideInlineCompletions(W,x,H,X,oe){return this.s(W,K,ve=>ve.provideInlineCompletions(D.URI.revive(x),H,X,oe),void 0,oe)}$handleInlineCompletionDidShow(W,x,H,X){this.s(W,K,async oe=>{oe.handleDidShowCompletionItem(x,H,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,x,H,X){this.s(W,K,async oe=>{oe.handlePartialAccept(x,H,X)},void 0,void 0)}$freeInlineCompletionsList(W,x){this.s(W,K,async H=>{H.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(W,x,H,X){const oe=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,ve=this.t(new Ee(this.h,H),W);return this.e.$registerSignatureHelpProvider(ve,this.o(x,W),oe),this.p(ve)}$provideSignatureHelp(W,x,H,X,oe){return this.s(W,Ee,ve=>ve.provideSignatureHelp(D.URI.revive(x),H,X,oe),void 0,oe)}$releaseSignatureHelp(W,x){this.s(W,Ee,H=>H.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(W,x,H){const X=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new le(this.h,this.j.converter,H,this.l,W),W);this.e.$registerInlayHintsProvider(oe,this.o(x,W),typeof H.resolveInlayHint=="function",X,Le.u(W));let ve=this.p(oe);if(X!==void 0){const Me=H.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(X));ve=P.$rL.from(ve,Me)}return ve}$provideInlayHints(W,x,H,X){return this.s(W,le,oe=>oe.provideInlayHints(D.URI.revive(x),H,X),void 0,X)}$resolveInlayHint(W,x,H){return this.s(W,le,X=>X.resolveInlayHint(x,H),void 0,H)}$releaseInlayHints(W,x){this.s(W,le,H=>H.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(W,x,H){const X=this.t(new de(this.h,H),W);return this.e.$registerDocumentLinkProvider(X,this.o(x,W),typeof H.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(W,x,H){return this.s(W,de,X=>X.provideLinks(D.URI.revive(x),H),void 0,H,x.scheme==="output")}$resolveDocumentLink(W,x,H){return this.s(W,de,X=>X.resolveLink(x,H),void 0,void 0,!0)}$releaseDocumentLinks(W,x){this.s(W,de,H=>H.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(W,x,H){const X=this.t(new ue(this.h,H),W);return this.e.$registerDocumentColorProvider(X,this.o(x,W)),this.p(X)}$provideDocumentColors(W,x,H){return this.s(W,ue,X=>X.provideColors(D.URI.revive(x),H),[],H)}$provideColorPresentations(W,x,H,X){return this.s(W,ue,oe=>oe.provideColorPresentations(D.URI.revive(x),H,X),void 0,X)}registerFoldingRangeProvider(W,x,H){const X=this.q(),oe=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new pe(new ge(this.h,H),W)),this.e.$registerFoldingRangeProvider(X,this.o(x,W),W.identifier,oe);let ve=this.p(X);if(oe!==void 0){const Me=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));ve=P.$rL.from(ve,Me)}return ve}$provideFoldingRanges(W,x,H,X){return this.s(W,ge,oe=>oe.provideFoldingRanges(D.URI.revive(x),H,X),void 0,X)}registerSelectionRangeProvider(W,x,H){const X=this.t(new V(this.h,H,this.l),W);return this.e.$registerSelectionRangeProvider(X,this.o(x,W)),this.p(X)}$provideSelectionRanges(W,x,H,X){return this.s(W,V,oe=>oe.provideSelectionRanges(D.URI.revive(x),H,X),[],X)}registerCallHierarchyProvider(W,x,H){const X=this.t(new Z(this.h,H),W);return this.e.$registerCallHierarchyProvider(X,this.o(x,W)),this.p(X)}$prepareCallHierarchy(W,x,H,X){return this.s(W,Z,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(x),H,X)),void 0,X)}$provideCallHierarchyIncomingCalls(W,x,H,X){return this.s(W,Z,oe=>oe.provideCallsTo(x,H,X),void 0,X)}$provideCallHierarchyOutgoingCalls(W,x,H,X){return this.s(W,Z,oe=>oe.provideCallsFrom(x,H,X),void 0,X)}$releaseCallHierarchy(W,x){this.s(W,Z,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(W,x,H){const X=this.t(new he(this.h,H),W);return this.e.$registerTypeHierarchyProvider(X,this.o(x,W)),this.p(X)}$prepareTypeHierarchy(W,x,H,X){return this.s(W,he,oe=>Promise.resolve(oe.prepareSession(D.URI.revive(x),H,X)),void 0,X)}$provideTypeHierarchySupertypes(W,x,H,X){return this.s(W,he,oe=>oe.provideSupertypes(x,H,X),void 0,X)}$provideTypeHierarchySubtypes(W,x,H,X){return this.s(W,he,oe=>oe.provideSubtypes(x,H,X),void 0,X)}$releaseTypeHierarchy(W,x){this.s(W,he,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(W,x,H,X){const oe=this.q();this.f.set(oe,new pe(new be(this.e,this.h,H,oe,W),W));const ve=(0,t.$LF)(W,"dropMetadata")&&X?be.toInternalProviderId(W.identifier.value,X.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(x,W),ve,(0,t.$LF)(W,"dropMetadata")?X:void 0),this.p(oe)}$provideDocumentOnDropEdits(W,x,H,X,oe,ve){return this.s(W,be,Me=>Promise.resolve(Me.provideDocumentOnDropEdits(x,D.URI.revive(H),X,oe,ve)),void 0,void 0)}registerMappedEditsProvider(W,x,H){const X=this.t(new Pe(this.h,H),W);return this.e.$registerMappedEditsProvider(X,this.o(x,W)),this.p(X)}$provideMappedEdits(W,x,H,X,oe){return this.s(W,Pe,ve=>Promise.resolve(ve.provideMappedEdits(x,H,X,oe)),null,oe)}registerDocumentPasteEditProvider(W,x,H,X){const oe=this.q();this.f.set(oe,new pe(new T(this.e,this.h,H,oe,W),W));const ve=T.toInternalProviderId(W.identifier.value,X.id);return this.e.$registerPasteEditProvider(oe,this.o(x,W),ve,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(W,x,H,X,oe){return this.s(W,T,ve=>ve.prepareDocumentPaste(D.URI.revive(x),H,X,oe),void 0,oe)}$providePasteEdits(W,x,H,X,oe,ve){return this.s(W,T,Me=>Me.providePasteEdits(x,D.URI.revive(H),X,oe,ve),void 0,ve)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:Le.w(W.decreaseIndentPattern),increaseIndentPattern:Le.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Le.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Le.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:Le.w(W.beforeText),afterText:W.afterText?Le.w(W.afterText):void 0,previousLineText:W.previousLineText?Le.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(Le.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(x=>P.SyntaxTokenType.toString(x)):void 0}}static D(W){return W.map(Le.C)}setLanguageConfiguration(W,x,H){const{wordPattern:X}=H;if(X&&(0,$.$Ze)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(x,X):this.h.setWordDefinitionFor(x,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const oe=this.q(),ve={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,x,ve),this.p(oe)}$setWordDefinitions(W){for(const x of W)this.h.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.$Hgc=Le}),define(Ce[332],Ie([1,0,6,16,7,39,8,3,26]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class k{constructor(C,b,E,S){this.c=b,this.d=E,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$pL.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,b){await this.a.$changeLanguage(C,b);const E=this.c.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,b){const E=C.version,S=N.Position.from(b),u=await this.a.$tokensAtPosition(C.uri,S),m={type:f.StandardTokenType.Other,range:C.getWordRangeAtPosition(b)??new f.$tL(b.line,b.character,b.line,b.character)};if(!u)return m;const a={range:N.Range.to(u.range),type:N.TokenType.to(u.type)};return!a.range.contains(b)||E!==C.version?m:a}createLanguageStatusItem(C,b,E){const S=this.f++,u=this.a,m=this.g,a=`${C.identifier.value}/${b}`;if(m.has(a))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);m.add(a);const i={selector:E,id:b,name:C.displayName??C.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new v.$Sc,o=()=>{if(r?.dispose(),!m.has(a)){console.warn(`LanguageStatusItem (${b}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,A.$$g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:a,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?P.default.Error:i.severity===f.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),u.$removeLanguageStatus(S),m.delete(a)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,o()},get selector(){return i.selector},set selector(h){i.selector=h,o()},get text(){return i.text},set text(h){i.text=h,o()},set text2(h){(0,$.$MF)(C,"languageStatusText"),i.text=h,o()},get text2(){return(0,$.$MF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,o()},get severity(){return i.severity},set severity(h){i.severity=h,o()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,o()},get command(){return i.command},set command(h){i.command=h,o()},get busy(){return i.busy},set busy(h){i.busy=h,o()}};return o(),t}}e.$7hc=k}),define(Ce[333],Ie([1,0,15,2,16,7,118]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0;class v{constructor(C,b,E,S){this.start=C,this.deletedCount=b,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new P.$QM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,b){return{EOL:b.eol,lines:b.source,languageId:b.language,uri:b.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,b,E){this.notebook=C,this.h=b,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(f.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,b=this.h.getDocument(this.uri);if(!b)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:b.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(E)}return this.f}setOutputs(C){this.a=C.map(f.NotebookCellOutput.to)}setOutputItems(C,b,E){const S=E.map(f.NotebookCellOutputItem.to),u=this.a.find(m=>m.id===C);if(u&&(b||(u.items.length=0),u.items.push(...S),u.items.length>1&&u.items.every(m=>A.$rJ(m.mime)))){const m=new Map,a=[];u.items.forEach(i=>{let r;m.has(i.mime)?r=m.get(i.mime):(r=[],m.set(i.mime,r),a.push(i.mime)),r.push(i.data)}),u.items.length=0,a.forEach(i=>{const r=A.$sJ(m.get(i));u.items.push({mime:i,data:r.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Rhc=$;class k{static{this.a=0}constructor(C,b,E,S,u){this.k=C,this.l=b,this.m=E,this.uri=S,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,b={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(E){return E=C.n(E),C.b[E].apiCell},getCells(E){return(E?C.p(E):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(b)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,b,E){this.g=C.versionId,this.h=b,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},u=[];for(const a of C.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,S.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,S.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),u.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),u.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const m=new Map;for(let a=0;a<u.length;a++){const i=u[a],r=m.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let b=C.start|0,E=C.end|0;return b<0&&(b=0),E>this.b.length&&(E=this.b.length),C.with({start:b,end:E})}p(C){C=this.o(C);const b=[];for(let E=C.start;E<C.end;E++)b.push(this.b[E]);return b}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,b,E){if(this.j)return;const S=[],u=[],m=[];if(C.reverse().forEach(a=>{const r=a[2].map(t=>{const h=new $(this,this.l,t);return b||u.push($.asModelAddData(this.apiNotebook,t)),h}),n=new v(a[0],a[1],[],r),o=this.b.splice(a[0],a[1],...r);for(const t of o)m.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:m}),E)for(const a of S)E.push(a.asApiEvent())}s(C,b,E,S){const u=this.b.splice(C,b);this.b.splice(E,0,...u);const m=[new v(C,b,u.map(a=>a.apiCell),[]),new v(E,0,[],u)];for(const a of m)S.push(a.asApiEvent())}t(C,b){this.b[C].setOutputs(b)}u(C,b,E,S){this.b[C].setOutputItems(b,E,S)}v(C,b){const E=this.b[C];E.apiCell.document.languageId!==b&&this.m.$acceptModelLanguageChanged(E.uri,b)}w(C,b){const E=this.b[C];E.apiCell.mime=b}x(C,b){this.b[C].setMetadata(b)}y(C,b){this.b[C].setInternalMetadata(b)}getCellFromApiCell(C){return this.b.find(b=>b.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(b=>b.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Shc=k}),define(Ce[334],Ie([1,0,4,2,16,7]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class A{constructor($,k,R,C={timeout:1500,errors:3}){this.b=$,this.c=k,this.d=R,this.f=C,this.a=new D.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(k,R,C)=>{const b=function(S){k.call(R,S)};return b.extension=$,this.a.event(b,void 0,C)}}async $participateInSave($,k,R){const C=N.URI.revive($),b=this.c.getNotebookDocument(C);if(!b)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:b.apiNotebook,reason:f.TextDocumentSaveReason.to(k)},R,async(u,m)=>{const a=Date.now(),i=await await Promise.resolve(u);Date.now()-a>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof P.$BL?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const u of E){const{edits:m}=f.WorkspaceEdit.from(u);S.edits=S.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$9hc=A}),define(Ce[150],Ie([1,0,14,16,7]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,$,k,R,C,b){this.id=v,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=b}get apiEditor(){if(!this.e){const v=this;this.e={get notebook(){return v.notebookData.apiNotebook},get selection(){return v.a[0]},set selection($){this.selections=[$]},get selections(){return v.a},set selections($){if(!Array.isArray($)||!$.every(f.$QM.isNotebookRange))throw(0,D.$7)("selections");v.a=$,v.g($)},get visibleRanges(){return v.b},revealRange($,k){v.f.$tryRevealRange(v.id,N.NotebookRange.from($),k??f.NotebookEditorRevealType.Default)},get viewColumn(){return v.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(v){this.d=v}_acceptVisibleRanges(v){this.b=v}_acceptSelections(v){this.a=v}g(v){this.f.$trySetSelections(this.id,v.map(N.NotebookRange.from))}_acceptViewColumn(v){this.c=v}}e.$Thc=P}),define(Ce[335],Ie([1,0,4,13,16]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let P=class{constructor(v,$){this.c=v,this.d=$,this.a=new D.$Wd,this.b=new D.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,$);const k=this.d.getEditorById(v);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(f.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(f.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const $ in v)this.d.getEditorById($)._acceptViewColumn(f.ViewColumn.to(v[$]))}};e.$$hc=P,e.$$hc=P=Ke([We(0,N.$qj)],P)}),define(Ce[336],Ie([1,0,4,6,150]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class P{constructor(v,$){this.c=$,this.a=new Map,this.b=v.getProxy(N.$pL.MainThreadNotebookRenderers)}$postRendererMessage(v,$,k){const R=this.c.getEditorById(v);this.a.get($)?.fire({editor:R.apiEditor,message:k})}createRendererMessaging(v,$){if(!v.contributes?.notebookRenderer?.some(R=>R.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(R,C,b)=>this.d($).event(R,C,b),postMessage:(R,C)=>{f.$Thc.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const b=C&&f.$Thc.apiEditorsToExtHost.get(C);return this.b.$postMessage(b?.id,$,R)}}}d(v){let $=this.a.get(v);return $||($=new D.$Wd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(v)}}),this.a.set(v,$),$)}}e.$bic=P}),define(Ce[337],Ie([1,0,16,107,22,52,14]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class v{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,b,E){const S=this.b++,{title:u,location:m,cancellable:a}=b,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:D.ProgressLocation.from(m),title:u,source:i,cancellable:a},C.isUnderDevelopment?void 0:C.identifier.value).catch(A.$2),this.d(S,E,!!a)}d(C,b,E){let S;E&&(S=new f.$7d,this.c.set(C,S));const u=a=>{this.a.$progressEnd(a),this.c.delete(a),S?.dispose()};let m;try{m=b(new k(this.a,C),E&&S?S.token:f.CancellationToken.None)}catch(a){throw u(C),a}return m.then(a=>u(C),a=>u(C)),m}$acceptProgressCanceled(C){const b=this.c.get(C);b&&(b.cancel(),this.c.delete(C))}}e.$fic=v;function $(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class k extends N.$yv{constructor(C,b){super(E=>this.throttledReport(E)),this.c=C,this.d=b}throttledReport(C){this.c.$progressReport(this.d,C)}}Ke([(0,P.$Ch)(100,(R,C)=>$(R,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ce[338],Ie([1,0,2,6,8,16]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;class A{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(N.$pL.MainThreadQuickDiff)}$provideOriginalResource($,k,R){const C=D.URI.revive(k),b=this.c.get($);return b?(0,f.$1g)(()=>b.provideOriginalResource(C,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,k,R,C){const b=A.a++;return this.c.set(b,k),this.b.$registerQuickDiffProvider(b,P.DocumentSelector.from($,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(b),this.c.delete(b)}}}}e.$gic=A}),define(Ce[339],Ie([1,0,22,4,3,6,2,7,14,19,39,55,26,16]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;function S(u,m,a){const i=u.getProxy(P.$pL.MainThreadQuickOpen);class r{constructor(p,I){this.e=new Map,this.f=0,this.a=p,this.b=I}showQuickPick(p,I,w,g=D.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),L=++this.f,F=i.$show(L,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},g),z={},j=F.then(()=>z);return Promise.race([j,y]).then(O=>{if(O===z)return;const M=(0,b.$LF)(p,"quickPickItemTooltip");return y.then(T=>{const U=[];for(let J=0;J<T.length;J++){const ne=T[J];if(typeof ne=="string")U.push({label:ne,handle:J});else if(ne.kind===v.QuickPickItemKind.Separator)U.push({type:"separator",label:ne.label});else{ne.tooltip&&!M&&console.warn(`Extension '${p.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`);const ee=ne.iconPath?s(ne.iconPath):void 0;U.push({label:ne.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:M?E.MarkdownString.fromStrict(ne.tooltip):void 0,handle:J})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=J=>{w.onDidSelectItem(T[J])}),i.$setItems(L,U),F.then(J=>{if(typeof J=="number")return T[J];if(Array.isArray(J))return J.map(ne=>T[ne])})})}).then(void 0,O=>{if(!(0,$.$4)(O))return i.$setError(L,O),Promise.reject(O)})}$onItemSelected(p){this.c?.(p)}showInput(p,I=D.CancellationToken.None){return this.d=p?.validateInput,i.$input(p,typeof this.d=="function",I).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(p){if(!this.d)return;const I=await this.d(p);if(!I||typeof I=="string")return I;let w;switch(I.severity){case v.InputBoxValidationSeverity.Info:w=R.default.Info;break;case v.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case v.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:w}}async showWorkspaceFolderPick(p,I=D.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[p]);if(!w)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(p){const I=new d(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(p){const I=new l(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(p,I){this.e.get(p)?._fireDidChangeValue(I)}$onDidAccept(p){this.e.get(p)?._fireDidAccept()}$onDidChangeActive(p,I){const w=this.e.get(p);w instanceof d&&w._fireDidChangeActive(I)}$onDidChangeSelection(p,I){const w=this.e.get(p);w instanceof d&&w._fireDidChangeSelection(I)}$onDidTriggerButton(p,I){this.e.get(p)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(p,I,w){const g=this.e.get(p);g instanceof d&&g._fireDidTriggerItemButton(I,w)}$onDidHide(p){this.e.get(p)?._fireDidHide()}}class n{static{this.a=1}constructor(p,I){this.x=p,this.y=I,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Wd,this.q=new N.$Wd,this.r=new N.$Wd,this.s=new N.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(p){this.b=p,this.z({title:p})}get step(){return this.c}set step(p){this.c=p,this.z({step:p})}get totalSteps(){return this.d}set totalSteps(p){this.d=p,this.z({totalSteps:p})}get enabled(){return this.g}set enabled(p){this.g=p,this.z({enabled:p})}get busy(){return this.j}set busy(p){this.j=p,this.z({busy:p})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(p){this.k=p,this.z({ignoreFocusOut:p})}get value(){return this.l}set value(p){this.l=p,this.z({value:p})}get placeholder(){return this.m}set placeholder(p){this.m=p,this.z({placeholder:p})}get buttons(){return this.n}set buttons(p){this.n=p.slice(),this.o.clear(),p.forEach((I,w)=>{const g=I===v.$NM.Back?-1:w;this.o.set(g,I)}),this.z({buttons:p.map((I,w)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===v.$NM.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(p){this.l=p,this.q.fire(p)}_fireDidTriggerButton(p){const I=this.o.get(p);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(p){if(!this.v){for(const I of Object.keys(p)){const w=p[I];this.u[I]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function o(c){if(c instanceof v.$mM)return{id:c.id};const p=h(c),I=t(c);return{dark:typeof p=="string"?A.URI.file(p):p,light:typeof I=="string"?A.URI.file(I):I}}function t(c){return typeof c=="object"&&"light"in c?c.light:c}function h(c){return typeof c=="object"&&"dark"in c?c.dark:c}function s(c){const p=o(c);let I,w;return"id"in p?w=C.ThemeIcon.asClassName(p):I=p,{iconPath:I,iconClass:w}}class d extends n{constructor(p,I){super(p.identifier,I),this.O=p,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Wd,this.L=[],this.M=new N.$Wd,this.N=new N.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(p){this.B=p.slice(),this.C.clear(),this.D.clear(),p.forEach((g,y)=>{this.C.set(y,g),this.D.set(g,y)});const I=(0,b.$LF)(this.O,"quickPickItemTooltip"),w=[];for(let g=0;g<p.length;g++){const y=p[g];if(y.kind===v.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=y.iconPath?s(y.iconPath):void 0;w.push({handle:g,label:y.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((F,z)=>({...s(F.iconPath),tooltip:F.tooltip,handle:z}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(p){this.E=p,this.z({canSelectMany:p})}get matchOnDescription(){return this.F}set matchOnDescription(p){this.F=p,this.z({matchOnDescription:p})}get matchOnDetail(){return this.G}set matchOnDetail(p){this.G=p,this.z({matchOnDetail:p})}get sortByLabel(){return this.H}set sortByLabel(p){this.H=p,this.z({sortByLabel:p})}get keepScrollPosition(){return this.I}set keepScrollPosition(p){this.I=p,this.z({keepScrollPosition:p})}get activeItems(){return this.J}set activeItems(p){this.J=p.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(p){this.L=p.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(p){const I=(0,k.$Hb)(p.map(w=>this.C.get(w)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(p){const I=(0,k.$Hb)(p.map(w=>this.C.get(w)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(p,I){const w=this.C.get(p);if(!w||!w.buttons||!w.buttons.length)return;const g=w.buttons[I];g&&this.N.fire({button:g,item:w})}}class l extends n{constructor(p,I){super(p.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(p){this.B=p,this.z({password:p})}get prompt(){return this.C}set prompt(p){this.C=p,this.z({prompt:p})}get valueSelection(){return this.D}set valueSelection(p){this.D=p,this.z({valueSelection:p})}get validationMessage(){return this.E}set validationMessage(p){this.E=p,p?typeof p=="string"?this.z({validationMessage:p,severity:R.default.Error}):this.z({validationMessage:p.message,severity:p.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new r(m,a)}e.$hic=S}),define(Ce[340],Ie([1,0,2,4,52,3,8,6,19,128,13,25,55,16,26,15,11]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=void 0;function i(L){return L instanceof D.URI}function r(L,F){return L.scheme===u.Schemas.file&&F.scheme===u.Schemas.file&&m.$k?L.toString()===F.toString():L.toString().toLowerCase()===F.toString().toLowerCase()}function n(L){if(L)return typeof L.iconPath=="string"?D.URI.file(L.iconPath):D.URI.isUri(L.iconPath)||b.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function o(L){if(L.icon){if(D.URI.isUri(L.icon))return L.icon;if(b.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const F=L.icon;return{light:F.light,dark:F.dark}}}else return}function t(L,F){if(!L.iconPath&&!F.iconPath)return 0;if(L.iconPath){if(!F.iconPath)return 1}else return-1;const z=typeof L.iconPath=="string"?L.iconPath:D.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,j=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,k.$Vq)(z,j)}function h(L,F){let z=0;if(L.strikeThrough!==F.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==F.faded)return L.faded?1:-1;if(L.tooltip!==F.tooltip)return(L.tooltip||"").localeCompare(F.tooltip||"");if(z=t(L,F),z!==0)return z;if(L.light&&F.light)z=t(L.light,F.light);else{if(L.light)return 1;if(F.light)return-1}if(z!==0)return z;if(L.dark&&F.dark)z=t(L.dark,F.dark);else{if(L.dark)return 1;if(F.dark)return-1}return z}function s(L,F){if(L.command!==F.command)return L.command<F.command?-1:1;if(L.title!==F.title)return L.title<F.title?-1:1;if(L.tooltip!==F.tooltip){if(L.tooltip!==void 0&&F.tooltip!==void 0)return L.tooltip<F.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(L.arguments===F.arguments)return 0;if(L.arguments)if(F.arguments){if(L.arguments.length!==F.arguments.length)return L.arguments.length-F.arguments.length}else return 1;else return-1;for(let z=0;z<L.arguments.length;z++){const j=L.arguments[z],O=F.arguments[z];if(j!==O&&!(i(j)&&i(O)&&r(j,O)))return j<O?-1:1}return 0}function d(L,F){let z=(0,k.$Vq)(L.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(z!==0)return z;if(L.command&&F.command)z=s(L.command,F.command);else{if(L.command)return 1;if(F.command)return-1}if(z!==0)return z;if(L.decorations&&F.decorations)z=h(L.decorations,F.decorations);else{if(L.decorations)return 1;if(F.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)z=(0,k.$Vq)(L.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)z=(0,k.$Vq)(L.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return z}function l(L,F){for(let z=0;z<L.length;z++)if(L[z]!==F[z])return!1;return!0}function c(L,F){return L.command===F.command&&L.title===F.title&&L.tooltip===F.tooltip&&(L.arguments&&F.arguments?l(L.arguments,F.arguments):L.arguments===F.arguments)}function p(L,F){return(0,$.$ub)(L,F,c)}class I{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.l,F),this.n(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.l,F),this.f=F}get validateInput(){return(0,S.$MF)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,S.$MF)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.l,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.l,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.l,F))}get document(){return(0,S.$MF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(F,z,j,O,M){this.k=F,this.l=O,this.m=M,this.d="",this.e=new N.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=j}showValidationMessage(F,z){(0,S.$MF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,F,z)}$onInputBoxValueChange(F){this.n(F)}n(F){this.d=F,this.e.fire(F)}}e.$iic=I;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,z,j,O,M,T,U){this.q=F,this.s=z,this.t=j,this.u=O,this.v=M,this.multiDiffEditorEnableViewChanges=T,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,z){const j=this.h.get(F);return j?(0,A.$1g)(()=>this.s.executeCommand(j.command,...j.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(d),j=(0,$.$Db)(this.o,F,d).map(T=>{const U=T.toInsert.map(J=>{const ne=this.e++;this.g.set(ne,J);const ee=J.resourceUri;let Q;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const ge=new P.$Sc;Q=this.s.converter.toInternal(J.command,ge),this.j.set(ne,ge)}else this.h.set(ne,J.command);const Y=(0,S.$LF)(this.w,"scmMultiDiffEditor"),ce=Y?J.multiDiffEditorOriginalUri:void 0,te=Y?J.multiFileDiffEditorModifiedUri:void 0,fe=n(J.decorations),re=J.decorations&&n(J.decorations.light)||fe,K=J.decorations&&n(J.decorations.dark)||fe,B=[re,K],ae=J.decorations&&J.decorations.tooltip||"",Ee=J.decorations&&!!J.decorations.strikeThrough,le=J.decorations&&!!J.decorations.faded,de=J.contextValue||"";return{rawResource:[ne,ee,B,ae,Ee,le,de,Q,ce,te],handle:ne}});return{start:T.start,deleteCount:T.deleteCount,toInsert:U}}),O=j.map(({start:T,deleteCount:U,toInsert:J})=>[T,U,J.map(ne=>ne.rawResource)]),M=j.reverse();for(const{start:T,deleteCount:U,toInsert:J}of M){const ne=J.map(Q=>Q.handle),ee=this.n.splice(T,U,...ne);for(const Q of ee)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=F,O}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.w,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let z;(0,S.$LF)(this.x,"quickDiffProvider")&&(z=F?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!F,quickDiffLabel:z})}get historyProvider(){return(0,S.$MF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(F){(0,S.$MF)(this.x,"scmHistoryProvider"),this.j=F,this.k.value=new P.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(F){F!==this.m&&(this.m=F,this.#e.$updateSourceControl(this.w,{commitTemplate:F}))}get acceptInputCommand(){return this.o}set acceptInputCommand(F){this.n.value=new P.$Sc,this.o=F;const z=this.y.converter.toInternal(F,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,S.$MF)(this.x,"scmActionButton"),this.q}set actionButton(F){(0,S.$MF)(this.x,"scmActionButton"),this.p.value=new P.$Sc,this.q=F;const z=F!==void 0?{command:this.y.converter.toInternal(F.command,this.p.value),secondaryCommands:F.secondaryCommands?.map(j=>j.map(O=>this.y.converter.toInternal(O,this.p.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(F){if(this.t&&F&&p(this.t,F))return;this.s.value=new P.$Sc,this.t=F;const z=(F||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(F,z,j,O,M,T,U){this.x=F,this.y=O,this.z=M,this.A=T,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Uc,this.m=void 0,this.n=new P.$Uc,this.o=void 0,this.p=new P.$Uc,this.s=new P.$Uc,this.t=void 0,this.u=!1,this.v=new N.$Wd,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.C=new Map,this.D=new Set,this.#e=j;const J=D.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new I(F,z,this.#e,this.w,J),this.#e.$registerSourceControl(this.w,M,T,U,J)}createResourceGroup(F,z,j){const O=(0,S.$LF)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,M=new w(this.#e,this.y,this.w,F,z,O,this.x),T=N.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,T),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const F=[],z=[];for(const[j,O]of this.C){O.dispose();const M=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),M.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),F.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&z.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,F,z),this.C.clear()}eventuallyUpdateResourceStates(){const F=[];this.D.forEach(z=>{const j=z._takeResourceStateSnapshot();j.length!==0&&F.push([z.handle,j])}),F.length>0&&this.#e.$spliceResourceStates(this.w,F),this.D.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.u=F,this.v.fire(F)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ke([(0,f.$Bh)(100)],g.prototype,"eventuallyAddResourceGroups",null),Ke([(0,f.$Bh)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,z,j,O){this.l=z,this.m=j,this.n=O,this.g=new Map,this.h=new C.$qm,this.j=new N.$Wd,this.e=F.getProxy(v.$pL.MainThreadSCM),this.f=F.getProxy(v.$pL.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const T=this.g.get(M.sourceControlHandle);if(!T)return M;const U=T.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const T=this.g.get(M.sourceControlHandle);return T?T.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const T=this.g.get(M.handle);return T||M}return M}})}createSourceControl(F,z,j,O){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,z,j,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const M=a.d++,T=new g(F,this.m,this.e,this.l,z,j,O);this.g.set(M,T);const U=this.h.get(F.identifier)||[];return U.push(T),this.h.set(F.identifier,U),T}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const z=this.h.get(F.identifier),j=z&&z[z.length-1];return j&&j.inputBox}$provideOriginalResource(F,z,j){const O=D.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",F,O.toString());const M=this.g.get(F);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$1g)(()=>M.quickDiffProvider.provideOriginalResource(O,j)).then(T=>T||null)}$onInputBoxValueChange(F,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const j=this.g.get(F);return j&&j.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(F,z,j,O){this.n.trace("ExtHostSCM#$executeResourceCommand",F,z,j);const M=this.g.get(F);if(!M)return Promise.resolve(void 0);const T=M.getResourceGroup(z);return T?T.$executeResourceCommand(j,O):Promise.resolve(void 0)}$validateInput(F,z,j){this.n.trace("ExtHostSCM#$validateInput",F);const O=this.g.get(F);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$1g)(()=>O.inputBox.validateInput(z,j)).then(M=>{if(!M)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(M.message);return T?Promise.resolve([T,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,z,j,O){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,j,O)??void 0}async $provideHistoryItems(F,z,j,O){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(z,j,O))?.map(U=>({...U,icon:o(U)}))??void 0}async $provideHistoryItemSummary(F,z,j,O){const M=this.g.get(F)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const T=await M.provideHistoryItemSummary(z,j,O);return T?{...T,icon:o(T)}:void 0}async $provideHistoryItemChanges(F,z,j,O){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(z,j,O)??void 0}};e.$jic=y,e.$jic=y=a=Ke([We(3,R.$qj)],y)}),define(Ce[341],Ie([1,0,6,16,2]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class P{static{this.a=0}constructor(v,$){this.d=$,this.c=new Map,this.b=v.getProxy(D.$pL.MainThreadShare)}async $provideShare(v,$,k){return await this.c.get(v)?.provideShare({selection:N.Range.to($.selection),resourceUri:f.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(v,$){const k=P.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,N.DocumentSelector.from(v,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$kic=P}),define(Ce[342],Ie([1,0,7,6,218,3,16,18]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$nM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$nM("statusBarItem.warningForeground")]])}#e;#t;constructor(b,E,S,u,m,a=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Sc,this.#e=b,this.#t=E,m&&u){this.c=(0,D.$3L)(u.identifier,m);const r=S.get(this.c);r&&(a=r.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=u,this.f=m,this.g=a,this.h=this.u(i)}u(b){if((0,v.$Of)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(b){this.k=b,this.v()}set name(b){this.m=b,this.v()}set tooltip(b){this.l=b,this.v()}set color(b){this.n=b,this.v()}set backgroundColor(b){b&&!$.b.has(b.id)&&(b=void 0),this.o=b,this.v()}set command(b){this.r?.fromApi!==b&&(this.p&&this.q.add(this.p),this.p=new P.$Sc,typeof b=="string"?this.r={fromApi:b,internal:this.#t.toInternal({title:"",command:b},this.p)}:b?this.r={fromApi:b,internal:this.#t.toInternal(b,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(b){this.t=b,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let b;this.e?this.f?b=`${this.e.identifier.value}.${this.f}`:b=this.e.identifier.value:b=this.f;let E;this.m?E=this.m:E=(0,f.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const u=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,b,this.e?.identifier.value,E,this.k,u,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$mic=$;class k{constructor(b){this.b=[],this.a=b.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(b){const E={message:b};return this.b.unshift(E),this.c(),new D.$rL(()=>{const S=this.b.indexOf(E);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(b,E){this.e=new Map,this.a=b.getProxy(N.$pL.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(b){for(const E of b)this.e.set(E.entryId,E)}createStatusBarEntry(b,E,S,u){return new $(this.a,this.b,this.e,b,E,S,u)}setStatusBarMessage(b,E){const S=this.c.setMessage(b);let u;return typeof E=="number"?u=setTimeout(()=>S.dispose(),E):typeof E<"u"&&E.then(()=>S.dispose(),()=>S.dispose()),new D.$rL(()=>{S.dispose(),clearTimeout(u)})}}e.$nic=R}),define(Ce[151],Ie([1,0,29,141,68,111,89,16,2]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=e.$QN=e.$PN=void 0;const k=(r,n,o,t)=>{let h=n;return{enumerable:!0,configurable:!1,get(){return h},set(s){if(!o(h,s)){const d=h;h=s,r.listener?.(t(s,d))}}}},R=(r,n)=>r===n,C={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(r,n)=>!(r.length!==n.length||r.some(o=>!n.find(t=>o.id===t.id)))},b=r=>n=>({op:4,update:r(n)}),E=(r,n)=>({range:(()=>{let o;const t=b(h=>({range:D.$Xs.lift(v.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return o},set(h){r.listener?.({op:6}),C.range(o,h)||(o=h,r.listener?.(t(h)))}}})(),label:k(r,n,C.label,b(o=>({label:o}))),description:k(r,void 0,C.description,b(o=>({description:o}))),sortText:k(r,void 0,C.sortText,b(o=>({sortText:o}))),canResolveChildren:k(r,!1,C.canResolveChildren,o=>({op:2,state:o})),busy:k(r,!1,C.busy,b(o=>({busy:o}))),error:k(r,void 0,C.error,b(o=>({error:v.MarkdownString.fromStrict(o)||null}))),tags:k(r,[],C.tags,(o,t)=>({op:1,new:o.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),S=r=>{const n=f.$gK.fromString(r.extId),o=new m(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return o.range=v.Range.to(r.range||void 0),o.description=r.description||void 0,o.sortText=r.sortText||void 0,o.tags=r.tags.map(t=>v.TestTag.to({id:(0,A.$lK)(t).tagId})),o},u=r=>{let n;for(const o of r.tests){const t=S(o.item);(0,N.$zN)(t).parent=n,n=t}return n};e.$PN=u;class m{constructor(n,o,t,h){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const s=(0,N.$yN)(this,n);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,P.$xN)(s,N.$zN,m),enumerable:!0,writable:!1},...E(s,t)})}}e.$QN=m;class a extends m{constructor(n,o){super(n,n,o,void 0),this._isRoot=!0}}e.$RN=a;class i extends P.$tN{constructor(n,o,t){super({controllerId:n,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:N.$zN,getChildren:h=>h.children,root:new a(n,o),toITestItem:v.TestItem.from})}}e.$SN=i}),define(Ce[33],Ie([1,0,18,7,16,24,6,19,13,56,29,48,2,3,5,20,151,21,69,44,38,87,90,30]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=void 0;let s=class{#e;#t;#i;constructor(w,g,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(A.$pL.MainThreadCommands),this.d=g,this.#i=y,this.#t=w.getProxy(A.$pL.MainThreadTelemetry),this.converter=new d(this,L=>{const F=this.c.get(L);return F?.result===c.Void?F:void 0},g),this.f=[{processArgument(L){return(0,k.$Fh)(L)}},{processArgument(L){return(0,P.$Bn)(L,function(F){if(R.$Xs.isIRange(F))return f.Range.to(F);if(C.$Ws.isIPosition(F))return f.Position.to(F);if(R.$Xs.isIRange(F.range)&&b.URI.isUri(F.uri))return f.location.to(F);if(F instanceof a.$ke)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const g=this.registerCommand(!1,w.id,async(...y)=>{const L=w.args.map((z,j)=>{if(!z.validate(y[j]))throw new Error(`Invalid argument '${z.name}' when running '${w.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return z.convert(y[j])}),F=await this.executeCommand(w.internalId,...L);return w.result.convert(F,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$rL(()=>{g.dispose(),this.c.delete(w.id)})}registerCommand(w,g,y,L,F,z){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:y,thisArg:L,metadata:F,extension:z}),w&&this.#e.$registerCommand(g),new N.$rL(()=>{this.b.delete(g)&&w&&this.#e.$unregisterCommand(g)})}executeCommand(w,...g){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,g,!0)}async g(w,g,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,g,!1);{let L=!1;const F=(0,P.$Bn)(g,function(z){if(z instanceof N.$sL)return f.Position.from(z);if(z instanceof N.$tL)return f.Range.from(z);if(z instanceof N.$DL)return f.location.from(z);if(N.$QM.isNotebookRange(z))return f.NotebookRange.from(z);if(z instanceof ArrayBuffer)return L=!0,a.$ke.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return L=!0,a.$ke.wrap(z);if(z instanceof a.$ke)return L=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(w,L?new i.$Wv(F):F,y);return(0,k.$Fh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(w,g,!1);throw z}}}async h(w,g,y){const L=this.b.get(w);if(!L)throw new Error("Unknown command");const{callback:F,thisArg:z,metadata:j}=L;if(j?.args)for(let M=0;M<j.args.length;M++)try{(0,D.$2f)(g[M],j.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${j.args[M].name}' - ${j.args[M].description}`)}const O=n.$Sd.create();try{return await F.apply(z,g)}catch(M){if(w===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...g);T&&(w=T.command)}if(this.d.error(M,w,L.extension?.identifier),!y)throw M;if(L.extension?.identifier){const T=this.#i.onExtensionError(L.extension.identifier,M);this.d.trace("forwarded error to extension?",T,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Ti)(M)),this.id=w,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,w,O.elapsed())}}j(w,g,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new o.$Oo(g),duration:y})}$executeContributedCommand(w,...g){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(g=g.map(L=>this.f.reduce((F,z)=>z.processArgument(F,y.extension?.identifier),L)),this.h(w,g,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(g=>(w&&(g=g.filter(y=>y[0]!=="_")),g))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[g,y]of this.b){const{metadata:L}=y;L&&(w[g]=L)}return Promise.resolve(w)}};e.$YN=s,e.$YN=s=Ke([We(0,u.$DN),We(1,$.$qj),We(2,t.$XN)],s),e.$ZN=(0,S.$9h)("IExtHostCommands");class d{constructor(w,g,y){this.d=w,this.f=g,this.g=y,this.delegatingCommandId=`__vsc${(0,h.$sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,g){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const L=this.f(w.command);if(L)y.id=L.internalId,y.arguments=L.args.map((F,z)=>F.convert(w.arguments&&w.arguments[z]));else if((0,v.$Lb)(w.arguments)){const F=`${w.command} /${++this.c}`;this.b.set(F,w),g.add((0,E.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),y.$ident=F,y.id=this.delegatingCommandId,y.arguments=[F],this.g.trace("CommandsConverter#CREATE",w.command,F)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const g=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$1N=d;class l{static{this.Uri=new l("uri","Uri of a text document",w=>b.URI.isUri(w),w=>w)}static{this.Position=new l("position","A position in a text document",w=>N.$sL.isPosition(w),f.Position.from)}static{this.Range=new l("range","A range in a text document",w=>N.$tL.isRange(w),f.Range.from)}static{this.Selection=new l("selection","A selection in a text document",w=>N.$uL.isSelection(w),f.Selection.from)}static{this.Number=new l("number","",w=>typeof w=="number",w=>w)}static{this.String=new l("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=l.Arr(l.String)}static Arr(w){return new l(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,g=>Array.isArray(g)&&g.every(y=>w.validate(y)),g=>g.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",w=>w instanceof N.$OL,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",w=>w instanceof N.$0M,f.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",w=>w instanceof m.$QN,f.TestItem.from)}constructor(w,g,y,L){this.name=w,this.description=g,this.validate=y,this.convert=L}optional(){return new l(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,g){return new l(w??this.name,g??this.description,this.validate,this.convert)}}e.$2N=l;class c{static{this.Void=new c("no result",w=>w)}constructor(w,g){this.description=w,this.convert=g}}e.$3N=c;class p{constructor(w,g,y,L,F){this.id=w,this.internalId=g,this.description=y,this.args=L,this.result=F}}e.$4N=p}),define(Ce[343],Ie([1,0,19,15,2,83,131,45,33,16,7]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;const C=[new $.$4N("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new $.$4N("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$2N.Uri],new $.$3N("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,D.$Kb)(u))return;class a extends R.$JL{static to(r){const n=new a(r.name,k.SymbolKind.to(r.kind),r.containerName||"",new R.$DL(m[0],k.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=k.Range.to(r.selectionRange),n.children=r.children?r.children.map(a.to):[],n}}return u.map(a.to)})),new $.$4N("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$2N.Uri,new $.$2N("options","Formatting options",u=>!0,u=>u)],new $.$3N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$4N("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$2N.Uri,$.$2N.Range,new $.$2N("options","Formatting options",u=>!0,u=>u)],new $.$3N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$4N("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$2N.Uri,$.$2N.Position,new $.$2N("ch","Trigger character",u=>typeof u=="string",u=>u),new $.$2N("options","Formatting options",u=>!0,u=>u)],new $.$3N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$4N("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$4N("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$4N("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$4N("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$4N("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Location-instances.",E(k.location.to))),new $.$4N("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new $.$4N("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$2N.Uri,new $.$2N("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>R.$sL.isPosition(m)),u=>u.map(k.Position.from))],new $.$3N("A promise that resolves to an array of ranges.",u=>u.map(m=>{let a;for(const i of m.reverse())a=new R.$NL(k.Range.to(i),a);return a}))),new $.$4N("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$2N.String.with("query","Search string")],new $.$3N("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(k.WorkspaceSymbol.to))),new $.$4N("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(k.CallHierarchyItem.to))),new $.$4N("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$2N.CallHierarchyItem],new $.$3N("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(k.CallHierarchyIncomingCall.to))),new $.$4N("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$2N.CallHierarchyItem],new $.$3N("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(k.CallHierarchyOutgoingCall.to))),new $.$4N("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:k.Range.to(u.range),placeholder:u.text}})),new $.$4N("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$2N.Uri,$.$2N.Position,$.$2N.String.with("newName","The new symbol name")],new $.$3N("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return k.WorkspaceEdit.to(u)}})),new $.$4N("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$2N.Uri,$.$2N.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$3N("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(k.DocumentLink.to))),new $.$4N("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$2N.Uri],new $.$3N("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new R.$HM(u.tokenTypes,u.tokenModifiers)})),new $.$4N("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$2N.Uri],new $.$3N("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,A.$9$)(u);if(m.type==="full")return new R.$JM(m.data,void 0)})),new $.$4N("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$2N.Uri,$.$2N.Range.optional()],new $.$3N("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new R.$HM(u.tokenTypes,u.tokenModifiers)})),new $.$4N("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$2N.Uri,$.$2N.Range],new $.$3N("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,A.$9$)(u);if(m.type==="full")return new R.$JM(m.data,void 0)})),new $.$4N("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$2N.Uri,$.$2N.Position,$.$2N.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$2N.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$3N("A promise that resolves to a CompletionList-instance.",(u,m,a)=>{if(!u)return new R.$ZL([]);const i=u.suggestions.map(r=>k.CompletionItem.to(r,a));return new R.$ZL(i,u.incomplete)})),new $.$4N("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$2N.Uri,$.$2N.Position,$.$2N.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$3N("A promise that resolves to SignatureHelp.",u=>{if(u)return k.SignatureHelp.to(u)})),new $.$4N("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$2N.Uri,$.$2N.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$3N("A promise that resolves to an array of CodeLens-instances.",(u,m,a)=>E(i=>new R.$RL(k.Range.to(i.range),i.command&&a.fromInternal(i.command)))(u))),new $.$4N("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$2N.Uri,new $.$2N("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>R.$tL.isRange(u),u=>R.$uL.isSelection(u)?k.Selection.from(u):k.Range.from(u)),$.$2N.String.with("kind","Code action kind to return code actions for").optional(),$.$2N.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$3N("A promise that resolves to an array of Command-instances.",(u,m,a)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(i.command)}else{const r=new R.$LL(i.title,i.kind?new R.$ML(i.kind):void 0);return i.edit&&(r.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(r.command=a.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(u))),new $.$4N("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$2N.Uri],new $.$3N("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new R.$6L(k.Range.to(m.range),k.Color.to(m.color))):[])),new $.$4N("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$2N("color","The color to show and insert",u=>u instanceof R.$5L,k.Color.from),new $.$2N("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:k.Range.from(u.range)}))],new $.$3N("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(k.ColorPresentation.to):[])),new $.$4N("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$2N.Uri,$.$2N.Range],new $.$3N("A promise that resolves to an array of Inlay objects",(u,m,a)=>u.map(k.InlayHint.to.bind(void 0,a)))),new $.$4N("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$2N.Uri],new $.$3N("A promise that resolves to an array of FoldingRange objects",(u,m)=>{if(u)return u.map(k.FoldingRange.to)})),new $.$4N("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$3N("A promise that resolves to an array of NotebookContentProvider static info objects.",E(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>k.NotebookExclusiveDocumentPattern.to(m))})))),new $.$4N("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$2N.Uri,$.$2N.Range,new $.$2N("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof R.$tL,u=>k.InlineValueContext.from(u))],new $.$3N("A promise that resolves to an array of InlineValue objects",u=>u.map(k.InlineValue.to))),new $.$4N("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$2N("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,N.$hg)(u,N.Schemas.http,N.Schemas.https),u=>u),new $.$2N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[k.ViewColumn.from(u),void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional(),$.$2N.String.with("label","").optional()],$.$3N.Void),new $.$4N("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$2N.Uri.with("resource","Resource to open"),$.$2N.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$2N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[k.ViewColumn.from(u),void 0]:[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)])).optional()],$.$3N.Void),new $.$4N("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$2N.Uri.with("left","Left-hand side resource of the diff editor"),$.$2N.Uri.with("right","Right-hand side resource of the diff editor"),$.$2N.String.with("title","Human readable title for the diff editor").optional(),new $.$2N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[k.ViewColumn.from(u.viewColumn),k.TextEditorOpenOptions.from(u)]).optional()],$.$3N.Void),new $.$4N("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$2N.String.with("title","Human readable title for the changes editor"),new $.$2N("resourceList","List of resources to compare",u=>{for(const m of u){if(m.length!==3)return!1;const[a,i,r]=m;if(!f.URI.isUri(a)||!f.URI.isUri(i)&&i!==void 0&&i!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},u=>u)],$.$3N.Void),new $.$4N("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$2N.Uri,$.$2N.Position],new $.$3N("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$4N("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$2N.TypeHierarchyItem],new $.$3N("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$4N("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$2N.TypeHierarchyItem],new $.$3N("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(k.TypeHierarchyItem.to))),new $.$4N("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$2N.TestItem],$.$3N.Void),new $.$4N("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$2N.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$3N.Void),new $.$4N("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$2N.String.with("name","The context key name"),new $.$2N("value","The context key value",()=>!0,u=>u)],$.$3N.Void),new $.$4N("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$2N.Uri,$.$2N.StringArray,new $.$2N("MappedEditsContext","Mapped Edits Context",u=>k.MappedEditsContext.is(u),u=>k.MappedEditsContext.from(u))],new $.$3N("A promise that resolves to a workspace edit or null",u=>u?k.WorkspaceEdit.to(u):null))];class b{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",v.$8i)}}e.$Igc=b;function E(u){return m=>{if(Array.isArray(m))return m.map(u)}}function S(u){if(!Array.isArray(u))return;const m=[];for(const a of u)P.$Jt(a)?m.push(k.DefinitionLink.to(a)):m.push(k.location.to(a));return m}}),define(Ce[344],Ie([1,0,8,3,2,6,33,16,7]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class k{static{this.a=0}constructor(E,S){this.extension=E,this.provider=S,this.handle=k.a++}}class R{constructor(E){this.session=E,this.responses=[]}}class C{static{this.a=0}constructor(E,S,u,m){this.f=u,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(P.$pL.MainThreadInlineChat),S.registerApiCommand(new A.$4N("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$2N("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?v.Range.from(a.initialRange):void 0,initialSelection:$.$uL.isSelection(a.initialSelection)?v.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?v.Position.from(a.position):void 0}})],A.$3N.Void))}registerProvider(E,S,u){const m=new k(E,S);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,u?.label??E.displayName??E.name,E.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",u?.supportReportIssue??!1),(0,N.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,S,u,m){const a=this.b.get(E);if(!a){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(f.URI.revive(S)),r=v.Selection.to(u),n=await a.provider.prepareInteractiveEditorSession({document:i,selection:r},m);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const o=C.a++;return this.d.set(o,new R(n)),{id:o,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:v.Range.from(n.wholeRange),message:n.message}}async $provideResponse(E,S,u,m){const a=this.b.get(E);if(!a)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:u.prompt,selection:v.Selection.to(u.selection),wholeRange:v.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument(f.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let n=!1;const o={report:async I=>{if(!u.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||m.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:I.message,edits:I.edits?.map(v.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:$.$SL.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(a.provider.provideInteractiveEditorResponse(i.session,r,o,m));let h;try{h=await(0,D.$Wg)(t,m)}finally{n=!0}if(!h)return;const s=i.responses.push(h)-1,d={wholeRange:v.Range.from(h.wholeRange),placeholder:h.placeholder};if(!C.h(h))return{...d,id:s,type:"editorEdit",message:v.MarkdownString.from(h.contents),edits:[]};const{edits:l,contents:c}=h,p=c!==void 0?v.MarkdownString.from(c):void 0;return l instanceof $.$BL?{...d,id:s,type:"bulkEdit",edits:v.WorkspaceEdit.from(l),message:p}:{...d,id:s,type:"editorEdit",edits:l.map(v.TextEdit.from),message:p}}async $provideFollowups(E,S,u,m){const a=this.b.get(E),i=this.d.get(S),r=i?.responses[u];if(a&&r&&a.provider.provideFollowups){const n=Promise.resolve(a.provider.provideFollowups(i.session,r,m));return(await(0,D.$Wg)(n,m))?.map(v.ChatInlineFollowup.from)}}$handleFeedback(E,S,u,m){const a=this.b.get(E),i=this.d.get(S),r=i?.responses[u];if(a&&r){const n=v.InteractiveEditorResponseFeedbackKind.to(m);a.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(E,S){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$Qhc=C}),define(Ce[345],Ie([1,0,2,33]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4hc=void 0;class f{constructor(A,v,$,k,R){this.a=v,this.b=$,this.c=k;const C=new N.$4N("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$2N("showOptions","Show Options",b=>!0,b=>b),new N.$2N("resource","Interactive resource Uri",b=>!0,b=>b),new N.$2N("controllerId","Notebook controller Id",b=>!0,b=>b),new N.$2N("title","Interactive editor title",b=>!0,b=>b)],new N.$3N("Notebook and input URI",b=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",b.notebookEditorId),b.notebookEditorId!==void 0){const E=this.a.getEditorById(b.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:D.URI.revive(b.notebookUri),inputUri:D.URI.revive(b.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",b.notebookUri,b.inputUri),{notebookUri:D.URI.revive(b.notebookUri),inputUri:D.URI.revive(b.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,v,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,v){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$4hc=f}),define(Ce[346],Ie([1,0,19,8,22,4,3,28,2,25,13,6,33,16,7,112,286,26,69,287]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0;let n=class{constructor(p,I,w,g,y){this.m=I,this.n=w,this.o=g,this.q=y,this.b=new v.$Ac,this.c=new v.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=p.getProxy(C.$pL.MainThreadNotebookKernels);const L=new b.$4N("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$2N("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const z=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:z}}else if(F&&"notebookEditor"in F){const z=this.n.getIdByEditor(F.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return F})],b.$3N.Void);this.o.registerApiCommand(L)}createNotebookController(p,I,w,g,y,L){for(const fe of this.j.values())if(fe.controller.id===I&&k.$om.equals(p.identifier,fe.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const F=this.k++,z=this;this.q.trace(`NotebookController[${F}], CREATED by ${p.identifier.value}, ${I}`);const j=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${p.identifier}'`);let O=!1;const M=new P.$Wd,T=new P.$Wd,U={id:l(p.identifier,I),notebookType:w,extensionId:p.identifier,extensionLocation:p.extensionLocation,label:g||p.identifier.value,preloads:L?L.map(E.NotebookRendererScript.from):[]};let J=y??j,ne,ee;this.a.$addKernel(F,U).catch(fe=>{console.log(fe),O=!0});let Q=0;const Y=()=>{if(O)return;const fe=++Q;Promise.resolve().then(()=>{fe===Q&&this.a.$updateKernel(F,U)})},ce=new v.$Ac,te={get id(){return I},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return U.label},set label(fe){U.label=fe??p.displayName??p.name,Y()},get detail(){return U.detail??""},set detail(fe){U.detail=fe,Y()},get description(){return U.description??""},set description(fe){U.description=fe,Y()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(fe){U.supportedLanguages=fe,Y()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){U.supportsExecutionOrder=fe,Y()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(fe){J=fe??j},get interruptHandler(){return ne},set interruptHandler(fe){ne=fe,U.supportsInterrupt=!!fe,Y()},set variableProvider(fe){(0,a.$MF)(p,"notebookVariableProvider"),ee=fe,U.hasVariableProvider=!!fe,fe?.onDidChangeVariables(re=>z.a.$variablesUpdated(re.uri)),Y()},get variableProvider(){return ee},createNotebookCellExecution(fe){if(O)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.notebook.uri))throw z.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return z._createNotebookCellExecution(fe,l(p.identifier,this.id))},createNotebookExecution(fe){if((0,a.$MF)(p,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.uri))throw z.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.uri.toString()}`);return z._createNotebookExecution(fe,l(p.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${F}], DISPOSED`),O=!0,this.j.delete(F),M.dispose(),T.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(fe,re){re===S.NotebookControllerAffinity2.Hidden&&(0,a.$MF)(p,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(F,fe.uri,re)},onDidReceiveMessage:T.event,postMessage(fe,re){return(0,a.$MF)(p,"notebookMessaging"),z.a.$postMessage(F,re&&z.n.getIdByEditor(re),fe)},asWebviewUri(fe){return(0,a.$MF)(p,"notebookMessaging"),(0,u.$Lwb)(fe,z.m.remote)}};return this.j.set(F,{extensionId:p.identifier,controller:te,onDidReceiveMessage:T,onDidChangeSelection:M,associatedNotebooks:ce}),te}getIdByController(p){for(const[I,w]of this.j)if(w.controller===p)return l(w.extensionId,p.id);return null}createNotebookControllerDetectionTask(p,I){const w=this.g++,g=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${p.identifier.value}`),this.a.$addKernelDetectionTask(w,I);const y={dispose:()=>{this.f.delete(w),g.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(p,I,w){const g=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?g:void 0,L=this;this.h.set(g,w),this.q.trace(`NotebookKernelSourceActionProvider[${g}], CREATED by ${p.identifier.value}`),this.a.$addKernelSourceActionProvider(g,g,I);let F;return y!==void 0&&(F=w.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(g),L.a.$removeKernelSourceActionProvider(g,g),F?.dispose()}}}async $provideKernelSourceActions(p,I){const w=this.h.get(p);if(w){const g=new A.$Sc;return(await w.provideNotebookKernelSourceActions(I)??[]).map(L=>E.NotebookKernelSourceAction.from(L,this.o.converter,g))}return[]}$acceptNotebookAssociation(p,I,w){const g=this.j.get(p);if(g){const y=this.n.getNotebookDocument($.URI.revive(I));w?g.associatedNotebooks.set(y.uri,!0):g.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${p}] ASSOCIATE notebook`,y.uri.toString(),w),g.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(p,I,w){const g=this.j.get(p);if(!g)return;const y=this.n.getNotebookDocument($.URI.revive(I)),L=[];for(const F of w){const z=y.getCell(F);z&&L.push(z.apiCell)}try{this.q.trace(`NotebookController[${p}] EXECUTE cells`,y.uri.toString(),L.length),await g.controller.executeHandler.call(g.controller,L,y.apiNotebook,g.controller)}catch(F){this.q.error(`NotebookController[${p}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(p,I,w){const g=this.j.get(p);if(!g)return;const y=this.n.getNotebookDocument($.URI.revive(I));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,y.apiNotebook);else for(const L of w){const F=y.getCell(L);F&&this.b.get(F.uri)?.cancel()}if(g.controller.interruptHandler){const L=this.c.get(y.uri);w.length&&Array.isArray(L)&&L.length&&L.forEach(F=>F.dispose())}}async $provideVariables(p,I,w,g,y,L,F){const z=this.j.get(p);if(!z)return;const j=this.n.getNotebookDocument($.URI.revive(w)),O=z.controller.variableProvider;if(!O)return;let M;if(g!==void 0){if(M=this.s[g],!M)return}else this.s={};const T=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,U=O.provideVariables(j.apiNotebook,M,T,L,F);let J=0;for await(const ne of U){if(F.isCancellationRequested)return;const ee={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[ee.id]=ne.variable,this.a.$receiveVariable(I,ee),J++>=r.$Wfb)return}}$acceptKernelMessageFromRenderer(p,I,w){const g=this.j.get(p);if(!g)return;const y=this.n.getEditorById(I);g.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(p,I,w){const y=this.n.getNotebookDocument($.URI.revive(p)).getCell(I);if(y){const L=w?E.NotebookCellExecutionState.to(w):S.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:y.apiCell,state:L})}}_createNotebookCellExecution(p,I){if(p.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this.n.getNotebookDocument(p.notebook.uri).getCellFromApiCell(p);if(!g)throw new Error("invalid cell");if(this.b.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const y=new t(I,g,this.a);this.b.set(g.uri,y);const L=y.onDidChangeState(()=>{y.state===o.Resolved&&(y.dispose(),L.dispose(),this.b.delete(g.uri))});return y.asApiObject()}_createNotebookExecution(p,I){const w=this.n.getNotebookDocument(p.uri),g=p.getCells().find(F=>{const z=w.getCellFromApiCell(F);return z&&this.b.has(z.uri)});if(g)throw new Error(`duplicate cell execution for ${g.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new s(I,w,this.a),L=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),L.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,L]),y.asApiObject()}};e.$_hc=n,e.$_hc=n=Ke([We(4,R.$qj)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class t extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(p,I,w){super(),this.m=I,this.n=w,this.b=t.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new f.$7d),this.h=new d(10,g=>this.s(g)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,p,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(p){await this.h.addItem(p)}async s(p){const I=Array.isArray(p)?p:[p];return this.n.$updateExecution(this.b,new i.$Wv(I))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(p){let I=this.m;if(p&&(I=this.m.notebook.getCellFromApiCell(p)),!I)throw new Error("INVALID cell");return I.handle}y(p){return p.map(I=>{const w=S.$UM.ensureUniqueMimeTypes(I.items,!0);return w===I.items?E.NotebookCellOutput.from(I):E.NotebookCellOutput.from({items:w,id:I.id,metadata:I.metadata})})}async z(p,I,w){const g=this.w(I),y=this.y((0,D.$3b)(p));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:g,append:w,outputs:y})}async C(p,I,w){return p=S.$UM.ensureUniqueMimeTypes((0,D.$3b)(p),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:p.map(E.NotebookCellOutputItem.from),outputId:I.id,append:w})}asApiObject(){const p=this;return Object.freeze({get token(){return p.g.token},get cell(){return p.m.apiCell},get executionOrder(){return p.j},set executionOrder(w){p.j=w,p.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:p.j}])},start(w){if(p.f===o.Resolved||p.f===o.Started)throw new Error("Cannot call start again");p.f=o.Started,p.c.fire(),p.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,g){if(p.f===o.Resolved)throw new Error("Cannot call resolve twice");p.f=o.Resolved,p.c.fire(),p.h.flush(),p.n.$completeExecution(p.b,new i.$Wv({runEndTime:g,lastRunSuccess:w}))},clearOutput(w){return p.t(),p.z([],w,!1)},appendOutput(w,g){return p.t(),p.z(w,g,!0)},replaceOutput(w,g){return p.t(),p.z(w,g,!1)},appendOutputItems(w,g){return p.t(),p.C(w,g,!0)},replaceOutputItems(w,g){return p.t(),p.C(w,g,!1)}})}}var h;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(h||(h={}));class s extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(p,I,w){super(),this.h=I,this.j=w,this.b=s.a++,this.c=new P.$Wd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new f.$7d),this.j.$createNotebookExecution(this.b,p,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(p,I){this.f=p,this.g=I,this.a=[],this.b=Date.now()}addItem(p){return this.a.push(p),this.c||(this.c=new N.$th,this.b=Date.now(),(0,N.$0g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const p=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>p.complete())}}function l(c,p){return`${c.value}/${p}`}e.$aic=l}),define(Ce[46],Ie([1,0,4,6,5,2,20,3,7,220,14,264,22,30,265,55,8,16,33]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=e.$mhc=e.$lhc=void 0,e.$lhc=(0,f.$9h)("IExtHostTerminalService");class r{constructor(w,g,y,L){this.l=w,this._id=g,this.m=y,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const F=this;this.value={get name(){return F.n||""},get processId(){return F.b},get creationOptions(){return F.m},get exitStatus(){return F.h},get state(){return F.j},get selection(){return F.k},sendText(z,j=!0){F.q(),F.l.$sendText(F._id,z,j)},show(z){F.q(),F.l.$show(F._id,z)},hide(){F.q(),F.l.$hide(F._id)},dispose(){F.a||(F.a=!0,F.l.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(w,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??g?.cwd??void 0,env:w.env??void 0,icon:l(w.iconPath)??void 0,color:u.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(w.location,g?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,g,y,L,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:u.ThemeColor.isThemeColor(F)?F.id:void 0,location:g?.location||this.o(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,g){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in w?{viewColumn:a.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,g){this.h=Object.freeze({code:w,reason:g})}setDimensions(w,g){return w===this.d&&g===this.g||w===0||g===0?!1:(this.d=w,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(g=>{g!==w&&(this.b=Promise.resolve(w))})}}e.$mhc=r;class n{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new D.$Wd,this.onProcessData=this.a.event,this.b=new D.$Wd,this.d=new D.$Wd,this.onDidChangeProperty=this.d.event,this.f=new D.$Wd,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,g){this.g.setDimensions?.({columns:w,rows:g})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let o=1,t=class extends v.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,g,y){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new v.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Wd,this.onDidChangeShell=this.N.event,this.O=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$pL.MainThreadTerminalService),this.y=new S.$Vsb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:L=>{const F=z=>{const j=z;return this.W(j.instanceId)?.value};switch(L?.$mid){case 15:return F(L);default:{if(Array.isArray(L))for(let z=0;z<L.length&&L[z].$mid===15;z++)L[z]=F(L[z]);return L}}}}),this.B({dispose:()=>{for(const[L,F]of this.g)F.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,g){const y=new r(this.a,(0,E.$sg)(),w,w.name),L=new n(w.pty);return y.createExtensionTerminal(w.location,g,this.R(w,g).resolvedExtHostIdentifier,l(w.iconPath),c(w.color)).then(F=>{const z=this.S(F,L);this.h[F]=z}),this.f.push(y),y.value}R(w,g){if(g=g||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const L=this.f.find(F=>F.value===y);L&&(g.resolvedExtHostIdentifier=L._id)}}else w.location&&typeof w.location!="object"?g.location=w.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(w,g){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const L=new n(g),F=this.S(w,L);this.h[w]=F}async $acceptActiveTerminalChanged(w){const g=this.b;if(w===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const y=this.W(w);y&&(this.b=y,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,g){const y=this.W(w);y&&this.O.fire({terminal:y.value,data:g})}async $acceptTerminalDimensions(w,g,y){const L=this.W(w);L&&L.setDimensions(g,y)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(w,g){const y=this.W(w);y&&this.P.fire({terminal:y.value,...g})}async $acceptTerminalMaximumDimensions(w,g,y){this.g.get(w)?.resize(g,y)}async $acceptTerminalTitleChange(w,g){const y=this.W(w);y&&(y.name=g)}async $acceptTerminalClosed(w,g,y){const L=this.Y(this.f,w);if(L!==null){const F=this.f.splice(L,1)[0];F.setExitStatus(g,y),this.H.fire(F.value)}}$acceptTerminalOpened(w,g,y,L){if(g){const j=this.Y(this.f,g);if(j!==null){this.f[j]._id=w,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const F={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:P.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},z=new r(this.a,w,F,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(w,g){this.W(w)?._setProcessId(g)}async $startExtensionTerminal(w,g){const y=this.W(w);if(!y)return{message:(0,k.localize)(0,null,w)};y.isOpen||await new Promise(F=>{const z=this.onDidOpenTerminal(async j=>{j===y.value&&(z.dispose(),F())})});const L=this.g.get(w);L?L.startSendingEvents(g):this.j[w]={initialDimensions:g}}S(w,g){const y=new v.$Sc;y.add(g.onProcessReady(F=>this.a.$sendProcessReady(w,F.pid,F.cwd,F.windowsPty))),y.add(g.onDidChangeProperty(F=>this.a.$sendProcessProperty(w,F))),this.y.startBuffering(w,g.onProcessData),y.add(g.onProcessExit(F=>this.U(w,F))),this.g.set(w,g);const L=this.j[w];return L&&g instanceof n&&(g.startSendingEvents(L.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,g){this.g.get(w)?.acknowledgeDataEvent(g)}$acceptProcessInput(w,g){this.g.get(w)?.input(g)}$acceptTerminalInteraction(w){const g=this.W(w);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(w,g){this.W(w)?.setSelection(g)}$acceptProcessResize(w,g,y){try{this.g.get(w)?.resize(g,y)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(w,g){this.g.get(w)?.shutdown(g)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(g=>this.a.$sendProcessProperty(w,{type:"cwd",value:g}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$rL(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,g,y){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,y),this.a.$registerProfileProvider(g,w.identifier.value),new $.$rL(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(w,g,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,g),new $.$rL(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,g){const y=new b.$7d().token;if(y.isCancellationRequested)return;const L=this.D.get(w);if(!L)return;const F=await L.provideTerminalQuickFixes(g,y);if(F===null||Array.isArray(F)&&F.length===0)return;const z=new v.$Sc;if(this.w.value=z,!Array.isArray(F))return F?a.TerminalQuickFix.from(F,this.Q.converter,z):void 0;const j=[];for(const O of F){const M=a.TerminalQuickFix.from(O,this.Q.converter,z);M&&j.push(M)}return j}async $createContributedProfileTerminal(w,g){const y=new b.$7d().token;let L=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,g);return}this.createTerminalFromOptions(L.options,g)}}async $provideLinks(w,g){const y=this.W(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const F=new b.$7d;this.G.set(w,F);const z=[],j={terminal:y.value,line:g},O=[];for(const U of this.z)O.push(m.Promises.withAsyncBody(async J=>{F.token.onCancellationRequested(()=>J({provider:U,links:[]}));const ne=await U.provideTerminalLinks(j,F.token)||[];F.token.isCancellationRequested||J({provider:U,links:ne})}));const M=await Promise.all(O);if(F.token.isCancellationRequested)return[];const T=new Map;for(const U of M)U&&U.links.length>0&&z.push(...U.links.map(J=>{const ne={id:o++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return T.set(ne.id,{provider:U.provider,link:J}),ne}));return this.F.set(w,T),z}$activateLink(w,g){const y=this.F.get(w)?.get(g);y&&y.provider.handleTerminalLink(y.link)}U(w,g){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,g)}W(w){return this.X(this.f,w)}X(w,g){const y=this.Y(w,g);return y!==null?w[y]:null}Y(w,g){const y=w.findIndex(L=>L._id===g);return y===-1?null:y}getEnvironmentVariableCollection(w){let g=this.n.get(w.identifier.value);return g||(g=new h,this.$(w.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(w,g){const y=(0,C.$Pr)(g.map),L=(0,C.$Qr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(w,g.persistent,y.length===0?void 0:y,L)}$initEnvironmentVariableCollections(w){w.forEach(g=>{const y=g[0],L=new h(g[1]);this.$(y,L)})}$acceptDefaultProfile(w,g){const y=this.s;this.s=w,this.u=g,y?.path!==w.path&&this.N.fire(w.path)}$(w,g){this.n.set(w,g),g.onDidChangeCollection(()=>{this.Z(w,g)})}};e.$nhc=t,e.$nhc=t=Ke([We(1,i.$ZN),We(2,A.$DN)],t);class h{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Wd,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const g=this.h(w);let y=this.a.get(g);return y||(y=new s(this,w),this.a.set(g,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,g,y,L){this.f(w,{value:g,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:L})}append(w,g,y,L){this.f(w,{value:g,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:L})}prepend(w,g,y,L){this.f(w,{value:g,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:L})}f(w,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,g.scope),L=this.map.get(y),F=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==g.value||L.type!==g.type||L.options?.applyAtProcessCreation!==F.applyAtProcessCreation||L.options?.applyAtShellIntegration!==F.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const z=this.g(w,g.scope),j={variable:w,...g,options:F};this.map.set(z,j),this.d.fire()}}get(w,g){const y=this.g(w,g),L=this.map.get(y);return L?p(L):void 0}g(w,g){const y=this.h(g);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const g=new Map;for(const[y,L]of this.map)this.h(L.scope)===this.h(w)&&g.set(L.variable,p(L));return g}delete(w,g){const y=this.g(w,g);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[g,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(g);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,g){const y=this.h(g),L=this.descriptionMap.get(y);if(!L||L.description!==w){let F;typeof w=="string"?F=w:F=w?.value.split(`

`)[0];const z={description:F,scope:g};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(w){const g=this.h(w);return this.descriptionMap.get(g)?.description}k(w){const g=this.h(w);this.descriptionMap.delete(g)}}class s{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,g){this.b=w,this.d=g,this.a=new D.$Wd}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,g,y){this.b.replace(w,g,y,this.d)}append(w,g,y){this.b.append(w,g,y,this.d)}prepend(w,g,y){this.b.prepend(w,g,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,g){this.b.getVariableMap(this.d).forEach((y,L)=>w.call(g,L,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(w,g){super(!1,w,g)}createTerminal(w,g,y){throw new R.$_}createTerminalFromOptions(w,g){throw new R.$_}};e.$ohc=d,e.$ohc=d=Ke([We(0,i.$ZN),We(1,A.$DN)],d);function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function c(I){return u.ThemeColor.isThemeColor(I)?I:void 0}function p(I){const w={...I};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Ce[347],Ie([1,0,8,21,22,4,75,54,3,24,18,30,13,6,20,151,16,7,68,111,89,26]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=e.$sic=e.$ric=void 0;let t=class extends $.$Tc{constructor(O,M,T,U){super(),this.w=U,this.f=this.B(new P.$Wd),this.g=new Map,this.s=this.B(new P.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(E.$pL.MainThreadTesting),this.m=new y(this.h),this.j=new l(this.h,M),T.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const ne=J,ee=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$gK.root(ee))?.collection.tree.get(ee)?.actual??(0,u.$PN)(J)}case 18:{const{extId:ne,message:ee}=J;return{test:this.g.get(i.$gK.root(ne))?.collection.tree.get(ne)?.actual,message:m.TestMessage.to(ee)}}default:return J}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await T.executeCommand("_testing.getExplorerSelection"),ne=ee=>{const Q=this.g.get(i.$gK.root(ee));if(Q)return i.$gK.isRoot(ee)?Q.controller:Q.collection.tree.get(ee)?.actual};return{include:J?.include.map(ne).filter(R.$Sf)||[],exclude:J?.exclude.map(ne).filter(R.$Sf)||[]}})}createTestController(O,M,T,U){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const J=new $.$Sc,ne=J.add(new u.$SN(M,T,this.w));ne.root.label=T;const ee=new Map,Q=new Set,Y=this.h,ce={items:ne.root.children,get label(){return T},set label(fe){T=fe,ne.root.label=fe,Y.$updateController(M,{label:T})},get refreshHandler(){return U},set refreshHandler(fe){U=fe,Y.$updateController(M,{canRefresh:!!fe})},get id(){return M},createRunProfile:(fe,re,K,B,ae,Ee)=>{let le=(0,v.$Wi)(fe);for(;ee.has(le);)le++;return new F(this.h,ee,Q,this.s.event,M,le,fe,re,K,B,ae,Ee)},createTestItem(fe,re,K){return new u.$QN(M,fe,re,K)},createTestRun:(fe,re,K=!0)=>this.j.createTestRun(O,M,ne,fe,re,K),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const re=fe instanceof Array?fe:[fe];this.h.$markTestRetired(re.map(K=>i.$gK.fromExtHostTestItem(K,M).toString()))}},set resolveHandler(fe){ne.resolveHandler=fe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{J.dispose()}};Y.$registerTestController(M,T,!!U),J.add((0,$.$Rc)(()=>Y.$unregisterTestController(M)));const te={controller:ce,collection:ne,profiles:ee,extension:O,activeProfiles:Q};return this.g.set(M,te),J.add((0,$.$Rc)(()=>this.g.delete(M))),J.add(ne.onDidGenerateDiff(fe=>Y.$publishDiff(M,fe.map(n.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.m.checkout()}async runTests(O,M=f.CancellationToken.None){const T=c(O);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.g.get(T.controllerId);if(!U)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(J=>i.$gK.fromExtHostTestItem(J,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:z[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:O.exclude?.map(J=>J.id)},M)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,M,T){return await this.j.getCoverageReport(O,M)?.provideFileCoverage(T)??[]}async $resolveFileCoverage(O,M,T,U){return await this.j.getCoverageReport(O,M)?.resolveFileCoverage(T,U)??[]}$configureRunProfile(O,M){this.g.get(O)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(O){const M=new Map;for(const[T,U]of Object.entries(O)){const J=this.g.get(T);if(!J)continue;const ne=new Map,ee=U.filter(Y=>!J.activeProfiles.has(Y)),Q=[...J.activeProfiles].filter(Y=>!U.includes(Y));for(const Y of ee)ne.set(Y,!0),J.activeProfiles.add(Y);for(const Y of Q)ne.set(Y,!1),J.activeProfiles.delete(Y);ne.size&&M.set(T,ne)}this.s.fire(M)}async $refreshTests(O,M){await this.g.get(O)?.controller.refreshHandler?.(M)}$publishTestResults(O){this.results=Object.freeze(O.map(M=>(0,k.$An)(m.TestResults.to(M))).concat(this.results).sort((M,T)=>T.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,M){const T=this.g.get(i.$gK.fromString(O).controllerId)?.collection;T&&(await T.expand(O,M<0?1/0:M),T.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:T=>T},M)))}async $runControllerTests(O,M){return Promise.all(O.map(T=>this.y(T,!1,M)))}async $startContinuousRun(O,M){const T=new f.$7d(M),U=await Promise.all(O.map(J=>this.y(J,!0,T.token)));return!M.isCancellationRequested&&!U.some(J=>J.error)&&await new Promise(J=>M.onCancellationRequested(J)),T.dispose(!0),U}async y(O,M,T){const U=this.g.get(O.controllerId);if(!U)return{};const{collection:J,profiles:ne,extension:ee}=U,Q=ne.get(O.profileId);if(!Q)return{};const Y=O.testIds.map(re=>J.tree.get(re)).filter(R.$Sf),ce=O.excludeExtIds.map(re=>U.collection.tree.get(re)).filter(R.$Sf).filter(re=>Y.some(K=>K.fullId.compare(re.fullId)===2));if(!Y.length)return{};const te=new a.$2M(Y.some(re=>re.actual instanceof u.$RN)?void 0:Y.map(re=>re.actual),ce.map(re=>re.actual),Q,M),fe=(0,n.$iK)(O)&&this.j.prepareForMainThreadTestRun(te,p.fromInternal(O,U.collection),ee,T);try{return await Q.runHandler(te,T),{}}catch(re){return{error:String(re)}}finally{fe&&(fe.hasRunningTasks&&!T.isCancellationRequested&&await P.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$ric=t,e.$ric=t=Ke([We(0,S.$DN),We(1,b.$qj)],t);const h=1e4;var s;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(s||(s={}));class d extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,M,T,U,J){super(),this.s=O,this.w=M,this.y=T,this.z=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Wd),this.m=this.B(new P.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new f.$7d(J));const ne=this.B(new D.$ih(()=>this.C(),h));this.B(this.h.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(O){const M=this.s.id,T=this.s.controllerId,U=(0,C.$sg)(),J=this.y,ne=this.m;let ee;const Q=fe=>(re,...K)=>{if(ce){this.z.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.s.isIncluded(re)&&(this.F(re),fe(re,...K))},Y=(fe,re)=>{const K=re instanceof Array?re.map(m.TestMessage.from):[m.TestMessage.from(re)];if(fe.uri&&fe.range){const B={range:m.Range.from(fe.range),uri:fe.uri};for(const ae of K)ae.location=ae.location||B}this.w.$appendTestMessagesInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),K)};let ce=!1;const te={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return ee?.provider},set coverageProvider(fe){(0,o.$MF)(J,"testCoverage"),ee=fe&&new I(fe),ne.fire({taskId:U,runId:M,coverage:ee})},enqueued:Q(fe=>{this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),1)}),skipped:Q(fe=>{this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),5)}),started:Q(fe=>{this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),2)}),errored:Q((fe,re,K)=>{Y(fe,re),this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),6,K)}),failed:Q((fe,re,K)=>{Y(fe,re),this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,T).toString(),4,K)}),passed:Q((fe,re)=>{this.w.$updateTestStateInRun(M,U,i.$gK.fromExtHostTestItem(fe,this.s.controllerId).toString(),3,re)}),appendOutput:(fe,re,K)=>{ce||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(M,U,N.$ke.fromString(fe),re&&m.location.from(re),K&&i.$gK.fromExtHostTestItem(K,T).toString()))},end:()=>{ce||(ce=!0,this.w.$finishedTestRunTask(M,U),this.f.delete(U),this.f.size||this.D())}};return this.f.set(U,{run:te}),this.w.$startedTestRunTask(M,{id:U,name:O,running:!0}),te}C(){for(const{run:O}of this.f.values())O.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(O){if(!(O instanceof u.$QN))throw new r.$vN(O.id);if(this.g.has(i.$gK.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const M=[],T=this.s.colllection.root;for(;;){const U=m.TestItem.from(O);if(M.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),O===T))break;O=O.parent||T}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(O,M){this.g=O,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(O,M){return this.f.find(T=>T.runId===O)?.coverage.get(M)}prepareForMainThreadTestRun(O,M,T,U){return this.j(O,M,T,U)}cancelRunById(O){for(const M of this.c.values())if(M.id===O){M.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,M,T,U,J,ne){const ee=this.c.get(U);if(ee)return ee.createRun(J);const Q=p.fromPublic(M,T,U,ne),Y=c(U);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:Y&&{group:z[Y.kind],id:Y.profileId},exclude:U.exclude?.map(te=>i.$gK.fromExtHostTestItem(te,T.root.id).toString())??[],id:Q.id,include:U.include?.map(te=>i.$gK.fromExtHostTestItem(te,T.root.id).toString())??[T.root.id],persist:ne});const ce=this.j(U,Q,O);return P.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(Q.id),ce.dispose()}),ce.createRun(J)}j(O,M,T,U){const J=new d(M,this.g,T,this.h,U);this.c.set(O,J);let ne;const ee=J.onDidCoverage(({runId:Q,taskId:Y,coverage:ce})=>{ne||(ne={runId:Q,coverage:new Map},this.f.unshift(ne),this.f.length>n.$nK&&this.f.pop()),ne.coverage.set(Y,ce),this.g.$signalCoverageAvailable(Q,Y,!!ce)});return P.Event.once(J.onEnd)(()=>{this.c.delete(O),ee.dispose()}),J}}e.$sic=l;const c=j=>{if(j.profile){if(!(j.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class p{static fromPublic(O,M,T,U){return new p(O,(0,C.$sg)(),T.include?.map(J=>i.$gK.fromExtHostTestItem(J,O).toString())??[O],T.exclude?.map(J=>i.$gK.fromExtHostTestItem(J,O).toString())??[],U,M)}static fromInternal(O,M){return new p(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,M)}constructor(O,M,T,U,J,ne){this.controllerId=O,this.id=M,this.isPersisted=J,this.colllection=ne,this.c=T.map(ee=>ee+"\0"),this.f=U.map(ee=>ee+"\0")}isIncluded(O){const M=i.$gK.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const T of this.f)if(M===T||M.startsWith(T))return!1;for(const T of this.c)if(M===T||M.startsWith(T))return!0;return!1}}e.$tic=p;class I{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(O,M){const T=await this.c;let U=T?.[O];return!this.provider||!T||!U?[]:(U.detailedCoverage||(U=T[O]=await this.provider.resolveFileCoverage?.(U,M)??U),U.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(O){this.j=O,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,m.TestItem.toPlain(O.item)),this.c.has(O)||this.f.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.f.delete(O);const M=i.$gK.parentId(O.item.extId);if(M&&this.h.has(M.toString())){this.h.add(O.item.extId);return}this.g.add(O)}getChangeEvent(){const{c:O,f:M,g:T}=this;return{get added(){return[...O].map(U=>U.revived)},get updated(){return[...M].map(U=>U.revived)},get removed(){return[...T].map(U=>U.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends n.$oK{constructor(){super(...arguments),this.s=new P.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(O){return this.f.get(O)}getMirroredTestDataByReference(O){return this.f.get(O.id)}w(O,M){return{...O,revived:m.TestItem.toPlain(O.item),depth:M?M.depth+1:0,children:new Set}}v(){return new w(this.s)}}class y{constructor(O){this.f=O}checkout(){this.c||(this.c=this.g());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(M=>M.revived)},dispose:(0,A.$db)(()=>{--O.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}g(){const O=new g({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:O}}}const L=(j,O,M,T)=>{M?Object.assign(M,T):O.$updateTestRunConfig(j.controllerId,j.profileId,T)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(O){O!==this.f&&(this.f=O,L(this,this.#e,this.#n,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,L(this,this.#e,this.#n,{supportsContinuousRun:O}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(O){O!==this.isDefault&&(O?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,L(this,this.#e,this.#n,{tag:O?m.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,L(this,this.#e,this.#n,{hasConfigurationHandler:!!O}))}get onDidChangeDefault(){return P.Event.chain(this.#i,O=>O.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(R.$Sf))}constructor(O,M,T,U,J,ne,ee,Q,Y,ce=!1,te=void 0,fe=!1){this.controllerId=J,this.profileId=ne,this.f=ee,this.kind=Q,this.runHandler=Y,this._tag=te,this.g=fe,this.#e=O,this.#s=M,this.#t=T,this.#i=U,M.set(ne,this);const re=z[Q];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ce&&T.add(ne),this.#n={profileId:ne,controllerId:J,tag:te?m.TestTag.namespace(this.controllerId,te.id):null,label:ee,group:re,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$uic=F;const z={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Ce[152],Ie([1,0,61,14,121,16,7]),function(me,e,D,N,f,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=e.$LN=e.$KN=void 0;class v{static{this.c=new f.$IN("TextEditorDecorationType")}constructor(b,E,S){const u=v.c.nextId();b.$registerTextEditorDecorationType(E.identifier,u,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:u,dispose(){b.$removeTextEditorDecorationType(u)}})}}e.$KN=v;class ${constructor(b,E){this.g=[],this.h=void 0,this.j=!1,this.c=b,this.d=b.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(b,E){this.k();let S=null;if(b instanceof A.$sL)S=new A.$tL(b,b);else if(b instanceof A.$tL)S=b;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(b,E){this.k(),this.l(new A.$tL(b,b),E,!0)}delete(b){this.k();let E=null;if(b instanceof A.$tL)E=b;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(b,E,S){const u=this.c.validateRange(b);this.g.push({range:u,text:E,forceMoveMarkers:S})}setEndOfLine(b){if(this.k(),b!==A.EndOfLine.LF&&b!==A.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=b}}class k{constructor(b,E,S,u){this.c=b,this.d=E,this._accept(S),this.e=u;const m=this;this.value={get tabSize(){return m.f},set tabSize(a){m.n(a)},get indentSize(){return m.g},set indentSize(a){m.p(a)},get insertSpaces(){return m.j},set insertSpaces(a){m.s(a)},get cursorStyle(){return m.k},set cursorStyle(a){m.t(a)},get lineNumbers(){return m.l},set lineNumbers(a){m.u(a)}}}_accept(b){this.f=b.tabSize,this.g=b.indentSize,this.h=b.originalIndentSize,this.j=b.insertSpaces,this.k=b.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(b.lineNumbers)}m(b){if(b==="auto")return"auto";if(typeof b=="number"){const E=Math.floor(b);return E>0?E:null}if(typeof b=="string"){const E=parseInt(b,10);return isNaN(E)?null:E>0?E:null}return null}n(b){const E=this.m(b);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(b){if(b==="tabSize")return"tabSize";if(typeof b=="number"){const E=Math.floor(b);return E>0?E:null}if(typeof b=="string"){const E=parseInt(b,10);return isNaN(E)?null:E>0?E:null}return null}p(b){const E=this.o(b);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(b){return b==="auto"?"auto":b==="false"?!1:!!b}s(b){const E=this.q(b);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(b){this.k!==b&&(this.k=b,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:b})))}u(b){this.l!==b&&(this.l=b,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(b)})))}assign(b){const E={};let S=!1;if(typeof b.tabSize<"u"){const u=this.m(b.tabSize);u==="auto"?(S=!0,E.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,S=!0,E.tabSize=u)}if(typeof b.indentSize<"u"){const u=this.o(b.indentSize);u==="tabSize"?(S=!0,E.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,S=!0,E.indentSize=u)}if(typeof b.insertSpaces<"u"){const u=this.q(b.insertSpaces);u==="auto"?(S=!0,E.insertSpaces=u):this.j!==u&&(this.j=u,S=!0,E.insertSpaces=u)}typeof b.cursorStyle<"u"&&this.k!==b.cursorStyle&&(this.k=b.cursorStyle,S=!0,E.cursorStyle=b.cursorStyle),typeof b.lineNumbers<"u"&&this.l!==b.lineNumbers&&(this.l=b.lineNumbers,S=!0,E.lineNumbers=P.TextEditorLineNumbersStyle.from(b.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(b,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${b}' failed:'`),this.e.warn(S)})}}e.$LN=k;class R{constructor(b,E,S,u,m,a,i,r){this.id=b,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=m,this.d=new k(this.j,this.id,a,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return u.value},set document(o){throw new N.$9("document")},get selection(){return n.c&&n.c[0]},set selection(o){if(!(o instanceof A.$uL))throw(0,N.$7)("selection");n.c=[o],n.l()},get selections(){return n.c},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof A.$uL)))throw(0,N.$7)("selections");n.c=o,n.l()},get visibleRanges(){return n.e},set visibleRanges(o){throw new N.$9("visibleRanges")},get options(){return n.d.value},set options(o){n.g||n.d.assign(o)},get viewColumn(){return n.f},set viewColumn(o){throw new N.$9("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new $(u.value,t);return o(h),n.m(h)},insertSnippet(o,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(d=>P.Range.from(d));else if(t instanceof A.$sL){const{lineNumber:d,column:l}=P.Position.from(t);s=[{startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l}]}else if(t instanceof A.$tL)s=[P.Range.from(t)];else{s=[];for(const d of t)if(d instanceof A.$tL)s.push(P.Range.from(d));else{const{lineNumber:l,column:c}=P.Position.from(d);s.push({startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c})}}return E.$tryInsertSnippet(b,u.value.version,o.value,s,h)},setDecorations(o,t){const h=t.length===0;h&&!n.h.has(o.key)||(h?n.h.delete(o.key):n.h.add(o.key),n.n(()=>{if(P.$AN(t))return E.$trySetDecorations(b,o.key,P.$BN(t));{const s=new Array(4*t.length);for(let d=0,l=t.length;d<l;d++){const c=t[d];s[4*d]=c.start.line+1,s[4*d+1]=c.start.character+1,s[4*d+2]=c.end.line+1,s[4*d+3]=c.end.character+1}return E.$trySetDecorationsFast(b,o.key,s)}}))},revealRange(o,t){n.n(()=>E.$tryRevealRange(b,P.Range.from(o),t||A.TextEditorRevealType.Default))},show(o){E.$tryShowEditor(b,P.ViewColumn.from(o))},hide(){E.$tryHideEditor(b)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(b){(0,D.ok)(!this.g),this.d._accept(b)}_acceptVisibleRanges(b){(0,D.ok)(!this.g),this.e=b}_acceptViewColumn(b){(0,D.ok)(!this.g),this.f=b}_acceptSelections(b){(0,D.ok)(!this.g),this.c=b}async l(){const b=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,b)),this.value}m(b){const E=b.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(m=>m.range);S.sort((m,a)=>m.end.line===a.end.line?m.end.character===a.end.character?m.start.line===a.start.line?m.start.character-a.start.character:m.start.line-a.start.line:m.end.character-a.end.character:m.end.line-a.end.line);for(let m=0,a=S.length-1;m<a;m++){const i=S[m].end;if(S[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=E.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,u,{setEndOfLine:typeof E.setEndOfLine=="number"?P.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(b){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$MN=R}),define(Ce[73],Ie([1,0,61,4,3,2,5,6,149,20,152,16,13,28,15,53,43]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=e.$NN=void 0;class a{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,o){this.h=n,this.i=o,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new N.$Wd,this.e=new N.$Wd,this.f=new N.$Wd,this.g=new N.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const o=[],t=[],h=[];if(n.removedDocuments)for(const s of n.removedDocuments){const d=P.URI.revive(s),l=this.c.get(d);l?.unref()&&(this.c.delete(d),o.push(l.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const d=P.URI.revive(s.uri);let l=this.c.get(d);if(l&&d.scheme!==S.Schemas.vscodeNotebookCell&&d.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);l||(l=new a(new $.$GN(this.h.getProxy(v.$pL.MainThreadDocuments),d,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(d,l),t.push(l.value)),l.ref()}if(n.removedEditors)for(const s of n.removedEditors){const d=this.b.get(s);this.b.delete(s),d&&h.push(d)}if(n.addedEditors)for(const s of n.addedEditors){const d=P.URI.revive(s.documentUri);D.ok(this.c.has(d),`document '${d}' does not exist`),D.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const l=this.c.get(d).value,c=new R.$MN(s.id,this.h.getProxy(v.$pL.MainThreadTextEditors),this.i,new m.$V(()=>l.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(p=>C.Range.to(p)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,c)}n.newActiveEditor!==void 0&&(D.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,f.$Oc)(o),(0,f.$Oc)(h),n.removedDocuments&&this.e.fire(o),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return u.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const o=this.b.get(this.a);return n?o:o?.value}allEditors(){return[...this.b.values()]}};e.$NN=i,e.$NN=i=Ke([We(0,k.$DN),We(1,b.$qj)],i),e.$ON=(0,A.$9h)("IExtHostDocumentsAndEditors")}),define(Ce[348],Ie([1,0,19,4,6,152,16,7]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class ${constructor(R,C){this.i=C,this.a=new N.$Wd,this.b=new N.$Wd,this.c=new N.$Wd,this.d=new N.$Wd,this.f=new N.$Wd,this.g=new N.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(f.$pL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(b=>b.value)}async showTextDocument(R,C,b){let E;typeof C=="number"?E={position:A.ViewColumn.from(C),preserveFocus:b}:typeof C=="object"?E={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,E),u=S&&this.i.getEditor(S);if(u)return u.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new P.$KN(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const b=this.i.getEditor(R);if(!b)throw new Error("unknown text editor");if(C.options&&b._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(A.Selection.to);b._acceptSelections(E)}if(C.visibleRanges){const E=D.$Hb(C.visibleRanges.map(A.Range.to));b._acceptVisibleRanges(E)}if(C.options&&this.b.fire({textEditor:b.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=v.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(A.Selection.to);this.a.fire({textEditor:b.value,selections:S,kind:E})}if(C.visibleRanges){const E=D.$Hb(C.visibleRanges.map(A.Range.to));this.c.fire({textEditor:b.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const C in R){const b=this.i.getEditor(C);if(!b)throw new Error("Unknown text editor");const E=A.ViewColumn.to(R[C]);b.value.viewColumn!==E&&(b._acceptViewColumn(E),this.d.fire({textEditor:b.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$Qgc=$}),define(Ce[349],Ie([1,0,2,5,6,3,7,16,25,18]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=void 0,e.$wic=(0,N.$9h)("IExtHostTimeline");class R{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy(f.$pL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(u,m)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&$.$om.equals(m,this.b.get(u.source)?.extension)){const a=u.uri===void 0?void 0:D.URI.revive(u.uri);return this.c.get(u.source)?.get(C(a))?.get(u.handle)}else return;return u}})}async $getTimeline(E,S,u,m){return this.b.get(E)?.provider.provideTimeline(D.URI.revive(S),u,m)}registerTimelineProvider(E,S,u,m){const a=new P.$Sc,i=this.d(S.id,m,a).bind(this);let r;S.onDidChange&&(r=S.onDidChange(o=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...o,id:S.id}),this));const n=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(o,t,h){t?.resetCache&&(a.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(o,t,h);if(s==null)return;const d=i(o,t);return{...s,source:S.id,items:s.items.map(d)}},dispose(){for(const o of n.values())o.get(S.id)?.clear();r?.dispose(),a.dispose()}},u)}d(E,S,u){return(m,a)=>{let i;if(a?.cacheResults){let r=this.c.get(E);r===void 0&&(r=new Map,this.c.set(E,r));const n=C(m);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...o}=r,t=`${E}|${r.id??r.timestamp}`;i?.set(t,r);let h,s,d;r.iconPath&&(n instanceof A.$mM?d={id:n.id,color:n.color}:D.URI.isUri(n)?(h=n,s=n):{light:h,dark:s}=n);let l;return A.$SL.isMarkdownString(o.tooltip)?l=v.MarkdownString.from(o.tooltip):(0,k.$Kf)(o.tooltip)?l=o.tooltip:A.$SL.isMarkdownString(o.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=v.MarkdownString.from(o.detail)):(0,k.$Kf)(o.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=o.detail),{...o,id:o.id??void 0,handle:t,source:E,command:r.command?S.toInternal(r.command,u):void 0,icon:h,iconDark:s,themeIcon:d,tooltip:l,accessibilityInformation:r.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,P.$Rc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$xic=R;function C(b){return b?.toString()}}),define(Ce[350],Ie([1,0,221,23,2,4,3,280,8,7,18,19,16,63,22,178,26]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;function a(n,o){if((0,R.$Kf)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends A.$Tc{constructor(o,t,h){super(),this.f=o,this.g=t,this.h=h,this.a=new Map,this.b=new u.$X8;function s(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>s(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(l=>s(l)?this.r(l):l):d})}registerTreeDataProvider(o,t,h){const s=this.createTreeView(o,{treeDataProvider:t},h);return{dispose:()=>s.dispose()}}createTreeView(o,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,c=!!t.dragAndDropController?.handleDrop,p=this.m(o,t,h),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:d,hasHandleDrag:l,hasHandleDrop:c,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(o,I),g={get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get activeItem(){return(0,m.$MF)(h,"treeViewActiveItem"),p.focusedElement},get onDidChangeActiveItem(){return(0,m.$MF)(h,"treeViewActiveItem"),p.onDidChangeActiveItem},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get onDidChangeCheckboxState(){return p.onDidChangeCheckboxState},get message(){return p.message},set message(y){(0,E.$mk)(y)&&(0,m.$MF)(h,"treeViewMarkdownMessage"),p.message=y},get title(){return p.title},set title(y){p.title=y},get description(){return p.description},set description(y){p.description=y},get badge(){return p.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?p.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(p.badge=void 0)},reveal:(y,L)=>p.reveal(y,L),dispose:async()=>{await w,this.a.delete(o),p.dispose()}};return this.B(g),g}$getChildren(o,t){const h=this.a.get(o);return h?h.getChildren(t):Promise.reject(new v.$fF(o))}async $handleDrop(o,t,h,s,d,l,c,p){const I=this.a.get(o);if(!I)return Promise.reject(new v.$fF(o));const w=b.DataTransfer.toDataTransfer(h,async g=>(await this.f.$resolveDropFileData(o,t,g)).buffer);return c===o&&p&&await this.j(w,I,p,d,l),I.onDrop(w,s,d)}async j(o,t,h,s,d){const l=this.b.removeDragOperationTransfer(d);if(l)(await l)?.forEach((c,p)=>{c&&o.set(p,c)});else if(d&&t.handleDrag){const c=t.handleDrag(h,o,s);this.b.addDragOperationTransfer(d,c),await c}return o}async $handleDrag(o,t,h,s){const d=this.a.get(o);if(!d)return Promise.reject(new v.$fF(o));const l=await this.j(new k.$jM,d,t,s,h);if(!(!l||s.isCancellationRequested))return b.DataTransfer.from(l)}async $hasResolve(o){const t=this.a.get(o);if(!t)throw new v.$fF(o);return t.hasResolve}$resolve(o,t,h){const s=this.a.get(o);if(!s)throw new v.$fF(o);return s.resolveTreeItem(t,h)}$setExpanded(o,t,h){const s=this.a.get(o);if(!s)throw new v.$fF(o);s.setExpanded(t,h)}$setSelectionAndFocus(o,t,h){const s=this.a.get(o);if(!s)throw new v.$fF(o);s.setSelectionAndFocus(t,h)}$setVisible(o,t){const h=this.a.get(o);if(!h){if(!t)return;throw new v.$fF(o)}h.setVisible(t)}$changeCheckboxState(o,t){const h=this.a.get(o);if(!h)throw new v.$fF(o);h.setCheckboxState(t)}m(o,t,h){const s=this.B(new r(o,t,this.f,this.g.converter,this.h,h));return this.a.set(o,s),s}r(o){const t=this.a.get(o.$treeViewId);return t&&"$treeItemHandle"in o?t.getExtensionElement(o.$treeItemHandle):t&&"$focusedTreeItem"in o&&o.$focusedTreeItem?t.focusedElement:null}}e.$yic=i;class r extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(o=>this.getExtensionElement(o)).filter(o=>!(0,R.$Tf)(o))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(o,t,h,s,d,l){if(super(),this.I=o,this.J=h,this.L=s,this.M=d,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$7d,l.contributes&&l.contributes.views)for(const w in l.contributes.views)for(const g of l.contributes.views[w])g.id===o&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let c,p;const I=P.Event.debounce(this.F.event,(w,g)=>(w||(w={message:!1,elements:[]}),g.element!==!1&&(c||(c=new Promise(y=>p=y),this.G=this.G.then(()=>c)),Array.isArray(g.element)?w.elements.push(...g.element):w.elements.push(g.element)),g.message&&(w.message=!0),w),200,!0);this.B(I(({message:w,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const y=p;return c=null,this.$(g).then(()=>y())})),w&&this.J.$setMessage(this.I,b.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(o){const t=o?this.getExtensionElement(o):void 0;if(o&&!t)return this.M.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let h=this.X(o);return h||(h=await this.Y(t)),h?h.map(s=>s.item):void 0}getExtensionElement(o){return this.j.get(o)}reveal(o,t){t=t||{select:!0,focus:!1};const h=(0,R.$Tf)(t.select)?!0:t.select,s=(0,R.$Tf)(t.focus)?!1:t.focus,d=(0,R.$Tf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.G.then(()=>this.S(o)).then(l=>this.W(o,l[l.length-1]).then(c=>this.J.$reveal(this.I,{item:c.item,parentChain:l.map(p=>p.item)},{select:h,focus:s,expand:d})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:h,focus:s,expand:d})}get message(){return this.O}set message(o){this.O=o,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(o){this.P=o,this.J.$setTitle(this.I,o,this.Q)}get description(){return this.Q}set description(o){this.Q=o,this.J.$setTitle(this.I,this.P,o)}get badge(){return this.R}set badge(o){this.R?.value===o?.value&&this.R?.tooltip===o?.tooltip||(this.R=b.ViewBadge.from(o),this.J.$setBadge(this.I,o))}setExpanded(o,t){const h=this.getExtensionElement(o);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(o,t){const h=!(0,C.$ub)(this.s,o);this.s=o;const s=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(o){o!==this.r&&(this.r=o,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(o){const t=(await Promise.all(o.map(async h=>{const s=this.getExtensionElement(h.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(o,t,h){const s=[];for(const d of o){const l=this.getExtensionElement(d);l&&s.push(l)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(o,t,h){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$1g)(()=>this.g?.handleDrop?this.g.handleDrop(s,o,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(o,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(o);if(h){const s=this.m.get(h);if(s){const d=await this.f.resolveTreeItem(s.extensionItem,h,t)??s.extensionItem;return this.hb(d),s.item.tooltip=this.eb(d.tooltip),s.item.command=this.fb(s.disposableStore,d.command),s.item}}}S(o){return this.U(o).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(s=>(h.push(s),h))):Promise.resolve([]))}U(o){const t=this.m.get(o);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$1g)(()=>this.f.getParent(o))}W(o,t){const h=this.m.get(o);return h?Promise.resolve(h):(0,$.$1g)(()=>this.f.getTreeItem(o)).then(s=>this.kb(o,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(s);if(d){const l=this.m.get(d);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(o){if(o){let t;if(typeof o=="string"){const h=this.getExtensionElement(o);t=h?this.m.get(h):void 0}else t=o;return t&&t.children||void 0}return this.h}async Y(o){this.rb(o);const t=new S.$7d(this.Z.token);try{const h=o?this.m.get(o):void 0,s=await this.f.getChildren(o);if(t.token.isCancellationRequested)return;const d=(0,C.$Hb)(s||[]),l=await Promise.all((0,C.$Hb)(d).map(p=>this.f.getTreeItem(p)));if(t.token.isCancellationRequested)return;const c=l.map((p,I)=>p?this.db(d[I],p,h):null);return(0,C.$Hb)(c)}finally{t.dispose()}}$(o){if(o.some(h=>!h))return this.Z.dispose(!0),this.Z=new S.$7d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(o);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(o){const t=new Set,h=o.map(d=>this.m.get(d));for(const d of h)if(d&&!t.has(d.item.handle)){let l=d;for(;l&&l.parent&&h.findIndex(c=>l&&l.parent&&c&&c.item.handle===l.parent.item.handle)===-1;){const c=this.j.get(l.parent.item.handle);l=c?this.m.get(c):void 0}l&&!l.parent&&t.add(d.item.handle)}const s=[];return t.forEach(d=>{const l=this.j.get(d);if(l){const c=this.m.get(l);c&&(!c.parent||!t.has(c.parent.item.handle))&&s.push(d)}}),s}bb(o){const t={};return Promise.all(o.map(h=>this.cb(h).then(s=>{s&&(t[h]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(o){const t=this.getExtensionElement(o);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,$.$1g)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const d=this.ib(t,s,h.parent);return this.pb(t,d,h,h.parent),h.dispose(),d}return null})}return Promise.resolve(null)}db(o,t,h){const s=this.ib(o,t,h);if(t.id&&this.j.has(s.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(o,s),this.qb(s,h),s}eb(o){return k.$SL.isMarkdownString(o)?b.MarkdownString.from(o):o}fb(o,t){return t?{...this.L.toInternal(t,o),originalId:t.command}:void 0}gb(o){if(o.checkboxState===void 0)return;let t,h,s;return typeof o.checkboxState=="number"?t=o.checkboxState:(t=o.checkboxState.state,h=o.checkboxState.tooltip,s=o.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:s}}hb(o){if(!k.$eM.isTreeItem(o,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(o,t,h){this.hb(t);const s=this.B(new A.$Sc),d=this.kb(o,t,h),l=this.lb(t);return{item:{handle:d,parentHandle:h?h.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,R.$Tf)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(o){return o.iconPath instanceof k.$mM?o.iconPath:void 0}kb(o,{id:t,label:h,resourceUri:s},d,l){if(t)return`${r.b}/${t}`;const c=a(h,this.N),p=d?d.item.handle:r.a;let I=c?c.label:s?(0,N.$Gg)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const w=this.m.has(o)?this.m.get(o).item.handle:void 0,g=this.X(d)||[];let y,L=0;do{if(y=`${p}/${L}:${I}`,l||!this.j.has(y)||w===y)break;L++}while(L<=g.length);return y}lb(o){if(o.iconPath&&!(o.iconPath instanceof k.$mM))return typeof o.iconPath=="string"||f.URI.isUri(o.iconPath)?this.nb(o.iconPath):this.nb(o.iconPath.light)}mb(o){if(o.iconPath&&!(o.iconPath instanceof k.$mM)&&o.iconPath.dark)return this.nb(o.iconPath.dark)}nb(o){return f.URI.isUri(o)?o:f.URI.file(o)}ob(o,t){this.j.set(t.item.handle,o),this.m.set(o,t)}pb(o,t,h,s){this.j.delete(t.item.handle),this.m.delete(o),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(o,t);const d=this.X(s)||[],l=d.filter(c=>c.item.handle===h.item.handle)[0];l&&d.splice(d.indexOf(l),1,t)}qb(o,t){t?(t.children||(t.children=[]),t.children.push(o)):(this.h||(this.h=[]),this.h.push(o))}rb(o){if(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(o){const t=this.m.get(o);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}this.m.delete(o),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(o=>o.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[351],Ie([1,0,4,3,2,30,16,92,6,7]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class R extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(S,u,m,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=u,this.#n=m,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,f.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Tc{static c(){return(0,P.$sg)()}constructor(S,u,m){super(),this.j=u,this.m=m,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$pL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,u,m,a,i={}){const r=typeof a=="object"?a.viewColumn:a,n={viewColumn:A.ViewColumn.from(r),preserveFocus:typeof a=="object"&&!!a.preserveFocus},o=(0,v.$6gc)(S),t=C.c();this.f.$createWebviewPanel((0,v.$8gc)(S),t,u,{title:m,panelOptions:b(i),webviewOptions:(0,v.$9gc)(S,this.m,i),serializeBuffersForPostMessage:o},n);const h=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,u,m,r,i,h,!0)}$onDidChangeWebviewPanelViewStates(S){const u=Object.keys(S);u.sort((m,a)=>{const i=S[m],r=S[a];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const m of u){const a=this.getWebviewPanel(m);if(!a)continue;const i=S[m];a._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,u,m){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:m,extension:S}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,v.$6gc)(S)}),new k.$rL(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(S,u,m,a){const i=this.h.get(u);if(!i)throw new Error(`No serializer found for '${u}'`);const{serializer:r,extension:n}=i,o=this.j.createNewWebview(S,m.webviewOptions,n),t=this.createNewWebviewPanel(S,u,m.title,a,m.panelOptions,o,m.active);await r.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(S,u,m,a,i,r,n){const o=new R(S,this.f,r,{viewType:u,title:m,viewColumn:a,panelOptions:i,active:n});return this.g.set(S,o),o}getWebviewPanel(S){return this.g.get(S)}}e.$0gc=C;function b(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[352],Ie([1,0,4,3,92,16,6,7]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class $ extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,b,E,S,u,m){super(),this.#s=!1,this.#u=this.B(new D.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Wd),this.onDidDispose=this.#l.event,this.#i=E,this.#a=S,this.#e=C,this.#t=b,this.#n=u,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(C,b){this.d=b,this.b=new Map,this.c=new Map,this.a=C.getProxy(A.$pL.MainThreadWebviewViews)}registerWebviewViewProvider(C,b,E,S){if(this.b.has(b))throw new Error(`View provider for '${b}' already registered`);return this.b.set(b,{provider:E,extension:C}),this.a.$registerWebviewViewProvider((0,f.$8gc)(C),b,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$6gc)(C)}),new v.$rL(()=>{this.b.delete(b),this.a.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(C,b,E,S,u){const m=this.b.get(b);if(!m)throw new Error(`No view provider found for '${b}'`);const{provider:a,extension:i}=m,r=this.d.createNewWebview(C,{},i),n=new $(C,this.a,b,E,r,!0);this.c.set(C,n),await a.resolveWebviewView(n,{state:S},u)}async $onDidChangeWebviewViewVisibility(C,b){this.e(C)._setVisible(b)}async $disposeWebviewView(C){const b=this.e(C);this.c.delete(C),b.dispose(),this.d.deleteWebview(C)}e(C){const b=this.c.get(C);if(!b)throw new Error("No webview found");return b}}e.$Bic=k}),define(Ce[353],Ie([1,0,70,15,13,251,32,11]),function(me,e,D,N,f,P,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;let $=class{constructor(C,b){C.addFileSystemProvider(N.Schemas.file,new k(b),{isCaseSensitive:v.$k})}};e.$gjc=$,e.$gjc=$=Ke([We(0,D.$2gc),We(1,f.$qj)],$);class k{constructor(C){this.b=C,this.a=new P.$Eq(this.b)}async stat(C){const b=await this.a.stat(C);return{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,b,E){return this.a.writeFile(C,b,{...E,unlock:!1,atomic:!1})}delete(C,b){return this.a.delete(C,{...b,useTrash:!1,atomic:!1})}rename(C,b,E){return this.a.rename(C,b,E)}copy(C,b,E){return this.a.copy(C,b,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,b){throw new Error("Method not implemented.")}}}),define(Ce[354],Ie([1,0,17,64,30,33,3,6,2,20]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;let R=class extends A.$Tc{constructor(b,E){super();const S=b.getProxy(v.$pL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async u=>{const m=$.URI.file((0,D.$jc)((0,N.tmpdir)(),(0,f.$sg)()));return await S.$download(u,m),m})}};e.$ejc=R,e.$ejc=R=Ke([We(0,k.$DN),We(1,P.$ZN)],R)}),define(Ce[355],Ie([1,0,57,17,2,93,3,15,8,31]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;class R extends P.$4gc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==v.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const s=h.fsPath;let d=0;do{let l;d===0?l=s:l=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${d}`:`${s}-${d}`,await C(l);const c=N.$jc(l,"vscode.lock"),p=await u(this.d,c,!1);if(p)return this.i=p,process.on("exit",()=>{p.dispose()}),f.URI.file(l);d++}while(d<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$qjc=R;async function C(o){try{await k.Promises.stat(o);return}catch{}try{await k.Promises.mkdir(o,{recursive:!0})}catch{}}const b=1e3,E=10*60*1e3;class S extends A.$Tc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new $.$hh),this.a.cancelAndSet(async()=>{const s=await m(t,h);(!s||s.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(h,new Date,new Date)}catch(d){t.error(d),t.info(`Lock '${h}': Could not update mtime.`)}},b)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function u(o,t,h){try{const d={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(d),{flag:"wx"})}catch(d){o.error(d)}const s=await m(o,t);return!s||s.pid!==process.pid?h?(o.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(o,t)):(o.info(`Lock '${t}': Lock acquired.`),new S(o,t))}async function m(o,t){let h;try{h=await k.Promises.readFile(t)}catch(s){return o.error(s),null}try{return JSON.parse(String(h))}catch(s){return o.error(s),null}}async function a(o,t){let h;try{h=await k.Promises.stat(t)}catch(s){return o.error(s),0}return h.mtime.getTime()}function i(o){try{return process.kill(o,0),!0}catch{return!1}}async function r(o,t){const h=await m(o,t);if(!h)return o.info(`Lock '${t}': Could not read pid of lock holder.`),n(o,t);if(h.willReleaseAt){let p=h.willReleaseAt-Date.now();if(p<5e3){for(p>0?o.info(`Lock '${t}': The lockfile is scheduled to be released in ${p} ms.`):o.info(`Lock '${t}': The lockfile is scheduled to have been released.`);p>0;){if(await(0,$.$0g)(Math.min(100,p)),await a(o,t)===0)return n(o,t);p=h.willReleaseAt-Date.now()}return n(o,t)}}if(!i(h.pid))return o.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),n(o,t);const s=await a(o,t),d=Date.now()-s;if(d<=E)return o.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null;o.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$0g)(2e3);const l=await a(o,t),c=Date.now()-l;return c<=E?(o.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(o.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(o,t))}async function n(o,t){o.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return u(o,t,!0)}}),define(Ce[356],Ie([1,0,30,20,46,33]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;let A=class extends f.$nhc{constructor($,k){super(!0,$,k)}createTerminal($,k,R){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:R})}createTerminalFromOptions($,k){const R=new f.$mhc(this.a,(0,D.$sg)(),$,$.name);return this.f.push(R),R.create($,this.R($,k)),R.value}};e.$Lic=A,e.$Lic=A=Ke([We(0,P.$ZN),We(1,N.$DN)],A)}),define(Ce[357],Ie([1,0,4,37,45,5]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LK=e.$KK=e.OutputChannelUpdateMode=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=void 0,e.$AK="text/x-code-output",e.$BK="output",e.$CK="Log",e.$DK="text/x-code-log-output",e.$EK="log",e.$FK="workbench.panel.output",e.$GK=new f.$nj("inOutput",!1),e.$HK=new f.$nj("activeLogOutput",!1),e.$IK=new f.$nj("outputView.scrollLock",!1),e.$JK=(0,P.$9h)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$KK={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.a=new Map,this.b=new D.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(R=>k.push(R)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}N.$Ln.add(e.$KK.OutputChannels,new v),e.$LK=new f.$nj("activeOutputChannel","")}),define(Ce[153],Ie([1,0,6,5,20,25,13,357,70,27,59,183,21,18,32,4,3]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;class a extends A.$wj{get disposed(){return this.n}constructor(o,t,h,s,d){super(),this.id=o,this.name=t,this.r=h,this.s=s,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(o){this.append(o+`
`)}append(o){this.info(o)}clear(){const o=this.m;this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Clear,o)}replace(o){const t=this.m;this.info(o),this.s.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(o,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof o=="boolean"?o:t))}hide(){this.s.$close(this.id)}g(o,t){this.m+=b.$ke.fromString(t).byteLength,(0,A.log)(this.r,o,t),this.visible&&(this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends a{appendLine(o){this.append(o)}}let r=class{constructor(o,t,h,s,d,l){this.i=t,this.j=h,this.k=s,this.l=d,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=o.getProxy(D.$pL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Am)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.h=o;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(o,t,h){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,d=(0,E.$Kf)(t)?t:void 0;if((0,E.$Kf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const c=this.i.environment.extensionLogLevel?.find(([I])=>P.$om.equals(h.identifier,I))?.[1];c&&(l=(0,A.$Gj)(c));const p=s?this.o(o,l,h):this.n(o,d,h);return p.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),s?this.r(o,l??this.m.getLevel(),p):this.q(o,p)}async n(o,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,d=this.k.extUri.joinPath(s,`${this.f++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),c=await this.a.$register(o,d,t,h.identifier.value);return new a(c,o,l,this.a,h)}async o(o,t,h){const s=await this.p(h),d=o.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(s,`${d}.log`),c=`${h.identifier.value}.${d}`,p=this.l.createLogger(l,{id:c,name:o,logLevel:t,extensionId:h.identifier.value});return new i(c,o,p,this.a,h)}p(o){let t=this.d.get(o.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,o.identifier.value);this.d.set(o.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(s){if((0,S.$Jk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return h})())}return t}q(o,t){let h=!1;const s=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return o},append(d){s(),t.then(l=>l.append(d))},appendLine(d){s(),t.then(l=>l.appendLine(d))},clear(){s(),t.then(d=>d.clear())},replace(d){s(),t.then(l=>l.replace(d))},show(d,l){s(),t.then(c=>c.show(d,l))},hide(){s(),t.then(d=>d.hide())},dispose(){h=!0,t.then(d=>d.dispose())}}}r(o,t,h){const s=new m.$Sc,d=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},l=s.add(new u.$Wd);function c(p){t=p,l.fire(p)}return h.then(p=>{s.add(p),p.logLevel!==t&&c(p.logLevel),s.add(p.onDidChangeLogLevel(I=>c(I)))}),{...this.q(o,h),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(p,...I){d(),h.then(w=>w.trace(p,...I))},debug(p,...I){d(),h.then(w=>w.debug(p,...I))},info(p,...I){d(),h.then(w=>w.info(p,...I))},warn(p,...I){d(),h.then(w=>w.warn(p,...I))},error(p,...I){d(),h.then(w=>w.error(p,...I))},dispose(){s.dispose()}}}};e.$cic=r,e.$cic=r=Ke([We(0,f.$DN),We(1,k.$TN),We(2,$.$2gc),We(3,R.$Bgc),We(4,A.$rj),We(5,A.$qj)],r),e.$dic=(0,N.$9h)("IExtHostOutputService")}),define(Ce[154],Ie([1,0,5,8]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Pm=(0,D.$9h)("remoteAgentService"),e.$Qm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let P=1/0;for(let v=0;v<this.maxSampleCount;v++){const $=await f.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,N.$0g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(P):A=this.initial.reduce((v,$)=>v+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:P,average:this.average.reduce((v,$)=>v+$,0)/this.average.length,high:typeof A>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[358],Ie([1,0,225,86,37,40,51,3,4,154,11,24,8]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=void 0,e.$8H=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$9H=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$0H=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$$H=Object.freeze({id:"problems",title:(0,D.localize)(3,null),type:"object",order:101}),e.$_H={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new $.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const S=new E;f.$Ln.add(e.$_H.ConfigurationMigration,S);let u=class extends v.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,S.migrations)})),this.c(S.migrations),this.B(S.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(n=>this.g(n,i?.uri))])}async g(i,r){const n=this.a.inspect(i.key,{resource:r}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,h]of o){const s=n[t];if(!s)continue;const d=[];if(s.value!==void 0){const l=await this.h(i,t,s.value,r,void 0);for(const c of l??[])d.push([c,[]])}for(const{identifiers:l,value:c}of s.overrides??[])if(c!==void 0){const p=await this.h(i,t,c,r,l);for(const I of p??[])d.push([I,l])}d.length&&await Promise.allSettled(d.map(async([[l,c],p])=>this.a.updateValue(l,c.value,{resource:r,overrideIdentifiers:p},h)))}}async h(i,r,n,o,t){const h=d=>{const c=this.a.inspect(d,{resource:o})[r];if(c)return t?c.overrides?.find(({identifiers:p})=>(0,C.$Dn)(p,t))?.value:c.value},s=await i.migrateFn(n,h);return Array.isArray(s)?s:[[i.key,s]]}};e.$aI=u,e.$aI=u=Ke([We(0,A.$Ci),We(1,P.$fi)],u);let m=class extends v.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new b.$th,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;f.$Ln.as(N.$Qn.Configuration).registerConfiguration({...e.$0H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(4,null)},default:[],markdownDescription:(0,D.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(6,null),scope:2}}})}};e.$bI=m,e.$bI=m=Ke([We(0,k.$Pm)],m)}),define(Ce[359],Ie([1,0,35,15,17,23,234,358,86,5,37]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1db=e.$Zdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Ydb=e.$Xdb=void 0,e.$Xdb=(0,k.$9h)("editorResolverService"),e.$Ydb="workbench.editorAssociations";const C=R.$Ln.as($.$Qn.Configuration),b={...v.$9H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(b);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var S;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function u(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$Zdb=u;function m(a,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const o=typeof a=="string"&&a.indexOf(f.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Gg)(i);return D.$Oj(typeof a=="string"?a.toLowerCase():a,o.toLowerCase())}e.$1db=m}),define(Ce[360],Ie([1,0,34,15,17,11,23,2,5,269,40,144,154]),function(me,e,D,N,f,P,A,v,$,k,R,C,b){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$4K=void 0,e.$4K=(0,$.$9h)("pathService");let S=E=class{constructor(m,a,i,r){this.d=m,this.e=a,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??m})()}hasValidBasename(m,a,i){return typeof a=="string"||typeof a>"u"?this.a.then(r=>this.h(m,r,a)):this.h(m,a,i)}h(m,a,i){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,D.$8f)(i??(0,A.$Gg)(m),a===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,k.$1K)(a.getWorkspace());if(i)return i;const r=a.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=a.getWorkspace().configuration;return n?n.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?f.$fc:f.$gc)}async fileURI(m){let a="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const r=m.indexOf("/",2);r===-1?(a=m.substring(2),m="/"):(a=m.substring(2,r),m=m.substring(r)||"/")}return v.URI.from({scheme:N.Schemas.file,authority:a,path:m,query:"",fragment:""})}};e.$5K=S,e.$5K=S=E=Ke([We(1,b.$Pm),We(2,C.$MK),We(3,R.$fi)],S)}),define(Ce[361],Ie([1,0,236,19,52,4,54,3,2,51,241,13,65,271,88,40,144,26,22,18,24,45]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=e.$VK=e.OnPortForward=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.TunnelSource=e.TunnelCloseReason=e.$PK=e.$OK=e.$NK=void 0;const t=10*1e3,h="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",d=1e3*60*60*24*14;e.$NK="onTunnel",e.$OK=new o.$nj("forwardedPortsViewEnabled",!1,D.localize(0,null));function l(j){const O=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$PK=l;var c;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(c||(e.TunnelCloseReason=c={}));var p;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(p||(e.TunnelSource=p={})),e.$QK={source:p.User,description:D.localize(1,null)},e.$RK={source:p.Auto,description:D.localize(2,null)};function I(j,O,M){const T=j.get(g(O,M));if(T)return T;if((0,S.$Iv)(O))for(const U of S.$Hv){const J=g(U,M);if(j.has(J))return j.get(J)}else if((0,S.$Kv)(O))for(const U of S.$Jv){const J=g(U,M);if(j.has(J))return j.get(J)}}e.$SK=I;function w(j,O,M){const T=I(j,O,M);if(T)return T;const U=(0,S.$Kv)(O)?"localhost":(0,S.$Iv)(O)?"0.0.0.0":void 0;if(U)return I(j,U,M)}e.$TK=w;function g(j,O){return j+":"+O}e.$UK=g;var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function L(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}e.$VK=L;class F extends v.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new P.$Wd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(M=>{(M.affectsConfiguration(F.c)||M.affectsConfiguration(F.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,M,T){let U=this.w(O,M,T,this.j,0);const J={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;U>=0;){const ne=this.j[U];ne.key===O?(J.onAutoForward=ne.onAutoForward??J.onAutoForward,J.elevateIfNeeded=ne.elevateIfNeeded!==void 0?ne.elevateIfNeeded:J.elevateIfNeeded,J.label=ne.label??J.label,J.requireLocalPort=ne.requireLocalPort,J.protocol=ne.protocol):(J.onAutoForward=J.onAutoForward??ne.onAutoForward,J.elevateIfNeeded=J.elevateIfNeeded!==void 0?J.elevateIfNeeded:ne.elevateIfNeeded,J.label=J.label??ne.label,J.requireLocalPort=J.requireLocalPort!==void 0?J.requireLocalPort:void 0,J.protocol=J.protocol??ne.protocol),U=this.w(O,M,T,this.j,U+1)}return J.onAutoForward!==void 0||J.elevateIfNeeded!==void 0||J.label!==void 0||J.requireLocalPort!==void 0||J.protocol!==void 0?J:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,r.$Kf)(O.host)&&(0,r.$Of)(O.port)}w(O,M,T,U,J){if(J>=U.length)return-1;const ne=!(0,S.$Iv)(M)&&!(0,S.$Kv)(M),Q=U.slice(J).findIndex(Y=>(0,r.$Of)(Y.key)?ne?!1:Y.key===O:this.t(Y.key)?ne?!1:O>=Y.key.start&&O<=Y.key.end:this.u(Y.key)?O===Y.key.port&&M===Y.key.host:T?Y.key.test(T):!1);return Q>=0?Q+J:-1}y(){const O=this.r.getValue(F.c);if(!O||!(0,r.$Mf)(O))return[];const M=[];for(const U in O){if(U===void 0)continue;const J=O[U];let ne;if(Number(U))ne=Number(U);else if((0,r.$Kf)(U))if(F.g.test(U)){const ee=U.match(F.g);ne={start:Number(ee[1]),end:Number(ee[2])}}else if(F.h.test(U)){const ee=U.match(F.h);ne={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(U)}catch{}ee&&(ne=ee)}ne&&M.push({key:ne,elevateIfNeeded:J.elevateIfNeeded,onAutoForward:J.onAutoForward,label:J.label,requireLocalPort:J.requireLocalPort,protocol:J.protocol})}const T=this.r.getValue(F.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(M)}z(O){function M(T,U){return(0,r.$Of)(T.key)?T.key:U.t(T.key)?T.key.start:U.u(T.key)?T.key.port:Number.MAX_VALUE}return O.sort((T,U)=>M(T,this)-M(U,this))}C(){return this.m}static providedActionToAction(O){switch(O){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(O,M,T){const J=this.r.inspect(F.c).userRemoteValue;let ne;!J||!(0,r.$Mf)(J)?ne={}:ne=(0,n.$zn)(J),ne[`${O}`]||(ne[`${O}`]={});for(const ee in M)ne[`${O}`][ee]=M[ee];return this.r.updateValue(F.c,ne,T)}}e.$WK=F;let z=class extends v.$Tc{constructor(O,M,T,U,J,ne,ee,Q,Y,ce){super(),this.H=O,this.I=M,this.J=T,this.L=U,this.M=J,this.N=ne,this.O=ee,this.P=Q,this.Q=Y,this.R=ce,this.c=new Map,this.g=new P.$Wd,this.onForwardPort=this.g.event,this.h=new P.$Wd,this.onClosePort=this.h.event,this.j=new P.$Wd,this.onPortName=this.j.event,this.n=new P.$Wd,this.onCandidatesChanged=this.n.event,this.t=new P.$Wd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Wd,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new F(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async te=>{const fe=await this.getAttributes(te.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of te)if(re.localAddress){const K=g(re.tunnelRemoteHost,re.tunnelRemotePort),B=w(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(K,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:fe?.get(re.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(re.localAddress,fe?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:re.privacy,source:e.$QK}),this.f.set(K,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async te=>{const fe=g(te.tunnelRemoteHost,te.tunnelRemotePort);if(!w(this.forwarded,te.tunnelRemoteHost,te.tunnelRemotePort)&&!w(this.detected,te.tunnelRemoteHost,te.tunnelRemotePort)&&!w(this.c,te.tunnelRemoteHost,te.tunnelRemotePort)&&te.localAddress){const re=w(this.m??new Map,te.tunnelRemoteHost,te.tunnelRemotePort),K=(await this.getAttributes([{port:te.tunnelRemotePort,host:te.tunnelRemoteHost}]))?.get(te.tunnelRemotePort);this.forwarded.set(fe,{remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localAddress:te.localAddress,protocol:K?.protocol??S.TunnelProtocol.Http,localUri:await this.X(te.localAddress,K),localPort:te.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:te.privacy,source:e.$QK})}await this.cb(),this.f.set(fe,te),this.g.fire(this.forwarded.get(fe))})),this.B(this.H.onTunnelClosed(te=>this.W(te,c.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$NK))?(this.R.createKey(e.$OK.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,M){const T=g(O.host,O.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(O))}X(O,M){if(O.startsWith("http"))return $.URI.parse(O);const T=M?.protocol??"http";return $.URI.parse(`${T}://${O}`)}async Y(O){const M=this.N.getWorkspace(),T=M.configuration?(0,A.$Wi)(M.configuration.path):M.folders.length>0?(0,A.$Wi)(M.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${O}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(h)}async $(){return this.Y(s)}async ab(){const O=this.I.get(h,1);if(O)return this.I.remove(h,1),await this.cb(),O;const M=await this.Z();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const M=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(T=>T.remotePort).join(", ")}`);for(const T of M){const U=w(this.detected,T.remoteHost,T.remotePort);T.source.source!==p.Extension&&!U||T.source.source===p.Extension&&U?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===p.Extension&&!U&&this.D.set(g(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Z();this.w=this.B(new v.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}bb(){const O=this.I.keys(0,0).filter(M=>M.startsWith(s));for(const M of O){const T=this.I.getNumber(M,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const U=M.replace(s,h);this.I.remove(M,0),this.I.remove(U,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=Array.from(this.forwarded.values()),M=O.map(ne=>({remoteHost:ne.remoteHost,remotePort:ne.remotePort,localPort:ne.localPort,name:ne.name,localAddress:ne.localAddress,localUri:ne.localUri,protocol:ne.protocol,source:ne.source}));let T;O.length>0&&(T=JSON.stringify(M));const U=await this.Z(),J=await this.$();!T&&U&&J?(this.I.remove(U,0),this.I.remove(J,0)):T!==this.y&&U&&J&&(this.I.store(U,T,0,0),this.I.store(J,Date.now()+d,0,0)),this.y=T}}async eb(O,M,T){if(!O.tunnelLocalPort||!T?.requireLocalPort||O.tunnelLocalPort===M)return;const U=new Date;if(this.db.getTime()+t>U.getTime())return;this.db=U;const J=D.localize(3,null,M,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(J)}async forward(O,M){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(O,M)}async fb(O,M){await this.Q.activateByEvent(e.$NK);const T=w(this.forwarded,O.remote.host,O.remote.port);M=M??(M!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const U=O.local!==void 0?O.local:O.remote.port;let J;if(T)return this.hb(T,O,M);{const ne=this.L.remoteAuthority,ee=ne?{getAddress:async()=>(await this.M.resolveAuthority(ne)).authority}:void 0,Q=g(O.remote.host,O.remote.port);this.c.set(Q,!0),O=this.gb(Q,O);const Y=await this.H.openTunnel(ee,O.remote.host,O.remote.port,void 0,U,O.elevateIfNeeded?O.elevateIfNeeded:M?.elevateIfNeeded,O.privacy,M?.protocol);if(typeof Y=="string")J=Y;else if(Y&&Y.localAddress){const ce=w(this.m??new Map,O.remote.host,O.remote.port),te=Y.protocol?Y.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,fe={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:M?.label??O.name,closeable:!0,localAddress:Y.localAddress,protocol:te,localUri:await this.X(Y.localAddress,M),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:O.source??e.$QK,privacy:Y.privacy};return this.forwarded.set(Q,fe),this.f.set(Q,Y),this.c.delete(Q),await this.cb(),await this.eb(Y,U,M),this.g.fire(fe),Y}this.c.delete(Q)}return J}gb(O,M){const T=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(T){const U=T.get(O);T.delete(O),U&&(M.name=U.name??M.name,M.local=("local"in U?U.local:"localPort"in U?U.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(O,M,T){const U=T?.label??M.name;let J;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(J||(J={}));let ne=J.None;switch(U!==O.name&&(O.name=U,ne=J.Fire),(T?.protocol||O.protocol!==S.TunnelProtocol.Http)&&T?.protocol!==O.protocol&&(M.source=O.source,ne=J.Reopen),M.privacy&&O.privacy!==M.privacy&&(ne=J.Reopen),ne){case J.Fire:{this.g.fire();break}case J.Reopen:await this.close(O.remoteHost,O.remotePort,c.User),await this.fb(M,T)}return w(this.f,M.remote.host,M.remote.port)}async name(O,M,T){const U=w(this.forwarded,O,M),J=g(O,M);if(U){U.name=T,await this.cb(),this.j.fire({host:O,port:M});return}else this.detected.has(J)&&(this.detected.get(J).name=T,this.j.fire({host:O,port:M}))}async close(O,M,T){const U=g(O,M),J=this.forwarded.get(U);return T===c.AutoForwardEnd&&J&&J.source.source===p.Auto&&this.F.set(U,{local:J.localPort,name:J.name,privacy:J.privacy}),await this.H.closeTunnel(O,M),this.W({host:O,port:M},T)}address(O,M){const T=g(O,M);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const M of O){const T=w(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),U=typeof M.localAddress=="string"?M.localAddress:g(M.localAddress.host,M.localAddress.port);this.detected.set(g(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:U,protocol:S.TunnelProtocol.Http,localUri:this.X(U),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:p.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,U,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let M=O;this.r&&(M=await this.r(O));const T=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(U=>U.port).join(", ")}`),this.n.fire(T)}ib(O){const M=this.m??new Map,T=new Map;return this.m=T,O.forEach(U=>{const J=g(U.host,U.port);T.set(J,{host:U.host,port:U.port,detail:U.detail,pid:U.pid}),M.has(J)&&M.delete(J);const ne=w(this.forwarded,U.host,U.port);ne&&(ne.runningProcess=U.detail,ne.hasRunningProcess=!0,ne.pid=U.pid)}),M.forEach((U,J)=>{const ne=l(J);if(!ne)return;const ee=w(this.forwarded,ne.host,ne.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const Q=w(this.detected,ne.host,ne.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const O=Array.from(this.forwarded.values()),M=await this.getAttributes(O.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(M)for(const T of O){const U=M.get(T.remotePort);(U?.protocol||T.protocol!==S.TunnelProtocol.Http)&&U?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},U),U&&U.label&&U.label!==T.name&&await this.name(T.remoteHost,T.remotePort,U.label)}}async getAttributes(O,M=!0){const T=new Map,U=new Map;O.forEach(Y=>{const ce=w(this.m??new Map,S.$Hv[0],Y.port)??Y;if(ce){T.set(Y.port,ce);const te=L(ce)?ce.pid:void 0;U.has(te)||U.set(te,[]),U.get(te)?.push(Y.port)}});const J=new Map;if(O.forEach(Y=>{const ce=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ce&&J.set(Y.port,ce)}),this.G.length===0||!M)return J.size>0?J:void 0;const ne=await Promise.all((0,N.$Rb)(this.G.map(Y=>Array.from(U.entries()).map(ce=>{const te=ce[1],fe=T.get(te[0]);return Y.providePortAttributes(te,fe?.pid,fe?.detail,new i.$7d().token)})))),ee=new Map;if(ne.forEach(Y=>Y.forEach(ce=>{ce&&ee.set(ce.port,ce)})),!J&&!ee)return;const Q=new Map;return O.forEach(Y=>{const ce=J.get(Y.port),te=ee.get(Y.port);Q.set(Y.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??F.providedActionToAction(te?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Q}addAttributesProvider(O){this.G.push(O)}};e.$XK=z,Ke([(0,f.$Bh)(1e3)],z.prototype,"cb",null),e.$XK=z=Ke([We(0,S.$Dv),We(1,E.$xp),We(2,k.$Ci),We(3,m.$MK),We(4,b.$$k),We(5,u.$fi),We(6,C.$qj),We(7,R.$9v),We(8,a.$IF),We(9,o.$oj)],z)}),define(Ce[94],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$EJ=e.$DJ=void 0;class D{constructor(A,v){this.line=A,this.character=v}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,v){return new D(0,0)}with(A){return new D(0,0)}}e.$DJ=D;class N{constructor(A,v,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(A,v),this.end=new D($,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new N(0,0,0,0)}with(A){return new N(0,0,0,0)}}e.$EJ=N;var f;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(Ce[36],Ie([1,0,19,35,24,34,12,5,17,14,94,8]),function(me,e,D,N,f,P,A,v,$,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.SearchErrorCode=e.$TJ=e.$SJ=e.SearchSortOrder=e.ViewMode=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.SearchCompletionExitCode=e.$NJ=e.$MJ=e.$LJ=e.QueryType=e.SearchProviderType=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$FJ="workbench.view.search",e.$GJ="workbench.panel.search",e.$HJ="workbench.view.search",e.$IJ="search-result",e.$JJ="search.exclude";const b="\u27EA ",E=" characters skipped \u27EB",S=(b.length+E.length+5)*2;e.$KJ=(0,v.$9h)("searchService");var u;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(u||(e.SearchProviderType=u={}));var m;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(m||(e.QueryType=m={}));function a(Y){return!!Y.preview}e.$LJ=a;function i(Y){return!!Y.resource}e.$MJ=i;function r(Y){return!!Y.message}e.$NJ=r;var n;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class o{constructor(ce){this.resource=ce,this.results=[]}}e.$OJ=o;class t{constructor(ce,te,fe,re){this.ranges=te,this.webviewIndex=re;const K=Array.isArray(te)?te:[te];if(fe&&fe.matchLines===1&&h(K)){ce=(0,A.$Df)(ce,fe.matchLines);let B="",ae=0,Ee=0;const le=Math.floor(fe.charsPerLine/5),de=[];for(const ue of K){const ge=Math.max(ue.startColumn-le,0),V=ue.startColumn+fe.charsPerLine;if(ge>Ee+le+S){const Z=b+(ge-Ee)+E;B+=Z+ce.slice(ge,V),ae+=ge-(Ee+Z.length)}else B+=ce.slice(Ee,V);de.push(new d(0,ue.startColumn-ae,ue.endColumn-ae)),Ee=V}this.preview={text:B,matches:Array.isArray(this.ranges)?de:de[0]}}else{const B=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ce,matches:(0,D.$2b)(te,ae=>new s(ae.startLineNumber-B,ae.startColumn,ae.endLineNumber-B,ae.endColumn))}}}}e.$PJ=t;function h(Y){const ce=Y[0].startLineNumber;for(const te of Y)if(te.startLineNumber!==ce||te.endLineNumber!==ce)return!1;return!0}class s{constructor(ce,te,fe,re){this.startLineNumber=ce,this.startColumn=te,this.endLineNumber=fe,this.endColumn=re}}e.$QJ=s;class d extends s{constructor(ce,te,fe){super(ce,te,ce,fe)}}e.$RJ=d;var l;(function(Y){Y.List="list",Y.Tree="tree"})(l||(e.ViewMode=l={}));var c;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(c||(e.SearchSortOrder=c={}));function p(Y,ce=!0){const te=Y&&Y.files&&Y.files.exclude,fe=ce&&Y&&Y.search&&Y.search.exclude;if(!te&&!fe)return;if(!te||!fe)return te||fe;let re=Object.create(null);return re=f.$Cn(re,f.$zn(te)),re=f.$Cn(re,f.$zn(fe),!0),re}e.$SJ=p;function I(Y,ce){return Y.excludePattern&&N.$Oj(Y.excludePattern,ce)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&N.$Oj(Y.includePattern,ce)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(te=>{const fe=te.folder.fsPath;if(P.$0f(ce,fe)){const re=$.$lc(fe,ce);return!te.includePattern||!!N.$Oj(te.includePattern,re)}else return!1}):!1:!0}e.$TJ=I;var w;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class g extends Error{constructor(ce,te){super(ce),this.code=te}}e.$UJ=g;function y(Y){const ce=Y.message;if((0,k.$4)(Y))return new g(ce,w.canceled);try{const te=JSON.parse(ce);return new g(te.message,te.code)}catch{return new g(ce,w.other)}}e.$VJ=y;function L(Y){const ce={message:Y.message,code:Y.code};return new Error(JSON.stringify(ce))}e.$WJ=L;function F(Y){return Y.type==="error"?!0:Y.type==="success"}e.$XJ=F;function z(Y){return Y.type==="success"}e.$YJ=z;function j(Y){return!!Y.path}e.$ZJ=j;function O(Y,ce,te=!0){const fe=Y.searchPath?Y.searchPath:Y.relativePath;return te?(0,A.$Af)(fe,ce):N.$Oj(ce,fe)}e.$1J=O;class M{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$2J=M;function T(Y,ce){const te={...Y||{},...ce||{}};return Object.keys(te).filter(fe=>{const re=te[fe];return typeof re=="boolean"&&re})}e.$3J=T;class U{constructor(ce,te){this.c=null,this.a={...ce.excludePattern||{},...te.excludePattern||{}},this.b=N.$Pj(this.a);let fe=ce.includePattern;te.includePattern&&(fe?fe={...fe,...te.includePattern}:fe=te.includePattern),fe&&(this.c=N.$Pj(fe))}matchesExcludesSync(ce,te,fe){return!!(this.b&&this.b(ce,te,fe))}includedInQuerySync(ce,te,fe){return!(this.b&&this.b(ce,te,fe)||this.c&&!this.c(ce,te,fe))}includedInQuery(ce,te,fe){const re=this.b(ce,te,fe),K=()=>this.c?!!this.c(ce,te,fe):!0;return(0,C.$Ug)(re)?re.then(B=>B?!1:K()):K()}hasSiblingExcludeClauses(){return J(this.a)}}e.$4J=U;function J(Y){for(const ce in Y)if(typeof Y[ce]!="boolean")return!0;return!1}function ne(Y){if(!Y)return;let ce;return te=>(ce||(ce=(Y()||Promise.resolve([])).then(fe=>fe?Q(fe):{})),ce.then(fe=>!!fe[te]))}e.$5J=ne;function ee(Y){if(!Y)return;let ce;return te=>{if(!ce){const fe=Y();ce=fe?Q(fe):{}}return!!ce[te]}}e.$6J=ee;function Q(Y){const ce={};for(const te of Y)ce[te]=!0;return ce}}),define(Ce[41],Ie([1,0,19,8,22,4,3,78,15,122,23,12,2,223,5,13,254,40,59,27,20,16,7,67,36,6,56]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=void 0;function c(z,j,O){return new R.$yg(M=>g(M,O)).isEqual(z,j)}function p(z,j,O){return c(z.uri,j.uri,O)?0:(0,C.$7e)(z.uri.toString(),j.uri.toString())}function I(z,j,O){return z.index!==j.index?z.index<j.index?-1:1:c(z.uri,j.uri,O)?(0,C.$7e)(z.name,j.name):(0,C.$7e)(z.uri.toString(),j.uri.toString())}function w(z,j,O,M){const T=z.slice(0).sort((J,ne)=>O(J,ne,M)),U=j.slice(0).sort((J,ne)=>O(J,ne,M));return(0,D.$Eb)(T,U,(J,ne)=>O(J,ne,M))}function g(z,j){const O=j.getCapabilities(z.scheme);return!(O&&O&1024)}class y extends a.$pi{static toExtHostWorkspace(j,O,M,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:U,name:J,folders:ne,configuration:ee,transient:Q,isUntitled:Y}=j,ce=[],te=O;O?ne.forEach((B,ae)=>{const Ee=b.URI.revive(B.uri),le=y.o(M||O,Ee,T);le?(le.name=B.name,le.index=B.index,ce.push(le)):ce.push({uri:Ee,name:B.name,index:ae})}):ce.push(...ne.map(({uri:B,name:ae,index:Ee})=>({uri:b.URI.revive(B),name:ae,index:Ee}))),ce.sort((B,ae)=>B.index<ae.index?-1:1);const fe=new y(U,J,ce,!!Q,ee?b.URI.revive(ee):null,!!Y,B=>g(B,T)),{added:re,removed:K}=w(te?te.workspaceFolders:[],fe.workspaceFolders,p,T);return{workspace:fe,added:re,removed:K}}static o(j,O,M){for(let T=0;T<j.folders.length;T++){const U=j.workspaceFolders[T];if(c(U.uri,O,M))return U}}constructor(j,O,M,T,U,J,ne){super(j,M.map(ee=>new a.$qi(ee)),T,U,ne),this.t=O,this.u=J,this.q=[],this.s=v.$ci.forUris(ne),M.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,O){return O&&this.s.get(j)&&(j=(0,R.$Ig)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let L=class{constructor(j,O,M,T,U){this.c=new P.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new P.$Yd,this.C=new Map,this.h=T,this.s=M,this.t=U,this.j=new k.$_l,this.k=new N.$8g,this.o=j.getProxy(d.$pL.MainThreadWorkspace),this.q=j.getProxy(d.$pL.MainThreadMessageService);const J=O.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?b.URI.revive(J.configuration):null,!!J.isUntitled,ne=>g(ne,M)):void 0}$initializeWorkspace(j,O){this.v=O,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:$.Schemas.untitled,path:(0,R.$Gg)((0,R.$Ig)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,O,M,...T){const U=[];if(Array.isArray(T)&&T.forEach(Y=>{b.URI.isUri(Y.uri)&&!U.some(ce=>c(ce.uri,Y.uri,this.s))&&U.push({uri:Y.uri,name:Y.name||(0,R.$Fg)(Y.uri)})}),this.n||[O,M].some(Y=>typeof Y!="number"||Y<0)||M===0&&U.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(O+M>J.length)return!1;const ne=J.slice(0);ne.splice(O,M,...U.map(Y=>({uri:Y.uri,name:Y.name||(0,R.$Fg)(Y.uri),index:void 0})));for(let Y=0;Y<ne.length;Y++){const ce=ne[Y];if(ne.some((te,fe)=>fe!==Y&&c(ce.uri,te.uri,this.s)))return!1}ne.forEach((Y,ce)=>Y.index=ce);const{added:ee,removed:Q}=w(J,ne,I,this.s);if(ee.length===0&&Q.length===0)return!1;if(this.o){const Y=j.displayName||j.name;this.o.$updateWorkspaceFolders(Y,O,M,U).then(void 0,ce=>{this.n=void 0;const te={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Y,ce.toString()),te,[])})}return this.y(ne),!0}getWorkspaceFolder(j,O){if(this.x)return this.x.getWorkspaceFolder(j,O)}async getWorkspaceFolder2(j,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,O)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,O){let M,T="";if(typeof j=="string"?(M=b.URI.file(j),T=j):typeof j<"u"&&(M=j,T=j.fsPath),!M)return T;const U=this.getWorkspaceFolder(M,!0);if(!U)return T;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let J=(0,R.$Lg)(U.uri,M);return O&&U.name&&(J=`${U.name}/${J}`),J}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:O,added:M,removed:T}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:T}))}findFiles(j,O,M,T,U=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let J="",ne=!0;return O===null?ne=!1:O!==void 0&&(typeof O=="string"?J=O:J=O.pattern),this.z(j,void 0,{exclude:J,maxResults:M,useDefaultExcludes:ne,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},U)}findFiles2(j,O={},M,T=f.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,j,O,T)}async z(j,O,M,T=f.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const U=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,J={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:U,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let ne;if(j){const{includePattern:ee,folder:Q}=F(o.GlobPattern.from(j));ne=Q,J.includePattern=ee}else{const{includePattern:ee,folder:Q}=F(o.GlobPattern.from(O));ne=Q,J.filePattern=ee}return this.o.$startFileSearch(ne??null,J,T).then(ee=>Array.isArray(ee)?ee.map(Q=>b.URI.revive(Q)):[])}async findTextInFiles(j,O,M,T,U=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),ne=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:ee,folder:Q}=F(o.GlobPattern.from(O.include)),Y=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,ce={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:ne,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:ee,excludePattern:Y},te=!1;if(this.u[J]=fe=>{if(te)return;const re=b.URI.revive(fe.resource);fe.results.forEach(K=>{const B=(0,l.$Fh)(K);(0,s.$LJ)(B)?M({uri:re,preview:{text:B.preview.text,matches:(0,D.$2b)(B.preview.matches,ae=>new t.$tL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,D.$2b)(B.ranges,ae=>new t.$tL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):M({uri:re,text:B.text,lineNumber:B.lineNumber})})},U.isCancellationRequested)return{};try{const fe=await this.o.$startTextSearch(j,Q??null,ce,J,U);return delete this.u[J],fe||{}}catch(fe){throw delete this.u[J],fe}}$handleTextSearchResult(j,O){this.u[O]?.(j)}async save(j){const O=await this.o.$save(j,{saveAs:!1});return b.URI.revive(O)}async saveAs(j){const O=await this.o.$save(j,{saveAs:!0});return b.URI.revive(O)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,O){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,O);const M=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,M),(0,A.$Rc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,O){this.h.info("Getting edit session identifier for workspaceFolder",j);const M=await this.resolveWorkspaceFolder(b.URI.revive(j));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const T=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!T),!T)return;const U=await T.provideEditSessionIdentity(M,O);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(j,O,M,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const U=await this.resolveWorkspaceFolder(b.URI.revive(j));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const J=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!J),!J)return;const ne=await J.provideEditSessionIdentityMatch?.(O,M,T);if(this.h.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}getOnWillCreateEditSessionIdentityEvent(j){return(O,M,T)=>{const U=function(ne){O.call(M,ne)};return U.extension=j,this.B.event(U,void 0,T)}}async $onWillCreateEditSessionIdentity(j,O,M){const T=await this.resolveWorkspaceFolder(b.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},O,async(U,J)=>{const ne=Date.now();await Promise.resolve(U),Date.now()-ne>M&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(j,O){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,O);const M=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,M),(0,A.$Rc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,O,M){const T=this.C.get(j.scheme);if(!T)return;const U=await T.provideCanonicalUri?.(b.URI.revive(j),O,M);if(U)return U}async $provideCanonicalUri(j,O,M){return this.provideCanonicalUri(b.URI.revive(j),{targetScheme:O},M)}};e.$Vgc=L,e.$Vgc=L=Ke([We(0,n.$DN),We(1,r.$TN),We(2,i.$Bgc),We(3,u.$qj),We(4,h.$Tgc)],L),e.$Wgc=(0,S.$9h)("IExtHostWorkspace");function F(z){let j,O;return z&&(typeof z=="string"?j=z:(j=z.pattern,O=b.URI.revive(z.baseUri))),{includePattern:j,folder:O}}}),define(Ce[42],Ie([1,0,24,4,41,6,7,256,86,18,8,5,20,13,2]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=e.$Xgc=void 0;function u(h,s){if(s){const d=s.split(".");let l=h;for(let c=0;l&&c<d.length;c++)l=l[d[c]];return l}}function m(h){return h instanceof S.URI}function a(h){return h&&h.uri instanceof S.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function r(h){return h&&h.uri instanceof S.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function n(h){if(m(h))return{resource:h};if(a(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(r(h))return{resource:h.uri};if(h===null)return{resource:null}}let o=class{constructor(s,d,l){this.a=s.getProxy(P.$pL.MainThreadConfiguration),this.c=d,this.b=l,this.d=new R.$8g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,d){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(s,d))}};e.$Xgc=o,e.$Xgc=o=Ke([We(0,b.$DN),We(1,f.$Wgc),We(2,E.$qj)],o);class t{constructor(s,d,l,c){this.a=new N.$Wd,this.b=s,this.f=c,this.c=d,this.e=v.$0n.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,d){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$0n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(d,l))}getConfiguration(s,d,l){const c=n(d)||{},p=this.g(s?u(this.e.getValue(void 0,c,this.c.workspace),s):this.e.getValue(void 0,c,this.c.workspace));s&&this.h(s,c,l?.identifier);function I(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(g){return typeof u(p,g)<"u"},get:(g,y)=>{this.h(s?`${s}.${g}`:g,c,l?.identifier);let L=u(p,g);if(typeof L>"u")L=y;else{let F;const z=(j,O)=>{if((0,k.$Mf)(j)){let M;const T=()=>{F=F||(0,D.$zn)(p),M=M||u(F,O)};return new Proxy(j,{get:(U,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return T(),()=>M;if(F)return M=M||u(F,O),M[J];const ne=U[J];return typeof J=="string"?z(ne,`${O}.${J}`):ne},set:(U,J,ne)=>(T(),M&&(M[J]=ne),!0),deleteProperty:(U,J)=>(T(),M&&delete M[J],!0),defineProperty:(U,J,ne)=>(T(),M&&Object.defineProperty(M,J,ne),!0)})}return Array.isArray(j)?(0,D.$zn)(j):j};L=z(L,g)}return L},update:(g,y,L,F)=>{g=s?`${s}.${g}`:g;const z=I(L);return y!==void 0?this.b.$updateConfigurationOption(z,g,y,c,F):this.b.$removeConfigurationOption(z,g,c,F)},inspect:g=>{g=s?`${s}.${g}`:g;const y=this.e.inspect(g,c,this.c.workspace);if(y)return{key:g,defaultValue:(0,D.$zn)(y.policy?.value??y.default?.value),globalValue:(0,D.$zn)(y.user?.value??y.application?.value),workspaceValue:(0,D.$zn)(y.workspace?.value),workspaceFolderValue:(0,D.$zn)(y.workspaceFolder?.value),defaultLanguageValue:(0,D.$zn)(y.default?.override),globalLanguageValue:(0,D.$zn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,D.$zn)(y.workspace?.override),workspaceFolderLanguageValue:(0,D.$zn)(y.workspaceFolder?.override),languageIds:(0,D.$zn)(y.overrideIdentifiers)}}};return typeof p=="object"&&(0,D.$Cn)(w,p,!1),Object.freeze(w)}g(s){const d=l=>(0,k.$Mf)(l)?new Proxy(l,{get:(c,p)=>d(c[p]),set:(c,p,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(c,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(c,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return d(s)}h(s,d,l){const c=$.$1n.test(s)?4:this.d.get(s),p=l?`[${l.value}] `:"";if(c===4){typeof d?.resource>"u"&&this.f.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){d?.resource&&this.f.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,d){const l=new v.$_n(s,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(c,p)=>l.affectsConfiguration(c,n(p))})}k(s){return s.reduce((d,l)=>(d.set(l[0],l[1]),d),new Map)}}e.$Ygc=t,e.$Zgc=(0,C.$9h)("IExtHostConfiguration")}),define(Ce[95],Ie([1,0,2,8,4,6,7,41,73,42,22,46,20,27,5,15,11,13,91,298,14]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=e.$oic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(z){function j(M){if(M!=null)return M}z.from=j;function O(M){if(M!=null)return M}z.to=O})(o||(o={}));var t;(function(z){function j(M){if(M!=null)return M}z.from=j;function O(M){if(M!=null)return M}z.to=O})(t||(t={}));var h;(function(z){function j(M){if(M!=null)return M}z.from=j;function O(M){if(M!=null)return M}z.to=O})(h||(h={}));var s;(function(z){function j(T){if(T){const U=T;return U&&!!U.process}else return!1}z.is=j;function O(T){if(T==null)return;const U={process:T.process,args:T.args};return T.options&&(U.options=h.from(T.options)),U}z.from=O;function M(T){if(T!=null)return new A.$aM(T.process,T.args,T.options)}z.to=M})(s||(s={}));var d;(function(z){function j(M){if(M!=null)return M}z.from=j;function O(M){if(M!=null)return M}z.to=O})(d||(d={}));var l;(function(z){function j(T){if(T){const U=T;return U&&(!!U.commandLine||!!U.command)}else return!1}z.is=j;function O(T){if(T==null)return;const U={};return T.commandLine!==void 0?U.commandLine=T.commandLine:(U.command=T.command,U.args=T.args),T.options&&(U.options=d.from(T.options)),U}z.from=O;function M(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.$bM(T.commandLine,T.options):new A.$bM(T.command,T.args?T.args:[],T.options)}z.to=M})(l||(l={}));var c;(function(z){function j(T){if(T){const U=T;return U&&U.customExecution==="customExecution"}else return!1}z.is=j;function O(T){return{customExecution:"customExecution"}}z.from=O;function M(T,U){return U.get(T)}z.to=M})(c||(e.CustomExecutionDTO=c={}));var p;(function(z){function j(O,M){let T;return O.scope!==void 0&&typeof O.scope!="number"?T=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===A.TaskScope.Workspace&&M&&M.workspaceFile?T=M.workspaceFile:T=r.$FG),{id:O._id,workspaceFolder:T}}z.from=j})(p||(e.TaskHandleDTO=p={}));var I;(function(z){function j(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}z.from=j})(I||(I={}));var w;(function(z){function j(T,U){if(T==null)return[];const J=[];for(const ne of T){const ee=O(ne,U);ee&&J.push(ee)}return J}z.fromMany=j;function O(T,U){if(T==null)return;let J;T.execution instanceof A.$aM?J=s.from(T.execution):T.execution instanceof A.$bM?J=l.from(T.execution):T.execution&&T.execution instanceof A.$cM&&(J=c.from(T.execution));const ne=o.from(T.definition);let ee;return T.scope?typeof T.scope=="number"?ee=T.scope:ee=T.scope.uri:ee=A.TaskScope.Workspace,!ne||!ee?void 0:{_id:T._id,definition:ne,name:T.name,source:{extensionId:U.identifier.value,label:T.source,scope:ee},execution:J,isBackground:T.isBackground,group:I.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}z.from=O;async function M(T,U,J){if(T==null)return;let ne;s.is(T.execution)?ne=s.to(T.execution):l.is(T.execution)?ne=l.to(T.execution):c.is(T.execution)&&(ne=c.to(T._id,J));const ee=o.to(T.definition);let Q;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Q=T.source.scope:Q=await U.resolveWorkspaceFolder(D.URI.revive(T.source.scope)):Q=A.TaskScope.Workspace),!ee||!Q)return;const Y=new A.$dM(ee,Q,T.name,T.source.label,ne,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=A.$_L.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new A.$_L(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}z.to=M})(w||(e.TaskDTO=w={}));var g;(function(z){function j(M){return M}z.from=j;function O(M){if(M)return Object.assign(Object.create(null),M)}z.to=O})(g||(g={}));class y{#e;constructor(j,O,M){this._id=O,this.a=M,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let L=class{constructor(j,O,M,T,U,J,ne,ee){this.q=new f.$Wd,this.r=new f.$Wd,this.s=new f.$Wd,this.u=new f.$Wd,this.a=j.getProxy(P.$pL.MainThreadTask),this.b=M,this.c=T,this.d=U,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,O,M){if(!M)return new A.$rL(()=>{});const T=this.x();return this.j.set(T,{type:O,provider:M,extension:j}),this.a.$registerTaskProvider(T,O),new A.$rL(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,O){this.a.$registerTaskSystem(j,O)}fetchTasks(j){return this.a.$fetchTasks(g.from(j)).then(async O=>{const M=[];for(const T of O){const U=await w.to(T,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const j=[];return this.k.forEach(O=>j.push(O)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,O,M){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(O,await T.callback(M))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const O=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const O=await this.z(j.id);this.s.fire({execution:O,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const O=await this.z(j.id);this.u.fire({execution:O,exitCode:j.exitCode})}$provideTasks(j,O){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));const T=[],U=(0,N.$1g)(()=>M.provider.provideTasks(R.CancellationToken.None)).then(J=>this.v(O,T,M,J));return new Promise(J=>{U.then(ne=>{Promise.all(T).then(()=>{J(ne)})})})}async $resolveTask(j,O){const M=this.j.get(j);if(!M)return Promise.reject(new Error("no handler found"));if(O.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${M.type}].`);const T=await w.to(O,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(T,R.CancellationToken.None);if(!U)return;this.A(U,M);const J=w.from(U,M.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(J.execution)&&await this.y(J,U,!0),await this.w(J)}x(){return this.h++}async y(j,O,M){const T=await this.a.$createTaskId(j);!M&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,O.execution)),this.m.set(T,O.execution)}async z(j,O){if(typeof j=="string"){const U=this.l.get(j);if(!U)throw new n.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(j.id);if(M)return M;let T;return O?T=Promise.resolve(new y(this,j.id,O)):T=w.to(j.task,this.b,this.m).then(U=>{if(!U)throw new n.$bb("Unexpected: Task does not exist.");return new y(this,j.id,U)}),this.l.set(j.id,T),T.then(U=>(this.k.set(j.id,U),U))}A(j,O){j._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const M=this.n.values();let T=M.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=M.next()}};e.$oic=L,e.$oic=L=Ke([We(0,b.$DN),We(1,E.$TN),We(2,v.$Wgc),We(3,$.$ON),We(4,k.$Zgc),We(5,C.$lhc),We(6,a.$qj),We(7,i.$Egc)],L);let F=class extends L{constructor(j,O,M,T,U,J,ne,ee){super(j,O,M,T,U,J,ne,ee),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const M=w.from(O,j);if(M===void 0)throw new Error("Task is not valid");if(c.is(M.execution))await this.y(M,O,!1);else throw new n.$_;const T=await this.z(await this.a.$getTaskExecution(M),O);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),T}v(j,O,M,T){const U=[];if(T)for(const J of T){if(this.A(J,M),!J.definition||!j[J.definition.type]){const ee=J.source?J.source:"No task source";this.f.warn(`The task [${ee}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=w.from(J,M.extension);ne&&c.is(ne.execution)?(U.push(ne),O.push(this.y(ne,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(j){if(c.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,O,M){}};e.$pic=F,e.$pic=F=Ke([We(0,b.$DN),We(1,E.$TN),We(2,v.$Wgc),We(3,$.$ON),We(4,k.$Zgc),We(5,C.$lhc),We(6,a.$qj),We(7,i.$Egc)],F),e.$qic=(0,S.$9h)("IExtHostTask")}),define(Ce[362],Ie([1,0,36,29]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=e.$_J=void 0;function f(A){return"cellResults"in A}e.$_J=f,e.$aK="rawCell#";function P(A,v){let $=-1;const k=[];let R=[];return A.forEach(b=>{b.range.startLineNumber!==$&&R.length>0&&(k.push([...R]),R=[]),R.push(b),$=b.range.endLineNumber}),R.length>0&&k.push([...R]),k.map(b=>{const E=[],S=b[0].range.startLineNumber,u=b[b.length-1].range.endLineNumber;for(let m=S;m<=u;m++)E.push(v.getLineContent(m));return new D.$PJ(E.join(`
`)+`
`,b.map(m=>new N.$Xs(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$bK=P}),define(Ce[363],Ie([1,0,217,21,4,3,28,12,18,2,32,110,6,33,16,7,69,333,150,24,15,288,362,359]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,c,p,I,w,g){this.q=p,this.r=I,this.s=w,this.t=g,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new f.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$xgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(b.$pL.MainThreadNotebook),this.c=l.getProxy(b.$pL.MainThreadNotebookDocuments),this.d=l.getProxy(b.$pL.MainThreadNotebookEditors),this.i=c.converter,c.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const L=y.notebookEditor?.notebookUri,F=y.cell.handle,j=this.g.get(L)?.getCell(F);if(j)return j.apiCell}if(y&&y.$mid===14){const L=y.uri,F=this.g.get(L);if(F)return F.apiNotebook}return y}}),s.B(c)}getEditorById(l){const c=this.h.get(l);if(!c)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return c}getIdByEditor(l){for(const[c,p]of this.h)if(p.apiEditor===l)return c}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,c){const p=this.g.get(l);if(!p&&!c)throw new Error(`NO notebook document for '${l}'`);return p}static u(l,c){if(!c)return;const p=c.filenamePattern.map(I=>S.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(c.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:c.displayName,filenamePattern:p,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,c,p){const I=s.a++,w=typeof p.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(I,p),this.b.$registerNotebookCellStatusBarItemProvider(I,w,c);let g;return w!==void 0&&(g=p.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new u.$rL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,w),g?.dispose()})}async createNotebookDocument(l){const c=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return k.URI.revive(c)}async openNotebookDocument(l){const c=this.g.get(l);if(c)return c.apiNotebook;const p=await this.c.$tryOpenNotebook(l),I=this.g.get(k.URI.revive(p));return(0,$.$Vf)(I?.apiNotebook)}async showNotebookDocument(l,c){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let p;typeof c=="object"?p={position:S.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(S.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:p={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,p),w=I&&this.h.get(I)?.apiEditor;if(w)return w;throw I?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,c,p,I){const w=this.f.get(l),g=k.URI.revive(c),y=this.g.get(g);if(!y||!w)return;const L=y.getCellFromIndex(p);if(!L)return;const F=await w.provideCellStatusBarItems(L.apiCell,I);if(!F)return;const z=new P.$Sc,j=this.p.add([z]),M=(Array.isArray(F)?F:[F]).map(T=>S.NotebookStatusBarItem.from(T,this.i,z));return{cacheId:j,items:M}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,c,p,I,w){if((0,v.$Ke)(c))throw new Error("viewType cannot be empty or just whitespace");const g=this.w++;return this.x.set(g,{viewType:c,serializer:p,options:I}),this.b.$registerNotebookSerializer(g,{id:l.identifier,location:l.extensionLocation},c,S.NotebookDocumentContentOptions.from(I),s.u(l,w)),(0,P.$Rc)(()=>{this.b.$unregisterNotebookSerializer(g)})}async $dataToNotebook(l,c,p){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const w=await I.serializer.deserializeNotebook(c.buffer,p);return new m.$Wv(S.NotebookData.from(w))}async $notebookToData(l,c,p){const I=this.x.get(l);if(!I)throw new Error("NO serializer found");const w=await I.serializer.serializeNotebook(S.NotebookData.to(c.value),p);return N.$ke.wrap(w)}async $saveNotebook(l,c,p,I,w){const g=k.URI.revive(c),y=this.x.get(l);if(!y)throw new Error("NO serializer found");const L=this.g.get(g);if(!L)throw new Error("Document NOT found");if(L.versionId!==p)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(g.scheme))throw new R.$Ok((0,D.localize)(0,null,this.z(g)),6);await this.y(g,I);const F={metadata:(0,r.$Hn)(L.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of L.apiNotebook.getCells()){const U=new u.$RM(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);U.metadata=(0,r.$Hn)(T.metadata,J=>!(y.options?.transientCellMetadata??{})[J]),F.cells.push(U)}const z=await y.serializer.serializeNotebook(F,w);await this.s.value.writeFile(g,z);const j=this.s.getFileSystemProviderExtUri(g.scheme),O=await this.s.value.stat(g);return{name:j.basename(g),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(g.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Zk({mtime:O.mtime,size:O.size}),children:void 0}}async $searchInNotebooks(l,c,p,I,w){const g=this.x.get(l)?.serializer;if(!g)return{limitHit:!1,results:[]};const y=new A.$Bc;await(async(O,M,T)=>{await Promise.all(O.map(async U=>await Promise.all(U.filenamePatterns.map(J=>{const ne={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:J};return this.t.doInternalFileSearchWithCustomCallback(ne,M,ee=>{ee.forEach(Q=>{y.has(Q)||I.some(ce=>U.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(te=>(0,h.$1db)(te,Q)))||y.add(Q)})})}))))})(p,w,c);const F=new A.$Ac;let z=!1;const j=Array.from(y).map(async O=>{const M=[];try{if(w.isCancellationRequested)return;if(c.maxResults&&[...F.values()].reduce((ne,ee)=>ne+ee.cellResults.length,0)>c.maxResults){z=!0;return}const T=[],U=this.g.get(O);if(U)U.apiNotebook.getCells().forEach(ee=>T.push({input:ee.document.getText(),outputs:ee.outputs.flatMap(Q=>Q.items.map(Y=>Y.data.toString()))}));else{const ne=await this.s.value.readFile(O),ee=N.$ke.fromString(ne.toString()),Q=await g.deserializeNotebook(ee.buffer,w);if(w.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(te=>te.items.map(fe=>fe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;T.forEach((ne,ee)=>{const Q=c.contentPattern.pattern,Y=new o.$8Rb(ne.input,void 0,ne.outputs),ce=Y.findInInputs(Q),te=Y.findInOutputs(Q),fe=te.flatMap(re=>(0,t.$bK)(re.matches,re.textBuffer)).map((re,K)=>(re.webviewIndex=K,re));if(ce.length>0||te.length>0){const re={index:ee,contentResults:(0,t.$bK)(ce,Y.inputTextBuffer),webviewResults:fe};M.push(re)}});const J={resource:O,cellResults:M};F.set(O,J);return}catch{return}});return await Promise.all(j),{limitHit:z,results:[...F.values()]}}async y(l,c){const p=await this.s.value.stat(l);if(typeof c?.mtime=="number"&&typeof c.etag=="string"&&c.etag!==R.$Yk&&typeof p.mtime=="number"&&typeof p.size=="number"&&c.mtime<p.mtime&&c.etag!==R.$Zk({mtime:c.mtime,size:p.size}))throw new R.$Ok((0,D.localize)(1,null),3,c)}z(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString()}A(l,c,p){if(this.h.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const I=new i.$Thc(c,this.d,l,p.visibleRanges.map(S.NotebookRange.to),p.selections.map(S.NotebookRange.to),typeof p.viewColumn=="number"?S.ViewColumn.to(p.viewColumn):void 0);this.h.set(c,I)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const p of l.value.removedDocuments){const I=k.URI.revive(p),w=this.g.get(I);w&&(w.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(g=>g.document.uri)}),this.n.fire(w.apiNotebook));for(const g of this.h.values())g.notebookData.uri.toString()===I.toString()&&this.h.delete(g.id)}if(l.value.addedDocuments){const p=[];for(const I of l.value.addedDocuments){const w=k.URI.revive(I.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const g=new a.$Shc(this.c,this.q,this.r,w,I);p.push(...I.cells.map(y=>a.$Rhc.asModelAddData(g.apiNotebook,y))),this.g.get(w)?.dispose(),this.g.set(w,g),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(g.apiNotebook)}}if(l.value.addedEditors)for(const p of l.value.addedEditors){if(this.h.has(p.id))return;const I=k.URI.revive(p.documentUri),w=this.g.get(I);w&&this.A(w,p.id,p)}const c=[];if(l.value.removedEditors)for(const p of l.value.removedEditors){const I=this.h.get(p);I&&(this.h.delete(p),this.k?.id===I.id&&(this.k=void 0),c.push(I))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const p=new Set;this.l.forEach(I=>p.add(I.id));for(const I of this.h.values()){const w=p.has(I.id);I._acceptVisibility(w)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const c=E.$2N.String.with("notebookType","A notebook type"),p=new E.$4N("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new E.$2N("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>N.$ke.wrap(w))],new E.$3N("Notebook Data",w=>S.NotebookData.to(w.value))),I=new E.$4N("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new E.$2N("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$Wv(S.NotebookData.from(w)))],new E.$3N("Bytes",w=>w.buffer));l.registerApiCommand(p),l.registerApiCommand(I)}}e.$3hc=s}),define(Ce[364],Ie([1,0,17,22,44,35,23,38,36]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class k{constructor(b,E,S){this.k=b,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=b.filePattern,this.b=b.includePattern&&P.$Pj(b.includePattern),this.c=b.maxResults||void 0,this.d=b.exists,this.h=new Set,this.j=b.excludePattern&&P.$Pj(b.excludePattern)}cancel(){this.g=!0,this.h.forEach(b=>b.cancel()),this.h=new Set}search(b){const E=this.k.folderQueries||[];return new Promise((S,u)=>{const m=a=>{this.f++,b(a)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const i=a.toString(),r=D.$nc(i);this.j&&this.j(i,r)||this.v(m,{base:a,basename:r})}),Promise.all(E.map(a=>this.p(a,m))).then(a=>{S({limitHit:this.e,stats:a[0]||void 0})},a=>{u(new Error((0,f.$Ti)(a)))})})}async p(b,E){const S=new N.$7d,u=this.q(b),m=this.r(),a=new $.$4J(this.k,b),i=!a.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=v.$Sd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,S.token),o=r.elapsed(),t=v.$Sd.create();return this.g&&!this.e||(n&&n.forEach(h=>{const s=D.$gc.relative(b.folder.path,h.path);if(i){const d=D.$nc(h.path);this.v(E,{base:b.folder,relativePath:s,basename:d});return}this.s(m,b.folder,s,E)}),this.g&&!this.e)?null:(this.u(m,a,E),{providerTime:o,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(b){const E=(0,$.$3J)(this.k.includePattern,b.includePattern),S=(0,$.$3J)(this.k.excludePattern,b.excludePattern);return{folder:b.folder,excludes:S,includes:E,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const b={rootEntries:[],pathToEntries:Object.create(null)};return b.pathToEntries["."]=b.rootEntries,b}s({pathToEntries:b},E,S,u){if(S===this.a){const a=D.$nc(this.a);this.v(u,{base:E,relativePath:this.a,basename:a})}function m(a){const i=D.$nc(a),r=D.$mc(a);let n=b[r];n||(n=b[r]=[],m(r)),n.push({base:E,relativePath:a,basename:i})}m(S)}u({rootEntries:b,pathToEntries:E},S,u){const m=this,a=this.a;function i(r){const n=(0,$.$6J)(()=>r.map(o=>o.basename));for(let o=0,t=r.length;o<t;o++){const h=r[o],{relativePath:s,basename:d}=h;if(S.matchesExcludesSync(s,d,a!==d?n:void 0))continue;const l=E[s];if(l)i(l);else{if(s===a)continue;m.v(u,h)}if(m.e)break}}i(b)}v(b,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||b(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(b,E,S,u){const m=this.c(b.cacheKey),a=new k(b,E,m&&m.token);let i=0;const r=n=>{i+=n.length,S(n.map(o=>this.d(o)))};return this.e(a,R.a,r,u).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(b){this.c(b)?.cancel()}c(b){if(b)return this.b.has(b)||this.b.set(b,new N.$7d),this.b.get(b)}d(b){return b.relativePath?{resource:A.$Jg(b.base,b.relativePath)}:{resource:b.base}}e(b,E,S,u){const m=u.onCancellationRequested(()=>{b.cancel()}),a=r=>{r&&(i.push(r),E>0&&i.length>=E&&(S(i),i=[]))};let i=[];return b.search(a).then(r=>(i.length&&S(i),m.dispose(),r),r=>(i.length&&S(i),m.dispose(),Promise.reject(r)))}}e.$Uhc=R}),define(Ce[365],Ie([1,0,19,74,35,102,28,15,17,23,12,18,2,99,237,51,13,40,143,360,36]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=void 0;let o=class{constructor(g,y,L,F,z){this.a=g,this.b=y,this.c=L,this.d=F,this.e=z}text(g,y,L={}){g=this.f(g,L);const F=this.a.getValue(),z=y&&y.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(y?.map(a.$ri),L),type:2,contentPattern:g,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:F.search.usePCRE2||z||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(g,y){const L=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const F={...g,wordSeparators:L.editor.wordSeparators};return this.j(g,y)&&(F.isCaseSensitive=!0),this.k(g)&&(F.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),F}file(g,y={}){return{...this.h(g,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(g,y){return g?(g=Array.isArray(g)?g.map(l):l(g),y?this.parseSearchPaths(g):{pattern:h(...Array.isArray(g)?g:[g])}):{}}h(g=[],y={}){const L=this.g(y.includePattern,y.expandPatterns),F=this.g(y.excludePattern,y.expandPatterns),z=g.length>1,j=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(T=>this.q(T,y,F)):g.map(T=>this.r(T,y,F,z))).filter(T=>!!T),O={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:F.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=D.$Hb(D.$Rb(this.c.groups.map(ne=>ne.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const U=T.filter(ne=>(0,n.$TJ)(O,ne.fsPath)),J=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...O,...J}}const M=y.extraFileResources&&y.extraFileResources.filter(T=>(0,n.$TJ)(O,T.fsPath));return O.extraFileResources=M&&M.length?M:void 0,O}i(g){const y=[],L=new A.$Ac,F={};let z=!1;return g.forEach(j=>{if(j.scheme===v.Schemas.walkThrough)return;if((0,k.$Ng)(j)){const M=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$mc(j.fsPath)});let T=L.get(M);T||(z=!0,T={folder:M,includePattern:{}},y.push(T),L.set(M,T));const U=$.$lc(M.fsPath,j.fsPath);(0,C.$Vf)(T.includePattern)[U.replace(/\\/g,"/")]=!0}else j.fsPath&&(z=!0,F[j.fsPath]=!0)}),{folderQueries:y,includePattern:F,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(g,y){if(y.isSmartCase){if(g.isRegExp){if(R.$Bf(g.pattern,!0))return!0}else if(R.$Bf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,E.$7B)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const y=J=>$.$ic(J)||/^\.\.?([\/\\]|$)/.test(J),F=(Array.isArray(g)?g:s(g)).map(J=>{const ne=this.e.resolvedUserHome;return ne?(0,P.$2v)(J,ne.scheme===v.Schemas.file?ne.fsPath:ne.path):J}),z=N.$K(F,J=>y(J)?"searchPaths":"exprSegments"),j=(z.exprSegments||[]).map(J=>R.$Ve(J,"/")).map(J=>R.$Ve(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),d(J))),O={},M=this.m(z.searchPaths||[]);M&&M.length&&(O.searchPaths=M);const T=D.$Rb(j),U=h(...T);return U&&(O.pattern=U),O}l(g,y){return y.disregardExcludeSettings?void 0:(0,n.$SJ)(g,!y.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const y=g.flatMap(F=>{let{pathPortion:z,globPortion:j}=t(F);return j&&(j=c(j)),this.n(z).flatMap(M=>this.o(M,j))}),L=new Map;return y.forEach(F=>{const z=F.searchPath.toString(),j=L.get(z);j?F.pattern&&(j.pattern=j.pattern||{},j.pattern[F.pattern]=!0):L.set(z,{searchPath:F.searchPath,pattern:F.pattern?h(F.pattern):void 0})}),Array.from(L.values())}n(g){if($.$ic(g)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==v.Schemas.file?[{searchPath:y[0].uri.with({path:g})}]:[{searchPath:b.URI.file($.$hc(g))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(g=l(g),g.startsWith("../")||g===".."){const F=$.$gc.resolve(y.path,g);return[{searchPath:y.with({path:F})}]}const L=c(g);return[{searchPath:y,pattern:L}]}else{if(g==="./"||g===".\\")return[];{const y=g.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(z=>{const j=y.match(new RegExp(`^${R.$Pe(z.name)}(?:/(.*)|$)`));return j?{match:j,folder:z}:null}).filter(C.$Sf);if(F.length)return F.map(z=>{const j=z.match[1];return{searchPath:z.folder.uri,pattern:j&&c(j)}});{const z=g.match(/\.[\/\\](.+)[\/\\]?/),j=z?z[1]:g,O=S.localize(0,null,j);throw new Error(O)}}}}o(g,y){const L=g.pattern&&y?`${g.pattern}/${y}`:g.pattern||y,F=[{searchPath:g.searchPath,pattern:L}];return L&&!L.endsWith("**")&&F.push({searchPath:g.searchPath,pattern:L+"/**"}),F}q(g,y,L){const F=this.r((0,a.$ri)(g.searchPath),y,L,!1);return F?{...F,includePattern:g.pattern}:null}r(g,y,L,F){let z;const j=b.URI.isUri(g)?g:g.uri;if(L.searchPaths){const J=L.searchPaths.filter(ne=>(0,k.$Cg)(ne.searchPath,j))[0];if(J&&!J.pattern)return null;J&&(z=J.pattern)}const O=this.a.getValue({resource:j}),T={...this.l(O,y)||{},...z||{}},U=b.URI.isUri(g)?(0,k.$Gg)(g):g.name;return{folder:j,folderName:F?U:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!O.search.followSymlinks}}};e.$6K=o,e.$6K=o=Ke([We(0,u.$Ci),We(1,a.$fi),We(2,i.$bD),We(3,m.$qj),We(4,r.$4K)],o);function t(w){const g=w.match(/[\*\{\}\(\)\[\]\?]/);if(g){const y=g.index,L=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let F=w.substr(0,L.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:w.substr((L.index||0)+1)}}}return{pathPortion:w}}function h(...w){return w.length?w.reduce((g,y)=>(g[y]=!0,g),Object.create(null)):void 0}function s(w){return f.$Nj(w,",").map(g=>g.trim()).filter(g=>!!g.length)}function d(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function l(w){return w.replace(/\\/g,"/")}function c(w){return l(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(w){return w.replace(/([?*[\]])/g,"[$1]")}function I(w,g){w=D.$Mb(w,F=>F.toString());const y=[],L=g.getWorkspace();return w&&w.forEach(F=>{let z;if(g.getWorkbenchState()===2)z=(0,k.$Lg)(L.folders[0].uri,F),z&&z!=="."&&(z="./"+z);else{const j=g.getWorkspaceFolder(F);if(j){const O=j.name;if(L.folders.filter(T=>T.name===O).length===1){const T=(0,k.$Lg)(j.uri,F);T===""?z=`./${j.name}`:z=`./${j.name}/${T}`}else z=F.fsPath}}z&&y.push(p(z))}),y}e.$7K=I}),define(Ce[366],Ie([1,0,23,2,22,14,5,365,36,40,8]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ctb=e.$Btb=void 0;const C=7e3;function b(m,a){const i=a.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],n=[];for(const l of i)if(/^workspaceContains:/.test(l)){const c=l.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||m.forceUsingSearch?n.push(c):r.push(c)}if(r.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:o,resolve:t}=(0,R.$2g)(),h=l=>t({activationEvent:l}),s=Promise.all(r.map(l=>E(m,l,h))).then(()=>{}),d=S(m,a.identifier,n,h);return Promise.all([s,d]).then(()=>{t(void 0)}),o}e.$Btb=b;async function E(m,a,i){for(const r of m.folders)if(await m.exists(D.$Jg(N.URI.revive(r),a))){i(`workspaceContains:${a}`);return}}async function S(m,a,i,r){if(i.length===0)return Promise.resolve(void 0);const n=new f.$7d,o=m.checkExists(m.folders,i,n.token),t=setTimeout(async()=>{n.cancel(),m.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let h=!1;try{h=await o}catch(s){P.$4(s)||P.$1(s)}n.dispose(),clearTimeout(t),h&&r(`workspaceContains:${i.join(",")}`)}function u(m,a,i,r){const n=m.get(A.$8h),o=m.get($.$KJ),h=n.createInstance(v.$6K).file(a.map(s=>(0,k.$ri)(N.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(h,r).then(s=>!!s.limitHit,s=>P.$4(s)?!1:Promise.reject(s))}e.$Ctb=u}),define(Ce[47],Ie([1,0,214,17,58,23,8,3,78,2,13,6,42,294,117,41,26,145,14,25,21,273,7,65,5,27,93,20,106,71,46,4,366,116,275,15,114,38,11,115]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s,d,l,c,p,I,w,g,y,L,F,z,j,O,M,T){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=e.$zhc=e.$yhc=e.$xhc=e.$whc=void 0,e.$whc=(0,s.$9h)("IHostUtils");let J=U=class extends v.$Tc{constructor(K,B,ae,Ee,le,de,ue,ge,V,Z,he,be){super(),this.X=be,this.a=this.B(new g.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ae,this.f=ue,this.j=Ee,this.m=le,this.s=de,this.t=V,this.u=Z,this.w=he,this.y=this.g.getProxy(C.$pL.MainThreadWorkspace),this.z=this.g.getProxy(C.$pL.MainThreadTelemetry),this.C=this.g.getProxy(C.$pL.MainThreadExtensionService),this.D=new A.$8g,this.F=new A.$8g,this.G=new A.$8g,this.H=new A.$8g,this.I=new fe(this.f.extensions.activationEvents),this.L=new a.$B8b(this.I,this.f.extensions.allExtensions);const Pe=new r.$pm(this.f.extensions.myExtensions);this.J=new a.$B8b(this.I,ce(this.L,Pe)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$hhc(this.g,this.s),this.N=new L.$phc(this.g),this.O=ge,this.h=K.createChild(new p.$7h([S.$ihc,this.M],[L.$qhc,this.N])),this.P=this.B(new E.$ghc(this.J,this.L,{onExtensionActivationError:(pe,Le,Ne)=>{this.C.$onExtensionActivationError(pe,i.$3(Le),Ne)},actualActivateExtension:async(pe,Le)=>{if(a.$B8b.isHostExtension(pe,this.J,this.L))return await this.C.$activateExtension(pe,Le),new E.$fhc;const Ne=this.J.getExtensionDescription(pe);return this.db(Ne,Le)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.cb(le))}catch{}await Promise.all(K)}terminate(K,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ae=this.Y();Promise.race([(0,A.$0g)(5e3),ae]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const B=await this.C.$getExtension(K);return B&&{...B,identifier:new r.$om(B.identifier.value),extensionLocation:k.URI.revive(B.extensionLocation)}}Z(K,B){return this.P.activateByEvent(K,B)}$(K,B){return this.P.activateById(K,B)}activateByIdWithErrors(K,B){return this.$(K,B).then(()=>{const ae=this.P.getActivatedExtension(K);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===z.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(K.fsPath);return k.URI.file(B)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new te(K))),this.Q}async bb(K){const B=$.$ci.forUris(ae=>P.$Ag.ignorePathCasing(ae));return await Promise.all(K.map(async ae=>{if(this.ub(ae)){const Ee=await this.ab(ae.extensionLocation);B.set(Ee,ae)}})),B}cb(K){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return B;const ae=this.P.getActivatedExtension(K);if(!ae)return B;try{typeof ae.module.deactivate=="function"&&(B=Promise.resolve(ae.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(Ee)}try{(0,v.$Oc)(ae.subscriptions)}catch(Ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(Ee)}return B}async db(K,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,B).then(ae=>{const Ee=ae.activationTimes;return this.C.$onDidActivateExtension(K.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,B),this.eb(K,B,"success",Ee),ae},ae=>{throw this.eb(K,B,"failure"),ae})}eb(K,B,ae,Ee){const le=ee(K,B);this.z.$publicLog2("extensionActivationTimes",{...le,...Ee||{},outcome:ae})}fb(K,B){const ae=ee(K,B);this.z.$publicLog2("activatePlugin",ae);const Ee=this.ub(K);if(!Ee)return Promise.resolve(new E.$ehc(E.$bhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${K.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const le=new E.$chc(B.startup);return Promise.all([this.vb(K,(0,P.$Jg)(K.extensionLocation,Ee),le),this.gb(K)]).then(de=>(f.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),U.hb(this.s,K.identifier,de[0],de[1],le))).then(de=>(f.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),de))}gb(K){const B=new o.$khc(K,this.M),ae=new o.$jhc(K.identifier.value,!1,this.M),Ee=new F.$rhc(K,this.N),le=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([B.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const ue=this;let ge,V;const Z=(0,m.$LF)(K,"ipc")?this.f.messagePorts?.get(r.$om.toKey(K.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ae,secrets:Ee,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(he){return N.$jc(K.extensionLocation.fsPath,he)},get storagePath(){return ue.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return ue.O.globalValue(K).fsPath},get logPath(){return N.$jc(ue.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return k.URI.joinPath(ue.f.logsLocation,K.identifier.value)},get storageUri(){return ue.O.workspaceValue(K)},get globalStorageUri(){return ue.O.globalValue(K)},get extensionMode(){return le},get extension(){return ge===void 0&&(ge=new Y(ue,K.identifier,K,de,!1)),ge},get extensionRuntime(){return(0,m.$MF)(K,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!V){if(!Z)return;const he=g.Event.buffer(g.Event.fromDOMEventEmitter(Z,"message",be=>be.data));Z.start(),V={onDidReceiveMessage:he,postMessage:Z.postMessage.bind(Z)}}return V}})})}static hb(K,B,ae,Ee,le){return ae=ae||{activate:void 0,deactivate:void 0},this.ib(K,B,ae,Ee,le).then(de=>new E.$dhc(!1,null,le.build(),ae,de,Ee.subscriptions))}static ib(K,B,ae,Ee,le){if(typeof ae.activate=="function")try{le.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${B.value}`);const de=typeof global=="object"?global:self,ue=ae.activate.apply(de,[Ee]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ue).then(ge=>(le.activateResolveStop(),ge))}catch(de){return Promise.reject(de)}else return Promise.resolve(ae)}jb(K,B){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:B}).then(void 0,ae=>{this.s.error(ae)})}kb(K,B=0){const Ee=Date.now();(0,M.$B)(()=>{for(let le=B;le<K.length;le+=1){const de=K[le];for(const ue of de.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-Ee>50){this.kb(K,le);break}else this.jb(de,ue)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(K=>{const B=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ae=this.J.getAllExtensionDescriptions();if(B)this.kb(ae);else for(const Ee of ae)if(Ee.activationEvents)for(const le of Ee.activationEvents)le==="onStartupFinished"&&this.jb(Ee,le)})}mb(){const K=this.Z("*",!0).then(void 0,de=>{this.s.error(de)});this.B(this.j.onDidChangeWorkspace(de=>this.nb(de.added)));const B=this.j.workspace?this.j.workspace.folders:[],ae=this.nb(B),Ee=this.pb(),le=Promise.all([Ee,K,ae]).then(()=>{});return Promise.race([le,(0,A.$0g)(1e4)]).then(()=>{this.lb()}),le}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(K,B))).then(()=>{})}async ob(K,B){if(this.isActivated(B.identifier))return;const ae=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:K.map(de=>de.uri),forceUsingSearch:ae||!this.c.fsExists,exists:de=>this.c.fsExists(de.fsPath),checkExists:(de,ue,ge)=>this.y.$checkExists(de,ue,ge)},le=await(0,y.$Btb)(Ee,B);if(le)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:le.activationEvent}).then(void 0,de=>this.s.error(de))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:B}=this.f.environment;if(!K||!B)throw new Error(D.localize(0,null));const ae=await this.vb(null,B,new E.$chc(!1));if(!ae||typeof ae.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((Ee,le)=>{const de=(V,Z)=>{V?(M.$t&&this.s.error("Test runner called back with error",V),le(V)):(M.$t&&(Z?this.s.info(`Test runner called back with ${Z} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof Z=="number"&&Z>0?1:0))},ue=(0,P.$xg)(B),ge=ae.run(ue,de);ge&&ge.then&&ge.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(V=>{M.$t&&this.s.error("Test runner finished with error",V),le(V instanceof Error&&V.stack?V.stack:String(V))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$0g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,B){return this.R[K]=B,(0,v.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:B}=await this.sb(K);return B?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const B=K.indexOf("+");if(B===-1)throw new t.$xL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ae=K.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this.R[ae]}}async $resolveAuthority(K,B){const ae=O.$Sd.create(!1),Ee=()=>`[resolveAuthority(${(0,h.$cl)(K)},${B})][${ae.elapsed()}ms] `,le=x=>this.s.info(`${Ee()}${x}`),de=x=>this.s.warn(`${Ee()}${x}`),ue=(x,H=void 0)=>this.s.error(`${Ee()}${x}`,H),ge=x=>{if(x instanceof t.$xL)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},V=async x=>{le(`activating resolver for ${x}...`);const{resolver:H,authorityPrefix:X}=await this.sb(x);if(!H)throw ue(`no resolver for ${X}`),new t.$xL(`No remote extension installed to resolve ${X}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:X,remoteAuthority:x}},Z=K.split(/@|%40/g).reverse();le(`activating remote resolvers ${Z.join(" -> ")}`);let he;try{he=await Promise.all(Z.map(V)).catch(async x=>{if(!(x instanceof t.$xL)||x._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return de(`resolving nested authorities failed: ${x.message}`),[await V(K)]})}catch(x){return ge(x)}const be=new A.$hh;be.cancelAndSet(()=>le("waiting..."),1e3);let Pe,pe;for(const[x,{authorityPrefix:H,resolver:X,remoteAuthority:oe}]of he.entries())try{if(x===he.length-1)le("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${H}`),Pe=await X.resolve(oe,{resolveAttempt:B,execServer:pe}),f.mark(`code/extHost/didResolveAuthorityOK/${H}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(X,t.$wL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(le(`invoking resolveExecServer() for ${oe}`),f.mark(`code/extHost/willResolveExecServer/${H}`),pe=await X.resolveExecServer?.(oe,{resolveAttempt:B,execServer:pe}),!pe)throw new t.$xL(`Exec server was not available for ${oe}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ve){return f.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",ve),be.dispose(),ge(ve)}be.dispose();const Le={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Ne={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.$wL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let W;if(t.$wL.isManagedResolvedAuthority(Pe)){const x=B;this.X.setFactory(x,Pe.makeConnection),W={authority:K,connectTo:new h.$_k(x),connectionToken:Pe.connectionToken}}else W={authority:K,connectTo:new h.$al(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:W,options:Ne,tunnelInformation:Le}}}async $getCanonicalURI(K,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$cl)(K)})`);const{resolver:ae}=await this.sb(K);if(!ae)return null;const Ee=k.URI.revive(B);if(typeof ae.getCanonicalURI>"u")return Ee;const le=await(0,A.$1g)(()=>ae.getCanonicalURI(Ee));return le||Ee}$startExtensionHost(K){K.toAdd.forEach(Ee=>Ee.extensionLocation=k.URI.revive(Ee.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,K);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(K,B){return B===1?this.D.wait().then(ae=>this.Z(K,!1)):this.G.wait().then(ae=>this.Z(K,!1))}async $activate(K,B){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,B),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(de=>de.extensionLocation=k.URI.revive(de.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,K),Ee=await this.bb(ae);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const B=n.$ke.alloc(K),ae=Math.random()%256;for(let Ee=0;Ee<K;Ee++)B.writeUInt8(ae,Ee);return B}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$xhc=J,e.$xhc=J=U=Ke([We(0,s.$8h),We(1,e.$whc),We(2,c.$DN),We(3,u.$Wgc),We(4,b.$Zgc),We(5,R.$qj),We(6,d.$TN),We(7,l.$3gc),We(8,I.$Ezb),We(9,w.$lhc),We(10,j.$thc),We(11,T.$uhc)],J);function ne(re,K,B,ae){re.addActivationEvents(ae.addActivationEvents);const Ee=new a.$B8b(re,K.getAllExtensionDescriptions());Ee.deltaExtensions(ae.toAdd,ae.toRemove);const le=new r.$pm(B.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ae.myToRemove)le.delete(ue);for(const ue of ae.myToAdd)le.add(ue);const de=ce(Ee,le);return{globalRegistry:Ee,myExtensions:de}}function ee(re,K){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q(re){return re.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$yhc=(0,s.$9h)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(K,B,ae,Ee,le){this.#e=K,this.#t=B,this.#i=ae.identifier,this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=N.$hc((0,P.$xg)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=Ee,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$zhc=Y;function ce(re,K){return re.getAllExtensionDescriptions().filter(B=>K.has(B.identifier))}class te{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Ahc=te;class fe{constructor(K){this.a=new r.$qm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const B of Object.keys(K))this.a.set(B,K[B])}}}),define(Ce[367],Ie([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;let u=class{constructor(n,o,t,h,s,d,l){this.c=n,this.d=o,this.e=t,this.f=h,this.g=s,this.h=d,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new a(this.c,o,this.d,n,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,o,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const o of n.nodeModuleName)this.a.set(o,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(o=>n.alternativeModuleName(o))}};e.$Iic=u,e.$Iic=u=Ke([We(2,R.$8h),We(3,P.$Zgc),We(4,C.$yhc),We(5,k.$TN),We(6,b.$qj)],u);let m=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const o=(0,E.$Pe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${s}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const o=this.b.exec(this.c(n));if(!o)return;const[,t,h,s]=o,d=S.a.get(h);if(d!==void 0)return console.warn(`${h} as been renamed to ${d}, please update your imports`),t+d+s}c(n){return n.replace(/\\/g,"/")}};m=S=Ke([We(0,k.$TN)],m);class a{constructor(n,o,t,h,s){this.c=n,this.d=o,this.e=t,this.f=h,this.g=s,this.nodeModuleName="vscode",this.a=new v.$qm}load(n,o){const t=this.d.findSubstr(o);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((s,d)=>h+=`	${d} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${h}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let i=class{constructor(n,o,t){this.e=n,this.f=o,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$pL.MainThreadTelemetry);const h=t.getProxy(f.$pL.MainThreadWindow);this.c=(s,d)=>{const l=N.URI.parse(s);return d?this.g(s,d):l.scheme==="http"||l.scheme==="https"?h.$openUri(l,s,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?h.$openUri(l,s,{}):this.g(s,d)}}load(n,o,t){const h=this.e.findSubstr(o);return h&&(this.a=h.identifier.value,this.h()),this.b=t(n),this.c}g(n,o){return this.i(),this.b(n,o)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ke([We(2,$.$DN)],i)}),define(Ce[60],Ie([1,0,43,3,17,49,5,73,72,47,7,41,291,42]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=void 0,e.$Bhc=(0,A.$9h)("IExtHostVariableResolverProvider");class S extends b.$EO{constructor(a,i,r,n,o,t,h){function s(){if(r){const d=r.activeEditor();if(d)return d.document.uri;const l=n.tabGroups.all.find(c=>c.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof R.$_M||l.input instanceof R.$eN)return l.input.modified;if(l.input instanceof R.$$M||l.input instanceof R.$dN||l.input instanceof R.$bN)return l.input.uri}}}super({getFolderUri:d=>{const l=t.folders.filter(c=>c.name===d);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,l)=>o.getConfiguration(void 0,d).get(l),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=s();if(d)return f.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=s();if(d){const l=i.getWorkspaceFolder(d);if(l)return f.$hc(l.uri.fsPath)}}},getSelectedText:()=>{if(r){const d=r.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(r){const d=r.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>a.getExtension(d)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(P.env))}}let u=class extends N.$Tc{constructor(a,i,r,n,o){super(),this.b=a,this.c=i,this.g=r,this.h=n,this.j=o,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Chc=u,e.$Chc=u=Ke([We(0,k.$yhc),We(1,C.$Wgc),We(2,v.$ON),We(3,E.$Zgc),We(4,$.$_gc)],u)}),define(Ce[96],Ie([1,0,8,4,2,25,5,6,72,47,20,7,41,140,283,42,60,3,55,33]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=e.$Fhc=e.$Ehc=e.$Dhc=void 0,e.$Dhc=(0,A.$9h)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(c,p,I,w,g,y,L){this.I=p,this.J=I,this.K=w,this.L=g,this.M=y,this.N=L,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new N.$Wd,this.n=new N.$Wd,this.o=new N.$Wd,this.u=new N.$Wd,this.k=c.getProxy(v.$pL.MainThreadDebugService),this.z=new N.$Wd,this.B=new N.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(F=>{F.onDidChange(z=>{this.O(F)}),this.O(F)})}asDebugSourceUri(c,p){const I=c;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let w=`debug:${encodeURIComponent(I.path||"")}`,g="?";return p&&(w+=`${g}session=${encodeURIComponent(p.id)}`,g="&"),w+=`${g}ref=${I.sourceReference}`,f.URI.parse(w)}else{if(I.path)return f.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(c){const p=[];for(const I of c.getAllExtensionDescriptions())if(I.contributes){const w=I.contributes.debuggers;if(w&&w.length>0)for(const g of w)(0,S.$iG)(g)&&p.push(g.type)}this.k.$registerDebugTypes(p)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const c=[];return this.y.forEach(p=>c.push(p)),c}async $resolveDebugVisualizer(c,p){const I=this.G.get(c);if(!I)throw new Error(`No debug visualizer found with id '${c}'`);let{v:w,provider:g}=I;if(w.visualization||(w=await g.resolveDebugVisualization?.(w,p)||w,I.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${g}'`);return this.db(w.visualization)}async $executeDebugVisualizerCommand(c){const p=this.G.get(c);if(!p)throw new Error(`No debug visualizer found with id '${c}'`);const I=p.v.visualization;I&&"command"in I&&this.N.executeCommand(I.command,...I.arguments||[])}async $provideDebugVisualizers(c,p,I,w){const g=this.l.get(I.sessionId),y=this.cb(c,p),L=this.E.get(y);if(!g||!L)return[];const F=await L.provideDebugVisualization({session:g.api,variable:I.variable,containerId:I.containerId,frameId:I.frameId,threadId:I.threadId},w);return F?F.map(z=>{const j=++this.H;this.G.set(j,{v:z,provider:L});const O=z.iconPath?this.eb(z.iconPath):void 0;return{id:j,name:z.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.db(z.visualization)}}):[]}$disposeDebugVisualizers(c){for(const p of c)this.G.delete(p)}registerDebugVisualizationProvider(c,p,I){if(!c.contributes?.debugVisualizers?.some(y=>y.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const w=P.$om.toKey(c.identifier),g=this.cb(w,p);if(this.E.has(g))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.E.set(g,I),this.k.$registerDebugVisualizer(w,p),(0,a.$Rc)(()=>{this.k.$unregisterDebugVisualizer(w,p),this.E.delete(p)})}addBreakpoints(c){const p=c.filter(g=>{const y=g.id;return this.y.has(y)?!1:(this.y.set(y,g),!0)});this.$(p,[],[]);const I=[],w=new Map;for(const g of p)if(g instanceof C.$rM){let y=w.get(g.location.uri.toString());y||(y={type:"sourceMulti",uri:g.location.uri,lines:[]},w.set(g.location.uri.toString(),y),I.push(y)),y.lines.push({id:g.id,enabled:g.enabled,condition:g.condition,hitCondition:g.hitCondition,logMessage:g.logMessage,line:g.location.range.start.line,character:g.location.range.start.character})}else g instanceof C.$sM&&I.push({type:"function",id:g.id,enabled:g.enabled,hitCondition:g.hitCondition,logMessage:g.logMessage,condition:g.condition,functionName:g.functionName});return this.k.$registerBreakpoints(I)}removeBreakpoints(c){const p=c.filter(y=>this.y.delete(y.id));this.$([],p,[]);const I=p.filter(y=>y instanceof C.$rM).map(y=>y.id),w=p.filter(y=>y instanceof C.$sM).map(y=>y.id),g=p.filter(y=>y instanceof C.$tM).map(y=>y.id);return this.k.$unregisterBreakpoints(I,w,g)}startDebugging(c,p,I){return this.k.$startDebugging(c?c.uri:void 0,p,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,suppressSaveBeforeStart:I.suppressSaveBeforeStart,suppressDebugStatusbar:I.suppressDebugStatusbar??I.debugUI?.simple,suppressDebugToolbar:I.suppressDebugToolbar??I.debugUI?.simple,suppressDebugView:I.suppressDebugView??I.debugUI?.simple})}stopDebugging(c){return this.k.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,p,I){if(!p)return new C.$rL(()=>{});const w=this.d++;return this.f.push({type:c,handle:w,provider:p}),this.k.$registerDebugConfigurationProvider(c,I,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,w),new C.$rL(()=>{this.f=this.f.filter(g=>g.provider!==p),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(c,p,I){if(!I)return new C.$rL(()=>{});if(!this.W(c,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.S(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:p,handle:w,factory:I}),this.k.$registerDebugAdapterDescriptorFactory(p,w),new C.$rL(()=>{this.h=this.h.filter(g=>g.factory!==I),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(c,p){if(!p)return new C.$rL(()=>{});const I=this.i++;return this.j.push({type:c,handle:I,factory:p}),new C.$rL(()=>{this.j=this.j.filter(w=>w.factory!==p)})}async $runInTerminal(c,p){return Promise.resolve(void 0)}async $substituteVariables(c,p){let I;const w=await this.bb(c);return w&&(I={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(I,p)}P(c,p){if(c.type==="implementation")return new s(c.implementation)}Q(){}async $startDASession(c,p){const I=this,w=await this.ab(p);return this.Y(this.S(w.type),w).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const y=this.R(g),L=this.P(y,w);if(!L)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const F=L;return this.C.set(c,F),this.X(w).then(z=>(z&&this.D.set(c,z),F.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const O=j,M={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const T=await this.F.sign(O.arguments.value);M.body={signature:T},F.sendResponse(M)}else throw new Error("no signer")}catch(T){M.success=!1,M.message=T.message,F.sendResponse(M)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(j),j=(0,S.$nG)(j,!0),I.k.$acceptDAMessage(c,j)}),F.onError(j=>{z&&z.onError&&z.onError(j),this.k.$acceptDAError(c,j.name,j.message,j.stack)}),F.onExit(j=>{z&&z.onExit&&z.onExit(j??void 0,void 0),this.k.$acceptDAExit(c,j??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),F.startSession()))})}$sendDAMessage(c,p){p=(0,S.$mG)(p,!1);const I=this.D.get(c);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(p),this.C.get(c)?.sendMessage(p)}$stopDASession(c){const p=this.D.get(c);this.D.delete(c),p&&p.onWillStopSession&&p.onWillStopSession();const I=this.C.get(c);return this.C.delete(c),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const p=[],I=[],w=[];if(c.added)for(const g of c.added){const y=g.id;if(y&&!this.y.has(y)){let L;if(g.type==="function")L=new C.$sM(g.functionName,g.enabled,g.condition,g.hitCondition,g.logMessage);else if(g.type==="data")L=new C.$tM(g.label,g.dataId,g.canPersist,g.enabled,g.hitCondition,g.condition,g.logMessage);else{const F=f.URI.revive(g.uri);L=new C.$rM(new C.$DL(F,new C.$sL(g.line,g.character)),g.enabled,g.condition,g.hitCondition,g.logMessage)}(0,C.$pM)(L,y),this.y.set(y,L),p.push(L)}}if(c.removed)for(const g of c.removed){const y=this.y.get(g);y&&(this.y.delete(g),I.push(y))}if(c.changed){for(const g of c.changed)if(g.id){const y=this.y.get(g.id);if(y){if(y instanceof C.$sM&&g.type==="function"){const L=y;L.enabled=g.enabled,L.condition=g.condition,L.hitCondition=g.hitCondition,L.logMessage=g.logMessage,L.functionName=g.functionName}else if(y instanceof C.$rM&&g.type==="source"){const L=y;L.enabled=g.enabled,L.condition=g.condition,L.hitCondition=g.hitCondition,L.logMessage=g.logMessage,L.location=new C.$DL(f.URI.revive(g.uri),new C.$sL(g.line,g.character))}w.push(y)}}}this.$(p,I,w)}async $acceptStackFrameFocus(c){let p;const I=c.sessionId?await this.ab(c.sessionId):void 0;if(!I)throw new Error("no DebugSession found for debug focus context");c.kind==="thread"?p=new C.$zM(I.api,c.threadId):p=new C.$yM(I.api,c.threadId,c.frameId),this.A=p,this.B.fire(this.A)}$provideDebugConfigurations(c,p,I){return(0,D.$1g)(async()=>{const w=this.V(c);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const g=await this.bb(p);return w.provideDebugConfigurations(g,I)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(c,p,I,w){return(0,D.$1g)(async()=>{const g=this.V(c);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(p);return g.resolveDebugConfiguration(y,I,w)})}$resolveDebugConfigurationWithSubstitutedVariables(c,p,I,w){return(0,D.$1g)(async()=>{const g=this.V(c);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(p);return g.resolveDebugConfigurationWithSubstitutedVariables(y,I,w)})}async $provideDebugAdapter(c,p){const I=this.U(c);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.ab(p);return this.Y(I,w).then(g=>{if(!g)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.R(g)})}async $acceptDebugSessionStarted(c){const p=await this.ab(c);this.m.fire(p.api)}async $acceptDebugSessionTerminated(c){const p=await this.ab(c);p&&(this.n.fire(p.api),this.l.delete(p.id))}async $acceptDebugSessionActiveChanged(c){this.q=c?await this.ab(c):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(c,p){(await this.ab(c))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(c,p){const w={session:(await this.ab(c)).api,event:p.event,body:p.body};this.u.fire(w)}R(c){if(c instanceof C.$uM)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof C.$vM)return{type:"server",port:c.port,host:c.host};if(c instanceof C.$wM)return{type:"pipeServer",path:c.path};if(c instanceof C.$xM)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}S(c){const p=this.h.filter(I=>I.type===c);if(p.length>0)return p[0].factory}U(c){const p=this.h.filter(I=>I.handle===c);if(p.length>0)return p[0].factory}V(c){const p=this.f.filter(I=>I.handle===c);if(p.length>0)return p[0].provider}W(c,p){if(c.contributes){const I=c.contributes.debuggers;if(I&&I.length>0){for(const w of I)if(w.label&&w.type&&w.type===p)return!0}}return!1}X(c){const I=c.configuration.type,w=this.j.filter(g=>g.type===I||g.type==="*").map(g=>(0,D.$1g)(()=>g.factory.createDebugAdapterTracker(c.api)).then(y=>y,y=>null));return Promise.race([Promise.all(w).then(g=>{const y=g.filter(L=>!!L);if(y.length>0)return new h(y)}),new Promise(g=>setTimeout(()=>g(void 0),1e3))]).catch(g=>{})}async Y(c,p){const I=p.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new C.$vM(I));if(c){const g=await this.J.getExtensionRegistry();return(0,D.$1g)(()=>c.createDebugAdapterDescriptor(p.api,this.Z(p,g))).then(y=>{if(y)return y})}const w=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(p,w))}Z(c,p){}$(c,p,I){(c.length>0||p.length>0||I.length>0)&&this.z.fire(Object.freeze({added:c,removed:p,changed:I}))}async ab(c){if(c)if(typeof c=="string"){const p=this.l.get(c);if(p)return p}else{let p=this.l.get(c.id);if(!p){const I=await this.bb(c.folderUri),w=c.parent?this.l.get(c.parent):void 0;p=new o(this.k,c.id,c.type,c.name,I,c.configuration,w?.api),this.l.set(p.id,p),this.k.$sessionCached(p.id)}return p}throw new Error("cannot find session")}bb(c){if(c){const p=f.URI.revive(c);return this.I.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}cb(c,p){return`${c}\0${p}`}db(c){if(c){if("title"in c&&"command"in c)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(c){const p=this.fb(c);let I,w;return"id"in p?w=i.ThemeIcon.asClassName(p):I=p,{iconPath:I,iconClass:w}}fb(c){if(c instanceof C.$mM)return{id:c.id};const p=typeof c=="object"&&"dark"in c?c.dark:c,I=typeof c=="object"&&"light"in c?c.light:c;return{dark:typeof p=="string"?f.URI.file(p):p,light:typeof I=="string"?f.URI.file(I):I}}};e.$Ehc=n,e.$Ehc=n=Ke([We(0,R.$DN),We(1,b.$Wgc),We(2,k.$yhc),We(3,u.$Zgc),We(4,$.$_gc),We(5,m.$Bhc),We(6,r.$ZN)],n);class o{constructor(c,p,I,w,g,y,L){this.f=c,this.g=p,this.h=I,this.i=w,this.j=g,this.k=y,this.l=L}get api(){const c=this;return this.d??=Object.freeze({id:c.g,type:c.h,get name(){return c.i},set name(p){c.i=p,c.f.$setDebugSessionName(c.g,p)},parentSession:c.l,workspaceFolder:c.j,configuration:c.k,customRequest(p,I){return c.f.$customDebugAdapterRequest(c.g,p,I)},getDebugProtocolBreakpoint(p){return c.f.$getDebugProtocolBreakpoint(c.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(c){this.i=c}get configuration(){return this.k}}e.$Fhc=o;class t{constructor(c){this.value=Object.freeze({append(p){c.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Ghc=t;class h{constructor(c){this.d=c}onWillStartSession(){this.d.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(c):void 0)}onWillStopSession(){this.d.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.d.forEach(p=>p.onError?p.onError(c):void 0)}onExit(c,p){this.d.forEach(I=>I.onExit?I.onExit(c,p):void 0)}}class s extends E.$wmb{constructor(c){super(),this.h=c,c.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.h.handleMessage(c)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends n{constructor(c,p,I,w,g,y,L){super(c,p,I,w,g,y,L)}};e.$Hhc=d,e.$Hhc=d=Ke([We(0,R.$DN),We(1,b.$Wgc),We(2,k.$yhc),We(3,u.$Zgc),We(4,$.$_gc),We(5,m.$Bhc),We(6,r.$ZN)],d)}),define(Ce[368],Ie([1,0,14,58,2,6,312,13,84,106,27,249,20,67,47,90]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=void 0;class m{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(v.$qj),t=r.get(b.$DN).getProxy(P.$pL.MainThreadErrors);D.setUnexpectedErrorHandler(h=>{n.error(h);const s=D.$3(h);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(v.$qj),o=r.get(b.$DN),t=r.get(S.$yhc),h=r.get(u.$XN),s=o.getProxy(P.$pL.MainThreadExtensionService),d=o.getProxy(P.$pL.MainThreadErrors),l=await t.getExtensionPathIndex(),c=new WeakMap;function p(g,y){if(c.has(g))return c.get(g).stack;let L="",F,z;for(const O of y)L+=`
	at ${O.toString()}`,z=O.getFileName(),!F&&z&&(F=l.findSubstr(f.URI.file(z)));const j=`${g.name||"Error"}: ${g.message||""}${L}`;return c.set(g,{extensionIdentifier:F?.identifier,stack:j}),j}const I=Symbol("prepareStackTrace wrapped");let w=p;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(g){if(g===p||!g||g[I]){w=g||p;return}w=function(y,L){return p(y,L),g.call(Error,y,L)},Object.assign(w,{[I]:!0})}}),D.setUnexpectedErrorHandler(g=>{n.error(g);const y=D.$3(g),L=c.get(g);if(!L?.extensionIdentifier){d.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(L.extensionIdentifier,y);const F=h.onExtensionError(L.extensionIdentifier,g);n.trace("forwarded error to extension?",F,L)})}}e.$Jic=m;class a{constructor(r,n,o,t,h){this.a=o,this.b=new A.$J8b(r,null,t),n=a.e(n,this.b);const s=new k.$7h(...(0,$.$3r)());s.set(R.$TN,{_serviceBrand:void 0,...n,messagePorts:h}),s.set(b.$DN,new b.$EN(this.b)),s.set(E.$Tgc,new E.$Ugc(t)),s.set(S.$whc,o);const d=new C.$Hq(s,!0);d.invokeFunction(m.installEarlyHandler),this.d=d.invokeFunction(l=>l.get(v.$qj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=d.invokeFunction(l=>l.get(S.$yhc)),this.c.initialize(),d.invokeFunction(m.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(P.$pL.MainThreadExtensionService);return f.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=f.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const o=r.environment.extensionDevelopmentLocationURI;return o&&(r.environment.extensionDevelopmentLocationURI=o.map(t=>f.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=f.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=f.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$Kic=a}),define(Ce[369],Ie([1,0,8,11,224,243,138,96,72,47,20,46,7,60,41,284,285,42,33]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;let r=class extends v.$Ehc{constructor(s,d,l,c,p,I,w,g){super(s,d,l,c,I,w,g),this.ib=p,this.gb=new t}P(s,d){switch(s.type){case"server":return new u.$Pic(s);case"pipeServer":return new u.$Qic(s);case"executable":return new u.$Ric(s,d.type)}return super.P(s,d)}Z(s,d){const l=u.$Ric.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(l)return new b.$uM(l.command,l.args,l.options)}Q(){return new A.$v_b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(O=>{this.gb.onTerminalClosed(O)}));const l=await this.K.getConfigProvider(),c=this.ib.getDefaultShell(!0),p=this.ib.getDefaultShellArgs(!0),I=s.title||f.localize(0,null),w=JSON.stringify({shell:c,shellArgs:p});let g=await this.gb.checkout(w,I),y,L=!1;if(g)y=s.cwd;else{const O={shellPath:c,shellArgs:p,cwd:s.cwd,name:I,iconPath:new b.$mM("debug")};L=!0,g=this.ib.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(g,w)}g.show(!0);const F=await g.processId;L?await new Promise(O=>setTimeout(O,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?g.sendText("cls"):c.indexOf("bash")>=0?g.sendText("clear"):N.$i?g.sendText("cls"):g.sendText("clear"));const z=(0,m.$Tic)(c,s.args,!!s.argsCanBeInterpretedByShell,y,s.env);g.sendText(z);const j=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.gb.free(g),j.dispose())});return F}else if(s.kind==="external")return o(s,await this.K.getConfigProvider());return super.$runInTerminal(s,d)}};e.$Uic=r,e.$Uic=r=Ke([We(0,R.$DN),We(1,S.$Wgc),We(2,k.$yhc),We(3,a.$Zgc),We(4,C.$lhc),We(5,$.$_gc),We(6,E.$Bhc),We(7,i.$ZN)],r);let n;function o(h,s){if(!n)if(N.$i)n=new P.$f$b;else if(N.$j)n=new P.$g$b;else if(N.$k)n=new P.$h$b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(h.title,h.cwd,h.args,h.env||{},d.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const c=[...this.b.entries()].map(([p,I])=>(0,D.$Vg)(async w=>{if(p.name!==d||I.lastUsedAt!==-1&&await(0,m.$Sic)(await p.processId))return null;const g=Date.now();return I.lastUsedAt+t.a>g||w.isCancellationRequested||I.config!==s?null:(I.lastUsedAt=g,p)}));return await(0,D.$bh)(c,p=>!!p)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(Ce[370],Ie([1,0,17,2,104,41,73,42,40,46,20,27,95,15,13,91,23,64,60]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;let r=class extends b.$oic{constructor(o,t,h,s,d,l,c,p,I){super(o,t,h,s,d,l,c,p),this.C=h,this.D=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(o,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const s=b.TaskHandleDTO.from(h,this.C),d=await this.a.$getTaskExecution(s);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.z(d,t);return this.a.$executeTask(s).catch(()=>{}),l}else{const s=b.TaskDTO.from(t,o);if(s===void 0)return Promise.reject(new Error("Task is not valid"));b.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const d=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),d}}v(o,t,h,s){const d=[];if(s)for(const l of s){this.A(l,h),(!l.definition||!o[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const c=b.TaskDTO.from(l,h.extension);c&&(d.push(c),b.CustomExecutionDTO.is(c.execution)&&t.push(this.y(c,l,!0)))}return{tasks:d,extension:h.extension}}async w(o){return o}async G(o){let t=o&&o.length>0?o[0]:void 0;if(!t){const h=N.URI.file((0,a.homedir)());t=new $.$qi({uri:h,name:m.$Gg(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(o,t){const h=N.URI.revive(o),s={process:void 0,variables:Object.create(null)},d=await this.b.resolveWorkspaceFolder(h),l=await this.b.getWorkspaceFolders2()??[],c=await this.D.getResolver(),p=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(l);for(const I of t.variables)s.variables[I]=await c.resolveAsync(p,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(D.$tc);for(let w=0;w<I.length;w++)I[w]=await c.resolveAsync(p,I[w])}s.process=await f.win32.findExecutable(await c.resolveAsync(p,t.process.name),t.process.cwd!==void 0?await c.resolveAsync(p,t.process.cwd):void 0,I)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(o,t,h){return f.win32.findExecutable(o,t,h)}};e.$Mic=r,e.$Mic=r=Ke([We(0,R.$DN),We(1,C.$TN),We(2,P.$Wgc),We(3,A.$ON),We(4,v.$Zgc),We(5,k.$lhc),We(6,S.$qj),We(7,u.$Egc),We(8,i.$Bhc)],r)}),define(Ce[371],Ie([1,0,64,60]),function(me,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class f extends N.$Chc{m(){return(0,D.homedir)()}}e.$sjc=f}),define(Ce[155],Ie([1,0,19,8,22,44,15,17,23,2,36]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=e.$Whc=e.$Vhc=void 0;class C{constructor(i,r,n,o){this.d=i,this.e=r,this.f=n,this.g=o,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],o=new f.$7d(r);return new Promise((t,h)=>{this.a=new E(i);let s=!1;const d=(l,c)=>{if(!s&&!this.b){const p=this.h(l);u(l)&&typeof this.d.maxResults=="number"&&this.c+p>this.d.maxResults&&(this.b=!0,s=!0,o.cancel(),l=this.j(l,this.d.maxResults-this.c));const I=this.h(l);this.c+=I,(I>0||!u(l))&&this.a.add(l,c)}};Promise.all(n.map((l,c)=>this.k(l,p=>d(p,c),o.token))).then(l=>{o.dispose(),this.a.flush();const c=l.some(p=>!!p&&!!p.limitHit);t({limitHit:this.b||c,messages:(0,D.$Rb)(l.map(p=>p?.message?Array.isArray(p.message)?p.message:[p.message]:[])),stats:{type:this.g}})},l=>{o.dispose();const c=(0,P.$Ti)(l);h(new Error(c))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],o=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:o.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const o=new R.$4J(this.d,i),t=[],h={report:l=>{if(!this.l(l))return;const c=i.folder.scheme===A.Schemas.file?(0,R.$5J)(()=>this.f.readdir($.$Ig(l.uri))):void 0,p=$.$Lg(i.folder,l.uri);if(p){const I=o.includedInQuery(p,v.$nc(p),c);(0,N.$Ug)(I)?t.push(I.then(w=>{w&&r(l)})):I&&r(l)}}},s=this.n(i),d=await this.e.provideTextSearchResults(b(this.d.contentPattern),s,h,n);return t.length&&await Promise.all(t),d}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,R.$3J)(this.d.includePattern,i.includePattern),n=(0,R.$3J)(this.d.excludePattern,i.excludePattern),o={folder:k.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return o.usePCRE2=this.d.usePCRE2,o}}e.$Vhc=C;function b(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Cg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Whc=E;function S(a){return u(a)?{preview:{matches:(0,D.$2b)(a.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:a.preview.text},ranges:(0,D.$2b)(a.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function u(a){return!!a.preview}e.$Xhc=u;class m{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Yhc=m}),define(Ce[97],Ie([1,0,3,6,5,364,20,67,13,2,155]),function(me,e,D,N,f,P,A,v,$,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=e.$Zhc=void 0,e.$Zhc=(0,f.$9h)("IExtHostSearch");let C=class{constructor(u,m,a){this.k=u,this.l=m,this.n=a,this.c=this.k.getProxy(N.$pL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$Uhc}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,m){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const a=this.d++;return this.e.set(a,m),this.c.$registerTextSearchProvider(a,this.o(u)),(0,D.$Rc)(()=>{this.g.delete(u),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(u,m){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const a=this.d++;return this.h.set(a,m),this.c.$registerFileSearchProvider(a,this.o(u)),(0,D.$Rc)(()=>{this.i.delete(u),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(u,m,a,i){const r=b(a),n=this.h.get(u);if(n)return this.j.fileSearch(r,n,o=>{this.c.$handleFileMatch(u,m,o.map(t=>t.resource))},i);throw new Error("unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,m,a){return{messages:[]}}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,m,a,i){const r=this.e.get(u);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const n=b(a);return this.q(n,r).search(t=>this.c.$handleTextMatch(u,m,t),i)}$enableExtensionHostSearch(){}q(u,m){return new R.$Vhc(u,m,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};e.$1hc=C,e.$1hc=C=Ke([We(0,A.$DN),We(1,v.$Tgc),We(2,$.$qj)],C);function b(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(u=>k.URI.revive(u))}}e.$2hc=b;function E(S){return{...S,folder:k.URI.revive(S.folder)}}}),define(Ce[372],Ie([1,0,22,14,4,3,15,39,2,132,192,173,80,25,32,13,66,87,268,6,314,343,91,315,320,300,321,322,323,301,289,33,324,42,325,96,148,326,303,316,327,328,73,72,317,47,329,70,330,59,27,344,345,318,304,331,332,114,115,305,363,334,274,335,346,336,153,306,337,338,339,20,340,97,116,341,307,342,117,93,95,90,46,347,348,319,349,350,71,16,7,308,67,309,92,351,352,147,41,282,113,26,94]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s,d,l,c,p,I,w,g,y,L,F,z,j,O,M,T,U,J,ne,ee,Q,Y,ce,te,fe,re,K,B,ae,Ee,le,de,ue,ge,V,Z,he,be,Pe,pe,Le,Ne,W,x,H,X,oe,ve,Me,qe,Ge,Ye,it,ut,ot,et,Ae,ke,He,_,se,De,Ve,Xe,nt,rt,je,yt,kt,Tt,Mt,St,ei,Vt,ni,Zt,Yt,_e,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;function ti(dt){const $t=dt.get(K.$TN),Jt=dt.get(re.$Bgc),ii=dt.get(te.$2gc),At=dt.get(Y.$yhc),ft=dt.get(ni.$Wgc),Nt=dt.get(ke.$XN),oi=dt.get(L.$Zgc),Ft=dt.get(kt.$Tgc),Je=dt.get(ve.$DN),jt=dt.get(ot.$ihc),Ut=dt.get(et.$3gc),xt=dt.get(u.$rj),gt=dt.get(u.$qj),zt=dt.get(nt.$Ezb),Lt=dt.get(t.$Egc),Bt=dt.get(Vt.$Dic),Gt=dt.get(Ge.$qhc),Wt=dt.get(ee.$_gc),It=dt.get(V.$uhc);Je.set(r.$qL.ExtHostFileSystemInfo,Jt),Je.set(r.$qL.ExtHostLogLevelServiceShape,xt),Je.set(r.$qL.ExtHostWorkspace,ft),Je.set(r.$qL.ExtHostConfiguration,oi),Je.set(r.$qL.ExtHostExtensionService,At),Je.set(r.$qL.ExtHostStorage,jt),Je.set(r.$qL.ExtHostTunnelService,zt),Je.set(r.$qL.ExtHostWindow,Bt),Je.set(r.$qL.ExtHostSecretState,Gt),Je.set(r.$qL.ExtHostTelemetry,Nt),Je.set(r.$qL.ExtHostEditorTabs,Wt),Je.set(r.$qL.ExtHostManagedSockets,It);const qt=Je.set(r.$qL.ExtHostDecorations,dt.get(j.$Jhc)),Dt=Je.set(r.$qL.ExtHostDocumentsAndEditors,dt.get(ne.$ON)),pt=Je.set(r.$qL.ExtHostCommands,dt.get(g.$ZN)),Pt=Je.set(r.$qL.ExtHostTerminalService,dt.get(He.$lhc)),Ct=Je.set(r.$qL.ExtHostDebugService,dt.get(z.$Dhc)),li=Je.set(r.$qL.ExtHostSearch,dt.get(qe.$Zhc)),Xt=Je.set(r.$qL.ExtHostTask,dt.get(Ae.$qic)),bi=Je.set(r.$qL.ExtHostOutputService,dt.get(W.$dic)),Re=Je.set(r.$qL.ExtHostLocalization,dt.get(ge.$thc)),Oe=Je.set(r.$qL.ExtHostUrls,new Tt.$Aic(Je)),ye=Je.set(r.$qL.ExtHostDocuments,new J.$zgc(Je,Dt)),ie=Je.set(r.$qL.ExtHostDocumentContentProviders,new T.$Lhc(Je,Dt,gt)),Te=Je.set(r.$qL.ExtHostDocumentSaveParticipant,new U.$Mhc(gt,ye,Je.getProxy(r.$pL.MainThreadBulkEdits))),ze=Je.set(r.$qL.ExtHostNotebook,new he.$3hc(Je,pt,Dt,ye,ii,li)),xe=Je.set(r.$qL.ExtHostNotebookDocuments,new Pe.$0hc(ze)),Qe=Je.set(r.$qL.ExtHostNotebookEditors,new pe.$$hc(gt,ze)),at=Je.set(r.$qL.ExtHostNotebookKernels,new Le.$_hc(Je,$t,ze,pt,gt)),vt=Je.set(r.$qL.ExtHostNotebookRenderers,new Ne.$bic(Je,ze)),Kt=Je.set(r.$qL.ExtHostNotebookDocumentSaveParticipant,new be.$9hc(gt,ze,Je.getProxy(r.$pL.MainThreadBulkEdits))),Et=Je.set(r.$qL.ExtHostEditors,new se.$Qgc(Je,Dt)),Rt=Je.set(r.$qL.ExtHostTreeViews,new Xe.$yic(Je.getProxy(r.$pL.MainThreadTreeViews),pt,gt)),Qt=Je.set(r.$qL.ExtHostEditorInsets,new w.$Rgc(Je.getProxy(r.$pL.MainThreadEditorInsets),Et,$t.remote)),wi=Je.set(r.$qL.ExtHostDiagnostics,new O.$Dgc(Je,gt,Jt,Dt)),pi=Je.set(r.$qL.ExtHostLanguages,new ue.$7hc(Je,ye,pt.converter,Ft)),ht=Je.set(r.$qL.ExtHostLanguageFeatures,new de.$Hgc(Je,Ft,ye,pt,wi,gt,Lt,Nt)),Xi=Je.set(r.$qL.ExtHostFileSystem,new ce.$Ohc(Je,ht)),ai=Je.set(r.$qL.ExtHostFileSystemEventService,new fe.$Phc(Je,gt,Dt)),fi=Je.set(r.$qL.ExtHostQuickOpen,(0,oe.$hic)(Je,ft,pt)),ki=Je.set(r.$qL.ExtHostSCM,new Me.$jic(Je,pt,ye,gt)),Ai=Je.set(r.$qL.ExtHostQuickDiff,new X.$gic(Je,Ft)),Qi=Je.set(r.$qL.ExtHostShare,new Ye.$kic(Je,Ft)),Ri=Je.set(r.$qL.ExtHostComments,(0,y.$Sgc)(Je,pt,ye)),Si=Je.set(r.$qL.ExtHostProgress,new H.$fic(Je.getProxy(r.$pL.MainThreadProgress))),Zi=Je.set(r.$qL.ExtHostLabelService,new le.$6hc(Je)),Mi=Je.set(r.$qL.ExtHostTheming,new De.$vic(Je)),gi=Je.set(r.$qL.ExtHostAuthentication,new h.$Jgc(Je)),Yi=Je.set(r.$qL.ExtHostTimeline,new Ve.$xic(Je,pt)),Di=Je.set(r.$qL.ExtHostWebviews,new Mt.$7gc(Je,$t.remote,ft,gt,Lt)),Ni=Je.set(r.$qL.ExtHostWebviewPanels,new St.$0gc(Je,Di,ft)),ln=Je.set(r.$qL.ExtHostCustomEditors,new F.$$gc(Je,ye,Ut,Di,Ni)),Fi=Je.set(r.$qL.ExtHostWebviewViews,new ei.$Bic(Je,Di)),mi=Je.set(r.$qL.ExtHostTesting,new _.$ric(Je,gt,pt,Dt)),hn=Je.set(r.$qL.ExtHostUriOpeners,new yt.$zic(Je)),dn=Je.set(r.$qL.ExtHostProfileContentHandlers,new x.$eic(Je));Je.set(r.$qL.ExtHostInteractive,new ae.$4hc(Je,ze,Dt,pt,gt));const xi=Je.set(r.$qL.ExtHostInlineChat,new B.$Qhc(Je,pt,ye,gt)),Ei=Je.set(r.$qL.ExtHostChatProvider,new c.$Mgc(Je,gt,gi)),Ti=Je.set(r.$qL.ExtHostChatAgents2,new l.$Ngc(Je,Ei,gt,pt)),_i=Je.set(r.$qL.ExtHostChatVariables,new p.$Ogc(Je)),Ci=Je.set(r.$qL.ExtHostChat,new d.$Lgc(Je)),Oi=Je.set(r.$qL.ExtHostAiRelatedInformation,new n.$ygc(Je)),fn=Je.set(r.$qL.ExtHostAiEmbeddingVector,new Q.$Nhc(Je)),Ii=Je.set(r.$qL.ExtHostIssueReporter,new Ee.$5hc(Je)),ji=Je.set(r.$qL.ExtHostStatusBar,new ut.$nic(Je,pt.converter)),hi=Je.set(r.$qL.ExtHostSpeech,new it.$lic(Je)),Pi=Object.values(r.$qL);Je.assertRegistered(Pi);const gn=new s.$Kgc(Je,Dt),ri=new I.$Pgc(Je),vi=new Z.$8hc(Je,gt),Ui=new M.$Khc(Je);return o.$Igc.register(pt),function(Be,ci,zi){function st($e){return(Se,Ue,ct)=>{const wt=$e(Ot=>{try{Se.call(Ue,Ot)}catch(Gi){N.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${Gi.toString()}`,{cause:Gi})),Nt.onExtensionError(Be.identifier,Gi)}});return ct?.push(wt),wt}}const bt=function(){let $e=!Be.isUnderDevelopment;function Se(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const wt=ct;typeof wt.scheme>"u"&&Se(),typeof wt.exclusive=="boolean"&&(0,_e.$MF)(Be,"documentFiltersExclusive")}return ct}}(),en={getSession($e,Se,Ue){return gi.getSession(Be,$e,Se,Ue)},getSessions($e,Se){return(0,_e.$MF)(Be,"authGetSessions"),gi.getSessions(Be,$e,Se)},async hasSession($e,Se){return(0,_e.$MF)(Be,"authSession"),!!await gi.getSession(Be,$e,Se,{silent:!0})},get onDidChangeSessions(){return st(gi.onDidChangeSessions)},registerAuthenticationProvider($e,Se,Ue,ct){return gi.registerAuthenticationProvider($e,Se,Ue,ct)}},mn={registerCommand($e,Se,Ue){return pt.registerCommand(!0,$e,Se,Ue,void 0,Be)},registerTextEditorCommand($e,Se,Ue){return pt.registerCommand(!0,$e,(...ct)=>{const wt=Et.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(Ot=>{Se.apply(Ue,[wt,Ot,...ct])}).then(Ot=>{Ot||gt.warn("Edits from command "+$e+" were not applied.")},Ot=>{gt.warn("An error occurred while running command "+$e,Ot)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Se,Ue)=>((0,_e.$MF)(Be,"diffCommand"),pt.registerCommand(!0,$e,async(...ct)=>{const wt=Dt.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Ot=await Et.getDiffInformation(wt.id);Se.apply(Ue,[Ot,...ct])},void 0,void 0,Be)),executeCommand($e,...Se){return pt.executeCommand($e,...Se)},getCommands($e=!1){return pt.getCommands($e)}},tn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return st(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Nt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Nt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$MF)(Be,"telemetry"),Nt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$MF)(Be,"telemetry"),st(Nt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ke.$WN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Se){return ke.$VN.validateSender($e),Nt.instantiateLogger(Be,$e,Se)},openExternal($e,Se){return Bt.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return Oe.createAppUri($e);try{return await Bt.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Se){if((0,A.$gg)($e,A.Schemas.http)||(0,A.$gg)($e,A.Schemas.https))return $e;throw Se}},get remoteName(){return(0,m.$el)($t.remote.authority)},get remoteAuthority(){return(0,_e.$MF)(Be,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return st(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,_e.$MF)(Be,"handleIssueUri"),Ii.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,_e.$MF)(Be,"handleIssueUri"),Ii.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,_e.$MF)(Be,"resolvers"),$t.quality},get appCommit(){return(0,_e.$MF)(Be,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController($e,Se,Ue){return mi.createTestController(Be,$e,Se,Ue)},createTestObserver(){return(0,_e.$MF)(Be,"testObserver"),mi.createTestObserver()},runTests($e){return(0,_e.$MF)(Be,"testObserver"),mi.runTests($e)},get onDidChangeTestResults(){return(0,_e.$MF)(Be,"testObserver"),st(mi.onResultsChanged)},get testResults(){return(0,_e.$MF)(Be,"testObserver"),mi.results}},yi=$t.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,rn={getExtension($e,Se){(0,_e.$LF)(Be,"extensionsAny")||(Se=!1);const Ue=ci.mine.getExtensionDescription($e);if(Ue)return new Y.$zhc(At,Be.identifier,Ue,yi,!1);if(Se){const ct=ci.all.getExtensionDescription($e);if(ct)return new Y.$zhc(At,Be.identifier,ct,yi,!0)}},get all(){const $e=[];for(const Se of ci.mine.getAllExtensionDescriptions())$e.push(new Y.$zhc(At,Be.identifier,Se,yi,!1));return $e},get allAcrossExtensionHosts(){(0,_e.$MF)(Be,"extensionsAny");const $e=new E.$pm(ci.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of ci.all.getAllExtensionDescriptions()){const ct=!$e.has(Ue.identifier);Se.push(new Y.$zhc(At,Be.identifier,Ue,yi,ct))}return Se},get onDidChange(){return(0,_e.$LF)(Be,"extensionsAny")?st(f.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):st(ci.mine.onDidChange)}},sn={createDiagnosticCollection($e){return wi.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return st(wi.onDidChangeDiagnostics)},getDiagnostics:$e=>wi.getDiagnostics($e),getLanguages(){return pi.getLanguages()},setTextDocumentLanguage($e,Se){return pi.changeLanguage($e.uri,Se)},match($e,Se){const Ue=ye.getDocumentData(Se.uri)?.notebook;return(0,R.$Et)(rt.LanguageSelector.from($e),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,Se,Ue){return ht.registerCodeActionProvider(Be,bt($e),Se,Ue)},registerDocumentPasteEditProvider($e,Se,Ue){return(0,_e.$MF)(Be,"documentPaste"),ht.registerDocumentPasteEditProvider(Be,bt($e),Se,Ue)},registerCodeLensProvider($e,Se){return ht.registerCodeLensProvider(Be,bt($e),Se)},registerDefinitionProvider($e,Se){return ht.registerDefinitionProvider(Be,bt($e),Se)},registerDeclarationProvider($e,Se){return ht.registerDeclarationProvider(Be,bt($e),Se)},registerImplementationProvider($e,Se){return ht.registerImplementationProvider(Be,bt($e),Se)},registerTypeDefinitionProvider($e,Se){return ht.registerTypeDefinitionProvider(Be,bt($e),Se)},registerHoverProvider($e,Se){return ht.registerHoverProvider(Be,bt($e),Se,Be.identifier)},registerEvaluatableExpressionProvider($e,Se){return ht.registerEvaluatableExpressionProvider(Be,bt($e),Se,Be.identifier)},registerInlineValuesProvider($e,Se){return ht.registerInlineValuesProvider(Be,bt($e),Se,Be.identifier)},registerDocumentHighlightProvider($e,Se){return ht.registerDocumentHighlightProvider(Be,bt($e),Se)},registerMultiDocumentHighlightProvider($e,Se){return ht.registerMultiDocumentHighlightProvider(Be,bt($e),Se)},registerLinkedEditingRangeProvider($e,Se){return ht.registerLinkedEditingRangeProvider(Be,bt($e),Se)},registerReferenceProvider($e,Se){return ht.registerReferenceProvider(Be,bt($e),Se)},registerRenameProvider($e,Se){return ht.registerRenameProvider(Be,bt($e),Se)},registerNewSymbolNamesProvider($e,Se){return(0,_e.$MF)(Be,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Be,bt($e),Se)},registerDocumentSymbolProvider($e,Se,Ue){return ht.registerDocumentSymbolProvider(Be,bt($e),Se,Ue)},registerWorkspaceSymbolProvider($e){return ht.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Se){return ht.registerDocumentFormattingEditProvider(Be,bt($e),Se)},registerDocumentRangeFormattingEditProvider($e,Se){return ht.registerDocumentRangeFormattingEditProvider(Be,bt($e),Se)},registerOnTypeFormattingEditProvider($e,Se,Ue,...ct){return ht.registerOnTypeFormattingEditProvider(Be,bt($e),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider($e,Se,Ue){return ht.registerDocumentSemanticTokensProvider(Be,bt($e),Se,Ue)},registerDocumentRangeSemanticTokensProvider($e,Se,Ue){return ht.registerDocumentRangeSemanticTokensProvider(Be,bt($e),Se,Ue)},registerSignatureHelpProvider($e,Se,Ue,...ct){return typeof Ue=="object"?ht.registerSignatureHelpProvider(Be,bt($e),Se,Ue):ht.registerSignatureHelpProvider(Be,bt($e),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider($e,Se,...Ue){return ht.registerCompletionItemProvider(Be,bt($e),Se,Ue)},registerInlineCompletionItemProvider($e,Se,Ue){return Se.handleDidShowCompletionItem&&(0,_e.$MF)(Be,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,_e.$MF)(Be,"inlineCompletionsAdditions"),Ue&&(0,_e.$MF)(Be,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Be,bt($e),Se,Ue)},registerDocumentLinkProvider($e,Se){return ht.registerDocumentLinkProvider(Be,bt($e),Se)},registerColorProvider($e,Se){return ht.registerColorProvider(Be,bt($e),Se)},registerFoldingRangeProvider($e,Se){return ht.registerFoldingRangeProvider(Be,bt($e),Se)},registerSelectionRangeProvider($e,Se){return ht.registerSelectionRangeProvider(Be,$e,Se)},registerCallHierarchyProvider($e,Se){return ht.registerCallHierarchyProvider(Be,$e,Se)},registerTypeHierarchyProvider($e,Se){return ht.registerTypeHierarchyProvider(Be,$e,Se)},setLanguageConfiguration:($e,Se)=>ht.setLanguageConfiguration(Be,$e,Se),getTokenInformationAtPosition($e,Se){return(0,_e.$MF)(Be,"tokenInformation"),pi.tokenAtPosition($e,Se)},registerInlayHintsProvider($e,Se){return ht.registerInlayHintsProvider(Be,$e,Se)},createLanguageStatusItem($e,Se){return pi.createLanguageStatusItem(Be,$e,Se)},registerDocumentDropEditProvider($e,Se,Ue){return ht.registerDocumentOnDropEditProvider(Be,$e,Se,(0,_e.$LF)(Be,"dropMetadata")?Ue:void 0)}},on={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument($e,Se,Ue){$.URI.isUri($e)&&$e.scheme===A.Schemas.vscodeRemote&&!$e.authority&&Lt.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri($e)?Promise.resolve(an.openTextDocument($e)):Promise.resolve($e));return Et.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType($e){return Et.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Se,Ue){return st(Et.onDidChangeActiveTextEditor)($e,Se,Ue)},onDidChangeVisibleTextEditors($e,Se,Ue){return st(Et.onDidChangeVisibleTextEditors)($e,Se,Ue)},onDidChangeTextEditorSelection($e,Se,Ue){return st(Et.onDidChangeTextEditorSelection)($e,Se,Ue)},onDidChangeTextEditorOptions($e,Se,Ue){return st(Et.onDidChangeTextEditorOptions)($e,Se,Ue)},onDidChangeTextEditorVisibleRanges($e,Se,Ue){return st(Et.onDidChangeTextEditorVisibleRanges)($e,Se,Ue)},onDidChangeTextEditorViewColumn($e,Se,Ue){return st(Et.onDidChangeTextEditorViewColumn)($e,Se,Ue)},onDidCloseTerminal($e,Se,Ue){return st(Pt.onDidCloseTerminal)($e,Se,Ue)},onDidOpenTerminal($e,Se,Ue){return st(Pt.onDidOpenTerminal)($e,Se,Ue)},onDidChangeActiveTerminal($e,Se,Ue){return st(Pt.onDidChangeActiveTerminal)($e,Se,Ue)},onDidChangeTerminalDimensions($e,Se,Ue){return(0,_e.$MF)(Be,"terminalDimensions"),st(Pt.onDidChangeTerminalDimensions)($e,Se,Ue)},onDidChangeTerminalState($e,Se,Ue){return st(Pt.onDidChangeTerminalState)($e,Se,Ue)},onDidWriteTerminalData($e,Se,Ue){return(0,_e.$MF)(Be,"terminalDataWriteEvent"),st(Pt.onDidWriteTerminalData)($e,Se,Ue)},onDidExecuteTerminalCommand($e,Se,Ue){return(0,_e.$MF)(Be,"terminalExecuteCommandEvent"),st(Pt.onDidExecuteTerminalCommand)($e,Se,Ue)},get state(){return Bt.getState(Be)},onDidChangeWindowState($e,Se,Ue){return st(Bt.onDidChangeWindowState)($e,Se,Ue)},showInformationMessage($e,...Se){return vi.showMessage(Be,v.default.Info,$e,Se[0],Se.slice(1))},showWarningMessage($e,...Se){return vi.showMessage(Be,v.default.Warning,$e,Se[0],Se.slice(1))},showErrorMessage($e,...Se){return vi.showMessage(Be,v.default.Error,$e,Se[0],Se.slice(1))},showQuickPick($e,Se,Ue){return fi.showQuickPick(Be,$e,Se,Ue)},showWorkspaceFolderPick($e){return fi.showWorkspaceFolderPick($e)},showInputBox($e,Se){return fi.showInput($e,Se)},showOpenDialog($e){return Ui.showOpenDialog(Be,$e)},showSaveDialog($e){return Ui.showSaveDialog($e)},createStatusBarItem($e,Se,Ue){let ct,wt,Ot;return typeof $e=="string"?(ct=$e,wt=Se,Ot=Ue):(wt=$e,Ot=Se),ji.createStatusBarEntry(Be,ct,wt,Ot)},setStatusBarMessage($e,Se){return ji.setStatusBarMessage($e,Se)},withScmProgress($e){return Lt.report("window.withScmProgress",Be,"Use 'withProgress' instead."),Si.withProgress(Be,{location:je.ProgressLocation.SourceControl},(Se,Ue)=>$e({report(ct){}}))},withProgress($e,Se){return Si.withProgress(Be,$e,Se)},createOutputChannel($e,Se){return bi.createOutputChannel($e,Se,Be)},createWebviewPanel($e,Se,Ue,ct){return Ni.createWebviewPanel(Be,$e,Se,Ue,ct)},createWebviewTextEditorInset($e,Se,Ue,ct){return(0,_e.$MF)(Be,"editorInsets"),Qt.createWebviewEditorInset($e,Se,Ue,ct,Be)},createTerminal($e,Se,Ue){return typeof $e=="object"?"pty"in $e?Pt.createExtensionTerminal($e):Pt.createTerminalFromOptions($e):Pt.createTerminal($e,Se,Ue)},registerTerminalLinkProvider($e){return Pt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Se){return Pt.registerProfileProvider(Be,$e,Se)},registerTerminalQuickFixProvider($e,Se){return(0,_e.$MF)(Be,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider($e,Be.identifier.value,Se)},registerTreeDataProvider($e,Se){return Rt.registerTreeDataProvider($e,Se,Be)},createTreeView($e,Se){return Rt.createTreeView($e,Se,Be)},registerWebviewPanelSerializer:($e,Se)=>Ni.registerWebviewPanelSerializer(Be,$e,Se),registerCustomEditorProvider:($e,Se,Ue={})=>ln.registerCustomEditorProvider(Be,$e,Se,Ue),registerFileDecorationProvider($e){return qt.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return Oe.registerUriHandler(Be,$e)},createQuickPick(){return fi.createQuickPick(Be)},createInputBox(){return fi.createInputBox(Be)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme($e,Se,Ue){return st(Mi.onDidChangeActiveColorTheme)($e,Se,Ue)},registerWebviewViewProvider($e,Se,Ue){return Fi.registerWebviewViewProvider(Be,$e,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return ze.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Se,Ue){return st(ze.onDidChangeActiveNotebookEditor)($e,Se,Ue)},get visibleNotebookEditors(){return ze.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(ze.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Se,Ue){return st(Qe.onDidChangeNotebookEditorSelection)($e,Se,Ue)},onDidChangeNotebookEditorVisibleRanges($e,Se,Ue){return st(Qe.onDidChangeNotebookEditorVisibleRanges)($e,Se,Ue)},showNotebookDocument($e,Se){return ze.showNotebookDocument($e,Se)},registerExternalUriOpener($e,Se,Ue){return(0,_e.$MF)(Be,"externalUriOpener"),hn.registerExternalUriOpener(Be.identifier,$e,Se,Ue)},registerProfileContentHandler($e,Se){return(0,_e.$MF)(Be,"profileContentHandlers"),dn.registerProfileContentHandler(Be,$e,Se)},registerQuickDiffProvider($e,Se,Ue,ct){return(0,_e.$MF)(Be,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt($e),Se,Ue,ct)},get tabGroups(){return Wt.tabGroups},registerShareProvider($e,Se){return(0,_e.$MF)(Be,"shareProvider"),Qi.registerShareProvider(bt($e),Se)}},an={get rootPath(){return Lt.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new N.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new N.$9("workspaceFile")},updateWorkspaceFolders:($e,Se,...Ue)=>ft.updateWorkspaceFolders(Be,$e,Se||0,...Ue),onDidChangeWorkspaceFolders:function($e,Se,Ue){return st(ft.onDidChangeWorkspace)($e,Se,Ue)},asRelativePath:($e,Se)=>ft.getRelativePath($e,Se),findFiles:($e,Se,Ue,ct)=>ft.findFiles($e,Se,Ue,Be.identifier,ct),findFiles2:($e,Se,Ue)=>((0,_e.$MF)(Be,"findFiles2"),ft.findFiles2($e,Se,Be.identifier,Ue)),findTextInFiles:($e,Se,Ue,ct)=>{(0,_e.$MF)(Be,"findTextInFiles");let wt,Ot;return typeof Se=="object"?(wt=Se,Ot=Ue):(wt={},Ot=Se,ct=Ue),ft.findTextInFiles($e,wt||{},Ot,Be.identifier,ct)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Se){return gn.applyWorkspaceEdit($e,Be,Se)},createFileSystemWatcher:($e,Se,Ue,ct)=>{let wt;return typeof Se=="boolean"?wt={ignoreCreateEvents:!!Se,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Se&&((0,_e.$MF)(Be,"createFileSystemWatcher"),wt={...Se,correlate:!0}),ai.createFileSystemWatcher(ft,Be,$e,wt)},get textDocuments(){return ye.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new N.$9("textDocuments")},openTextDocument($e){let Se;const Ue=$e;if(typeof $e=="string")Se=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Se=Promise.resolve($e);else if(!Ue||typeof Ue=="object")Se=ye.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Lt.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),ye.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:($e,Se,Ue)=>st(ye.onDidAddDocument)($e,Se,Ue),onDidCloseTextDocument:($e,Se,Ue)=>st(ye.onDidRemoveDocument)($e,Se,Ue),onDidChangeTextDocument:($e,Se,Ue)=>st(ye.onDidChangeDocument)($e,Se,Ue),onDidSaveTextDocument:($e,Se,Ue)=>st(ye.onDidSaveDocument)($e,Se,Ue),onWillSaveTextDocument:($e,Se,Ue)=>st(Te.getOnWillSaveTextDocumentEvent(Be))($e,Se,Ue),get notebookDocuments(){return ze.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Se){let Ue;if($.URI.isUri($e))Ue=$e,await ze.openNotebookDocument($e);else if(typeof $e=="string")Ue=$.URI.revive(await ze.createNotebookDocument({viewType:$e,content:Se}));else throw new Error("Invalid arguments");return ze.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,Se,Ue){return st(xe.onDidSaveNotebookDocument)($e,Se,Ue)},onDidChangeNotebookDocument($e,Se,Ue){return st(xe.onDidChangeNotebookDocument)($e,Se,Ue)},onWillSaveNotebookDocument($e,Se,Ue){return st(Kt.getOnWillSaveNotebookDocumentEvent(Be))($e,Se,Ue)},get onDidOpenNotebookDocument(){return st(ze.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(ze.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Se,Ue,ct){return ze.registerNotebookSerializer(Be,$e,Se,Ue,(0,_e.$LF)(Be,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:($e,Se,Ue)=>st(zi.onDidChangeConfiguration)($e,Se,Ue),getConfiguration($e,Se){return Se=arguments.length===1?void 0:Se,zi.getConfiguration($e,Se,Be)},registerTextDocumentContentProvider($e,Se){return ie.registerTextDocumentContentProvider($e,Se)},registerTaskProvider:($e,Se)=>(Lt.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(Be,$e,Se)),registerFileSystemProvider($e,Se,Ue){return(0,P.$Qc)(Xi.registerFileSystemProvider(Be,$e,Se,Ue),ii.addFileSystemProvider($e,Se,Ue))},get fs(){return ii.value},registerFileSearchProvider:($e,Se)=>((0,_e.$MF)(Be,"fileSearchProvider"),li.registerFileSearchProvider($e,Se)),registerTextSearchProvider:($e,Se)=>((0,_e.$MF)(Be,"textSearchProvider"),li.registerTextSearchProvider($e,Se)),registerRemoteAuthorityResolver:($e,Se)=>((0,_e.$MF)(Be,"resolvers"),At.registerRemoteAuthorityResolver($e,Se)),registerResourceLabelFormatter:$e=>((0,_e.$MF)(Be,"resolvers"),Zi.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,_e.$MF)(Be,"resolvers"),At.getRemoteExecServer($e)),onDidCreateFiles:($e,Se,Ue)=>st(ai.onDidCreateFile)($e,Se,Ue),onDidDeleteFiles:($e,Se,Ue)=>st(ai.onDidDeleteFile)($e,Se,Ue),onDidRenameFiles:($e,Se,Ue)=>st(ai.onDidRenameFile)($e,Se,Ue),onWillCreateFiles:($e,Se,Ue)=>st(ai.getOnWillCreateFileEvent(Be))($e,Se,Ue),onWillDeleteFiles:($e,Se,Ue)=>st(ai.getOnWillDeleteFileEvent(Be))($e,Se,Ue),onWillRenameFiles:($e,Se,Ue)=>st(ai.getOnWillRenameFileEvent(Be))($e,Se,Ue),openTunnel:$e=>((0,_e.$MF)(Be,"tunnels"),zt.openTunnel(Be,$e).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,_e.$MF)(Be,"tunnels"),zt.getTunnels()},onDidChangeTunnels:($e,Se,Ue)=>((0,_e.$MF)(Be,"tunnels"),st(zt.onDidChangeTunnels)($e,Se,Ue)),registerPortAttributesProvider:($e,Se)=>((0,_e.$MF)(Be,"portsAttributes"),zt.registerPortsAttributesProvider($e,Se)),registerTunnelProvider:($e,Se)=>((0,_e.$MF)(Be,"tunnelFactory"),zt.registerTunnelProvider($e,Se)),registerTimelineProvider:($e,Se)=>((0,_e.$MF)(Be,"timeline"),Yi.registerTimelineProvider($e,Se,Be.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,_e.$MF)(Be,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Se,Ue)=>st(ft.onDidGrantWorkspaceTrust)($e,Se,Ue),registerEditSessionIdentityProvider:($e,Se)=>((0,_e.$MF)(Be,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Se)),onWillCreateEditSessionIdentity:($e,Se,Ue)=>((0,_e.$MF)(Be,"editSessionIdentityProvider"),st(ft.getOnWillCreateEditSessionIdentityEvent(Be))($e,Se,Ue)),registerCanonicalUriProvider:($e,Se)=>((0,_e.$MF)(Be,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Se)),getCanonicalUri:($e,Se,Ue)=>((0,_e.$MF)(Be,"canonicalUriProvider"),ft.provideCanonicalUri($e,Se,Ue))},$n={get inputBox(){return Lt.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),ki.getLastInputBox(Be)},createSourceControl($e,Se,Ue){return ki.createSourceControl(Be,$e,Se,Ue)}},cn={createCommentController($e,Se){return Ri.createCommentController(Be,$e,Se)}},un={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get stackFrameFocus(){return Ct.stackFrameFocus},registerDebugVisualizationProvider($e,Se){return(0,_e.$MF)(Be,"debugVisualization"),Ct.registerDebugVisualizationProvider(Be,$e,Se)},onDidStartDebugSession($e,Se,Ue){return st(Ct.onDidStartDebugSession)($e,Se,Ue)},onDidTerminateDebugSession($e,Se,Ue){return st(Ct.onDidTerminateDebugSession)($e,Se,Ue)},onDidChangeActiveDebugSession($e,Se,Ue){return st(Ct.onDidChangeActiveDebugSession)($e,Se,Ue)},onDidReceiveDebugSessionCustomEvent($e,Se,Ue){return st(Ct.onDidReceiveDebugSessionCustomEvent)($e,Se,Ue)},onDidChangeBreakpoints($e,Se,Ue){return st(Ct.onDidChangeBreakpoints)($e,Se,Ue)},onDidChangeStackFrameFocus($e,Se,Ue){return(0,_e.$MF)(Be,"debugFocus"),st(Ct.onDidChangeStackFrameFocus)($e,Se,Ue)},registerDebugConfigurationProvider($e,Se,Ue){return Ct.registerDebugConfigurationProvider($e,Se,Ue||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Se){return Ct.registerDebugAdapterDescriptorFactory(Be,$e,Se)},registerDebugAdapterTrackerFactory($e,Se){return Ct.registerDebugAdapterTrackerFactory($e,Se)},startDebugging($e,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ct.startDebugging($e,Se,{parentSession:Ue}):Ct.startDebugging($e,Se,Ue||{})},stopDebugging($e){return Ct.stopDebugging($e)},addBreakpoints($e){return Ct.addBreakpoints($e)},removeBreakpoints($e){return Ct.removeBreakpoints($e)},asDebugSourceUri($e,Se){return Ct.asDebugSourceUri($e,Se)}},Bi={registerTaskProvider:($e,Se)=>Xt.registerTaskProvider(Be,$e,Se),fetchTasks:$e=>Xt.fetchTasks($e),executeTask:$e=>Xt.executeTask(Be,$e),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:($e,Se,Ue)=>st(Xt.onDidStartTask)($e,Se,Ue),onDidEndTask:($e,Se,Ue)=>st(Xt.onDidEndTask)($e,Se,Ue),onDidStartTaskProcess:($e,Se,Ue)=>st(Xt.onDidStartTaskProcess)($e,Se,Ue),onDidEndTaskProcess:($e,Se,Ue)=>st(Xt.onDidEndTaskProcess)($e,Se,Ue)},Wi={createNotebookController($e,Se,Ue,ct,wt){return at.createNotebookController(Be,$e,Se,Ue,ct,(0,_e.$LF)(Be,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Se)=>ze.registerNotebookCellStatusBarItemProvider(Be,$e,Se),createRendererMessaging($e){return vt.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,_e.$MF)(Be,"notebookKernelSource"),at.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Se){return(0,_e.$MF)(Be,"notebookKernelSource"),at.registerKernelSourceActionProvider(Be,$e,Se)},onDidChangeNotebookCellExecutionState($e,Se,Ue){return(0,_e.$MF)(Be,"notebookCellExecutionState"),st(at.onDidChangeNotebookCellExecutionState)($e,Se,Ue)}},qi={t(...$e){if(typeof $e[0]=="string"){const Se=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return Re.getMessage(Be.identifier.value,{message:Se,args:Ue})}return Re.getMessage(Be.identifier.value,$e[0])},get bundle(){return Re.getBundle(Be.identifier.value)},get uri(){return Re.getBundleUri(Be.identifier.value)}},Li={_version:1,registerInteractiveEditorSessionProvider($e,Se){return(0,_e.$MF)(Be,"interactive"),xi.registerProvider(Be,$e,Se)},registerInteractiveSessionProvider($e,Se){return(0,_e.$MF)(Be,"interactive"),Ci.registerChatProvider(Be,$e,Se)},sendInteractiveRequestToProvider($e,Se){return(0,_e.$MF)(Be,"interactive"),Ci.sendInteractiveRequestToProvider($e,Se)},transferChatSession($e,Se){return(0,_e.$MF)(Be,"interactive"),Ci.transferChatSession($e,Se)}},Vi={getRelatedInformation($e,Se){return(0,_e.$MF)(Be,"aiRelatedInformation"),Oi.getRelatedInformation(Be,$e,Se)},registerRelatedInformationProvider($e,Se){return(0,_e.$MF)(Be,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Be,$e,Se)},registerEmbeddingVectorProvider($e,Se){return(0,_e.$MF)(Be,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(Be,$e,Se)}},Hi={registerChatResponseProvider($e,Se,Ue){return(0,_e.$MF)(Be,"chatProvider"),Ei.registerLanguageModel(Be.identifier,$e,Se,Ue)},requestLanguageModelAccess($e,Se){return(0,_e.$MF)(Be,"chatRequestAccess"),Ei.requestLanguageModelAccess(Be,$e,Se)},get languageModels(){return(0,_e.$MF)(Be,"chatRequestAccess"),Ei.getLanguageModelIds()},onDidChangeLanguageModels:($e,Se,Ue)=>((0,_e.$MF)(Be,"chatRequestAccess"),Ei.onDidChangeProviders($e,Se,Ue)),registerVariable($e,Se,Ue){return(0,_e.$MF)(Be,"chatAgents2"),_i.registerVariableResolver(Be,$e,Se,Ue)},registerMappedEditsProvider($e,Se){return(0,_e.$MF)(Be,"mappedEditsProvider"),ht.registerMappedEditsProvider(Be,$e,Se)},createChatAgent($e,Se){return(0,_e.$MF)(Be,"chatAgents2"),Ti.createChatAgent(Be,$e,Se)}},bn={registerSpeechProvider($e,Se){return(0,_e.$MF)(Be,"speech"),hi.registerProvider(Be.identifier,$e,Se)}};return{version:$t.version,ai:Vi,authentication:en,commands:mn,comments:cn,chat:Hi,debug:un,env:tn,extensions:rn,interactive:Li,l10n:qi,languages:sn,notebooks:Wi,scm:$n,speech:bn,tasks:Bi,tests:nn,window:on,workspace:an,Breakpoint:je.$qM,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$jN,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$iN,CallHierarchyIncomingCall:je.$PL,CallHierarchyItem:je.$OL,CallHierarchyOutgoingCall:je.$QL,CancellationError:N.$5,CancellationTokenSource:D.$7d,CandidatePortSource:r.CandidatePortSource,CodeAction:je.$LL,CodeActionKind:je.$ML,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$RL,Color:je.$5L,ColorInformation:je.$6L,ColorPresentation:je.$7L,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$YL,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$ZL,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$cM,DebugAdapterExecutable:je.$uM,DebugAdapterInlineImplementation:je.$xM,DebugAdapterNamedPipeServer:je.$wM,DebugAdapterServer:je.$vM,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DebugVisualization:je.$MM,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$FL,DiagnosticRelatedInformation:je.$EL,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$rL,DocumentHighlight:je.$HL,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$IL,DocumentLink:je.$4L,DocumentSymbol:je.$KL,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$AM,InlineValueText:je.$BM,InlineValueVariableLookup:je.$CM,InlineValueEvaluatableExpression:je.$DM,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:f.$Wd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$OM,FileDecoration2:je.$OM,FileSystemError:je.$FM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:je.$GM,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$sM,InlineCompletionItem:je.$1L,InlineCompletionList:je.$2L,Hover:je.$GL,IndentAction:C.IndentAction,Location:je.$DL,MarkdownString:je.$SL,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:je.$TL,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$sL,ProcessExecution:je.$aM,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$NM,Range:je.$tL,RelativePattern:je.$oM,Selection:je.$uL,SelectionRange:je.$NL,SemanticTokens:je.$JM,SemanticTokensBuilder:je.$IM,SemanticTokensEdit:je.$KM,SemanticTokensEdits:je.$LM,SemanticTokensLegend:je.$HM,ShellExecution:je.$bM,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$VL,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$UL,SnippetString:je.$CL,SourceBreakpoint:je.$rM,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$JL,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$dM,TaskGroup:je.$_L,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$8L,TerminalQuickFixTerminalCommand:je.$0L,TerminalQuickFixOpener:je.$9L,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$$L,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$yL,SnippetTextEdit:je.$AL,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$nM,ThemeIcon:je.$mM,TreeItem:je.$eM,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$0M,UIKind:Yt.UIKind,Uri:$.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$BL,DocumentDropEdit:je.$kM,DocumentPasteEdit:je.$lM,InlayHint:je.$XL,InlayHintLabelPart:je.$WL,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$xL,ResolvedAuthority:je.$vL,ManagedResolvedAuthority:je.$wL,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$YM,NotebookRange:je.$QM,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$RM,NotebookData:je.$SM,NotebookRendererScript:je.$WM,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$UM,NotebookCellOutputItem:je.$TM,NotebookCellStatusBarItem:je.$VM,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$zL,NotebookKernelSourceAction:je.$XM,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$1M,LinkedEditingRanges:je.$ZM,TestResultState:je.TestResultState,TestRunRequest:je.$2M,TestMessage:je.$3M,TestTag:je.$4M,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:je.$jM,DataTransferItem:je.$fM,CoveredCount:je.$5M,FileCoverage:je.$6M,StatementCoverage:je.$7M,BranchCoverage:je.$8M,DeclarationCoverage:je.$9M,FunctionCoverage:je.$9M,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$$M,TabInputTextDiff:je.$_M,TabInputTextMerge:je.$aN,TabInputCustom:je.$bN,TabInputNotebook:je.$dN,TabInputNotebookDiff:je.$eN,TabInputWebview:je.$cN,TabInputTerminal:je.$fN,TabInputInteractiveWindow:je.$gN,TabInputChat:je.$hN,TelemetryTrustedValue:a.$Oo,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,ChatAgentCopyKind:je.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$yM,ThreadFocus:je.$zM,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus,KeywordRecognitionStatus:je.KeywordRecognitionStatus,ChatResponseTextPart:je.$kN,ChatResponseMarkdownPart:je.$lN,ChatResponseFileTreePart:je.$mN,ChatResponseAnchorPart:je.$nN,ChatResponseProgressPart:je.$oN,ChatResponseReferencePart:je.$qN,ChatResponseCommandButtonPart:je.$pN,ChatAgentRequestTurn:je.$rN,ChatAgentResponseTurn:je.$sN}}}e.$Eic=ti}),define(Ce[373],Ie([1,0,84,153,41,148,42,33,73,46,95,96,97,117,71,91,147,70,59,116,90,72,146,13,60,114,115]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$2r)(d.$thc,d.$shc,1),(0,D.$2r)(h.$rj,t.$Fic,1),(0,D.$2r)(u.$Egc,u.$Fgc,1),(0,D.$2r)(v.$ZN,v.$YN,0),(0,D.$2r)(A.$Zgc,A.$Xgc,0),(0,D.$2r)(a.$2gc,a.$1gc,0),(0,D.$2r)(C.$Dhc,C.$Hhc,0),(0,D.$2r)(P.$Jhc,P.$Ihc,0),(0,D.$2r)($.$ON,$.$NN,0),(0,D.$2r)(l.$uhc,l.$vhc,0),(0,D.$2r)(i.$Bgc,i.$Agc,0),(0,D.$2r)(N.$dic,N.$cic,1),(0,D.$2r)(b.$Zhc,b.$1hc,0),(0,D.$2r)(E.$ihc,E.$hhc,0),(0,D.$2r)(R.$qic,R.$pic,0),(0,D.$2r)(k.$lhc,k.$ohc,0),(0,D.$2r)(S.$Ezb,S.$Fzb,0),(0,D.$2r)(m.$Dic,m.$Cic,0),(0,D.$2r)(f.$Wgc,f.$Vgc,0),(0,D.$2r)(r.$qhc,r.$phc,0),(0,D.$2r)(n.$XN,n.$UN,0),(0,D.$2r)(o.$_gc,o.$ahc,0),(0,D.$2r)(s.$Bhc,s.$Chc,0)}),define(Ce[119],Ie([1,0,19,13,36,94]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=e.$Wic=e.$Vic=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$Vic=A;function v(C,b,E,S){const u=(0,D.$2b)(E,$),m=new f.$PJ(b,u,S),a=m.preview.matches;return{ranges:(0,D.$2b)(u,k),uri:C,preview:{text:m.preview.text,matches:(0,D.$2b)(a,k)}}}e.$Wic=v;function $(C){return new f.$QJ(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new P.$EJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(b,E){this.a=b,this.b=E}appendLine(b){this.b.debug(`${this.a}#search`,b)}};e.$Xic=R,e.$Xic=R=Ke([We(1,N.$qj)],R)}),define(Ce[374],Ie([1,0,50,17,77,34,11,12,119,375]),function(me,e,D,N,f,P,A,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=e.$Yic=void 0;const R=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(r,n,o,t){const h=b(r,n,o,t),s=n.folder.fsPath;return{cmd:D.spawn(R,h.args,{cwd:s}),rgDiskPath:R,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.$Yic=C;function b(r,n,o,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],o,!1).forEach(d=>{const l=(0,$.$Vic)(d);if(h.push("-g",l),A.$j){const c=(0,f.$Kl)(l);c!==l&&h.push("-g",c)}});const s=E([n],t,void 0,!1);return s.globArgs.forEach(d=>{const l=`!${(0,$.$Vic)(d)}`;if(h.push("-g",l),A.$j){const c=(0,f.$Kl)(l);c!==l&&h.push("-g",c)}}),n.disregardIgnoreFiles!==!1?h.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),n.ignoreSymlinks||h.push("--follow"),r.exists&&h.push("--quiet"),h.push("--no-config"),n.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function E(r,n,o,t=!0){const h=[];let s={};return r.forEach(d=>{const l=Object.assign({},d.excludePattern||{},n||{}),c=u(l,t?d.folder.fsPath:void 0,o);h.push(...c.globArgs),c.siblingClauses&&(s=Object.assign(s,c.siblingClauses))}),{globArgs:h,siblingClauses:s}}function S(r,n,o=!0){const t=[];return r.forEach(h=>{const s=Object.assign({},n||{},h.includePattern||{}),d=u(s,o?h.folder.fsPath:void 0);t.push(...d.globArgs)}),t}function u(r,n,o){const t=[],h={};return Object.keys(r).forEach(s=>{if(o&&o.has(s)||!s)return;const d=r[s];s=a(n?m(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof d=="boolean"&&d?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):d&&d.when&&(h[s]=d)}),{globArgs:t,siblingClauses:h}}function m(r,n){return N.$ic(n)?n:N.$jc(r,n)}e.$Zic=m;function a(r){return r=v.$Ve(r,"\\"),v.$Ve(r,"/")}function i(r){return P.$6f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$1ic=i}),define(Ce[376],Ie([1,0,50,57,17,377,19,44,35,77,34,11,38,12,18,31,36,374,129]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=e.$2ic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(d){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=d,this.b=d.filePattern||"",this.d=d.includePattern&&$.$Pj(d.includePattern),this.f=d.maxResults||null,this.g=!!d.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=d.shouldGlobMatchFilePattern?null:(0,i.$3q)(this.b).normalizedLowercase),this.u=d.excludePattern&&$.$Pj(d.excludePattern),this.t=new Map,d.folderQueries.forEach(l=>{const c=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),p=l.folder.fsPath;d.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==p).forEach(I=>{(0,R.$0f)(I,p)&&(c[f.$lc(p,I)]=!0)}),this.t.set(p,new t(c,p))})}cancel(){this.l=!0,r.forEach(d=>d())}walk(d,l,c,p,I){if(this.m=b.$Sd.create(!1),this.l)return I(null,this.j);l.forEach(w=>{const g=f.$nc(w.fsPath);this.u&&this.u(w.fsPath,g)||this.J(c,{relativePath:w.fsPath,searchPath:void 0})}),this.r=b.$Sd.create(!1),this.w(d,(w,g)=>{this.x(this.y,this,w,c,p,y=>{if(y){const L=(0,v.$Ti)(y);console.error(L),this.q.push(L),g(y,void 0)}else g(null,void 0)})},(w,g)=>{this.m.stop();const y=w?A.$Hb(w)[0]:null;I(y,this.j)})}w(d,l,c){const p=new Array(d.length),I=new Array(d.length);let w=!1,g=0;if(d.length===0)return c(null,[]);d.forEach((y,L)=>{l(y,(F,z)=>{if(F?(w=!0,p[L]=null,I[L]=F):(p[L]=z,I[L]=null),++g===d.length)return c(w?I:null,p)})})}x(d,l,...c){try{d.apply(l,c)}catch(p){c[c.length-1](p)}}y(d,l,c,p){const I=d.folder.fsPath,w=C.$j,g=()=>j&&j.kill();r.add(g);let y=U=>{r.delete(g),y=()=>{},p(U)},L="";const F=this.D(),z=(0,a.$Yic)(this.a,d,this.a.includePattern,this.t.get(d.folder.fsPath).expression),j=z.cmd,O=!Object.keys(z.siblingClauses).length,M=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let T=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),c({message:T}),this.s=0,this.z(j,"utf8",c,(U,J,ne)=>{if(U){y(U);return}if(this.j){y();return}const Q=(L+(w?k.$Jl(J||""):J)).split(`
`);if(ne){const Y=Q.length;Q[Y-1]=Q[Y-1].trim(),Q[Y-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Q.length,O){for(const Y of Q)if(this.J(l,{base:I,relativePath:Y,searchPath:this.N(d,Y)}),this.j){g();break}(ne||this.j)&&y();return}this.G(d,F,I,Q,l),ne&&(this.H(F,I,l),y())})}spawnFindCmd(d){const l=this.t.get(d.folder.fsPath),c=l.getBasenameTerms(),p=l.getPathTerms(),I=["-L","."];if(c.length||p.length){I.push("-not","(","(");for(const w of c)I.push("-name",w),I.push("-o");for(const w of p)I.push("-path",w),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),D.spawn("find",I,{cwd:d.folder.fsPath})}readStdout(d,l,c){let p="";this.z(d,l,()=>{},(I,w,g)=>{if(I){c(I);return}p+=w,g&&c(null,p)})}z(d,l,c,p){let I=(y,L,F)=>{(y||F)&&(I=()=>{},this.r?.stop()),p(y,L,F)},w=!1;d.stdout?(this.A(d.stdout,l,I),d.stdout.once("data",()=>w=!0)):c({message:"stdout is null"});let g;d.stderr?g=this.B(d.stderr):c({message:"stderr is null"}),d.on("error",y=>{I(y)}),d.on("close",y=>{let L;!w&&(L=this.C(g,l))&&h(L)?I(new Error(`command failed with error code ${y}: ${this.C(g,l)}`)):(this.g&&y===0&&(this.j=!0),I(null,"",!0))})}A(d,l,c){const p=new P.StringDecoder(l);return d.on("data",I=>{c(null,p.write(I))}),p}B(d){const l=[];return d.on("data",c=>{l.push(c)}),l}C(d,l){const c=new P.StringDecoder(l);return d.map(p=>c.write(p)).join("")}D(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}G(d,{pathToEntries:l},c,p,I){p.indexOf(this.b)!==-1&&this.J(I,{base:c,relativePath:this.b,searchPath:this.N(d,this.b)});const w=g=>{const y=f.$nc(g),L=f.$mc(g);let F=l[L];F||(F=l[L]=[],w(L)),F.push({base:c,relativePath:g,basename:y,searchPath:this.N(d,g)})};p.forEach(w)}H({rootEntries:d,pathToEntries:l},c,p){const I=this,w=this.t.get(c),g=this.b;function y(L){I.o++;const F=(0,m.$6J)(()=>L.map(z=>z.basename));for(let z=0,j=L.length;z<j;z++){const O=L[z],{relativePath:M,basename:T}=O;if(w.test(M,T,g!==T?F:void 0))continue;const U=l[M];if(U)y(U);else{if(I.p++,M===g)continue;I.J(p,O)}if(I.j)break}}y(d)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(d,l,c,p,I){const w=d.folder,g=(0,m.$6J)(()=>c);this.w(c,(y,L)=>{if(this.l||this.j)return L(null);const F=l?[l,y].join(f.sep):y;if(this.t.get(d.folder.fsPath).test(F,y,this.a.filePattern!==y?g:void 0))return L(null);const z=[w.fsPath,F].join(f.sep);N.lstat(z,(j,O)=>{if(j||this.l||this.j)return L(null);this.L(z,O,(M,T)=>M||this.l||this.j?L(null):T.isDirectory()?(this.o++,this.M(z,O,(U,J)=>U||this.l||this.j||(J=J||"",this.v[J])?L(null):(this.v[J]=!0,u.Promises.readdir(z).then(ne=>{if(this.l||this.j)return L(null);this.I(d,F,ne,p,ee=>L(ee||null))},ne=>{L(null)})))):(this.p++,F===this.b||this.h&&S.$Of(T.size)&&T.size>this.h||this.J(p,{base:w.fsPath,relativePath:F,searchPath:this.N(d,F)}),L(null,void 0)))})},y=>{const L=y&&A.$Hb(y);return I(L&&L.length>0?L[0]:void 0)})}J(d,l){this.K(l)&&(!this.d||this.d(l.relativePath,f.$nc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||d(l))}K(d){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$1J)(d,this.c);if(this.b)return(0,m.$1J)(d,this.b,!1)}return!0}L(d,l,c){return l.isSymbolicLink()?N.stat(d,c):c(null,l)}M(d,l,c){return l.isSymbolicLink()?N.realpath(d,(p,I)=>p?c(p):c(null,I)):c(null,d)}N(d,l){return d.folderName?f.$jc(d.folderName,l):l}}e.$2ic=n;class o{constructor(d){this.a=d.folderQueries,this.b=d.extraFileResources||[],this.c=new n(d)}search(d,l,c){this.c.walk(this.a,this.b,d,l,(p,I)=>{c(p,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$3ic=o;class t{constructor(d,l){this.expression=d,this.c=l,this.d(d)}d(d){let l,c;Object.keys(d).filter(p=>d[p]).forEach(p=>{f.$ic(p)?(l=l||$.$Kj(),l[p]=d[p]):(c=c||$.$Kj(),c[p]=d[p])}),this.a=l&&$.$Pj(l,{trimForExclusions:!0}),this.b=c&&$.$Pj(c,{trimForExclusions:!0})}test(d,l,c){return this.b&&this.b(d,l,c)||this.a&&this.a(f.$jc(this.c,d),l,c)}getBasenameTerms(){const d=[];return this.a&&d.push(...$.$Rj(this.a)),this.b&&d.push(...$.$Rj(this.b)),d}getPathTerms(){const d=[];return this.a&&d.push(...$.$Sj(this.a)),this.b&&d.push(...$.$Sj(this.b)),d}}function h(s){const d=s.trim().split(`
`),l=d[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return E.$Cf(d[d.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(Ce[378],Ie([1,0,98,21,187,22]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.DecodeStreamErrorKind=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=void 0,e.$lD="utf8",e.$mD="utf8bom",e.$nD="utf16be",e.$oD="utf16le";function A(l){return[e.$lD,e.$mD,e.$nD,e.$oD].some(c=>c===l)}e.$pD=A,e.$qD=[254,255],e.$rD=[255,254],e.$sD=[239,187,191];const v=512,$=512,k=512*8,R=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class b extends Error{constructor(c,p){super(c),this.decodeStreamErrorKind=p}}e.$tD=b;class E{static async create(c){let p;if(c!==e.$lD)p=(await(0,f.$kD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(c));else{const I=new TextDecoder;p={write(w){return I.decode(w,{stream:!0})},end(){return I.decode()}}}return new E(p)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function S(l,c){const p=c.minBytesRequiredForDetection??c.guessEncoding?k:$;return new Promise((I,w)=>{const g=(0,D.$$d)(O=>O.join("")),y=[];let L=0,F;const z=new P.$7d,j=async()=>{try{const O=await d({buffer:N.$ke.concat(y),bytesRead:L},c.guessEncoding);if(O.seemsBinary&&c.acceptTextOnly)throw new b("Stream is binary but only text is accepted for decoding",1);O.encoding=await c.overwriteEncoding(O.encoding),F=await E.create(O.encoding);const M=F.write(N.$ke.concat(y).buffer);g.write(M),y.length=0,L=0,I({stream:g,detected:O})}catch(O){z.cancel(),g.destroy(),w(O)}};(0,D.$ce)(l,{onData:async O=>{F?g.write(F.write(O.buffer)):(y.push(O),L+=O.byteLength,L>=p&&(l.pause(),await j(),setTimeout(()=>l.resume())))},onError:O=>g.error(O),onEnd:async()=>{F||await j(),g.end(F?.end())}},z.token)})}e.$uD=S;async function u(l,c,p){const w=(await(0,f.$kD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(c),p);let g=!1,y=!1;return{read(){if(y)return null;const L=l.read();if(typeof L!="string"){if(y=!0,!g&&p?.addBOM)switch(c){case e.$lD:case e.$mD:return N.$ke.wrap(Uint8Array.from(e.$sD));case e.$nD:return N.$ke.wrap(Uint8Array.from(e.$qD));case e.$oD:return N.$ke.wrap(Uint8Array.from(e.$rD))}const F=w.end();return F&&F.length>0?(g=!0,N.$ke.wrap(F)):null}return g=!0,N.$ke.wrap(w.write(L))}}}e.$vD=u;async function m(l){return(await(0,f.$kD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(l))}e.$wD=m;function a(l){return l===e.$mD||l===null?e.$lD:l}e.$xD=a;function i(l,c){if(!l||c<e.$qD.length)return null;const p=l.readUInt8(0),I=l.readUInt8(1);if(p===e.$qD[0]&&I===e.$qD[1])return e.$nD;if(p===e.$rD[0]&&I===e.$rD[1])return e.$oD;if(c<e.$sD.length)return null;const w=l.readUInt8(2);return p===e.$sD[0]&&I===e.$sD[1]&&w===e.$sD[2]?e.$mD:null}e.$yD=i;const r=["ascii","utf-16","utf-32"];async function n(l){const c=await(0,f.$kD)("jschardet","dist/jschardet.min.js"),p=l.slice(0,R),I=h(p.buffer),w=c.detect(I);if(!w||!w.encoding)return null;const g=w.encoding.toLowerCase();return 0<=r.indexOf(g)?null:t(w.encoding)}const o={ibm866:"cp866",big5:"cp950"};function t(l){const c=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[c]||c}function h(l){let c="";for(let p=0;p<l.length;p++)c+=String.fromCharCode(l[p]);return c}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=l.match(/windows(\d+)/);return c?"windows-"+c[1]:l}}}e.$zD=s;function d({buffer:l,bytesRead:c},p){let I=i(l,c),w=!1;if(I!==e.$nD&&I!==e.$oD&&l){let g=!0,y=!0,L=!1;for(let F=0;F<c&&F<v;F++){const z=F%2===1,j=l.readUInt8(F)===0;if(j&&(L=!0),g&&(z&&!j||!z&&j)&&(g=!1),y&&(z&&j||!z&&!j)&&(y=!1),j&&!g&&!y)break}L&&(g?I=e.$oD:y?I=e.$nD:w=!0)}return p&&!w&&!I&&l?n(l.slice(0,c)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:w,encoding:I}}e.$AD=d,e.$BD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[156],Ie([1,0,378,31,155]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class P extends f.$Vhc{constructor(v,$,k=N,R="searchProcess"){super(v,$,{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$zD)(C)},R)}}e.$$ic=P}),define(Ce[157],Ie([1,0,50,394,377,19,74,35,12,2,36,94,395,375,119]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=e.$9ic=e.$8ic=e.$7ic=e.$6ic=e.$5ic=e.$4ic=void 0;const u=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(g){this.a=g}provideTextSearchResults(g,y,L,F){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,j)=>{F.onCancellationRequested(()=>Q());const O=t(g,y),M=y.folder.fsPath,T=O.map(re=>re.match(/^-/)?re:`'${re}'`).join(" ");this.a.appendLine(`${u} ${T}
 - cwd: ${M}`);let U=D.spawn(u,O,{cwd:M});U.on("error",re=>{console.error(re),this.a.appendLine("Error: "+(re&&re.message)),j((0,R.$WJ)(new R.$UJ(re&&re.message,R.SearchErrorCode.rgProcessError)))});let J=!1;const ne=new r(y.maxResults,y.folder,y.previewOptions);ne.on("result",re=>{J=!0,ce="",L.report(re)});let ee=!1;const Q=()=>{ee=!0,U?.kill(),ne?.cancel()};let Y=!1;ne.on("hitLimit",()=>{Y=!0,Q()});let ce="";U.stdout.on("data",re=>{ne.handleData(re),J||(ce+=re)});let te=!1;U.stdout.once("data",()=>te=!0);let fe="";U.stderr.on("data",re=>{const K=re.toString();this.a.appendLine(K),fe.length+K.length<1e6&&(fe+=K)}),U.on("close",()=>{if(this.a.appendLine(te?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),ee)z({limitHit:Y});else{ne.flush(),U=null;let re;fe&&!te&&(re=a(fe))?j((0,R.$WJ)(new R.$UJ(re.message,re.code))):z({limitHit:Y})}})})}}e.$4ic=m;function a(w){const g=w.split(`
`),y=g[0].trim();if(g.some(F=>F.startsWith("regex parse error")))return new R.$UJ(i(g),R.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new R.$UJ(`Unknown encoding: ${L[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$UJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$UJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$UJ(y,R.SearchErrorCode.regexParseError)}function i(w){const g=["Regex parse error"],y=w.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const F=L.split(":")[1];g.push(":"+F)}}return g.join("")}class r extends N.EventEmitter{constructor(g,y,L){super(),this.g=g,this.h=y,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,y){return super.on(g,y),this}handleData(g){if(this.b)return;const y=typeof g=="string"?g:this.d.write(g);this.k(y)}k(g){let y=g.indexOf(`
`);const L=this.a+g;if(y>=0)y+=this.a.length;else{this.a=L;return}let F=0;for(;y>=0;)this.m(L.substring(F,y).trim()),F=y+1,y=L.indexOf(`
`,F);this.a=L.substring(F)}m(g){if(this.b||!g)return;let y;try{y=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(y.type==="match"){const L=n(y.data.path),F=k.URI.joinPath(this.h,L),z=this.n(y.data,F);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=n(y.data.path),F=k.URI.joinPath(this.h,L);this.o(y.data,F).forEach(j=>this.p(j))}}n(g,y){const L=g.line_number-1,F=n(g.lines),z=Buffer.from(F);let j=0,O=0,M=L;g.submatches.length===0&&g.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const T=(0,P.$Hb)(g.submatches.map((U,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ne=n(U.match),ee=z.slice(j,U.start).toString(),Q=o(ee),Y=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+O,ce=o(ne),te=Q.numLines+M,fe=ce.numLines+te,re=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Y;return j=U.end,O=re,M=fe,new C.$EJ(te,Y,fe,re)}));return(0,S.$Wic)(y,F,T,this.j)}o(g,y){const L=n(g.lines),F=g.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((z,j)=>({text:z,uri:y,lineNumber:F+j}))}p(g){this.emit("result",g)}}e.$5ic=r;function n(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function o(w){const g=/\n/g;let y=0,L=-1,F;for(;F=g.exec(w);)y++,L=F.index;const z=L>=0?w.length-L-1:w.length;return{numLines:y,lastLineLength:z}}function t(w,g){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:F}=(0,A.$K)(g.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const j=new Set;F.forEach(O=>{j.add(O)}),y.push("-g","!*"),j.forEach(O=>{h(O).map(S.$Vic).forEach(M=>{y.push("-g",M)})})}L&&L.length&&L.forEach(j=>{y.push("-g",j)}),g.excludes.map(S.$Vic).forEach(j=>y.push("-g",`!${j}`)),g.maxFileSize&&y.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),g.followSymlinks&&y.push("--follow"),g.encoding&&g.encoding!=="utf8"&&y.push("--encoding",g.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,$.$Pe)(w.pattern),w.isRegExp=!0),g.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=s(w.pattern),y.push("--engine","auto"));let z;if(w.isWordMatch){const O=(0,$.$Ye)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",O)}else if(w.isRegExp){let j=l(w.pattern);j=c(j),y.push("--regexp",j)}else z=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),g.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),g.beforeContext&&y.push("--before-context",g.beforeContext+""),g.afterContext&&y.push("--after-context",g.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}e.$6ic=t;function h(w){return I(w).flatMap(y=>{const L=(0,v.$Nj)(y,"/");return L.map((F,z)=>L.slice(0,z+1).join("/"))})}function s(w){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(g);)w=w.replace(g,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}e.$7ic=s;const d=w=>w.type==="Assertion"&&w.kind==="lookbehind";function l(w){let g;try{g=new b.RegExpParser().parsePattern(w)}catch{return w}let y="",L=0;const F=(O,M,T)=>{y+=w.slice(L,O)+T,L=M},z=[];return new b.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const M=z[0];if(!M)F(O.start,O.end,"\\r?\\n");else if(!z.some(d))if(M.type==="CharacterClass")if(M.negate){const T=w.slice(M.start+2,O.start)+w.slice(O.end,M.end-1);M.parent?.type==="Quantifier"?F(M.start,M.end,T?`[^${T}]`:"."):F(M.start,M.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=w.slice(M.start+1,O.start)+w.slice(O.end,M.end-1);F(M.start,M.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else M.type==="Quantifier"&&F(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){z.unshift(O)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(O){z.unshift(O)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(O){z.unshift(O)},onCharacterClassLeave(){z.shift()},onAssertionEnter(O){d(O)&&z.push(O)},onAssertionLeave(O){z[0]===O&&z.shift()}}).visit(g),y+=w.slice(L),y}e.$8ic=l;function c(w){return w.replace(/\n/g,"\\r?\\n")}e.$9ic=c;function p(w){let g=!1,y=!1,L="",F="";for(let z=0;z<w.length;z++){const j=w[z];switch(j){case"\\":y?(g?F+="\\"+j:L+="\\"+j,y=!1):y=!0;break;case"{":if(y)g?F+=j:L+=j,y=!1;else{if(g)return{strInBraces:L+"{"+F+"{"+w.substring(z+1)};g=!0}break;case"}":if(y)g?F+=j:L+=j,y=!1;else{if(g)return{fixedStart:L,strInBraces:F,fixedEnd:w.substring(z+1)};L+=j}break;default:g?F+=(y?"\\":"")+j:L+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:L+(g?"{"+F:"")}}function I(w){const{fixedStart:g,strInBraces:y,fixedEnd:L}=p(w);if(g===void 0||L===void 0)return[y];let F=(0,v.$Nj)(y,",");F.length||(F=[""]);const z=I(L);return F.flatMap(j=>{const O=g+j;return z.map(M=>O+M)})}e.$0ic=I}),define(Ce[379],Ie([1,0,22,157,107,15]),function(me,e,D,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;class A{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,R,C,b){const E=new N.$4ic(this.b);if(R.folder.scheme===P.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:P.Schemas.file})},u=new f.$yv(m=>C.report({...m,uri:m.uri.with({scheme:R.folder.scheme})}));return this.c(b,m=>E.provideTextSearchResults(k,S,u,m))}else return this.c(b,S=>E.provideTextSearchResults(k,R,C,S))}async c(k,R){const C=v(k);this.a.add(C);const b=await R(C.token);return this.a.delete(C),b}d(){this.a.forEach(k=>k.cancel())}}e.$bjc=A;function v($){const k=new D.$7d;return $.onCancellationRequested(()=>k.cancel()),k}}),define(Ce[380],Ie([1,0,31,157,156]),function(me,e,D,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;class P{constructor($){this.a=$}search($,k,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){R({message:E})}},b=new f.$$ic(this.a,new N.$4ic(C),D);return new Promise((E,S)=>b.search(u=>{k(u.map(A))},$).then(u=>E({limitHit:u.limitHit,type:"success",stats:u.stats}),S))}}e.$_ic=P;function A(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce(($,k)=>{if(k.ranges){const R=k;return $+(Array.isArray(R.ranges)?R.ranges.length:1)}else return $+1},0)}}}),define(Ce[381],Ie([1,0,19,8,14,4,129,17,38,2,32,36,376,380]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let o;const t=a(n),h=new P.$Wd({onDidAddFirstListener:()=>{o=(0,N.$Vg)(s=>this.doFileSearchWithEngine(b.$3ic,t,d=>h.fire(d),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}textSearch(n){let o;const t=a(n),h=new P.$Wd({onDidAddFirstListener:()=>{o=(0,N.$Vg)(s=>this.f(t,d=>h.fire(d),s)),o.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{o.cancel()}});return h.event}f(n,o,t){return n.maxFileSize=this.g().maxFileSize,new E.$_ic(n).search(t,o,o)}g(){return{maxFileSize:16*R.$2k.GB}}doFileSearch(n,o,t){return this.doFileSearchWithEngine(b.$3ic,n,o,t)}doFileSearchWithEngine(n,o,t,h,s=S.a){let d=0;const l=p=>{Array.isArray(p)?(d+=p.length,t(p.map(I=>this.h(I)))):p.relativePath?(d++,t(this.h(p))):t(p)};if(o.sortByScore){let p=this.l(o,l,h);if(!p){const I=o.maxResults?Object.assign({},o,{maxResults:null}):o,w=new n(I);p=this.j(w,o,t,l,h)}return new Promise((I,w)=>{p.then(([g,y])=>{const L=y.map(F=>this.h(F));this.o(L,t,s),I(g)},w)})}const c=new n(o);return this.r(c,l,s,h).then(p=>({limitHit:p.limitHit,type:"success",stats:{detailStats:p.stats,type:this.d,fromCache:!1,resultCount:d,sortingTime:void 0}}))}h(n){return{path:n.base?(0,v.$jc)(n.base,n.relativePath):n.relativePath}}j(n,o,t,h,s){const d=new P.$Wd;let l=(0,N.$Vg)(p=>{let I=[];const w=g=>{Array.isArray(g)?I=g:(h(g),d.fire(g))};return this.r(n,w,-1,p).then(g=>[g,I])}),c;if(o.cacheKey){c=this.k(o.cacheKey);const p={promise:l,event:d.event,resolved:!1};c.resultsToSearchCache[o.filePattern||""]=p,l.then(()=>{p.resolved=!0},I=>{delete c.resultsToSearchCache[o.filePattern||""]}),l=this.s(l)}return l.then(([p,I])=>{const w=c?c.scorerCache:Object.create(null),g=(typeof o.maxResults!="number"||o.maxResults>0)&&$.$Sd.create(!1);return this.n(o,I,w,s).then(y=>{const L=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:p.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:o.folderQueries.length,resultCount:y.length},messages:p.messages,limitHit:p.limitHit||typeof o.maxResults=="number"&&I.length>o.maxResults},y]})})}k(n){const o=this.b[n];return o||(this.b[n]=new u)}l(n,o,t){const h=n.cacheKey&&this.b[n.cacheKey];if(!h)return;const s=this.q(h,n.filePattern||"",o,t);if(s)return s.then(([d,l,c])=>{const p=$.$Sd.create(!1);return this.n(n,l,h.scorerCache,t).then(I=>{const w=p.elapsed(),g={fromCache:!0,detailStats:c,type:this.d,resultCount:l.length,sortingTime:w};return[{type:"success",limitHit:d.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults,stats:g},I]})})}n(n,o,t,h){const s=(0,A.$3q)(n.filePattern||""),d=(c,p)=>(0,A.$2q)(c,p,s,!0,m,t),l=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return D.$Gb(o,d,l,1e4,h)}o(n,o,t){if(t&&t>0)for(let h=0;h<n.length;h+=t)o(n.slice(h,h+t));else o(n)}q(n,o,t,h){const s=$.$Sd.create(!1),d=o.indexOf(v.sep)>=0;let l;for(const w in n.resultsToSearchCache)if(o.startsWith(w)){if(d&&w.indexOf(v.sep)<0&&w!=="")continue;const g=n.resultsToSearchCache[w];l={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!l)return null;const c=s.elapsed(),p=$.$Sd.create(!1),I=l.event(t);return h&&h.onCancellationRequested(()=>{I.dispose()}),l.promise.then(([w,g])=>{if(h&&h.isCancellationRequested)throw(0,f.$6)();const y=[],L=(0,A.$3q)(o).normalizedLowercase;for(const F of g)(0,C.$1J)(F,L)&&y.push(F);return[w,y,{cacheWasResolved:l.resolved,cacheLookupTime:c,cacheFilterTime:p.elapsed(),cacheEntryCount:g.length}]})}r(n,o,t,h){return new Promise((s,d)=>{let l=[];h?.onCancellationRequested(()=>n.cancel()),n.search(c=>{c&&(t?(l.push(c),t>0&&l.length>=t&&(o(l),l=[])):o(c))},c=>{o(c)},(c,p)=>{l.length&&o(l),c?(o({message:"Search finished. Error: "+c.message}),d(c)):(o({message:"Search finished. Stats: "+JSON.stringify(p.stats)}),s(p))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(o,t){return n.then(o,t)}catch(o){return this.then(void 0,o)}finally(o){return n.finally(o)}}}}e.$ajc=S;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(r){return(0,v.$nc)(r.relativePath)}getItemDescription(r){return(0,v.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function a(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>k.URI.revive(n))}}function i(r){return{...r,folder:k.URI.revive(r.folder)}}}),define(Ce[382],Ie([1,0,3,15,2,31,13,27,20,97,67,36,381,379,119,156]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let m=class extends k.$1hc{constructor(i,r,n,o){super(i,n,o),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Sc;const t=new S.$Xic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$bjc(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Xic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new E.$bjc(i))),this.x.add(this.z(N.Schemas.file,new b.$ajc("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,D.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,o){const t=(0,k.$2hc)(n);if(i===this.t){const h=Date.now();return this.A(i,r,t,o).then(s=>{const d=Date.now()-h;return this.n.debug(`Ext host file search time: ${d}ms`),s})}return super.$provideFileSearchResults(i,r,n,o)}doInternalFileSearchWithCustomCallback(i,r,n){const o=t=>{if((0,C.$ZJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(h=>f.URI.file(h.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,o,r)}async A(i,r,n,o){return this.doInternalFileSearchWithCustomCallback(n,o,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new u.$$ic(i,r,void 0,"textSearchProvider")}};e.$cjc=m,e.$cjc=m=Ke([We(0,$.$DN),We(1,v.$TN),We(2,R.$Tgc),We(3,A.$qj)],m)}),define(Ce[120],Ie([1,0,396,62,64,397,21,14,4,3,17,11,30,81,82]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class u{traceSocketEvent(g,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,y)}constructor(g,y=""){this.f=!0,this.debugLabel=y,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,v.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const y=L=>{this.traceSocketEvent("read",L),g(A.$ke.wrap(L))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(g){const y=L=>{g({type:0,hadError:L,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(g){const y=()=>{g()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Xh=u;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var a;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(a||(a={}));class i extends k.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,y){this.socket.traceSocketEvent(g,y)}constructor(g,y,L,F){super(),this.f=this.B(new $.$Wd),this.g=this.B(new $.$Wd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:L?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new r(this,y,L,F,this.f,(z,j)=>this.m(z,j))),this.B(this.a.onError(z=>{console.error(z),(0,v.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Sh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let y=0;for(;y<g.byteLength;)this.a.writeMessage(g.slice(y,Math.min(y+262144,g.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(g,{compressed:y,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let F=2;g.byteLength<126?F+=0:g.byteLength<2**16?F+=2:F+=8;const z=A.$ke.alloc(F),j=y?64:0,O=L&15;if(z.writeUInt8(128|j|O,0),g.byteLength<126)z.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){z.writeUInt8(126,1);let M=1;z.writeUInt8(g.byteLength>>>8&255,++M),z.writeUInt8(g.byteLength>>>0&255,++M)}else{z.writeUInt8(127,1);let M=1;z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(g.byteLength>>>24&255,++M),z.writeUInt8(g.byteLength>>>16&255,++M),z.writeUInt8(g.byteLength>>>8&255,++M),z.writeUInt8(g.byteLength>>>0&255,++M)}this.socket.write(A.$ke.concat([z,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),L=y.readUInt8(0),F=(L&128)>>>7,z=(L&64)>>>6,j=L&15,O=y.readUInt8(1),M=(O&128)>>>7,T=O&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),L=y.readUInt8(1),F=(L&128)>>>7;let z=L&127,j=1;z===126?z=y.readUInt8(++j)*2**8+y.readUInt8(++j):z===127&&(z=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let O=0;F&&(O=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=z,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Yh=i;class r extends k.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ke.alloc(0)}constructor(g,y,L,F,z,j){super(),this.n=g,this.r=z,this.s=j,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Wd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Wd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new n(this.n,F,L,{windowBits:15})),this.f=this.B(new o(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(g,y){this.g.push({data:g,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:y}=this.g.shift();if(this.f&&y.compressed){const L=await this.w(this.f,g);this.s(L,y)}else this.s(g,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,y){return new Promise((L,F)=>{g.write(y),g.flush(z=>L(z))})}acceptFrame(g,y,L){this.h.push({data:g,isCompressed:y,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const y=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,y,L){return new Promise((F,z)=>{g.write(y),L&&g.write(A.$ke.fromByteArray([0,0,255,255])),g.flush(j=>F(j))})}}class n extends k.$Tc{get recordedInflateBytes(){return this.j?A.$ke.concat(this.f):A.$ke.alloc(0)}constructor(g,y,L,F){super(),this.h=g,this.j=y,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(A.$ke.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$ke.concat(this.g);this.g.length=0,g(y)})}}class o extends k.$Tc{constructor(g,y){super(),this.g=g,this.a=this.B(new $.$Wd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$ke.wrap(L))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$ke.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),g(y)})}}function t(w,g){if(g===0)return;const y=w.byteLength>>>2;for(let M=0;M<y;M++){const T=w.readUInt32BE(M*4);w.writeUInt32BE(T^g,M*4)}const L=y*4,F=w.byteLength-L,z=g>>>24&255,j=g>>>16&255,O=g>>>8&255;F>=1&&w.writeUInt8(w.readUInt8(L)^z,L),F>=2&&w.writeUInt8(w.readUInt8(L+1)^j,L+1),F>=3&&w.writeUInt8(w.readUInt8(L+2)^O,L+2)}e.$Zh=process.env.XDG_RUNTIME_DIR;const h={2:107,1:103};function s(){const w=(0,b.$sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const g=process.platform!=="darwin"&&e.$Zh?e.$Zh:(0,f.tmpdir)(),y=(0,R.$jc)(g,`vscode-ipc-${w}.sock`);return l(y),y}e.$1h=s;function d(w,g,y){const F=(0,D.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${y}-${g}-sock`;const z=y.substr(0,4),j=g.substr(0,6);let O;return process.platform!=="darwin"&&e.$Zh&&!process.env.VSCODE_PORTABLE?O=(0,R.$jc)(e.$Zh,`vscode-${F}-${z}-${j}.sock`):O=(0,R.$jc)(w,`${z}-${j}.sock`),l(O),O}e.$2h=d;function l(w){const g=h[C.$u];typeof g=="number"&&w.length>=g&&console.warn(`WARNING: IPC handle "${w}" is longer than ${g} chars, try a shorter --user-data-dir`)}class c extends E.$Mh{static b(g){const y=$.Event.fromNodeEventEmitter(g,"connection");return $.Event.map(y,L=>({protocol:new S.$Th(new u(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(g){super(c.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$3h=c;function p(w){return new Promise((g,y)=>{const L=(0,N.createServer)();L.on("error",y),L.listen(w,()=>{L.removeListener("error",y),g(new c(L))})})}e.$4h=p;function I(w,g){return new Promise((y,L)=>{const F=(0,N.createConnection)(w,()=>{F.removeListener("error",L),y(S.$Uh.fromSocket(new u(F,`ipc-client${g}`),g))});F.once("error",L)})}e.$5h=I}),define(Ce[383],Ie([1,0,62,64,167,120,8,3,11,51,13,136,258,259,109,88,21]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=e.$s_b=e.$r_b=e.$q_b=void 0;async function a(t,h,s,d,l){let c;for(let p=3;p&&(c?.dispose(),c=await new i(t,h,s,d,l).waitForReady(),!(l&&f.$vg[l]||!f.$vg[c.tunnelLocalPort]));p--);return c}class i extends v.$Tc{constructor(h,s,d,l,c){super(),this.m=s,this.n=c,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=D.createServer(),this.c=new A.$8g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,s=(0,u.$Kv)(this.m)?"0.0.0.0":"127.0.0.1";let d=await(0,f.$wg)(h,2,1e3,s),l=null;return this.b.listen(d,this.m),await this.c.wait(),l=this.b.address(),l||(d=0,this.b.listen(d,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(h){h.pause();const s=(0,u.$Iv)(this.tunnelRemoteHost)||(0,u.$Kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,b.$ol)(this.a,s,this.tunnelRemotePort),l=d.getSocket(),c=d.readEntireBuffer();d.dispose(),c.byteLength>0&&h.write(c.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),l.end()}),h.on("close",()=>l.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),l instanceof P.$Xh?l.socket.destroy():l.end()}),l instanceof P.$Xh?this.t(h,l):this.s(h,l),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),l.end()})}s(h,s){s.onClose(()=>h.destroy()),s.onEnd(()=>h.end()),s.onData(d=>h.write(d.buffer)),h.on("data",d=>s.write(m.$ke.wrap(d))),h.resume()}t(h,s){const d=s.socket;d.on("end",()=>h.end()),d.on("close",()=>h.end()),d.on("error",()=>{h.destroy()}),d.pipe(h),h.pipe(d)}}e.$q_b=i;let r=class extends u.$Nv{constructor(h,s,d,l,c){super(s,c),this.v=h,this.w=d,this.y=l}isPortPrivileged(h){return(0,u.$Lv)(h,this.m,$.OS,N.release())}t(h,s,d,l,c,p,I,w){const g=this.s(s,d);if(g)return++g.refcount,g.value;if((0,u.$Fv)(h))return this.u(h,s,d,c,p,I,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${d} on local port ${c}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},L=a(y,l,s,d,c);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,d,L),L}}};e.$r_b=r,e.$r_b=r=Ke([We(0,E.$il),We(1,R.$qj),We(2,S.$ll),We(3,C.$Ij),We(4,k.$Ci)],r);let n=class extends r{constructor(h,s,d,l,c){super(h,s,d,l,c)}};e.$s_b=n,e.$s_b=n=Ke([We(0,E.$il),We(1,R.$qj),We(2,S.$ll),We(3,C.$Ij),We(4,k.$Ci)],n);let o=class extends v.$Tc{constructor(h,s,d,l,c){super(),this.b=h,this.c=s,this.f=d,this.g=l,this.h=c,this.a=new Map}async openTunnel(h,s,d,l,c,p,I,w,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${l} on local port ${p}.`),!this.a.has(h)){const y=new n(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(h,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(s,d,l,c,p,I,w,g)}};e.$t_b=o,e.$t_b=o=Ke([We(0,E.$il),We(1,R.$qj),We(2,C.$Ij),We(3,S.$ll),We(4,k.$Ci)],o)}),define(Ce[384],Ie([1,0,120,278,57,33,2,13,40]),function(me,e,D,N,f,P,A,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0;class k{constructor(b,E,S){this.b=b,this.c=E,this.f=S,this.a=N.createServer((u,m)=>this.h(u,m)),this.g().catch(u=>(E.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,E){const S=(m,a)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(a||null),i=>i&&this.c.error(i))},u=[];b.setEncoding("utf8"),b.on("data",m=>u.push(m)),b.on("end",async()=>{try{const m=JSON.parse(u.join(""));let a;switch(m.type){case"open":a=await this.i(m);break;case"openExternal":a=await this.j(m);break;case"status":a=await this.l(m);break;case"extensionManagement":a=await this.k(m);break;default:S(404,`Unknown message type: ${m.type}`);break}S(200,a)}catch(m){const a=m instanceof Error?m.message:JSON.stringify(m);S(500,a),this.c.error("Error while processing pipe request",m)}})}async i(b){const{fileURIs:E,folderURIs:S,forceNewWindow:u,diffMode:m,mergeMode:a,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:o,remoteAuthority:t}=b,h=[];if(Array.isArray(S))for(const c of S)try{h.push({folderUri:A.URI.parse(c)})}catch{}if(Array.isArray(E))for(const c of E)try{(0,$.$Bi)(c)?h.push({workspaceUri:A.URI.parse(c)}):h.push({fileUri:A.URI.parse(c)})}catch{}const s=o?A.URI.file(o):void 0,l={forceNewWindow:u,diffMode:m,mergeMode:a,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,l)}async j(b){for(const E of b.uris){const S=A.URI.parse(E),u=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(b){const E=u=>u?.map(m=>/\.vsix$/i.test(m)?A.URI.parse(m):m),S={list:b.list,install:E(b.install),uninstall:E(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$5N=k;let R=class extends k{constructor(b,E){super(b,E,(0,D.$1h)())}};e.$6N=R,e.$6N=R=Ke([We(0,P.$ZN),We(1,v.$qj)],R)}),define(Ce[385],Ie([1,0,58,372,367,277,47,354,2,15,7,384,103,310,353]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class u extends f.$Iic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,d,l){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,b.$zq)(d.filename)),c=>n.apply(this,[c,d,l])):n.apply(this,arguments)};const o=r._resolveLookupPaths;r._resolveLookupPaths=(h,s)=>o.call(this,t(h),s);const t=h=>{for(const s of i.b){const d=s(h);if(d){h=d;break}}return h}}}class m extends A.$xhc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$fjc);const i=this.h.invokeFunction(N.$Eic);if(this.h.createInstance(v.$ejc),this.f.remote.isRemote&&this.f.remote.authority){const o=this.h.createInstance(C.$6N);process.env.VSCODE_IPC_HOOK_CLI=o.ipcHandlePath}this.h.createInstance(S.$gjc),await this.h.createInstance(u,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,P.$djc)(this.j,n,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let o=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),o=me.__$__nodeRequire(r.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return o}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$hjc=m}),define(Ce[386],Ie([1,0,50,21,4,3,122,11,23,2,31,13,257,65,109,88,383,27,20,71,361]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=e.$njc=e.$mjc=e.$ljc=e.$kjc=e.$jjc=e.$ijc=void 0;function o(g){const y=g.trim().split(`
`),L=[];return y.forEach(z=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);j&&j.length>=3&&L.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),L.reduce((z,j)=>(z[j.socket]=j,z),{})}e.$ijc=o;function t(...g){const y=[].concat(...g.map(s));return[...new Map(y.filter(L=>L.st==="0A").map(L=>{const F=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:h(F[0]),port:parseInt(F[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$jjc=t;function h(g){let y="";if(g.length===8)for(let L=g.length-2;L>=0;L-=2)y+=parseInt(g.substr(L,2),16),L!==0&&(y+=".");else for(let L=0;L<g.length;L+=8){const F=g.substring(L,L+8);let z="";for(let j=8;j>=2;j-=2)z+=F.substring(j-2,j),(j===6||j===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",L+j!==g.length-6&&(y+=":"))}return y}e.$kjc=h;function s(g){const y=g.trim().split(`
`),L=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((j,O,M)=>(j[L[M]||M]=O,j),{}))}e.$ljc=s;function d(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function l(g){const y=g.trim().split(`
`),L=[];return y.forEach(F=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);z&&z.length>=4&&L.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),L}e.$mjc=l;async function c(g,y,L){const F=L.reduce((j,O)=>(j[O.pid]=O,j),{}),z=[];return g.forEach(({socket:j,ip:O,port:M})=>{const T=y[j]?y[j].pid:void 0,U=T?F[T]?.cmd:void 0;T&&U&&!d(U)&&z.push({host:O,port:M,detail:U,pid:T})}),z}e.$njc=c;function p(g,y,L){const F=new Map,z=l(y);for(const j of g){const O=L.get(j.port);if(O){F.set(j.port,O);continue}const M=z.find(T=>T.cmd.includes(`${j.port}`));if(M){let T=M,U;do U=z.find(J=>J.ppid===T.pid),U&&(T=U);while(U);F.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else F.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return F}e.$ojc=p;let I=class extends r.$Fzb{constructor(y,L,F,z){super(y,L,F),this.D=L,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,v.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new A.$am;let z=0;for(;this.C;){const j=new Date().getTime(),O=(await this.I()).filter(U=>(0,u.$Iv)(U.host)||(0,u.$Kv)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),z++>3&&F.update(M),(!L||JSON.stringify(L)!==JSON.stringify(O))&&(L=O,await this.a.$onFoundNewCandidates(L));const T=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(U=>setTimeout(()=>U(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",L="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),L=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(y,L),z=await new Promise(ee=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Y,ce)=>{ee(Y)})}),j=o(z),O=await R.Promises.readdir("/proc"),M=[];for(const ee of O)try{const Q=Number(ee),Y=$.$Jg(k.URI.file("/proc"),ee);if((await R.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(Q)){const te=await R.Promises.readlink($.$Jg(Y,"cwd").fsPath),fe=await R.Promises.readFile($.$Jg(Y,"cmdline").fsPath,"utf8");M.push({pid:Q,cwd:te,cmd:fe})}}catch{}const T=[],U=F.filter(ee=>{const Q=j[ee.socket];return Q||T.push(ee),Q}),J=c(U,j,M);let ne;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const ee=await new Promise(Q=>{(0,D.exec)("ps -F -A -l | grep root",(Y,ce,te)=>{Q(ce)})});this.z=p(T,ee,this.z),ne=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ne.map(Q=>Q.port).join(", ")}`)}return J.then(ee=>ne?ee.concat(ne):ee)}w(y){return async L=>{const F=new m.$q_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,O,M,T){const U=await y.makeConnection();return w.connect(U,O,M,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$_k(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await F.waitForReady();const z=new f.$Wd;return{localAddress:(0,n.$PK)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{F.dispose(),z.fire(),z.dispose()}}}}};e.$pjc=I,e.$pjc=I=Ke([We(0,i.$DN),We(1,a.$TN),We(2,C.$qj),We(3,S.$ll)],I);class w extends b.$Esb{static connect(y,L,F,z){const j=new P.$Sc,O={onClose:j.add(new f.$Wd),onData:j.add(new f.$Wd),onEnd:j.add(new f.$Wd)};j.add(y.onDidReceiveMessage(T=>O.onData.fire(N.$ke.wrap(T)))),j.add(y.onDidEnd(()=>O.onEnd.fire())),j.add(y.onDidClose(T=>O.onClose.fire({type:0,error:T,hadError:!!T})));const M=new w(y,z,O);return M.B(j),(0,b.$Dsb)(M,L,F,z,O)}constructor(y,L,F){super(L,F),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ce[387],Ie([1,0,84,356,370,369,382,385,386,96,47,97,95,46,71,93,355,311,13,371,60,272,105,109,138]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a,i,r,n,o,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$2r)(R.$yhc,v.$hjc,0),(0,D.$2r)(i.$rj,a.$rjc,1),(0,D.$2r)(i.$qj,new t.$6h(o.$Hic,[!1],!0)),(0,D.$2r)(h.$ll,s.$v_b,1),(0,D.$2r)(u.$3gc,m.$qjc,0),(0,D.$2r)(k.$Dhc,P.$Uic,0),(0,D.$2r)(C.$Zhc,A.$cjc,0),(0,D.$2r)(b.$qic,f.$Mic,0),(0,D.$2r)(E.$lhc,N.$Lic,0),(0,D.$2r)(S.$Ezb,$.$pjc,0),(0,D.$2r)(n.$Bhc,r.$sjc,0)}),define(Ce[398],Ie([1,0,62,399,58,14,82,120,255,113,368,21,31,103,8,132,279,293,373,387]),function(me,e,D,N,f,P,A,v,$,k,R,C,b,E,S,u,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let p=0;p<process.execArgv.length;p++)process.execArgv[p]==="--inspect-port=0"&&(process.execArgv.splice(p,1),p--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,p=c._load;c._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return p.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function o(c){process.exit=function(p){if(c)r(p);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const p=new Error("An extension called process.crash() and this was prevented.");console.warn(p.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(p,I){p==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),n(p,I)}}let t=function(c){r()};function h(){const c=(0,a.$Xm)(process.env);if(c.type===3)return new Promise((p,I)=>{const w=g=>{const y=g[0],L=new A.$Vh;y.on("message",F=>L.fire(C.$ke.wrap(F.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),p({onMessage:L.event,send:F=>y.postMessage(F.buffer)})};process.parentPort.on("message",g=>w(g.ports))});if(c.type===2)return new Promise((p,I)=>{let w=null;const g=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,F=new S.$jh(()=>t("renderer disconnected for too long (1)"),y),z=new S.$jh(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(O,M)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const T=C.$ke.wrap(Buffer.from(O.initialDataChunk,"base64"));let U;if(O.skipWebSocketFrames)U=new v.$Xh(M,"extHost-socket");else{const J=C.$ke.wrap(Buffer.from(O.inflateBytes,"base64"));U=new v.$Yh(new v.$Xh(M,"extHost-socket"),O.permessageDeflate,J,!1)}w?(F.cancel(),z.cancel(),w.beginAcceptReconnection(U,T),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(g),w=new A.$Wh({socket:U,initialChunk:T}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),p(w),w.onSocketClose(()=>{F.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;F.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const p=c.pipeName;return new Promise((I,w)=>{const g=D.createConnection(p,()=>{g.removeListener("error",w);const y=new A.$Wh({socket:new v.$Xh(g,"extHost-renderer")});y.sendResume(),I(y)});g.once("error",w),g.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const c=await h();return new class{constructor(){this.a=new A.$Vh,this.onMessage=this.a.event,this.b=!1,c.onMessage(p=>{(0,k.$xm)(p,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(p)})}send(p){this.b||c.send(p)}async drain(){if(c.drain)return c.drain()}}}function d(c){return new Promise(p=>{const I=c.onMessage(w=>{I.dispose();const g=JSON.parse(w.toString()),y=g.commit,L=$.default.commit;if(y&&L&&y!==L&&r(55),g.parentPid){let F=0;setInterval(function(){try{process.kill(g.parentPid,0),F=0}catch(j){j&&j.code==="EPERM"?(F++,F>=3&&t(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${g.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(g.parentPid)}catch(j){(0,P.$1)(j)}}c.send((0,k.$wm)(0)),p({protocol:c,initData:g})});c.send((0,k.$wm)(1))})}async function l(){const c=[];process.on("unhandledRejection",(F,z)=>{c.push(z),setTimeout(()=>{const j=c.indexOf(z);j>=0&&z.catch(O=>{c.splice(j,1),(0,P.$4)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),F&&(0,P.$1)(F))})},1e3)}),process.on("rejectionHandled",F=>{const z=c.indexOf(F);z>=0&&c.splice(z,1)}),process.on("uncaughtException",function(F){(0,P.$Z)(F)||(0,P.$1)(F)}),f.mark("code/extHost/willConnectToRenderer");const p=await s();f.mark("code/extHost/didConnectToRenderer");const I=await d(p);f.mark("code/extHost/didWaitForInitData");const{initData:w}=I;o(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,u.boolean)(i.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(z){r(z)}fsExists(z){return b.Promises.exists(z)}fsRealpath(z){return(0,E.$yq)(z)}};let y=null;w.remote.authority&&i.transformURIs&&(y=(0,m.$6r)(w.remote.authority));const L=new R.$Kic(I.protocol,w,g,y);t=F=>L.terminate(F)}l().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c15c66607256592202cc051fb3e117baf54af63/core/vs/workbench/api/node/extensionHostProcess.js.map
