/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],H=function(W){for(var e=[],P=0,T=W.length;P<T;P++)e[P]=G[W[P]];return e};define(G[22],H([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const v=new Map,N=new Map,s=new Map,f=new Map;function t(h,i){h.has(i.detail)||h.set(i.detail,-i.timestamp)}function d(h,i){const n=h.get(i.detail);n&&(n>=0||h.set(i.detail,n+i.timestamp))}let $=[];typeof W=="function"&&typeof W.getStats=="function"&&($=W.getStats().slice(0).sort((h,i)=>h.timestamp-i.timestamp));for(const h of $)switch(h.type){case 10:t(v,h);break;case 11:case 12:d(v,h);break;case 21:t(N,h);break;case 22:d(N,h);break;case 33:t(s,h);break;case 34:d(s,h);break;case 31:t(f,h);break;case 32:d(f,h);break}let l=0;s.forEach(h=>l+=h);function o(h){const i=[];return h.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:o(v),amdInvoke:o(N),nodeRequire:o(s),nodeEval:o(f),nodeRequireTotal:l}}static toMarkdownTable(v,N){let s="";const f=[];return v.forEach((t,d)=>{f[d]=t.length}),N.forEach(t=>{t.forEach((d,$)=>{typeof d>"u"&&(d=t[$]="-");const l=d.toString().length;f[$]=Math.max(l,f[$])})}),v.forEach((t,d)=>{s+=`| ${t+" ".repeat(f[d]-t.toString().length)} `}),s+=`|
`,v.forEach((t,d)=>{s+=`| ${"-".repeat(f[d])} `}),s+=`|
`,N.forEach(t=>{t.forEach((d,$)=>{typeof d<"u"&&(s+=`| ${d+" ".repeat(f[$]-d.toString().length)} `)}),s+=`|
`}),s}}e.$U=P}),define(G[4],H([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=void 0;let P;function T(n){P=n}e.$td=T;function v(){return P}e.$ud=v;class N{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([f(h("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[f(" "),d($(r.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),d($(r.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),d($(r.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(r,m){console.log(...this.b([t("observable value changed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m)]))}formatChanges(r){if(r.size!==0)return d(" (changed deps: "+[...r].map(m=>m.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(k,M)=>(this.d.get(r).add(k),m.apply(r,[k,M]))}handleDerivedRecomputed(r,m){const k=this.d.get(r);console.log(...this.b([t("derived recomputed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),this.formatChanges(k),{data:[{fn:r._computeFn}]}])),k.clear()}handleFromEventObservableTriggered(r,m){console.log(...this.b([t("observable from event triggered"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(k,M)=>(this.d.get(r).add(k),m.apply(r,[k,M]))}handleAutorunTriggered(r){const m=this.d.get(r);console.log(...this.b([t("autorun"),d(r.debugName,{color:"BlueViolet"}),this.formatChanges(m),{data:[{fn:r._runFn}]}])),m.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let m=r.getDebugName();m===void 0&&(m=""),console.log(...this.b([t("transaction"),d(m,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$vd=N;function s(n){const r=new Array,m=[];let k="";function M(S){if("length"in S)for(const g of S)g&&M(g);else"text"in S?(k+=`%c${S.text}`,r.push(S.style),S.data&&m.push(...S.data)):"data"in S&&m.push(...S.data)}M(n);const L=[k,...r];return L.push(...m),L}function f(n){return d(n,{color:"black"})}function t(n){return d(i(`${n}: `,10),{color:"black",bold:!0})}function d(n,r={color:"black"}){function m(M){return Object.entries(M).reduce((L,[S,g])=>`${L}${S}:${g};`,"")}const k={color:r.color};return r.strikeThrough&&(k["text-decoration"]="line-through"),r.bold&&(k["font-weight"]="bold"),{text:n,style:m(k)}}function $(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?l(n,r):o(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function l(n,r){let m="[ ",k=!0;for(const M of n){if(k||(m+=", "),m.length-5>r){m+="...";break}k=!1,m+=`${$(M,r-m.length)}`}return m+=" ]",m}function o(n,r){let m="{ ",k=!0;for(const[M,L]of Object.entries(n)){if(k||(m+=", "),m.length-5>r){m+="...";break}k=!1,m+=`${M}: ${$(L,r-m.length)}`}return m+=" }",m}function h(n,r){let m="";for(let k=1;k<=r;k++)m+=n;return m}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(G[5],H([0,1,4]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=void 0;let T;function v(C){T=C}e.$Cd=v;let N;function s(C){N=C}e.$Dd=s;let f;function t(C){f=C}e.$Ed=t;class d{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,a){const A=a===void 0?void 0:b,F=a===void 0?b:a;return f({owner:A,debugName:()=>{const q=D(F);if(q!==void 0)return q;const p=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(F.toString());if(p)return`${this.debugName}.${p[2]}`;if(!A)return`${this.debugName} (mapped)`}},q=>F(this.read(q),q))}recomputeInitiallyAndOnChange(b,a){return b.add(T(this,a)),this}keepObserved(b){return b.add(N(this)),this}}e.$Fd=d;class $ extends d{constructor(){super(...arguments),this.c=new Set}addObserver(b){const a=this.c.size;this.c.add(b),a===0&&this.f()}removeObserver(b){this.c.delete(b)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Gd=$;function l(C,b){const a=new r(C,b);try{C(a)}finally{a.finish()}}e.$Hd=l;let o;function h(C){if(o)C(o);else{const b=new r(C,void 0);o=b;try{C(b)}finally{b.finish(),o=void 0}}}e.$Id=h;async function i(C,b){const a=new r(C,b);try{await C(a)}finally{a.finish()}}e.$Jd=i;function n(C,b,a){C?b(C):l(b,a)}e.$Kd=n;class r{constructor(b,a){this._fn=b,this.b=a,this.a=[],(0,P.$ud)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():D(this._fn)}updateObserver(b,a){this.a.push({observer:b,observable:a}),b.beginUpdate(a)}finish(){const b=this.a;for(let a=0;a<b.length;a++){const{observer:A,observable:F}=b[a];A.endUpdate(F)}this.a=null,(0,P.$ud)()?.handleEndTransaction()}}e.$Ld=r;const m=new Map,k=new WeakMap;function M(C,b,a,A){const F=k.get(C);if(F)return F;const q=L(C,b,a,A);if(q){let K=m.get(q)??0;K++,m.set(q,K);const p=K===1?q:`${q}#${K}`;return k.set(C,p),p}}e.$Md=M;function L(C,b,a,A){const F=k.get(C);if(F)return F;const q=A?y(A)+".":"";let K;if(b!==void 0)if(typeof b=="function"){if(K=b(),K!==void 0)return q+K}else return q+b;if(a!==void 0&&(K=D(a),K!==void 0))return q+K;if(A!==void 0){for(const p in A)if(A[p]===C)return q+p}}const S=new Map,g=new WeakMap;function y(C){const b=g.get(C);if(b)return b;const a=O(C);let A=S.get(a)??0;A++,S.set(a,A);const F=A===1?a:`${a}#${A}`;return g.set(C,F),F}function O(C){const b=C.constructor;return b?b.name:"Object"}function D(C){const b=C.toString(),A=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(A?A[1]:void 0)?.trim()}e.$Nd=D;function U(C,b){return typeof C=="string"?new c(void 0,C,b):new c(C,void 0,b)}e.$Od=U;class c extends ${get debugName(){return M(this,this.d,void 0,this.b)??"ObservableValue"}constructor(b,a,A){super(),this.b=b,this.d=a,this.a=A}get(){return this.a}set(b,a,A){if(this.a===b)return;let F;a||(a=F=new r(()=>{},()=>`Setting ${this.debugName}`));try{const q=this.a;this.e(b),(0,P.$ud)()?.handleObservableChanged(this,{oldValue:q,newValue:b,change:A,didChange:!0,hadValue:!0});for(const K of this.c)a.updateObserver(K,this),K.handleChange(this,A)}finally{F&&F.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(b){this.a=b}}e.$Pd=c;function E(C,b){return typeof C=="string"?new j(void 0,C,b):new j(C,void 0,b)}e.$Qd=E;class j extends c{e(b){this.a!==b&&(this.a&&this.a.dispose(),this.a=b)}dispose(){this.a?.dispose()}}e.$Rd=j}),define(G[9],H([0,1,23,2,5,4]),function(W,e,P,T,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=void 0;function s(i){return new o(void 0,i,void 0,void 0)}e.$$c=s;function f(i,n){return new o(i.debugName,n,void 0,void 0)}e.$_c=f;function t(i,n){return new o(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$ad=t;function d(i,n){const r=new T.$Sc,m=t({debugName:i.debugName??(()=>(0,v.$Nd)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(k,M)=>{r.clear(),n(k,M,r)});return(0,T.$Rc)(()=>{m.dispose(),r.dispose()})}e.$bd=d;function $(i){const n=new T.$Sc,r=f({debugName:()=>(0,v.$Nd)(i)||"(anonymous)"},m=>{n.clear(),i(m,n)});return(0,T.$Rc)(()=>{r.dispose(),n.dispose()})}e.$cd=$;var l;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class o{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,v.$Nd)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,m,k){this.h=n,this._runFn=r,this.i=m,this.j=k,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,N.$ud)()?.handleAutorunCreated(this),this.k(),(0,T.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,N.$ud)()?.handleAutorunTriggered(this);const m=this.g;this.g=this.i?.(),this._runFn(this,m)}}finally{r||(0,N.$ud)()?.handleAutorunFinished(this);for(const m of this.f)m.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$9c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:k=>k===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$dd=o,function(i){i.Observer=o}(s||(e.$$c=s={}));function h(i,n){let r;return f({debugName:()=>(0,v.$Nd)(n)},m=>{const k=i.read(m),M=r;r=k,n({lastValue:M,newValue:k})})}e.$ed=h}),define(G[10],H([0,1,23,2,5,4]),function(W,e,P,T,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=void 0;const s=(i,n)=>i===n;function f(i,n){return n!==void 0?new h(i,void 0,n,void 0,void 0,void 0,s):new h(void 0,void 0,i,void 0,void 0,void 0,s)}e.$wd=f;function t(i,n){return new h(i.owner,i.debugName,n,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??s)}e.$xd=t;function d(i,n){return new h(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$yd=d;function $(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const k=new T.$Sc;return new h(m,()=>(0,v.$Nd)(r)??"(anonymous)",M=>(k.clear(),r(M,k)),void 0,void 0,()=>k.dispose(),s)}e.$zd=$;function l(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const k=new T.$Sc;return new h(m,()=>(0,v.$Nd)(r)??"(anonymous)",M=>{k.clear();const L=r(M);return L&&k.add(L),L},void 0,void 0,()=>k.dispose(),s)}e.$Ad=l,(0,v.$Ed)(t);var o;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class h extends v.$Gd{get debugName(){return(0,v.$Md)(this,this.p,this._computeFn,this.n)??"(anonymous)"}constructor(n,r,m,k,M,L=void 0,S){super(),this.n=n,this.p=r,this._computeFn=m,this.q=k,this.s=M,this.t=L,this.u=S,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,N.$ud)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,m=this.h;this.e=3;const k=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,k)}finally{for(const L of this.l)L.removeObserver(this);this.l.clear()}const M=r&&!this.u(m,this.h);if((0,N.$ud)()?.handleDerivedRecomputed(this,{oldValue:m,newValue:this.h,change:void 0,didChange:M,hadValue:r}),M)for(const L of this.c)L.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const m of this.c)m.handlePossibleChange(this);if(r)for(const m of this.c)m.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const m of r)m.endUpdate(this)}(0,P.$9c)(()=>this.j>=0)}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const m=this.s?this.s({changedObservable:n,change:r,didChange:M=>M===n},this.m):!0,k=this.e===3;if(m&&(this.e===1||k)&&(this.e=2,k))for(const M of this.c)M.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$Bd=h}),define(G[24],H([0,1,2,9,5,10,4]),function(W,e,P,T,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=void 0;function f(U){return new t(U)}e.$fd=f;class t extends v.$Fd{constructor(c){super(),this.a=c}get debugName(){return this.toString()}get(){return this.a}addObserver(c){}removeObserver(c){}toString(){return`Const: ${this.a}`}}function d(U){const c=(0,v.$Od)("promiseValue",{});return U.then(E=>{c.set({value:E},void 0)}),c}e.$gd=d;function $(U,c){return new Promise(E=>{let j=!1,C=!1;const b=U.map(A=>({isFinished:c(A),state:A})),a=(0,T.$$c)(A=>{const{isFinished:F,state:q}=b.read(A);F&&(j?a.dispose():C=!0,E(q))});j=!0,C&&a.dispose()})}e.$hd=$;function l(U,c){return new o(U,c)}e.$id=l;class o extends v.$Gd{constructor(c,E){super(),this.h=c,this._getValue=E,this.b=!1,this.l=j=>{const C=this._getValue(j),b=this.a,a=!this.b||b!==C;let A=!1;a&&(this.a=C,this.b&&(A=!0,(0,v.$Kd)(o.globalTransaction,F=>{(0,s.$ud)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b});for(const q of this.c)F.updateObserver(q,this),q.handleChange(this,void 0)},()=>{const F=this.j();return"Event fired"+(F?`: ${F}`:"")})),this.b=!0),A||(0,s.$ud)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b})}}j(){return(0,v.$Nd)(this._getValue)}get debugName(){const c=this.j();return"From Event"+(c?`: ${c}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$jd=o,function(U){U.Observer=o;function c(E,j){let C=!1;o.globalTransaction===void 0&&(o.globalTransaction=E,C=!0);try{j()}finally{C&&(o.globalTransaction=void 0)}}U.batchEventsGlobally=c}(l||(e.$id=l={}));function h(U,c){return new i(U,c)}e.$kd=h;class i extends v.$Gd{constructor(c,E){super(),this.debugName=c,this.b=E,this.h=()=>{(0,v.$Hd)(j=>{for(const C of this.c)j.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(U){return typeof U=="string"?new r(U):new r(void 0,U)}e.$ld=n;class r extends v.$Gd{get debugName(){return(0,v.$Md)(this,this.a,void 0,this.b)??"Observable Signal"}constructor(c,E){super(),this.a=c,this.b=E}trigger(c,E){if(!c){(0,v.$Hd)(j=>{this.trigger(j,E)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.c)c.updateObserver(j,this),j.handleChange(this,E)}get(){}}function m(U,c,E){const j=(0,v.$Od)("debounced",void 0);let C;return E.add((0,T.$$c)(b=>{const a=U.read(b);C&&clearTimeout(C),C=setTimeout(()=>{(0,v.$Hd)(A=>{j.set(a,A)})},c)})),j}e.$md=m;function k(U,c,E){const j=(0,v.$Od)("triggeredRecently",!1);let C;return E.add(U(()=>{j.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{j.set(!1,void 0)},c)})),j}e.$nd=k;function M(U){const c=new S(!1,void 0);return U.addObserver(c),(0,P.$Rc)(()=>{U.removeObserver(c)})}e.$od=M,(0,v.$Dd)(M);function L(U,c){const E=new S(!0,c);return U.addObserver(E),c?c(U.get()):U.reportChanges(),(0,P.$Rc)(()=>{U.removeObserver(E)})}e.$pd=L,(0,v.$Cd)(L);class S{constructor(c,E){this.b=c,this.c=E,this.a=0}beginUpdate(c){this.a++}endUpdate(c){this.a--,this.a===0&&this.b&&(this.c?this.c(c.get()):c.reportChanges())}handlePossibleChange(c){}handleChange(c,E){}}function g(U){let c;return(0,N.$wd)(j=>(c=U(j,c),c))}e.$qd=g;function y(U,c){let E;const j=(0,v.$Od)("derivedObservableWithWritableCache.counter",0),C=(0,N.$wd)(U,b=>(j.read(b),E=c(b,E),E));return Object.assign(C,{clearCache:b=>{E=void 0,j.set(j.get()+1,b)}})}e.$rd=y;function O(U,c,E,j){let C=new D(E,j);return(0,N.$xd)({debugName:()=>(0,v.$Md)(C,void 0,E,U),owner:U,onLastObserverRemoved:()=>{C.dispose(),C=new D(E)}},a=>(C.setItems(c.read(a)),C.getItems()))}e.$sd=O;class D{constructor(c,E){this.c=c,this.e=E,this.a=new Map,this.b=[]}dispose(){this.a.forEach(c=>c.store.dispose()),this.a.clear()}setItems(c){const E=[],j=new Set(this.a.keys());for(const C of c){const b=this.e?this.e(C):C;let a=this.a.get(b);if(a)j.delete(b);else{const A=new P.$Sc;a={out:this.c(C,A),store:A},this.a.set(b,a)}E.push(a.out)}for(const C of j)this.a.get(C).store.dispose(),this.a.delete(C);this.b=E}getItems(){return this.b}}}),define(G[11],H([0,1,5,10,9,24,4]),function(W,e,P,T,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Od}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Qd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Hd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Kd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$wd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$xd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$yd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$zd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$ed}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$ad}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$cd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$_c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$bd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return N.$fd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return N.$md}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return N.$qd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return N.$rd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return N.$od}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return N.$pd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return N.$id}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return N.$gd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return N.$ld}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return N.$kd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return N.$hd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return N.$nd}}),!1&&(0,s.$td)(new s.$vd)}),define(G[25],H([0,1,6,2]),function(W,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function v(L){const S=L;return S?typeof S.read=="function":!1}e.$8d=v;function N(L){const S=L;return S?[S.on,S.pause,S.resume,S.destroy].every(g=>typeof g=="function"):!1}e.$9d=N;function s(L){const S=L;return S?N(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$0d=s;function f(L,S){return new t(L,S)}e.$$d=f;class t{constructor(S,g){this.e=S,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(g=>g(S))}h(S){this.c.error.length===0?(0,P.$1)(S):this.c.error.slice(0).forEach(g=>g(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,g){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(S,g){if(this.a.destroyed)return;let y;switch(S){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const O=y.indexOf(g);O>=0&&y.splice(O,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(L,S){const g=[];let y;for(;(y=L.read())!==null;)g.push(y);return S(g)}e.$_d=d;function $(L,S,g){const y=[];let O;for(;(O=L.read())!==null&&y.length<g;)y.push(O);return O===null&&y.length>0?S(y):{read:()=>{if(y.length>0)return y.shift();if(typeof O<"u"){const D=O;return O=void 0,D}return L.read()}}}e.$ae=$;function l(L,S){return new Promise((g,y)=>{const O=[];o(L,{onData:D=>{S&&O.push(D)},onError:D=>{S?y(D):g(void 0)},onEnd:()=>{g(S?S(O):void 0)}})})}e.$be=l;function o(L,S,g){L.on("error",y=>{g?.isCancellationRequested||S.onError(y)}),L.on("end",()=>{g?.isCancellationRequested||S.onEnd()}),L.on("data",y=>{g?.isCancellationRequested||S.onData(y)})}e.$ce=o;function h(L,S){return new Promise((g,y)=>{const O=new T.$Sc,D=[],U=j=>{if(D.push(j),D.length>S)return O.dispose(),L.pause(),g({stream:L,buffer:D,ended:!1})},c=j=>(O.dispose(),y(j)),E=()=>(O.dispose(),g({stream:L,buffer:D,ended:!0}));O.add((0,T.$Rc)(()=>L.removeListener("error",c))),L.on("error",c),O.add((0,T.$Rc)(()=>L.removeListener("end",E))),L.on("end",E),O.add((0,T.$Rc)(()=>L.removeListener("data",U))),L.on("data",U)})}e.$de=h;function i(L,S){const g=f(S);return g.end(L),g}e.$ee=i;function n(){const L=f(()=>{throw new Error("not supported")});return L.end(),L}e.$fe=n;function r(L){let S=!1;return{read:()=>S?null:(S=!0,L)}}e.$ge=r;function m(L,S,g){const y=f(g);return o(L,{onData:O=>y.write(S.data(O)),onError:O=>y.error(S.error?S.error(O):O),onEnd:()=>y.end()}),y}e.$he=m;function k(L,S,g){let y=!1;return{read:()=>{const O=S.read();return y?O:(y=!0,O!==null?g([L,O]):L)}}}e.$ie=k;function M(L,S,g){let y=!1;const O=f(g);return o(S,{onData:D=>y?O.write(D):(y=!0,O.write(g([L,D]))),onError:D=>O.error(D),onEnd:()=>{y||(y=!0,O.write(L)),O.end()}}),O}e.$je=M}),define(G[12],H([0,1,26,25]),function(W,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const v=typeof Buffer<"u",N=new P.$V(()=>new Uint8Array(256));let s,f;class t{static alloc(a){return v?new t(Buffer.allocUnsafe(a)):new t(new Uint8Array(a))}static wrap(a){return v&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new t(a)}static fromString(a,A){return!(A?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(a)):(s||(s=new TextEncoder),new t(s.encode(a)))}static fromByteArray(a){const A=t.alloc(a.length);for(let F=0,q=a.length;F<q;F++)A.buffer[F]=a[F];return A}static concat(a,A){if(typeof A>"u"){A=0;for(let K=0,p=a.length;K<p;K++)A+=a[K].byteLength}const F=t.alloc(A);let q=0;for(let K=0,p=a.length;K<p;K++){const V=a[K];F.set(V,q),q+=V.byteLength}return F}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=t.alloc(this.byteLength);return a.set(this),a}toString(){return v?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,A){return new t(this.buffer.subarray(a,A))}set(a,A){if(a instanceof t)this.buffer.set(a.buffer,A);else if(a instanceof Uint8Array)this.buffer.set(a,A);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),A);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return o(this.buffer,a)}writeUInt32BE(a,A){h(this.buffer,a,A)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,A){n(this.buffer,a,A)}readUInt8(a){return r(this.buffer,a)}writeUInt8(a,A){m(this.buffer,a,A)}indexOf(a,A=0){return d(this.buffer,a instanceof t?a.buffer:a,A)}}e.$ke=t;function d(b,a,A=0){const F=a.byteLength,q=b.byteLength;if(F===0)return 0;if(F===1)return b.indexOf(a[0]);if(F>q-A)return-1;const K=N.value;K.fill(a.length);for(let J=0;J<a.length;J++)K[a[J]]=a.length-J-1;let p=A+a.length-1,V=p,_=-1;for(;p<q;)if(b[p]===a[V]){if(V===0){_=p;break}p--,V--}else p+=Math.max(a.length-V,K[b[p]]),V=a.length-1;return _}e.$le=d;function $(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0}e.$me=$;function l(b,a,A){b[A+0]=a&255,a=a>>>8,b[A+1]=a&255}e.$ne=l;function o(b,a){return b[a]*2**24+b[a+1]*2**16+b[a+2]*2**8+b[a+3]}e.$oe=o;function h(b,a,A){b[A+3]=a,a=a>>>8,b[A+2]=a,a=a>>>8,b[A+1]=a,a=a>>>8,b[A]=a}e.$pe=h;function i(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0|b[a+2]<<16>>>0|b[a+3]<<24>>>0}e.$qe=i;function n(b,a,A){b[A+0]=a&255,a=a>>>8,b[A+1]=a&255,a=a>>>8,b[A+2]=a&255,a=a>>>8,b[A+3]=a&255}e.$re=n;function r(b,a){return b[a]}e.$se=r;function m(b,a,A){b[A]=a}e.$te=m;function k(b){return T.$_d(b,a=>t.concat(a))}e.$ue=k;function M(b){return T.$ge(b)}e.$ve=M;function L(b){return T.$be(b,a=>t.concat(a))}e.$we=L;async function S(b){return b.ended?t.concat(b.buffer):t.concat([...b.buffer,await L(b.stream)])}e.$xe=S;function g(b){return T.$ee(b,a=>t.concat(a))}e.$ye=g;function y(b){return T.$he(b,{data:a=>typeof a=="string"?t.fromString(a):t.wrap(a)},a=>t.concat(a))}e.$ze=y;function O(b){return T.$$d(a=>t.concat(a),b)}e.$Ae=O;function D(b,a){return T.$ie(b,a,A=>t.concat(A))}e.$Be=D;function U(b,a){return T.$je(b,a,A=>t.concat(A))}e.$Ce=U;function c(b){let a=0,A=0,F=0;const q=new Uint8Array(Math.floor(b.length/4*3)),K=V=>{switch(A){case 3:q[F++]=a|V,A=0;break;case 2:q[F++]=a|V>>>2,a=V<<6,A=3;break;case 1:q[F++]=a|V>>>4,a=V<<4,A=2;break;default:a=V<<2,A=1}};for(let V=0;V<b.length;V++){const _=b.charCodeAt(V);if(_>=65&&_<=90)K(_-65);else if(_>=97&&_<=122)K(_-97+26);else if(_>=48&&_<=57)K(_-48+52);else if(_===43||_===45)K(62);else if(_===47||_===95)K(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${b[V]}`)}}const p=F;for(;A>0;)K(0);return t.wrap(q).slice(0,p)}e.$De=c;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:b},a=!0,A=!1){const F=A?j:E;let q="";const K=b.byteLength%3;let p=0;for(;p<b.byteLength-K;p+=3){const V=b[p+0],_=b[p+1],J=b[p+2];q+=F[V>>>2],q+=F[(V<<4|_>>>4)&63],q+=F[(_<<2|J>>>6)&63],q+=F[J&63]}if(K===1){const V=b[p+0];q+=F[V>>>2],q+=F[V<<4&63],a&&(q+="==")}else if(K===2){const V=b[p+0],_=b[p+1];q+=F[V>>>2],q+=F[(V<<4|_>>>4)&63],q+=F[_<<2&63],a&&(q+="=")}return q}e.$Ee=C}),define(G[27],H([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(G[13],H([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.StringEOL=void 0;var P;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function T(v){let N=0,s=0,f=0,t=0;for(let d=0,$=v.length;d<$;d++){const l=v.charCodeAt(d);l===13?(N===0&&(s=d),N++,d+1<$&&v.charCodeAt(d+1)===10?(t|=2,d++):t|=3,f=d+1):l===10&&(t|=1,N===0&&(s=d),N++,f=d+1)}return N===0&&(s=v.length),[N,s,v.length-f,t]}e.$xt=T}),define(G[14],H([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var N;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(N||(e.StandardTokenType=N={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class f{static getLanguageId(d){return(d&255)>>>0}static getTokenType(d){return(d&768)>>>8}static containsBalancedBrackets(d){return(d&1024)!==0}static getFontStyle(d){return(d&30720)>>>11}static getForeground(d){return(d&16744448)>>>15}static getBackground(d){return(d&4278190080)>>>24}static getClassNameFromMetadata(d){let l="mtk"+this.getForeground(d);const o=this.getFontStyle(d);return o&1&&(l+=" mtki"),o&2&&(l+=" mtkb"),o&4&&(l+=" mtku"),o&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(d,$){const l=this.getForeground(d),o=this.getFontStyle(d);let h=`color: ${$[l]};`;o&1&&(h+="font-style: italic;"),o&2&&(h+="font-weight: bold;");let i="";return o&4&&(i+=" underline"),o&8&&(i+=" line-through"),i&&(h+=`text-decoration:${i};`),h}static getPresentationFromMetadata(d){const $=this.getForeground(d),l=this.getFontStyle(d);return{foreground:$,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$vt=f}),define(G[28],H([0,1,29]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=void 0;class T{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,f){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=f}replace(s,f,t){if(s>=this.a.length)return;if(f===0){this.insert(s,t);return}else if(t===0){this.delete(s,f);return}const d=this.a.slice(0,s),$=this.a.slice(s+f),l=v(t,this.b);this.a=d.concat(l,$)}delete(s,f){f===0||s>=this.a.length||this.a.splice(s,f)}insert(s,f){if(f===0||s>=this.a.length)return;const t=[];for(let d=0;d<f;d++)t[d]=this.b;this.a=(0,P.$Wb)(this.a,s,t)}}e.$jC=T;function v(N,s){const f=[];for(let t=0;t<N;t++)f[t]=s;return f}}),define(G[7],H([0,1,14]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0;class T{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(s,f){const t=T.defaultTokenMetadata,d=new Uint32Array(2);return d[0]=s.length,d[1]=t,new T(d,s,f)}constructor(s,f,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(s){return s instanceof T?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,f,t){if(this.c!==s.c||this.b!==s.b)return!1;const d=f<<1,$=d+(t<<1);for(let l=d;l<$;l++)if(this.a[l]!==s.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const f=this.a[(s<<1)+1],t=P.$vt.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const f=this.a[(s<<1)+1];return P.$vt.getTokenType(f)}getForeground(s){const f=this.a[(s<<1)+1];return P.$vt.getForeground(f)}getClassName(s){const f=this.a[(s<<1)+1];return P.$vt.getClassNameFromMetadata(f)}getInlineStyle(s,f){const t=this.a[(s<<1)+1];return P.$vt.getInlineStyleFromMetadata(t,f)}getPresentation(s){const f=this.a[(s<<1)+1];return P.$vt.getPresentationFromMetadata(f)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return T.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,f,t){return new v(this,s,f,t)}static convertToEndOffset(s,f){const d=(s.length>>>1)-1;for(let $=0;$<d;$++)s[$<<1]=s[$+1<<1];s[d<<1]=f}static findIndexInTokensArray(s,f){if(s.length<=2)return 0;let t=0,d=(s.length>>>1)-1;for(;t<d;){const $=t+Math.floor((d-t)/2),l=s[$<<1];if(l===f)return $+1;l<f?t=$+1:l>f&&(d=$)}return t}withInserted(s){if(s.length===0)return this;let f=0,t=0,d="";const $=new Array;let l=0;for(;;){const o=f<this.b?this.a[f<<1]:-1,h=t<s.length?s[t]:null;if(o!==-1&&(h===null||o<=h.offset)){d+=this.c.substring(l,o);const i=this.a[(f<<1)+1];$.push(d.length,i),f++,l=o}else if(h){if(h.offset>l){d+=this.c.substring(l,h.offset);const i=this.a[(f<<1)+1];$.push(d.length,i),l=h.offset}d+=h.text,$.push(d.length,h.tokenMetadata),t++}else break}return new T(new Uint32Array($),d,this.d)}}e.$yt=T;class v{constructor(s,f,t,d){this.a=s,this.b=f,this.c=t,this.d=d,this.e=s.findTokenIndexAtOffset(f),this.f=0;for(let $=this.e,l=s.getCount();$<l&&!(s.getStartOffset($)>=t);$++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof v?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const f=this.a.getEndOffset(this.e+s);return Math.min(this.c,f)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,f){return this.a.getInlineStyle(this.e+s,f)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(G[30],H([0,1,7]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.$zt=void 0,e.$zt=new Uint32Array(0).buffer;class T{static deleteBeginning(s,f){return s===null||s===e.$zt?s:T.delete(s,0,f)}static deleteEnding(s,f){if(s===null||s===e.$zt)return s;const t=v(s),d=t[t.length-2];return T.delete(s,f,d)}static delete(s,f,t){if(s===null||s===e.$zt||f===t)return s;const d=v(s),$=d.length>>>1;if(f===0&&d[d.length-2]===t)return e.$zt;const l=P.$yt.findIndexInTokensArray(d,f),o=l>0?d[l-1<<1]:0,h=d[l<<1];if(t<h){const k=t-f;for(let M=l;M<$;M++)d[M<<1]-=k;return s}let i,n;o!==f?(d[l<<1]=f,i=l+1<<1,n=f):(i=l<<1,n=o);const r=t-f;for(let k=l+1;k<$;k++){const M=d[k<<1]-r;M>n&&(d[i++]=M,d[i++]=d[(k<<1)+1],n=M)}if(i===d.length)return s;const m=new Uint32Array(i);return m.set(d.subarray(0,i),0),m.buffer}static append(s,f){if(f===e.$zt)return s;if(s===e.$zt)return f;if(s===null)return s;if(f===null)return null;const t=v(s),d=v(f),$=d.length>>>1,l=new Uint32Array(t.length+d.length);l.set(t,0);let o=t.length;const h=t[t.length-2];for(let i=0;i<$;i++)l[o++]=d[i<<1]+h,l[o++]=d[(i<<1)+1];return l.buffer}static insert(s,f,t){if(s===null||s===e.$zt)return s;const d=v(s),$=d.length>>>1;let l=P.$yt.findIndexInTokensArray(d,f);l>0&&d[l-1<<1]===f&&l--;for(let o=l;o<$;o++)d[o<<1]+=t;return s}}e.$At=T;function v(N){return N instanceof Uint32Array?N:new Uint32Array(N)}e.$Bt=v}),define(G[31],H([0,1,29,12,44,13,30,15]),function(W,e,P,T,v,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=void 0;class t{static deserialize($,l,o){const h=new Uint32Array($.buffer),i=(0,T.$oe)($,l);l+=4;const n=(0,T.$oe)($,l);l+=4;const r=[];for(let m=0;m<n;m++){const k=(0,T.$oe)($,l);l+=4,r.push(h.subarray(l/4,l/4+k/4)),l+=k}return o.push(new t(i,r)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,l){this.a=$,this.b=l}getLineRange(){return new f.$7s(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let l=0;l<this.b.length;l++){const o=this.b[l];if(!(o instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=o.byteLength}return $}serialize($,l){(0,T.$pe)($,this.a,l),l+=4,(0,T.$pe)($,this.b.length,l),l+=4;for(let o=0;o<this.b.length;o++){const h=this.b[o];if(!(h instanceof Uint32Array))throw new Error("Not supported!");(0,T.$pe)($,h.byteLength,l),l+=4,$.set(new Uint8Array(h.buffer),l),l+=h.byteLength}return l}applyEdit($,l){const[o,h]=(0,N.$xt)(l);this.c($),this.d(new v.$Ws($.startLineNumber,$.startColumn),o,h)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const l=$.startLineNumber-this.a,o=$.endLineNumber-this.a;if(o<0){const h=o-l;this.a-=h;return}if(!(l>=this.b.length)){if(l<0&&o>=this.b.length){this.a=0,this.b=[];return}if(l===o){this.b[l]=s.$At.delete(this.b[l],$.startColumn-1,$.endColumn-1);return}if(l>=0)if(this.b[l]=s.$At.deleteEnding(this.b[l],$.startColumn-1),o<this.b.length){const h=s.$At.deleteBeginning(this.b[o],$.endColumn-1);this.b[l]=s.$At.append(this.b[l],h),this.b.splice(l+1,o-l)}else this.b[l]=s.$At.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const h=-l;this.a-=h,this.b[o]=s.$At.deleteBeginning(this.b[o],$.endColumn-1),this.b=this.b.slice(o)}}}d($,l,o){if(l===0&&o===0)return;const h=$.lineNumber-this.a;if(h<0){this.a+=l;return}if(!(h>=this.b.length)){if(l===0){this.b[h]=s.$At.insert(this.b[h],$.column-1,o);return}this.b[h]=s.$At.deleteEnding(this.b[h],$.column-1),this.b[h]=s.$At.insert(this.b[h],$.column-1,o),this.e($.lineNumber,l)}}e($,l){if(l===0)return;const o=[];for(let h=0;h<l;h++)o[h]=null;this.b=P.$Wb(this.b,$,o)}}e.$Ct=t}),define(G[16],H([0,1,12,31]),function(W,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=void 0;class v{static deserialize(s){let f=0;const t=(0,P.$oe)(s,f);f+=4;const d=[];for(let $=0;$<t;$++)f=T.$Ct.deserialize(s,f,d);return d}constructor(){this.a=[]}add(s,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(f);return}}this.a.push(new T.$Ct(s,[f]))}finalize(){return this.a}serialize(){const s=this.b(),f=new Uint8Array(s);return this.c(f),f}b(){let s=0;s+=4;for(let f=0;f<this.a.length;f++)s+=this.a[f].serializeSize();return s}c(s){let f=0;(0,P.$pe)(s,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(s,f)}}e.$kC=v}),define(G[32],H([0,1,33,3,17,45]),function(W,e,P,T,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=void 0;function s(c){return c===47||c===92}e.$3f=s;function f(c){return c.replace(/[\\/]/g,P.$gc.sep)}e.$4f=f;function t(c){return c.indexOf("/")===-1&&(c=f(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$5f=t;function d(c,E=P.$gc.sep){if(!c)return"";const j=c.length,C=c.charCodeAt(0);if(s(C)){if(s(c.charCodeAt(1))&&!s(c.charCodeAt(2))){let a=3;const A=a;for(;a<j&&!s(c.charCodeAt(a));a++);if(A!==a&&!s(c.charCodeAt(a+1))){for(a+=1;a<j;a++)if(s(c.charCodeAt(a)))return c.slice(0,a+1).replace(/[\\/]/g,E)}}return E}else if(m(C)&&c.charCodeAt(1)===58)return s(c.charCodeAt(2))?c.slice(0,2)+E:c.slice(0,2);let b=c.indexOf("://");if(b!==-1){for(b+=3;b<j;b++)if(s(c.charCodeAt(b)))return c.slice(0,b+1)}return""}e.$6f=d;function $(c){if(!T.$i||!c||c.length<5)return!1;let E=c.charCodeAt(0);if(E!==92||(E=c.charCodeAt(1),E!==92))return!1;let j=2;const C=j;for(;j<c.length&&(E=c.charCodeAt(j),E!==92);j++);return!(C===j||(E=c.charCodeAt(j+1),isNaN(E)||E===92))}e.$7f=$;const l=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(c,E=T.$i){const j=E?l:o;return!(!c||c.length===0||/^\s+$/.test(c)||(j.lastIndex=0,j.test(c))||E&&h.test(c)||c==="."||c===".."||E&&c[c.length-1]==="."||E&&c.length!==c.trim().length||c.length>255)}e.$8f=i;function n(c,E,j){const C=c===E;return!j||C?C:!c||!E?!1:(0,v.$bf)(c,E)}e.$9f=n;function r(c,E,j,C=P.sep){if(c===E)return!0;if(!c||!E||E.length>c.length)return!1;if(j){if(!(0,v.$cf)(c,E))return!1;if(E.length===c.length)return!0;let a=E.length;return E.charAt(E.length-1)===C&&a--,c.charAt(a)===C}return E.charAt(E.length-1)!==C&&(E+=C),c.indexOf(E)===0}e.$0f=r;function m(c){return c>=65&&c<=90||c>=97&&c<=122}e.$$f=m;function k(c,E){return T.$i&&c.endsWith(":")&&(c+=P.sep),(0,P.$ic)(c)||(c=(0,P.$jc)(E,c)),c=(0,P.$hc)(c),T.$i?(c=(0,v.$Ve)(c,P.sep),c.endsWith(":")&&(c+=P.sep)):(c=(0,v.$Ve)(c,P.sep),c||(c=P.sep)),c}e.$_f=k;function M(c){const E=(0,P.$hc)(c);return T.$i?c.length>3?!1:L(E)&&(c.length===2||E.charCodeAt(2)===92):E===P.$gc.sep}e.$ag=M;function L(c,E=T.$i){return E?m(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$bg=L;function S(c,E=T.$i){return L(c,E)?c[0]:void 0}e.$cg=S;function g(c,E,j){return E.length>c.length?-1:c===E?0:(j&&(c=c.toLowerCase(),E=E.toLowerCase()),c.indexOf(E))}e.$dg=g;function y(c){const E=c.split(":");let j,C,b;for(const a of E){const A=Number(a);(0,N.$Of)(A)?C===void 0?C=A:b===void 0&&(b=A):j=j?[j,a].join(":"):a}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:C!==void 0?C:void 0,column:b!==void 0?b:C!==void 0?1:void 0}}e.$eg=y;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(c,E,j=8){let C="";for(let a=0;a<j;a++){let A;a===0&&T.$i&&!E&&(j===3||j===4)?A=D:A=O,C+=A.charAt(Math.floor(Math.random()*A.length))}let b;return E?b=`${E}-${C}`:b=C,c?(0,P.$jc)(c,b):b}e.$fg=U}),define(G[18],H([0,1,6,3,17,8]),function(W,e,P,T,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.Schemas=void 0;var s;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function f(o,h){return N.URI.isUri(o)?(0,v.$bf)(o.scheme,h):(0,v.$cf)(o,h+":")}e.$gg=f;function t(o,...h){return h.some(i=>f(o,i))}e.$hg=t,e.$ig="vscode-tkn",e.$jg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${s.vscodeRemoteResource}`}set(h,i,n){this.a[h]=i,this.b[h]=n}setConnectionToken(h,i){this.c[h]=i}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(M){return P.$1(M),h}const i=h.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],m=this.c[i];let k=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(k+=`&${e.$jg}=${encodeURIComponent(m)}`),N.URI.from({scheme:T.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:k})}}e.$kg=new d,e.$lg="vs/../../extensions",e.$mg="vs/../../node_modules",e.$ng="vs/../../node_modules.asar",e.$og="vs/../../node_modules.asar.unpacked",e.$pg="vscode-app";class ${static{this.a=e.$pg}asBrowserUri(h){const i=this.b(h,W);return this.uriToBrowserUri(i)}uriToBrowserUri(h){return h.scheme===s.vscodeRemote?e.$kg.rewrite(h):h.scheme===s.file&&(T.$m||T.$q===`${s.vscodeFileResource}://${$.a}`)?h.with({scheme:s.vscodeFileResource,authority:h.authority||$.a,query:null,fragment:null}):h}asFileUri(h){const i=this.b(h,W);return this.uriToFileUri(i)}uriToFileUri(h){return h.scheme===s.vscodeFileResource?h.with({scheme:s.file,authority:h.authority!==$.a?h.authority:null,query:null,fragment:null}):h}b(h,i){return N.URI.isUri(h)?h:N.URI.parse(i.toUrl(h))}}e.$qg=new $;var l;(function(o){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(h.get("3"));const i="vscode-coi";function n(m){let k;typeof m=="string"?k=new URL(m).searchParams:m instanceof URL?k=m.searchParams:N.URI.isUri(m)&&(k=new URL(m.toString(!0)).searchParams);const M=k?.get(i);if(M)return h.get(M)}o.getHeadersFromQuery=n;function r(m,k,M){if(!globalThis.crossOriginIsolated)return;const L=k&&M?"3":M?"2":"1";m instanceof URLSearchParams?m.set(i,L):m[i]=L}o.addSearchParam=r})(l||(e.COI=l={}))}),define(G[34],H([0,1,22,18,3,8]),function(W,e,P,T,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=void 0;class s{constructor(o,h,i){this.id=o,this.dependencies=h,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(o,h,i)=>{typeof o!="string"&&(i=h,h=o,o=null),(typeof h!="object"||!Array.isArray(h))&&(i=h,h=null),this.c.push(new s(o,h,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){if(o.startsWith(window.location.origin)||o.startsWith("vscode-file://vscode-app"))return o;throw new Error(`[trusted_script_src] Invalid script url: ${o}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){return o}})))}async load(o){this.g();const h=await(this.a?this.i(o):this.b?this.h(o):this.j(o));if(!h)throw new Error(`Did not receive a define call from script ${o}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${o}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(o){return new Promise((h,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",m),n.removeEventListener("error",k)},m=M=>{r(),h(this.c.pop())},k=M=>{r(),i(M)};n.addEventListener("load",m),n.addEventListener("error",k),this.f&&(o=this.f.createScriptURL(o)),n.setAttribute("src",o),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(o){return new Promise((h,i)=>{try{this.f&&(o=this.f.createScriptURL(o)),importScripts(o),h(this.c.pop())}catch(n){i(n)}})}async j(o){try{const h=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=N.URI.parse(o).fsPath,m=h.readFileSync(r).toString(),k=n.wrap(m.replace(/^#!.*/,""));return new i.Script(k).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const t=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function $(l,o,h){if(P.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[l]&&(l=d[l]);const i=`${l}/${o}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const M=`${h&&!v.$o?T.$ng:T.$mg}/${i}`;n=T.$qg.asBrowserUri(M).toString(!0)}const r=f.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{W([l],i,n)})}e.$kD=$}),define(G[19],H([0,1,32,18,33,3,17,8]),function(W,e,P,T,v,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.DataUri=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=void 0;function t(h){return(0,f.$wc)(h,!0)}e.$xg=t;class d{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$7e)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return P.$0f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Og)(i.authority,n.authority))return P.$0f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Gg)(i)||i.authority}basename(i){return v.$gc.basename(i.path)}extname(i){return v.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=f.URI.file(v.$mc(t(i))).path:(n=v.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=f.URI.file(v.$hc(t(i))).path:n=v.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Og)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const k=v.$lc(t(i),t(n));return N.$i?P.$4f(k):k}let r=i.path||"/";const m=n.path||"/";if(this.a(i)){let k=0;for(const M=Math.min(r.length,m.length);k<M&&!(r.charCodeAt(k)!==m.charCodeAt(k)&&r.charAt(k).toLowerCase()!==m.charAt(k).toLowerCase());k++);r=m.substr(0,k)+r.substr(k)}return v.$gc.relative(r,m)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const r=f.URI.file(v.$kc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=P.$5f(n),i.with({path:v.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$bf)(i,n)}hasTrailingPathSeparator(i,n=v.sep){if(i.scheme===T.Schemas.file){const r=t(i);return r.length>P.$6f(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=v.sep){return(0,e.$Pg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=v.sep){let r=!1;if(i.scheme===T.Schemas.file){const m=t(i);r=m!==void 0&&m.length===P.$6f(m).length&&m[m.length-1]===n}else{n="/";const m=i.path;r=m.length===1&&m.charCodeAt(m.length-1)===47}return!r&&!(0,e.$Pg)(i,n)?i.with({path:i.path+"/"}):i}}e.$yg=d,e.$zg=new d(()=>!1),e.$Ag=new d(h=>h.scheme===T.Schemas.file?!N.$k:!0),e.$Bg=new d(h=>!0),e.$Cg=e.$zg.isEqual.bind(e.$zg),e.$Dg=e.$zg.isEqualOrParent.bind(e.$zg),e.$Eg=e.$zg.getComparisonKey.bind(e.$zg),e.$Fg=e.$zg.basenameOrAuthority.bind(e.$zg),e.$Gg=e.$zg.basename.bind(e.$zg),e.$Hg=e.$zg.extname.bind(e.$zg),e.$Ig=e.$zg.dirname.bind(e.$zg),e.$Jg=e.$zg.joinPath.bind(e.$zg),e.$Kg=e.$zg.normalizePath.bind(e.$zg),e.$Lg=e.$zg.relativePath.bind(e.$zg),e.$Mg=e.$zg.resolvePath.bind(e.$zg),e.$Ng=e.$zg.isAbsolutePath.bind(e.$zg),e.$Og=e.$zg.isEqualAuthority.bind(e.$zg),e.$Pg=e.$zg.hasTrailingPathSeparator.bind(e.$zg),e.$Qg=e.$zg.removeTrailingPathSeparator.bind(e.$zg),e.$Rg=e.$zg.addTrailingPathSeparator.bind(e.$zg);function $(h,i){const n=[];for(let r=0;r<h.length;r++){const m=i(h[r]);h.some((k,M)=>M===r?!1:(0,e.$Dg)(m,i(k)))||n.push(h[r])}return n}e.$Sg=$;var l;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(M=>{const[L,S]=M.split(":");L&&S&&r.set(L,S)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&r.set(h.META_DATA_MIME,k),r}h.parseMetaData=i})(l||(e.DataUri=l={}));function o(h,i,n){if(i){let r=h.path;return r&&r[0]!==v.$gc.sep&&(r=v.$gc.sep+r),h.with({scheme:n,authority:i,path:r})}return h.with({scheme:n})}e.$Tg=o}),define(G[20],H([0,1,46,6,35,2,19,3,27,26]),function(W,e,P,T,v,N,s,f,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.Promises=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=void 0;function $(R){return!!R&&typeof R.then=="function"}e.$Ug=$;function l(R){const u=new P.$7d,w=R(u.token),I=new Promise((z,B)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),B(new T.$5)});Promise.resolve(w).then(Q=>{Y.dispose(),u.dispose(),z(Q)},Q=>{Y.dispose(),u.dispose(),B(Q)})});return new class{cancel(){u.cancel(),u.dispose()}then(z,B){return I.then(z,B)}catch(z){return this.then(void 0,z)}finally(z){return I.finally(z)}}}e.$Vg=l;function o(R,u,w){return new Promise((I,z)=>{const B=u.onCancellationRequested(()=>{B.dispose(),I(w)});R.then(I,z).finally(()=>B.dispose())})}e.$Wg=o;function h(R,u){return new Promise((w,I)=>{const z=u.onCancellationRequested(()=>{z.dispose(),I(new T.$5)});R.then(w,I).finally(()=>z.dispose())})}e.$Xg=h;async function i(R){let u=-1;const w=R.map((I,z)=>I.then(B=>(u=z,B)));try{return await Promise.race(w)}finally{R.forEach((I,z)=>{z!==u&&I.cancel()})}}e.$Yg=i;function n(R,u,w){let I;const z=setTimeout(()=>{I?.(void 0),w?.()},u);return Promise.race([R.finally(()=>clearTimeout(z)),new Promise(B=>I=B)])}e.$Zg=n;function r(R){return new Promise((u,w)=>{const I=R();$(I)?I.then(u,w):u(I)})}e.$1g=r;function m(){let R,u;return{promise:new Promise((I,z)=>{R=I,u=z}),resolve:R,reject:u}}e.$2g=m;class k{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const w=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(w,w).then(I)})}return new Promise((w,I)=>{this.b.then(w,I)})}return this.a=u(),new Promise((w,I)=>{this.a.then(z=>{this.a=null,w(z)},z=>{this.a=null,I(z)})})}dispose(){this.f=!0}}e.$3g=k;class M{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$4g=M;class L{constructor(){this.a=new Map}queue(u,w){const z=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(u)===z&&this.a.delete(u)});return this.a.set(u,z),z}}e.$5g=L;const S=(R,u)=>{let w=!0;const I=setTimeout(()=>{w=!1,u()},R);return{isTriggered:()=>w,dispose:()=>{clearTimeout(I),w=!1}}},g=R=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,R())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class y{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,w=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((z,B)=>{this.d=z,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const z=this.g;return this.g=null,z()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=w===t.$Td?g(I):S(w,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$6g=y;class O{constructor(u){this.a=new y(u),this.b=new k}trigger(u,w){return this.a.trigger(()=>this.b.queue(u),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$7g=O;class D{constructor(){this.a=!1,this.b=new Promise((u,w)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$8g=D;class U extends D{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$9g=U;function c(R,u){return u?new Promise((w,I)=>{const z=setTimeout(()=>{B.dispose(),w()},R),B=u.onCancellationRequested(()=>{clearTimeout(z),B.dispose(),I(new T.$5)})}):l(w=>c(R,w))}e.$0g=c;function E(R,u=0,w){const I=setTimeout(()=>{R(),w&&z.dispose()},u),z=(0,N.$Rc)(()=>{clearTimeout(I),w?.deleteAndLeak(z)});return w?.add(z),z}e.$$g=E;function j(R){const u=[];let w=0;const I=R.length;function z(){return w<I?R[w++]():null}function B(Y){Y!=null&&u.push(Y);const Q=z();return Q?Q.then(B):Promise.resolve(u)}return Promise.resolve(null).then(B)}e.$_g=j;function C(R,u=I=>!!I,w=null){let I=0;const z=R.length,B=()=>{if(I>=z)return Promise.resolve(w);const Y=R[I++];return Promise.resolve(Y()).then(X=>u(X)?Promise.resolve(X):B())};return B()}e.$ah=C;function b(R,u=I=>!!I,w=null){if(R.length===0)return Promise.resolve(w);let I=R.length;const z=()=>{I=-1;for(const B of R)B.cancel?.()};return new Promise((B,Y)=>{for(const Q of R)Q.then(X=>{--I>=0&&u(X)?(z(),B(X)):I===0&&B(w)}).catch(X=>{--I>=0&&(z(),Y(X))})})}e.$bh=b;class a{constructor(u){this.a=0,this.b=!1,this.f=u,this.g=[],this.d=0,this.h=new v.$Wd}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(u){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,I)=>{this.g.push({factory:u,c:w,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const u=this.g.shift();this.d++;const w=u.factory();w.then(u.c,u.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ch=a;class A extends a{constructor(){super(1)}}e.$dh=A;class F{constructor(){this.a=new te,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$eh=F;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueSize(u,w=s.$zg){const I=w.getComparisonKey(u);return this.a.get(I)?.size??0}queueFor(u,w,I=s.$zg){const z=I.getComparisonKey(u);let B=this.a.get(z);if(!B){B=new A;const Y=this.f++,Q=v.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(z),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(Y,Q),this.a.set(z,B)}return B.queue(w)}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$fh=q;class K{constructor(u,w){this.a=-1,typeof u=="function"&&typeof w=="number"&&this.setIfNotSet(u,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},w)}setIfNotSet(u,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},w))}}e.$gh=K;class p{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,w,I=globalThis){this.cancel();const z=I.setInterval(()=>{u()},w);this.d=(0,N.$Rc)(()=>{I.clearInterval(z),this.d=void 0})}dispose(){this.cancel()}}e.$hh=p;class V{constructor(u,w){this.b=-1,this.a=u,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$ih=V;class _{constructor(u,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=u,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$jh=_;class J extends V{constructor(u,w){super(u,w),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$kh=J;class he extends N.$Tc{constructor(u,w){super(),this.g=u,this.h=w,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of u)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$lh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$nh=(R,u)=>{(0,f.$B)(()=>{if(w)return;const I=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:e.$nh=(R,u,w)=>{const I=R.requestIdleCallback(u,typeof w=="number"?{timeout:w}:void 0);let z=!1;return{dispose(){z||(z=!0,R.cancelIdleCallback(I))}}},e.$mh=R=>(0,e.$nh)(globalThis,R)}();class ee{constructor(u,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,e.$nh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$oh=ee;class oe extends ee{constructor(u){super(globalThis,u)}}e.$ph=oe;async function ue(R,u,w){let I;for(let z=0;z<w;z++)try{return await R()}catch(B){I=B,await c(u)}throw I}e.$qh=ue;class te{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,w,I){return this.a={taskId:u,cancel:()=>I?.(),promise:w},w.then(()=>this.d(u),()=>this.d(u)),w}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{const{promise:w,resolve:I,reject:z}=m();this.b={run:u,promise:w,promiseResolve:I,promiseReject:z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$rh=te;class ce{constructor(u,w=()=>Date.now()){this.d=u,this.f=w,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$sh=ce;var ne;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,w)=>{this.a=u,this.b=w})}complete(u){return new Promise(w=>{this.a(u),this.d={outcome:0,value:u},w()})}error(u){return new Promise(w=>{this.b(u),this.d={outcome:1,value:u},w()})}cancel(){return this.error(new T.$5)}}e.$th=x;var ie;(function(R){async function u(I){let z;const B=await Promise.all(I.map(Y=>Y.then(Q=>Q,Q=>{z||(z=Q)})));if(typeof z<"u")throw z;return B}R.settled=u;function w(I){return new Promise(async(z,B)=>{try{await I(z,B)}catch(Y){B(Y)}})}R.withAsyncBody=w})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$uh=se;class de{constructor(u){this.b=u,this.a=new d.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$vh=de;var re;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(re||(re={}));class Z{static fromArray(u){return new Z(w=>{w.emitMany(u)})}static fromPromise(u){return new Z(async w=>{w.emitMany(await u)})}static fromPromises(u){return new Z(async w=>{await Promise.all(u.map(async I=>w.emitOne(await I)))})}static merge(u){return new Z(async w=>{await Promise.all(u.map(async I=>{for await(const z of I)w.emitOne(z)}))})}static{this.EMPTY=Z.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$Wd,queueMicrotask(async()=>{const w={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(u(w)),this.j()}catch(I){this.k(I)}finally{w.emitOne=void 0,w.emitMany=void 0,w.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,w){return new Z(async I=>{for await(const z of u)I.emitOne(w(z))})}map(u){return Z.map(this,u)}static filter(u,w){return new Z(async I=>{for await(const z of u)w(z)&&I.emitOne(z)})}filter(u){return Z.filter(this,u)}static coalesce(u){return Z.filter(u,w=>!!w)}coalesce(){return Z.coalesce(this)}static async toPromise(u){const w=[];for await(const I of u)w.push(I);return w}toPromise(){return Z.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$wh=Z;class ae extends Z{constructor(u,w){super(w),this.l=u}cancel(){this.l.cancel()}}e.$xh=ae;function le(R){const u=new P.$7d,w=R(u.token);return new ae(u,async I=>{const z=u.token.onCancellationRequested(()=>{z.dispose(),u.dispose(),I.reject(new T.$5)});try{for await(const B of w){if(u.token.isCancellationRequested)return;I.emitOne(B)}z.dispose(),u.dispose()}catch(B){z.dispose(),u.dispose(),I.reject(B)}})}e.$yh=le;class fe{constructor(){this.a=new x,this.b=new Z(I=>{if(u){I.reject(u);return}return w&&I.emitMany(w),this.d=z=>I.reject(z),this.f=z=>I.emitOne(z),this.a.p});let u,w;this.f=I=>{w||(w=[]),w.push(I)},this.d=I=>{u||(u=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$zh=fe}),define(G[21],H([0,1,36]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=e.$hC=e.$gC=void 0,e.$gC=new class{clone(){return this}equals(N){return this===N}};function T(N,s){return new P.$Gt([new P.$Ft(0,"",N)],s)}e.$hC=T;function v(N,s){const f=new Uint32Array(2);return f[0]=0,f[1]=(N<<0|0|0|32768|2<<24)>>>0,new P.$Ht(f,s===null?e.$gC:s)}e.$iC=v}),define(G[37],H([0,1,20,6,3,38,13,15,47,21,28,16,7]),function(W,e,P,T,v,N,s,f,t,d,$,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=void 0;var h;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(h||(h={}));class i{constructor(g,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$lC=i;class n extends i{constructor(g,y,O,D){super(g,y),this._textModel=O,this._languageIdCodec=D}updateTokensUntilLine(g,y){const O=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>y)break;const U=this._textModel.getLineContent(D.lineNumber),c=M(this._languageIdCodec,O,this.tokenizationSupport,U,!0,D.startState);g.add(D.lineNumber,c.tokens),this.store.setEndState(D.lineNumber,c.endState)}}getTokenTypeIfInsertingCharacter(g,y){const O=this.getStartState(g.lineNumber);if(!O)return 0;const D=this._textModel.getLanguageId(),U=this._textModel.getLineContent(g.lineNumber),c=U.substring(0,g.column-1)+y+U.substring(g.column-1),E=M(this._languageIdCodec,D,this.tokenizationSupport,c,!0,O),j=new o.$yt(E.tokens,c,this._languageIdCodec);if(j.getCount()===0)return 0;const C=j.findTokenIndexAtOffset(g.column-1);return j.getStandardTokenType(C)}tokenizeLineWithEdit(g,y,O){const D=g.lineNumber,U=g.column,c=this.getStartState(D);if(!c)return null;const E=this._textModel.getLineContent(D),j=E.substring(0,U-1)+O+E.substring(U-1+y),C=this._textModel.getLanguageIdAtPosition(D,0),b=M(this._languageIdCodec,C,this.tokenizationSupport,j,!0,c);return new o.$yt(b.tokens,j,this._languageIdCodec)}isCheapToTokenize(g){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<y||g===y&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,y,O){if(O<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,O),{heuristicTokens:!1};let D=this.b(y);const U=this._textModel.getLanguageId();for(let c=y;c<=O;c++){const E=this._textModel.getLineContent(c),j=M(this._languageIdCodec,U,this.tokenizationSupport,E,!0,D);g.add(c,j.tokens),D=j.endState}return{heuristicTokens:!0}}b(g){let y=this._textModel.getLineFirstNonWhitespaceColumn(g);const O=[];let D=null;for(let E=g-1;y>1&&E>=1;E--){const j=this._textModel.getLineFirstNonWhitespaceColumn(E);if(j!==0&&j<y&&(O.push(this._textModel.getLineContent(E)),y=j,D=this.getStartState(E),D))break}D||(D=this.tokenizationSupport.getInitialState()),O.reverse();const U=this._textModel.getLanguageId();let c=D;for(const E of O)c=M(this._languageIdCodec,U,this.tokenizationSupport,E,!1,c).endState;return c}}e.$mC=n;class r{constructor(g){this.d=g,this.a=new m,this.b=new k,this.b.addRange(new t.$5s(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,y){if(!y)throw new T.$cb("Cannot set null/undefined state");this.b.delete(g);const O=this.a.setEndState(g,y);return O&&g<this.d&&this.b.addRange(new t.$5s(g+1,g+2)),O}acceptChange(g,y){this.d+=y-g.length,this.a.acceptChange(g,y),this.b.addRangeAndResize(new t.$5s(g.startLineNumber,g.endLineNumberExclusive),y)}acceptChanges(g){for(const y of g){const[O]=(0,s.$xt)(y.text);this.acceptChange(new f.$7s(y.range.startLineNumber,y.range.endLineNumber+1),O+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$5s(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,y){return g===1?y:this.getEndState(g-1)}getFirstInvalidLine(g){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const O=this.getStartState(y,g);if(!O)throw new T.$cb("Start state must be defined");return{lineNumber:y,startState:O}}}e.$nC=r;class m{constructor(){this.a=new $.$jC(null)}getEndState(g){return this.a.get(g)}setEndState(g,y){const O=this.a.get(g);return O&&O.equals(y)?!1:(this.a.set(g,y),!0)}acceptChange(g,y){let O=g.length;y>0&&O>0&&(O--,y--),this.a.replace(g.startLineNumber,O,y)}acceptChanges(g){for(const y of g){const[O]=(0,s.$xt)(y.text);this.acceptChange(new f.$7s(y.range.startLineNumber,y.range.endLineNumber+1),O+1)}}}e.$oC=m;class k{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$5s(g.start+1,g.endExclusive),g.start}delete(g){const y=this.a.findIndex(O=>O.contains(g));if(y!==-1){const O=this.a[y];O.start===g?O.endExclusive===g+1?this.a.splice(y,1):this.a[y]=new t.$5s(g+1,O.endExclusive):O.endExclusive===g+1?this.a[y]=new t.$5s(O.start,g):this.a.splice(y,1,new t.$5s(O.start,g),new t.$5s(g+1,O.endExclusive))}}addRange(g){t.$5s.addRange(g,this.a)}addRangeAndResize(g,y){let O=0;for(;!(O>=this.a.length||g.start<=this.a[O].endExclusive);)O++;let D=O;for(;!(D>=this.a.length||g.endExclusive<this.a[D].start);)D++;const U=y-g.length;for(let c=D;c<this.a.length;c++)this.a[c]=this.a[c].delta(U);if(O===D){const c=new t.$5s(g.start,g.start+y);c.isEmpty||this.a.splice(O,0,c)}else{const c=Math.min(g.start,this.a[O].start),E=Math.max(g.endExclusive,this.a[D-1].endExclusive),j=new t.$5s(c,E+U);j.isEmpty?this.a.splice(O,D-O):this.a.splice(O,D-O,j)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$pC=k;function M(S,g,y,O,D,U){let c=null;if(y)try{c=y.tokenizeEncoded(O,D,U.clone())}catch(E){(0,T.$1)(E)}return c||(c=(0,d.$iC)(S.encodeLanguageId(g),U)),o.$yt.convertToEndOffset(c.tokens,O.length),c}class L{constructor(g,y){this.b=g,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$mh)(g=>{this.f=!1,this.h(g)}))}h(g){const y=Date.now()+g.timeRemaining(),O=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$B)(O):this.g())};O()}j(){const g=this.b._textModel.getLineCount(),y=new l.$kC,O=N.$Sd.create(!1);do if(O.elapsed()>1||this.l(y)>=g)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(g,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,y){this.b.store.invalidateEndStateRange(new f.$7s(g,y))}}e.$qC=L}),define(G[39],H([0,1,35,2,38,14,36]),function(W,e,P,T,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Hb=void 0;class f extends T.$Tc{constructor(d,$,l,o,h,i,n){super(),this.c=d,this.f=$,this.g=l,this.h=o,this.j=h,this.m=i,this.n=n,this.a=[],this.b=this.B(new P.$Wd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(d,$,l){throw new Error("Not supported!")}createBackgroundTokenizer(d,$){if(this.h)return this.h(d,$)}tokenizeEncoded(d,$,l){const o=Math.random()*1e4<1,h=this.n||o,i=h?new v.$Sd(!0):void 0,n=this.c.tokenizeLine2(d,l,500);if(h){const m=i.elapsed();(o||m>32)&&this.m(m,d.length,o)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${d.substring(0,100)}`),new s.$Ht(n.tokens,l);if(this.g){const m=this.a,k=n.tokens;for(let M=0,L=k.length>>>1;M<L;M++){const S=k[(M<<1)+1],g=N.$vt.getLanguageId(S);m[g]||(m[g]=!0,this.b.fire(g))}}let r;return l.equals(n.ruleStack)?r=l:r=n.ruleStack,new s.$Ht(n.tokens,r)}}e.$0Hb=f}),define(G[40],H([0,1,21,2,11]),function(W,e,P,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Hb=void 0;class N extends T.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,d){super(),this.a=f,this.b=t,this.c=d,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,d){throw new Error("Not supported!")}tokenizeEncoded(f,t,d){return f.length>=this.c.get()?(0,P.$iC)(this.a,d):this.b.tokenizeEncoded(f,t,d)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$$Hb=N}),define(G[41],H([0,1,34,20,11,3,15,48,37,16,7,39,40]),function(W,e,P,T,v,N,s,f,t,d,$,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dIb=void 0;class h extends f.$ov{constructor(r,m,k,M,L,S,g,y){super(r,m,k,M),this.s=L,this.t=S,this.u=g,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new T.$ih(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,m){this.t=r,this.u=m,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,m){this.a&&(this.a.store.invalidateEndStateRange(new s.$7s(r,m)),this.q.schedule())}async v(){this.a=null;const r=this.t,m=this.u,k=await this.s.getOrCreateGrammar(r,m);if(!(this.b||r!==this.t||m!==this.u||!k)){if(k.grammar){const M=new o.$$Hb(this.u,new l.$0Hb(k.grammar,k.initialState,!1,void 0,()=>!1,(L,S,g)=>{this.s.reportTokenizationTime(L,r,k.sourceExtensionId,S,g)},!1),this.c);this.a=new t.$lC(this.f.length,M)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:m}=await(0,P.$kD)("vscode-textmate","release/main.js");this.m=m}const r=new Date().getTime();for(;;){let m=0;const k=new d.$kC,M=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||m>200)break;m++;const y=this.f[g.lineNumber-1],O=this.a.tokenizationSupport.tokenizeEncoded(y,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,O.endState)){const U=this.m(g.startState,O.endState);M.setState(g.lineNumber,U)}else M.setState(g.lineNumber,null);if($.$yt.convertToEndOffset(O.tokens,y.length),k.add(g.lineNumber,O.tokens),new Date().getTime()-r>20)break}if(m===0)break;const L=M.getStateDeltas();if(this.s.setTokensAndStates(this.h,k.serialize(),L),new Date().getTime()-r>20){(0,N.$B)(()=>this.w());return}}}}e.$dIb=h;class i{constructor(){this.a=-1,this.b=[]}setState(r,m){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(m):this.b.push({startLineNumber:r,stateDeltas:[m]}),this.a=r}getStateDeltas(){return this.b}}}),define(G[42],H([0,1,19]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aIb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(N){if(this.a[N.scopeName]){const s=this.a[N.scopeName];P.$Cg(s.location,N.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${N.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${N.location.toString()}`)}this.a[N.scopeName]=N}getGrammarDefinition(N){return this.a[N]||null}}e.$aIb=T}),define(G[43],H([0,1,2,42]),function(W,e,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cIb=e.$bIb=void 0,e.$bIb="No TM Grammar registered for this language.";class v extends P.$Tc{constructor(s,f,t,d){super(),this.a=s,this.b=t.INITIAL,this.c=new T.$aIb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:d,loadGrammar:async $=>{const l=this.c.getGrammarDefinition($);if(!l)return this.a.logTrace(`No grammar found for scope ${$}`),null;const o=l.location;try{const h=await this.a.readFile(o);return t.parseRawGrammar(h,o.path)}catch(h){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${o}`,h),null}},getInjections:$=>{const l=$.split(".");let o=[];for(let h=1;h<=l.length;h++){const i=l.slice(0,h).join(".");o=[...o,...this.f[i]||[]]}return o}}));for(const $ of f){if(this.c.register($),$.injectTo){for(const l of $.injectTo){let o=this.f[l];o||(this.f[l]=o=[]),o.push($.scopeName)}if($.embeddedLanguages)for(const l of $.injectTo){let o=this.g[l];o||(this.g[l]=o=[]),o.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(s){return this.h.has(s)}setTheme(s,f){this.j.setTheme(s,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,f){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$bIb);const d=this.c.getGrammarDefinition(t);if(!d)throw new Error(e.$bIb);const $=d.embeddedLanguages;if(this.g[t]){const h=this.g[t];for(const i of h)for(const n of Object.keys(i))$[n]=i[n]}const l=Object.keys($).length>0;let o;try{o=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:$,tokenTypes:d.tokenTypes,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors})}catch(h){throw h.message&&h.message.startsWith("No grammar provided for")?new Error(e.$bIb):h}return{languageId:s,grammar:o,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:d.sourceExtensionId}}}e.$cIb=v}),define(G[49],H([0,1,8,43,41]),function(W,e,P,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function N(f,t){return new s(f,t)}e.create=N;class s{constructor(t,d){this.f=d,this.b=new Map,this.c=[],this.a=t.host;const $=d.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g($)}async g(t){const d=this.f.textmateMainUri,$=await new Promise((n,r)=>{W([d],n,r)}),l=await new Promise((n,r)=>{W([this.f.onigurumaMainUri],n,r)}),h=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(h);const i=Promise.resolve({createOnigScanner:n=>l.createOnigScanner(n),createOnigString:n=>l.createOnigString(n)});return new T.$cIb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const d=P.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new v.$dIb(d,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(l,o){const h=await $.d;return h?($.c[o]||($.c[o]=h.createGrammar(l,o)),$.c[o]):Promise.resolve(null)},setTokensAndStates(l,o,h){$.a.setTokensAndStates(t.controllerId,l,o,h)},reportTokenizationTime(l,o,h,i,n){$.a.reportTokenizationTime(l,o,h,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,d){this.b.get(t).onEvents(d)}retokenize(t,d,$){this.b.get(t).retokenize(d,$)}acceptModelLanguageChanged(t,d,$){this.b.get(t).onLanguageId(d,$)}acceptRemovedModel(t){const d=this.b.get(t);d&&(d.dispose(),this.b.delete(t))}async acceptTheme(t,d){(await this.d)?.setTheme(t,d)}acceptMaxTokenizationLineLength(t,d){this.b.get(t).acceptMaxTokenizationLineLength(d)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c15c66607256592202cc051fb3e117baf54af63/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
